import*as ComponentHelpers from"../../component_helpers/component_helpers.js";import*as Host from"../../host/host.js";import*as Platform from"../../platform/platform.js";import*as Coordinator from"../../render_coordinator/render_coordinator.js";import*as LitHtml from"../../third_party/lit-html/lit-html.js";import*as UI from"../../ui/ui.js";const coordinator=Coordinator.RenderCoordinator.RenderCoordinator.instance();import{addColumnVisibilityCheckboxes,addSortableColumnItems}from"./DataGridContextMenuUtils.js";import{calculateColumnWidthPercentageFromWeighting,calculateFirstFocusableCell,ContextMenuHeaderResetClickEvent,getRowEntryForColumnId,handleArrowKeyNavigation,renderCellValue}from"./DataGridUtils.js";import*as i18n from"../../i18n/i18n.js";const UIStrings={sortBy:"Sort By",resetColumns:"Reset Columns",headerOptions:"Header Options"},str_=i18n.i18n.registerUIStrings("ui/components/DataGrid.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ColumnHeaderClickEvent extends Event{constructor(e,t){super("column-header-click"),this.data={column:e,columnIndex:t}}}export class NewUserFilterTextEvent extends Event{constructor(e){super("new-user-filter-text",{composed:!0}),this.data={filterText:e}}}export class BodyCellFocusedEvent extends Event{constructor(e,t){super("cell-focused",{composed:!0}),this.data={cell:e,row:t}}}const KEYS_TREATED_AS_CLICKS=new Set([" ","Enter"]),ROW_HEIGHT_PIXELS=18,PADDING_ROWS_COUNT=10;export class DataGrid extends HTMLElement{constructor(){super(),this.shadow=this.attachShadow({mode:"open"}),this.columns=[],this.rows=[],this.sortState=null,this.scheduledRender=!1,this.contextMenus=void 0,this.currentResize=null,this.rowIndexMap=new WeakMap,this.resizeObserver=new ResizeObserver((()=>{this.alignScrollHandlers()})),this.boundOnResizePointerUp=this.onResizePointerUp.bind(this),this.boundOnResizePointerMove=this.onResizePointerMove.bind(this),this.boundOnResizePointerDown=this.onResizePointerDown.bind(this),this.focusableCell=[0,1],this.hasRenderedAtLeastOnce=!1,this.userHasFocusInDataGrid=!1,this.userHasScrolled=!1,this.enqueuedRender=!1,this.shadow.adoptedStyleSheets=[...ComponentHelpers.GetStylesheet.getStyleSheets("ui/inspectorScrollbars.css",{enableLegacyPatching:!1})]}connectedCallback(){ComponentHelpers.SetCSSProperty.set(this,"--table-row-height","18px")}get data(){return{columns:this.columns,rows:this.rows,activeSort:this.sortState,contextMenus:this.contextMenus}}set data(e){if(this.columns=e.columns,this.rows=e.rows,this.rows.forEach(((e,t)=>{this.rowIndexMap.set(e,t)})),this.sortState=e.activeSort,this.contextMenus=e.contextMenus,this.hasRenderedAtLeastOnce||(this.focusableCell=calculateFirstFocusableCell({columns:this.columns,rows:this.rows})),this.hasRenderedAtLeastOnce){const[e,t]=this.focusableCell,i=e>this.columns.length,o=t>this.rows.length;(i||o)&&(this.focusableCell=[i?this.columns.length:e,o?this.rows.length:t])}this.render()}scrollToBottomIfRequired(){if(!1===this.hasRenderedAtLeastOnce||this.userHasFocusInDataGrid||this.userHasScrolled)return;const e=this.getCurrentlyFocusableCell();e&&e===this.shadow.activeElement||coordinator.read((()=>{const e=this.shadow.querySelector(".wrapping-container");if(!e)return;const t=e.scrollHeight;coordinator.scroll((()=>{e.scrollTo(0,t)}))}))}engageResizeObserver(){this.hasRenderedAtLeastOnce||this.resizeObserver.observe(this.shadow.host)}getCurrentlyFocusableCell(){const[e,t]=this.focusableCell;return this.shadow.querySelector(`[data-row-index="${t}"][data-col-index="${e}"]`)}focusCell([e,t]){this.userHasFocusInDataGrid=!0;const[i,o]=this.focusableCell;i===e&&o===t||(this.focusableCell=[e,t],this.render());const s=this.getCurrentlyFocusableCell();s&&coordinator.write((()=>{s.focus()}))}onTableKeyDown(e){const t=e.key;if(KEYS_TREATED_AS_CLICKS.has(t)){const e=this.getCurrentlyFocusableCell(),[t,i]=this.focusableCell,o=this.columns[t];e&&0===i&&o&&o.sortable&&this.onColumnHeaderClick(o,t)}if(!Platform.KeyboardUtilities.keyIsArrowKey(t))return;const i=handleArrowKeyNavigation({key:t,currentFocusedCell:this.focusableCell,columns:this.columns,rows:this.rows});e.preventDefault(),this.focusCell(i)}onColumnHeaderClick(e,t){this.dispatchEvent(new ColumnHeaderClickEvent(e,t))}ariaSortForHeader(e){return!e.sortable||this.sortState&&this.sortState.columnId===e.id?this.sortState&&this.sortState.columnId===e.id?"ASC"===this.sortState.direction?"ascending":"descending":void 0:"none"}renderEmptyFillerRow(){const e=this.columns.map(((e,t)=>{if(!e.visible)return LitHtml.nothing;const i=LitHtml.Directives.classMap({firstVisibleColumn:0===t});return LitHtml.html`<td tabindex="-1" class=${i} data-filler-row-column-index=${t}></td>`}));return LitHtml.html`<tr tabindex="-1" class="filler-row padding-row">${e}</tr>`}cleanUpAfterResizeColumnComplete(){this.currentResize&&(this.currentResize.documentForCursorChange.body.style.cursor=this.currentResize.cursorToRestore,this.currentResize=null,this.alignScrollHandlers())}onResizePointerDown(e){if(1!==e.buttons||Host.Platform.isMac()&&e.ctrlKey)return;e.preventDefault();const t=e.target;if(!t)return;const i=t.dataset.columnIndex;if(!i)return;const o=globalThis.parseInt(i,10),s=this.columns.findIndex(((e,t)=>t>o&&!0===e.visible)),r=this.shadow.querySelector(`td[data-filler-row-column-index="${o}"]`),n=this.shadow.querySelector(`td[data-filler-row-column-index="${s}"]`);if(!r||!n)return;const l=this.shadow.querySelector(`col[data-col-column-index="${o}"]`),a=this.shadow.querySelector(`col[data-col-column-index="${s}"]`);if(!l||!a)return;const c=e.target.ownerDocument;c&&(this.currentResize={leftCellCol:l,rightCellCol:a,leftCellColInitialPercentageWidth:globalThis.parseInt(l.style.width,10),rightCellColInitialPercentageWidth:globalThis.parseInt(a.style.width,10),initialLeftCellWidth:r.clientWidth,initialRightCellWidth:n.clientWidth,initialMouseX:e.x,documentForCursorChange:c,cursorToRestore:t.style.cursor},c.body.style.cursor="col-resize",t.setPointerCapture(e.pointerId),t.addEventListener("pointermove",this.boundOnResizePointerMove))}onResizePointerMove(e){if(e.preventDefault(),!this.currentResize)return;const t=this.currentResize.leftCellColInitialPercentageWidth+this.currentResize.rightCellColInitialPercentageWidth-10,i=e.x-this.currentResize.initialMouseX,o=Math.abs(i)/(this.currentResize.initialLeftCellWidth+this.currentResize.initialRightCellWidth)*100;let s,r;i>0?(s=Platform.NumberUtilities.clamp(this.currentResize.leftCellColInitialPercentageWidth+o,10,t),r=Platform.NumberUtilities.clamp(this.currentResize.rightCellColInitialPercentageWidth-o,10,t)):i<0&&(s=Platform.NumberUtilities.clamp(this.currentResize.leftCellColInitialPercentageWidth-o,10,t),r=Platform.NumberUtilities.clamp(this.currentResize.rightCellColInitialPercentageWidth+o,10,t)),s&&r&&(this.currentResize.leftCellCol.style.width=s.toFixed(2)+"%",this.currentResize.rightCellCol.style.width=r.toFixed(2)+"%")}onResizePointerUp(e){e.preventDefault();const t=e.target;t&&(t.releasePointerCapture(e.pointerId),t.removeEventListener("pointermove",this.boundOnResizePointerMove),this.cleanUpAfterResizeColumnComplete())}renderResizeForCell(e,t){const[i]=t;return i!==this.getIndexOfLastVisibleColumn()&&e.visible?LitHtml.html`<span class="cell-resize-handle"
     @pointerdown=${this.boundOnResizePointerDown}
     @pointerup=${this.boundOnResizePointerUp}
     data-column-index=${i}
    ></span>`:LitHtml.nothing}getIndexOfLastVisibleColumn(){let e=this.columns.length-1;for(;e>-1;e--){if(this.columns[e].visible)break}return e}onHeaderContextMenu(e){if(2!==e.button)return;const t=new UI.ContextMenu.ContextMenu(e);addColumnVisibilityCheckboxes(this,t);const i=t.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,i),t.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.contextMenus&&this.contextMenus.headerRow&&this.contextMenus.headerRow(t,this.columns),t.show()}onBodyRowContextMenu(e){if(2!==e.button)return;if(!e.target||!(e.target instanceof HTMLElement))return;const t=e.target.dataset.rowIndex;if(!t)return;const i=parseInt(t,10),o=this.rows[i-1],s=new UI.ContextMenu.ContextMenu(e),r=s.defaultSection().appendSubMenuItem(i18nString(UIStrings.sortBy));addSortableColumnItems(this,r);const n=s.defaultSection().appendSubMenuItem(i18nString(UIStrings.headerOptions));addColumnVisibilityCheckboxes(this,n),n.defaultSection().appendItem(i18nString(UIStrings.resetColumns),(()=>{this.dispatchEvent(new ContextMenuHeaderResetClickEvent)})),this.contextMenus&&this.contextMenus.bodyRow&&this.contextMenus.bodyRow(s,this.columns,o),s.show()}onScroll(){this.render()}onWheel(){this.userHasScrolled=!0}alignScrollHandlers(){return coordinator.read((()=>{const e=this.shadow.querySelectorAll("th:not(.hidden)"),t=this.shadow.querySelectorAll(".cell-resize-handle");this.shadow.querySelector("table")&&e.forEach((async(e,i)=>{const o=e.clientWidth,s=e.offsetLeft;if(t[i]){const e=t[i].clientWidth;coordinator.write((()=>{t[i].style.left=s+o-e+"px"}))}}))}))}calculateTopAndBottomRowIndexes(){return coordinator.read((()=>{const e=this.shadow.querySelector(".wrapping-container");let t=0,i=window.innerHeight;e&&(t=e.scrollTop,i=e.clientHeight);let o=Math.floor((t-180)/18),s=Math.ceil((t+i+180)/18);return o=Math.max(0,o),s=Math.min(this.rows.filter((e=>!e.hidden)).length,s),{topVisibleRow:o,bottomVisibleRow:s}}))}onFocusOut(){this.userHasFocusInDataGrid=!1}render(){this.scheduledRender?this.enqueuedRender=!0:(this.scheduledRender=!0,coordinator.read((async()=>{const{topVisibleRow:e,bottomVisibleRow:t}=await this.calculateTopAndBottomRowIndexes(),i=this.rows.filter((e=>!e.hidden)).filter(((i,o)=>o>=e&&o<=t)),o=this.columns.findIndex((e=>e.visible)),s=this.columns.some((e=>!0===e.sortable));await coordinator.write((()=>{LitHtml.render(LitHtml.html`
        <style>
          :host {
            height: 100%;
            display: block;
            position: relative;
          }
          /* Ensure that vertically we don't overflow */
          .wrapping-container {
            overflow-y: scroll;
            /* Use max-height instead of height to ensure that the
              table does not use more space than necessary. */
            height: 100%;
          }

          table {
            border-spacing: 0;
            width: 100%;
            height: 100%;
            /* To make sure that we properly hide overflowing text
              when horizontal space is too narrow. */
            table-layout: fixed;
          }

          tr {
            outline: none;
          }

          tbody tr {
            background-color: var(--color-background);
          }

          tbody tr.selected {
            background-color: var(--color-background-elevation-1);
          }

          td,
          th {
            padding: 1px 4px;
            /* Divider between each cell, except the first one (see below) */
            border-left: 1px solid var(--color-details-hairline);
            color: var(--color-text-primary);
            line-height: var(--table-row-height);
            height: var(--table-row-height);
            user-select: text;
            /* Ensure that text properly cuts off if horizontal space is too narrow */
            white-space: nowrap;
            text-overflow: ellipsis;
            overflow: hidden;
          }

          th {
            font-weight: normal;
            text-align: left;
            border-bottom: 1px solid var(--color-details-hairline);
            position: sticky;
            top: 0;
            z-index: 2;
            background-color: var(--color-background-elevation-1);
          }

          td:focus,
          th:focus {
            outline: var(--color-primary) auto 1px;
          }

          .cell-resize-handle {
            top: 0;
            height: 100%;
            z-index: 3;
            width: 20px;
            cursor: col-resize;
            position: absolute;
          }
          /* There is no divider before the first cell */
          td.firstVisibleColumn,
          th.firstVisibleColumn {
            border-left: none;
          }

          .hidden {
            display: none;
          }

          .filler-row td {
            /* By making the filler row cells 100% they take up any extra height,
            * leaving the cells with content to be the regular height, and the
            * final filler row to be as high as it needs to be to fill the empty
            * space.
            */
            height: 100%;
            pointer-events: none;
          }

          [aria-sort]:hover {
            cursor: pointer;
          }

          [aria-sort="descending"]::after {
            content: " ";
            border-left: 0.3em solid transparent;
            border-right: 0.3em solid transparent;
            border-top: 0.3em solid var(--color-text-primary);
            position: absolute;
            right: 0.5em;
            top: 0.6em;
          }

          [aria-sort="ascending"]::after {
            content: " ";
            border-bottom: 0.3em solid var(--color-text-primary);
            border-left: 0.3em solid transparent;
            border-right: 0.3em solid transparent;
            position: absolute;
            right: 0.5em;
            top: 0.6em;
          }
        </style>
        ${this.columns.map(((e,t)=>this.renderResizeForCell(e,[t,0])))}
        <div class="wrapping-container" @scroll=${this.onScroll} @wheel=${this.onWheel} @focusout=${this.onFocusOut}>
          <table
            aria-rowcount=${this.rows.length}
            aria-colcount=${this.columns.length}
            @keydown=${this.onTableKeyDown}
          >
            <colgroup>
              ${this.columns.map(((e,t)=>{const i=`width: ${calculateColumnWidthPercentageFromWeighting(this.columns,e.id)}%`;return e.visible?LitHtml.html`<col style=${i} data-col-column-index=${t}>`:LitHtml.nothing}))}
            </colgroup>
            <thead>
              <tr @contextmenu=${this.onHeaderContextMenu}>
                ${this.columns.map(((e,t)=>{const i=LitHtml.Directives.classMap({hidden:!e.visible,firstVisibleColumn:t===o}),r=s&&t===this.focusableCell[0]&&0===this.focusableCell[1];return LitHtml.html`<th class=${i}
                    data-grid-header-cell=${e.id}
                    @click=${()=>{this.focusCell([t,0]),this.onColumnHeaderClick(e,t)}}
                    title=${e.title}
                    aria-sort=${LitHtml.Directives.ifDefined(this.ariaSortForHeader(e))}
                    aria-colindex=${t+1}
                    data-row-index='0'
                    data-col-index=${t}
                    tabindex=${LitHtml.Directives.ifDefined(s?r?"0":"-1":void 0)}
                  >${e.title}</th>`}))}
              </tr>
            </thead>
            <tbody>
              <tr class="filler-row-top padding-row" style=${LitHtml.Directives.styleMap({height:18*e+"px"})}></tr>
              ${LitHtml.Directives.repeat(i,(e=>this.rowIndexMap.get(e)),(e=>{const t=this.rowIndexMap.get(e);if(void 0===t)throw new Error("Trying to render a row that has no index in the rowIndexMap");const i=this.getCurrentlyFocusableCell(),[,s]=this.focusableCell,r=t+1,n=!!i&&(i===this.shadow.activeElement&&r===s),l=LitHtml.Directives.classMap({selected:n,hidden:!0===e.hidden});return LitHtml.html`
                  <tr
                    aria-rowindex=${t+1}
                    class=${l}
                    @contextmenu=${this.onBodyRowContextMenu}
                  >${this.columns.map(((t,i)=>{const s=getRowEntryForColumnId(e,t.id),n=LitHtml.Directives.classMap({hidden:!t.visible,firstVisibleColumn:i===o}),l=i===this.focusableCell[0]&&r===this.focusableCell[1],a=t.visible?renderCellValue(s):null;return LitHtml.html`<td
                      class=${n}
                      tabindex=${l?"0":"-1"}
                      aria-colindex=${i+1}
                      title=${s.title||String(s.value).substr(0,20)}
                      data-row-index=${r}
                      data-col-index=${i}
                      data-grid-value-cell-for-column=${t.id}
                      @focus=${()=>{this.dispatchEvent(new BodyCellFocusedEvent(s,e))}}
                      @click=${()=>{this.focusCell([i,r])}}
                    >${a}</td>`}))}
                `}))}
              ${this.renderEmptyFillerRow()}
              <tr class="filler-row-bottom padding-row" style=${LitHtml.Directives.styleMap({height:18*Math.max(0,i.length-t)+"px"})}></tr>
            </tbody>
          </table>
        </div>
        `,this.shadow,{eventContext:this})}));const r=this.focusableCell[1];this.userHasFocusInDataGrid&&r>0&&this.focusCell(this.focusableCell),this.scrollToBottomIfRequired(),this.engageResizeObserver(),this.scheduledRender=!1,this.hasRenderedAtLeastOnce=!0,this.enqueuedRender&&(this.enqueuedRender=!1,this.render())})))}}customElements.define("devtools-data-grid",DataGrid);