import*as Common from"../common/common.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import{LiveLocationWithPool}from"./LiveLocation.js";import{ResourceMapping}from"./ResourceMapping.js";import{SASSSourceMapping}from"./SASSSourceMapping.js";import{StylesSourceMapping}from"./StylesSourceMapping.js";let cssWorkspaceBindingInstance;export class CSSWorkspaceBinding{constructor(o,e){this._workspace=e,this._modelToInfo=new Map,this._sourceMappings=[],o.observeModels(SDK.CSSModel.CSSModel,this),this._liveLocationPromises=new Set}static instance(o={forceNew:null,targetManager:null,workspace:null}){const{forceNew:e,targetManager:t,workspace:s}=o;if(!cssWorkspaceBindingInstance||e){if(!t||!s)throw new Error(`Unable to create CSSWorkspaceBinding: targetManager and workspace must be provided: ${(new Error).stack}`);cssWorkspaceBindingInstance=new CSSWorkspaceBinding(t,s)}return cssWorkspaceBindingInstance}_getCSSModelInfo(o){return this._modelToInfo.get(o)}modelAdded(o){this._modelToInfo.set(o,new ModelInfo(o,this._workspace))}modelRemoved(o){this._getCSSModelInfo(o)._dispose(),this._modelToInfo.delete(o)}async pendingLiveLocationChangesPromise(){await Promise.all(this._liveLocationPromises)}_recordLiveLocationChange(o){o.then((()=>{this._liveLocationPromises.delete(o)})),this._liveLocationPromises.add(o)}async updateLocations(o){const e=this._getCSSModelInfo(o.cssModel())._updateLocations(o);this._recordLiveLocationChange(e),await e}createLiveLocation(o,e,t){const s=this._getCSSModelInfo(o.cssModel())._createLiveLocation(o,e,t);return this._recordLiveLocationChange(s),s}propertyUILocation(o,e){const t=o.ownerStyle;if(!t||t.type!==SDK.CSSStyleDeclaration.Type.Regular||!t.styleSheetId)return null;const s=t.cssModel().styleSheetHeaderForId(t.styleSheetId);if(!s)return null;const n=e?o.nameRange():o.valueRange();if(!n)return null;const i=n.startLine,a=n.startColumn,r=new SDK.CSSModel.CSSLocation(s,s.lineNumberInSource(i),s.columnNumberInSource(i,a));return this.rawLocationToUILocation(r)}rawLocationToUILocation(o){for(let e=this._sourceMappings.length-1;e>=0;--e){const t=this._sourceMappings[e].rawLocationToUILocation(o);if(t)return t}return this._getCSSModelInfo(o.cssModel())._rawLocationToUILocation(o)}uiLocationToRawLocations(o){for(let t=this._sourceMappings.length-1;t>=0;--t){const e=this._sourceMappings[t].uiLocationToRawLocations(o);if(e.length)return e}const e=[];for(const t of this._modelToInfo.values())e.push(...t._uiLocationToRawLocations(o));return e}addSourceMapping(o){this._sourceMappings.push(o)}}export class ModelInfo{constructor(o,e){this._eventListeners=[o.addEventListener(SDK.CSSModel.Events.StyleSheetAdded,(o=>{this._styleSheetAdded(o)}),this),o.addEventListener(SDK.CSSModel.Events.StyleSheetRemoved,(o=>{this._styleSheetRemoved(o)}),this)],this._stylesSourceMapping=new StylesSourceMapping(o,e);const t=o.sourceMapManager();this._sassSourceMapping=new SASSSourceMapping(o.target(),t,e),this._locations=new Platform.MapUtilities.Multimap,this._unboundLocations=new Platform.MapUtilities.Multimap}async _createLiveLocation(o,e,t){const s=new LiveLocation(o,this,e,t),n=o.header();return n?(s._header=n,this._locations.set(n,s),await s.update()):this._unboundLocations.set(o.url,s),s}_disposeLocation(o){o._header?this._locations.delete(o._header,o):this._unboundLocations.delete(o._url,o)}_updateLocations(o){const e=[];for(const t of this._locations.get(o))e.push(t.update());return Promise.all(e)}async _styleSheetAdded(o){const e=o.data;if(!e.sourceURL)return;const t=[];for(const s of this._unboundLocations.get(e.sourceURL))s._header=e,this._locations.set(e,s),t.push(s.update());await Promise.all(t),this._unboundLocations.deleteAll(e.sourceURL)}async _styleSheetRemoved(o){const e=o.data,t=[];for(const s of this._locations.get(e))s._header=null,this._unboundLocations.set(s._url,s),t.push(s.update());await Promise.all(t),this._locations.deleteAll(e)}_rawLocationToUILocation(o){let e=null;return e=e||this._sassSourceMapping.rawLocationToUILocation(o),e=e||this._stylesSourceMapping.rawLocationToUILocation(o),e=e||ResourceMapping.instance().cssLocationToUILocation(o),e}_uiLocationToRawLocations(o){let e=this._sassSourceMapping.uiLocationToRawLocations(o);return e.length?e:(e=this._stylesSourceMapping.uiLocationToRawLocations(o),e.length?e:ResourceMapping.instance().uiLocationToCSSLocations(o))}_dispose(){Common.EventTarget.EventTarget.removeEventListeners(this._eventListeners),this._stylesSourceMapping.dispose(),this._sassSourceMapping.dispose()}}export class LiveLocation extends LiveLocationWithPool{constructor(o,e,t,s){super(t,s),this._url=o.url,this._lineNumber=o.lineNumber,this._columnNumber=o.columnNumber,this._info=e,this._header=null}header(){return this._header}async uiLocation(){if(!this._header)return null;const o=new SDK.CSSModel.CSSLocation(this._header,this._lineNumber,this._columnNumber);return CSSWorkspaceBinding.instance().rawLocationToUILocation(o)}dispose(){super.dispose(),this._info._disposeLocation(this)}async isIgnoreListed(){return!1}}