import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as WebComponents from"../ui/components/components.js";import*as UI from"../ui/ui.js";import{ContrastDetails,Events as ContrastDetailsEvents}from"./ContrastDetails.js";import{ContrastOverlay}from"./ContrastOverlay.js";const UIStrings={toggleColorPicker:"Toggle color picker",changeHue:"Change hue",changeAlpha:"Change alpha",hex:"HEX",changeColorFormat:"Change color format",previewPalettes:"Preview palettes",addToPalette:"Add to palette",colorPalettes:"Color Palettes",returnToColorPicker:"Return to color picker",colorS:"Color {PH1}",longclickOrLongpressSpaceToShow:"Long-click or long-press space to show alternate shades of {PH1}",removeColor:"Remove color",removeAllToTheRight:"Remove all to the right",clearPalette:"Clear palette",sInS:"{PH1} in {PH2}",copyColorToClipboard:"Copy color to clipboard",pressArrowKeysMessage:"Press arrow keys with or without modifiers to move swatch position. Arrow key with Shift key moves position largely, with Ctrl key it is less and with Alt key it is even less"},str_=i18n.i18n.registerUIStrings("color_picker/Spectrum.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),colorElementToMutable=new WeakMap,colorElementToColor=new WeakMap;export class Spectrum extends UI.Widget.VBox{constructor(t){super(!0),this.registerRequiredCSS("color_picker/spectrum.css",{enableLegacyPatching:!0}),this.contentElement.tabIndex=0,this._colorElement=this.contentElement.createChild("div","spectrum-color"),this._colorElement.tabIndex=0,this.setDefaultFocusedElement(this._colorElement),this._colorElement.addEventListener("keydown",this._onSliderKeydown.bind(this,d.bind(this)));const e=i18nString(UIStrings.pressArrowKeysMessage);UI.ARIAUtils.setAccessibleName(this._colorElement,e),UI.ARIAUtils.markAsApplication(this._colorElement),this._colorDragElement=this._colorElement.createChild("div","spectrum-sat fill").createChild("div","spectrum-val fill").createChild("div","spectrum-dragger"),this._dragX=0,this._dragY=0;const o=this.contentElement.createChild("div","spectrum-tools"),s=new UI.Toolbar.Toolbar("spectrum-eye-dropper",o);this._colorPickerButton=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.toggleColorPicker),"largeicon-eyedropper"),this._colorPickerButton.setToggled(!0),this._colorPickerButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._toggleColorPicker.bind(this,void 0)),s.appendToolbarItem(this._colorPickerButton),this._swatch=new Swatch(o),this._hueElement=o.createChild("div","spectrum-hue"),this._hueElement.tabIndex=0,this._hueElement.addEventListener("keydown",this._onSliderKeydown.bind(this,h.bind(this))),UI.ARIAUtils.setAccessibleName(this._hueElement,i18nString(UIStrings.changeHue)),UI.ARIAUtils.markAsSlider(this._hueElement,0,360),this._hueSlider=this._hueElement.createChild("div","spectrum-slider"),this._alphaElement=o.createChild("div","spectrum-alpha"),this._alphaElement.tabIndex=0,this._alphaElement.addEventListener("keydown",this._onSliderKeydown.bind(this,c.bind(this))),UI.ARIAUtils.setAccessibleName(this._alphaElement,i18nString(UIStrings.changeAlpha)),UI.ARIAUtils.markAsSlider(this._alphaElement,0,1),this._alphaElementBackground=this._alphaElement.createChild("div","spectrum-alpha-background"),this._alphaSlider=this._alphaElement.createChild("div","spectrum-slider"),this._displayContainer=o.createChild("div","spectrum-text source-code"),UI.ARIAUtils.markAsPoliteLiveRegion(this._displayContainer,!0),this._textValues=[];for(let m=0;m<4;++m){const t=UI.UIUtils.createInput("spectrum-text-value");this._displayContainer.appendChild(t),t.maxLength=4,this._textValues.push(t),t.addEventListener("keydown",this._inputChanged.bind(this),!1),t.addEventListener("input",this._inputChanged.bind(this),!1),t.addEventListener("wheel",this._inputChanged.bind(this),!1),t.addEventListener("paste",this._pasted.bind(this),!1)}this._textLabels=this._displayContainer.createChild("div","spectrum-text-label"),this._hexContainer=o.createChild("div","spectrum-text spectrum-text-hex source-code"),UI.ARIAUtils.markAsPoliteLiveRegion(this._hexContainer,!0),this._hexValue=UI.UIUtils.createInput("spectrum-text-value"),this._hexContainer.appendChild(this._hexValue),this._hexValue.maxLength=9,this._hexValue.addEventListener("keydown",this._inputChanged.bind(this),!1),this._hexValue.addEventListener("input",this._inputChanged.bind(this),!1),this._hexValue.addEventListener("wheel",this._inputChanged.bind(this),!1),this._hexValue.addEventListener("paste",this._pasted.bind(this),!1);const i=this._hexContainer.createChild("div","spectrum-text-label");i.textContent=i18nString(UIStrings.hex),UI.ARIAUtils.setAccessibleName(this._hexValue,i.textContent);const n=o.createChild("div","spectrum-display-switcher spectrum-switcher");_(n),UI.UIUtils.setTitle(n,i18nString(UIStrings.changeColorFormat)),n.tabIndex=0,self.onInvokeElement(n,(t=>{this._formatViewSwitch(),t.consume(!0)})),UI.ARIAUtils.markAsButton(n),UI.UIUtils.installDragHandle(this._hueElement,this._dragStart.bind(this,h.bind(this)),h.bind(this),null,"pointer","default"),UI.UIUtils.installDragHandle(this._alphaElement,this._dragStart.bind(this,c.bind(this)),c.bind(this),null,"pointer","default"),UI.UIUtils.installDragHandle(this._colorElement,this._dragStart.bind(this,d.bind(this)),d.bind(this),null,"pointer","default"),t&&(this._contrastInfo=t,this._contrastOverlay=new ContrastOverlay(this._contrastInfo,this._colorElement),this._contrastDetails=new ContrastDetails(this._contrastInfo,this.contentElement,this._toggleColorPicker.bind(this),this._contrastPanelExpanded.bind(this),this.colorSelected.bind(this)),this._contrastDetailsBackgroundColorPickedToggledBound=this._contrastDetailsBackgroundColorPickedToggled.bind(this)),this.element.classList.add("flex-none"),this._palettes=new Map,this._palettePanel=this.contentElement.createChild("div","palette-panel"),this._palettePanelShowing=!1,this._paletteSectionContainer=this.contentElement.createChild("div","spectrum-palette-container"),this._paletteContainer=this._paletteSectionContainer.createChild("div","spectrum-palette"),this._paletteContainer.addEventListener("contextmenu",this._showPaletteColorContextMenu.bind(this,-1)),this._shadesContainer=this.contentElement.createChild("div","palette-color-shades hidden"),UI.UIUtils.installDragHandle(this._paletteContainer,this._paletteDragStart.bind(this),this._paletteDrag.bind(this),this._paletteDragEnd.bind(this),"default");const l=this._paletteSectionContainer.createChild("div","spectrum-palette-switcher spectrum-switcher");_(l),UI.UIUtils.setTitle(l,i18nString(UIStrings.previewPalettes)),UI.ARIAUtils.markAsButton(l),l.tabIndex=0,self.onInvokeElement(l,(t=>{this._togglePalettePanel(!0),t.consume(!0)})),this._deleteIconToolbar=new UI.Toolbar.Toolbar("delete-color-toolbar"),this._deleteButton=new UI.Toolbar.ToolbarButton("","largeicon-trash-bin"),this._deleteIconToolbar.appendToolbarItem(this._deleteButton);this.contentElement.createChild("div","spectrum-overlay fill").addEventListener("click",this._togglePalettePanel.bind(this,!1)),this._addColorToolbar=new UI.Toolbar.Toolbar("add-color-toolbar");const r=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.addToPalette),"largeicon-add");function a(t,e){const o=e,s=t.getBoundingClientRect();switch(o.key){case"ArrowLeft":case"ArrowDown":return s.left-1;case"ArrowRight":case"ArrowUp":return s.right+1;default:return e.x}}function h(t){const e=this._hsv.slice(),o=1-(a(this._hueSlider,t)-this._hueElement.getBoundingClientRect().left)/this._hueAlphaWidth;e[0]=Platform.NumberUtilities.clamp(o,0,1),this._innerSetColor(e,"",void 0,void 0,ChangeSource.Other);const s=this._color().canonicalHSLA();UI.ARIAUtils.setValueNow(this._hueElement,s[0])}function c(t){const e=this._hsv.slice(),o=(a(this._alphaSlider,t)-this._hueElement.getBoundingClientRect().left)/this._hueAlphaWidth,s=Math.round(100*o)/100;e[3]=Platform.NumberUtilities.clamp(s,0,1),this._innerSetColor(e,"",void 0,void 0,ChangeSource.Other);const i=this._color().canonicalHSLA();UI.ARIAUtils.setValueText(this._alphaElement,i[3])}function d(t){const e=this._hsv.slice(),o=function(t,e){const o=t.getBoundingClientRect(),s=o.x+o.width/2,i=o.y+o.width/2,n=function(t,e){const o=e;o.altKey?t=1:o.ctrlKey?t=10:o.shiftKey&&(t=20);return t}(o.width/4,e);switch(e.key){case"ArrowLeft":return{x:o.left-n,y:i};case"ArrowRight":return{x:o.right+n,y:i};case"ArrowDown":return{x:s,y:o.bottom+n};case"ArrowUp":return{x:s,y:o.top-n};default:return{x:e.x,y:e.y}}}(this._colorDragElement,t);this._colorOffset=this._colorElement.totalOffset(),e[1]=Platform.NumberUtilities.clamp((o.x-this._colorOffset.left)/this.dragWidth,0,1),e[2]=Platform.NumberUtilities.clamp(1-(o.y-this._colorOffset.top)/this.dragHeight,0,1),this._innerSetColor(e,"",void 0,void 0,ChangeSource.Other)}function _(t){const e=new WebComponents.Icon.Icon;e.data={iconName:"switcherIcon",color:"var(--color-text-primary)",width:"16px",height:"16px"},t.appendChild(e)}r.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._onAddColorMousedown.bind(this)),r.element.addEventListener("keydown",this._onAddColorKeydown.bind(this)),this._addColorToolbar.appendToolbarItem(r),this._colorPickedBound=this._colorPicked.bind(this),this._numPaletteRowsShown=-1,this._loadPalettes(),new PaletteGenerator((t=>{t.colors.length?this.addPalette(t):this._selectedColorPalette.get()===t.title&&this._paletteSelected(MaterialPalette)}))}_dragStart(t,e){return this._colorOffset=this._colorElement.totalOffset(),t(e),!0}_contrastDetailsBackgroundColorPickedToggled(t){t.data&&this._toggleColorPicker(!1)}_contrastPanelExpanded(){this._contrastOverlay&&this._contrastDetails&&(this._contrastOverlay.setVisible(this._contrastDetails.expanded()),this._resizeForSelectedPalette(!0))}_updatePalettePanel(){this._palettePanel.removeChildren();this._palettePanel.createChild("div","palette-title").textContent=i18nString(UIStrings.colorPalettes);const t=new UI.Toolbar.Toolbar("",this._palettePanel);this._closeButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.returnToColorPicker),"largeicon-delete"),this._closeButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._togglePalettePanel.bind(this,!1)),this._closeButton.element.addEventListener("keydown",this._onCloseBtnKeydown.bind(this)),t.appendToolbarItem(this._closeButton);for(const e of this._palettes.values())this._palettePanel.appendChild(this._createPreviewPaletteElement(e))}_togglePalettePanel(t){this._palettePanelShowing!==t&&(t&&this._updatePalettePanel(),this._palettePanelShowing=t,this.contentElement.classList.toggle("palette-panel-showing",t),this._focus())}_onCloseBtnKeydown(t){(isEscKey(t)||isEnterOrSpaceKey(t))&&(this._togglePalettePanel(!1),t.consume(!0))}_onSliderKeydown(t,e){switch(e.key){case"ArrowLeft":case"ArrowRight":case"ArrowDown":case"ArrowUp":t(e),e.consume(!0)}}_focus(){this.isShowing()&&(this._palettePanelShowing&&this._closeButton?this._closeButton.element.focus({preventScroll:!0}):this.contentElement.focus())}_createPaletteColor(t,e,o){const s=document.createElement("div");return s.classList.add("spectrum-palette-color"),s.style.background=Platform.StringUtilities.sprintf("linear-gradient(%s, %s), url(Images/checker.png)",t,t),o&&s.animate([{opacity:0},{opacity:1}],{duration:100,delay:o,fill:"backwards"}),UI.Tooltip.Tooltip.install(s,e||t),s}_showPalette(t,e,o){this._resizeForSelectedPalette(),this._paletteContainer.removeChildren();for(let s=0;s<t.colors.length;s++){const o=e?100*s/t.colors.length:0,i=this._createPaletteColor(t.colors[s],t.colorNames[s],o);if(UI.ARIAUtils.markAsButton(i),UI.ARIAUtils.setAccessibleName(i,i18nString(UIStrings.colorS,{PH1:t.colors[s]})),i.tabIndex=-1,i.addEventListener("mousedown",this._paletteColorSelected.bind(this,t.colors[s],t.colorNames[s],Boolean(t.matchUserFormat))),i.addEventListener("focus",this._paletteColorSelected.bind(this,t.colors[s],t.colorNames[s],Boolean(t.matchUserFormat))),i.addEventListener("keydown",this._onPaletteColorKeydown.bind(this,s)),t.mutable)colorElementToMutable.set(i,!0),colorElementToColor.set(i,t.colors[s]),i.addEventListener("contextmenu",this._showPaletteColorContextMenu.bind(this,s));else if(t===MaterialPalette){i.classList.add("has-material-shades");let e=i.createChild("div","spectrum-palette-color spectrum-palette-color-shadow");e.style.background=t.colors[s],e=i.createChild("div","spectrum-palette-color spectrum-palette-color-shadow"),e.style.background=t.colors[s],UI.Tooltip.Tooltip.install(i,i18nString(UIStrings.longclickOrLongpressSpaceToShow,{PH1:t.colors[s]})),UI.ARIAUtils.setAccessibleName(i,UI.Tooltip.Tooltip.getContent(i)),new UI.UIUtils.LongClickController(i,this._showLightnessShades.bind(this,i,t.colors[s]))}this._paletteContainer.appendChild(i)}this._paletteContainer.childNodes.length>0&&(this._paletteContainer.childNodes[0].tabIndex=0),this._paletteContainerMutable=t.mutable,t.mutable?(this._paletteContainer.appendChild(this._addColorToolbar.element),this._paletteContainer.appendChild(this._deleteIconToolbar.element)):(this._addColorToolbar.element.remove(),this._deleteIconToolbar.element.remove()),this._togglePalettePanel(!1),this._focus()}_showLightnessShades(t,e,o){this._shadesCloseHandler&&this._shadesCloseHandler(),this._shadesContainer.classList.remove("hidden"),this._shadesContainer.removeChildren(),this._shadesContainer.animate([{transform:"scaleY(0)",opacity:"0"},{transform:"scaleY(1)",opacity:"1"}],{duration:200,easing:"cubic-bezier(0.4, 0, 0.2, 1)"});let s=this._paletteContainer.offsetTop+t.offsetTop+(t.parentElement?t.parentElement.offsetTop:0);this._contrastDetails&&(s+=this._contrastDetails.element().offsetHeight),this._shadesContainer.style.top=s+"px",this._shadesContainer.style.left=t.offsetLeft+"px",t.classList.add("spectrum-shades-shown");const i=MaterialPaletteShades[e];for(let n=i.length-1;n>=0;n--){const e=this._createPaletteColor(i[n],void 0,200*n/i.length+100);UI.ARIAUtils.markAsButton(e),UI.ARIAUtils.setAccessibleName(e,i18nString(UIStrings.colorS,{PH1:i[n]})),e.tabIndex=-1,e.addEventListener("mousedown",this._paletteColorSelected.bind(this,i[n],i[n],!1)),e.addEventListener("focus",this._paletteColorSelected.bind(this,i[n],i[n],!1)),e.addEventListener("keydown",this._onShadeColorKeydown.bind(this,t)),this._shadesContainer.appendChild(e)}this._shadesContainer.childNodes.length>0&&this._shadesContainer.childNodes[this._shadesContainer.childNodes.length-1].focus(),this._shadesCloseHandler=function(t){this._shadesContainer.classList.add("hidden"),t.classList.remove("spectrum-shades-shown"),this._shadesCloseHandler&&this._shadesContainer.ownerDocument.removeEventListener("mousedown",this._shadesCloseHandler,!0),delete this._shadesCloseHandler}.bind(this,t),this._shadesContainer.ownerDocument.addEventListener("mousedown",this._shadesCloseHandler,!0)}_slotIndexForEvent(t){const e=t,o=e.pageX-this._paletteContainer.totalOffsetLeft(),s=e.pageY-this._paletteContainer.totalOffsetTop(),i=Math.min(o/COLOR_CHIP_SIZE|0,ITEMS_PER_PALETTE_ROW-1),n=s/COLOR_CHIP_SIZE|0;return Math.min(n*ITEMS_PER_PALETTE_ROW+i,this._customPaletteSetting.get().colors.length-1)}_isDraggingToBin(t){return t.pageX>this._deleteIconToolbar.element.totalOffsetLeft()}_paletteDragStart(t){const e=UI.UIUtils.deepElementFromEvent(t);if(!e||!colorElementToMutable.get(e))return!1;const o=this._slotIndexForEvent(t);this._dragElement=e;const s=t;return this._dragHotSpotX=s.pageX-o%ITEMS_PER_PALETTE_ROW*COLOR_CHIP_SIZE,this._dragHotSpotY=s.pageY-(o/ITEMS_PER_PALETTE_ROW|0)*COLOR_CHIP_SIZE,!0}_paletteDrag(t){const e=t;if(e.pageX<this._paletteContainer.totalOffsetLeft()||e.pageY<this._paletteContainer.totalOffsetTop())return;if(!this._dragElement||void 0===this._dragHotSpotX||void 0===this._dragHotSpotY)return;const o=this._slotIndexForEvent(t),s=e.pageX-o%ITEMS_PER_PALETTE_ROW*COLOR_CHIP_SIZE,i=e.pageY-(o/ITEMS_PER_PALETTE_ROW|0)*COLOR_CHIP_SIZE,n=this._isDraggingToBin(t);this._deleteIconToolbar.element.classList.add("dragging"),this._deleteIconToolbar.element.classList.toggle("delete-color-toolbar-active",n);const l="translateX("+(s-this._dragHotSpotX)+"px) translateY("+(i-this._dragHotSpotY)+"px)";this._dragElement.style.transform=n?l+" scale(0.8)":l;const r=Array.prototype.slice.call(this._paletteContainer.children),a=r.indexOf(this._dragElement),h=new Map;for(const c of r)h.set(c,c.totalOffset());a!==o&&this._paletteContainer.insertBefore(this._dragElement,r[o>a?o+1:o]);for(const c of r){if(c===this._dragElement)continue;const t=h.get(c),e=c.totalOffset();!t||t.left===e.left&&t.top===e.top||c.animate([{transform:"translateX("+(t.left-e.left)+"px) translateY("+(t.top-e.top)+"px)"},{transform:"none"}],{duration:100,easing:"cubic-bezier(0, 0, 0.2, 1)"})}}_paletteDragEnd(t){if(!this._dragElement)return;this._isDraggingToBin(t)&&this._dragElement.remove(),this._dragElement.style.removeProperty("transform");const e=this._paletteContainer.children,o=[];for(let i=0;i<e.length;++i){const t=colorElementToColor.get(e[i]);t&&o.push(t)}const s=this._customPaletteSetting.get();s.colors=o,this._customPaletteSetting.set(s),this._showPalette(s,!1),this._deleteIconToolbar.element.classList.remove("dragging"),this._deleteIconToolbar.element.classList.remove("delete-color-toolbar-active")}_loadPalettes(){this._palettes.set(MaterialPalette.title,MaterialPalette);const t={title:"Custom",colors:[],colorNames:[],mutable:!0,matchUserFormat:void 0};this._customPaletteSetting=Common.Settings.Settings.instance().createSetting("customColorPalette",t);const e=this._customPaletteSetting.get();e.colorNames=e.colorNames||[],this._palettes.set(e.title,e),this._selectedColorPalette=Common.Settings.Settings.instance().createSetting("selectedColorPalette",GeneratedPaletteTitle);const o=this._palettes.get(this._selectedColorPalette.get());o&&this._showPalette(o,!0)}addPalette(t){this._palettes.set(t.title,t),this._selectedColorPalette.get()===t.title&&this._showPalette(t,!0)}_createPreviewPaletteElement(t){const e=document.createElement("div");e.classList.add("palette-preview"),UI.ARIAUtils.markAsButton(e),e.tabIndex=0;let o;for(e.createChild("div","palette-preview-title").textContent=t.title,o=0;o<5&&o<t.colors.length;o++)e.appendChild(this._createPaletteColor(t.colors[o],t.colorNames[o]));for(;o<5;o++)e.createChild("div","spectrum-palette-color empty-color");return self.onInvokeElement(e,(e=>{this._paletteSelected(t),e.consume(!0)})),e}_paletteSelected(t){this._selectedColorPalette.set(t.title),this._showPalette(t,!0)}_resizeForSelectedPalette(t){const e=this._palettes.get(this._selectedColorPalette.get());if(!e)return;let o=e.colors.length;e===this._customPaletteSetting.get()&&o++;const s=Math.max(1,Math.ceil(o/ITEMS_PER_PALETTE_ROW));if(this._numPaletteRowsShown===s&&!t)return;this._numPaletteRowsShown=s;let i=236;this._contrastDetails&&(this._contrastDetails.expanded()?i+=78:i+=36),this.element.style.height=i+12+24*s+"px",this.dispatchEventToListeners(Events.SizeChanged)}_paletteColorSelected(t,e,o){const s=Common.Color.Color.parse(t);s&&this._innerSetColor(s.hsva(),t,e,o?this._colorFormat:s.format(),ChangeSource.Other)}_onPaletteColorKeydown(t,e){let o;switch(e.key){case"ArrowLeft":o=t-1;break;case"ArrowRight":o=t+1;break;case"ArrowUp":o=t-ITEMS_PER_PALETTE_ROW;break;case"ArrowDown":o=t+ITEMS_PER_PALETTE_ROW}void 0!==o&&o>-1&&o<this._paletteContainer.childNodes.length&&this._paletteContainer.childNodes[o].focus()}_onShadeColorKeydown(t,e){const o=e,s=o.target;isEscKey(e)||"Tab"===o.key?(t.focus(),this._shadesCloseHandler&&this._shadesCloseHandler(),e.consume(!0)):"ArrowUp"===o.key&&s.previousElementSibling?(s.previousElementSibling.focus(),e.consume(!0)):"ArrowDown"===o.key&&s.nextElementSibling&&(s.nextElementSibling.focus(),e.consume(!0))}_onAddColorMousedown(){this._addColorToCustomPalette()}_onAddColorKeydown(t){isEnterOrSpaceKey(t)&&(this._addColorToCustomPalette(),t.consume(!0))}_addColorToCustomPalette(){const t=this._customPaletteSetting.get();t.colors.push(this.colorString()),this._customPaletteSetting.set(t),this._showPalette(t,!1);const e=this._paletteContainer.querySelectorAll(".spectrum-palette-color");e[e.length-1].focus()}_showPaletteColorContextMenu(t,e){if(!this._paletteContainerMutable)return;const o=new UI.ContextMenu.ContextMenu(e);-1!==t&&(o.defaultSection().appendItem(i18nString(UIStrings.removeColor),this._deletePaletteColors.bind(this,t,!1)),o.defaultSection().appendItem(i18nString(UIStrings.removeAllToTheRight),this._deletePaletteColors.bind(this,t,!0))),o.defaultSection().appendItem(i18nString(UIStrings.clearPalette),this._deletePaletteColors.bind(this,-1,!0)),o.show()}_deletePaletteColors(t,e){const o=this._customPaletteSetting.get();e?o.colors.splice(t+1,o.colors.length-t-1):o.colors.splice(t,1),this._customPaletteSetting.set(o),this._showPalette(o,!1)}setColor(t,e){this._originalFormat=e,this._innerSetColor(t.hsva(),"",void 0,e,ChangeSource.Model);const o=this._color().canonicalHSLA();UI.ARIAUtils.setValueNow(this._hueElement,o[0]),UI.ARIAUtils.setValueText(this._alphaElement,o[3])}colorSelected(t){this._innerSetColor(t.hsva(),"",void 0,void 0,ChangeSource.Other)}_innerSetColor(t,e,o,s,i){if(void 0!==t&&(this._hsv=t),this._colorName=o,void 0!==e&&(this._colorString=e),void 0!==s){const t=Common.Color.Format;console.assert(s!==t.Original,"Spectrum's color format cannot be Original"),s===t.RGBA?s=t.RGB:s===t.HSLA?s=t.HSL:s===t.HEXA?s=t.HEX:s===t.ShortHEXA&&(s=t.ShortHEX),this._colorFormat=s}this._contrastInfo&&this._contrastInfo.setColor(Common.Color.Color.fromHSVA(this._hsv),this._colorFormat),this._updateHelperLocations(),this._updateUI(),i!==ChangeSource.Input&&this._updateInput(),i!==ChangeSource.Model&&this.dispatchEventToListeners(Events.ColorChanged,this.colorString())}_color(){return Common.Color.Color.fromHSVA(this._hsv)}colorName(){return this._colorName}colorString(){if(this._colorString)return this._colorString;const t=Common.Color.Format,e=this._color();let o=e.asString(this._colorFormat);return o||(o=this._colorFormat===t.Nickname?e.asString(e.hasAlpha()?t.HEXA:t.HEX):this._colorFormat===t.ShortHEX?e.asString(e.detectHEXFormat()):this._colorFormat===t.HEX?e.asString(t.HEXA):this._colorFormat===t.HSL?e.asString(t.HSLA):e.asString(t.RGBA),console.assert(Boolean(o)),o||"")}_updateHelperLocations(){const t=this._hsv[0],e=this._hsv[1],o=this._hsv[2],s=this._hsv[3];this._dragX=e*this.dragWidth,this._dragY=this.dragHeight-o*this.dragHeight;const i=Math.max(-this._colorDragElementHeight,Math.min(this.dragWidth-this._colorDragElementHeight,this._dragX-this._colorDragElementHeight)),n=Math.max(-this._colorDragElementHeight,Math.min(this.dragHeight-this._colorDragElementHeight,this._dragY-this._colorDragElementHeight));this._colorDragElement.positionAt(i,n);const l=(1-t)*this._hueAlphaWidth-this.slideHelperWidth;this._hueSlider.style.left=l+"px";const r=s*this._hueAlphaWidth-this.slideHelperWidth;this._alphaSlider.style.left=r+"px"}_updateInput(){const t=Common.Color.Format;if(this._colorFormat===t.HEX||this._colorFormat===t.ShortHEX||this._colorFormat===t.Nickname)this._hexContainer.hidden=!1,this._displayContainer.hidden=!0,this._colorFormat===t.ShortHEX?this._hexValue.value=String(this._color().asString(this._color().detectHEXFormat())):this._hexValue.value=String(this._color().asString(this._color().hasAlpha()?t.HEXA:t.HEX));else{this._hexContainer.hidden=!0,this._displayContainer.hidden=!1;const e=this._colorFormat===t.RGB;this._textLabels.textContent=e?"RGBA":"HSLA";const o=e?this._color().canonicalRGBA():this._color().canonicalHSLA();for(let t=0;t<3;++t)UI.ARIAUtils.setAccessibleName(this._textValues[t],i18nString(UIStrings.sInS,{PH1:this._textLabels.textContent.charAt(t),PH2:this._textLabels.textContent})),this._textValues[t].value=String(o[t]),e||1!==t&&2!==t||(this._textValues[t].value+="%");UI.ARIAUtils.setAccessibleName(this._textValues[3],i18nString(UIStrings.sInS,{PH1:this._textLabels.textContent.charAt(3),PH2:this._textLabels.textContent})),this._textValues[3].value=String(Math.round(100*o[3])/100)}}_updateUI(){const t=Common.Color.Color.fromHSVA([this._hsv[0],1,1,1]);this._colorElement.style.backgroundColor=t.asString(Common.Color.Format.RGB),this._contrastOverlay&&this._contrastOverlay.setDimensions(this.dragWidth,this.dragHeight),this._swatch.setColor(this._color(),this.colorString()),this._colorDragElement.style.backgroundColor=this._color().asString(Common.Color.Format.RGBA);const e=Common.Color.Color.fromHSVA(this._hsv.slice(0,3).concat(1));this._alphaElementBackground.style.backgroundImage=Platform.StringUtilities.sprintf("linear-gradient(to right, rgba(0,0,0,0), %s)",e.asString(Common.Color.Format.RGB))}_formatViewSwitch(){const t=Common.Color.Format;let e=t.RGB;this._colorFormat===t.RGB?e=t.HSL:this._colorFormat===t.HSL&&(e=this._originalFormat===t.ShortHEX||this._originalFormat===t.ShortHEXA?t.ShortHEX:t.HEX),this._innerSetColor(void 0,"",void 0,e,ChangeSource.Other)}_pasted(t){if(!t.clipboardData)return;const e=t.clipboardData.getData("text"),o=Common.Color.Color.parse(e);o&&(this._innerSetColor(o.hsva(),e,void 0,void 0,ChangeSource.Other),t.preventDefault())}_inputChanged(t){function e(t){return t.value}const o=t.currentTarget,s=UI.UIUtils.createReplacementString(o.value,t);s&&(o.value=s,o.selectionStart=0,o.selectionEnd=s.length,t.consume(!0));const i=Common.Color.Format;let n;if(this._colorFormat===i.Nickname||this._colorFormat===i.HEX||this._colorFormat===i.ShortHEX)n=this._hexValue.value;else{const t=this._colorFormat===i.RGB?"rgb":"hsl",o=this._textValues.slice(0,-1).map(e).join(" "),s=this._textValues.slice(-1).map(e).join(" ");n=Platform.StringUtilities.sprintf("%s(%s)",t,[o,s].join(" / "))}const l=Common.Color.Color.parse(n);if(!l)return;let r;this._colorFormat!==i.HEX&&this._colorFormat!==i.ShortHEX||(r=l.detectHEXFormat()),this._innerSetColor(l.hsva(),n,void 0,r,ChangeSource.Input)}wasShown(){this._hueAlphaWidth=this._hueElement.offsetWidth,this.slideHelperWidth=this._hueSlider.offsetWidth/2,this.dragWidth=this._colorElement.offsetWidth,this.dragHeight=this._colorElement.offsetHeight,this._colorDragElementHeight=this._colorDragElement.offsetHeight/2,this._innerSetColor(void 0,void 0,void 0,void 0,ChangeSource.Model),this._toggleColorPicker(!0),this._contrastDetails&&this._contrastDetailsBackgroundColorPickedToggledBound&&this._contrastDetails.addEventListener(ContrastDetailsEvents.BackgroundColorPickerWillBeToggled,this._contrastDetailsBackgroundColorPickedToggledBound)}willHide(){this._toggleColorPicker(!1),this._contrastDetails&&this._contrastDetailsBackgroundColorPickedToggledBound&&this._contrastDetails.removeEventListener(ContrastDetailsEvents.BackgroundColorPickerWillBeToggled,this._contrastDetailsBackgroundColorPickedToggledBound)}_toggleColorPicker(t,e){void 0===t&&(t=!this._colorPickerButton.toggled()),this._colorPickerButton.setToggled(t),this._contrastDetails&&t&&this._contrastDetails.backgroundColorPickerEnabled()&&this._contrastDetails.toggleBackgroundColorPicker(!1),Host.InspectorFrontendHost.InspectorFrontendHostInstance.setEyeDropperActive(t),t?Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this._colorPickedBound):Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.removeEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this._colorPickedBound)}_colorPicked(t){const e=t.data,o=[e.r,e.g,e.b,(e.a/2.55|0)/100],s=Common.Color.Color.fromRGBA(o);this._innerSetColor(s.hsva(),"",void 0,void 0,ChangeSource.Other),Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront()}}export const ChangeSource={Input:"Input",Model:"Model",Other:"Other"};export var Events;!function(t){t.ColorChanged="ColorChanged",t.SizeChanged="SizeChanged"}(Events||(Events={}));const COLOR_CHIP_SIZE=24,ITEMS_PER_PALETTE_ROW=8,GeneratedPaletteTitle="Page colors";export class PaletteGenerator{constructor(t){this._callback=t,this._frequencyMap=new Map;const e=[];for(const o of SDK.SDKModel.TargetManager.instance().models(SDK.CSSModel.CSSModel))for(const t of o.allStyleSheets())e.push(this._processStylesheet(t));Promise.all(e).catch((t=>{console.error(t)})).then(this._finish.bind(this))}_frequencyComparator(t,e){return this._frequencyMap.get(e)-this._frequencyMap.get(t)}_finish(){let t=[...this._frequencyMap.keys()];t=t.sort(this._frequencyComparator.bind(this));const e=new Map;for(;e.size<24&&t.length;){const o=t.shift(),s=Common.Color.Color.parse(o);s&&"white"!==s.nickname()&&"black"!==s.nickname()&&e.set(o,s)}this._callback({title:GeneratedPaletteTitle,colors:[...e.keys()].sort((function(t,o){const s=e.get(t).hsva(),i=e.get(o).hsva();return i[1]<.12&&s[1]<.12?i[2]*i[3]-s[2]*s[3]:i[1]<.12?-1:s[1]<.12?1:i[0]===s[0]?i[1]*i[3]-s[1]*s[3]:(i[0]+.94)%1-(s[0]+.94)%1})),colorNames:[],mutable:!1,matchUserFormat:void 0})}async _processStylesheet(t){let e=(await t.requestContent()).content||"";e=e.toLowerCase();const o=e.match(/((?:rgb|hsl)a?\([^)]+\)|#[0-9a-f]{6}|#[0-9a-f]{3})/g)||[];for(const s of o){let t=this._frequencyMap.get(s)||0;this._frequencyMap.set(s,++t)}}}export const MaterialPaletteShades={"#F44336":["#FFEBEE","#FFCDD2","#EF9A9A","#E57373","#EF5350","#F44336","#E53935","#D32F2F","#C62828","#B71C1C"],"#E91E63":["#FCE4EC","#F8BBD0","#F48FB1","#F06292","#EC407A","#E91E63","#D81B60","#C2185B","#AD1457","#880E4F"],"#9C27B0":["#F3E5F5","#E1BEE7","#CE93D8","#BA68C8","#AB47BC","#9C27B0","#8E24AA","#7B1FA2","#6A1B9A","#4A148C"],"#673AB7":["#EDE7F6","#D1C4E9","#B39DDB","#9575CD","#7E57C2","#673AB7","#5E35B1","#512DA8","#4527A0","#311B92"],"#3F51B5":["#E8EAF6","#C5CAE9","#9FA8DA","#7986CB","#5C6BC0","#3F51B5","#3949AB","#303F9F","#283593","#1A237E"],"#2196F3":["#E3F2FD","#BBDEFB","#90CAF9","#64B5F6","#42A5F5","#2196F3","#1E88E5","#1976D2","#1565C0","#0D47A1"],"#03A9F4":["#E1F5FE","#B3E5FC","#81D4FA","#4FC3F7","#29B6F6","#03A9F4","#039BE5","#0288D1","#0277BD","#01579B"],"#00BCD4":["#E0F7FA","#B2EBF2","#80DEEA","#4DD0E1","#26C6DA","#00BCD4","#00ACC1","#0097A7","#00838F","#006064"],"#009688":["#E0F2F1","#B2DFDB","#80CBC4","#4DB6AC","#26A69A","#009688","#00897B","#00796B","#00695C","#004D40"],"#4CAF50":["#E8F5E9","#C8E6C9","#A5D6A7","#81C784","#66BB6A","#4CAF50","#43A047","#388E3C","#2E7D32","#1B5E20"],"#8BC34A":["#F1F8E9","#DCEDC8","#C5E1A5","#AED581","#9CCC65","#8BC34A","#7CB342","#689F38","#558B2F","#33691E"],"#CDDC39":["#F9FBE7","#F0F4C3","#E6EE9C","#DCE775","#D4E157","#CDDC39","#C0CA33","#AFB42B","#9E9D24","#827717"],"#FFEB3B":["#FFFDE7","#FFF9C4","#FFF59D","#FFF176","#FFEE58","#FFEB3B","#FDD835","#FBC02D","#F9A825","#F57F17"],"#FFC107":["#FFF8E1","#FFECB3","#FFE082","#FFD54F","#FFCA28","#FFC107","#FFB300","#FFA000","#FF8F00","#FF6F00"],"#FF9800":["#FFF3E0","#FFE0B2","#FFCC80","#FFB74D","#FFA726","#FF9800","#FB8C00","#F57C00","#EF6C00","#E65100"],"#FF5722":["#FBE9E7","#FFCCBC","#FFAB91","#FF8A65","#FF7043","#FF5722","#F4511E","#E64A19","#D84315","#BF360C"],"#795548":["#EFEBE9","#D7CCC8","#BCAAA4","#A1887F","#8D6E63","#795548","#6D4C41","#5D4037","#4E342E","#3E2723"],"#9E9E9E":["#FAFAFA","#F5F5F5","#EEEEEE","#E0E0E0","#BDBDBD","#9E9E9E","#757575","#616161","#424242","#212121"],"#607D8B":["#ECEFF1","#CFD8DC","#B0BEC5","#90A4AE","#78909C","#607D8B","#546E7A","#455A64","#37474F","#263238"]};export const MaterialPalette={title:"Material",mutable:!1,matchUserFormat:!0,colors:Object.keys(MaterialPaletteShades),colorNames:[]};export class Swatch{constructor(t){const e=t.createChild("span","swatch");this._swatchInnerElement=e.createChild("span","swatch-inner"),this._swatchOverlayElement=e.createChild("span","swatch-overlay"),UI.ARIAUtils.markAsButton(this._swatchOverlayElement),UI.ARIAUtils.setPressed(this._swatchOverlayElement,!1),this._swatchOverlayElement.tabIndex=0,self.onInvokeElement(this._swatchOverlayElement,this._onCopyText.bind(this)),this._swatchOverlayElement.addEventListener("mouseout",this._onCopyIconMouseout.bind(this)),this._swatchOverlayElement.addEventListener("blur",this._onCopyIconMouseout.bind(this)),this._swatchCopyIcon=UI.Icon.Icon.create("largeicon-copy","copy-color-icon"),UI.Tooltip.Tooltip.install(this._swatchCopyIcon,i18nString(UIStrings.copyColorToClipboard)),this._swatchOverlayElement.appendChild(this._swatchCopyIcon),UI.ARIAUtils.setAccessibleName(this._swatchOverlayElement,this._swatchCopyIcon.title)}setColor(t,e){this._swatchInnerElement.style.backgroundColor=t.asString(Common.Color.Format.RGBA),this._swatchInnerElement.classList.toggle("swatch-inner-white",t.hsla()[2]>.9),this._colorString=e||null,this._swatchOverlayElement.hidden=!e}_onCopyText(t){this._swatchCopyIcon.setIconType("largeicon-checkmark"),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(this._colorString),UI.ARIAUtils.setPressed(this._swatchOverlayElement,!0),t.consume()}_onCopyIconMouseout(){this._swatchCopyIcon.setIconType("largeicon-copy"),UI.ARIAUtils.setPressed(this._swatchOverlayElement,!1)}}