import*as Root from"../root/root.js";import{Format}from"./Color.js";import{Console}from"./Console.js";import{ObjectWrapper}from"./Object.js";import{getLocalizedSettingsCategory,getRegisteredSettings,registerSettingExtengionsForTest,registerSettingExtension}from"./SettingRegistration.js";let settingsInstance;export class Settings{constructor(e,t){this._globalStorage=e,this._localStorage=t,this._sessionStorage=new SettingsStorage({}),this.settingNameSet=new Set,this.orderValuesBySettingCategory=new Map,this._eventSupport=new ObjectWrapper,this._registry=new Map,this._moduleSettings=new Map;for(const i of getRegisteredSettings()){const{settingName:e,defaultValue:t,storageType:s}=i,n="regex"===i.settingType&&"string"===typeof t?this.createRegExpSetting(e,t,void 0,s):this.createSetting(e,t,s);"mac"===Root.Runtime.Runtime.platform()&&i.titleMac?n.setTitleFunction(i.titleMac):n.setTitleFunction(i.title),i.userActionCondition&&n.setRequiresUserAction(Boolean(Root.Runtime.Runtime.queryParam(i.userActionCondition))),n.setRegistration(i),this._registerModuleSetting(n)}}static hasInstance(){return"undefined"!==typeof settingsInstance}static instance(e={forceNew:null,globalStorage:null,localStorage:null}){const{forceNew:t,globalStorage:i,localStorage:s}=e;if(!settingsInstance||t){if(!i||!s)throw new Error(`Unable to create settings: global and local storage must be provided: ${(new Error).stack}`);settingsInstance=new Settings(i,s)}return settingsInstance}static removeInstance(){settingsInstance=void 0}_registerModuleSetting(e){const t=e.name,i=e.category(),s=e.order();if(this.settingNameSet.has(t))throw new Error(`Duplicate Setting name '${t}'`);if(i&&s){const e=this.orderValuesBySettingCategory.get(i)||new Set;if(e.has(s))throw new Error(`Duplicate order value '${s}' for settings category '${i}'`);e.add(s),this.orderValuesBySettingCategory.set(i,e)}this.settingNameSet.add(t),this._moduleSettings.set(e.name,e)}moduleSetting(e){const t=this._moduleSettings.get(e);if(!t)throw new Error("No setting registered: "+e);return t}settingForTest(e){const t=this._registry.get(e);if(!t)throw new Error("No setting registered: "+e);return t}createSetting(e,t,i){const s=this._storageFromType(i);let n=this._registry.get(e);return n||(n=new Setting(this,e,t,this._eventSupport,s),this._registry.set(e,n)),n}createLocalSetting(e,t){return this.createSetting(e,t,SettingStorageType.Local)}createRegExpSetting(e,t,i,s){return this._registry.get(e)||this._registry.set(e,new RegExpSetting(this,e,t,this._eventSupport,this._storageFromType(s),i)),this._registry.get(e)}clearAll(){this._globalStorage.removeAll(),this._localStorage.removeAll();Settings.instance().createSetting(VersionController._currentVersionName,0).set(VersionController.currentVersion)}_storageFromType(e){switch(e){case SettingStorageType.Local:return this._localStorage;case SettingStorageType.Session:return this._sessionStorage;case SettingStorageType.Global:return this._globalStorage}return this._globalStorage}}export class SettingsStorage{constructor(e,t,i,s,n){this._object=e,this._setCallback=t||function(){},this._removeCallback=i||function(){},this._removeAllCallback=s||function(){},this._storagePrefix=n||""}set(e,t){e=this._storagePrefix+e,this._object[e]=t,this._setCallback(e,t)}has(e){return(e=this._storagePrefix+e)in this._object}get(e){return e=this._storagePrefix+e,this._object[e]}remove(e){e=this._storagePrefix+e,delete this._object[e],this._removeCallback(e)}removeAll(){this._object={},this._removeAllCallback()}_dumpSizes(){Console.instance().log("Ten largest settings: ");const e={__proto__:null};for(const i in this._object)e[i]=this._object[i].length;const t=Object.keys(e);t.sort((function(t,i){return e[i]-e[t]}));for(let i=0;i<10&&i<t.length;++i)Console.instance().log("Setting: '"+t[i]+"', size: "+e[t[i]])}}export class Setting{constructor(e,t,i,s,n){this._settings=e,this._name=t,this._defaultValue=i,this._eventSupport=s,this._storage=n,this._titleFunction,this._title,this._registration=null}addChangeListener(e,t){return this._eventSupport.addEventListener(this._name,e,t)}removeChangeListener(e,t){this._eventSupport.removeEventListener(this._name,e,t)}get name(){return this._name}title(){return this._title?this._title:this._titleFunction?this._titleFunction():""}setTitleFunction(e){e&&(this._titleFunction=e)}setTitle(e){this._title=e}setRequiresUserAction(e){this._requiresUserAction=e}get(){if(this._requiresUserAction&&!this._hadUserAction)return this._defaultValue;if("undefined"!==typeof this._value)return this._value;if(this._value=this._defaultValue,this._storage.has(this._name))try{this._value=JSON.parse(this._storage.get(this._name))}catch(e){this._storage.remove(this._name)}return this._value}set(e){this._hadUserAction=!0,this._value=e;try{const i=JSON.stringify(e);try{this._storage.set(this._name,i)}catch(t){this._printSettingsSavingError(t.message,this._name,i)}}catch(t){Console.instance().error("Cannot stringify setting with name: "+this._name+", error: "+t.message)}this._eventSupport.dispatchEventToListeners(this._name,e)}remove(){this._settings._registry.delete(this._name),this._settings._moduleSettings.delete(this._name),this._storage.remove(this._name)}setRegistration(e){this._registration=e}type(){return this._registration?this._registration.settingType:null}options(){return this._registration&&this._registration.options?this._registration.options.map((e=>{const{value:t,title:i,text:s,raw:n}=e;return{value:t,title:i(),text:"function"===typeof s?s():s,raw:n}})):[]}reloadRequired(){return this._registration&&this._registration.reloadRequired||null}category(){return this._registration&&this._registration.category||null}tags(){return this._registration&&this._registration.tags?this._registration.tags.map((e=>e())).join("\0"):null}order(){return this._registration&&this._registration.order||null}_printSettingsSavingError(e,t,i){const s="Error saving setting with name: "+this._name+", value length: "+i.length+". Error: "+e;console.error(s),Console.instance().error(s),this._storage._dumpSizes()}defaultValue(){return this._defaultValue}}export class RegExpSetting extends Setting{constructor(e,t,i,s,n,r){super(e,t,i?[{pattern:i}]:[],s,n),this._regexFlags=r}get(){const e=[],t=this.getAsArray();for(let i=0;i<t.length;++i){const s=t[i];s.pattern&&!s.disabled&&e.push(s.pattern)}return e.join("|")}getAsArray(){return super.get()}set(e){this.setAsArray([{pattern:e,disabled:!1}])}setAsArray(e){delete this._regex,super.set(e)}asRegExp(){if("undefined"!==typeof this._regex)return this._regex;this._regex=null;try{const e=this.get();e&&(this._regex=new RegExp(e,this._regexFlags||""))}catch(e){}return this._regex}}export class VersionController{static get _currentVersionName(){return"inspectorVersion"}static get currentVersion(){return 30}updateVersion(){const e=window.localStorage?window.localStorage[VersionController._currentVersionName]:0,t=Settings.instance().createSetting(VersionController._currentVersionName,0),i=VersionController.currentVersion,s=t.get()||parseInt(e||"0",10);if(0===s)return void t.set(i);const n=this._methodsToRunToUpdateVersion(s,i);for(const r of n)this[r].call(this);t.set(i)}_methodsToRunToUpdateVersion(e,t){const i=[];for(let s=e;s<t;++s)i.push("_updateVersionFrom"+s+"To"+(s+1));return i}_updateVersionFrom0To1(){this._clearBreakpointsWhenTooMany(Settings.instance().createLocalSetting("breakpoints",[]),5e5)}_updateVersionFrom1To2(){Settings.instance().createSetting("previouslyViewedFiles",[]).set([])}_updateVersionFrom2To3(){Settings.instance().createSetting("fileSystemMapping",{}).set({}),Settings.instance().createSetting("fileMappingEntries",[]).remove()}_updateVersionFrom3To4(){const e=Settings.instance().createSetting("showHeaSnapshotObjectsHiddenProperties",!1);moduleSetting("showAdvancedHeapSnapshotProperties").set(e.get()),e.remove()}_updateVersionFrom4To5(){const e={FileSystemViewSidebarWidth:"fileSystemViewSplitViewState",elementsSidebarWidth:"elementsPanelSplitViewState",StylesPaneSplitRatio:"stylesPaneSplitViewState",heapSnapshotRetainersViewSize:"heapSnapshotSplitViewState","InspectorView.splitView":"InspectorView.splitViewState","InspectorView.screencastSplitView":"InspectorView.screencastSplitViewState","Inspector.drawerSplitView":"Inspector.drawerSplitViewState",layerDetailsSplitView:"layerDetailsSplitViewState",networkSidebarWidth:"networkPanelSplitViewState",sourcesSidebarWidth:"sourcesPanelSplitViewState",scriptsPanelNavigatorSidebarWidth:"sourcesPanelNavigatorSplitViewState",sourcesPanelSplitSidebarRatio:"sourcesPanelDebuggerSidebarSplitViewState","timeline-details":"timelinePanelDetailsSplitViewState","timeline-split":"timelinePanelRecorsSplitViewState","timeline-view":"timelinePanelTimelineStackSplitViewState",auditsSidebarWidth:"auditsPanelSplitViewState",layersSidebarWidth:"layersPanelSplitViewState",profilesSidebarWidth:"profilesPanelSplitViewState",resourcesSidebarWidth:"resourcesPanelSplitViewState"},t={};for(const i in e){const s=e[i],n=i+"H";let r=null;const o=Settings.instance().createSetting(i,t);o.get()!==t&&(r=r||{},r.vertical={},r.vertical.size=o.get(),o.remove());const a=Settings.instance().createSetting(n,t);a.get()!==t&&(r=r||{},r.horizontal={},r.horizontal.size=a.get(),a.remove()),r&&Settings.instance().createSetting(s,{}).set(r)}}_updateVersionFrom5To6(){const e={debuggerSidebarHidden:"sourcesPanelSplitViewState",navigatorHidden:"sourcesPanelNavigatorSplitViewState","WebInspector.Drawer.showOnLoad":"Inspector.drawerSplitViewState"};for(const t in e){const i=Settings.instance().createSetting(t,null);if(null===i.get()){i.remove();continue}const s=e[t],n="WebInspector.Drawer.showOnLoad"===t,r=i.get()!==n;i.remove();const o=r?"OnlyMain":"Both",a=Settings.instance().createSetting(s,{}),l=a.get()||{};l.vertical=l.vertical||{},l.vertical.showMode=o,l.horizontal=l.horizontal||{},l.horizontal.showMode=o,a.set(l)}}_updateVersionFrom6To7(){const e={sourcesPanelNavigatorSplitViewState:"sourcesPanelNavigatorSplitViewState",elementsPanelSplitViewState:"elementsPanelSplitViewState",stylesPaneSplitViewState:"stylesPaneSplitViewState",sourcesPanelDebuggerSidebarSplitViewState:"sourcesPanelDebuggerSidebarSplitViewState"},t={};for(const i in e){const e=Settings.instance().createSetting(i,t),s=e.get();s!==t&&(s.vertical&&s.vertical.size&&s.vertical.size<1&&(s.vertical.size=0),s.horizontal&&s.horizontal.size&&s.horizontal.size<1&&(s.horizontal.size=0),e.set(s))}}_updateVersionFrom7To8(){}_updateVersionFrom8To9(){const e=["skipStackFramesPattern","workspaceFolderExcludePattern"];for(let t=0;t<e.length;++t){const i=Settings.instance().createSetting(e[t],"");let s=i.get();if(!s)return;"string"===typeof s&&(s=[s]);for(let e=0;e<s.length;++e)"string"===typeof s[e]&&(s[e]={pattern:s[e]});i.set(s)}}_updateVersionFrom9To10(){if(window.localStorage)for(const e in window.localStorage)e.startsWith("revision-history")&&window.localStorage.removeItem(e)}_updateVersionFrom10To11(){const e=Settings.instance().createSetting("customDevicePresets",void 0),t=e.get();if(!Array.isArray(t))return;const i=[];for(let s=0;s<t.length;++s){const e=t[s],n={};n.title=e.title,n.type="unknown",n["user-agent"]=e.userAgent,n.capabilities=[],e.touch&&n.capabilities.push("touch"),e.mobile&&n.capabilities.push("mobile"),n.screen={},n.screen.vertical={width:e.width,height:e.height},n.screen.horizontal={width:e.height,height:e.width},n.screen["device-pixel-ratio"]=e.deviceScaleFactor,n.modes=[],n["show-by-default"]=!0,n.show="Default",i.push(n)}i.length&&Settings.instance().createSetting("customEmulatedDeviceList",[]).set(i),e.remove()}_updateVersionFrom11To12(){this._migrateSettingsFromLocalStorage()}_updateVersionFrom12To13(){this._migrateSettingsFromLocalStorage(),Settings.instance().createSetting("timelineOverviewMode","").remove()}_updateVersionFrom13To14(){const e={throughput:-1,latency:0};Settings.instance().createSetting("networkConditions",e).set(e)}_updateVersionFrom14To15(){const e=Settings.instance().createLocalSetting("workspaceExcludedFolders",{}),t=e.get(),i={};for(const s in t){i[s]=[];for(const e of t[s])i[s].push(e.path)}e.set(i)}_updateVersionFrom15To16(){const e=Settings.instance().createSetting("InspectorView.panelOrder",{}),t=e.get();for(const i of Object.keys(t))t[i]=10*(t[i]+1);e.set(t)}_updateVersionFrom16To17(){const e=Settings.instance().createSetting("networkConditionsCustomProfiles",[]),t=e.get(),i=[];if(Array.isArray(t))for(const s of t)"string"===typeof s.title&&"object"===typeof s.value&&"number"===typeof s.value.throughput&&"number"===typeof s.value.latency&&i.push({title:s.title,value:{download:s.value.throughput,upload:s.value.throughput,latency:s.value.latency}});e.set(i)}_updateVersionFrom17To18(){const e=Settings.instance().createLocalSetting("workspaceExcludedFolders",{}),t=e.get(),i={};for(const s in t){let e=s.replace(/\\/g,"/");e.startsWith("file://")||(e=e.startsWith("/")?"file://"+e:"file:///"+e),i[e]=t[s]}e.set(i)}_updateVersionFrom18To19(){const e=Settings.instance().createSetting("networkLogColumnsVisibility",{status:!0,type:!0,initiator:!0,size:!0,time:!0}),t=e.get();t.name=!0,t.timeline=!0;const i={};for(const s in t)t.hasOwnProperty(s)&&(i[s.toLowerCase()]={visible:t[s]});Settings.instance().createSetting("networkLogColumns",{}).set(i),e.remove()}_updateVersionFrom19To20(){const e=Settings.instance().createSetting("InspectorView.panelOrder",{});Settings.instance().createSetting("panel-tabOrder",{}).set(e.get()),e.remove()}_updateVersionFrom20To21(){const e=Settings.instance().createSetting("networkLogColumns",{}),t=e.get();delete t.timeline,delete t.waterfall,e.set(t)}_updateVersionFrom21To22(){const e=Settings.instance().createLocalSetting("breakpoints",[]),t=e.get();for(const i of t)i.url=i.sourceFileId,delete i.sourceFileId;e.set(t)}_updateVersionFrom22To23(){}_updateVersionFrom23To24(){const e=Settings.instance().createSetting("searchInContentScripts",!1);Settings.instance().createSetting("searchInAnonymousAndContentScripts",!1).set(e.get()),e.remove()}_updateVersionFrom24To25(){const e=Settings.instance().createSetting("networkLogColumns",{status:!0,type:!0,initiator:!0,size:!0,time:!0}),t=e.get();delete t.product,e.set(t)}_updateVersionFrom25To26(){const e=Settings.instance().createSetting("messageURLFilters",{}),t=Object.keys(e.get()).map((e=>`-url:${e}`)).join(" ");if(t){const e=Settings.instance().createSetting("console.textFilter",""),i=e.get()?` ${e.get()}`:"";e.set(`${t}${i}`)}e.remove()}_updateVersionFrom26To27(){function e(e,t,i){const s=Settings.instance().createSetting(e,{}),n=s.get();t in n&&(n[i]=n[t],delete n[t],s.set(n))}e("panel-tabOrder","audits2","audits"),e("panel-closeableTabs","audits2","audits"),function(e,t,i){const s=Settings.instance().createSetting(e,"");s.get()===t&&s.set(i)}("panel-selectedTab","audits2","audits")}_updateVersionFrom27To28(){const e=Settings.instance().createSetting("uiTheme","systemPreferred");"default"===e.get()&&e.set("systemPreferred")}_updateVersionFrom28To29(){function e(e,t,i){const s=Settings.instance().createSetting(e,{}),n=s.get();t in n&&(n[i]=n[t],delete n[t],s.set(n))}e("panel-tabOrder","audits","lighthouse"),e("panel-closeableTabs","audits","lighthouse"),function(e,t,i){const s=Settings.instance().createSetting(e,"");s.get()===t&&s.set(i)}("panel-selectedTab","audits","lighthouse")}_updateVersionFrom29To30(){const e=Settings.instance().createSetting("closeableTabs",{}),t=Settings.instance().createSetting("panel-closeableTabs",{}),i=Settings.instance().createSetting("drawer-view-closeableTabs",{}),s=t.get(),n=t.get(),r=Object.assign(n,s);e.set(r),t.remove(),i.remove()}_migrateSettingsFromLocalStorage(){const e=new Set(["advancedSearchConfig","breakpoints","consoleHistory","domBreakpoints","eventListenerBreakpoints","fileSystemMapping","lastSelectedSourcesSidebarPaneTab","previouslyViewedFiles","savedURLs","watchExpressions","workspaceExcludedFolders","xhrBreakpoints"]);if(window.localStorage)for(const t in window.localStorage){if(e.has(t))continue;const i=window.localStorage[t];window.localStorage.removeItem(t),Settings.instance()._globalStorage.set(t,i)}}_clearBreakpointsWhenTooMany(e,t){e.get().length>t&&e.set([])}}export const SettingStorageType={Global:Symbol("Global"),Local:Symbol("Local"),Session:Symbol("Session")};export function moduleSetting(e){return Settings.instance().moduleSetting(e)}export function settingForTest(e){return Settings.instance().settingForTest(e)}export function detectColorFormat(e){const t=Format;let i;const s=Settings.instance().moduleSetting("colorFormat").get();return i=s===t.Original?t.Original:s===t.RGB?t.RGB:s===t.HSL?t.HSL:s===t.HEX?e.detectHEXFormat():t.RGB,i}export{getLocalizedSettingsCategory,getRegisteredSettings,registerSettingExtension,registerSettingExtengionsForTest};export let SimpleSettingOption;