import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as ObjectUI from"../object_ui/object_ui.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TextEditor from"../text_editor/text_editor.js";import*as TextUtils from"../text_utils/text_utils.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as UI from"../ui/ui.js";const UIStrings={consoleclearWasPreventedDueTo:"`console.clear()` was prevented due to 'Preserve log'",consoleWasCleared:"Console was cleared",clearAllMessagesWithS:"Clear all messages with {PH1}",assertionFailed:"Assertion failed: ",violationS:"`[Violation]` {PH1}",interventionS:"`[Intervention]` {PH1}",deprecationS:"`[Deprecation]` {PH1}",thisValueWillNotBeCollectedUntil:"This value will not be collected until console is cleared.",thisValueWasEvaluatedUponFirst:"This value was evaluated upon first expanding. It may have changed since then.",functionWasResolvedFromBound:"Function was resolved from bound function.",exception:"<exception>",warning:"Warning",error:"Error",repeatS:"Repeat {PH1}",warningS:"Warning {PH1}",errorS:"Error {PH1}",url:"<URL>",tookNms:"took <N>ms",someEvent:"<some> event",Mxx:" M<XX>",attribute:"<attribute>",index:"(index)",value:"Value",console:"Console"},str_=i18n.i18n.registerUIStrings("console/ConsoleViewMessage.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),elementToMessage=new WeakMap;export const getMessageForElement=e=>elementToMessage.get(e);const defaultConsoleRowHeight=19,parameterToRemoteObject=e=>t=>t instanceof SDK.RemoteObject.RemoteObject?t:e?"object"===typeof t?e.createRemoteObject(t):e.createRemoteObjectFromPrimitiveValue(t):SDK.RemoteObject.RemoteObject.fromLocalObject(t);export class ConsoleViewMessage{constructor(e,t,s,n){this._message=e,this._linkifier=t,this._repeatCount=1,this._closeGroupDecorationCount=0,this._nestingLevel=s,this._selectableChildren=[],this._messageResized=n,this._element=null,this._previewFormatter=new ObjectUI.RemoteObjectPreviewFormatter.RemoteObjectPreviewFormatter,this._searchRegex=null,this._messageLevelIcon=null,this._traceExpanded=!1,this._expandTrace=null,this._anchorElement=null,this._contentElement=null,this._nestingLevelMarkers=null,this._searchHighlightNodes=[],this._searchHighlightNodeChanges=[],this._isVisible=!1,this._cachedHeight=0,this._messagePrefix="",this._timestampElement=null,this._inSimilarGroup=!1,this._similarGroupMarker=null,this._lastInSimilarGroup=!1,this._groupKey="",this._repeatCountElement=null}element(){return this.toMessageElement()}wasShown(){this._isVisible=!0}onResize(){}willHide(){this._isVisible=!1,this._cachedHeight=this.element().offsetHeight}isVisible(){return this._isVisible}fastHeight(){return this._cachedHeight?this._cachedHeight:this.approximateFastHeight()}approximateFastHeight(){return 19}consoleMessage(){return this._message}_buildMessage(){let e,t=this._message.messageText;if(this._message.source===SDK.ConsoleModel.MessageSource.ConsoleAPI)switch(this._message.type){case SDK.ConsoleModel.MessageType.Trace:e=this._format(this._message.parameters||["console.trace"]);break;case SDK.ConsoleModel.MessageType.Clear:e=document.createElement("span"),e.classList.add("console-info"),Common.Settings.Settings.instance().moduleSetting("preserveConsoleLog").get()?e.textContent=i18nString(UIStrings.consoleclearWasPreventedDueTo):e.textContent=i18nString(UIStrings.consoleWasCleared),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.clearAllMessagesWithS,{PH1:UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("console.clear")}));break;case SDK.ConsoleModel.MessageType.Dir:{const t=["%O",this._message.parameters?this._message.parameters[0]:void 0];e=this._format(t);break}case SDK.ConsoleModel.MessageType.Profile:case SDK.ConsoleModel.MessageType.ProfileEnd:e=this._format([t]);break;default:{if(this._message.type===SDK.ConsoleModel.MessageType.Assert&&(this._messagePrefix=i18nString(UIStrings.assertionFailed)),this._message.parameters&&1===this._message.parameters.length){const t=this._message.parameters[0];"string"!==typeof t&&"string"===t.type&&(e=this._tryFormatAsError(t.value))}const s=this._message.parameters||[t];e=e||this._format(s)}}else if(this._message.source===SDK.ConsoleModel.MessageSource.Network)e=this._formatAsNetworkRequest()||this._format([t]);else{const s=this._message.parameters&&t===this._message.parameters[0];this._message.source===SDK.ConsoleModel.MessageSource.Violation?t=i18nString(UIStrings.violationS,{PH1:t}):this._message.source===SDK.ConsoleModel.MessageSource.Intervention?t=i18nString(UIStrings.interventionS,{PH1:t}):this._message.source===SDK.ConsoleModel.MessageSource.Deprecation&&(t=i18nString(UIStrings.deprecationS,{PH1:t}));const n=this._message.parameters||[t];s&&(n[0]=t),e=this._format(n)}e.classList.add("console-message-text");const s=document.createElement("span");return s.classList.add("source-code"),this._anchorElement=this._buildMessageAnchor(),this._anchorElement&&s.appendChild(this._anchorElement),s.appendChild(e),s}_formatAsNetworkRequest(){const e=SDK.NetworkLog.NetworkLog.requestForConsoleMessage(this._message);if(!e)return null;const t=document.createElement("span");if(this._message.level===SDK.ConsoleModel.MessageLevel.Error){UI.UIUtils.createTextChild(t,e.requestMethod+" ");const s=Components.Linkifier.Linkifier.linkifyRevealable(e,e.url(),e.url());s.tabIndex=-1,this._selectableChildren.push({element:s,forceSelect:()=>s.focus()}),t.appendChild(s),e.failed&&UI.UIUtils.createTextChildren(t," ",e.localizedFailDescription||""),0!==e.statusCode&&UI.UIUtils.createTextChildren(t," ",String(e.statusCode)),e.statusText&&UI.UIUtils.createTextChildren(t," (",e.statusText,")")}else{const s=this._message.messageText,n=this._linkifyWithCustomLinkifier(s,((t,s,n,i)=>{const r=s===e.url()?Components.Linkifier.Linkifier.linkifyRevealable(e,s,e.url()):Components.Linkifier.Linkifier.linkifyURL(s,{text:t,lineNumber:n,columnNumber:i});return r.tabIndex=-1,this._selectableChildren.push({element:r,forceSelect:()=>r.focus()}),r}));t.appendChild(n)}return t}_buildMessageAnchor(){const e=(e=>e.scriptId?this._linkifyScriptId(e.scriptId,e.url||"",e.line,e.column):e.stackTrace&&e.stackTrace.callFrames.length?this._linkifyStackTraceTopFrame(e.stackTrace):e.url&&"undefined"!==e.url?this._linkifyLocation(e.url,e.line,e.column):null)(this._message);if(e){e.tabIndex=-1,this._selectableChildren.push({element:e,forceSelect:()=>e.focus()});const t=document.createElement("span");return t.classList.add("console-message-anchor"),t.appendChild(e),UI.UIUtils.createTextChild(t," "),t}return null}_buildMessageWithStackTrace(e){const t=document.createElement("div");t.classList.add("console-message-stack-trace-toggle");const s=t.createChild("div","console-message-stack-trace-wrapper"),n=this._buildMessage(),i=UI.Icon.Icon.create("smallicon-triangle-right","console-message-expand-icon"),r=s.createChild("div");r.appendChild(i),r.tabIndex=-1,r.appendChild(n);const o=s.createChild("div"),a=Components.JSPresentationUtils.buildStackTracePreviewContents(e.target(),this._linkifier,{stackTrace:this._message.stackTrace,contentUpdated:void 0,tabStops:void 0});o.appendChild(a.element);for(const l of a.links)this._selectableChildren.push({element:l,forceSelect:()=>l.focus()});o.classList.add("hidden"),UI.ARIAUtils.markAsTreeitem(this.element()),UI.ARIAUtils.setExpanded(this.element(),!1),this._expandTrace=e=>{i.setIconType(e?"smallicon-triangle-down":"smallicon-triangle-right"),o.classList.toggle("hidden",!e),UI.ARIAUtils.setExpanded(this.element(),e),this._traceExpanded=e};return r.addEventListener("click",(e=>{UI.UIUtils.isEditing()||s.hasSelection()||(this._expandTrace&&this._expandTrace(o.classList.contains("hidden")),e.consume())}),!1),this._message.type===SDK.ConsoleModel.MessageType.Trace&&this._expandTrace(!0),t._expandStackTraceForTest=this._expandTrace.bind(this,!0),t}_linkifyLocation(e,t,s){const n=this._message.runtimeModel();return n?this._linkifier.linkifyScriptLocation(n.target(),null,e,t,{columnNumber:s,className:void 0,tabStop:void 0}):null}_linkifyStackTraceTopFrame(e){const t=this._message.runtimeModel();return t?this._linkifier.linkifyStackTraceTopFrame(t.target(),e):null}_linkifyScriptId(e,t,s,n){const i=this._message.runtimeModel();return i?this._linkifier.linkifyScriptLocation(i.target(),e,t,s,{columnNumber:n,className:void 0,tabStop:void 0}):null}_format(e){const t=document.createElement("span");if(this._messagePrefix&&(t.createChild("span").textContent=this._messagePrefix),!e.length)return t;let s=e.map(parameterToRemoteObject(this._message.runtimeModel()));const n="string"===SDK.RemoteObject.RemoteObject.type(s[0])&&(this._message.type!==SDK.ConsoleModel.MessageType.Result||this._message.level===SDK.ConsoleModel.MessageLevel.Error);if(n){const e=this._formatWithSubstitutionString(s[0].description,s.slice(1),t);s=Array.from(e.unusedSubstitutions||[]),s.length&&UI.UIUtils.createTextChild(t," ")}for(let i=0;i<s.length;++i)n&&"string"===s[i].type?t.appendChild(this._linkifyStringAsFragment(s[i].description||"")):t.appendChild(this._formatParameter(s[i],!1,!0)),i<s.length-1&&UI.UIUtils.createTextChild(t," ");return t}_formatParameter(e,t,s){if(e.customPreview())return new ObjectUI.CustomPreviewComponent.CustomPreviewComponent(e).element;const n=t?"object":e.subtype||e.type;let i;switch(n){case"error":i=this._formatParameterAsError(e);break;case"function":i=this._formatParameterAsFunction(e,s);break;case"array":case"arraybuffer":case"blob":case"dataview":case"generator":case"iterator":case"map":case"object":case"promise":case"proxy":case"set":case"typedarray":case"weakmap":case"weakset":case"webassemblymemory":i=this._formatParameterAsObject(e,s);break;case"node":i=e.isNode()?this._formatParameterAsNode(e):this._formatParameterAsObject(e,!1);break;case"trustedtype":i=this._formatParameterAsObject(e,!1);break;case"string":i=this._formatParameterAsString(e);break;case"boolean":case"date":case"null":case"number":case"regexp":case"symbol":case"undefined":case"bigint":i=this._formatParameterAsValue(e);break;default:i=this._formatParameterAsValue(e),console.error(`Tried to format remote object of unknown type ${n}.`)}return i.classList.add(`object-value-${n}`),i.classList.add("source-code"),i}_formatParameterAsValue(e){const t=document.createElement("span"),s=e.description||"";if(s.length>getMaxTokenizableStringLength()){const e=new ObjectUI.ObjectPropertiesSection.ExpandableTextPropertyValue(document.createElement("span"),s,getLongStringVisibleLength());t.appendChild(e.element)}else UI.UIUtils.createTextChild(t,s);return e.objectId&&t.addEventListener("contextmenu",this._contextMenuEventFired.bind(this,e),!1),t}_formatParameterAsTrustedType(e){const t=document.createElement("span"),s=document.createElement("span");return s.appendChild(this._formatParameterAsString(e)),s.classList.add("object-value-string"),UI.UIUtils.createTextChild(t,`${e.className} `),t.appendChild(s),t}_formatParameterAsObject(e,t){const s=document.createElement("span");if(s.classList.add("console-object"),t&&e.preview)s.classList.add("console-object-preview"),this._previewFormatter.appendObjectPreview(s,e.preview,!1);else if("function"===e.type){const t=s.createChild("span");ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.formatObjectAsFunction(e,t,!1),s.classList.add("object-value-function")}else"trustedtype"===e.subtype?s.appendChild(this._formatParameterAsTrustedType(e)):UI.UIUtils.createTextChild(s,e.description||"");if(!e.hasChildren||e.customPreview())return s;const n=s.createChild("span","object-state-note info-note");this._message.type===SDK.ConsoleModel.MessageType.QueryObjectResult?UI.Tooltip.Tooltip.install(n,i18nString(UIStrings.thisValueWillNotBeCollectedUntil)):UI.Tooltip.Tooltip.install(n,i18nString(UIStrings.thisValueWasEvaluatedUponFirst));const i=new ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection(e,s,this._linkifier);return i.element.classList.add("console-view-object-properties-section"),i.enableContextMenu(),i.setShowSelectionOnKeyboardFocus(!0,!0),this._selectableChildren.push(i),i.addEventListener(UI.TreeOutline.Events.ElementAttached,this._messageResized),i.addEventListener(UI.TreeOutline.Events.ElementExpanded,this._messageResized),i.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this._messageResized),i.element}_formatParameterAsFunction(e,t){const s=document.createElement("span");return SDK.RemoteObject.RemoteFunction.objectAsFunction(e).targetFunction().then(function(n){const i=document.createElement("span"),r=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.formatObjectAsFunction(n,i,!0,t);if(s.appendChild(i),n!==e){const e=s.createChild("span","object-info-state-note");UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.functionWasResolvedFromBound))}s.addEventListener("contextmenu",this._contextMenuEventFired.bind(this,n),!1),r.then((()=>this._formattedParameterAsFunctionForTest()))}.bind(this)),s}_formattedParameterAsFunctionForTest(){}_contextMenuEventFired(e,t){const s=new UI.ContextMenu.ContextMenu(t);s.appendApplicableItems(e),s.show()}_renderPropertyPreviewOrAccessor(e,t,s){return"accessor"===t.type?this._formatAsAccessorProperty(e,s.map((e=>e.name.toString())),!1):this._previewFormatter.renderPropertyPreview(t.type,"subtype"in t?t.subtype:void 0,null,t.value)}_formatParameterAsNode(e){const t=document.createElement("span"),s=e.runtimeModel().target().model(SDK.DOMModel.DOMModel);return s?(s.pushObjectAsNodeToFrontend(e).then((async s=>{if(!s)return void t.appendChild(this._formatParameterAsObject(e,!1));const n=await UI.UIUtils.Renderer.render(s);n?(n.tree&&(this._selectableChildren.push(n.tree),n.tree.addEventListener(UI.TreeOutline.Events.ElementAttached,this._messageResized),n.tree.addEventListener(UI.TreeOutline.Events.ElementExpanded,this._messageResized),n.tree.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this._messageResized)),t.appendChild(n.node)):t.appendChild(this._formatParameterAsObject(e,!1)),this._formattedParameterAsNodeForTest()})),t):t}_formattedParameterAsNodeForTest(){}_formatParameterAsString(e){const t=e.description??"",s=JSON.stringify(t),n=document.createElement("span");return n.appendChild(this._linkifyStringAsFragment(s)),n}_formatParameterAsError(e){const t=document.createElement("span"),s=this._tryFormatAsError(e.description||"");return t.appendChild(s||this._linkifyStringAsFragment(e.description||"")),t}_formatAsArrayEntry(e){return this._previewFormatter.renderPropertyPreview(e.type,e.subtype,e.className,e.description)}_formatAsAccessorProperty(e,t,s){const n=ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement.createRemoteObjectAccessorPropertySpan(e,t,function(e){const t=e.wasThrown,i=e.object;if(!i)return;if(n.removeChildren(),t){const e=n.createChild("span");e.textContent=i18nString(UIStrings.exception),UI.Tooltip.Tooltip.install(e,i.description)}else if(s)n.appendChild(this._formatAsArrayEntry(i));else{const e=100,t=i.type,s=i.subtype;let r="";"function"!==t&&i.description&&(r="string"===t||"regexp"===s||"trustedtype"===s?Platform.StringUtilities.trimMiddle(i.description,e):Platform.StringUtilities.trimEndWithMaxLength(i.description,e)),n.appendChild(this._previewFormatter.renderPropertyPreview(t,s,i.className,r))}}.bind(this));return n}_formatWithSubstitutionString(e,t,s){function n(e,t,s){return s instanceof SDK.RemoteObject.RemoteObject?this._formatParameter(s,e,t):i(s)}function i(e){if(void 0!==e)return"string"===typeof e?e:e.description}function r(e){if(e instanceof SDK.RemoteObject.RemoteObject)return"bigint"===e.type?e.description:"number"!==typeof e.value?"NaN":Math.floor(e.value)}let o=null;function a(e){const t=["background","border","color","font","line","margin","padding","text","-webkit-background","-webkit-border","-webkit-font","-webkit-margin","-webkit-padding","-webkit-text"];for(const s of t)if(e.startsWith(s))return!0;return!1}const l={};function c(e){if(o)for(const[t,{value:s,priority:n}]of o.entries())e.style.setProperty(t,s,n)}return l.o=n.bind(this,!1,!0),l.s=i,l.f=function(e){if(e instanceof SDK.RemoteObject.RemoteObject)return"number"!==typeof e.value?"NaN":e.value},l.i=r,l.d=r,l.c=function(e){o=new Map;const t=document.createElement("span");if(void 0!==e&&"string"!==typeof e&&e.description){t.setAttribute("style",e.description);for(const e of t.style)if(a(e)){const s={value:t.style.getPropertyValue(e),priority:t.style.getPropertyPriority(e)};o.set(e,s)}}},l.O=n.bind(this,!0,!1),l._=function(e){return e instanceof Node?e:""},Platform.StringUtilities.format(e,t,l,s,function(e,t){if(t instanceof Node)return e.appendChild(t),e;if("undefined"===typeof t)return e;if(!o)return e.appendChild(this._linkifyStringAsFragment(String(t))),e;const s=String(t).split("\n");for(let n=0;n<s.length;n++){const t=s[n],i=this._linkifyStringAsFragment(t),r=document.createElement("span");r.style.setProperty("contain","paint"),r.style.setProperty("display","inline-block"),r.style.setProperty("max-width","100%"),r.appendChild(i),c(r);for(const e of r.children)e.classList.contains("devtools-link")&&e instanceof HTMLElement&&this._applyForcedVisibleStyle(e);e.appendChild(r),n<s.length-1&&e.appendChild(document.createElement("br"))}return e}.bind(this))}_applyForcedVisibleStyle(e){e.style.setProperty("-webkit-text-stroke","0","important"),e.style.setProperty("text-decoration","underline","important");const t=ThemeSupport.ThemeSupport.instance().patchColorText("rgb(33%, 33%, 33%)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);e.style.setProperty("color",t,"important");let s="hsl(0, 0%, 100%)";this._message.level===SDK.ConsoleModel.MessageLevel.Error?s="hsl(0, 100%, 97%)":(this._message.level===SDK.ConsoleModel.MessageLevel.Warning||this._shouldRenderAsWarning())&&(s="hsl(50, 100%, 95%)");const n=ThemeSupport.ThemeSupport.instance().patchColorText(s,ThemeSupport.ThemeSupport.ColorUsage.Background);e.style.setProperty("background-color",n,"important")}matchesFilterRegex(e){e.lastIndex=0;const t=this.contentElement(),s=this._anchorElement?this._anchorElement.deepTextContent():"";return Boolean(s)&&e.test(s.trim())||e.test(t.deepTextContent().slice(s.length))}matchesFilterText(e){return this.contentElement().deepTextContent().toLowerCase().includes(e.toLowerCase())}updateTimestamp(){this._contentElement&&(Common.Settings.Settings.instance().moduleSetting("consoleTimestampsEnabled").get()?(this._timestampElement||(this._timestampElement=document.createElement("span"),this._timestampElement.classList.add("console-timestamp")),this._timestampElement.textContent=UI.UIUtils.formatTimestamp(this._message.timestamp,!1)+" ",UI.Tooltip.Tooltip.install(this._timestampElement,UI.UIUtils.formatTimestamp(this._message.timestamp,!0)),this._contentElement.insertBefore(this._timestampElement,this._contentElement.firstChild)):this._timestampElement&&(this._timestampElement.remove(),this._timestampElement=null))}nestingLevel(){return this._nestingLevel}setInSimilarGroup(e,t){this._inSimilarGroup=e,this._lastInSimilarGroup=e&&Boolean(t),this._similarGroupMarker&&!e?(this._similarGroupMarker.remove(),this._similarGroupMarker=null):this._element&&!this._similarGroupMarker&&e&&(this._similarGroupMarker=document.createElement("div"),this._similarGroupMarker.classList.add("nesting-level-marker"),this._element.insertBefore(this._similarGroupMarker,this._element.firstChild),this._similarGroupMarker.classList.toggle("group-closed",this._lastInSimilarGroup))}isLastInSimilarGroup(){return Boolean(this._inSimilarGroup)&&Boolean(this._lastInSimilarGroup)}resetCloseGroupDecorationCount(){this._closeGroupDecorationCount&&(this._closeGroupDecorationCount=0,this._updateCloseGroupDecorations())}incrementCloseGroupDecorationCount(){++this._closeGroupDecorationCount,this._updateCloseGroupDecorations()}_updateCloseGroupDecorations(){if(this._nestingLevelMarkers)for(let e=0,t=this._nestingLevelMarkers.length;e<t;++e){this._nestingLevelMarkers[e].classList.toggle("group-closed",t-e<=this._closeGroupDecorationCount)}}_focusedChildIndex(){return this._selectableChildren.length?this._selectableChildren.findIndex((e=>e.element.hasFocus())):-1}_onKeyDown(e){!UI.UIUtils.isEditing()&&this._element&&this._element.hasFocus()&&!this._element.hasSelection()&&this.maybeHandleOnKeyDown(e)&&e.consume(!0)}maybeHandleOnKeyDown(e){const t=this._focusedChildIndex(),s=-1===t;if(this._expandTrace&&s&&("ArrowLeft"===e.key&&this._traceExpanded||"ArrowRight"===e.key&&!this._traceExpanded))return this._expandTrace(!this._traceExpanded),!0;if(!this._selectableChildren.length)return!1;if("ArrowLeft"===e.key)return this._element&&this._element.focus(),!0;if("ArrowRight"===e.key&&s&&this._selectNearestVisibleChild(0))return!0;if("ArrowUp"===e.key){const e=this._nearestVisibleChild(0);if(this._selectableChildren[t]===e&&e)return this._element&&this._element.focus(),!0;if(this._selectNearestVisibleChild(t-1,!0))return!0}if("ArrowDown"===e.key){if(s&&this._selectNearestVisibleChild(0))return!0;if(!s&&this._selectNearestVisibleChild(t+1))return!0}return!1}_selectNearestVisibleChild(e,t){const s=this._nearestVisibleChild(e,t);return!!s&&(s.forceSelect(),!0)}_nearestVisibleChild(e,t){const s=this._selectableChildren.length;if(e<0||e>=s)return null;const n=t?-1:1;let i=e;for(;!this._selectableChildren[i].element.offsetParent;)if(i+=n,i<0||i>=s)return null;return this._selectableChildren[i]}focusLastChildOrSelf(){this._element&&!this._selectNearestVisibleChild(this._selectableChildren.length-1,!0)&&this._element.focus()}setContentElement(e){console.assert(!this._contentElement,"Cannot set content element twice"),this._contentElement=e}getContentElement(){return this._contentElement}contentElement(){if(this._contentElement)return this._contentElement;const e=document.createElement("div");e.classList.add("console-message"),this._messageLevelIcon&&e.appendChild(this._messageLevelIcon),this._contentElement=e;const t=this._message.runtimeModel();let s;const n=Boolean(this._message.stackTrace)&&(this._message.source===SDK.ConsoleModel.MessageSource.Network||this._message.source===SDK.ConsoleModel.MessageSource.Violation||this._message.level===SDK.ConsoleModel.MessageLevel.Error||this._message.level===SDK.ConsoleModel.MessageLevel.Warning||this._message.type===SDK.ConsoleModel.MessageType.Trace);return s=t&&n?this._buildMessageWithStackTrace(t):this._buildMessage(),e.appendChild(s),this.updateTimestamp(),this._contentElement}toMessageElement(){return this._element||(this._element=document.createElement("div"),this._element.tabIndex=-1,this._element.addEventListener("keydown",this._onKeyDown.bind(this)),this.updateMessageElement()),this._element}updateMessageElement(){if(this._element){this._element.className="console-message-wrapper",this._element.removeChildren(),this._message.isGroupStartMessage()&&this._element.classList.add("console-group-title"),this._message.source===SDK.ConsoleModel.MessageSource.ConsoleAPI&&this._element.classList.add("console-from-api"),this._inSimilarGroup&&(this._similarGroupMarker=this._element.createChild("div","nesting-level-marker"),this._similarGroupMarker.classList.toggle("group-closed",this._lastInSimilarGroup)),this._nestingLevelMarkers=[];for(let e=0;e<this._nestingLevel;++e)this._nestingLevelMarkers.push(this._element.createChild("div","nesting-level-marker"));switch(this._updateCloseGroupDecorations(),elementToMessage.set(this._element,this),this._message.level){case SDK.ConsoleModel.MessageLevel.Verbose:this._element.classList.add("console-verbose-level");break;case SDK.ConsoleModel.MessageLevel.Info:this._element.classList.add("console-info-level"),this._message.type===SDK.ConsoleModel.MessageType.System&&this._element.classList.add("console-system-type");break;case SDK.ConsoleModel.MessageLevel.Warning:this._element.classList.add("console-warning-level");break;case SDK.ConsoleModel.MessageLevel.Error:this._element.classList.add("console-error-level")}this._updateMessageLevelIcon(),this._shouldRenderAsWarning()&&this._element.classList.add("console-warning-level"),this._element.appendChild(this.contentElement()),this._repeatCount>1&&this._showRepeatCountElement()}}_shouldRenderAsWarning(){return(this._message.level===SDK.ConsoleModel.MessageLevel.Verbose||this._message.level===SDK.ConsoleModel.MessageLevel.Info)&&(this._message.source===SDK.ConsoleModel.MessageSource.Violation||this._message.source===SDK.ConsoleModel.MessageSource.Deprecation||this._message.source===SDK.ConsoleModel.MessageSource.Intervention||this._message.source===SDK.ConsoleModel.MessageSource.Recommendation)}_updateMessageLevelIcon(){let e="",t="";if(this._message.level===SDK.ConsoleModel.MessageLevel.Warning?(e="smallicon-warning",t=i18nString(UIStrings.warning)):this._message.level===SDK.ConsoleModel.MessageLevel.Error&&(e="smallicon-error",t=i18nString(UIStrings.error)),!this._messageLevelIcon){if(!e)return;this._messageLevelIcon=UI.Icon.Icon.create("","message-level-icon"),this._contentElement&&this._contentElement.insertBefore(this._messageLevelIcon,this._contentElement.firstChild)}this._messageLevelIcon.setIconType(e),UI.ARIAUtils.setAccessibleName(this._messageLevelIcon,t)}repeatCount(){return this._repeatCount||1}resetIncrementRepeatCount(){this._repeatCount=1,this._repeatCountElement&&(this._repeatCountElement.remove(),this._contentElement&&this._contentElement.classList.remove("repeated-message"),this._repeatCountElement=null)}incrementRepeatCount(){this._repeatCount++,this._showRepeatCountElement()}setRepeatCount(e){this._repeatCount=e,this._showRepeatCountElement()}_showRepeatCountElement(){if(!this._element)return;if(!this._repeatCountElement){switch(this._repeatCountElement=document.createElement("span",{is:"dt-small-bubble"}),this._repeatCountElement.classList.add("console-message-repeat-count"),this._message.level){case SDK.ConsoleModel.MessageLevel.Warning:this._repeatCountElement.type="warning";break;case SDK.ConsoleModel.MessageLevel.Error:this._repeatCountElement.type="error";break;case SDK.ConsoleModel.MessageLevel.Verbose:this._repeatCountElement.type="verbose";break;default:this._repeatCountElement.type="info"}this._shouldRenderAsWarning()&&(this._repeatCountElement.type="warning"),this._element.insertBefore(this._repeatCountElement,this._contentElement),this.contentElement().classList.add("repeated-message")}this._repeatCountElement.textContent=`${this._repeatCount}`;let e=i18nString(UIStrings.repeatS,{PH1:this._repeatCount});this._message.level===SDK.ConsoleModel.MessageLevel.Warning?e=i18nString(UIStrings.warningS,{PH1:e}):this._message.level===SDK.ConsoleModel.MessageLevel.Error&&(e=i18nString(UIStrings.errorS,{PH1:e})),UI.ARIAUtils.setAccessibleName(this._repeatCountElement,e)}get text(){return this._message.messageText}toExportString(){const e=[],t=this.contentElement().childTextNodes().map(Components.Linkifier.Linkifier.untruncatedNodeText).join("");for(let s=0;s<this.repeatCount();++s)e.push(t);return e.join("\n")}setSearchRegex(e){if(this._searchHighlightNodeChanges&&this._searchHighlightNodeChanges.length&&UI.UIUtils.revertDomChanges(this._searchHighlightNodeChanges),this._searchRegex=e,this._searchHighlightNodes=[],this._searchHighlightNodeChanges=[],!this._searchRegex)return;const t=this.contentElement().deepTextContent();let s;this._searchRegex.lastIndex=0;const n=[];for(;(s=this._searchRegex.exec(t))&&s[0];)n.push(new TextUtils.TextRange.SourceRange(s.index,s[0].length));n.length&&(this._searchHighlightNodes=UI.UIUtils.highlightSearchResults(this.contentElement(),n,this._searchHighlightNodeChanges))}searchRegex(){return this._searchRegex}searchCount(){return this._searchHighlightNodes.length}searchHighlightNode(e){return this._searchHighlightNodes[e]}_tryFormatAsError(e){const t=this._message.runtimeModel();if(!t||!["EvalError","ReferenceError","SyntaxError","TypeError","RangeError","Error","URIError"].some((function(t){return e.startsWith(t)})))return null;const s=t.debuggerModel(),n=t.target().inspectedURL(),i=e.split("\n"),r=[];let o=0;for(let h=0;h<i.length;++h){o+=h>0?i[h-1].length+1:0;const e=/^\s*at\s/.test(i[h]);if(!e&&r.length)return null;if(!e)continue;let t=-1,s=-1;const a=/\([^\)\(]+:\d+:\d+\)/g,l=/\([^\)\(]+\)/g;let m,d=null;for(;m=a.exec(i[h]);)d=m;if(!d)for(;m=l.exec(i[h]);)d=m;d&&(t=d.index,s=d.index+d[0].length-1);const u=-1!==t,p=u?t+1:i[h].indexOf("at")+3,g=u?s:i[h].length,_=i[h].substring(p,g),f=Common.ParsedURL.ParsedURL.splitLineAndColumn(_);if(!f)return null;if("<anonymous>"===f.url)continue;let C=c(f.url);if(!C&&Common.ParsedURL.ParsedURL.isRelativeURL(f.url)&&(C=c(Common.ParsedURL.ParsedURL.completeURL(n,f.url))),!C)return null;r.push({url:C,positionLeft:o+p,positionRight:o+g,lineNumber:f.lineNumber,columnNumber:f.columnNumber})}if(!r.length)return null;const a=document.createElement("span");let l=0;for(let h=0;h<r.length;++h){a.appendChild(this._linkifyStringAsFragment(e.substring(l,r[h].positionLeft)));const t=this._linkifier.linkifyScriptLocation(s.target(),null,r[h].url,r[h].lineNumber,{columnNumber:r[h].columnNumber,className:void 0,tabStop:void 0});t.tabIndex=-1,this._selectableChildren.push({element:t,forceSelect:()=>t.focus()}),a.appendChild(t),l=r[h].positionRight}return l!==e.length&&a.appendChild(this._linkifyStringAsFragment(e.substring(l))),a;function c(e){if(!e)return null;const t=Common.ParsedURL.ParsedURL.fromString(e);return t?t.url:s.scriptsForSourceURL(e).length?e:null}}_linkifyWithCustomLinkifier(e,t){if(e.length>getMaxTokenizableStringLength()){const t=new ObjectUI.ObjectPropertiesSection.ExpandableTextPropertyValue(document.createElement("span"),e,getLongStringVisibleLength()),s=document.createDocumentFragment();return s.appendChild(t.element),s}const s=document.createDocumentFragment(),n=ConsoleViewMessage._tokenizeMessageText(e);for(const i of n)if(i.text)switch(i.type){case"url":{const e=i.text.startsWith("www.")?"http://"+i.text:i.text,n=Common.ParsedURL.ParsedURL.splitLineAndColumn(e),r=Common.ParsedURL.ParsedURL.removeWasmFunctionInfoFromURL(n.url);let o;o=n?t(i.text,r,n.lineNumber,n.columnNumber):t(i.text,""),s.appendChild(o);break}default:s.appendChild(document.createTextNode(i.text))}return s}_linkifyStringAsFragment(e){return this._linkifyWithCustomLinkifier(e,((e,t,s,n)=>{const i={text:e,lineNumber:s,columnNumber:n},r=Components.Linkifier.Linkifier.linkifyURL(t,i);return r.tabIndex=-1,this._selectableChildren.push({element:r,forceSelect:()=>r.focus()}),r}))}static _tokenizeMessageText(e){const{tokenizerRegexes:t,tokenizerTypes:s}=getOrCreateTokenizers();if(e.length>getMaxTokenizableStringLength())return[{text:e,type:void 0}];return TextUtils.TextUtils.Utils.splitStringByRegexes(e,t).map((e=>({text:e.value,type:s[e.regexIndex]})))}groupKey(){return this._groupKey||(this._groupKey=this._message.groupCategoryKey()+":"+this.groupTitle()),this._groupKey}groupTitle(){return ConsoleViewMessage._tokenizeMessageText(this._message.messageText).reduce(((e,t)=>{let s=t.text;return"url"===t.type?s=i18nString(UIStrings.url):"time"===t.type?s=i18nString(UIStrings.tookNms):"event"===t.type?s=i18nString(UIStrings.someEvent):"milestone"===t.type?s=i18nString(UIStrings.Mxx):"autofill"===t.type&&(s=i18nString(UIStrings.attribute)),e+s}),"").replace(/[%]o/g,"")}}let tokenizerRegexes=null,tokenizerTypes=null;function getOrCreateTokenizers(){if(!tokenizerRegexes||!tokenizerTypes){const e="\\u0000-\\u0020\\u007f-\\u009f",t=new RegExp("(?:[a-zA-Z][a-zA-Z0-9+.-]{2,}:\\/\\/|data:|www\\.)[^\\s"+e+'"]{2,}[^\\s'+e+"\"')}\\],:;.!?]","u"),s=/(?:\/[\w\.-]*)+\:[\d]+/,n=/took [\d]+ms/,i=/'\w+' event/,r=/\sM[6-7]\d/,o=/\(suggested: \"[\w-]+\"\)/,a=new Map;return a.set(t,"url"),a.set(s,"url"),a.set(n,"time"),a.set(i,"event"),a.set(r,"milestone"),a.set(o,"autofill"),tokenizerRegexes=Array.from(a.keys()),tokenizerTypes=Array.from(a.values()),{tokenizerRegexes:tokenizerRegexes,tokenizerTypes:tokenizerTypes}}return{tokenizerRegexes:tokenizerRegexes,tokenizerTypes:tokenizerTypes}}export class ConsoleGroupViewMessage extends ConsoleViewMessage{constructor(e,t,s,n,i){console.assert(e.isGroupStartMessage()),super(e,t,s,i),this._collapsed=e.type===SDK.ConsoleModel.MessageType.StartGroupCollapsed,this._expandGroupIcon=null,this._onToggle=n}_setCollapsed(e){this._collapsed=e,this._expandGroupIcon&&this._expandGroupIcon.setIconType(this._collapsed?"smallicon-triangle-right":"smallicon-triangle-down"),this._onToggle.call(null)}collapsed(){return this._collapsed}maybeHandleOnKeyDown(e){return-1===this._focusedChildIndex()&&("ArrowLeft"===e.key&&!this._collapsed||"ArrowRight"===e.key&&this._collapsed)?(this._setCollapsed(!this._collapsed),!0):super.maybeHandleOnKeyDown(e)}toMessageElement(){let e=this._element||null;if(!e){e=super.toMessageElement();const t=this._collapsed?"smallicon-triangle-right":"smallicon-triangle-down";this._expandGroupIcon=UI.Icon.Icon.create(t,"expand-group-icon"),this.contentElement().tabIndex=-1,this._repeatCountElement?this._repeatCountElement.insertBefore(this._expandGroupIcon,this._repeatCountElement.firstChild):e.insertBefore(this._expandGroupIcon,this._contentElement),e.addEventListener("click",(()=>this._setCollapsed(!this._collapsed)))}return e}_showRepeatCountElement(){super._showRepeatCountElement(),this._repeatCountElement&&this._expandGroupIcon&&this._repeatCountElement.insertBefore(this._expandGroupIcon,this._repeatCountElement.firstChild)}}export class ConsoleCommand extends ConsoleViewMessage{constructor(e,t,s,n){super(e,t,s,n),this._formattedCommand=null}contentElement(){const e=this.getContentElement();if(e)return e;const t=document.createElement("div");this.setContentElement(t),t.classList.add("console-user-command");const s=UI.Icon.Icon.create("smallicon-user-command","command-result-icon");if(t.appendChild(s),elementToMessage.set(t,this),this._formattedCommand=document.createElement("span"),this._formattedCommand.classList.add("source-code"),this._formattedCommand.textContent=Platform.StringUtilities.replaceControlCharacters(this.text),t.appendChild(this._formattedCommand),this._formattedCommand.textContent.length<MaxLengthToIgnoreHighlighter){new TextEditor.SyntaxHighlighter.SyntaxHighlighter("text/javascript",!0).syntaxHighlightNode(this._formattedCommand).then(this._updateSearch.bind(this))}else this._updateSearch();return this.updateTimestamp(),t}_updateSearch(){this.setSearchRegex(this.searchRegex())}}export class ConsoleCommandResult extends ConsoleViewMessage{contentElement(){const e=super.contentElement();if(!e.classList.contains("console-user-command-result")&&(e.classList.add("console-user-command-result"),this.consoleMessage().level===SDK.ConsoleModel.MessageLevel.Info)){const t=UI.Icon.Icon.create("smallicon-command-result","command-result-icon");e.insertBefore(t,e.firstChild)}return e}}export class ConsoleTableMessageView extends ConsoleViewMessage{constructor(e,t,s,n){super(e,t,s,n),console.assert(e.type===SDK.ConsoleModel.MessageType.Table),this._dataGrid=null}wasShown(){this._dataGrid&&this._dataGrid.updateWidths(),super.wasShown()}onResize(){this.isVisible()&&this._dataGrid&&this._dataGrid.onResize()}contentElement(){const e=this.getContentElement();if(e)return e;const t=document.createElement("div");return t.classList.add("console-message"),this._messageLevelIcon&&t.appendChild(this._messageLevelIcon),this.setContentElement(t),t.appendChild(this._buildTableMessage()),this.updateTimestamp(),t}_buildTableMessage(){const e=document.createElement("span");e.classList.add("source-code"),this._anchorElement=this._buildMessageAnchor(),this._anchorElement&&e.appendChild(this._anchorElement);const t=this._message.parameters&&this._message.parameters.length?this._message.parameters[0]:null;if(!t)return this._buildMessage();const s=parameterToRemoteObject(this._message.runtimeModel())(t);if(!s||!s.preview)return this._buildMessage();const n=Symbol("rawValueColumn"),i=[],r=s.preview,o=[];for(let c=0;c<r.properties.length;++c){const e=r.properties[c];let t;if(e.valuePreview&&e.valuePreview.properties.length)t=e.valuePreview.properties;else{if(!e.value)continue;t=[{name:n,type:e.type,value:e.value}]}const a=new Map,l=20;for(let n=0;n<t.length;++n){const r=t[n];let o=-1!==i.indexOf(r.name);if(!o){if(i.length===l)continue;o=!0,i.push(r.name)}if(o){const t=this._renderPropertyPreviewOrAccessor(s,r,[e,r]);t.classList.add("console-message-nowrap-below"),a.set(r.name,t)}}o.push({rowName:e.name,rowValue:a})}const a=[];for(const{rowName:c,rowValue:h}of o){a.push(c);for(let e=0;e<i.length;++e)a.push(h.get(i[e]))}i.unshift(i18nString(UIStrings.index));const l=i.map((e=>e===n?i18nString(UIStrings.value):e.toString()));if(a.length&&(this._dataGrid=DataGrid.SortableDataGrid.SortableDataGrid.create(l,a,i18nString(UIStrings.console)),this._dataGrid)){this._dataGrid.setStriped(!0),this._dataGrid.setFocusable(!1);const t=document.createElement("span");t.classList.add("console-message-text");const n=t.createChild("div","console-message-formatted-table"),i=n.createChild("span");n.appendChild(this._formatParameter(s,!0,!1)),i.appendChild(this._dataGrid.element),e.appendChild(t),this._dataGrid.renderInline()}return e}approximateFastHeight(){const e=this._message.parameters&&this._message.parameters[0];return e&&"string"!==typeof e&&e.preview?19*e.preview.properties.length:19}}const MaxLengthToIgnoreHighlighter=1e4;export const MaxLengthForLinks=40;let maxTokenizableStringLength=1e4,longStringVisibleLength=5e3;export const getMaxTokenizableStringLength=()=>maxTokenizableStringLength;export const setMaxTokenizableStringLength=e=>{maxTokenizableStringLength=e};export const getLongStringVisibleLength=()=>longStringVisibleLength;export const setLongStringVisibleLength=e=>{longStringVisibleLength=e};