import*as BrowserSDK from"../browser_sdk/browser_sdk.js";import*as Common from"../common/common.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={session:"Session",name:"Name",value:"Value",size:"Size",editableCookies:"Editable Cookies",cookies:"Cookies",na:"N/A",showRequestsWithThisCookie:"Show Requests With This Cookie",showIssueAssociatedWithThis:"Show issue associated with this cookie",sourcePortTooltip:"Shows the source port (range 1-65535) the cookie was set on. If the port is unknown, this shows -1.",sourceSchemeTooltip:"Shows the source scheme (`Secure`, `NonSecure`) the cookie was set on. If the scheme is unknown, this shows `Unset`."},str_=i18n.i18n.registerUIStrings("cookie_table/CookiesTable.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_),expiresSessionValue=i18nLazyString(UIStrings.session);export class CookiesTable extends UI.Widget.VBox{constructor(e,t,i,o,r){super(),this.registerRequiredCSS("cookie_table/cookiesTable.css",{enableLegacyPatching:!0}),this.element.classList.add("cookies-table"),this._saveCallback=t,this._refreshCallback=i,this._deleteCallback=r;const s=Boolean(t),a=[{id:SDK.Cookie.Attributes.Name,title:i18nString(UIStrings.name),sortable:!0,disclosure:s,sort:DataGrid.DataGrid.Order.Ascending,longText:!0,weight:24,editable:s},{id:SDK.Cookie.Attributes.Value,title:i18nString(UIStrings.value),sortable:!0,longText:!0,weight:34,editable:s},{id:SDK.Cookie.Attributes.Domain,title:"Domain",sortable:!0,weight:7,editable:s},{id:SDK.Cookie.Attributes.Path,title:"Path",sortable:!0,weight:7,editable:s},{id:SDK.Cookie.Attributes.Expires,title:"Expires / Max-Age",sortable:!0,weight:7,editable:s},{id:SDK.Cookie.Attributes.Size,title:i18nString(UIStrings.size),sortable:!0,align:DataGrid.DataGrid.Align.Right,weight:7},{id:SDK.Cookie.Attributes.HttpOnly,title:"HttpOnly",sortable:!0,align:DataGrid.DataGrid.Align.Center,weight:7,dataType:DataGrid.DataGrid.DataType.Boolean,editable:s},{id:SDK.Cookie.Attributes.Secure,title:"Secure",sortable:!0,align:DataGrid.DataGrid.Align.Center,weight:7,dataType:DataGrid.DataGrid.DataType.Boolean,editable:s},{id:SDK.Cookie.Attributes.SameSite,title:"SameSite",sortable:!0,weight:7,editable:s},{id:SDK.Cookie.Attributes.SameParty,title:"SameParty",sortable:!0,align:DataGrid.DataGrid.Align.Center,weight:7,dataType:DataGrid.DataGrid.DataType.Boolean,editable:s},{id:SDK.Cookie.Attributes.Priority,title:"Priority",sortable:!0,sort:DataGrid.DataGrid.Order.Descending,weight:7,editable:s}];if(Root.Runtime.experiments.isEnabled("experimentalCookieFeatures")){const e=[{id:SDK.Cookie.Attributes.SourceScheme,title:"SourceScheme",sortable:!0,align:DataGrid.DataGrid.Align.Center,weight:7,editable:s},{id:SDK.Cookie.Attributes.SourcePort,title:"SourcePort",sortable:!0,align:DataGrid.DataGrid.Align.Center,weight:7,editable:s}];a.push(...e)}this._dataGrid=s?new DataGrid.DataGrid.DataGridImpl({displayName:i18nString(UIStrings.editableCookies),columns:a,editCallback:this._onUpdateCookie.bind(this),deleteCallback:this._onDeleteCookie.bind(this),refreshCallback:i}):new DataGrid.DataGrid.DataGridImpl({displayName:i18nString(UIStrings.cookies),columns:a,editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this._dataGrid.setStriped(!0),this._dataGrid.setName("cookiesTable"),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._rebuildTable,this),this._dataGrid.setRowContextMenuCallback(this._populateContextMenu.bind(this)),e&&this._dataGrid.renderInline(),o&&this._dataGrid.addEventListener(DataGrid.DataGrid.Events.SelectedNode,o,this),this._lastEditedColumnId=null,this._dataGrid.asWidget().show(this.element),this._data=[],this._cookieDomain="",this._cookieToBlockedReasons=null}setCookies(e,t){this.setCookieFolders([{cookies:e,folderName:null}],t)}setCookieFolders(e,t){this._data=e,this._cookieToBlockedReasons=t||null,this._rebuildTable()}setCookieDomain(e){this._cookieDomain=e}selectedCookie(){const e=this._dataGrid.selectedNode;return e?e.cookie:null}_getSelectionCookies(){const e=this._dataGrid.selectedNode,t=e&&e.traverseNextNode(!0),i=e&&e.traversePreviousNode(!0);return{current:e&&e.cookie,neighbor:t&&t.cookie||i&&i.cookie}}willHide(){this._lastEditedColumnId=null}_findSelectedCookie(e,t){if(!t)return null;const i=e.current,o=t.find((e=>this._isSameCookie(e,i)));if(o)return o;const r=e.neighbor,s=t.find((e=>this._isSameCookie(e,r)));return s||null}_isSameCookie(e,t){return null!==t&&void 0!==t&&t.name()===e.name()&&t.domain()===e.domain()&&t.path()===e.path()}_rebuildTable(){const e=this._getSelectionCookies(),t=this._lastEditedColumnId;this._lastEditedColumnId=null,this._dataGrid.rootNode().removeChildren();for(let i=0;i<this._data.length;++i){const o=this._data[i],r=this._findSelectedCookie(e,o.cookies);if(o.folderName){const e={};e[SDK.Cookie.Attributes.Name]=o.folderName,e[SDK.Cookie.Attributes.Value]="",e[SDK.Cookie.Attributes.Size]=this._totalSize(o.cookies),e[SDK.Cookie.Attributes.Domain]="",e[SDK.Cookie.Attributes.Path]="",e[SDK.Cookie.Attributes.Expires]="",e[SDK.Cookie.Attributes.HttpOnly]="",e[SDK.Cookie.Attributes.Secure]="",e[SDK.Cookie.Attributes.SameSite]="",e[SDK.Cookie.Attributes.SameParty]="",e[SDK.Cookie.Attributes.SourcePort]="",e[SDK.Cookie.Attributes.SourceScheme]="",e[SDK.Cookie.Attributes.Priority]="";const i=new DataGrid.DataGrid.DataGridNode(e);i.selectable=!0,this._dataGrid.rootNode().appendChild(i),i.element().classList.add("row-group"),this._populateNode(i,o.cookies,r,t),i.expand()}else this._populateNode(this._dataGrid.rootNode(),o.cookies,r,t)}e.current&&t&&!this._dataGrid.selectedNode&&this._addInactiveNode(this._dataGrid.rootNode(),e.current,t),this._saveCallback&&this._dataGrid.addCreationNode(!1)}_populateNode(e,t,i,o){if(e.removeChildren(),t){this._sortCookies(t);for(let r=0;r<t.length;++r){const s=t[r],a=this._createGridNode(s);e.appendChild(a),this._isSameCookie(s,i)&&(a.select(),null!==o&&this._dataGrid.startEditingNextEditableColumnOfDataGridNode(a,o))}}}_addInactiveNode(e,t,i){const o=this._createGridNode(t);e.appendChild(o),o.select(),o.setInactive(!0),null!==i&&this._dataGrid.startEditingNextEditableColumnOfDataGridNode(o,i)}_totalSize(e){let t=0;for(let i=0;e&&i<e.length;++i)t+=e[i].size();return t}_sortCookies(e){const t=this._dataGrid.isSortOrderAscending()?1:-1;function i(e,t){switch(t){case SDK.Cookie.Attributes.Name:return String(e.name());case SDK.Cookie.Attributes.Value:return String(e.value());case SDK.Cookie.Attributes.Domain:return String(e.domain());case SDK.Cookie.Attributes.Path:return String(e.path());case SDK.Cookie.Attributes.HttpOnly:return String(e.httpOnly());case SDK.Cookie.Attributes.Secure:return String(e.secure());case SDK.Cookie.Attributes.SameSite:return String(e.sameSite());case SDK.Cookie.Attributes.SameParty:return String(e.sameParty());case SDK.Cookie.Attributes.SourceScheme:return String(e.sourceScheme());default:return String(e.name())}}function o(e,i,o){return t*(e(i)-e(o))}let r;const s=this._dataGrid.sortColumnId()||SDK.Cookie.Attributes.Name;r=s===SDK.Cookie.Attributes.Expires?function(e,i){return e.session()!==i.session()?t*(e.session()?1:-1):e.session()?0:e.maxAge()&&i.maxAge()?t*(e.maxAge()-i.maxAge()):e.expires()&&i.expires()?t*(e.expires()-i.expires()):t*(e.expires()?1:-1)}:s===SDK.Cookie.Attributes.Size?o.bind(null,(e=>e.size())):s===SDK.Cookie.Attributes.SourcePort?o.bind(null,(e=>e.sourcePort())):s===SDK.Cookie.Attributes.Priority?function(e,i){const o=[Protocol.Network.CookiePriority.Low,Protocol.Network.CookiePriority.Medium,Protocol.Network.CookiePriority.High],r=o.indexOf(e.priority()),s=o.indexOf(i.priority());return t*(r-s)}:function(e,o,r){return t*Platform.StringUtilities.compare(i(o,e),i(r,e))}.bind(null,s),e.sort(r)}_createGridNode(e){const t={};t[SDK.Cookie.Attributes.Name]=e.name(),t[SDK.Cookie.Attributes.Value]=e.value(),e.type()===SDK.Cookie.Type.Request?(t[SDK.Cookie.Attributes.Domain]=e.domain()?e.domain():i18nString(UIStrings.na),t[SDK.Cookie.Attributes.Path]=e.path()?e.path():i18nString(UIStrings.na)):(t[SDK.Cookie.Attributes.Domain]=e.domain()||"",t[SDK.Cookie.Attributes.Path]=e.path()||""),e.maxAge()?t[SDK.Cookie.Attributes.Expires]=Number.secondsToString(Math.floor(e.maxAge())):e.expires()?e.expires()<0?t[SDK.Cookie.Attributes.Expires]=expiresSessionValue():t[SDK.Cookie.Attributes.Expires]=new Date(e.expires()).toISOString():t[SDK.Cookie.Attributes.Expires]=e.type()===SDK.Cookie.Type.Request?i18nString(UIStrings.na):expiresSessionValue(),t[SDK.Cookie.Attributes.Size]=e.size(),t[SDK.Cookie.Attributes.HttpOnly]=e.httpOnly(),t[SDK.Cookie.Attributes.Secure]=e.secure(),t[SDK.Cookie.Attributes.SameSite]=e.sameSite()||"",t[SDK.Cookie.Attributes.SameParty]=e.sameParty(),t[SDK.Cookie.Attributes.SourcePort]=e.sourcePort(),t[SDK.Cookie.Attributes.SourceScheme]=e.sourceScheme(),t[SDK.Cookie.Attributes.Priority]=e.priority()||"";const i=this._cookieToBlockedReasons?this._cookieToBlockedReasons.get(e):null,o=new DataGridNode(t,e,i||null);return o.selectable=!0,o}_onDeleteCookie(e){e.cookie&&this._deleteCallback&&this._deleteCallback(e.cookie,(()=>this._refresh()))}_onUpdateCookie(e,t,i,o){this._lastEditedColumnId=t,this._setDefaults(e),this._isValidCookieData(e.data)?this._saveNode(e):e.setDirty(!0)}_setDefaults(e){null===e.data[SDK.Cookie.Attributes.Name]&&(e.data[SDK.Cookie.Attributes.Name]=""),null===e.data[SDK.Cookie.Attributes.Value]&&(e.data[SDK.Cookie.Attributes.Value]=""),null===e.data[SDK.Cookie.Attributes.Domain]&&(e.data[SDK.Cookie.Attributes.Domain]=this._cookieDomain),null===e.data[SDK.Cookie.Attributes.Path]&&(e.data[SDK.Cookie.Attributes.Path]="/"),null===e.data[SDK.Cookie.Attributes.Expires]&&(e.data[SDK.Cookie.Attributes.Expires]=expiresSessionValue())}_saveNode(e){const t=e.cookie,i=this._createCookieFromData(e.data);e.cookie=i,this._saveCallback&&this._saveCallback(i,t).then((t=>{t?this._refresh():e.setDirty(!0)}))}_createCookieFromData(e){const t=new SDK.Cookie.Cookie(e[SDK.Cookie.Attributes.Name],e[SDK.Cookie.Attributes.Value],null,e[SDK.Cookie.Attributes.Priority]);return t.addAttribute(SDK.Cookie.Attributes.Domain,e[SDK.Cookie.Attributes.Domain]),t.addAttribute(SDK.Cookie.Attributes.Path,e[SDK.Cookie.Attributes.Path]),e.expires&&e.expires!==expiresSessionValue()&&t.addAttribute(SDK.Cookie.Attributes.Expires,new Date(e[SDK.Cookie.Attributes.Expires]).toUTCString()),e[SDK.Cookie.Attributes.HttpOnly]&&t.addAttribute(SDK.Cookie.Attributes.HttpOnly),e[SDK.Cookie.Attributes.Secure]&&t.addAttribute(SDK.Cookie.Attributes.Secure),e[SDK.Cookie.Attributes.SameSite]&&t.addAttribute(SDK.Cookie.Attributes.SameSite,e[SDK.Cookie.Attributes.SameSite]),e[SDK.Cookie.Attributes.SameParty]&&t.addAttribute(SDK.Cookie.Attributes.SameParty),SDK.Cookie.Attributes.SourceScheme in e&&t.addAttribute(SDK.Cookie.Attributes.SourceScheme,e[SDK.Cookie.Attributes.SourceScheme]),SDK.Cookie.Attributes.SourcePort in e&&t.addAttribute(SDK.Cookie.Attributes.SourcePort,Number.parseInt(e[SDK.Cookie.Attributes.SourcePort],10)||void 0),t.setSize(e[SDK.Cookie.Attributes.Name].length+e[SDK.Cookie.Attributes.Value].length),t}_isValidCookieData(e){return(Boolean(e.name)||Boolean(e.value))&&this._isValidDomain(e.domain)&&this._isValidPath(e.path)&&this._isValidDate(e.expires)}_isValidDomain(e){if(!e)return!0;const t=Common.ParsedURL.ParsedURL.fromString("http://"+e);return null!==t&&t.domain()===e}_isValidPath(e){const t=Common.ParsedURL.ParsedURL.fromString("http://example.com"+e);return null!==t&&t.path===e}_isValidDate(e){return""===e||e===expiresSessionValue()||!isNaN(Date.parse(e))}_refresh(){this._refreshCallback&&this._refreshCallback()}_populateContextMenu(e,t){const i=t.cookie;if(!i)return;const o=i;e.revealSection().appendItem(i18nString(UIStrings.showRequestsWithThisCookie),(()=>{const e=new CustomEvent("networkrevealandfilter",{bubbles:!0,composed:!0,detail:[{filterType:"cookie-domain",filterValue:o.domain()},{filterType:"cookie-name",filterValue:o.name()}]});this.element.dispatchEvent(e)})),BrowserSDK.RelatedIssue.hasIssues(o)&&e.revealSection().appendItem(i18nString(UIStrings.showIssueAssociatedWithThis),(()=>{BrowserSDK.RelatedIssue.reveal(o)}))}}export class DataGridNode extends DataGrid.DataGrid.DataGridNode{constructor(e,t,i){super(e),this.cookie=t,this._blockedReasons=i}createCells(e){super.createCells(e),this._blockedReasons&&this._blockedReasons.length&&e.classList.add("flagged-cookie-attribute-row")}createCell(e){const t=super.createCell(e);e===SDK.Cookie.Attributes.SourcePort?UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.sourcePortTooltip)):e===SDK.Cookie.Attributes.SourceScheme?UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.sourceSchemeTooltip)):UI.Tooltip.Tooltip.install(t,t.textContent||"");let i="";if(this._blockedReasons)for(const o of this._blockedReasons){const t=o.attribute===e,r=!o.attribute&&e===SDK.Cookie.Attributes.Name;(t||r)&&(i&&(i+="\n"),i+=o.uiString)}if(i){const e=UI.Icon.Icon.create("smallicon-info","cookie-warning-icon");UI.Tooltip.Tooltip.install(e,i),t.insertBefore(e,t.firstChild),t.classList.add("flagged-cookie-attribute-cell")}return t}}