import*as Common from"../common/common.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";export var Events;!function(e){e.CoverageUpdated="CoverageUpdated",e.CoverageReset="CoverageReset"}(Events||(Events={}));const COVERAGE_POLLING_PERIOD_MS=200;export class CoverageModel extends SDK.SDKModel.SDKModel{constructor(e){super(e),this._cpuProfilerModel=e.model(SDK.CPUProfilerModel.CPUProfilerModel),this._cssModel=e.model(SDK.CSSModel.CSSModel),this._debuggerModel=e.model(SDK.DebuggerModel.DebuggerModel),this._coverageByURL=new Map,this._coverageByContentProvider=new Map,this._coverageUpdateTimes=new Set,this._suspensionState="Active",this._pollTimer=null,this._currentPollPromise=null,this._shouldResumePollingOnResume=!1,this._jsBacklog=[],this._cssBacklog=[],this._performanceTraceRecording=!1}async start(e){if("Active"!==this._suspensionState)throw Error("Cannot start CoverageModel while it is not active.");const t=[];return this._cssModel&&(this._clearCSS(),this._cssModel.addEventListener(SDK.CSSModel.Events.StyleSheetAdded,this._handleStyleSheetAdded,this),t.push(this._cssModel.startCoverage())),this._cpuProfilerModel&&t.push(this._cpuProfilerModel.startPreciseCoverage(e,this.preciseCoverageDeltaUpdate.bind(this))),await Promise.all(t),Boolean(this._cssModel||this._cpuProfilerModel)}preciseCoverageDeltaUpdate(e,t,s){this._coverageUpdateTimes.add(e),this._backlogOrProcessJSCoverage(s,e)}async stop(){await this.stopPolling();const e=[];this._cpuProfilerModel&&e.push(this._cpuProfilerModel.stopPreciseCoverage()),this._cssModel&&(e.push(this._cssModel.stopCoverage()),this._cssModel.removeEventListener(SDK.CSSModel.Events.StyleSheetAdded,this._handleStyleSheetAdded,this)),await Promise.all(e)}reset(){this._coverageByURL=new Map,this._coverageByContentProvider=new Map,this._coverageUpdateTimes=new Set,this.dispatchEventToListeners(Events.CoverageReset)}async startPolling(){this._currentPollPromise||"Active"!==this._suspensionState||await this._pollLoop()}async _pollLoop(){this._clearTimer(),this._currentPollPromise=this._pollAndCallback(),await this._currentPollPromise,("Active"===this._suspensionState||this._performanceTraceRecording)&&(this._pollTimer=window.setTimeout((()=>this._pollLoop()),200))}async stopPolling(){this._clearTimer(),await this._currentPollPromise,this._currentPollPromise=null,await this._pollAndCallback()}async _pollAndCallback(){if("Suspended"===this._suspensionState&&!this._performanceTraceRecording)return;const e=await this._takeAllCoverage();console.assert("Suspended"!==this._suspensionState||Boolean(this._performanceTraceRecording),"CoverageModel was suspended while polling."),e.length&&this.dispatchEventToListeners(Events.CoverageUpdated,e)}_clearTimer(){this._pollTimer&&(clearTimeout(this._pollTimer),this._pollTimer=null)}async preSuspendModel(e){"Active"===this._suspensionState&&(this._suspensionState="Suspending","performance-timeline"!==e?this._currentPollPromise&&(await this.stopPolling(),this._shouldResumePollingOnResume=!0):this._performanceTraceRecording=!0)}async suspendModel(e){this._suspensionState="Suspended"}async resumeModel(){}async postResumeModel(){this._suspensionState="Active",this._performanceTraceRecording=!1,this._shouldResumePollingOnResume&&(this._shouldResumePollingOnResume=!1,await this.startPolling())}entries(){return Array.from(this._coverageByURL.values())}getCoverageForUrl(e){return this._coverageByURL.get(e)||null}usageForRange(e,t,s){const o=this._coverageByContentProvider.get(e);return o&&o.usageForRange(t,s)}_clearCSS(){for(const e of this._coverageByContentProvider.values()){if(1!==e.type())continue;const t=e.contentProvider();this._coverageByContentProvider.delete(t);const s=`${t.startLine}:${t.startColumn}`,o=this._coverageByURL.get(e.url());o&&o._coverageInfoByLocation.delete(s)&&(o._addToSizes(-e._usedSize,-e._size),o._coverageInfoByLocation.size||this._coverageByURL.delete(e.url()))}if(this._cssModel)for(const e of this._cssModel.getAllStyleSheetHeaders())this._addStyleSheetToCSSCoverage(e)}async _takeAllCoverage(){const[e,t]=await Promise.all([this._takeCSSCoverage(),this._takeJSCoverage()]);return[...e,...t]}async _takeJSCoverage(){if(!this._cpuProfilerModel)return[];const{coverage:e,timestamp:t}=await this._cpuProfilerModel.takePreciseCoverage();return this._coverageUpdateTimes.add(t),this._backlogOrProcessJSCoverage(e,t)}coverageUpdateTimes(){return this._coverageUpdateTimes}async _backlogOrProcessJSCoverage(e,t){if(e.length>0&&this._jsBacklog.push({rawCoverageData:e,stamp:t}),"Active"!==this._suspensionState)return[];const s=(e,t)=>e.stamp-t.stamp,o=[];for(const{rawCoverageData:r,stamp:n}of this._jsBacklog.sort(s))o.push(this._processJSCoverage(r,n));return this._jsBacklog=[],o.flat()}async processJSBacklog(){this._backlogOrProcessJSCoverage([],0)}_processJSCoverage(e,t){if(!this._debuggerModel)return[];const s=[];for(const o of e){const e=this._debuggerModel.scriptForId(o.scriptId);if(!e)continue;const r=[];let n=2;for(const t of o.functions){!1!==t.isBlockCoverage||1===t.ranges.length&&!t.ranges[0].count||(n|=4);for(const e of t.ranges)r.push(e)}const i=this._addCoverage(e,e.contentLength,e.lineOffset,e.columnOffset,r,n,t);i&&s.push(i)}return s}_handleStyleSheetAdded(e){const t=e.data;this._addStyleSheetToCSSCoverage(t)}async _takeCSSCoverage(){if(!this._cssModel||"Active"!==this._suspensionState)return[];const{coverage:e,timestamp:t}=await this._cssModel.takeCoverageDelta();return this._coverageUpdateTimes.add(t),this._backlogOrProcessCSSCoverage(e,t)}async _backlogOrProcessCSSCoverage(e,t){if(e.length>0&&this._cssBacklog.push({rawCoverageData:e,stamp:t}),"Active"!==this._suspensionState)return[];const s=(e,t)=>e.stamp-t.stamp,o=[];for(const{rawCoverageData:r,stamp:n}of this._cssBacklog.sort(s))o.push(this._processCSSCoverage(r,n));return this._cssBacklog=[],o.flat()}_processCSSCoverage(e,t){if(!this._cssModel)return[];const s=[],o=new Map;for(const r of e){const e=this._cssModel.styleSheetHeaderForId(r.styleSheetId);if(!e)continue;let t=o.get(e);t||(t=[],o.set(e,t)),t.push({startOffset:r.startOffset,endOffset:r.endOffset,count:Number(r.used)})}for(const r of o){const e=r[0],o=r[1],n=this._addCoverage(e,e.contentLength,e.startLine,e.startColumn,o,1,t);n&&s.push(n)}return s}static _convertToDisjointSegments(e,t){e.sort(((e,t)=>e.startOffset-t.startOffset));const s=[],o=[];for(const n of e){let e=o[o.length-1];for(;e&&e.endOffset<=n.startOffset;)r(e.endOffset,e.count),o.pop(),e=o[o.length-1];r(n.startOffset,e?e.count:0),o.push(n)}for(let n=o.pop();n;n=o.pop())r(n.endOffset,n.count);function r(e,o){const r=s[s.length-1];if(r){if(r.end===e)return;if(r.count===o)return void(r.end=e)}s.push({end:e,count:o,stamp:t})}return s}_addStyleSheetToCSSCoverage(e){this._addCoverage(e,e.contentLength,e.startLine,e.startColumn,[],1,Date.now())}_addCoverage(e,t,s,o,r,n,i){const a=e.contentURL();if(!a)return null;let c=this._coverageByURL.get(a),l=!1;c||(l=!0,c=new URLCoverageInfo(a),this._coverageByURL.set(a,c));const h=c._ensureEntry(e,t,s,o,n);this._coverageByContentProvider.set(e,h);const d=CoverageModel._convertToDisjointSegments(r,i),u=d[d.length-1];u&&u.end<t&&d.push({end:t,stamp:i,count:0});const _=h._usedSize;return h.mergeCoverage(d),l||h._usedSize!==_?(c._addToSizes(h._usedSize-_,0),h):null}async exportReport(e){const t=[];function s(e,t){const[s,o]=e.split(":"),[r,n]=t.split(":");return Number.parseInt(s,10)-Number.parseInt(r,10)||Number.parseInt(o,10)-Number.parseInt(n,10)}const o=Array.from(this._coverageByURL.keys()).sort();for(const r of o){const e=this._coverageByURL.get(r);if(!e)continue;const o=e.url();if(o.startsWith("extensions::")||o.startsWith("chrome-extension://"))continue;let n=!1;for(const t of e._coverageInfoByLocation.values())if(t._lineOffset||t._columnOffset){n=Boolean(o);break}let i=null;if(n){const e=SDK.ResourceTreeModel.ResourceTreeModel.resourceForURL(o);if(e){const t=(await e.requestContent()).content;i=new TextUtils.Text.Text(t||"")}}const a=Array.from(e._coverageInfoByLocation.keys()).sort(s);if(i){const s={url:o,ranges:[],text:i.value()};for(const t of a){const o=e._coverageInfoByLocation.get(t);if(!o)continue;const r=i?i.offsetFromPosition(o._lineOffset,o._columnOffset):0;let n=0;for(const e of o._segments)e.count?s.ranges.push({start:n+r,end:e.end+r}):n=e.end}t.push(s)}else for(const s of a){const r=e._coverageInfoByLocation.get(s);if(!r)continue;const n={url:o,ranges:[],text:(await r.contentProvider().requestContent()).content};let i=0;for(const e of r._segments)e.count?n.ranges.push({start:i,end:e.end}):i=e.end;t.push(n)}}await e.write(JSON.stringify(t,void 0,2)),e.close()}}SDK.SDKModel.SDKModel.register(CoverageModel,SDK.SDKModel.Capability.None,!1);export class URLCoverageInfo extends Common.ObjectWrapper.ObjectWrapper{constructor(e){super(),this._url=e,this._coverageInfoByLocation=new Map,this._size=0,this._usedSize=0,this._isContentScript=!1}url(){return this._url}type(){return this._type}size(){return this._size}usedSize(){return this._usedSize}unusedSize(){return this._size-this._usedSize}usedPercentage(){return 0===this._size?0:this.usedSize()/this.size()*100}unusedPercentage(){return 0===this._size?100:this.unusedSize()/this.size()*100}isContentScript(){return this._isContentScript}entries(){return this._coverageInfoByLocation.values()}_addToSizes(e,t){this._usedSize+=e,this._size+=t,0===e&&0===t||this.dispatchEventToListeners(URLCoverageInfo.Events.SizesChanged)}_ensureEntry(e,t,s,o,r){const n=`${s}:${o}`;let i=this._coverageInfoByLocation.get(n);return 2&r&&!this._coverageInfoByLocation.size&&(this._isContentScript=e.isContentScript()),this._type|=r,i?(i._coverageType|=r,i):(2&r&&!this._coverageInfoByLocation.size&&(this._isContentScript=e.isContentScript()),i=new CoverageInfo(e,t,s,o,r),this._coverageInfoByLocation.set(n,i),this._addToSizes(0,t),i)}}!function(e){e.Events={SizesChanged:Symbol("SizesChanged")}}(URLCoverageInfo||(URLCoverageInfo={}));export const mergeSegments=(e,t)=>{const s=[];let o=0,r=0;for(;o<e.length&&r<t.length;){const n=e[o],i=t[r],a=(n.count||0)+(i.count||0),c=Math.min(n.end,i.end),l=s[s.length-1],h=Math.min(n.stamp,i.stamp);l&&l.count===a&&l.stamp===h?l.end=c:s.push({end:c,count:a,stamp:h}),n.end<=i.end&&o++,n.end>=i.end&&r++}for(;o<e.length;o++)s.push(e[o]);for(;r<t.length;r++)s.push(t[r]);return s};export class CoverageInfo{constructor(e,t,s,o,r){this._contentProvider=e,this._size=t,this._usedSize=0,this._statsByTimestamp=new Map,this._lineOffset=s,this._columnOffset=o,this._coverageType=r,this._segments=[]}contentProvider(){return this._contentProvider}url(){return this._contentProvider.contentURL()}type(){return this._coverageType}mergeCoverage(e){this._segments=mergeSegments(this._segments,e),this._updateStats()}usedByTimestamp(){return this._statsByTimestamp}size(){return this._size}usageForRange(e,t){let s=Platform.ArrayUtilities.upperBound(this._segments,e,((e,t)=>e-t.end));for(;s<this._segments.length&&this._segments[s].end<t;++s)if(this._segments[s].count)return!0;return s<this._segments.length&&Boolean(this._segments[s].count)}_updateStats(){this._statsByTimestamp=new Map,this._usedSize=0;let e=0;for(const t of this._segments){let s=this._statsByTimestamp.get(t.stamp);if(void 0===s&&(s=0),t.count){const o=t.end-e;this._usedSize+=o,this._statsByTimestamp.set(t.stamp,s+o)}e=t.end}}}