import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Emulation from"../emulation/emulation.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as TextEditor from"../text_editor/text_editor.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import{Adorner}from"./Adorner.js";import{canGetJSPath,cssPath,jsPath,xPath}from"./DOMPath.js";import{ElementsPanel}from"./ElementsPanel.js";import{MappedCharToEntity}from"./ElementsTreeOutline.js";import{ImagePreviewPopover}from"./ImagePreviewPopover.js";import{getRegisteredDecorators}from"./MarkerDecorator.js";const UIStrings={thisFrameWasIdentifiedAsAnAd:"This frame was identified as an ad frame",forceState:"Force state",useSInTheConsoleToReferToThis:"Use {PH1} in the console to refer to this element.",addAttribute:"Add attribute",editAttribute:"Edit attribute",focus:"Focus",scrollIntoView:"Scroll into view",editText:"Edit text",editAsHtml:"Edit as HTML",copy:"Copy",copyOuterhtml:"Copy outerHTML",copySelector:"Copy `selector`",copyJsPath:"Copy JS path",copyStyles:"Copy styles",copyXpath:"Copy XPath",copyFullXpath:"Copy full XPath",cutElement:"Cut element",copyElement:"Copy element",pasteElement:"Paste element",duplicateElement:"Duplicate element",hideElement:"Hide element",deleteElement:"Delete element",expandRecursively:"Expand recursively",collapseChildren:"Collapse children",captureNodeScreenshot:"Capture node screenshot",valueIsTooLargeToEdit:"<value is too large to edit>",children:"Children:",enableGridMode:"Enable grid mode",disableGridMode:"Disable grid mode",enableFlexMode:"Enable flex mode",disableFlexMode:"Disable flex mode"},str_=i18n.i18n.registerUIStrings("elements/ElementsTreeElement.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ElementsTreeElement extends UI.TreeOutline.TreeElement{constructor(t,e){super(),this._node=t,this.treeOutline=null,this._gutterContainer=this.listItemElement.createChild("div","gutter-container"),this._gutterContainer.addEventListener("click",this._showContextMenu.bind(this));const i=UI.Icon.Icon.create("largeicon-menu","gutter-menu-icon");if(this._gutterContainer.appendChild(i),this._decorationsElement=this._gutterContainer.createChild("div","hidden"),this._isClosingTag=e,this._node.nodeType()!==Node.ELEMENT_NODE||e||(this._canAddAttributes=!0),this._searchQuery=null,this._expandedChildrenLimit=InitialChildrenLimit,this._decorationsThrottler=new Common.Throttler.Throttler(100),this._inClipboard=!1,this._hovered=!1,this._editing=null,this._highlightResult=[],!e&&(this._adornerContainer=this.listItemElement.createChild("div","adorner-container hidden"),this._adorners=[],this._styleAdorners=[],this._adornersThrottler=new Common.Throttler.Throttler(100),this.updateStyleAdorners(),t.isAdFrameNode())){const t=this.adornText("Ad","Security");UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.thisFrameWasIdentifiedAsAnAd))}this._htmlEditElement,this.expandAllButtonElement=null}static animateOnDOMUpdate(t){const e=t.listItemElement.querySelector(".webkit-html-tag-name");UI.UIUtils.runCSSAnimationOnce(e||t.listItemElement,"dom-update-highlight")}static visibleShadowRoots(t){let e=t.shadowRoots();return e.length&&!Common.Settings.Settings.instance().moduleSetting("showUAShadowDOM").get()&&(e=e.filter((function(t){return t.shadowRootType()!==SDK.DOMModel.DOMNode.ShadowRootTypes.UserAgent}))),e}static canShowInlineText(t){if(t.contentDocument()||t.importedDocument()||t.templateContent()||ElementsTreeElement.visibleShadowRoots(t).length||t.hasPseudoElements())return!1;if(t.nodeType()!==Node.ELEMENT_NODE)return!1;if(!t.firstChild||t.firstChild!==t.lastChild||t.firstChild.nodeType()!==Node.TEXT_NODE)return!1;return t.firstChild.nodeValue().length<80}static populateForcedPseudoStateItems(t,e){const i=["active","hover","focus","visited","focus-within","focus-visible"],n=e.domModel().cssModel().pseudoState(e),s=t.debugSection().appendSubMenuItem(i18nString(UIStrings.forceState));for(const r of i){const t=!!n&&n.indexOf(r)>=0;s.defaultSection().appendCheckboxItem(":"+r,o.bind(null,r,!t),t,!1)}function o(t,i){e.domModel().cssModel().forcePseudoState(e,t,i)}}isClosingTag(){return Boolean(this._isClosingTag)}node(){return this._node}isEditing(){return Boolean(this._editing)}highlightSearchResults(t){this._searchQuery!==t&&this._hideSearchHighlight(),this._searchQuery=t,this._searchHighlightsVisible=!0,this.updateTitle(null,!0)}hideSearchHighlights(){delete this._searchHighlightsVisible,this._hideSearchHighlight()}_hideSearchHighlight(){if(0!==this._highlightResult.length){for(let t=this._highlightResult.length-1;t>=0;--t){const e=this._highlightResult[t];switch(e.type){case"added":e.node.remove();break;case"changed":e.node.textContent=e.oldText||null}}this._highlightResult=[]}}setInClipboard(t){this._inClipboard!==t&&(this._inClipboard=t,this.listItemElement.classList.toggle("in-clipboard",t))}get hovered(){return this._hovered}set hovered(t){this._hovered!==t&&(this._hovered=t,this.listItemElement&&(t?(this._createSelection(),this.listItemElement.classList.add("hovered")):this.listItemElement.classList.remove("hovered")))}expandedChildrenLimit(){return this._expandedChildrenLimit}setExpandedChildrenLimit(t){this._expandedChildrenLimit=t}_createSelection(){const t=this.listItemElement;t&&(this.selectionElement||(this.selectionElement=document.createElement("div"),this.selectionElement.className="selection fill",this.selectionElement.style.setProperty("margin-left",-this._computeLeftIndent()+"px"),t.insertBefore(this.selectionElement,t.firstChild)))}_createHint(){if(this.listItemElement&&!this._hintElement){this._hintElement=this.listItemElement.createChild("span","selected-hint");const t="$0";UI.Tooltip.Tooltip.install(this._hintElement,i18nString(UIStrings.useSInTheConsoleToReferToThis,{PH1:t})),UI.ARIAUtils.markAsHidden(this._hintElement)}}onbind(){this.treeOutline&&!this._isClosingTag&&this.treeOutline.treeElementByNode.set(this._node,this)}onunbind(){this._editing&&this._editing.cancel(),this.treeOutline&&this.treeOutline.treeElementByNode.get(this._node)===this&&this.treeOutline.treeElementByNode.delete(this._node)}onattach(){this._hovered&&(this._createSelection(),this.listItemElement.classList.add("hovered")),this.updateTitle(),this.listItemElement.draggable=!0}async onpopulate(){if(this.treeOutline)return this.treeOutline.populateTreeElement(this)}async expandRecursively(){await this._node.getSubtree(-1,!0),await super.expandRecursively(Number.MAX_VALUE)}onexpand(){this._isClosingTag||this.updateTitle()}oncollapse(){this._isClosingTag||this.updateTitle()}select(t,e){return!this._editing&&super.select(t,e)}onselect(t){return!!this.treeOutline&&(this.treeOutline.suppressRevealAndSelect=!0,this.treeOutline.selectDOMNode(this._node,t),t&&(this._node.highlight(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.ChangeInspectedNodeInElementsPanel)),this._createSelection(),this._createHint(),this.treeOutline.suppressRevealAndSelect=!1,!0)}ondelete(){if(!this.treeOutline)return!1;const t=this.treeOutline.findTreeElement(this._node);return t?t.remove():this.remove(),!0}onenter(){return!this._editing&&(this._startEditing(),!0)}selectOnMouseDown(t){super.selectOnMouseDown(t),this._editing||t.detail>=2&&t.preventDefault()}ondblclick(t){return this._editing||this._isClosingTag||this._startEditingTarget(t.target)||this.isExpandable()&&!this.expanded&&this.expand(),!1}hasEditableNode(){return!this._node.isShadowRoot()&&!this._node.ancestorUserAgentShadowRoot()}_insertInLastAttributePosition(t,e){if(t.getElementsByClassName("webkit-html-attribute").length>0)t.insertBefore(e,t.lastChild);else if(null!==t.textContent){const i=t.textContent.match(/^<(.*?)>$/);if(!i)return;const n=i[1];t.textContent="",UI.UIUtils.createTextChild(t,"<"+n),t.appendChild(e),UI.UIUtils.createTextChild(t,">")}}_startEditingTarget(t){if(!this.treeOutline||this.treeOutline.selectedDOMNode()!==this._node)return!1;if(this._node.nodeType()!==Node.ELEMENT_NODE&&this._node.nodeType()!==Node.TEXT_NODE)return!1;const e=t.enclosingNodeOrSelfWithClass("webkit-html-text-node");if(e)return this._startEditingTextNode(e);const i=t.enclosingNodeOrSelfWithClass("webkit-html-attribute");if(i)return this._startEditingAttribute(i,t);const n=t.enclosingNodeOrSelfWithClass("webkit-html-tag-name");if(n)return this._startEditingTagName(n);return!!t.enclosingNodeOrSelfWithClass("add-attribute")&&this._addNewAttribute()}_showContextMenu(t){this.treeOutline&&this.treeOutline.showContextMenu(this,t)}populateTagContextMenu(t,e){const i=this._isClosingTag&&this.treeOutline?this.treeOutline.findTreeElement(this._node):this;if(!i)return;t.editSection().appendItem(i18nString(UIStrings.addAttribute),i._addNewAttribute.bind(i));const n=e.target,s=n.enclosingNodeOrSelfWithClass("webkit-html-attribute"),o=n.enclosingNodeOrSelfWithClass("add-attribute");s&&!o&&t.editSection().appendItem(i18nString(UIStrings.editAttribute),this._startEditingAttribute.bind(this,s,n)),this.populateNodeContextMenu(t),ElementsTreeElement.populateForcedPseudoStateItems(t,i.node()),this.populateScrollIntoView(t),t.viewSection().appendItem(i18nString(UIStrings.focus),(async()=>{await this._node.focus()}))}populateScrollIntoView(t){t.viewSection().appendItem(i18nString(UIStrings.scrollIntoView),(()=>this._node.scrollIntoView()))}populateTextContextMenu(t,e){this._editing||t.editSection().appendItem(i18nString(UIStrings.editText),this._startEditingTextNode.bind(this,e)),this.populateNodeContextMenu(t)}populateNodeContextMenu(t){const e=this.hasEditableNode();e&&!this._editing&&t.editSection().appendItem(i18nString(UIStrings.editAsHtml),this._editAsHTML.bind(this));const i=this._node.isShadowRoot(),n=t.clipboardSection().appendSubMenuItem(i18nString(UIStrings.copy)),s=UI.KeyboardShortcut.KeyboardShortcut.shortcutToString.bind(null),o=UI.KeyboardShortcut.Modifiers.CtrlOrMeta,r=this.treeOutline;if(!r)return;let l;const d=n.section();if(i||(l=d.appendItem(i18nString(UIStrings.copyOuterhtml),r.performCopyOrCut.bind(r,!1,this._node)),l.setShortcut(s("V",o))),this._node.nodeType()===Node.ELEMENT_NODE&&(d.appendItem(i18nString(UIStrings.copySelector),this._copyCSSPath.bind(this)),d.appendItem(i18nString(UIStrings.copyJsPath),this._copyJSPath.bind(this),!canGetJSPath(this._node)),d.appendItem(i18nString(UIStrings.copyStyles),this._copyStyles.bind(this))),i||(d.appendItem(i18nString(UIStrings.copyXpath),this._copyXPath.bind(this)),d.appendItem(i18nString(UIStrings.copyFullXpath),this._copyFullXPath.bind(this))),!i){l=n.clipboardSection().appendItem(i18nString(UIStrings.cutElement),r.performCopyOrCut.bind(r,!0,this._node),!this.hasEditableNode()),l.setShortcut(s("X",o)),l=n.clipboardSection().appendItem(i18nString(UIStrings.copyElement),r.performCopyOrCut.bind(r,!1,this._node)),l.setShortcut(s("C",o)),l=n.clipboardSection().appendItem(i18nString(UIStrings.pasteElement),r.pasteNode.bind(r,this._node),!r.canPaste(this._node)),l.setShortcut(s("V",o));const e=!this._node.parentNode||"#document"===this._node.parentNode.nodeName();l=t.editSection().appendItem(i18nString(UIStrings.duplicateElement),r.duplicateNode.bind(r,this._node),this._node.isInShadowTree()||e)}l=t.debugSection().appendCheckboxItem(i18nString(UIStrings.hideElement),r.toggleHideElement.bind(r,this._node),r.isToggledToHidden(this._node)),l.setShortcut(UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("elements.hide-element")||""),e&&t.editSection().appendItem(i18nString(UIStrings.deleteElement),this.remove.bind(this)),t.viewSection().appendItem(i18nString(UIStrings.expandRecursively),this.expandRecursively.bind(this)),t.viewSection().appendItem(i18nString(UIStrings.collapseChildren),this.collapseChildren.bind(this));const a=new Emulation.DeviceModeWrapper.ActionDelegate;t.viewSection().appendItem(i18nString(UIStrings.captureNodeScreenshot),a.handleAction.bind(null,UI.Context.Context.instance(),"emulation.capture-node-screenshot"))}_startEditing(){if(!this.treeOutline||this.treeOutline.selectedDOMNode()!==this._node)return;const t=this.listItemElement;if(this._canAddAttributes){const e=t.getElementsByClassName("webkit-html-attribute")[0];return e?this._startEditingAttribute(e,e.getElementsByClassName("webkit-html-attribute-value")[0]):this._addNewAttribute()}if(this._node.nodeType()===Node.TEXT_NODE){const e=t.getElementsByClassName("webkit-html-text-node")[0];if(e)return this._startEditingTextNode(e)}}_addNewAttribute(){const t=document.createElement("span"),e=this._buildAttributeDOM(t," ","",null);e.style.marginLeft="2px",e.style.marginRight="2px";const i=this.listItemElement.getElementsByClassName("webkit-html-tag")[0];return this._insertInLastAttributePosition(i,e),e.scrollIntoViewIfNeeded(!0),this._startEditingAttribute(e,e)}_triggerEditAttribute(t){const e=this.listItemElement.getElementsByClassName("webkit-html-attribute-name");for(let i=0,n=e.length;i<n;++i)if(e[i].textContent===t)for(let t=e[i].nextSibling;t;t=t.nextSibling)if(t.nodeType===Node.ELEMENT_NODE&&t.classList.contains("webkit-html-attribute-value"))return this._startEditingAttribute(t.parentElement,t)}_startEditingAttribute(t,e){if(console.assert(this.listItemElement.isAncestor(t)),UI.UIUtils.isBeingEdited(t))return!0;const i=t.getElementsByClassName("webkit-html-attribute-name")[0];if(!i)return!1;const n=i.textContent,s=t.getElementsByClassName("webkit-html-attribute-value")[0];e=s.isAncestor(e)?s:e;const o=n&&s?this._node.getAttribute(n):void 0;void 0!==o&&s.setTextContentTruncatedIfNeeded(o,i18nString(UIStrings.valueIsTooLargeToEdit)),function t(e){if(e.nodeType!==Node.TEXT_NODE){if(e.nodeType===Node.ELEMENT_NODE)for(let i=e.firstChild;i;i=i.nextSibling)t(i)}else e.nodeValue=e.nodeValue?e.nodeValue.replace(/\u200B/g,""):""}(t);const r=new UI.InplaceEditor.Config(this._attributeEditingCommitted.bind(this),this._editingCancelled.bind(this),n||void 0);Common.ParsedURL.ParsedURL.fromString(s.textContent||"")||r.setPostKeydownFinishHandler((function(e){return UI.UIUtils.handleElementValueModifications(e,t),""})),this._updateEditorHandles(t,r);const l=this.listItemElement.getComponentSelection();return l&&l.selectAllChildren(e),!0}_startEditingTextNode(t){if(UI.UIUtils.isBeingEdited(t))return!0;let e=this._node;e.nodeType()===Node.ELEMENT_NODE&&e.firstChild&&(e=e.firstChild);const i=t.enclosingNodeOrSelfWithClass("webkit-html-text-node");i&&(i.textContent=e.nodeValue());const n=new UI.InplaceEditor.Config(this._textNodeEditingCommitted.bind(this,e),this._editingCancelled.bind(this));this._updateEditorHandles(t,n);const s=this.listItemElement.getComponentSelection();return s&&s.selectAllChildren(t),!0}_startEditingTagName(t){if(!t&&!(t=this.listItemElement.getElementsByClassName("webkit-html-tag-name")[0]))return!1;const e=t.textContent;if(null!==e&&EditTagBlocklist.has(e.toLowerCase()))return!1;if(UI.UIUtils.isBeingEdited(t))return!0;const i=this._distinctClosingTagElement();function n(){i&&t&&(i.textContent="</"+t.textContent+">")}const s=t=>{" "===t.key&&(this._editing&&this._editing.commit(),t.consume(!0))};t.addEventListener("keyup",n,!1),t.addEventListener("keydown",s,!1);const o=new UI.InplaceEditor.Config(function(e,i,o,r,l){t&&(t.removeEventListener("keyup",n,!1),t.removeEventListener("keydown",s,!1),this._tagNameEditingCommitted(e,i,o,r,l))}.bind(this),function(e,i){t&&(t.removeEventListener("keyup",n,!1),t.removeEventListener("keydown",s,!1),this._editingCancelled(e,i))}.bind(this),e);this._updateEditorHandles(t,o);const r=this.listItemElement.getComponentSelection();return r&&r.selectAllChildren(t),!0}_updateEditorHandles(t,e){const i=UI.InplaceEditor.InplaceEditor.startEditing(t,e);this._editing=i?{commit:i.commit,cancel:i.cancel,editor:void 0,resize:()=>{}}:null}_startEditingAsHTML(t,e,i){if(null===i)return;let n=i;if(this._editing)return;n=this._convertWhitespaceToEntities(n).text,this._htmlEditElement=document.createElement("div"),this._htmlEditElement.className="source-code elements-tree-editor";let s=this.listItemElement.firstChild;for(;s;)s.style.display="none",s=s.nextSibling;this.childrenListElement&&(this.childrenListElement.style.display="none"),this.listItemElement.appendChild(this._htmlEditElement);const o=TextEditor.CodeMirrorTextEditor.CodeMirrorTextEditorFactory.instance().createEditor({lineNumbers:!1,lineWrapping:Common.Settings.Settings.instance().moduleSetting("domWordWrap").get(),mimeType:"text/html",autoHeight:!1,padBottom:!1,bracketMatchingSetting:void 0,devtoolsAccessibleName:void 0,maxHighlightLength:void 0,placeholder:void 0,lineWiseCopyCut:void 0,inputStyle:void 0});function r(){this.treeOutline&&this._htmlEditElement&&(this._htmlEditElement.style.width=this.treeOutline.visibleWidth()-this._computeLeftIndent()-30+"px"),this._editing&&this._editing.editor&&this._editing.editor.onResize()}function l(){if(!this._editing||!this._editing.editor)return;this._editing.editor.widget().element.removeEventListener("blur",this._editing.commit,!0),this._editing.editor.widget().detach(),this._editing=null,this._htmlEditElement&&this.listItemElement.removeChild(this._htmlEditElement),this._htmlEditElement=void 0,this.childrenListElement&&this.childrenListElement.style.removeProperty("display");let t=this.listItemElement.firstChild;for(;t;)t.style.removeProperty("display"),t=t.nextSibling;this.treeOutline&&(this.treeOutline.setMultilineEditing(null),this.treeOutline.focus()),e()}this._editing={commit:function(){this._editing&&this._editing.editor&&t(n,this._editing.editor.text());l.call(this)}.bind(this),cancel:l.bind(this),editor:o,resize:r.bind(this)},r.call(this),o.widget().show(this._htmlEditElement),o.setText(n),o.widget().focus(),o.widget().element.addEventListener("focusout",(t=>{const e=t.relatedTarget;e&&!e.isSelfOrDescendant(o.widget().element)&&this._editing&&this._editing.commit()}),!1),o.widget().element.addEventListener("keydown",function(t){const e=t,i=UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e)&&!e.altKey&&!e.shiftKey;"Enter"===e.key&&(i||e.isMetaOrCtrlForTest)?(e.consume(!0),this._editing&&this._editing.commit()):e.keyCode!==UI.KeyboardShortcut.Keys.Esc.code&&"Escape"!==e.key||(e.consume(!0),this._editing&&this._editing.cancel())}.bind(this),!0),this.treeOutline&&this.treeOutline.setMultilineEditing(this._editing)}_attributeEditingCommitted(t,e,i,n,s){this._editing=null;const o=this.treeOutline;function r(i){if(i&&this._editingCancelled(t,n),!s)return;o&&(o.runPendingUpdates(),o.focus());const r=this._node.attributes();for(let t=0;t<r.length;++t)if(r[t].name===n)return void("backward"===s?0===t?this._startEditingTagName():this._triggerEditAttribute(r[t-1].name):t===r.length-1?this._addNewAttribute():this._triggerEditAttribute(r[t+1].name));"backward"===s?" "===e?r.length>0&&this._triggerEditAttribute(r[r.length-1].name):r.length>1&&this._triggerEditAttribute(r[r.length-2].name):"forward"===s&&(Platform.StringUtilities.isWhitespace(e)?this._startEditingTagName():this._addNewAttribute())}!n.trim()&&!e.trim()||i===e?(this.updateTitle(),r.call(this)):this._node.setAttribute(n,e,r.bind(this))}_tagNameEditingCommitted(t,e,i,n,s){this._editing=null;const o=this;function r(){const e=o._distinctClosingTagElement();e&&(e.textContent="</"+n+">"),o._editingCancelled(t,n),l.call(o)}function l(){if("forward"!==s)return void this._addNewAttribute();const t=this._node.attributes();t.length>0?this._triggerEditAttribute(t[0].name):this._addNewAttribute()}if((e=e.trim())===i)return void r();const d=this.treeOutline,a=this.expanded;this._node.setNodeName(e,((t,e)=>{if(t||!e)return void r();if(!d)return;const i=d.selectNodeAfterEdit(a,t,e);l.call(i)}))}_textNodeEditingCommitted(t,e,i){this._editing=null,t.setNodeValue(i,function(){this.updateTitle()}.bind(this))}_editingCancelled(t,e){this._editing=null,this.updateTitle()}_distinctClosingTagElement(){if(this.expanded){const t=this.childrenListElement.querySelectorAll(".close");return t[t.length-1]}const t=this.listItemElement.getElementsByClassName("webkit-html-tag");return 1===t.length?null:t[t.length-1]}updateTitle(t,e){if(!this._editing){if(e)this._hideSearchHighlight();else{const e=this._nodeTitleInfo(t||null);if(this._node.nodeType()===Node.DOCUMENT_FRAGMENT_NODE&&this._node.isInShadowTree()&&this._node.shadowRootType()){this.childrenListElement.classList.add("shadow-root");let t=4;for(let e=this._node;t&&e;e=e.parentNode)e.nodeType()===Node.DOCUMENT_FRAGMENT_NODE&&t--;t?this.childrenListElement.classList.add("shadow-root-depth-"+t):this.childrenListElement.classList.add("shadow-root-deep")}const i=document.createElement("span");i.className="highlight",i.appendChild(e),this.title=i,this.updateDecorations(),this.listItemElement.insertBefore(this._gutterContainer,this.listItemElement.firstChild),!this._isClosingTag&&this._adornerContainer&&this.listItemElement.appendChild(this._adornerContainer),this._highlightResult=[],delete this.selectionElement,delete this._hintElement,this.selected&&(this._createSelection(),this._createHint())}this._highlightSearchResults()}}_computeLeftIndent(){let t=this.parent,e=0;for(;null!==t;)e++,t=t.parent;return 12*(e-2)+(this.isExpandable()?1:12)}updateDecorations(){this._gutterContainer.style.left=-this._computeLeftIndent()+"px",this.isClosingTag()||this._node.nodeType()===Node.ELEMENT_NODE&&this._decorationsThrottler.schedule(this._updateDecorationsInternal.bind(this))}_updateDecorationsInternal(){if(!this.treeOutline)return Promise.resolve();const t=this._node;this.treeOutline.decoratorExtensions||(this.treeOutline.decoratorExtensions=getRegisteredDecorators());const e=new Map;for(const r of this.treeOutline.decoratorExtensions)e.set(r.marker,r);const i=[],n=[],s=[];function o(e,i){const o=i.decorate(e);o&&(e===t?n:s).push(o)}return t.traverseMarkers((function(t,n){const s=e.get(n);if(!s)return;i.push(Promise.resolve(s.decorator()).then(o.bind(null,t)))})),Promise.all(i).then(function(){if(this._decorationsElement.removeChildren(),this._decorationsElement.classList.add("hidden"),this._gutterContainer.classList.toggle("has-decorations",Boolean(n.length||s.length)),UI.ARIAUtils.setAccessibleName(this._decorationsElement,""),!n.length&&!s.length)return;const t=new Set,e=document.createElement("div");for(const s of n){e.createChild("div").textContent=s.title,t.add(s.color)}if(this.expanded&&!n.length)return;const i=new Set;if(s.length){let t=e.createChild("div");t.textContent=i18nString(UIStrings.children);for(const n of s)t=e.createChild("div"),t.style.marginLeft="15px",t.textContent=n.title,i.add(n.color)}let o=0;r.call(this,t,"elements-gutter-decoration"),this.expanded||r.call(this,i,"elements-gutter-decoration elements-has-decorated-children");function r(t,e){for(const i of t){const t=this._decorationsElement.createChild("div",e);this._decorationsElement.classList.remove("hidden"),t.style.backgroundColor=i,t.style.borderColor=i,o&&(t.style.marginLeft=o+"px"),o+=3}}UI.Tooltip.Tooltip.install(this._decorationsElement,e),UI.ARIAUtils.setAccessibleName(this._decorationsElement,e.textContent||"")}.bind(this))}_buildAttributeDOM(t,e,i,n,s,o){const r=/[\/;:\)\]\}]/g;let l=0,d=0,a=0;function h(t,e){const i=this._convertWhitespaceToEntities(e);for(d=i.entityRanges.length,e=i.text.replace(r,((t,e)=>{for(;l<d&&i.entityRanges[l].offset<e;)i.entityRanges[l].offset+=a,++l;return a+=1,t+"\u200b"}));l<d;)i.entityRanges[l].offset+=a,++l;t.setTextContentTruncatedIfNeeded(e),UI.UIUtils.highlightRangesWithStyleClass(t,i.entityRanges,"webkit-html-entity-value")}const c=s||i.length>0,m=t.createChild("span","webkit-html-attribute"),u=m.createChild("span","webkit-html-attribute-name");u.textContent=e,c&&UI.UIUtils.createTextChild(m,'=\u200b"');const g=m.createChild("span","webkit-html-attribute-value");function p(t){const e=o?o.resolveURL(t):null;if(null===e){const e=document.createElement("span");return h.call(this,e,t),e}(t=t.replace(r,"$&\u200b")).startsWith("data:")&&(t=Platform.StringUtilities.trimMiddle(t,60));const i=o&&"a"===o.nodeName().toLowerCase()?UI.XLink.XLink.create(e,t,"",!0):Components.Linkifier.Linkifier.linkifyURL(e,{text:t,preventClick:!0,className:void 0,lineNumber:void 0,columnNumber:void 0,maxLength:void 0,tabStop:void 0,bypassURLTrimming:void 0});return ImagePreviewPopover.setImageUrl(i,e)}n&&n.isAttributeModified(e)&&UI.UIUtils.runCSSAnimationOnce(c?g:u,"dom-update-highlight");const _=o?o.nodeName().toLowerCase():"";function E(t){const e=document.createDocumentFragment();let i=0;for(;t.length;){i++>0&&UI.UIUtils.createTextChild(e," ");let n="",s="";const o=(t=t.trim()).search(/\s/);if(-1===o)n=t;else if(o>0&&","===t[o-1])n=t.substring(0,o);else{n=t.substring(0,o);const e=t.indexOf(",",o);s=-1!==e?t.substring(o,e+1):t.substring(o)}n&&(n.endsWith(",")?(e.appendChild(p.call(this,n.substring(0,n.length-1))),UI.UIUtils.createTextChild(e,",")):e.appendChild(p.call(this,n))),s&&UI.UIUtils.createTextChild(e,s),t=t.substring(n.length+s.length)}return e}return!_||"src"!==e&&"href"!==e?("img"!==_&&"source"!==_||"srcset"!==e)&&("image"!==_||"xlink:href"!==e&&"href"!==e)?h.call(this,g,i):g.appendChild(E.call(this,i)):g.appendChild(p.call(this,i)),c&&UI.UIUtils.createTextChild(m,'"'),m}_buildPseudoElementDOM(t,e){t.createChild("span","webkit-html-pseudo-element").textContent="::"+e,UI.UIUtils.createTextChild(t,"\u200b")}_buildTagDOM(t,e,i,n,s){const o=this._node,r=["webkit-html-tag"];i&&n&&r.push("close");const l=t.createChild("span",r.join(" "));UI.UIUtils.createTextChild(l,"<");const d=l.createChild("span",i?"webkit-html-close-tag-name":"webkit-html-tag-name");if(d.textContent=(i?"/":"")+e,UI.ARIAUtils.setAccessibleName(d,e),!i){if(o.hasAttributes()){const t=o.attributes();for(let e=0;e<t.length;++e){const i=t[e];UI.UIUtils.createTextChild(l," "),this._buildAttributeDOM(l,i.name,i.value,s,!1,o)}}if(s){let t=s.hasRemovedAttributes()||s.hasRemovedChildren();t=t||!this.expanded&&s.hasChangedChildren(),t&&UI.UIUtils.runCSSAnimationOnce(d,"dom-update-highlight")}}UI.UIUtils.createTextChild(l,">"),UI.UIUtils.createTextChild(t,"\u200b")}_convertWhitespaceToEntities(t){let e="",i=0;const n=[],s=MappedCharToEntity;for(let o=0,r=t.length;o<r;++o){const r=t.charAt(o);if(s.has(r)){e+=t.substring(i,o);const l="&"+s.get(r)+";";n.push({offset:e.length,length:l.length}),e+=l,i=o+1}}return e&&(e+=t.substring(i)),{text:e||t,entityRanges:n}}_nodeTitleInfo(t){const e=this._node,i=document.createDocumentFragment(),n=()=>{this._highlightResult=[],this._highlightSearchResults()};switch(e.nodeType()){case Node.ATTRIBUTE_NODE:this._buildAttributeDOM(i,e.name,e.value,t,!0);break;case Node.ELEMENT_NODE:{const n=e.pseudoType();if(n){this._buildPseudoElementDOM(i,n);break}const s=e.nodeNameInCorrectCase();if(this._isClosingTag){this._buildTagDOM(i,s,!0,!0,t);break}if(this._buildTagDOM(i,s,!1,!1,t),this.isExpandable()){if(!this.expanded){i.createChild("span","webkit-html-text-node bogus").textContent="\u2026",UI.UIUtils.createTextChild(i,"\u200b"),this._buildTagDOM(i,s,!0,!1,t)}break}if(ElementsTreeElement.canShowInlineText(e)){const n=i.createChild("span","webkit-html-text-node"),o=e.firstChild;if(!o)throw new Error("ElementsTreeElement._nodeTitleInfo expects node.firstChild to be defined.");const r=this._convertWhitespaceToEntities(o.nodeValue());n.textContent=r.text,UI.UIUtils.highlightRangesWithStyleClass(n,r.entityRanges,"webkit-html-entity-value"),UI.UIUtils.createTextChild(i,"\u200b"),this._buildTagDOM(i,s,!0,!1,t),t&&t.hasChangedChildren()&&UI.UIUtils.runCSSAnimationOnce(n,"dom-update-highlight"),t&&t.isCharDataModified()&&UI.UIUtils.runCSSAnimationOnce(n,"dom-update-highlight");break}(this.treeOutline&&this.treeOutline.isXMLMimeType||!ForbiddenClosingTagElements.has(s))&&this._buildTagDOM(i,s,!0,!1,t);break}case Node.TEXT_NODE:if(e.parentNode&&"script"===e.parentNode.nodeName().toLowerCase()){const t=i.createChild("span","webkit-html-text-node webkit-html-js-node"),s=e.nodeValue();t.textContent=s.startsWith("\n")?s.substring(1):s;new TextEditor.SyntaxHighlighter.SyntaxHighlighter("text/javascript",!0).syntaxHighlightNode(t).then(n)}else if(e.parentNode&&"style"===e.parentNode.nodeName().toLowerCase()){const t=i.createChild("span","webkit-html-text-node webkit-html-css-node"),s=e.nodeValue();t.textContent=s.startsWith("\n")?s.substring(1):s;new TextEditor.SyntaxHighlighter.SyntaxHighlighter("text/css",!0).syntaxHighlightNode(t).then(n)}else{UI.UIUtils.createTextChild(i,'"');const n=i.createChild("span","webkit-html-text-node"),s=this._convertWhitespaceToEntities(e.nodeValue());n.textContent=s.text,UI.UIUtils.highlightRangesWithStyleClass(n,s.entityRanges,"webkit-html-entity-value"),UI.UIUtils.createTextChild(i,'"'),t&&t.isCharDataModified()&&UI.UIUtils.runCSSAnimationOnce(n,"dom-update-highlight")}break;case Node.COMMENT_NODE:{const t=i.createChild("span","webkit-html-comment");UI.UIUtils.createTextChild(t,"\x3c!--"+e.nodeValue()+"--\x3e");break}case Node.DOCUMENT_TYPE_NODE:{const t=i.createChild("span","webkit-html-doctype");UI.UIUtils.createTextChild(t,"<!DOCTYPE "+e.nodeName()),e.publicId?(UI.UIUtils.createTextChild(t,' PUBLIC "'+e.publicId+'"'),e.systemId&&UI.UIUtils.createTextChild(t,' "'+e.systemId+'"')):e.systemId&&UI.UIUtils.createTextChild(t,' SYSTEM "'+e.systemId+'"'),e.internalSubset&&UI.UIUtils.createTextChild(t," ["+e.internalSubset+"]"),UI.UIUtils.createTextChild(t,">");break}case Node.CDATA_SECTION_NODE:{const t=i.createChild("span","webkit-html-text-node");UI.UIUtils.createTextChild(t,"<![CDATA["+e.nodeValue()+"]]>");break}case Node.DOCUMENT_FRAGMENT_NODE:i.createChild("span","webkit-html-fragment").textContent=Platform.StringUtilities.collapseWhitespace(e.nodeNameInCorrectCase());break;default:{const t=Platform.StringUtilities.collapseWhitespace(e.nodeNameInCorrectCase());UI.UIUtils.createTextChild(i,t)}}return i}remove(){if(this._node.pseudoType())return;this.parent&&this._node.parentNode&&this._node.parentNode.nodeType()!==Node.DOCUMENT_NODE&&this._node.removeNode()}toggleEditAsHTML(t,e){if(this._editing&&this._htmlEditElement)return void this._editing.commit();if(!1===e)return;function i(e){t&&t(!e)}const n=this._node;n.getOuterHTML().then(this._startEditingAsHTML.bind(this,(function(t,e){t!==e&&n.setOuterHTML(e,i)}),(function(){t&&t(!1)})))}_copyCSSPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(cssPath(this._node,!0))}_copyJSPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(jsPath(this._node,!0))}_copyXPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(xPath(this._node,!0))}_copyFullXPath(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(xPath(this._node,!1))}async _copyStyles(){const t=this._node,e=t.domModel().cssModel(),i=await e.cachedMatchedCascadeForNode(t);if(!i)return;const n=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),s=[];for(const o of i.nodeStyles().reverse())for(const t of o.leadingProperties())t.parsedOk&&!t.disabled&&t.activeInStyle()&&!t.implicit&&(i.isInherited(o)&&!SDK.CSSMetadata.cssMetadata().isPropertyInherited(t.name)||o.parentRule&&o.parentRule.isUserAgent()||i.propertyState(t)===SDK.CSSMatchedStyles.PropertyState.Active&&s.push(`${n}${t.name}: ${t.value};`));Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(s.join("\n"))}_highlightSearchResults(){if(!this._searchQuery||!this._searchHighlightsVisible)return;this._hideSearchHighlight();const t=this.listItemElement.textContent||"",e=createPlainTextSearchRegex(this._searchQuery,"gi");let i=e.exec(t);const n=[];for(;i;)n.push(new TextUtils.TextRange.SourceRange(i.index,i[0].length)),i=e.exec(t);n.length||n.push(new TextUtils.TextRange.SourceRange(0,t.length)),this._highlightResult=[],UI.UIUtils.highlightSearchResults(this.listItemElement,n,this._highlightResult)}_editAsHTML(){Common.Revealer.reveal(this.node()).then((()=>{const t=UI.ActionRegistry.ActionRegistry.instance().action("elements.edit-as-html");if(t)return t.execute()}))}adornText(t,e){const i=document.createElement("span");i.textContent=t;const n=new Adorner;return n.data={name:t,content:i,category:e},this._adorners.push(n),ElementsPanel.instance().registerAdorner(n),this._updateAdorners(),n}removeAdorner(t){const e=this._adorners;ElementsPanel.instance().deregisterAdorner(t),t.remove();for(let i=0;i<e.length;++i)if(e[i]===t)return e.splice(i,1),void this._updateAdorners()}removeAllAdorners(){for(const t of this._adorners)ElementsPanel.instance().deregisterAdorner(t),t.remove();this._adorners=[],this._updateAdorners()}_updateAdorners(){this._adornersThrottler.schedule(this._updateAdornersInternal.bind(this))}_updateAdornersInternal(){const t=this._adornerContainer;if(!t)return Promise.resolve();const e=this._adorners;if(0===e.length)return t.classList.add("hidden"),Promise.resolve();e.sort(adornerComparator),t.removeChildren();for(const i of e)t.appendChild(i);return t.classList.remove("hidden"),Promise.resolve()}async updateStyleAdorners(){if(this._isClosingTag)return;const t=this.node(),e=t.id;if(t.nodeType()===Node.COMMENT_NODE||t.nodeType()===Node.DOCUMENT_FRAGMENT_NODE||void 0===e)return;const i=await t.domModel().cssModel().computedStylePromise(e);for(const l of this._styleAdorners)this.removeAdorner(l);if(this._styleAdorners=[],!i)return;const n=i.get("display"),s="grid"===n||"inline-grid"===n,o=Root.Runtime.experiments.isEnabled("cssFlexboxFeatures")&&("flex"===n||"inline-flex"===n);let r;s&&(r=this.createGridAdorner()),o&&(r=this.createFlexAdorner()),r&&this._styleAdorners.push(r)}createGridAdorner(){const t=this.node(),e=t.id;if(!e)return null;const i=this.adornText("grid","Layout");i.classList.add("grid");return i.addInteraction((()=>{i.isActive()?t.domModel().overlayModel().highlightGridInPersistentOverlay(e):t.domModel().overlayModel().hideGridInPersistentOverlay(e)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableGridMode),ariaLabelActive:i18nString(UIStrings.disableGridMode)}),t.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentGridOverlayStateChanged,(t=>{const{nodeId:n,enabled:s}=t.data;n===e&&i.toggle(s)})),i}createFlexAdorner(){const t=this.node(),e=t.id;if(!e)return null;const i=this.adornText("flex","Layout");i.classList.add("flex");return i.addInteraction((()=>{const n=t.domModel().overlayModel();i.isActive()?n.highlightFlexContainerInPersistentOverlay(e):n.hideFlexContainerInPersistentOverlay(e)}),{isToggle:!0,shouldPropagateOnKeydown:!1,ariaLabelDefault:i18nString(UIStrings.enableFlexMode),ariaLabelActive:i18nString(UIStrings.disableFlexMode)}),t.domModel().overlayModel().addEventListener(SDK.OverlayModel.Events.PersistentFlexContainerOverlayStateChanged,(t=>{const{nodeId:n,enabled:s}=t.data;n===e&&i.toggle(s)})),i}}export const InitialChildrenLimit=500;export const ForbiddenClosingTagElements=new Set(["area","base","basefont","br","canvas","col","command","embed","frame","hr","img","input","keygen","link","menuitem","meta","param","source","track","wbr"]);export const EditTagBlocklist=new Set(["html","head","body"]);const OrderedAdornerCategories=["Security","Layout","Default"],AdornerCategoryOrder=new Map(OrderedAdornerCategories.map(((t,e)=>[t,e+1])));function adornerComparator(t,e){const i=AdornerCategoryOrder.get(t.category)||Number.POSITIVE_INFINITY,n=AdornerCategoryOrder.get(e.category)||Number.POSITIVE_INFINITY;return i===n?t.name.localeCompare(e.name):i-n}export let EditorHandles;