import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as MobileThrottling from"../mobile_throttling/mobile_throttling.js";import*as Root from"../root/root.js";import*as UI from"../ui/ui.js";import{defaultMobileScaleFactor,DeviceModeModel,Type,UA}from"./DeviceModeModel.js";import{EmulatedDevice,EmulatedDevicesList,Events,Horizontal,Vertical}from"./EmulatedDevices.js";const UIStrings={width:"Width",heightLeaveEmptyForFull:"Height (leave empty for full)",zoom:"Zoom",devicePixelRatio:"Device pixel ratio",deviceType:"Device type",experimentalWebPlatformFeature:'"`Experimental Web Platform Feature`" flag is enabled. Click to disable it.',experimentalWebPlatformFeatureFlag:'"`Experimental Web Platform Feature`" flag is disabled. Click to enable it.',moreOptions:"More options",fitToWindowF:"Fit to window ({PH1}%%)",autoadjustZoom:"Auto-adjust zoom",defaultF:"Default: {PH1}",hideDeviceFrame:"Hide device frame",showDeviceFrame:"Show device frame",hideMediaQueries:"Hide media queries",showMediaQueries:"Show media queries",hideRulers:"Hide rulers",showRulers:"Show rulers",removeDevicePixelRatio:"Remove device pixel ratio",addDevicePixelRatio:"Add device pixel ratio",removeDeviceType:"Remove device type",addDeviceType:"Add device type",resetToDefaults:"Reset to defaults",closeDevtools:"Close DevTools",responsive:"Responsive",edit:"Edit\u2026",portrait:"Portrait",landscape:"Landscape",rotate:"Rotate",none:"None",screenOrientationOptions:"Screen orientation options",toggleDualscreenMode:"Toggle dual-screen mode"},str_=i18n.i18n.registerUIStrings("emulation/DeviceModeToolbar.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);function setTitleForButton(e,t){e.setTitle(t),e.element.title=t}export class DeviceModeToolbar{constructor(e,t,i){this._model=e;const o=e.device();o&&this._recordDeviceChange(o,null),this._showMediaInspectorSetting=t,this._showRulersSetting=i,this._experimentDualScreenSupport=Root.Runtime.experiments.isEnabled("dualScreenSupport"),this._deviceOutlineSetting=this._model.deviceOutlineSetting(),this._showDeviceScaleFactorSetting=Common.Settings.Settings.instance().createSetting("emulation.showDeviceScaleFactor",!1),this._showDeviceScaleFactorSetting.addChangeListener(this._updateDeviceScaleFactorVisibility,this),this._showUserAgentTypeSetting=Common.Settings.Settings.instance().createSetting("emulation.showUserAgentType",!1),this._showUserAgentTypeSetting.addChangeListener(this._updateUserAgentTypeVisibility,this),this._autoAdjustScaleSetting=Common.Settings.Settings.instance().createSetting("emulation.autoAdjustScale",!0),this._lastMode=new Map,this._element=document.createElement("div"),this._element.classList.add("device-mode-toolbar");const s=this._element.createChild("div","device-mode-toolbar-spacer");s.createChild("div","device-mode-toolbar-spacer");const n=new UI.Toolbar.Toolbar("",s);this._fillLeftToolbar(n);const a=new UI.Toolbar.Toolbar("",this._element);a.makeWrappable(),this._fillMainToolbar(a);const l=this._element.createChild("div","device-mode-toolbar-spacer"),r=new UI.Toolbar.Toolbar("device-mode-toolbar-fixed-size",l);r.makeWrappable(),this._fillRightToolbar(r);const d=new UI.Toolbar.Toolbar("device-mode-toolbar-fixed-size",l);d.makeWrappable(),this._fillModeToolbar(d),l.createChild("div","device-mode-toolbar-spacer");const c=new UI.Toolbar.Toolbar("device-mode-toolbar-options",l);function h(){const t=e.toolbarControlsEnabledSetting().get();n.setEnabled(t),a.setEnabled(t),r.setEnabled(t),d.setEnabled(t),c.setEnabled(t)}c.makeWrappable(),this._fillOptionsToolbar(c),this._emulatedDevicesList=EmulatedDevicesList.instance(),this._emulatedDevicesList.addEventListener(Events.CustomDevicesUpdated,this._deviceListChanged,this),this._emulatedDevicesList.addEventListener(Events.StandardDevicesUpdated,this._deviceListChanged,this),this._persistenceSetting=Common.Settings.Settings.instance().createSetting("emulation.deviceModeValue",{device:"",orientation:"",mode:""}),this._model.toolbarControlsEnabledSetting().addChangeListener(h),h(),this._spanButton,this._modeButton,this._widthInput,this._heightInput,this._deviceScaleItem,this._deviceSelectItem,this._scaleItem,this._uaItem,this._experimentalButton,this._cachedDeviceScale,this._cachedUaType,this._updateWidthInput}_recordDeviceChange(e,t){e!==t&&e&&e.isDualScreen&&Host.userMetrics.dualScreenDeviceEmulated(Host.UserMetrics.DualScreenDeviceEmulated.DualScreenDeviceSelected)}_createEmptyToolbarElement(){const e=document.createElement("div");return e.classList.add("device-mode-empty-toolbar-element"),e}_fillLeftToolbar(e){e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement())),this._deviceSelectItem=new UI.Toolbar.ToolbarMenuButton(this._appendDeviceMenuItems.bind(this)),this._deviceSelectItem.setGlyph(""),this._deviceSelectItem.turnIntoSelect(!0),this._deviceSelectItem.setDarkText(),e.appendToolbarItem(this._deviceSelectItem)}_fillMainToolbar(e){const t=UI.UIUtils.createInput("device-mode-size-input","text");t.maxLength=4,t.title=i18nString(UIStrings.width),this._updateWidthInput=UI.UIUtils.bindInput(t,this._applyWidth.bind(this),DeviceModeModel.widthValidator,!0),this._widthInput=t,this._widthItem=this._wrapToolbarItem(t),e.appendToolbarItem(this._widthItem);const i=document.createElement("div");i.classList.add("device-mode-x"),i.textContent="\xd7",this._xItem=this._wrapToolbarItem(i),e.appendToolbarItem(this._xItem);const o=UI.UIUtils.createInput("device-mode-size-input","text");o.maxLength=4,o.title=i18nString(UIStrings.heightLeaveEmptyForFull),this._updateHeightInput=UI.UIUtils.bindInput(o,this._applyHeight.bind(this),(function(e){if(!e)return{valid:!0,errorMessage:void 0};return DeviceModeModel.heightValidator(e)}),!0),this._heightInput=o,this._heightItem=this._wrapToolbarItem(o),e.appendToolbarItem(this._heightItem)}_applyWidth(e){const t=e?Number(e):0;this._model.setWidthAndScaleToFit(t)}_applyHeight(e){const t=e?Number(e):0;this._model.setHeightAndScaleToFit(t)}_fillRightToolbar(e){e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement())),this._scaleItem=new UI.Toolbar.ToolbarMenuButton(this._appendScaleMenuItems.bind(this)),setTitleForButton(this._scaleItem,i18nString(UIStrings.zoom)),this._scaleItem.setGlyph(""),this._scaleItem.turnIntoSelect(),this._scaleItem.setDarkText(),e.appendToolbarItem(this._scaleItem),e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement())),this._deviceScaleItem=new UI.Toolbar.ToolbarMenuButton(this._appendDeviceScaleMenuItems.bind(this)),this._deviceScaleItem.setVisible(this._showDeviceScaleFactorSetting.get()),setTitleForButton(this._deviceScaleItem,i18nString(UIStrings.devicePixelRatio)),this._deviceScaleItem.setGlyph(""),this._deviceScaleItem.turnIntoSelect(),this._deviceScaleItem.setDarkText(),e.appendToolbarItem(this._deviceScaleItem),e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement())),this._uaItem=new UI.Toolbar.ToolbarMenuButton(this._appendUserAgentMenuItems.bind(this)),this._uaItem.setVisible(this._showUserAgentTypeSetting.get()),setTitleForButton(this._uaItem,i18nString(UIStrings.deviceType)),this._uaItem.setGlyph(""),this._uaItem.turnIntoSelect(),this._uaItem.setDarkText(),e.appendToolbarItem(this._uaItem),this._throttlingConditionsItem=MobileThrottling.ThrottlingManager.throttlingManager().createMobileThrottlingButton(),e.appendToolbarItem(this._throttlingConditionsItem)}_fillModeToolbar(e){e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement())),this._modeButton=new UI.Toolbar.ToolbarButton("","largeicon-rotate-screen"),this._modeButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._modeMenuClicked,this),e.appendToolbarItem(this._modeButton),this._experimentDualScreenSupport&&(this._spanButton=new UI.Toolbar.ToolbarButton("","largeicon-dual-screen"),this._spanButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._spanClicked,this),e.appendToolbarItem(this._spanButton),this._createExperimentalButton(e))}_createExperimentalButton(e){e.appendToolbarItem(new UI.Toolbar.ToolbarSeparator(!0));const t=this._model.webPlatformExperimentalFeaturesEnabled()?i18nString(UIStrings.experimentalWebPlatformFeature):i18nString(UIStrings.experimentalWebPlatformFeatureFlag);this._experimentalButton=new UI.Toolbar.ToolbarToggle(t,"largeicon-experimental-api"),this._experimentalButton.setToggled(this._model.webPlatformExperimentalFeaturesEnabled()),this._experimentalButton.setEnabled(!0),this._experimentalButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._experimentalClicked,this),e.appendToolbarItem(this._experimentalButton)}_experimentalClicked(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab("chrome://flags/#enable-experimental-web-platform-features")}_fillOptionsToolbar(e){e.appendToolbarItem(this._wrapToolbarItem(this._createEmptyToolbarElement()));const t=new UI.Toolbar.ToolbarMenuButton(this._appendOptionsMenuItems.bind(this));setTitleForButton(t,i18nString(UIStrings.moreOptions)),e.appendToolbarItem(t)}_appendScaleMenuItems(e){this._model.type()===Type.Device&&e.footerSection().appendItem(i18nString(UIStrings.fitToWindowF,{PH1:100*this._model.fitScale()}),this._onScaleMenuChanged.bind(this,this._model.fitScale()),!1),e.footerSection().appendCheckboxItem(i18nString(UIStrings.autoadjustZoom),this._onAutoAdjustScaleChanged.bind(this),this._autoAdjustScaleSetting.get());const t=function(t,i){e.defaultSection().appendCheckboxItem(t,this._onScaleMenuChanged.bind(this,i),this._model.scaleSetting().get()===i,!1)}.bind(this);t("50%",.5),t("75%",.75),t("100%",1),t("125%",1.25),t("150%",1.5)}_onScaleMenuChanged(e){this._model.scaleSetting().set(e)}_onAutoAdjustScaleChanged(){this._autoAdjustScaleSetting.set(!this._autoAdjustScaleSetting.get())}_appendDeviceScaleMenuItems(e){const t=this._model.deviceScaleFactorSetting(),i=this._model.uaSetting().get()===UA.Mobile||this._model.uaSetting().get()===UA.MobileNoTouch?defaultMobileScaleFactor:window.devicePixelRatio;function o(e,i,o){e.appendCheckboxItem(i,t.set.bind(t,o),t.get()===o)}o(e.headerSection(),i18nString(UIStrings.defaultF,{PH:i}),0),o(e.defaultSection(),"1",1),o(e.defaultSection(),"2",2),o(e.defaultSection(),"3",3)}_appendUserAgentMenuItems(e){const t=this._model.uaSetting();function i(i,o){e.defaultSection().appendCheckboxItem(i,t.set.bind(t,o),t.get()===o)}i(UA.Mobile,UA.Mobile),i(UA.MobileNoTouch,UA.MobileNoTouch),i(UA.Desktop,UA.Desktop),i(UA.DesktopTouch,UA.DesktopTouch)}_appendOptionsMenuItems(e){const t=this._model;function i(e,i,o,s,n){"undefined"===typeof n&&(n=t.type()===Type.None),e.appendItem(i.get()?o:s,i.set.bind(i,!i.get()),n)}i(e.headerSection(),this._deviceOutlineSetting,i18nString(UIStrings.hideDeviceFrame),i18nString(UIStrings.showDeviceFrame),t.type()!==Type.Device),i(e.headerSection(),this._showMediaInspectorSetting,i18nString(UIStrings.hideMediaQueries),i18nString(UIStrings.showMediaQueries)),i(e.headerSection(),this._showRulersSetting,i18nString(UIStrings.hideRulers),i18nString(UIStrings.showRulers)),i(e.defaultSection(),this._showDeviceScaleFactorSetting,i18nString(UIStrings.removeDevicePixelRatio),i18nString(UIStrings.addDevicePixelRatio)),i(e.defaultSection(),this._showUserAgentTypeSetting,i18nString(UIStrings.removeDeviceType),i18nString(UIStrings.addDeviceType)),e.appendItemsAtLocation("deviceModeMenu"),e.footerSection().appendItem(i18nString(UIStrings.resetToDefaults),this._reset.bind(this)),e.footerSection().appendItem(i18nString(UIStrings.closeDevtools),Host.InspectorFrontendHost.InspectorFrontendHostInstance.closeWindow.bind(Host.InspectorFrontendHost.InspectorFrontendHostInstance))}_reset(){this._deviceOutlineSetting.set(!1),this._showDeviceScaleFactorSetting.set(!1),this._showUserAgentTypeSetting.set(!1),this._showMediaInspectorSetting.set(!1),this._showRulersSetting.set(!1),this._model.reset()}_wrapToolbarItem(e){const t=document.createElement("div");return UI.Utils.createShadowRootWithCoreStyles(t,{cssFile:"emulation/deviceModeToolbar.css",enableLegacyPatching:!0,delegatesFocus:void 0}).appendChild(e),new UI.Toolbar.ToolbarItem(t)}_emulateDevice(e){const t=this._autoAdjustScaleSetting.get()?void 0:this._model.scaleSetting().get();this._recordDeviceChange(e,this._model.device()),this._model.emulate(Type.Device,e,this._lastMode.get(e)||e.modes[0],t)}_switchToResponsive(){this._model.emulate(Type.Responsive,null,null)}_filterDevices(e){return(e=e.filter((function(e){return e.show()}))).sort(EmulatedDevice.deviceComparator),e}_standardDevices(){return this._filterDevices(this._emulatedDevicesList.standard())}_customDevices(){return this._filterDevices(this._emulatedDevicesList.custom())}_allDevices(){return this._standardDevices().concat(this._customDevices())}_appendDeviceMenuItems(e){function t(t){if(!t.length)return;const i=e.section();for(const e of t)i.appendCheckboxItem(e.title,this._emulateDevice.bind(this,e),this._model.device()===e,!1)}e.headerSection().appendCheckboxItem(i18nString(UIStrings.responsive),this._switchToResponsive.bind(this),this._model.type()===Type.Responsive,!1),t.call(this,this._standardDevices()),t.call(this,this._customDevices()),e.footerSection().appendItem(i18nString(UIStrings.edit),this._emulatedDevicesList.revealCustomSetting.bind(this._emulatedDevicesList),!1)}_deviceListChanged(){const e=this._model.device();if(!e)return;const t=this._allDevices();-1===t.indexOf(e)?t.length?this._emulateDevice(t[0]):this._model.emulate(Type.Responsive,null,null):this._emulateDevice(e)}_updateDeviceScaleFactorVisibility(){this._deviceScaleItem&&this._deviceScaleItem.setVisible(this._showDeviceScaleFactorSetting.get())}_updateUserAgentTypeVisibility(){this._uaItem&&this._uaItem.setVisible(this._showUserAgentTypeSetting.get())}_spanClicked(e){const t=this._model.device();if(!t||!t.isDualScreen)return;Host.userMetrics.dualScreenDeviceEmulated(Host.UserMetrics.DualScreenDeviceEmulated.SpanButtonClicked);const i=this._autoAdjustScaleSetting.get()?void 0:this._model.scaleSetting().get(),o=this._model.mode();if(!o)return;const s=t.getSpanPartner(o);s&&this._model.emulate(this._model.type(),t,s,i)}_modeMenuClicked(e){const t=this._model.device(),i=this._model,o=this._autoAdjustScaleSetting;if(i.type()===Type.Responsive){const e=i.appliedDeviceSize();return void(o.get()?i.setSizeAndScaleToFit(e.height,e.width):(i.setWidth(e.height),i.setHeight(e.width)))}if(!t)return;if((t.isDualScreen||2===t.modes.length)&&t.modes[0].orientation!==t.modes[1].orientation){const e=o.get()?void 0:i.scaleSetting().get(),s=i.mode();if(!s)return;const n=t.getRotationPartner(s);if(!n)return;return void i.emulate(i.type(),i.device(),n,e)}if(!this._modeButton)return;const s=new UI.ContextMenu.ContextMenu(e.data,!1,this._modeButton.element.totalOffsetLeft(),this._modeButton.element.totalOffsetTop()+this._modeButton.element.offsetHeight);function n(e,i){if(!t)return;const o=t.modesForOrientation(e);if(o.length)if(1===o.length)a(o[0],i);else for(let t=0;t<o.length;t++)a(o[t],i+" \u2013 "+o[t].title)}function a(e,t){s.defaultSection().appendCheckboxItem(t,l.bind(null,e),i.mode()===e,!1)}function l(e){const t=o.get()?void 0:i.scaleSetting().get();i.emulate(i.type(),i.device(),e,t)}n(Vertical,i18nString(UIStrings.portrait)),n(Horizontal,i18nString(UIStrings.landscape)),s.show()}element(){return this._element}update(){this._model.type()!==this._cachedModelType&&(this._cachedModelType=this._model.type(),this._widthInput.disabled=this._model.type()!==Type.Responsive,this._heightInput.disabled=this._model.type()!==Type.Responsive,this._deviceScaleItem.setEnabled(this._model.type()===Type.Responsive),this._uaItem.setEnabled(this._model.type()===Type.Responsive),this._model.type()===Type.Responsive?(this._modeButton.setEnabled(!0),setTitleForButton(this._modeButton,i18nString(UIStrings.rotate))):this._modeButton.setEnabled(!1));const e=this._model.appliedDeviceSize();this._updateHeightInput&&this._updateHeightInput(this._model.type()===Type.Responsive&&this._model.isFullHeight()?"":String(e.height)),this._updateWidthInput(String(e.width)),this._heightInput.placeholder=String(e.height),this._model.scale()!==this._cachedScale&&(this._scaleItem.setText(`${(100*this._model.scale()).toFixed(0)}%`),this._cachedScale=this._model.scale());const t=this._model.appliedDeviceScaleFactor();t!==this._cachedDeviceScale&&(this._deviceScaleItem.setText(`DPR: ${t.toFixed(1)}`),this._cachedDeviceScale=t);const i=this._model.appliedUserAgentType();i!==this._cachedUaType&&(this._uaItem.setText(i),this._cachedUaType=i);let o=i18nString(UIStrings.none);this._model.type()===Type.Responsive&&(o=i18nString(UIStrings.responsive));const s=this._model.device();if(this._model.type()===Type.Device&&s&&(o=s.title),this._deviceSelectItem.setText(o),this._model.device()!==this._cachedModelDevice){const e=this._model.device();if(e){const t=e?e.modes.length:0;this._modeButton.setEnabled(t>=2),setTitleForButton(this._modeButton,i18nString(2===t?UIStrings.rotate:UIStrings.screenOrientationOptions))}this._cachedModelDevice=e}if(this._experimentDualScreenSupport&&this._experimentalButton){const e=this._model.device();e&&e.isDualScreen?(this._spanButton.setVisible(!0),this._experimentalButton.setVisible(!0)):(this._spanButton.setVisible(!1),this._experimentalButton.setVisible(!1)),setTitleForButton(this._spanButton,i18nString(UIStrings.toggleDualscreenMode))}if(this._model.type()===Type.Device&&this._lastMode.set(this._model.device(),this._model.mode()),this._model.mode()!==this._cachedModelMode&&this._model.type()!==Type.None){this._cachedModelMode=this._model.mode();const e=this._persistenceSetting.get(),t=this._model.device();if(t){e.device=t.title;const i=this._model.mode();e.orientation=i?i.orientation:"",e.mode=i?i.title:""}else e.device="",e.orientation="",e.mode="";this._persistenceSetting.set(e)}}restore(){for(const e of this._allDevices())if(e.title===this._persistenceSetting.get().device)for(const t of e.modes)if(t.orientation===this._persistenceSetting.get().orientation&&t.title===this._persistenceSetting.get().mode)return this._lastMode.set(e,t),void this._emulateDevice(e);this._model.emulate(Type.Responsive,null,null)}}