import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as UI from"../ui/ui.js";import{DeviceModeModel,Events,MaxDeviceSize,MinDeviceSize,Type}from"./DeviceModeModel.js";import{DeviceModeToolbar}from"./DeviceModeToolbar.js";import{MediaQueryInspector}from"./MediaQueryInspector.js";const UIStrings={doubleclickForFullHeight:"Double-click for full height",mobileS:"Mobile S",mobileM:"Mobile M",mobileL:"Mobile L",tablet:"Tablet",laptop:"Laptop",laptopL:"Laptop L"},str_=i18n.i18n.registerUIStrings("emulation/DeviceModeView.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class DeviceModeView extends UI.Widget.VBox{constructor(){super(!0),this.wrapperInstance,this.blockElementToWidth=new WeakMap,this.setMinimumSize(150,150),this.element.classList.add("device-mode-view"),this.registerRequiredCSS("emulation/deviceModeView.css",{enableLegacyPatching:!0}),UI.Tooltip.Tooltip.addNativeOverrideContainer(this.contentElement),this._model=DeviceModeModel.instance(),this._model.addEventListener(Events.Updated,this._updateUI,this),this._mediaInspector=new MediaQueryInspector((()=>this._model.appliedDeviceSize().width),this._model.setWidth.bind(this._model)),this._showMediaInspectorSetting=Common.Settings.Settings.instance().moduleSetting("showMediaQueryInspector"),this._showMediaInspectorSetting.addChangeListener(this._updateUI,this),this._showRulersSetting=Common.Settings.Settings.instance().moduleSetting("emulation.showRulers"),this._showRulersSetting.addChangeListener(this._updateUI,this),this._topRuler=new Ruler(!0,this._model.setWidthAndScaleToFit.bind(this._model)),this._topRuler.element.classList.add("device-mode-ruler-top"),this._leftRuler=new Ruler(!1,this._model.setHeightAndScaleToFit.bind(this._model)),this._leftRuler.element.classList.add("device-mode-ruler-left"),this._createUI(),UI.ZoomManager.ZoomManager.instance().addEventListener(UI.ZoomManager.Events.ZoomChanged,this._zoomChanged,this),this._presetBlocks,this._responsivePresetsContainer,this._screenArea,this._pageArea,this._outlineImage,this._contentClip,this._contentArea,this._rightResizerElement,this._leftResizerElement,this._bottomResizerElement,this._bottomRightResizerElement,this._bottomLeftResizerElement,this._cachedResizable,this._mediaInspectorContainer,this._screenImage,this._toolbar}_createUI(){this._toolbar=new DeviceModeToolbar(this._model,this._showMediaInspectorSetting,this._showRulersSetting),this.contentElement.appendChild(this._toolbar.element()),this._contentClip=this.contentElement.createChild("div","device-mode-content-clip vbox"),this._responsivePresetsContainer=this._contentClip.createChild("div","device-mode-presets-container"),this._populatePresetsContainer(),this._mediaInspectorContainer=this._contentClip.createChild("div","device-mode-media-container"),this._contentArea=this._contentClip.createChild("div","device-mode-content-area"),this._outlineImage=this._contentArea.createChild("img","device-mode-outline-image hidden fill"),this._outlineImage.addEventListener("load",this._onImageLoaded.bind(this,this._outlineImage,!0),!1),this._outlineImage.addEventListener("error",this._onImageLoaded.bind(this,this._outlineImage,!1),!1),this._screenArea=this._contentArea.createChild("div","device-mode-screen-area"),this._screenImage=this._screenArea.createChild("img","device-mode-screen-image hidden"),this._screenImage.addEventListener("load",this._onImageLoaded.bind(this,this._screenImage,!0),!1),this._screenImage.addEventListener("error",this._onImageLoaded.bind(this,this._screenImage,!1),!1),this._bottomRightResizerElement=this._screenArea.createChild("div","device-mode-resizer device-mode-bottom-right-resizer"),this._bottomRightResizerElement.createChild("div",""),this._createResizer(this._bottomRightResizerElement,2,1),this._bottomLeftResizerElement=this._screenArea.createChild("div","device-mode-resizer device-mode-bottom-left-resizer"),this._bottomLeftResizerElement.createChild("div",""),this._createResizer(this._bottomLeftResizerElement,-2,1),this._rightResizerElement=this._screenArea.createChild("div","device-mode-resizer device-mode-right-resizer"),this._rightResizerElement.createChild("div",""),this._createResizer(this._rightResizerElement,2,0),this._leftResizerElement=this._screenArea.createChild("div","device-mode-resizer device-mode-left-resizer"),this._leftResizerElement.createChild("div",""),this._createResizer(this._leftResizerElement,-2,0),this._bottomResizerElement=this._screenArea.createChild("div","device-mode-resizer device-mode-bottom-resizer"),this._bottomResizerElement.createChild("div",""),this._createResizer(this._bottomResizerElement,0,1),this._bottomResizerElement.addEventListener("dblclick",this._model.setHeight.bind(this._model,0),!1),UI.Tooltip.Tooltip.install(this._bottomResizerElement,i18nString(UIStrings.doubleclickForFullHeight)),this._pageArea=this._screenArea.createChild("div","device-mode-page-area"),this._pageArea.createChild("slot")}_populatePresetsContainer(){const e=[320,375,425,768,1024,1440,2560],t=[i18nString(UIStrings.mobileS),i18nString(UIStrings.mobileM),i18nString(UIStrings.mobileL),i18nString(UIStrings.tablet),i18nString(UIStrings.laptop),i18nString(UIStrings.laptopL),"4K"];this._presetBlocks=[];const i=this._responsivePresetsContainer.createChild("div","device-mode-presets-container-inner");for(let o=e.length-1;o>=0;--o){const n=i.createChild("div","fill device-mode-preset-bar-outer").createChild("div","device-mode-preset-bar");n.createChild("span").textContent=t[o]+" \u2013 "+e[o]+"px",n.addEventListener("click",s.bind(this,e[o]),!1),this.blockElementToWidth.set(n,e[o]),this._presetBlocks.push(n)}function s(e,t){this._model.emulate(Type.Responsive,null,null),this._model.setWidthAndScaleToFit(e),t.consume()}}_createResizer(e,t,i){const s=new UI.ResizerWidget.ResizerWidget;s.addElement(e);let o=t?"ew-resize":"ns-resize";return t*i>0&&(o="nwse-resize"),t*i<0&&(o="nesw-resize"),s.setCursor(o),s.addEventListener(UI.ResizerWidget.Events.ResizeStart,this._onResizeStart,this),s.addEventListener(UI.ResizerWidget.Events.ResizeUpdate,this._onResizeUpdate.bind(this,t,i)),s.addEventListener(UI.ResizerWidget.Events.ResizeEnd,this._onResizeEnd,this),s}_onResizeStart(e){this._slowPositionStart=null,this._resizeStart=this._model.screenRect().size()}_onResizeUpdate(e,t,i){i.data.shiftKey!==Boolean(this._slowPositionStart)&&(this._slowPositionStart=i.data.shiftKey?{x:i.data.currentX,y:i.data.currentY}:null);let s=i.data.currentX-i.data.startX,o=i.data.currentY-i.data.startY;if(this._slowPositionStart&&(s=(i.data.currentX-this._slowPositionStart.x)/10+this._slowPositionStart.x-i.data.startX,o=(i.data.currentY-this._slowPositionStart.y)/10+this._slowPositionStart.y-i.data.startY),e&&this._resizeStart){const t=s*UI.ZoomManager.ZoomManager.instance().zoomFactor();let i=this._resizeStart.width+t*e;i=Math.round(i/this._model.scale()),i>=MinDeviceSize&&i<=MaxDeviceSize&&this._model.setWidth(i)}if(t&&this._resizeStart){const e=o*UI.ZoomManager.ZoomManager.instance().zoomFactor();let i=this._resizeStart.height+e*t;i=Math.round(i/this._model.scale()),i>=MinDeviceSize&&i<=MaxDeviceSize&&this._model.setHeight(i)}}exitHingeMode(){this._model&&this._model.exitHingeMode()}_onResizeEnd(e){delete this._resizeStart,Host.userMetrics.actionTaken(Host.UserMetrics.Action.ResizedViewInResponsiveMode)}_updateUI(){function e(e,t){e.style.left=t.left+"px",e.style.top=t.top+"px",e.style.width=t.width+"px",e.style.height=t.height+"px"}if(!this.isShowing())return;const t=UI.ZoomManager.ZoomManager.instance().zoomFactor();let i=!1;const s=this._showRulersSetting.get()&&this._model.type()!==Type.None;let o=!1,n=!1;const r=this._model.screenRect().scale(1/t);this._cachedCssScreenRect&&r.isEqual(this._cachedCssScreenRect)||(e(this._screenArea,r),n=!0,i=!0,this._cachedCssScreenRect=r);const a=this._model.visiblePageRect().scale(1/t);this._cachedCssVisiblePageRect&&a.isEqual(this._cachedCssVisiblePageRect)||(e(this._pageArea,a),i=!0,this._cachedCssVisiblePageRect=a);const h=this._model.outlineRect();if(h){const s=h.scale(1/t);this._cachedOutlineRect&&s.isEqual(this._cachedOutlineRect)||(e(this._outlineImage,s),i=!0,this._cachedOutlineRect=s)}this._contentClip.classList.toggle("device-mode-outline-visible",Boolean(this._model.outlineImage()));const l=this._model.type()===Type.Responsive;l!==this._cachedResizable&&(this._rightResizerElement.classList.toggle("hidden",!l),this._leftResizerElement.classList.toggle("hidden",!l),this._bottomResizerElement.classList.toggle("hidden",!l),this._bottomRightResizerElement.classList.toggle("hidden",!l),this._bottomLeftResizerElement.classList.toggle("hidden",!l),this._cachedResizable=l);const d=this._showMediaInspectorSetting.get()&&this._model.type()!==Type.None;if(d!==this._cachedMediaInspectorVisible&&(d?this._mediaInspector.show(this._mediaInspectorContainer):this._mediaInspector.detach(),o=!0,i=!0,this._cachedMediaInspectorVisible=d),s!==this._cachedShowRulers&&(this._contentClip.classList.toggle("device-mode-rulers-visible",s),s?(this._topRuler.show(this._contentArea),this._leftRuler.show(this._contentArea)):(this._topRuler.detach(),this._leftRuler.detach()),o=!0,i=!0,this._cachedShowRulers=s),this._model.scale()!==this._cachedScale){n=!0,i=!0;for(const e of this._presetBlocks){const t=this.blockElementToWidth.get(e);if(!t)throw new Error("Could not get width for block.");e.style.width=t*this._model.scale()+"px"}this._cachedScale=this._model.scale()}this._toolbar.update(),this._loadImage(this._screenImage,this._model.screenImage()),this._loadImage(this._outlineImage,this._model.outlineImage()),this._mediaInspector.setAxisTransform(this._model.scale()),i&&this.doResize(),n&&(this._topRuler.render(this._model.scale()),this._leftRuler.render(this._model.scale()),this._topRuler.element.positionAt(this._cachedCssScreenRect?this._cachedCssScreenRect.left:0,this._cachedCssScreenRect?this._cachedCssScreenRect.top:0),this._leftRuler.element.positionAt(this._cachedCssScreenRect?this._cachedCssScreenRect.left:0,this._cachedCssScreenRect?this._cachedCssScreenRect.top:0)),o&&this._contentAreaResized()}_loadImage(e,t){e.getAttribute("srcset")!==t&&(e.setAttribute("srcset",t),t||e.classList.toggle("hidden",!0))}_onImageLoaded(e,t){e.classList.toggle("hidden",!t)}setNonEmulatedAvailableSize(e){if(this._model.type()!==Type.None)return;const t=UI.ZoomManager.ZoomManager.instance().zoomFactor(),i=e.getBoundingClientRect(),s=new UI.Geometry.Size(Math.max(i.width*t,1),Math.max(i.height*t,1));this._model.setAvailableSize(s,s)}_contentAreaResized(){const e=UI.ZoomManager.ZoomManager.instance().zoomFactor(),t=this._contentArea.getBoundingClientRect(),i=new UI.Geometry.Size(Math.max(t.width*e,1),Math.max(t.height*e,1)),s=new UI.Geometry.Size(Math.max((t.width-2*(this._handleWidth||0))*e,1),Math.max((t.height-(this._handleHeight||0))*e,1));this._model.setAvailableSize(i,s)}_measureHandles(){const e=this._rightResizerElement.classList.contains("hidden");this._rightResizerElement.classList.toggle("hidden",!1),this._bottomResizerElement.classList.toggle("hidden",!1),this._handleWidth=this._rightResizerElement.offsetWidth,this._handleHeight=this._bottomResizerElement.offsetHeight,this._rightResizerElement.classList.toggle("hidden",e),this._bottomResizerElement.classList.toggle("hidden",e)}_zoomChanged(){delete this._handleWidth,delete this._handleHeight,this.isShowing()&&(this._measureHandles(),this._contentAreaResized())}onResize(){this.isShowing()&&this._contentAreaResized()}wasShown(){this._measureHandles(),this._toolbar.restore()}willHide(){this._model.emulate(Type.None,null,null)}async captureScreenshot(){const e=await this._model.captureScreenshot(!1);if(null===e)return;const t=new Image;t.src="data:image/png;base64,"+e,t.onload=async()=>{const e=t.naturalWidth/this._model.screenRect().width,i=this._model.outlineRect();if(!i)throw new Error("Unable to take screenshot: no outlineRect available.");const s=i.scale(e),o=this._model.screenRect().scale(e),n=this._model.visiblePageRect().scale(e),r=o.left+n.left-s.left,a=o.top+n.top-s.top,h=document.createElement("canvas");h.width=Math.floor(s.width),h.height=Math.floor(s.height);const l=h.getContext("2d");if(!l)throw new Error("Could not get 2d context from canvas.");l.imageSmoothingEnabled=!1,this._model.outlineImage()&&await this._paintImage(l,this._model.outlineImage(),s.relativeTo(s)),this._model.screenImage()&&await this._paintImage(l,this._model.screenImage(),o.relativeTo(s)),l.drawImage(t,Math.floor(r),Math.floor(a)),this._saveScreenshot(h)}}async captureFullSizeScreenshot(){const e=await this._model.captureScreenshot(!0);if(null!==e)return this._saveScreenshotBase64(e)}async captureAreaScreenshot(e){const t=await this._model.captureScreenshot(!1,e);if(null!==t)return this._saveScreenshotBase64(t)}_saveScreenshotBase64(e){const t=new Image;t.src="data:image/png;base64,"+e,t.onload=()=>{const e=document.createElement("canvas");e.width=t.naturalWidth,e.height=t.naturalHeight;const i=e.getContext("2d");if(!i)throw new Error("Could not get 2d context for base64 screenshot.");i.imageSmoothingEnabled=!1,i.drawImage(t,0,0),this._saveScreenshot(e)}}_paintImage(e,t,i){return new Promise((s=>{const o=new Image;o.crossOrigin="Anonymous",o.srcset=t,o.onerror=()=>s(),o.onload=()=>{e.drawImage(o,i.left,i.top,i.width,i.height),s()}}))}_saveScreenshot(e){const t=this._model.inspectedURL();let i="";if(t){const e=Platform.StringUtilities.removeURLFragment(t);i=Platform.StringUtilities.trimURL(e)}const s=this._model.device();s&&this._model.type()===Type.Device&&(i+=`(${s.title})`);const o=document.createElement("a");o.download=i+".png",e.toBlob((e=>{o.href=URL.createObjectURL(e),o.click()}))}}export class Ruler extends UI.Widget.VBox{constructor(e,t){super(),this.element.classList.add("device-mode-ruler"),this._contentElement=this.element.createChild("div","device-mode-ruler-content").createChild("div","device-mode-ruler-inner"),this._horizontal=e,this._scale=1,this._count=0,this._throttler=new Common.Throttler.Throttler(0),this._applyCallback=t,this._renderedScale,this._renderedZoomFactor}render(e){this._scale=e,this._throttler.schedule(this._update.bind(this))}onResize(){this._throttler.schedule(this._update.bind(this))}_update(){const e=UI.ZoomManager.ZoomManager.instance().zoomFactor(),t=this._horizontal?this._contentElement.offsetWidth:this._contentElement.offsetHeight;this._scale===this._renderedScale&&e===this._renderedZoomFactor||(this._contentElement.removeChildren(),this._count=0,this._renderedScale=this._scale,this._renderedZoomFactor=e);const i=t*e/this._scale,s=Math.ceil(i/5);let o=1;this._scale<.8&&(o=2),this._scale<.6&&(o=4),this._scale<.4&&(o=8),this._scale<.2&&(o=16),this._scale<.1&&(o=32);for(let n=s;n<this._count;n++)if(!(n%o)){const e=this._contentElement.lastChild;e&&e.remove()}for(let n=this._count;n<s;n++){if(n%o)continue;const t=this._contentElement.createChild("div","device-mode-ruler-marker");if(n&&(this._horizontal?t.style.left=5*n*this._scale/e+"px":t.style.top=5*n*this._scale/e+"px",!(n%20))){const e=t.createChild("div","device-mode-ruler-text");e.textContent=String(5*n),e.addEventListener("click",this._onMarkerClick.bind(this,5*n),!1)}n%10?n%5||t.classList.add("device-mode-ruler-marker-medium"):t.classList.add("device-mode-ruler-marker-large")}return this._count=s,Promise.resolve()}_onMarkerClick(e){this._applyCallback.call(null,e)}}