import*as i18n from"../i18n/i18n.js";import*as UI from"../ui/ui.js";import{DeviceModeModel,MaxDeviceNameLength,UA}from"./DeviceModeModel.js";import{Capability,EmulatedDevice,EmulatedDevicesList,Events,Horizontal,Vertical}from"./EmulatedDevices.js";import{parseBrandsList,serializeBrandsList,validateAsStructuredHeadersString}from"./UserAgentMetadata.js";let devicesSettingsTabInstance;const UIStrings={emulatedDevices:"Emulated Devices",addCustomDevice:"Add custom device...",device:"Device",deviceName:"Device Name",width:"Width",height:"Height",devicePixelRatio:"Device pixel ratio",UABrands:'UA brands list (e.g. "Chromium";v="87")',userAgentClient:"User agent client hints",userAgentClientHintsAre:"User agent client hints are an alternative to the user agent string that identify the browser and the device in a more structured way with better privacy accounting. Click the button to learn more.",userAgentString:"User agent string",userAgentType:"User agent type",deviceNameMustBeLessThanS:"Device name must be less than {PH1} characters.",deviceNameCannotBeEmpty:"Device name cannot be empty.",fullBrowserVersion:"Full browser version (e.g. 87.0.4280.88)",platform:"Platform (e.g. Android)",platformVersion:"Platform version",architecture:"Architecture (e.g. x86)",deviceModel:"Device model",notRepresentable:"Not representable as structured headers string.",brandsList:"Brands list is not a valid structured fields list.",brandsListMust:"Brands list must consist of strings, each with a v parameter with a string value."},str_=i18n.i18n.registerUIStrings("emulation/DevicesSettingsTab.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class DevicesSettingsTab extends UI.Widget.VBox{constructor(){super(),this.element.classList.add("settings-tab-container"),this.element.classList.add("devices-settings-tab"),this.registerRequiredCSS("emulation/devicesSettingsTab.css",{enableLegacyPatching:!0});const e=this.element.createChild("header");UI.UIUtils.createTextChild(e.createChild("h1"),i18nString(UIStrings.emulatedDevices)),this.containerElement=this.element.createChild("div","settings-container-wrapper").createChild("div","settings-tab settings-content settings-container");const t=this.containerElement.createChild("div","devices-button-row");this._addCustomButton=UI.UIUtils.createTextButton(i18nString(UIStrings.addCustomDevice),this._addCustomDevice.bind(this)),this._addCustomButton.id="custom-device-add-button",t.appendChild(this._addCustomButton),this._list=new UI.ListWidget.ListWidget(this,!1),this._list.registerRequiredCSS("emulation/devicesSettingsTab.css",{enableLegacyPatching:!0}),this._list.element.classList.add("devices-list"),this._list.show(this.containerElement),this._muteUpdate=!1,this._emulatedDevicesList=EmulatedDevicesList.instance(),this._emulatedDevicesList.addEventListener(Events.CustomDevicesUpdated,this._devicesUpdated,this),this._emulatedDevicesList.addEventListener(Events.StandardDevicesUpdated,this._devicesUpdated,this),this.setDefaultFocusedElement(this._addCustomButton)}static instance(){return devicesSettingsTabInstance||(devicesSettingsTabInstance=new DevicesSettingsTab),devicesSettingsTabInstance}wasShown(){super.wasShown(),this._devicesUpdated()}_devicesUpdated(){if(this._muteUpdate)return;this._list.clear();let e=this._emulatedDevicesList.custom().slice();for(let t=0;t<e.length;++t)this._list.appendItem(e[t],!0);this._list.appendSeparator(),e=this._emulatedDevicesList.standard().slice(),e.sort(EmulatedDevice.deviceComparator);for(let t=0;t<e.length;++t)this._list.appendItem(e[t],!1)}_muteAndSaveDeviceList(e){this._muteUpdate=!0,e?this._emulatedDevicesList.saveCustomDevices():this._emulatedDevicesList.saveStandardDevices(),this._muteUpdate=!1}_addCustomDevice(){const e=new EmulatedDevice;e.deviceScaleFactor=0,e.horizontal.width=700,e.horizontal.height=400,e.vertical.width=400,e.vertical.height=700,this._list.addNewItem(this._emulatedDevicesList.custom().length,e)}_toNumericInputValue(e){return e?String(e):""}renderItem(e,t){const i=document.createElement("label");i.classList.add("devices-list-item");const s=i.createChild("input","devices-list-checkbox");s.type="checkbox",s.checked=e.show(),s.addEventListener("click",function(i){const n=s.checked;e.setShow(n),this._muteAndSaveDeviceList(t),i.consume()}.bind(this),!1);const n=document.createElement("span");return n.classList.add("device-name"),n.appendChild(document.createTextNode(e.title)),i.appendChild(n),i}removeItemRequested(e,t){this._emulatedDevicesList.removeCustomDevice(e)}commitEdit(e,t,i){e.title=t.control("title").value.trim(),e.vertical.width=t.control("width").value?parseInt(t.control("width").value,10):0,e.vertical.height=t.control("height").value?parseInt(t.control("height").value,10):0,e.horizontal.width=e.vertical.height,e.horizontal.height=e.vertical.width,e.deviceScaleFactor=t.control("scale").value?parseFloat(t.control("scale").value):0,e.userAgent=t.control("user-agent").value,e.modes=[],e.modes.push({title:"",orientation:Vertical,insets:new UI.Geometry.Insets(0,0,0,0),image:null}),e.modes.push({title:"",orientation:Horizontal,insets:new UI.Geometry.Insets(0,0,0,0),image:null}),e.capabilities=[];const s=t.control("ua-type").value;s!==UA.Mobile&&s!==UA.MobileNoTouch||e.capabilities.push(Capability.Mobile),s!==UA.Mobile&&s!==UA.DesktopTouch||e.capabilities.push(Capability.Touch);const n=parseBrandsList(t.control("brands").value.trim(),"unused_err1","unused_err2");e.userAgentMetadata={brands:"string"===typeof n?[]:n,fullVersion:t.control("full-version").value.trim(),platform:t.control("platform").value.trim(),platformVersion:t.control("platform-version").value.trim(),architecture:t.control("arch").value.trim(),model:t.control("model").value.trim(),mobile:s===UA.Mobile||s===UA.MobileNoTouch},i?this._emulatedDevicesList.addCustomDevice(e):this._emulatedDevicesList.saveCustomDevices(),this._addCustomButton.scrollIntoViewIfNeeded(),this._addCustomButton.focus()}beginEdit(e){const t=this._createEditor();let i;return t.control("title").value=e.title,t.control("width").value=this._toNumericInputValue(e.vertical.width),t.control("height").value=this._toNumericInputValue(e.vertical.height),t.control("scale").value=this._toNumericInputValue(e.deviceScaleFactor),t.control("user-agent").value=e.userAgent,i=e.mobile()?e.touch()?UA.Mobile:UA.MobileNoTouch:e.touch()?UA.DesktopTouch:UA.Desktop,t.control("ua-type").value=i,e.userAgentMetadata&&(t.control("brands").value=serializeBrandsList(e.userAgentMetadata.brands||[]),t.control("full-version").value=e.userAgentMetadata.fullVersion||"",t.control("platform").value=e.userAgentMetadata.platform,t.control("platform-version").value=e.userAgentMetadata.platformVersion,t.control("arch").value=e.userAgentMetadata.architecture,t.control("model").value=e.userAgentMetadata.model),t}_createEditor(){if(this._editor)return this._editor;const e=new UI.ListWidget.Editor;this._editor=e;const t=e.contentElement(),i=t.createChild("div","devices-edit-fields");UI.UIUtils.createTextChild(i.createChild("b"),i18nString(UIStrings.device));const s=e.createInput("title","text",i18nString(UIStrings.deviceName),(function(e,t,i){let s,n=!1;const a=i.value.trim();a.length>=MaxDeviceNameLength?s=i18nString(UIStrings.deviceNameMustBeLessThanS,{PH1:MaxDeviceNameLength}):0===a.length?s=i18nString(UIStrings.deviceNameCannotBeEmpty):n=!0;return{valid:n,errorMessage:s}}));i.createChild("div","hbox").appendChild(s),s.id="custom-device-name-field";const n=i.createChild("div","hbox");n.appendChild(e.createInput("width","text",i18nString(UIStrings.width),(function(e,t,i){return DeviceModeModel.widthValidator(i.value)}))),n.appendChild(e.createInput("height","text",i18nString(UIStrings.height),(function(e,t,i){return DeviceModeModel.heightValidator(i.value)})));const a=e.createInput("scale","text",i18nString(UIStrings.devicePixelRatio),(function(e,t,i){return DeviceModeModel.scaleValidator(i.value)}));a.classList.add("device-edit-fixed"),n.appendChild(a);const r=t.createChild("div","devices-edit-fields");UI.UIUtils.createTextChild(r.createChild("b"),i18nString(UIStrings.userAgentString));const d=r.createChild("div","hbox");d.appendChild(e.createInput("user-agent","text",i18nString(UIStrings.userAgentString),(()=>({valid:!0,errorMessage:void 0}))));const l=[UA.Mobile,UA.MobileNoTouch,UA.Desktop,UA.DesktopTouch],o=e.createSelect("ua-type",l,(()=>({valid:!0,errorMessage:void 0})),i18nString(UIStrings.userAgentType));o.classList.add("device-edit-fixed"),d.appendChild(o);const c=t.createChild("div","devices-edit-client-hints-heading");UI.UIUtils.createTextChild(c.createChild("b"),i18nString(UIStrings.userAgentClient));const u=document.createElement("a");u.href="https://web.dev/user-agent-client-hints/",u.target="_blank";const h=UI.Icon.Icon.create("mediumicon-info","help-icon");u.appendChild(h),u.title=i18nString(UIStrings.userAgentClientHintsAre),u.addEventListener("keydown",(e=>{"Enter"===e.key&&e.stopPropagation()})),c.appendChild(u);const v=new UI.TreeOutline.TreeOutlineInShadow;v.registerRequiredCSS("emulation/devicesSettingsTab.css",{enableLegacyPatching:!0}),v.setShowSelectionOnKeyboardFocus(!0,!1);const m=new UI.TreeOutline.TreeElement(c,!0);function g(e){const t=new UI.TreeOutline.TreeElement(e,!1);t.selectable=!1,t.listItemElement.classList.add("devices-edit-client-hints-field"),m.appendChild(t)}v.appendChild(m),m.select(!0,!1),t.appendChild(v.element);g(e.createInput("brands","text",i18nString(UIStrings.UABrands),(function(e,t,i){const s=i18nString(UIStrings.brandsList),n=i18nString(UIStrings.brandsListMust),a=parseBrandsList(i.value,s,n);if("string"===typeof a)return{valid:!1,errorMessage:a};return{valid:!0,errorMessage:void 0}})));g(e.createInput("full-version","text",i18nString(UIStrings.fullBrowserVersion),p));g(e.createInput("platform","text",i18nString(UIStrings.platform),p));g(e.createInput("platform-version","text",i18nString(UIStrings.platformVersion),p));g(e.createInput("arch","text",i18nString(UIStrings.architecture),p));return g(e.createInput("model","text",i18nString(UIStrings.deviceModel),p)),e;function p(e,t,i){return validateAsStructuredHeadersString(i.value,i18nString(UIStrings.notRepresentable))}}}