import*as Common from"../common/common.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{MaxDeviceSize,MinDeviceSize}from"./DeviceModeModel.js";export class EmulatedDevice{constructor(){this.title="",this.type=Type.Unknown,this.vertical={width:0,height:0,outlineInsets:null,outlineImage:null,hinge:null},this.horizontal={width:0,height:0,outlineInsets:null,outlineImage:null,hinge:null},this.deviceScaleFactor=1,this.capabilities=[Capability.Touch,Capability.Mobile],this.userAgent="",this.userAgentMetadata=null,this.modes=[],this.isDualScreen=!1,this.verticalSpanned={width:0,height:0,outlineInsets:null,outlineImage:null,hinge:null},this.horizontalSpanned={width:0,height:0,outlineInsets:null,outlineImage:null,hinge:null},this._show=_Show.Default,this._showByDefault=!0,this._extension=null}static fromJSONV1(t){try{function e(t,e,i,o){if("object"!==typeof t||null===t||!t.hasOwnProperty(e)){if("undefined"!==typeof o)return o;throw new Error("Emulated device is missing required property '"+e+"'")}const n=t[e];if(typeof n!==i||null===n)throw new Error("Emulated device property '"+e+"' has wrong type '"+typeof n+"'");return n}function i(t,i){const o=e(t,i,"number");if(o!==Math.abs(o))throw new Error("Emulated device value '"+i+"' must be integer");return o}function o(t){return new UI.Geometry.Insets(i(t,"left"),i(t,"top"),i(t,"right"),i(t,"bottom"))}function n(t){const o={};if(o.r=i(t,"r"),o.r<0||o.r>255)throw new Error("color has wrong r value: "+o.r);if(o.g=i(t,"g"),o.g<0||o.g>255)throw new Error("color has wrong g value: "+o.g);if(o.b=i(t,"b"),o.b<0||o.b>255)throw new Error("color has wrong b value: "+o.b);if(o.a=e(t,"a","number"),o.a<0||o.a>1)throw new Error("color has wrong a value: "+o.a);return o}function s(t){const e={};if(e.width=i(t,"width"),e.width<0||e.width>MaxDeviceSize)throw new Error("Emulated device has wrong hinge width: "+e.width);if(e.height=i(t,"height"),e.height<0||e.height>MaxDeviceSize)throw new Error("Emulated device has wrong hinge height: "+e.height);if(e.x=i(t,"x"),e.x<0||e.x>MaxDeviceSize)throw new Error("Emulated device has wrong x offset: "+e.height);if(e.y=i(t,"y"),e.x<0||e.x>MaxDeviceSize)throw new Error("Emulated device has wrong y offset: "+e.height);return t.contentColor&&(e.contentColor=n(t.contentColor)),t.outlineColor&&(e.outlineColor=n(t.outlineColor)),e}function r(t){const n={};if(n.width=i(t,"width"),n.width<0||n.width>MaxDeviceSize||n.width<MinDeviceSize)throw new Error("Emulated device has wrong width: "+n.width);if(n.height=i(t,"height"),n.height<0||n.height>MaxDeviceSize||n.height<MinDeviceSize)throw new Error("Emulated device has wrong height: "+n.height);const r=e(t.outline,"insets","object",null);if(r){if(n.outlineInsets=o(r),n.outlineInsets.left<0||n.outlineInsets.top<0)throw new Error("Emulated device has wrong outline insets");n.outlineImage=e(t.outline,"image","string")}return t.hinge&&(n.hinge=s(e(t,"hinge","object",void 0))),n}const a=new EmulatedDevice;a.title=e(t,"title","string"),a.type=e(t,"type","string");const l=e(t,"user-agent","string");a.userAgent=SDK.NetworkManager.MultitargetNetworkManager.patchUserAgentWithChromeVersion(l),a.userAgentMetadata=e(t,"user-agent-metadata","object",null);const h=e(t,"capabilities","object",[]);if(!Array.isArray(h))throw new Error("Emulated device capabilities must be an array");a.capabilities=[];for(let t=0;t<h.length;++t){if("string"!==typeof h[t])throw new Error("Emulated device capability must be a string");a.capabilities.push(h[t])}if(a.deviceScaleFactor=e(t.screen,"device-pixel-ratio","number"),a.deviceScaleFactor<0||a.deviceScaleFactor>100)throw new Error("Emulated device has wrong deviceScaleFactor: "+a.deviceScaleFactor);if(a.vertical=r(e(t.screen,"vertical","object")),a.horizontal=r(e(t.screen,"horizontal","object")),a.isDualScreen=e(t,"dual-screen","boolean",!1),a.isDualScreen&&(a.verticalSpanned=r(e(t.screen,"vertical-spanned","object",null)),a.horizontalSpanned=r(e(t.screen,"horizontal-spanned","object",null))),a.isDualScreen&&(!a.verticalSpanned||!a.horizontalSpanned))throw new Error("Emulated device '"+a.title+"'has dual screen without spanned orientations");const c=e(t,"modes","object",[{title:"default",orientation:"vertical"},{title:"default",orientation:"horizontal"}]);if(!Array.isArray(c))throw new Error("Emulated device modes must be an array");a.modes=[];for(let t=0;t<c.length;++t){const i={};if(i.title=e(c[t],"title","string"),i.orientation=e(c[t],"orientation","string"),i.orientation!==Vertical&&i.orientation!==Horizontal&&i.orientation!==VerticalSpanned&&i.orientation!==HorizontalSpanned)throw new Error("Emulated device mode has wrong orientation '"+i.orientation+"'");const n=a.orientationByName(i.orientation);if(i.insets=o(e(c[t],"insets","object",{left:0,top:0,right:0,bottom:0})),i.insets.top<0||i.insets.left<0||i.insets.right<0||i.insets.bottom<0||i.insets.top+i.insets.bottom>n.height||i.insets.left+i.insets.right>n.width)throw new Error("Emulated device mode '"+i.title+"'has wrong mode insets");i.image=e(c[t],"image","string",null),a.modes.push(i)}return a._showByDefault=e(t,"show-by-default","boolean",void 0),a._show=e(t,"show","string",_Show.Default),a}catch(e){return null}}static deviceComparator(t,e){const i=t._extension&&t._extension.descriptor().order||-1,o=e._extension&&e._extension.descriptor().order||-1;return i>o?1:o>i||t.title<e.title?-1:t.title>e.title?1:0}extension(){return this._extension}setExtension(t){this._extension=t}modesForOrientation(t){const e=[];for(let i=0;i<this.modes.length;i++)this.modes[i].orientation===t&&e.push(this.modes[i]);return e}getSpanPartner(t){switch(t.orientation){case Vertical:return this.modesForOrientation(VerticalSpanned)[0];case Horizontal:return this.modesForOrientation(HorizontalSpanned)[0];case VerticalSpanned:return this.modesForOrientation(Vertical)[0];default:return this.modesForOrientation(Horizontal)[0]}}getRotationPartner(t){switch(t.orientation){case HorizontalSpanned:return this.modesForOrientation(VerticalSpanned)[0];case VerticalSpanned:return this.modesForOrientation(HorizontalSpanned)[0];case Horizontal:return this.modesForOrientation(Vertical)[0];default:return this.modesForOrientation(Horizontal)[0]}}_toJSON(){const t={};t.title=this.title,t.type=this.type,t["user-agent"]=this.userAgent,t.capabilities=this.capabilities,t.screen={"device-pixel-ratio":this.deviceScaleFactor,vertical:this._orientationToJSON(this.vertical),horizontal:this._orientationToJSON(this.horizontal),"vertical-spanned":void 0,"horizontal-spanned":void 0},this.isDualScreen&&(t.screen["vertical-spanned"]=this._orientationToJSON(this.verticalSpanned),t.screen["horizontal-spanned"]=this._orientationToJSON(this.horizontalSpanned)),t.modes=[];for(let e=0;e<this.modes.length;++e){const i={title:this.modes[e].title,orientation:this.modes[e].orientation,insets:{left:this.modes[e].insets.left,top:this.modes[e].insets.top,right:this.modes[e].insets.right,bottom:this.modes[e].insets.bottom},image:this.modes[e].image||void 0};t.modes.push(i)}return t["show-by-default"]=this._showByDefault,t["dual-screen"]=this.isDualScreen,t.show=this._show,this.userAgentMetadata&&(t["user-agent-metadata"]=this.userAgentMetadata),t}_orientationToJSON(t){const e={};return e.width=t.width,e.height=t.height,t.outlineInsets&&(e.outline={insets:{left:t.outlineInsets.left,top:t.outlineInsets.top,right:t.outlineInsets.right,bottom:t.outlineInsets.bottom},image:t.outlineImage}),t.hinge&&(e.hinge={width:t.hinge.width,height:t.hinge.height,x:t.hinge.x,y:t.hinge.y,contentColor:void 0,outlineColor:void 0},t.hinge.contentColor&&(e.hinge.contentColor={r:t.hinge.contentColor.r,g:t.hinge.contentColor.g,b:t.hinge.contentColor.b,a:t.hinge.contentColor.a}),t.hinge.outlineColor&&(e.hinge.outlineColor={r:t.hinge.outlineColor.r,g:t.hinge.outlineColor.g,b:t.hinge.outlineColor.b,a:t.hinge.outlineColor.a})),e}modeImage(t){return t.image?this._extension?this._extension.module().substituteURL(t.image):t.image:""}outlineImage(t){const e=this.orientationByName(t.orientation);return e.outlineImage?this._extension?this._extension.module().substituteURL(e.outlineImage):e.outlineImage:""}orientationByName(t){switch(t){case VerticalSpanned:return this.verticalSpanned;case HorizontalSpanned:return this.horizontalSpanned;case Vertical:return this.vertical;default:return this.horizontal}}show(){return this._show===_Show.Default?this._showByDefault:this._show===_Show.Always}setShow(t){this._show=t?_Show.Always:_Show.Never}copyShowFrom(t){this._show=t._show}touch(){return-1!==this.capabilities.indexOf(Capability.Touch)}mobile(){return-1!==this.capabilities.indexOf(Capability.Mobile)}}export const Horizontal="horizontal";export const Vertical="vertical";export const HorizontalSpanned="horizontal-spanned";export const VerticalSpanned="vertical-spanned";export const Type={Phone:"phone",Tablet:"tablet",Notebook:"notebook",Desktop:"desktop",Unknown:"unknown"};export const Capability={Touch:"touch",Mobile:"mobile"};export const _Show={Always:"Always",Default:"Default",Never:"Never"};let _instance;export class EmulatedDevicesList extends Common.ObjectWrapper.ObjectWrapper{constructor(){super(),this._standardSetting=Common.Settings.Settings.instance().createSetting("standardEmulatedDeviceList",[]),this._standard=new Set,this._listFromJSONV1(this._standardSetting.get(),this._standard),this._updateStandardDevices(),this._customSetting=Common.Settings.Settings.instance().createSetting("customEmulatedDeviceList",[]),this._custom=new Set,this._listFromJSONV1(this._customSetting.get(),this._custom)||this.saveCustomDevices()}static instance(){return _instance||(_instance=new EmulatedDevicesList),_instance}_updateStandardDevices(){const t=new Set,e=Root.Runtime.Runtime.instance().extensions("emulated-device");for(const i of e){const e=EmulatedDevice.fromJSONV1(i.descriptor().device);e&&(e.setExtension(i),t.add(e))}this._copyShowValues(this._standard,t),this._standard=t,this.saveStandardDevices()}_listFromJSONV1(t,e){if(!Array.isArray(t))return!1;let i=!0;for(let o=0;o<t.length;++o){const n=EmulatedDevice.fromJSONV1(t[o]);n?(e.add(n),n.modes.length||(n.modes.push({title:"",orientation:Horizontal,insets:new UI.Geometry.Insets(0,0,0,0),image:null}),n.modes.push({title:"",orientation:Vertical,insets:new UI.Geometry.Insets(0,0,0,0),image:null}))):i=!1}return i}standard(){return[...this._standard]}custom(){return[...this._custom]}revealCustomSetting(){Common.Revealer.reveal(this._customSetting)}addCustomDevice(t){this._custom.add(t),this.saveCustomDevices()}removeCustomDevice(t){this._custom.delete(t),this.saveCustomDevices()}saveCustomDevices(){const t=[];this._custom.forEach((e=>t.push(e._toJSON()))),this._customSetting.set(t),this.dispatchEventToListeners(Events.CustomDevicesUpdated)}saveStandardDevices(){const t=[];this._standard.forEach((e=>t.push(e._toJSON()))),this._standardSetting.set(t),this.dispatchEventToListeners(Events.StandardDevicesUpdated)}_copyShowValues(t,e){const i=new Map;for(const o of t)i.set(o.title,o);for(const o of e){const t=i.get(o.title);t&&o.copyShowFrom(t)}}}export const Events={CustomDevicesUpdated:Symbol("CustomDevicesUpdated"),StandardDevicesUpdated:Symbol("StandardDevicesUpdated")};export let Mode;export let Orientation;export let JSONMode;