import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as Acorn from"../third_party/acorn/acorn.js";import{AcornTokenizer,ECMA_VERSION}from"./AcornTokenizer.js";import{CSSFormatter}from"./CSSFormatter.js";import{ESTreeWalker}from"./ESTreeWalker.js";import{FormattedContentBuilder}from"./FormattedContentBuilder.js";import{HTMLFormatter}from"./HTMLFormatter.js";import{IdentityFormatter}from"./IdentityFormatter.js";import{JavaScriptFormatter}from"./JavaScriptFormatter.js";export function createTokenizer(e){const r=CodeMirror.getMode({indentUnit:2},e),t=CodeMirror.startState(r);if(!r||"null"===r.name)throw new Error(`Could not find CodeMirror mode for MimeType: ${e}`);if(!r.token)throw new Error(`Could not find CodeMirror mode with token method: ${e}`);return(e,n)=>{const o=new CodeMirror.StringStream(e);for(;!o.eol();){const e=r.token(o,t),s=o.current();if(n(s,e,o.start,o.start+s.length)===AbortTokenization)return;o.start=o.pos}}}export const AbortTokenization={};export function evaluatableJavaScriptSubstring(e){const r=Acorn.tokenizer(e,{ecmaVersion:ECMA_VERSION});let t="";try{let n=r.getToken();for(;n.type!==Acorn.tokTypes.eof&&AcornTokenizer.punctuator(n);)n=r.getToken();const o=n.start;let s=n.end,a=0;for(;n.type!==Acorn.tokTypes.eof;){const e=AcornTokenizer.identifier(n),t=AcornTokenizer.keyword(n,"this"),o=n.type===Acorn.tokTypes.string;if(!t&&!e&&!o)break;for(s=n.end,n=r.getToken();AcornTokenizer.punctuator(n,".[]");)AcornTokenizer.punctuator(n,"[")&&a++,AcornTokenizer.punctuator(n,"]")&&(s=a>0?n.end:s,a--),n=r.getToken()}t=e.substring(o,s)}catch(n){console.error(n)}return t}export function javaScriptIdentifiers(e){let r=null;try{r=Acorn.parse(e,{ecmaVersion:ECMA_VERSION,ranges:!1})}catch(a){}const t=[],n=new ESTreeWalker((function(e){if(o(e))return e.id&&t.push(e.id),ESTreeWalker.SkipSubtree;if("Identifier"!==e.type)return;if(e.parent&&"MemberExpression"===e.parent.type){const r=e.parent;if(r.property===e&&!r.computed)return}return void t.push(e)}));function o(e){return"FunctionDeclaration"===e.type||"FunctionExpression"===e.type||"ArrowFunctionExpression"===e.type}if(!r||"Program"!==r.type||1!==r.body.length||!o(r.body[0]))return[];const s=r.body[0];for(const i of s.params)n.walk(i);return n.walk(s.body),t.map((e=>({name:"name"in e&&e.name||void 0,offset:e.start})))}export function format(e,r,t){const n={},o=new FormattedContentBuilder(t=t||"    "),s=Platform.StringUtilities.findLineEndingIndexes(r);try{switch(e){case"text/html":new HTMLFormatter(o).format(r,s);break;case"text/css":new CSSFormatter(o).format(r,s,0,r.length);break;case"text/javascript":case"application/javascript":new JavaScriptFormatter(o).format(r,s,0,r.length);break;default:new IdentityFormatter(o).format(r,s,0,r.length)}n.mapping=o.mapping,n.content=o.content()}catch(a){console.error(a),n.mapping={original:[0],formatted:[0]},n.content=r}return n}export function findLastFunctionCall(e){if(e.length>1e4)return null;try{const r=Acorn.tokenizer(e,{ecmaVersion:ECMA_VERSION});for(;r.getToken().type!==Acorn.tokTypes.eof;);}catch(c){return null}const r=_lastCompleteExpression(e,"000)",new Set(["CallExpression","NewExpression"]));if(!r)return null;if("CallExpression"!==r.baseNode.type&&"NewExpression"!==r.baseNode.type)return null;const t=r.baseNode.callee;let n="";const o="Identifier"===t.type?t:t.property;o&&("Identifier"===o.type?n=o.name:"Literal"===o.type&&(n=o.value));const s=r.baseNode.arguments.length-1,a=`(${r.baseExpression.substring(t.start-r.baseNode.start,t.end-r.baseNode.start)})`;let i="(function(){return this})()";if("MemberExpression"===t.type){const e=t.object;i=r.baseExpression.substring(e.start-r.baseNode.start,e.end-r.baseNode.start)}return{baseExpression:a,receiver:i,argumentIndex:s,functionName:n}}export function argumentsList(e){if(e.length>1e4)return[];let r=null;try{r=Acorn.parse(`(${e})`,{ecmaVersion:ECMA_VERSION})}catch(o){}if(!r)try{r=Acorn.parse(`({${e}})`,{ecmaVersion:ECMA_VERSION})}catch(o){}if(!r||!("body"in r)||!Array.isArray(r.body)||!r.body[0]||!("expression"in r.body[0]))return[];const t=r.body[0].expression;let n=null;switch(t.type){case"ClassExpression":{if(!t.body.body)break;const e=t.body.body.find((e=>"constructor"===e.kind));e&&(n=e.value.params);break}case"ObjectExpression":if(!t.properties[0]||!("value"in t.properties[0])||!("params"in t.properties[0].value))break;n=t.properties[0].value.params;break;case"FunctionExpression":case"ArrowFunctionExpression":n=t.params}return n?n.map((function e(r){switch(r.type){case"Identifier":return r.name;case"AssignmentPattern":return"?"+e(r.left);case"ObjectPattern":return"obj";case"ArrayPattern":return"arr";case"RestElement":return"..."+e(r.argument)}return"?"})):[]}export function findLastExpression(e){if(e.length>1e4)return null;try{const r=Acorn.tokenizer(e,{ecmaVersion:ECMA_VERSION});for(;r.getToken().type!==Acorn.tokTypes.eof;);}catch(n){return null}const r=".DEVTOOLS";try{Acorn.parse(e+r,{ecmaVersion:ECMA_VERSION})}catch(o){if(o.message.startsWith("Unexpected token")&&o.pos===e.length)return null}const t=_lastCompleteExpression(e,r,new Set(["MemberExpression","Identifier"]));return t?t.baseExpression:null}export function _lastCompleteExpression(e,r,t){let n=null,o="";for(let p=0;p<e.length;p++)try{o="{"===e[p]?`(${e.substring(p)})${r}`:`${e.substring(p)}${r}`,n=Acorn.parse(o,{ecmaVersion:ECMA_VERSION});break}catch(c){}if(!n)return null;const s=n.end;let a=null;if(new ESTreeWalker((e=>{if(a||e.end<s)return ESTreeWalker.SkipSubtree;t.has(e.type)&&(a=e)})).walk(n),!a)return null;let i=o.substring(a.start,o.length-r.length);return i.startsWith("{")&&(i=`(${i})`),{baseNode:a,baseExpression:i}}Root.Runtime.Runtime.queryParam("test")&&(console.error=()=>{});