import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Elements from"../elements/elements.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Network from"../network/network.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as WebComponents from"../ui/components/components.js";import*as UI from"../ui/ui.js";import{AffectedBlockedByResponseView}from"./AffectedBlockedByResponseView.js";import{AffectedCookiesView}from"./AffectedCookiesView.js";import{AffectedElementsView}from"./AffectedElementsView.js";import{AffectedElementsWithLowContrastView}from"./AffectedElementsWithLowContrastView.js";import{AffectedResourcesView,extractShortPath}from"./AffectedResourcesView.js";import{AffectedSharedArrayBufferIssueDetailsView}from"./AffectedSharedArrayBufferIssueDetailsView.js";import{AffectedTrustedWebActivityIssueDetailsView}from"./AffectedTrustedWebActivityIssueDetailsView.js";import{CorsIssueDetailsView}from"./CorsIssueDetailsView.js";const UIStrings={name:"Name",directive:"directive",directives:"directives",reportonly:"report-only",blocked:"blocked",clickToRevealTheViolatingDomNode:"Click to reveal the violating DOM node in the Elements panel",directiveC:"Directive",element:"Element",sourceLocation:"Source Location",status:"Status",resourceC:"Resource",request:"request",requests:"requests",source:"source",sources:"sources",resource:"resource",resources:"resources",restrictionStatus:"Restriction Status",limitExceeded:"Limit exceeded",resolutionStatus:"Resolution Status",frameUrl:"Frame URL",removed:"Removed",warned:"Warned",cpuPeakLimit:"CPU peak limit",cpuTotalLimit:"CPU total limit",networkLimit:"Network limit",affectedResources:"Affected Resources",learnMoreS:"Learn more: {PH1}",isThisIssueMessageHelpfulToYou:"Is this issue message helpful to you?"},str_=i18n.i18n.registerUIStrings("issues/IssueView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class AffectedDirectivesView extends AffectedResourcesView{constructor(e,t){super(e,{singular:i18nString(UIStrings.directive),plural:i18nString(UIStrings.directives)}),this._issue=t}_appendStatus(e,t){const s=document.createElement("td");t?(s.classList.add("affected-resource-report-only-status"),s.textContent=i18nString(UIStrings.reportonly)):(s.classList.add("affected-resource-blocked-status"),s.textContent=i18nString(UIStrings.blocked)),e.appendChild(s)}_appendViolatedDirective(e,t){const s=document.createElement("td");s.textContent=t,e.appendChild(s)}_appendBlockedURL(e,t){const s=document.createElement("td");s.classList.add("affected-resource-directive-info"),s.textContent=t,e.appendChild(s)}_appendBlockedElement(e,t,s){const i=new Elements.ElementsPanelLink.ElementsPanelLink;if(t){const e=t;UI.Tooltip.Tooltip.install(i,i18nString(UIStrings.clickToRevealTheViolatingDomNode));const n=()=>{const t=s.getTargetIfNotDisposed();if(t){Host.userMetrics.issuesPanelResourceOpened(this._issue.getCategory(),"Element");const s=new SDK.DOMModel.DeferredDOMNode(t,e);Common.Revealer.reveal(s)}},o=()=>{const t=s.getTargetIfNotDisposed();if(t){const s=new SDK.DOMModel.DeferredDOMNode(t,e);s&&s.highlight()}},r=()=>{SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()};i.data={onElementRevealIconClick:n,onElementRevealIconMouseEnter:o,onElementRevealIconMouseLeave:r}}const n=document.createElement("td");n.classList.add("affected-resource-csp-info-node"),n.appendChild(i),e.appendChild(n)}_appendAffectedContentSecurityPolicyDetails(e){const t=document.createElement("tr");if(this._issue.code()===SDK.ContentSecurityPolicyIssue.inlineViolationCode)this.appendColumnTitle(t,i18nString(UIStrings.directiveC)),this.appendColumnTitle(t,i18nString(UIStrings.element)),this.appendColumnTitle(t,i18nString(UIStrings.sourceLocation)),this.appendColumnTitle(t,i18nString(UIStrings.status));else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.urlViolationCode)this.appendColumnTitle(t,i18nString(UIStrings.resourceC),"affected-resource-directive-info-header"),this.appendColumnTitle(t,i18nString(UIStrings.status)),this.appendColumnTitle(t,i18nString(UIStrings.directiveC)),this.appendColumnTitle(t,i18nString(UIStrings.sourceLocation));else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.evalViolationCode)this.appendColumnTitle(t,i18nString(UIStrings.sourceLocation)),this.appendColumnTitle(t,i18nString(UIStrings.directiveC)),this.appendColumnTitle(t,i18nString(UIStrings.status));else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.trustedTypesSinkViolationCode)this.appendColumnTitle(t,i18nString(UIStrings.sourceLocation)),this.appendColumnTitle(t,i18nString(UIStrings.status));else{if(this._issue.code()!==SDK.ContentSecurityPolicyIssue.trustedTypesPolicyViolationCode)return void this.updateAffectedResourceCount(0);this.appendColumnTitle(t,i18nString(UIStrings.sourceLocation)),this.appendColumnTitle(t,i18nString(UIStrings.directiveC)),this.appendColumnTitle(t,i18nString(UIStrings.status))}this.affectedResources.appendChild(t);let s=0;for(const i of e)s++,this._appendAffectedContentSecurityPolicyDetail(i);this.updateAffectedResourceCount(s)}_appendAffectedContentSecurityPolicyDetail(e){const t=document.createElement("tr");t.classList.add("affected-resource-directive");const s=e.details(),i=e.model(),n=e.model()?.getTargetIfNotDisposed();if(this._issue.code()===SDK.ContentSecurityPolicyIssue.inlineViolationCode&&i)this._appendViolatedDirective(t,s.violatedDirective),this._appendBlockedElement(t,s.violatingNodeId,i),this.appendSourceLocation(t,s.sourceCodeLocation,n),this._appendStatus(t,s.isReportOnly);else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.urlViolationCode){const e=s.blockedURL?s.blockedURL:"";this._appendBlockedURL(t,e),this._appendStatus(t,s.isReportOnly),this._appendViolatedDirective(t,s.violatedDirective),this.appendSourceLocation(t,s.sourceCodeLocation,n)}else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.evalViolationCode)this.appendSourceLocation(t,s.sourceCodeLocation,n),this._appendViolatedDirective(t,s.violatedDirective),this._appendStatus(t,s.isReportOnly);else if(this._issue.code()===SDK.ContentSecurityPolicyIssue.trustedTypesSinkViolationCode)this.appendSourceLocation(t,s.sourceCodeLocation,n),this._appendStatus(t,s.isReportOnly);else{if(this._issue.code()!==SDK.ContentSecurityPolicyIssue.trustedTypesPolicyViolationCode)return;this.appendSourceLocation(t,s.sourceCodeLocation,n),this._appendViolatedDirective(t,s.violatedDirective),this._appendStatus(t,s.isReportOnly)}this.affectedResources.appendChild(t)}update(){this.clear(),this._appendAffectedContentSecurityPolicyDetails(this._issue.getCspIssues())}}class AffectedRequestsView extends AffectedResourcesView{constructor(e,t){super(e,{singular:i18nString(UIStrings.request),plural:i18nString(UIStrings.requests)}),this._issue=t}_appendAffectedRequests(e){let t=0;for(const s of e)for(const e of this.resolveRequestId(s.requestId))t++,this._appendNetworkRequest(e);this.updateAffectedResourceCount(t)}_appendNetworkRequest(e){const t=Platform.StringUtilities.trimMiddle(e.name(),100),s=document.createElement("td"),i=issueTypeToNetworkHeaderMap.get(this._issue.getCategory())||Network.NetworkItemView.Tabs.Headers;s.appendChild(UI.UIUtils.createTextButton(t,(()=>{Host.userMetrics.issuesPanelResourceOpened(this._issue.getCategory(),"Request"),Network.NetworkPanel.NetworkPanel.selectAndShowRequest(e,i)}),"link-style devtools-link"));const n=document.createElement("tr");n.classList.add("affected-resource-request"),n.appendChild(s),this.affectedResources.appendChild(n)}update(){this.clear();for(const e of this._issue.getBlockedByResponseDetails())return void this.updateAffectedResourceCount(0);this._appendAffectedRequests(this._issue.requests())}}class AffectedSourcesView extends AffectedResourcesView{constructor(e,t){super(e,{singular:i18nString(UIStrings.source),plural:i18nString(UIStrings.sources)}),this._issue=t}_appendAffectedSources(e){let t=0;for(const s of e)this._appendAffectedSource(s),t++;this.updateAffectedResourceCount(t)}_appendAffectedSource({url:e,lineNumber:t,columnNumber:s}){const i=document.createElement("td"),n={columnNumber:s,lineNumber:t,tabStop:!0},o=Components.Linkifier.Linkifier.linkifyURL(e,n);i.appendChild(o);const r=document.createElement("tr");r.classList.add("affected-resource-source"),r.appendChild(i),this.affectedResources.appendChild(r)}update(){this.clear(),this._appendAffectedSources(this._issue.sources())}}const issueTypeToNetworkHeaderMap=new Map([[SDK.Issue.IssueCategory.SameSiteCookie,Network.NetworkItemView.Tabs.Cookies],[SDK.Issue.IssueCategory.CrossOriginEmbedderPolicy,Network.NetworkItemView.Tabs.Headers],[SDK.Issue.IssueCategory.MixedContent,Network.NetworkItemView.Tabs.Headers]]);class AffectedMixedContentView extends AffectedResourcesView{constructor(e,t){super(e,{singular:i18nString(UIStrings.resource),plural:i18nString(UIStrings.resources)}),this._issue=t}_appendAffectedMixedContentDetails(e){const t=document.createElement("tr");this.appendColumnTitle(t,i18nString(UIStrings.name)),this.appendColumnTitle(t,i18nString(UIStrings.restrictionStatus)),this.affectedResources.appendChild(t);let s=0;for(const i of e){const e=i.getDetails();e.request?this.resolveRequestId(e.request.requestId).forEach((t=>{this.appendAffectedMixedContent(e,t),s++})):(this.appendAffectedMixedContent(e),s++)}this.updateAffectedResourceCount(s)}appendAffectedMixedContent(e,t=null){const s=document.createElement("tr");s.classList.add("affected-resource-mixed-content");const i=extractShortPath(e.insecureURL),n=document.createElement("td");if(t){const e=t,s=issueTypeToNetworkHeaderMap.get(this._issue.getCategory())||Network.NetworkItemView.Tabs.Headers;n.appendChild(UI.UIUtils.createTextButton(i,(()=>{Host.userMetrics.issuesPanelResourceOpened(this._issue.getCategory(),"Request"),Network.NetworkPanel.NetworkPanel.selectAndShowRequest(e,s)}),"link-style devtools-link"))}else n.classList.add("affected-resource-mixed-content-info"),n.textContent=i;UI.Tooltip.Tooltip.install(n,e.insecureURL),s.appendChild(n);const o=document.createElement("td");o.classList.add("affected-resource-mixed-content-info"),o.textContent=SDK.MixedContentIssue.MixedContentIssue.translateStatus(e.resolutionStatus),s.appendChild(o),this.affectedResources.appendChild(s)}update(){this.clear(),this._appendAffectedMixedContentDetails(this._issue.getMixedContentIssues())}}class AffectedHeavyAdView extends AffectedResourcesView{constructor(e,t){super(e,{singular:i18nString(UIStrings.resource),plural:i18nString(UIStrings.resources)}),this._issue=t}_appendAffectedHeavyAds(e){const t=document.createElement("tr");this.appendColumnTitle(t,i18nString(UIStrings.limitExceeded)),this.appendColumnTitle(t,i18nString(UIStrings.resolutionStatus)),this.appendColumnTitle(t,i18nString(UIStrings.frameUrl)),this.affectedResources.appendChild(t);let s=0;for(const i of e)this._appendAffectedHeavyAd(i),s++;this.updateAffectedResourceCount(s)}_statusToString(e){switch(e){case Protocol.Audits.HeavyAdResolutionStatus.HeavyAdBlocked:return i18nString(UIStrings.removed);case Protocol.Audits.HeavyAdResolutionStatus.HeavyAdWarning:return i18nString(UIStrings.warned)}return""}_limitToString(e){switch(e){case Protocol.Audits.HeavyAdReason.CpuPeakLimit:return i18nString(UIStrings.cpuPeakLimit);case Protocol.Audits.HeavyAdReason.CpuTotalLimit:return i18nString(UIStrings.cpuTotalLimit);case Protocol.Audits.HeavyAdReason.NetworkTotalLimit:return i18nString(UIStrings.networkLimit)}return""}_appendAffectedHeavyAd(e){const t=document.createElement("tr");t.classList.add("affected-resource-heavy-ad");const s=document.createElement("td");s.classList.add("affected-resource-heavy-ad-info"),s.textContent=this._limitToString(e.reason),t.appendChild(s);const i=document.createElement("td");i.classList.add("affected-resource-heavy-ad-info"),i.textContent=this._statusToString(e.resolution),t.appendChild(i);const n=e.frame.frameId,o=this.createFrameCell(n,this._issue);t.appendChild(o),this.affectedResources.appendChild(t)}update(){this.clear(),this._appendAffectedHeavyAds(this._issue.heavyAds())}}const issueSurveyTriggers=new Map([[SDK.Issue.IssueCategory.CrossOriginEmbedderPolicy,"devtools-issues-coep"],[SDK.Issue.IssueCategory.MixedContent,"devtools-issues-mixed-content"],[SDK.Issue.IssueCategory.SameSiteCookie,"devtools-issues-cookies-samesite"],[SDK.Issue.IssueCategory.HeavyAd,"devtools-issues-heavy-ad"],[SDK.Issue.IssueCategory.ContentSecurityPolicy,"devtools-issues-csp"],[SDK.Issue.IssueCategory.Other,null]]);export class IssueView extends UI.TreeOutline.TreeElement{constructor(e,t,s){super(),this._parent=e,this._issue=t,this._description=s,this.toggleOnClick=!0,this.listItemElement.classList.add("issue"),this.childrenListElement.classList.add("body"),this.affectedResources=this._createAffectedResources(),this._affectedResourceViews=[new AffectedCookiesView(this,this._issue),new AffectedElementsView(this,this._issue),new AffectedRequestsView(this,this._issue),new AffectedMixedContentView(this,this._issue),new AffectedSourcesView(this,this._issue),new AffectedHeavyAdView(this,this._issue),new AffectedDirectivesView(this,this._issue),new AffectedBlockedByResponseView(this,this._issue),new AffectedSharedArrayBufferIssueDetailsView(this,this._issue),new AffectedElementsWithLowContrastView(this,this._issue),new AffectedTrustedWebActivityIssueDetailsView(this,this._issue),new CorsIssueDetailsView(this,this._issue)],this._aggregatedIssuesCount=null,this._hasBeenExpandedBefore=!1}getIssueTitle(){return this._description.title}onattach(){this._appendHeader(),this._createBody(),this.appendChild(this.affectedResources);for(const e of this._affectedResourceViews)this.appendAffectedResource(e),e.update();this._createReadMoreLinks(),this.updateAffectedResourceVisibility()}appendAffectedResource(e){this.affectedResources.appendChild(e)}_appendHeader(){const e=document.createElement("div");e.classList.add("header");const t=new WebComponents.Icon.Icon;t.data={iconName:"breaking_change_icon",color:"",width:"16px",height:"16px"},t.classList.add("breaking-change"),this._aggregatedIssuesCount=document.createElement("span");const s=new Elements.Adorner.Adorner;s.data={name:"countWrapper",content:this._aggregatedIssuesCount},s.classList.add("aggregated-issues-count"),this._aggregatedIssuesCount.textContent=`${this._issue.getAggregatedIssuesCount()}`,e.appendChild(t),e.appendChild(s);const i=document.createElement("div");i.classList.add("title"),i.textContent=this._description.title,e.appendChild(i),this.listItemElement.appendChild(e)}onexpand(){if(Host.userMetrics.issuesPanelIssueExpanded(this._issue.getCategory()),!this._hasBeenExpandedBefore){this._hasBeenExpandedBefore=!0;for(const e of this._affectedResourceViews)e.expandIfOneResource()}}_updateAggregatedIssuesCount(){this._aggregatedIssuesCount&&(this._aggregatedIssuesCount.textContent=`${this._issue.getAggregatedIssuesCount()}`)}updateAffectedResourceVisibility(){const e=this._affectedResourceViews.every((e=>e.isEmpty()));this.affectedResources.hidden=e}_createAffectedResources(){const e=new UI.TreeOutline.TreeElement;return e.setCollapsible(!1),e.setExpandable(!0),e.expand(),e.selectable=!1,e.listItemElement.classList.add("affected-resources-label"),e.listItemElement.textContent=i18nString(UIStrings.affectedResources),e.childrenListElement.classList.add("affected-resources"),e}_createBody(){const e=new UI.TreeOutline.TreeElement;e.setCollapsible(!1),e.selectable=!1,e.listItemElement.appendChild(this._description.view),this.appendChild(e)}_createReadMoreLinks(){const e=new UI.TreeOutline.TreeElement;e.setCollapsible(!1),e.listItemElement.classList.add("link-wrapper");const t=e.listItemElement.createChild("ul","link-list");for(const i of this._description.links){const e=UI.Fragment.html`<a class="link devtools-link" role="link" tabindex="0" href=${i.link}>${i18nString(UIStrings.learnMoreS,{PH1:i.linkTitle})}</a>`,s=new WebComponents.Icon.Icon;s.data={iconName:"link_icon",color:"var(--issue-link)",width:"16px",height:"16px"},s.classList.add("link-icon"),e.prepend(s),self.onInvokeElement(e,(e=>{Host.userMetrics.issuesPanelResourceOpened(this._issue.getCategory(),"LearnMore");const t=SDK.SDKModel.TargetManager.instance().mainTarget();t&&t.targetAgent().invoke_createTarget({url:i.link}),e.consume(!0)}));t.createChild("li").appendChild(e)}this.appendChild(e);const s=issueSurveyTriggers.get(this._issue.getCategory());if(s){const e=new WebComponents.SurveyLink.SurveyLink;e.data={trigger:s,promptText:i18nString(UIStrings.isThisIssueMessageHelpfulToYou),canShowSurvey:Host.InspectorFrontendHost.InspectorFrontendHostInstance.canShowSurvey,showSurvey:Host.InspectorFrontendHost.InspectorFrontendHostInstance.showSurvey},t.createChild("li").appendChild(e)}}update(){this._affectedResourceViews.forEach((e=>e.update())),this.updateAffectedResourceVisibility(),this._updateAggregatedIssuesCount()}toggle(e){e||void 0===e&&!this.expanded?this.expand():this.collapse()}}