import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";const UIStrings={canOnlyAuditHttphttpsPagesAnd:"Can only audit HTTP/HTTPS pages and `Chrome` extensions. Navigate to a different page to start an audit.",thereMayBeStoredDataAffectingSingular:"There may be stored data affecting loading performance in this location: {PH1}. Audit this page in an incognito window to prevent those resources from affecting your scores.",thereMayBeStoredDataAffectingLoadingPlural:"There may be stored data affecting loading performance in these locations: {PH1}. Audit this page in an incognito window to prevent those resources from affecting your scores.",multipleTabsAreBeingControlledBy:"Multiple tabs are being controlled by the same `service worker`. Close your other tabs on the same origin to audit this page.",atLeastOneCategoryMustBeSelected:"At least one category must be selected.",localStorage:"Local Storage",indexeddb:"IndexedDB",webSql:"Web SQL",performance:"Performance",howLongDoesThisAppTakeToShow:"How long does this app take to show content and become usable",progressiveWebApp:"Progressive Web App",doesThisPageMeetTheStandardOfA:"Does this page meet the standard of a Progressive Web App",bestPractices:"Best practices",doesThisPageFollowBestPractices:"Does this page follow best practices for modern web development",accessibility:"Accessibility",isThisPageUsableByPeopleWith:"Is this page usable by people with disabilities or impairments",seo:"SEO",isThisPageOptimizedForSearch:"Is this page optimized for search engine results ranking",publisherAds:"Publisher Ads",isThisPageOptimizedForAdSpeedAnd:"Is this page optimized for ad speed and quality",applyMobileEmulation:"Apply mobile emulation",applyMobileEmulationDuring:"Apply mobile emulation during auditing",mobile:"Mobile",desktop:"Desktop",simulatedThrottling:"Simulated throttling",simulateASlowerPageLoadBasedOn:"Simulate a slower page load, based on data from an initial unthrottled load. If disabled, the page is actually slowed with applied throttling.",clearStorage:"Clear storage",resetStorageLocalstorage:"Reset storage (`localStorage`, `IndexedDB`, etc) before auditing. (Good for performance & `PWA` testing)"},str_=i18n.i18n.registerUIStrings("lighthouse/LighthouseController.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class LighthouseController extends Common.ObjectWrapper.ObjectWrapper{constructor(e){super(),e.registerStatusCallback((e=>this.dispatchEventToListeners(Events.AuditProgressChanged,{message:e})));for(const t of Presets)t.setting.addChangeListener(this.recomputePageAuditability.bind(this));for(const t of RuntimeSettings)t.setting.addChangeListener(this.recomputePageAuditability.bind(this));SDK.SDKModel.TargetManager.instance().observeModels(SDK.ServiceWorkerManager.ServiceWorkerManager,this),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.InspectedURLChanged,this.recomputePageAuditability,this)}modelAdded(e){this._manager||(this._manager=e,this._serviceWorkerListeners=[this._manager.addEventListener(SDK.ServiceWorkerManager.Events.RegistrationUpdated,this.recomputePageAuditability,this),this._manager.addEventListener(SDK.ServiceWorkerManager.Events.RegistrationDeleted,this.recomputePageAuditability,this)],this.recomputePageAuditability())}modelRemoved(e){this._manager===e&&(this._serviceWorkerListeners&&Common.EventTarget.EventTarget.removeEventListeners(this._serviceWorkerListeners),this._manager=null,this.recomputePageAuditability())}_hasActiveServiceWorker(){if(!this._manager)return!1;const e=this._manager.target();if(!e)return!1;const t=Common.ParsedURL.ParsedURL.fromString(e.inspectedURL()),i=t&&t.securityOrigin();for(const n of this._manager.registrations().values())if(n.securityOrigin===i)for(const e of n.versions.values())if(e.controlledClients.length>1)return!0;return!1}_hasAtLeastOneCategory(){return Presets.some((e=>e.setting.get()))}_unauditablePageMessage(){if(!this._manager)return null;const e=this._manager.target(),t=e&&e.inspectedURL();return t&&!/^(http|chrome-extension)/.test(t)?i18nString(UIStrings.canOnlyAuditHttphttpsPagesAnd):null}async _hasImportantResourcesNotCleared(){const e=RuntimeSettings.find((e=>"lighthouse.clear_storage"===e.setting.name));if(e&&!e.setting.get())return"";if(!this._manager)return"";const t=this._manager.target(),i=(await t.storageAgent().invoke_getUsageAndQuota({origin:t.inspectedURL()})).usageBreakdown.filter((e=>e.usage)).map((e=>STORAGE_TYPE_NAMES.get(e.storageType))).filter(Boolean);return 1===i.length?i18nString(UIStrings.thereMayBeStoredDataAffectingSingular,{PH1:i[0]}):i.length>1?i18nString(UIStrings.thereMayBeStoredDataAffectingLoadingPlural,{PH1:i.join(", ")}):""}async _evaluateInspectedURL(){if(!this._manager)return"";const e=this._manager.target(),t=e.model(SDK.RuntimeModel.RuntimeModel),i=t&&t.defaultExecutionContext();let n=e.inspectedURL();if(!i)return n;try{const e=await i.evaluate({expression:"window.location.href",objectGroup:"lighthouse",includeCommandLineAPI:!1,silent:!1,returnByValue:!0,generatePreview:!1,allowUnsafeEvalBlockedByCSP:void 0,disableBreaks:void 0,replMode:void 0,throwOnSideEffect:void 0,timeout:void 0},!1,!1);"exceptionDetails"in e&&e.exceptionDetails||!("object"in e)||!e.object||(n=e.object.value,e.object.release())}catch(s){console.error(s)}return n}getFlags(){const e={internalDisableDeviceScreenEmulation:!0};for(const t of RuntimeSettings)t.setFlags(e,t.setting.get());return e}getCategoryIDs(){const e=[];for(const t of Presets)t.setting.get()&&e.push(t.configID);return e}async getInspectedURL(e){return(e&&e.force||!this._inspectedURL)&&(this._inspectedURL=await this._evaluateInspectedURL()),this._inspectedURL}recomputePageAuditability(){const e=this._hasActiveServiceWorker(),t=this._hasAtLeastOneCategory(),i=this._unauditablePageMessage();let n="";e?n=i18nString(UIStrings.multipleTabsAreBeingControlledBy):t?i&&(n=i):n=i18nString(UIStrings.atLeastOneCategoryMustBeSelected),this.dispatchEventToListeners(Events.PageAuditabilityChanged,{helpText:n}),this._hasImportantResourcesNotCleared().then((e=>{this.dispatchEventToListeners(Events.PageWarningsChanged,{warning:e})}))}}const STORAGE_TYPE_NAMES=new Map([[Protocol.Storage.StorageType.Local_storage,i18nString(UIStrings.localStorage)],[Protocol.Storage.StorageType.Indexeddb,i18nString(UIStrings.indexeddb)],[Protocol.Storage.StorageType.Websql,i18nString(UIStrings.webSql)]]);export const Presets=[{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_perf",!0),configID:"performance",title:i18nString(UIStrings.performance),description:i18nString(UIStrings.howLongDoesThisAppTakeToShow),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_pwa",!0),configID:"pwa",title:i18nString(UIStrings.progressiveWebApp),description:i18nString(UIStrings.doesThisPageMeetTheStandardOfA),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_best_practices",!0),configID:"best-practices",title:i18nString(UIStrings.bestPractices),description:i18nString(UIStrings.doesThisPageFollowBestPractices),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_a11y",!0),configID:"accessibility",title:i18nString(UIStrings.accessibility),description:i18nString(UIStrings.isThisPageUsableByPeopleWith),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_seo",!0),configID:"seo",title:i18nString(UIStrings.seo),description:i18nString(UIStrings.isThisPageOptimizedForSearch),plugin:!1},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.cat_pubads",!1),plugin:!0,configID:"lighthouse-plugin-publisher-ads",title:i18nString(UIStrings.publisherAds),description:i18nString(UIStrings.isThisPageOptimizedForAdSpeedAnd)}];export const RuntimeSettings=[{setting:Common.Settings.Settings.instance().createSetting("lighthouse.device_type","mobile"),title:i18nString(UIStrings.applyMobileEmulation),description:i18nString(UIStrings.applyMobileEmulationDuring),setFlags:(e,t)=>{e.emulatedFormFactor=t},options:[{label:i18nString(UIStrings.mobile),value:"mobile"},{label:i18nString(UIStrings.desktop),value:"desktop"}],learnMore:void 0},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.throttling",!0),title:i18nString(UIStrings.simulatedThrottling),learnMore:"https://github.com/GoogleChrome/lighthouse/blob/master/docs/throttling.md#devtools-lighthouse-panel-throttling",description:i18nString(UIStrings.simulateASlowerPageLoadBasedOn),setFlags:(e,t)=>{e.throttlingMethod=t?"simulate":"devtools"},options:void 0},{setting:Common.Settings.Settings.instance().createSetting("lighthouse.clear_storage",!0),title:i18nString(UIStrings.clearStorage),description:i18nString(UIStrings.resetStorageLocalstorage),setFlags:(e,t)=>{e.disableStorageReset=!t},options:void 0,learnMore:void 0}];export const Events={PageAuditabilityChanged:Symbol("PageAuditabilityChanged"),PageWarningsChanged:Symbol("PageWarningsChanged"),AuditProgressChanged:Symbol("AuditProgressChanged"),RequestLighthouseStart:Symbol("RequestLighthouseStart"),RequestLighthouseCancel:Symbol("RequestLighthouseCancel")};