import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Extensions from"../extensions/extensions.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Persistence from"../persistence/persistence.js";import*as Platform from"../platform/platform.js";import*as ProtocolClient from"../protocol_client/protocol_client.js";import*as Recorder from"../recorder/recorder.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as Snippets from"../snippets/snippets.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as Timeline from"../timeline/timeline.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";import{ExecutionContextSelector}from"./ExecutionContextSelector.js";const UIStrings={theSystempreferredColorSchemeHas:"The system-preferred color scheme has changed. To apply this change to DevTools, reload.",customizeAndControlDevtools:"Customize and control DevTools",dockSide:"Dock side",placementOfDevtoolsRelativeToThe:"Placement of DevTools relative to the page. ({PH1} to restore last position)",undockIntoSeparateWindow:"Undock into separate window",dockToBottom:"Dock to bottom",dockToRight:"Dock to right",dockToLeft:"Dock to left",focusDebuggee:"Focus debuggee",hideConsoleDrawer:"Hide console drawer",showConsoleDrawer:"Show console drawer",moreTools:"More tools",help:"Help"},str_=i18n.i18n.registerUIStrings("main/MainImpl.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class MainImpl{constructor(){MainImpl._instanceForTest=this,Platform.runOnWindowLoad((()=>{this._loaded()})),this._lateInitDonePromise}static time(e){Host.InspectorFrontendHost.isUnderTest()||console.time(e)}static timeEnd(e){Host.InspectorFrontendHost.isUnderTest()||console.timeEnd(e)}async _loaded(){console.timeStamp("Main._loaded"),await Root.Runtime.appStarted,Root.Runtime.Runtime.setPlatform(Host.Platform.platform());const e=await new Promise((e=>{Host.InspectorFrontendHost.InspectorFrontendHostInstance.getPreferences(e)}));console.timeStamp("Main._gotPreferences"),this._createSettings(e),await this.requestAndRegisterLocaleData(),this._createAppUI()}async requestAndRegisterLocaleData(){const e=navigator.language||"en-US";i18n.i18n.registerLocale(e);const t=i18n.i18n.registeredLocale;if(t){const e=await Root.Runtime.loadResourcePromise(new URL(`../i18n/locales/${t}.json`,import.meta.url).toString());if(e){const n=JSON.parse(e);i18n.i18n.registerLocaleData(t,n)}}}_createSettings(e){this._initializeExperiments();let t,n="";Host.Platform.isCustomDevtoolsFrontend()?n="__custom__":Root.Runtime.Runtime.queryParam("can_dock")||!Boolean(Root.Runtime.Runtime.queryParam("debugFrontend"))||Host.InspectorFrontendHost.isUnderTest()||(n="__bundled__"),t=!Host.InspectorFrontendHost.isUnderTest()&&window.localStorage?new Common.Settings.SettingsStorage(window.localStorage,void 0,void 0,(()=>window.localStorage.clear()),n):new Common.Settings.SettingsStorage({},void 0,void 0,void 0,n);const o=new Common.Settings.SettingsStorage(e,Host.InspectorFrontendHost.InspectorFrontendHostInstance.setPreference,Host.InspectorFrontendHost.InspectorFrontendHostInstance.removePreference,Host.InspectorFrontendHost.InspectorFrontendHostInstance.clearPreferences,n);Common.Settings.Settings.instance({forceNew:!0,globalStorage:o,localStorage:t}),self.Common.settings=Common.Settings.Settings.instance(),Host.InspectorFrontendHost.isUnderTest()||(new Common.Settings.VersionController).updateVersion()}_initializeExperiments(){Root.Runtime.experiments.register("applyCustomStylesheet","Allow custom UI themes"),Root.Runtime.experiments.register("captureNodeCreationStacks","Capture node creation stacks"),Root.Runtime.experiments.register("sourcesPrettyPrint","Automatically pretty print in the Sources Panel"),Root.Runtime.experiments.register("backgroundServices","Background web platform feature events",!0),Root.Runtime.experiments.register("backgroundServicesNotifications","Background services section for Notifications"),Root.Runtime.experiments.register("backgroundServicesPaymentHandler","Background services section for Payment Handler"),Root.Runtime.experiments.register("backgroundServicesPushMessaging","Background services section for Push Messaging"),Root.Runtime.experiments.register("blackboxJSFramesOnTimeline","Ignore List for JavaScript frames on Timeline",!0),Root.Runtime.experiments.register("ignoreListJSFramesOnTimeline","Ignore List for JavaScript frames on Timeline",!0),Root.Runtime.experiments.register("cssOverview","CSS Overview"),Root.Runtime.experiments.register("emptySourceMapAutoStepping","Empty sourcemap auto-stepping"),Root.Runtime.experiments.register("inputEventsOnTimelineOverview","Input events on Timeline overview",!0),Root.Runtime.experiments.register("liveHeapProfile","Live heap profile",!0),Root.Runtime.experiments.register("protocolMonitor","Protocol Monitor"),Root.Runtime.experiments.register("developerResourcesView","Show developer resources view"),Root.Runtime.experiments.register("cspViolationsView","Show CSP Violations view"),Root.Runtime.experiments.register("recordCoverageWithPerformanceTracing","Record coverage while performance tracing"),Root.Runtime.experiments.register("samplingHeapProfilerTimeline","Sampling heap profiler timeline",!0),Root.Runtime.experiments.register("showOptionToNotTreatGlobalObjectsAsRoots","Show option to take heap snapshot where globals are not treated as root"),Root.Runtime.experiments.register("sourceDiff","Source diff"),Root.Runtime.experiments.register("sourceOrderViewer","Source order viewer"),Root.Runtime.experiments.register("spotlight","Spotlight",!0),Root.Runtime.experiments.register("webauthnPane","WebAuthn Pane"),Root.Runtime.experiments.register("keyboardShortcutEditor","Enable keyboard shortcut editor",!0),Root.Runtime.experiments.register("recorder","Recorder"),Root.Runtime.experiments.register("timelineEventInitiators","Timeline: event initiators"),Root.Runtime.experiments.register("timelineInvalidationTracking","Timeline: invalidation tracking",!0),Root.Runtime.experiments.register("timelineShowAllEvents","Timeline: show all events",!0),Root.Runtime.experiments.register("timelineV8RuntimeCallStats","Timeline: V8 Runtime Call Stats on Timeline",!0),Root.Runtime.experiments.register("timelineWebGL","Timeline: WebGL-based flamechart"),Root.Runtime.experiments.register("timelineReplayEvent","Timeline: Replay input events",!0),Root.Runtime.experiments.register("wasmDWARFDebugging","WebAssembly Debugging: Enable DWARF support"),Root.Runtime.experiments.register("dualScreenSupport","Emulation: Support dual screen mode"),Root.Runtime.experiments.setEnabled("dualScreenSupport",!0),Root.Runtime.experiments.register("cssFlexboxFeatures","Enable new CSS Flexbox debugging features"),Root.Runtime.experiments.register("APCA","Enable new Advanced Perceptual Contrast Algorithm (APCA) replacing previous contrast ratio and AA/AAA guidelines"),Root.Runtime.experiments.register("fullAccessibilityTree","Enable full accessibility tree view in the Elements panel"),Root.Runtime.experiments.register("fontEditor","Enable new Font Editor tool within the Styles Pane."),Root.Runtime.experiments.register("contrastIssues","Enable automatic contrast issue reporting via the Issues panel"),Root.Runtime.experiments.register("experimentalCookieFeatures","Enable experimental cookie features"),Root.Runtime.experiments.enableExperimentsByDefault(["cssFlexboxFeatures"]),Root.Runtime.experiments.cleanUpStaleExperiments();const e=Root.Runtime.Runtime.queryParam("enabledExperiments");if(e&&Root.Runtime.experiments.setServerEnabledExperiments(e.split(";")),Root.Runtime.experiments.enableExperimentsTransiently(["backgroundServices","backgroundServicesNotifications","backgroundServicesPushMessaging","backgroundServicesPaymentHandler","webauthnPane","developerResourcesView"]),Host.InspectorFrontendHost.isUnderTest()){const e=Root.Runtime.Runtime.queryParam("test");e&&e.includes("live-line-level-heap-profile.js")&&Root.Runtime.experiments.enableForTest("liveHeapProfile")}const t=Root.Runtime.experiments.isEnabled("blackboxJSFramesOnTimeline");Root.Runtime.experiments.setEnabled("ignoreListJSFramesOnTimeline",t);for(const n of Root.Runtime.experiments.enabledExperiments())Host.userMetrics.experimentEnabledAtLaunch(n.name)}async _createAppUI(){MainImpl.time("Main._createAppUI"),self.UI.viewManager=UI.ViewManager.ViewManager.instance(),self.Persistence.isolatedFileSystemManager=Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance();const e="systemPreferred",t=Common.Settings.Settings.instance().createSetting("uiTheme",e);if(UI.UIUtils.initializeUIUtils(document,t),t.get()===e){window.matchMedia("(prefers-color-scheme: dark)").addEventListener("change",(()=>{UI.InspectorView.InspectorView.instance().displayReloadRequiredWarning(i18nString(UIStrings.theSystempreferredColorSchemeHas))}))}UI.UIUtils.installComponentRootStyles(document.body),this._addMainEventListeners(document);const n=Boolean(Root.Runtime.Runtime.queryParam("can_dock"));self.UI.zoomManager=UI.ZoomManager.ZoomManager.instance({forceNew:!0,win:window,frontendHost:Host.InspectorFrontendHost.InspectorFrontendHostInstance}),self.UI.inspectorView=UI.InspectorView.InspectorView.instance(),UI.ContextMenu.ContextMenu.initialize(),UI.ContextMenu.ContextMenu.installHandler(document),UI.Tooltip.Tooltip.installHandler(document),SDK.FrameManager.FrameManager.instance(),SDK.NetworkLog.NetworkLog.instance(),self.SDK.consoleModel=SDK.ConsoleModel.ConsoleModel.instance(),self.UI.dockController=UI.DockController.DockController.instance({forceNew:!0,canDock:n}),self.SDK.multitargetNetworkManager=SDK.NetworkManager.MultitargetNetworkManager.instance({forceNew:!0}),self.SDK.domDebuggerManager=SDK.DOMDebuggerModel.DOMDebuggerManager.instance({forceNew:!0}),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.SuspendStateChanged,this._onSuspendStateChanged.bind(this)),self.Workspace.fileManager=Workspace.FileManager.FileManager.instance({forceNew:!0}),self.Workspace.workspace=Workspace.Workspace.WorkspaceImpl.instance(),self.Bindings.networkProjectManager=Bindings.NetworkProject.NetworkProjectManager.instance(),self.Bindings.resourceMapping=Bindings.ResourceMapping.ResourceMapping.instance({forceNew:!0,targetManager:SDK.SDKModel.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),new Bindings.PresentationConsoleMessageHelper.PresentationConsoleMessageManager,self.Bindings.cssWorkspaceBinding=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance({forceNew:!0,targetManager:SDK.SDKModel.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),self.Bindings.debuggerWorkspaceBinding=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance({forceNew:!0,targetManager:SDK.SDKModel.TargetManager.instance(),workspace:Workspace.Workspace.WorkspaceImpl.instance()}),self.Bindings.breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance(),targetManager:SDK.SDKModel.TargetManager.instance(),debuggerWorkspaceBinding:Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance()}),self.Extensions.extensionServer=Extensions.ExtensionServer.ExtensionServer.instance({forceNew:!0}),new Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding(Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance(),Workspace.Workspace.WorkspaceImpl.instance()),Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance().addPlatformFileSystem("snippet://",new Snippets.ScriptSnippetFileSystem.SnippetFileSystem),Root.Runtime.experiments.isEnabled("recorder")&&Persistence.IsolatedFileSystemManager.IsolatedFileSystemManager.instance().addPlatformFileSystem("recording://",new Recorder.RecordingFileSystem.RecordingFileSystem),self.Persistence.persistence=Persistence.Persistence.PersistenceImpl.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance(),breakpointManager:Bindings.BreakpointManager.BreakpointManager.instance()}),self.Persistence.networkPersistenceManager=Persistence.NetworkPersistenceManager.NetworkPersistenceManager.instance({forceNew:!0,workspace:Workspace.Workspace.WorkspaceImpl.instance()}),new ExecutionContextSelector(SDK.SDKModel.TargetManager.instance(),UI.Context.Context.instance()),self.Bindings.ignoreListManager=Bindings.IgnoreListManager.IgnoreListManager.instance({forceNew:!0,debuggerWorkspaceBinding:Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance()}),new PauseListener;const o=UI.ActionRegistry.ActionRegistry.instance({forceNew:!0});self.UI.actionRegistry=o,self.UI.shortcutRegistry=UI.ShortcutRegistry.ShortcutRegistry.instance({forceNew:!0,actionRegistry:o}),this._registerMessageSinkListener(),MainImpl.timeEnd("Main._createAppUI");const r=Common.AppProvider.getRegisteredAppProviders()[0];if(!r)throw new Error("Unable to boot DevTools, as the appprovider is missing");await this._showAppUI(await r.loadAppProvider())}async _showAppUI(e){MainImpl.time("Main._showAppUI");const t=e.createApp();UI.DockController.DockController.instance().initialize(),t.presentUI(document);const n=UI.ActionRegistry.ActionRegistry.instance().action("elements.toggle-element-search");n&&Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.EnterInspectElementMode,(()=>{n.execute()}),this),Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.RevealSourceLine,this._revealSourceLine,this),await UI.InspectorView.InspectorView.instance().createToolbars(),Host.InspectorFrontendHost.InspectorFrontendHostInstance.loadCompleted();const o=Root.Runtime.Runtime.queryParam("loadTimelineFromURL");null!==o&&Timeline.TimelinePanel.LoadTimelineHandler.instance().handleQueryParam(o),setTimeout(this._initializeTarget.bind(this),0),MainImpl.timeEnd("Main._showAppUI")}async _initializeTarget(){MainImpl.time("Main._initializeTarget");for(const e of Common.Runnable.earlyInitializationRunnables())await e().run();Host.InspectorFrontendHost.InspectorFrontendHostInstance.readyForTest(),setTimeout(this._lateInitialization.bind(this),100),MainImpl.timeEnd("Main._initializeTarget")}_lateInitialization(){MainImpl.time("Main._lateInitialization"),Extensions.ExtensionServer.ExtensionServer.instance().initializeExtensions();const e=Common.Runnable.lateInitializationRunnables().map((e=>e().run()));if(Root.Runtime.experiments.isEnabled("liveHeapProfile")){const t="memoryLiveHeapProfile";if(Common.Settings.Settings.instance().moduleSetting(t).get())e.push(PerfUI.LiveHeapProfile.LiveHeapProfile.instance().run());else{const e=async n=>{n.data&&(Common.Settings.Settings.instance().moduleSetting(t).removeChangeListener(e),PerfUI.LiveHeapProfile.LiveHeapProfile.instance().run())};Common.Settings.Settings.instance().moduleSetting(t).addChangeListener(e)}}this._lateInitDonePromise=Promise.all(e).then((()=>{})),MainImpl.timeEnd("Main._lateInitialization")}lateInitDonePromiseForTest(){return this._lateInitDonePromise}_registerMessageSinkListener(){Common.Console.Console.instance().addEventListener(Common.Console.Events.MessageAdded,(function(e){e.data.show&&Common.Console.Console.instance().show()}))}_revealSourceLine(e){const t=e.data.url,n=e.data.lineNumber,o=e.data.columnNumber,r=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(t);r?Common.Revealer.reveal(r.uiLocation(n,o)):Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,(function e(r){const i=r.data;i.url()===t&&(Common.Revealer.reveal(i.uiLocation(n,o)),Workspace.Workspace.WorkspaceImpl.instance().removeEventListener(Workspace.Workspace.Events.UISourceCodeAdded,e))}))}_postDocumentKeyDown(e){e.handled||UI.ShortcutRegistry.ShortcutRegistry.instance().handleShortcut(e)}_redispatchClipboardEvent(e){const t=new CustomEvent("clipboard-"+e.type,{bubbles:!0});t.original=e;const n=e.target&&e.target.ownerDocument,o=n?n.deepActiveElement():null;o&&o.dispatchEvent(t),t.handled&&e.preventDefault()}_contextMenuEventFired(e){(e.handled||e.target.classList.contains("popup-glasspane"))&&e.preventDefault()}_addMainEventListeners(e){e.addEventListener("keydown",this._postDocumentKeyDown.bind(this),!1),e.addEventListener("beforecopy",this._redispatchClipboardEvent.bind(this),!0),e.addEventListener("copy",this._redispatchClipboardEvent.bind(this),!1),e.addEventListener("cut",this._redispatchClipboardEvent.bind(this),!1),e.addEventListener("paste",this._redispatchClipboardEvent.bind(this),!1),e.addEventListener("contextmenu",this._contextMenuEventFired.bind(this),!0)}_onSuspendStateChanged(){const e=SDK.SDKModel.TargetManager.instance().allTargetsSuspended();UI.InspectorView.InspectorView.instance().onSuspendStateChanged(e)}}let zoomActionDelegateInstance,searchActionDelegateInstance,mainMenuItemInstance,settingsButtonProviderInstance,reloadActionDelegateInstance;MainImpl._instanceForTest=null;export class ZoomActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return zoomActionDelegateInstance&&!t||(zoomActionDelegateInstance=new ZoomActionDelegate),zoomActionDelegateInstance}handleAction(e,t){if(Host.InspectorFrontendHost.InspectorFrontendHostInstance.isHostedMode())return!1;switch(t){case"main.zoom-in":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.zoomIn(),!0;case"main.zoom-out":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.zoomOut(),!0;case"main.zoom-reset":return Host.InspectorFrontendHost.InspectorFrontendHostInstance.resetZoom(),!0}return!1}}export class SearchActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return searchActionDelegateInstance&&!t||(searchActionDelegateInstance=new SearchActionDelegate),searchActionDelegateInstance}handleAction(e,t){let n=UI.SearchableView.SearchableView.fromElement(document.deepActiveElement());if(!n){const e=UI.InspectorView.InspectorView.instance().currentPanelDeprecated();if(e&&(n=e.searchableView()),!n)return!1}switch(t){case"main.search-in-panel.find":return n.handleFindShortcut();case"main.search-in-panel.cancel":return n.handleCancelSearchShortcut();case"main.search-in-panel.find-next":return n.handleFindNextShortcut();case"main.search-in-panel.find-previous":return n.handleFindPreviousShortcut()}return!1}}export class MainMenuItem{constructor(){this._item=new UI.Toolbar.ToolbarMenuButton(this._handleContextMenu.bind(this),!0),this._item.setTitle(i18nString(UIStrings.customizeAndControlDevtools))}static instance(e={forceNew:null}){const{forceNew:t}=e;return mainMenuItemInstance&&!t||(mainMenuItemInstance=new MainMenuItem),mainMenuItemInstance}item(){return this._item}_handleContextMenu(e){if(UI.DockController.DockController.instance().canDock()){const t=document.createElement("div");t.classList.add("flex-centered"),t.classList.add("flex-auto"),t.tabIndex=-1;const o=t.createChild("span","flex-auto");o.textContent=i18nString(UIStrings.dockSide);const r=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("main.toggle-dock");UI.Tooltip.Tooltip.install(o,i18nString(UIStrings.placementOfDevtoolsRelativeToThe,{PH1:r[0].title()})),t.appendChild(o);const i=new UI.Toolbar.Toolbar("",t);Host.Platform.isMac()&&!ThemeSupport.ThemeSupport.instance().hasTheme()&&i.makeBlueOnHover();const s=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.undockIntoSeparateWindow),"largeicon-undock"),a=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToBottom),"largeicon-dock-to-bottom"),c=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToRight),"largeicon-dock-to-right"),l=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.dockToLeft),"largeicon-dock-to-left");s.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),a.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),c.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),l.addEventListener(UI.Toolbar.ToolbarButton.Events.MouseDown,(e=>e.data.consume())),s.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,UI.DockController.State.Undocked)),a.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,UI.DockController.State.DockedToBottom)),c.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,UI.DockController.State.DockedToRight)),l.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,n.bind(null,UI.DockController.State.DockedToLeft)),s.setToggled(UI.DockController.DockController.instance().dockSide()===UI.DockController.State.Undocked),a.setToggled(UI.DockController.DockController.instance().dockSide()===UI.DockController.State.DockedToBottom),c.setToggled(UI.DockController.DockController.instance().dockSide()===UI.DockController.State.DockedToRight),l.setToggled(UI.DockController.DockController.instance().dockSide()===UI.DockController.State.DockedToLeft),i.appendToolbarItem(s),i.appendToolbarItem(l),i.appendToolbarItem(a),i.appendToolbarItem(c),t.addEventListener("keydown",(e=>{let t=0;if("ArrowLeft"===e.key)t=-1;else{if("ArrowRight"!==e.key)return;t=1}const n=[s,l,a,c];let o=n.findIndex((e=>e.element.hasFocus()));o=Platform.NumberUtilities.clamp(o+t,0,n.length-1),n[o].element.focus(),e.consume(!0)})),e.headerSection().appendCustomItem(t)}const t=this._item.element;function n(n){UI.DockController.DockController.instance().once(UI.DockController.Events.AfterDockSideChanged).then((()=>{t.focus()})),UI.DockController.DockController.instance().setDockSide(n),e.discard()}if(UI.DockController.DockController.instance().dockSide()===UI.DockController.State.Undocked){const t=SDK.SDKModel.TargetManager.instance().mainTarget();t&&t.type()===SDK.SDKModel.Type.Frame&&e.defaultSection().appendAction("inspector_main.focus-debuggee",i18nString(UIStrings.focusDebuggee))}e.defaultSection().appendAction("main.toggle-drawer",UI.InspectorView.InspectorView.instance().drawerVisible()?i18nString(UIStrings.hideConsoleDrawer):i18nString(UIStrings.showConsoleDrawer)),e.appendItemsAtLocation("mainMenu");const o=e.defaultSection().appendSubMenuItem(i18nString(UIStrings.moreTools)),r=UI.ViewManager.getRegisteredViewExtensions();r.sort(((e,t)=>{const n=e.title(),o=t.title();return n.localeCompare(o)}));for(const i of r){const e=i.location(),t=i.persistence(),n=i.title(),r=i.viewId();"issues-pane"!==r?"closeable"===t&&("drawer-view"!==e&&"panel"!==e||o.defaultSection().appendItem(n,(()=>{UI.ViewManager.ViewManager.instance().showView(r,!0,!1)}))):o.defaultSection().appendItem(n,(()=>{Host.userMetrics.issuesPanelOpenedFrom(Host.UserMetrics.IssueOpener.HamburgerMenu),UI.ViewManager.ViewManager.instance().showView("issues-pane",!0)}))}e.footerSection().appendSubMenuItem(i18nString(UIStrings.help)).appendItemsAtLocation("mainMenuHelp")}}export class SettingsButtonProvider{constructor(){this._settingsButton=UI.Toolbar.Toolbar.createActionButtonForId("settings.show",{showLabel:!1,userActionCode:void 0})}static instance(e={forceNew:null}){const{forceNew:t}=e;return settingsButtonProviderInstance&&!t||(settingsButtonProviderInstance=new SettingsButtonProvider),settingsButtonProviderInstance}item(){return this._settingsButton}}export class PauseListener{constructor(){SDK.SDKModel.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this._debuggerPaused,this)}_debuggerPaused(e){SDK.SDKModel.TargetManager.instance().removeModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this._debuggerPaused,this);const t=e.data,n=t.debuggerPausedDetails();UI.Context.Context.instance().setFlavor(SDK.SDKModel.Target,t.target()),Common.Revealer.reveal(n)}}export function sendOverProtocol(e,t){return new Promise(((n,o)=>{const r=ProtocolClient.InspectorBackend.test.sendRawMessage;if(!r)return o("Unable to send message to test client");r(e,t,((e,...t)=>e?o(e):n(t)))}))}export class ReloadActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return reloadActionDelegateInstance&&!t||(reloadActionDelegateInstance=new ReloadActionDelegate),reloadActionDelegateInstance}handleAction(e,t){switch(t){case"main.debug-reload":return Components.Reload.reload(),!0}return!1}}new MainImpl;