import*as i18n from"../i18n/i18n.js";import*as UI from"../ui/ui.js";const UIStrings={video:"Video",audio:"Audio",track:"Track",decoder:"Decoder",properties:"Properties",textTrack:"Text track",noTextTracks:"No text tracks",resolution:"Resolution",fileSize:"File size",bitrate:"Bitrate",duration:"Duration",startTime:"Start time",streaming:"Streaming",playbackFrameUrl:"Playback frame URL",playbackFrameTitle:"Playback frame title",singleoriginPlayback:"Single-origin playback",rangeHeaderSupport:"`Range` header support",frameRate:"Frame rate",videoPlaybackRoughness:"Video playback roughness",videoFreezingScore:"Video freezing score",decoderName:"Decoder name",noDecoder:"No decoder",hardwareDecoder:"Hardware decoder",decryptingDemuxer:"Decrypting demuxer",encoderName:"Encoder name",noEncoder:"No encoder",hardwareEncoder:"Hardware encoder"},str_=i18n.i18n.registerUIStrings("media/PlayerPropertiesView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class PropertyRenderer extends UI.Widget.VBox{constructor(e){super(),this.contentElement.classList.add("media-property-renderer");const t=this.contentElement.createChild("span","media-property-renderer-title");this._contents=this.contentElement.createChild("span","media-property-renderer-contents"),UI.UIUtils.createTextChild(t,e),this._title=e,this._value=null,this._pseudoColorProtectionElement=null,this.contentElement.classList.add("media-property-renderer-hidden")}updateData(e,t){if(""===t||null===t)return this._updateData(e,null);try{t=JSON.parse(t)}catch(r){}return this._updateData(e,t)}_updateData(e,t){if(null===t)this.changeContents(null);else{if(this._value===t)return;this._value=t,this.changeContents(t)}}changeContents(e){if(null===e)this.contentElement.classList.add("media-property-renderer-hidden"),null===this._pseudoColorProtectionElement&&(this._pseudoColorProtectionElement=document.createElement("div"),this._pseudoColorProtectionElement.classList.add("media-property-renderer"),this._pseudoColorProtectionElement.classList.add("media-property-renderer-hidden"),this.contentElement.parentNode.insertBefore(this._pseudoColorProtectionElement,this.contentElement));else{null!==this._pseudoColorProtectionElement&&(this._pseudoColorProtectionElement.remove(),this._pseudoColorProtectionElement=null),this.contentElement.classList.remove("media-property-renderer-hidden"),this._contents.removeChildren();const t=document.createElement("span");t.textContent=e,this._contents.appendChild(t)}}}export class FormattedPropertyRenderer extends PropertyRenderer{constructor(e,t){super(i18nString(e)),this._formatfunction=t}_updateData(e,t){null===t?this.changeContents(null):this.changeContents(this._formatfunction(t))}}export class DefaultPropertyRenderer extends PropertyRenderer{constructor(e,t){super(i18nString(e)),this.changeContents(t)}}export class DimensionPropertyRenderer extends PropertyRenderer{constructor(e){super(i18nString(e)),this._width=0,this._height=0}_updateData(e,t){let r=!1;"width"===e&&Number(t)!==this._width&&(this._width=Number(t),r=!0),"height"===e&&Number(t)!==this._height&&(this._height=Number(t),r=!0),0===this._width||0===this._height?this.changeContents(null):r&&this.changeContents(`${this._width}\xd7${this._height}`)}}export class AttributesView extends UI.Widget.VBox{constructor(e){super(),this.contentElement.classList.add("media-attributes-view");for(const t of e)t.show(this.contentElement)}}export class TrackManager{constructor(e,t){this._type=t,this._view=e}updateData(e,t){const r=this._view.getTabs(this._type),i=JSON.parse(t);let n=1;for(const s of i)this.addNewTab(r,s,n),n++}addNewTab(e,t,r){const i=[];for(const[s,o]of Object.entries(t))i.push(new DefaultPropertyRenderer(s,o));const n=new AttributesView(i);e.addNewTab(r,n)}}export class VideoTrackManager extends TrackManager{constructor(e){super(e,"video")}}export class TextTrackManager extends TrackManager{constructor(e){super(e,"text")}}export class AudioTrackManager extends TrackManager{constructor(e){super(e,"audio")}}const TrackTypeLocalized={Video:i18nLazyString(UIStrings.video),Audio:i18nLazyString(UIStrings.audio)};class GenericTrackMenu extends UI.TabbedPane.TabbedPane{constructor(e,t=i18nString(UIStrings.track)){super(),this._decoderName=e,this._trackName=t}addNewTab(e,t){const r=i18nString(UIStrings.track);this.appendTab(`Track${e}`,`${this._trackName} #${e}`,t,`${this._decoderName} ${r} #${e}`)}}class DecoderTrackMenu extends GenericTrackMenu{constructor(e,t){super(e);const r=`${e} ${i18nString(UIStrings.decoder)}`,i=`${r} ${i18nString(UIStrings.properties)}`;this.appendTab("DecoderProperties",r,t,i)}}class NoTracksPlaceholderMenu extends UI.Widget.VBox{constructor(e,t){super(),this._isPlaceholder=!0,this._wrapping=e,this._wrapping.appendTab("_placeholder",t,new UI.Widget.VBox,t),this._wrapping.show(this.contentElement)}addNewTab(e,t){this._isPlaceholder&&(this._wrapping.closeTab("_placeholder"),this._isPlaceholder=!1),this._wrapping.addNewTab(e,t)}}export class PlayerPropertiesView extends UI.Widget.VBox{constructor(){super(),this.contentElement.classList.add("media-properties-frame"),this.registerRequiredCSS("media/playerPropertiesView.css",{enableLegacyPatching:!0}),this._mediaElements=[],this._videoDecoderElements=[],this._audioDecoderElements=[],this._textTrackElements=[],this._attributeMap=new Map,this.populateAttributesAndElements(),this._videoProperties=new AttributesView(this._mediaElements),this._videoDecoderProperties=new AttributesView(this._videoDecoderElements),this._audioDecoderProperties=new AttributesView(this._audioDecoderElements),this._videoProperties.show(this.contentElement),this._videoDecoderTabs=new DecoderTrackMenu(TrackTypeLocalized.Video(),this._videoDecoderProperties),this._videoDecoderTabs.show(this.contentElement),this._audioDecoderTabs=new DecoderTrackMenu(TrackTypeLocalized.Audio(),this._audioDecoderProperties),this._audioDecoderTabs.show(this.contentElement),this._textTrackTabs=null}_lazyCreateTrackTabs(){let e=this._textTrackTabs;if(null===e){const t=new GenericTrackMenu(i18nString(UIStrings.textTrack));e=new NoTracksPlaceholderMenu(t,i18nString(UIStrings.noTextTracks)),e.show(this.contentElement),this._textTracksTabs=e}return e}getTabs(e){if("audio"===e)return this._audioDecoderTabs;if("video"===e)return this._videoDecoderTabs;if("text"===e)return this._lazyCreateTrackTabs();throw new Error("Unreachable")}onProperty(e){const t=this._attributeMap.get(e.name);if(!t)throw new Error(`Player property "${e.name}" not supported.`);t.updateData(e.name,e.value)}formatKbps(e){if(""===e)return"0 kbps";return`${Math.floor(Number(e)/1e3)} kbps`}formatTime(e){if(""===e)return"0:00";const t=new Date;return t.setSeconds(Number(e)),t.toISOString().substr(11,8)}formatFileSize(e){if(""===e)return"0 bytes";const t=Number(e);if(t<1e3)return`${e} bytes`;const r=Math.floor(Math.log10(t)/3),i=["bytes","kB","MB","GB","TB"][r];return`${(t/Math.pow(1e3,r)).toFixed(2)} ${i}`}populateAttributesAndElements(){const e=new PropertyRenderer(i18nString(UIStrings.resolution));this._mediaElements.push(e),this._attributeMap.set("kResolution",e);const t=new FormattedPropertyRenderer(i18nString(UIStrings.fileSize),this.formatFileSize);this._mediaElements.push(t),this._attributeMap.set("kTotalBytes",t);const r=new FormattedPropertyRenderer(i18nString(UIStrings.bitrate),this.formatKbps);this._mediaElements.push(r),this._attributeMap.set("kBitrate",r);const i=new FormattedPropertyRenderer(i18nString(UIStrings.duration),this.formatTime);this._mediaElements.push(i),this._attributeMap.set("kMaxDuration",i);const n=new PropertyRenderer(i18nString(UIStrings.startTime));this._mediaElements.push(n),this._attributeMap.set("kStartTime",n);const s=new PropertyRenderer(i18nString(UIStrings.streaming));this._mediaElements.push(s),this._attributeMap.set("kIsStreaming",s);const o=new PropertyRenderer(i18nString(UIStrings.playbackFrameUrl));this._mediaElements.push(o),this._attributeMap.set("kFrameUrl",o);const a=new PropertyRenderer(i18nString(UIStrings.playbackFrameTitle));this._mediaElements.push(a),this._attributeMap.set("kFrameTitle",a);const d=new PropertyRenderer(i18nString(UIStrings.singleoriginPlayback));this._mediaElements.push(d),this._attributeMap.set("kIsSingleOrigin",d);const c=new PropertyRenderer(i18nString(UIStrings.rangeHeaderSupport));this._mediaElements.push(c),this._attributeMap.set("kIsRangeHeaderSupported",c);const h=new PropertyRenderer(i18nString(UIStrings.frameRate));this._mediaElements.push(h),this._attributeMap.set("kFramerate",h);const p=new PropertyRenderer(i18nString(UIStrings.videoPlaybackRoughness));this._mediaElements.push(p),this._attributeMap.set("kVideoPlaybackRoughness",p);const l=new PropertyRenderer(i18nString(UIStrings.videoFreezingScore));this._mediaElements.push(l),this._attributeMap.set("kVideoPlaybackFreezing",l);const u=new DefaultPropertyRenderer(i18nString(UIStrings.decoderName),i18nString(UIStrings.noDecoder));this._videoDecoderElements.push(u),this._attributeMap.set("kVideoDecoderName",u);const m=new PropertyRenderer(i18nString(UIStrings.hardwareDecoder));this._videoDecoderElements.push(m),this._attributeMap.set("kIsPlatformVideoDecoder",m);const g=new DefaultPropertyRenderer(i18nString(UIStrings.encoderName),i18nString(UIStrings.noEncoder));this._videoDecoderElements.push(g),this._attributeMap.set("kVideoEncoderName",g);const _=new PropertyRenderer(i18nString(UIStrings.hardwareEncoder));this._videoDecoderElements.push(_),this._attributeMap.set("kIsPlatformVideoEncoder",_);const S=new PropertyRenderer(i18nString(UIStrings.decryptingDemuxer));this._videoDecoderElements.push(S),this._attributeMap.set("kIsVideoDecryptingDemuxerStream",S);const b=new VideoTrackManager(this);this._attributeMap.set("kVideoTracks",b);const k=new DefaultPropertyRenderer(i18nString(UIStrings.decoderName),i18nString(UIStrings.noDecoder));this._audioDecoderElements.push(k),this._attributeMap.set("kAudioDecoderName",k);const w=new PropertyRenderer(i18nString(UIStrings.hardwareDecoder));this._audioDecoderElements.push(w),this._attributeMap.set("kIsPlatformAudioDecoder",w);const T=new PropertyRenderer(i18nString(UIStrings.decryptingDemuxer));this._audioDecoderElements.push(T),this._attributeMap.set("kIsAudioDecryptingDemuxerStream",T);const y=new AudioTrackManager(this);this._attributeMap.set("kAudioTracks",y);const P=new TextTrackManager(this);this._attributeMap.set("kTextTracks",P)}}