import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{EventSourceMessagesView}from"./EventSourceMessagesView.js";import{RequestCookiesView}from"./RequestCookiesView.js";import{RequestHeadersView}from"./RequestHeadersView.js";import{RequestInitiatorView}from"./RequestInitiatorView.js";import{RequestPreviewView}from"./RequestPreviewView.js";import{RequestResponseView}from"./RequestResponseView.js";import{RequestTimingView}from"./RequestTimingView.js";import{RequestTrustTokensView,statusConsideredSuccess}from"./RequestTrustTokensView.js";import{ResourceWebSocketFrameView}from"./ResourceWebSocketFrameView.js";const UIStrings={headers:"Headers",headersAndRequestBody:"Headers and request body",messages:"Messages",websocketMessages:"WebSocket messages",eventstream:"EventStream",preview:"Preview",responsePreview:"Response preview",signedexchangeError:"SignedExchange error",response:"Response",rawResponseData:"Raw response data",initiator:"Initiator",requestInitiatorCallStack:"Request initiator call stack",timing:"Timing",requestAndResponseTimeline:"Request and response timeline",trustTokens:"Trust Tokens",trustTokenOperationDetails:"Trust Token operation details",cookies:"Cookies",requestAndResponseCookies:"Request and response cookies"},str_=i18n.i18n.registerUIStrings("network/NetworkItemView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class NetworkItemView extends UI.TabbedPane.TabbedPane{constructor(e,s,t){if(super(),this._request=e,this.element.classList.add("network-item-view"),this._resourceViewTabSetting=Common.Settings.Settings.instance().createSetting("resourceViewTab","preview"),this._headersView=new RequestHeadersView(e),this.appendTab(Tabs.Headers,i18nString(UIStrings.headers),this._headersView,i18nString(UIStrings.headersAndRequestBody)),this.addEventListener(UI.TabbedPane.Events.TabSelected,this._tabSelected,this),e.resourceType()===Common.ResourceType.resourceTypes.WebSocket){const s=new ResourceWebSocketFrameView(e);this.appendTab(Tabs.WsFrames,i18nString(UIStrings.messages),s,i18nString(UIStrings.websocketMessages))}else if("text/event-stream"===e.mimeType)this.appendTab(Tabs.EventSource,i18nString(UIStrings.eventstream),new EventSourceMessagesView(e));else{this._responseView=new RequestResponseView(e);const s=new RequestPreviewView(e);this.appendTab(Tabs.Preview,i18nString(UIStrings.preview),s,i18nString(UIStrings.responsePreview));const t=e.signedExchangeInfo();if(t&&t.errors&&t.errors.length){const e=UI.Icon.Icon.create("smallicon-error");UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.signedexchangeError)),this.setTabIcon(Tabs.Preview,e)}this.appendTab(Tabs.Response,i18nString(UIStrings.response),this._responseView,i18nString(UIStrings.rawResponseData))}this.appendTab(Tabs.Initiator,i18nString(UIStrings.initiator),new RequestInitiatorView(e),i18nString(UIStrings.requestInitiatorCallStack)),this.appendTab(Tabs.Timing,i18nString(UIStrings.timing),new RequestTimingView(e,s),i18nString(UIStrings.requestAndResponseTimeline)),e.trustTokenParams()&&this.appendTab(Tabs.TrustTokens,i18nString(UIStrings.trustTokens),new RequestTrustTokensView(e),i18nString(UIStrings.trustTokenOperationDetails)),this._cookiesView=null,this._initialTab=t||this._resourceViewTabSetting.get()}wasShown(){super.wasShown(),this._request.addEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this._maybeAppendCookiesPanel,this),this._request.addEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this._maybeAppendCookiesPanel,this),this._request.addEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this._maybeShowErrorIconInTrustTokenTabHeader,this),this._maybeAppendCookiesPanel(),this._maybeShowErrorIconInTrustTokenTabHeader(),this._selectTab(this._initialTab)}willHide(){this._request.removeEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this._maybeAppendCookiesPanel,this),this._request.removeEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this._maybeAppendCookiesPanel,this),this._request.removeEventListener(SDK.NetworkRequest.Events.TrustTokenResultAdded,this._maybeShowErrorIconInTrustTokenTabHeader,this)}_maybeAppendCookiesPanel(){const e=this._request.hasRequestCookies()||this._request.responseCookies.length>0;console.assert(e||!this._cookiesView,"Cookies were introduced in headers and then removed!"),e&&!this._cookiesView&&(this._cookiesView=new RequestCookiesView(this._request),this.appendTab(Tabs.Cookies,i18nString(UIStrings.cookies),this._cookiesView,i18nString(UIStrings.requestAndResponseCookies)))}_maybeShowErrorIconInTrustTokenTabHeader(){const e=this._request.trustTokenOperationDoneEvent();e&&!statusConsideredSuccess(e.status)&&this.setTabIcon(Tabs.TrustTokens,UI.Icon.Icon.create("smallicon-error"))}_selectTab(e){this.selectTab(e)||this.selectTab("headers")}_tabSelected(e){e.data.isUserGesture&&this._resourceViewTabSetting.set(e.data.tabId)}request(){return this._request}async revealResponseBody(e){this._selectTab(Tabs.Response),this._responseView&&"number"===typeof e&&await this._responseView.revealLine(e)}revealRequestHeader(e){this._selectTab(Tabs.Headers),this._headersView.revealRequestHeader(e)}revealResponseHeader(e){this._selectTab(Tabs.Headers),this._headersView.revealResponseHeader(e)}}export var Tabs;!function(e){e.Cookies="cookies",e.EventSource="eventSource",e.Headers="headers",e.Initiator="initiator",e.Preview="preview",e.Response="response",e.Timing="timing",e.TrustTokens="trustTokens",e.WsFrames="webSocketFrames"}(Tabs||(Tabs={}));