import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as LinearMemoryInspector from"../linear_memory_inspector/linear_memory_inspector.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as WebComponents from"../ui/components/components.js";import*as UI from"../ui/ui.js";import{CustomPreviewComponent}from"./CustomPreviewComponent.js";import{JavaScriptAutocomplete}from"./JavaScriptAutocomplete.js";import{JavaScriptREPL}from"./JavaScriptREPL.js";import{createSpansForNodeTitle,RemoteObjectPreviewFormatter}from"./RemoteObjectPreviewFormatter.js";const UIStrings={exceptionS:"[Exception: {PH1}]",unknown:"unknown",expandRecursively:"Expand recursively",collapseChildren:"Collapse children",noProperties:"No properties",dots:"(...)",invokePropertyGetter:"Invoke property getter",showAllD:"Show all {PH1}",unreadable:"<unreadable>",noPropertyGetter:"No property getter",copyValue:"Copy value",copyPropertyPath:"Copy property path",stringIsTooLargeToEdit:"<string is too large to edit>",showMoreS:"Show more ({PH1})",longTextWasTruncatedS:"long text was truncated ({PH1})",copy:"Copy"},str_=i18n.i18n.registerUIStrings("object_ui/ObjectPropertiesSection.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),EXPANDABLE_MAX_LENGTH=50,parentMap=new WeakMap,objectPropertiesSectionMap=new WeakMap;export const getObjectPropertiesSectionFrom=e=>objectPropertiesSectionMap.get(e);export class ObjectPropertiesSection extends UI.TreeOutline.TreeOutlineInShadow{constructor(e,t,n,i,r,s,o){super(),this._object=e,this._editable=!0,o||this.hideOverflow(),this.setFocusable(!0),this.setShowSelectionOnKeyboardFocus(!0),this._objectTreeElement=new RootElement(e,n,i,r,s),this.appendChild(this._objectTreeElement),"string"!==typeof t&&t?(this.titleElement=t,this.element.appendChild(t)):(this.titleElement=this.element.createChild("span"),this.titleElement.textContent=t||""),this.titleElement instanceof HTMLElement&&!this.titleElement.hasAttribute("tabIndex")&&(this.titleElement.tabIndex=-1),objectPropertiesSectionMap.set(this.element,this),this.registerRequiredCSS("object_ui/objectValue.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("object_ui/objectPropertiesSection.css",{enableLegacyPatching:!0}),this.rootElement().childrenListElement.classList.add("source-code","object-properties-section")}static defaultObjectPresentation(e,t,n,i){const r=ObjectPropertiesSection.defaultObjectPropertiesSection(e,t,n,i);return e.hasChildren?r.element:r.titleElement}static defaultObjectPropertiesSection(e,t,n,i){const r=document.createElement("span");r.classList.add("source-code");const s=UI.Utils.createShadowRootWithCoreStyles(r,{cssFile:"object_ui/objectValue.css",enableLegacyPatching:!0,delegatesFocus:void 0}),o=ObjectPropertiesSection.createPropertyValue(e,!1,!0);s.appendChild(o.element);const a=new ObjectPropertiesSection(e,r,t);return a._editable=!1,n&&a.skipProto(),i&&a.setEditable(!1),a}static compareProperties(e,t){const n=e.name,i=t.name;return"__proto__"===n?1:"__proto__"===i?-1:!e.enumerable&&t.enumerable?1:!t.enumerable&&e.enumerable?-1:n.startsWith("_")&&!i.startsWith("_")?1:i.startsWith("_")&&!n.startsWith("_")?-1:e.symbol&&!t.symbol?1:t.symbol&&!e.symbol?-1:e.private&&!t.private?1:t.private&&!e.private?-1:Platform.StringUtilities.naturalOrderComparator(n,i)}static createNameElement(e,t){return null===e?UI.Fragment.html`<span class="name"></span>`:/^\s|\s$|^$|\n/.test(e)?UI.Fragment.html`<span class="name">"${e.replace(/\n/g,"\u21b5")}"</span>`:t?UI.Fragment.html`<span class="name">
  <span class="private-property-hash">${e[0]}</span>${e.substring(1)}
  </span>`:UI.Fragment.html`<span class="name">${e}</span>`}static valueElementForFunctionDescription(e,t,n){const i=document.createElement("span");i.classList.add("object-value-function");const r=(e=e||"").replace(/^function [gs]et /,"function ").replace(/^function [gs]et\(/,"function(").replace(/^[gs]et /,"");n=n||"";const s=r.match(/^(async\s+function)/),o=r.startsWith("function*"),a=r.startsWith("*"),l=!o&&r.startsWith("function"),p=r.startsWith("class ")||r.startsWith("class{"),c=r.indexOf("=>"),h=!s&&!o&&!l&&!p&&c>0;let d;if(p){d=r.substring("class".length);const e=/^[^{\s]+/.exec(d.trim());let t=n;e&&(t=e[0].trim()||n),u("class",d,t)}else if(s)d=r.substring(s[1].length),u("async \u0192",d,m(d));else if(o)d=r.substring("function*".length),u("\u0192*",d,m(d));else if(a)d=r.substring("*".length),u("\u0192*",d,m(d));else if(l)d=r.substring("function".length),u("\u0192",d,m(d));else if(h){const e=60;let t=r;n?t=n+"()":r.length>e&&(t=r.substring(0,c+2)+" {\u2026}"),u("",r,t)}else u("\u0192",r,m(r));return UI.Tooltip.Tooltip.install(i,Platform.StringUtilities.trimEndWithMaxLength(e,500)),i;function m(e){const t=e.indexOf("("),i=e.match(/\)\s*{/);if(-1!==t&&i&&void 0!==i.index&&i.index>t){return(e.substring(0,t).trim()||n)+e.substring(t,i.index+1)}return n+"()"}function u(e,n,r){e.length&&(i.createChild("span","object-value-function-prefix").textContent=e+" "),t?UI.UIUtils.createTextChild(i,Platform.StringUtilities.trimEndWithMaxLength(n.trim(),200)):UI.UIUtils.createTextChild(i,r.replace(/\n/g," "))}}static createPropertyValueWithCustomSupport(e,t,n,i,r){if(e.customPreview()){const t=new CustomPreviewComponent(e).element;return t.classList.add("object-properties-section-custom-section"),new ObjectPropertyValue(t)}return ObjectPropertiesSection.createPropertyValue(e,t,n,i,r)}static appendMemoryIcon(e,t){if("object"!==t.type||"arraybuffer"!==t.subtype&&"webassemblymemory"!==t.subtype)return;const n=new WebComponents.Icon.Icon;n.data={iconName:"ic_memory_16x16",color:"var(--color-text-secondary)",width:"13px",height:"13px"},n.onclick=e=>{Host.userMetrics.linearMemoryInspectorRevealedFrom(Host.UserMetrics.LinearMemoryInspectorRevealedFrom.MemoryIcon),LinearMemoryInspector.LinearMemoryInspectorController.LinearMemoryInspectorController.instance().openInspectorView(t),e.stopPropagation()},UI.Tooltip.Tooltip.install(n,"Reveal in Memory Inspector panel"),e.appendChild(n)}static createPropertyValue(e,t,n,i,r){let s;const o=e.type,a=e.subtype,l=e.description||"",p=e.className;if("object"===o&&"internal#location"===a){const t=e.debuggerModel().createRawLocationByScriptId(e.value.scriptId,e.value.lineNumber,e.value.columnNumber);if(t&&r)return new ObjectPropertyValue(r.linkifyRawLocation(t,""));s=new ObjectPropertyValue(function(){const e=document.createElement("span");return e.textContent="<"+i18nString(UIStrings.unknown)+">",UI.Tooltip.Tooltip.install(e,l||""),e}())}else if("string"===o&&"string"===typeof l)s=c();else if("object"===o&&"trustedtype"===a)s=function(){const e=document.createElement("span");e.classList.add("object-value-trustedtype");const t=`${p} "${l}"`;let n;if(t.length>(self.ObjectUI.ObjectPropertiesSection._maxRenderableStringLength||maxRenderableStringLength))n=new ExpandableTextPropertyValue(e,t,50);else{const i=c();UI.UIUtils.createTextChild(e,`${p} `),e.appendChild(i.element),n=new ObjectPropertyValue(e),UI.Tooltip.Tooltip.install(e,t)}return n}();else if("function"===o)s=new ObjectPropertyValue(ObjectPropertiesSection.valueElementForFunctionDescription(l));else if("object"===o&&"node"===a&&l)s=new ObjectPropertyValue(function(){const t=document.createElement("span");return t.classList.add("object-value-node"),createSpansForNodeTitle(t,l),t.addEventListener("click",(t=>{Common.Revealer.reveal(e),t.consume(!0)}),!1),t.addEventListener("mousemove",(()=>SDK.OverlayModel.OverlayModel.highlightObjectAsDOMNode(e)),!1),t.addEventListener("mouseleave",(()=>SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()),!1),t}());else{const t=document.createElement("span");if(t.classList.add("object-value-"+(a||o)),e.preview&&n){(new RemoteObjectPreviewFormatter).appendObjectPreview(t,e.preview,!1),s=new ObjectPropertyValue(t),UI.Tooltip.Tooltip.install(s.element,l||"")}else l.length>(self.ObjectUI.ObjectPropertiesSection._maxRenderableStringLength||maxRenderableStringLength)?s=new ExpandableTextPropertyValue(t,l,50):(s=new ObjectPropertyValue(t),s.element.textContent=l,UI.Tooltip.Tooltip.install(s.element,l));this.appendMemoryIcon(t,e)}if(t){const e=document.createElement("span");e.classList.add("error"),e.classList.add("value"),e.appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.exceptionS,{PH1:s.element})),s.element=e}return s.element.classList.add("value"),s;function c(){const e=document.createElement("span");e.classList.add("object-value-string");const t=JSON.stringify(l);let n;return l.length>(self.ObjectUI.ObjectPropertiesSection._maxRenderableStringLength||maxRenderableStringLength)?n=new ExpandableTextPropertyValue(e,t,50):(UI.UIUtils.createTextChild(e,t),n=new ObjectPropertyValue(e),UI.Tooltip.Tooltip.install(e,l)),n}}static formatObjectAsFunction(e,t,n,i){return e.debuggerModel().functionDetailsPromise(e).then((function(r){n&&r&&r.location&&(t.classList.add("linkified"),t.addEventListener("click",(()=>Common.Revealer.reveal(r.location)&&!1)));let s=i?"":"anonymous";r&&r.functionName&&(s=r.functionName);const o=ObjectPropertiesSection.valueElementForFunctionDescription(e.description,i,s);t.appendChild(o)}))}static _isDisplayableProperty(e,t){if(!t||!t.synthetic)return!0;const n=e.name;return!("[[Entries]]"===t.name&&("length"===n||"__proto__"===n))}skipProto(){this._skipProto=!0}expand(){this._objectTreeElement.expand()}setEditable(e){this._editable=e}objectTreeElement(){return this._objectTreeElement}enableContextMenu(){this.element.addEventListener("contextmenu",this._contextMenuEventFired.bind(this),!1)}_contextMenuEventFired(e){const t=new UI.ContextMenu.ContextMenu(e);t.appendApplicableItems(this._object),this._object instanceof SDK.RemoteObject.LocalJSONObject&&(t.viewSection().appendItem(i18nString(UIStrings.expandRecursively),this._objectTreeElement.expandRecursively.bind(this._objectTreeElement,Number.MAX_VALUE)),t.viewSection().appendItem(i18nString(UIStrings.collapseChildren),this._objectTreeElement.collapseChildren.bind(this._objectTreeElement))),t.show()}titleLessMode(){this._objectTreeElement.listItemElement.classList.add("hidden"),this._objectTreeElement.childrenListElement.classList.add("title-less-mode"),this._objectTreeElement.expand()}}const ARRAY_LOAD_THRESHOLD=100;export const maxRenderableStringLength=1e4;export class ObjectPropertiesSectionsTreeOutline extends UI.TreeOutline.TreeOutlineInShadow{constructor(e){super(),this.registerRequiredCSS("object_ui/objectValue.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("object_ui/objectPropertiesSection.css",{enableLegacyPatching:!0}),this._editable=!(e&&e.readOnly),this.contentElement.classList.add("source-code"),this.contentElement.classList.add("object-properties-section"),this.hideOverflow()}}export class RootElement extends UI.TreeOutline.TreeElement{constructor(e,t,n,i,r){super(document.createElement("slot")),this._object=e,this._extraProperties=r||[],this._ignoreHasOwnProperty=Boolean(i),this._emptyPlaceholder=n,this.setExpandable(!0),this.selectable=!0,this.toggleOnClick=!0,this.listItemElement.classList.add("object-properties-section-root-element"),this._linkifier=t}onexpand(){this.treeOutline&&this.treeOutline.element.classList.add("expanded")}oncollapse(){this.treeOutline&&this.treeOutline.element.classList.remove("expanded")}ondblclick(e){return!0}async onpopulate(){const e=this.treeOutline,t=!!e&&Boolean(e._skipProto);return ObjectPropertyTreeElement._populate(this,this._object,t,this._linkifier,this._emptyPlaceholder,this._ignoreHasOwnProperty,this._extraProperties)}}export const InitialVisibleChildrenLimit=200;export class ObjectPropertyTreeElement extends UI.TreeOutline.TreeElement{constructor(e,t){super(),this.property=e,this.toggleOnClick=!0,this._highlightChanges=[],this._linkifier=t,this._maxNumPropertiesToShow=200,this.listItemElement.addEventListener("contextmenu",this._contextMenuFired.bind(this),!1),this.listItemElement.dataset.objectPropertyNameForTest=e.name}static async _populate(e,t,n,i,r,s,o,a){if(t.arrayLength()>100)return e.removeChildren(),void ArrayGroupingTreeElement._populateArray(e,t,0,t.arrayLength()-1,i);let l;l=s?await t.getAllProperties(!1,!0):await SDK.RemoteObject.RemoteObject.loadFromObjectPerProto(t,!0);const p=l.properties,c=l.internalProperties;if(e.removeChildren(),p){o=o||[];for(let e=0;e<o.length;++e)p.push(o[e]);ObjectPropertyTreeElement.populateWithProperties(e,p,c,n,a||t,i,r)}}static populateWithProperties(e,t,n,i,r,s,o){t.sort(ObjectPropertiesSection.compareProperties);const a=(n=n||[]).find((e=>"[[Entries]]"===e.name));if(a){parentMap.set(a,r);const t=new ObjectPropertyTreeElement(a,s);t.setExpandable(!0),t.expand(),e.appendChild(t)}const l=[];let p=null;for(let c=0;c<t.length;++c){const n=t[c];if(parentMap.set(n,r),!ObjectPropertiesSection._isDisplayableProperty(n,e.property))continue;if("__proto__"===n.name&&!n.isAccessorProperty()){p=n;continue}if(n.isOwn&&n.getter){const e=new SDK.RemoteObject.RemoteObjectProperty("get "+n.name,n.getter,!1);parentMap.set(e,r),l.push(e)}if(n.isOwn&&n.setter){const e=new SDK.RemoteObject.RemoteObjectProperty("set "+n.name,n.setter,!1);parentMap.set(e,r),l.push(e)}(n.getter||!n.isAccessorProperty())&&"__proto__"!==n.name&&e.appendChild(new ObjectPropertyTreeElement(n,s))}for(let c=0;c<l.length;++c)e.appendChild(new ObjectPropertyTreeElement(l[c],s));!i&&p&&e.appendChild(new ObjectPropertyTreeElement(p,s));for(const c of n){parentMap.set(c,r);const t=new ObjectPropertyTreeElement(c,s);"[[Entries]]"!==c.name&&e.appendChild(t)}ObjectPropertyTreeElement._appendEmptyPlaceholderIfNeeded(e,o)}static _appendEmptyPlaceholderIfNeeded(e,t){if(e.childCount())return;const n=document.createElement("div");n.classList.add("gray-info-message"),n.textContent=t||i18nString(UIStrings.noProperties);const i=new UI.TreeOutline.TreeElement(n);e.appendChild(i)}static createRemoteObjectAccessorPropertySpan(e,t,n){const i=document.createElement("span"),r=i.createChild("span");if(r.textContent=i18nString(UIStrings.dots),!e)return i;function s(e){let t=this;const n=JSON.parse(e);for(let i=0,r=n.length;i<r;++i)t=t[n[i]];return t}return r.classList.add("object-value-calculate-value-button"),UI.Tooltip.Tooltip.install(r,i18nString(UIStrings.invokePropertyGetter)),r.addEventListener("click",(function(i){i.consume(),e&&e.callFunction(s,[{value:JSON.stringify(t)}]).then(n)}),!1),i}setSearchRegex(e,t){let n=UI.UIUtils.highlightedSearchResultClassName;if(t&&(n+=" "+t),this.revertHighlightChanges(),this._applySearch(e,this.nameElement,n),this.property.value){"object"!==this.property.value.type&&this._applySearch(e,this.valueElement,n)}return Boolean(this._highlightChanges.length)}_applySearch(e,t,n){const i=[],r=t.textContent||"";e.lastIndex=0;let s=e.exec(r);for(;s;)i.push(new TextUtils.TextRange.SourceRange(s.index,s[0].length)),s=e.exec(r);i.length&&UI.UIUtils.highlightRangesWithStyleClass(t,i,n,this._highlightChanges)}_showAllPropertiesElementSelected(e){return this.removeChild(e),this.children().forEach((e=>{e.hidden=!1})),!1}_createShowAllPropertiesButton(){const e=document.createElement("div");e.classList.add("object-value-calculate-value-button"),e.textContent=i18nString(UIStrings.dots),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.showAllD,{PH1:this.childCount()}));const t=this.children();for(let i=this._maxNumPropertiesToShow;i<this.childCount();++i)t[i].hidden=!0;const n=new UI.TreeOutline.TreeElement(e);n.onselect=this._showAllPropertiesElementSelected.bind(this,n),this.appendChild(n)}revertHighlightChanges(){UI.UIUtils.revertDomChanges(this._highlightChanges),this._highlightChanges=[]}async onpopulate(){const e=this.property.value;console.assert("undefined"!==typeof e);const t=this.treeOutline,n=!!t&&Boolean(t._skipProto),i="__proto__"!==this.property.name?e:parentMap.get(this.property);i&&(await ObjectPropertyTreeElement._populate(this,e,n,this._linkifier,void 0,void 0,void 0,i),this.childCount()>this._maxNumPropertiesToShow&&this._createShowAllPropertiesButton())}ondblclick(e){const t=e.target,n=t.isSelfOrDescendant(this.valueElement)||this.expandedValueElement&&t.isSelfOrDescendant(this.expandedValueElement);return this.property.value&&!this.property.value.customPreview()&&n&&(this.property.writable||this.property.setter)&&this._startEditing(),!1}onenter(){return!(!this.property.value||this.property.value.customPreview()||!this.property.writable&&!this.property.setter)&&(this._startEditing(),!0)}onattach(){this.update(),this._updateExpandable()}onexpand(){this._showExpandedValueElement(!0)}oncollapse(){this._showExpandedValueElement(!1)}_showExpandedValueElement(e){this.expandedValueElement&&(e?this._rowContainer.replaceChild(this.expandedValueElement,this.valueElement):this._rowContainer.replaceChild(this.valueElement,this.expandedValueElement))}_createExpandedValueElement(e){if(!(e.hasChildren&&!e.customPreview()&&"node"!==e.subtype&&"function"!==e.type&&("object"!==e.type||e.preview)))return null;const t=document.createElement("span");return t.classList.add("value"),"Object"===e.description?t.textContent="":t.setTextContentTruncatedIfNeeded(e.description||""),t.classList.add("object-value-"+(e.subtype||e.type)),UI.Tooltip.Tooltip.install(t,e.description||""),ObjectPropertiesSection.appendMemoryIcon(t,e),t}update(){this.nameElement=ObjectPropertiesSection.createNameElement(this.property.name,this.property.private),this.property.enumerable||this.nameElement.classList.add("object-properties-section-dimmed"),this.property.synthetic&&this.nameElement.classList.add("synthetic-property"),this._updatePropertyPath();const e=this.property.synthetic&&"[[Entries]]"===this.property.name;if(e)this.valueElement=document.createElement("span"),this.valueElement.classList.add("value");else if(this.property.value){const e="__proto__"!==this.property.name;this.propertyValue=ObjectPropertiesSection.createPropertyValueWithCustomSupport(this.property.value,this.property.wasThrown,e,this.listItemElement,this._linkifier),this.valueElement=this.propertyValue.element}else this.property.getter?this.valueElement=ObjectPropertyTreeElement.createRemoteObjectAccessorPropertySpan(parentMap.get(this.property),[this.property.name],this._onInvokeGetterClick.bind(this)):(this.valueElement=document.createElement("span"),this.valueElement.classList.add("object-value-undefined"),this.valueElement.textContent=i18nString(UIStrings.unreadable),UI.Tooltip.Tooltip.install(this.valueElement,i18nString(UIStrings.noPropertyGetter)));const t=this.valueElement.textContent;let n;this.property.value&&t&&!this.property.wasThrown&&(this.expandedValueElement=this._createExpandedValueElement(this.property.value)),this.listItemElement.removeChildren(),n=e?UI.Fragment.html`<span class='name-and-value'>${this.nameElement}</span>`:UI.Fragment.html`<span class='name-and-value'>${this.nameElement}: ${this.valueElement}</span>`,this._rowContainer=n,this.listItemElement.appendChild(this._rowContainer)}_updatePropertyPath(){if(UI.Tooltip.Tooltip.getContent(this.nameElement))return;const e=this.property.name;if(this.property.synthetic)return void UI.Tooltip.Tooltip.install(this.nameElement,e);const t=this.parent instanceof ObjectPropertyTreeElement&&this.parent.nameElement&&!this.parent.property.synthetic?UI.Tooltip.Tooltip.getContent(this.parent.nameElement):"";this.property.private||/^(?:[$_\p{ID_Start}])(?:[$_\u200C\u200D\p{ID_Continue}])*$/u.test(e)?UI.Tooltip.Tooltip.install(this.nameElement,t?`${t}.${e}`:e):/^(?:0|[1-9]\d*)$/.test(e)?UI.Tooltip.Tooltip.install(this.nameElement,`${t}[${e}]`):UI.Tooltip.Tooltip.install(this.nameElement,`${t}[${JSON.stringify(e)}]`)}_contextMenuFired(e){const t=new UI.ContextMenu.ContextMenu(e);if(t.appendApplicableItems(this),this.property.symbol&&t.appendApplicableItems(this.property.symbol),this.property.value&&(t.appendApplicableItems(this.property.value),parentMap.get(this.property)instanceof SDK.RemoteObject.LocalJSONObject)){const{value:{value:e}}=this.property,n="object"===typeof e?JSON.stringify(e,null,2):e,i=()=>{Host.userMetrics.actionTaken(Host.UserMetrics.Action.NetworkPanelCopyValue),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(n)};t.clipboardSection().appendItem(i18nString(UIStrings.copyValue),i)}if(!this.property.synthetic&&this.nameElement&&UI.Tooltip.Tooltip.getContent(this.nameElement)){const e=Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText.bind(Host.InspectorFrontendHost.InspectorFrontendHostInstance,UI.Tooltip.Tooltip.getContent(this.nameElement));t.clipboardSection().appendItem(i18nString(UIStrings.copyPropertyPath),e)}parentMap.get(this.property)instanceof SDK.RemoteObject.LocalJSONObject&&(t.viewSection().appendItem(i18nString(UIStrings.expandRecursively),this.expandRecursively.bind(this,Number.MAX_VALUE)),t.viewSection().appendItem(i18nString(UIStrings.collapseChildren),this.collapseChildren.bind(this))),this.propertyValue&&this.propertyValue.appendApplicableItems(e,t,{}),t.show()}_startEditing(){const e=this.treeOutline;if(this._prompt||!e||!e._editable||this._readOnly)return;if(this._editableDiv=this._rowContainer.createChild("span","editable-div"),this.property.value){let e=this.property.value.description;"string"===this.property.value.type&&"string"===typeof e&&(e=`"${e}"`),this._editableDiv.setTextContentTruncatedIfNeeded(e,i18nString(UIStrings.stringIsTooLargeToEdit))}const t=this._editableDiv.textContent||"";this.setExpandable(!1),this.listItemElement.classList.add("editing-sub-part"),this.valueElement.classList.add("hidden"),this._prompt=new ObjectPropertyPrompt;const n=this._prompt.attachAndStartEditing(this._editableDiv,this._editingCommitted.bind(this,t));n.classList.add("property-prompt");const i=this.listItemElement.getComponentSelection();i&&i.selectAllChildren(this._editableDiv),n.addEventListener("keydown",this._promptKeyDown.bind(this,t),!1)}_editingEnded(){this._prompt&&(this._prompt.detach(),delete this._prompt),this._editableDiv.remove(),this._updateExpandable(),this.listItemElement.scrollLeft=0,this.listItemElement.classList.remove("editing-sub-part"),this.select()}_editingCancelled(){this.valueElement.classList.remove("hidden"),this._editingEnded()}async _editingCommitted(e){const t=this._prompt?this._prompt.text():"";t!==e?(this._editingEnded(),await this._applyExpression(t)):this._editingCancelled()}_promptKeyDown(e,t){const n=t;return"Enter"===n.key?(n.consume(),void this._editingCommitted(e)):"Escape"===n.key?(n.consume(),void this._editingCancelled()):void 0}async _applyExpression(e){const t=SDK.RemoteObject.RemoteObject.toCallArgument(this.property.symbol||this.property.name);if(e=JavaScriptREPL.wrapObjectLiteral(e.trim()),this.property.synthetic){let t=!1;if(e&&(t=await this.property.setSyntheticValue(e)),t){const e=this.parent;e&&(e.invalidateChildren(),e.onpopulate())}else this.update();return}const n=parentMap.get(this.property),i=e?n.setPropertyValue(t,e):n.deleteProperty(t);if(await i)this.update();else if(e){const e=this.parent;e&&(e.invalidateChildren(),e.onpopulate())}else this.parent&&this.parent.removeChild(this)}_onInvokeGetterClick(e){e.object&&(this.property.value=e.object,this.property.wasThrown=e.wasThrown||!1,this.update(),this.invalidateChildren(),this._updateExpandable())}_updateExpandable(){this.property.value?this.setExpandable(!this.property.value.customPreview()&&this.property.value.hasChildren&&!this.property.wasThrown):this.setExpandable(!1)}path(){return UI.Tooltip.Tooltip.getContent(this.nameElement)}}export class ArrayGroupingTreeElement extends UI.TreeOutline.TreeElement{constructor(e,t,n,i,r){super(Platform.StringUtilities.sprintf("[%d \u2026 %d]",t,n),!0),this.toggleOnClick=!0,this._fromIndex=t,this._toIndex=n,this._object=e,this._readOnly=!0,this._propertyCount=i,this._linkifier=r}static async _populateArray(e,t,n,i,r){await ArrayGroupingTreeElement._populateRanges(e,t,n,i,!0,r)}static async _populateRanges(e,t,n,i,r,s){const o=await t.callFunctionJSON((function(e,t,n,i,r){if(void 0===e||void 0===t||void 0===i||void 0===r||void 0===n)return;let s=null;const o=t-e>=i&&ArrayBuffer.isView(this),a=o&&t-e>=r;function*l(n){if(void 0!==e&&void 0!==t&&void 0!==i&&void 0!==r)if(t-e<i)for(let i=e;i<=t;++i)i in n&&(yield i);else{s=s||Object.getOwnPropertyNames(n);for(let n=0;n<s.length;++n){const i=s[n],r=Number(i)>>>0;String(r)===i&&e<=r&&r<=t&&(yield r)}}}let p=0;if(o)p=t-e+1;else for(const d of l(this))++p;let c=p;c=p<=n?p:Math.pow(n,Math.ceil(Math.log(p)/Math.log(n))-1);const h=[];if(o)for(let d=e;d<=t;d+=c){const e=d;let n=e+c-1;n>t&&(n=t),h.push([e,n,n-e+1])}else{p=0;let e=-1,t=0;for(const n of l(this))-1===e&&(e=n),t=n,++p===c&&(h.push([e,t,p]),p=0,e=-1);p>0&&h.push([e,t,p])}return{ranges:h,skipGetOwnPropertyNames:a}}),[{value:n},{value:i},{value:ArrayGroupingTreeElement._bucketThreshold},{value:ArrayGroupingTreeElement._sparseIterationThreshold},{value:ArrayGroupingTreeElement._getOwnPropertyNamesThreshold}]);await async function(n){if(!n)return;const i=n.ranges;if(1===i.length)await ArrayGroupingTreeElement._populateAsFragment(e,t,i[0][0],i[0][1],s);else for(let r=0;r<i.length;++r){const n=i[r][0],o=i[r][1],a=i[r][2];n===o?await ArrayGroupingTreeElement._populateAsFragment(e,t,n,o,s):e.appendChild(new ArrayGroupingTreeElement(t,n,o,a,s))}r&&await ArrayGroupingTreeElement._populateNonIndexProperties(e,t,n.skipGetOwnPropertyNames,s)}(o)}static async _populateAsFragment(e,t,n,i,r){const s=await t.callFunction((function(e,t,n){const i=Object.create(null);if(void 0===e||void 0===t||void 0===n)return;if(t-e<n)for(let r=e;r<=t;++r)r in this&&(i[r]=this[r]);else{const n=Object.getOwnPropertyNames(this);for(let r=0;r<n.length;++r){const s=n[r],o=Number(s)>>>0;String(o)===s&&e<=o&&o<=t&&(i[o]=this[o])}}return i}),[{value:n},{value:i},{value:ArrayGroupingTreeElement._sparseIterationThreshold}]);if(!s.object||s.wasThrown)return;const o=s.object,a=await o.getAllProperties(!1,!0);o.release();const l=a.properties;if(l){l.sort(ObjectPropertiesSection.compareProperties);for(let t=0;t<l.length;++t){parentMap.set(l[t],this._object);const n=new ObjectPropertyTreeElement(l[t],r);n._readOnly=!0,e.appendChild(n)}}}static async _populateNonIndexProperties(e,t,n,i){const r=await t.callFunction((function(e){const t={__proto__:this.__proto__};if(e)return t;const n=Object.getOwnPropertyNames(this);for(let i=0;i<n.length;++i){const e=n[i];if(String(Number(e)>>>0)===e&&Number(e)>>>0!==4294967295)continue;const r=Object.getOwnPropertyDescriptor(this,e);r&&Object.defineProperty(t,e,r)}return t}),[{value:n}]);if(!r.object||r.wasThrown)return;const s=await r.object.getOwnProperties(!0);if(r.object.release(),!s.properties)return;const o=s.properties;o.sort(ObjectPropertiesSection.compareProperties);for(const a of o){if(parentMap.set(a,this._object),!ObjectPropertiesSection._isDisplayableProperty(a,e.property))continue;const t=new ObjectPropertyTreeElement(a,i);t._readOnly=!0,e.appendChild(t)}}async onpopulate(){this._propertyCount>=ArrayGroupingTreeElement._bucketThreshold?await ArrayGroupingTreeElement._populateRanges(this,this._object,this._fromIndex,this._toIndex,!1,this._linkifier):await ArrayGroupingTreeElement._populateAsFragment(this,this._object,this._fromIndex,this._toIndex,this._linkifier)}onattach(){this.listItemElement.classList.add("object-properties-section-name")}}ArrayGroupingTreeElement._bucketThreshold=100,ArrayGroupingTreeElement._sparseIterationThreshold=25e4,ArrayGroupingTreeElement._getOwnPropertyNamesThreshold=5e5;export class ObjectPropertyPrompt extends UI.TextPrompt.TextPrompt{constructor(){super();const e=JavaScriptAutocomplete.instance();this.initialize(e.completionsForTextInCurrentContext.bind(e))}}const sectionMap=new Map,cachedResultMap=new Map;export class ObjectPropertiesSectionsTreeExpandController{constructor(e){this._expandedProperties=new Set,e.addEventListener(UI.TreeOutline.Events.ElementAttached,this._elementAttached,this),e.addEventListener(UI.TreeOutline.Events.ElementExpanded,this._elementExpanded,this),e.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this._elementCollapsed,this)}watchSection(e,t){sectionMap.set(t,e),this._expandedProperties.has(e)&&t.expand()}stopWatchSectionsWithId(e){for(const t of this._expandedProperties)t.startsWith(e+":")&&this._expandedProperties.delete(t)}_elementAttached(e){const t=e.data;t.isExpandable()&&this._expandedProperties.has(this._propertyPath(t))&&t.expand()}_elementExpanded(e){const t=e.data;this._expandedProperties.add(this._propertyPath(t))}_elementCollapsed(e){const t=e.data;this._expandedProperties.delete(this._propertyPath(t))}_propertyPath(e){const t=cachedResultMap.get(e);if(t)return t;let n=e,i=n;if(!e.treeOutline)throw new Error("No tree outline available");const r=e.treeOutline.rootElement();let s;for(;n!==r;){let e="";e=n.property?n.property.name:"string"===typeof n.title?n.title:n.title.textContent||"",s=e+(s?"."+s:""),i=n,n.parent&&(n=n.parent)}return s=sectionMap.get(i)+(s?":"+s:""),cachedResultMap.set(e,s),s}}let rendererInstance;export class Renderer{static instance(e={forceNew:!1}){const{forceNew:t}=e;return rendererInstance&&!t||(rendererInstance=new Renderer),rendererInstance}render(e,t){if(!(e instanceof SDK.RemoteObject.RemoteObject))return Promise.reject(new Error("Can't render "+e));const n=(t=t||{title:void 0,editable:void 0}).title,i=new ObjectPropertiesSection(e,n);return n||i.titleLessMode(),i._editable=Boolean(t.editable),Promise.resolve({node:i.element,tree:i})}}export class ObjectPropertyValue{constructor(e){this.element=e}appendApplicableItems(e,t,n){}}export class ExpandableTextPropertyValue extends ObjectPropertyValue{constructor(e,t,n){super(e);const i=e.createChild("span");this._text=t,this._maxLength=n,i.textContent=t.slice(0,n),UI.Tooltip.Tooltip.install(i,`${t.slice(0,n)}\u2026`),this._expandElement=i.createChild("span"),this._maxDisplayableTextLength=1e7;const r=Platform.StringUtilities.countWtf8Bytes(t),s=Platform.NumberUtilities.bytesToString(r);this._text.length<this._maxDisplayableTextLength?(this._expandElementText=i18nString(UIStrings.showMoreS,{PH1:s}),this._expandElement.setAttribute("data-text",this._expandElementText),this._expandElement.classList.add("expandable-inline-button"),this._expandElement.addEventListener("click",this._expandText.bind(this)),this._expandElement.addEventListener("keydown",(e=>{const t=e;"Enter"!==t.key&&" "!==t.key||this._expandText()})),UI.ARIAUtils.markAsButton(this._expandElement)):(this._expandElement.setAttribute("data-text",i18nString(UIStrings.longTextWasTruncatedS,{PH1:s})),this._expandElement.classList.add("undisplayable-text")),this._copyButtonText=i18nString(UIStrings.copy);const o=i.createChild("span","expandable-inline-button");o.setAttribute("data-text",this._copyButtonText),o.addEventListener("click",this._copyText.bind(this)),o.addEventListener("keydown",(e=>{const t=e;"Enter"!==t.key&&" "!==t.key||this._copyText()})),UI.ARIAUtils.markAsButton(o)}appendApplicableItems(e,t,n){this._text.length<this._maxDisplayableTextLength&&this._expandElement&&t.clipboardSection().appendItem(this._expandElementText||"",this._expandText.bind(this)),t.clipboardSection().appendItem(this._copyButtonText,this._copyText.bind(this))}_expandText(){this._expandElement&&(this._expandElement.parentElement&&this._expandElement.parentElement.insertBefore(document.createTextNode(this._text.slice(this._maxLength)),this._expandElement),this._expandElement.remove(),this._expandElement=null)}_copyText(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(this._text)}}