import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as UI from"../ui/ui.js";const UIStrings={graphsDisplayingARealtimeViewOf:"Graphs displaying a real-time view of performance metrics",paused:"Paused",cpuUsage:"CPU usage",jsHeapSize:"JS heap size",domNodes:"DOM Nodes",jsEventListeners:"JS event listeners",documents:"Documents",documentFrames:"Document Frames",layoutsSec:"Layouts / sec",styleRecalcsSec:"Style recalcs / sec"},str_=i18n.i18n.registerUIStrings("performance_monitor/PerformanceMonitor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let performanceMonitorImplInstance,numberFormatter,percentFormatter;export class PerformanceMonitorImpl extends UI.Widget.HBox{constructor(){super(!0),this.registerRequiredCSS("performance_monitor/performanceMonitor.css",{enableLegacyPatching:!0}),this.contentElement.classList.add("perfmon-pane"),this._metricsBuffer=[],this._pixelsPerMs=.01,this._pollIntervalMs=500,this._scaleHeight=16,this._graphHeight=90,this._gridColor=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.08)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),this._controlPane=new ControlPane(this.contentElement);const t=this.contentElement.createChild("div","perfmon-chart-container");this._canvas=t.createChild("canvas"),this._canvas.tabIndex=-1,UI.ARIAUtils.setAccessibleName(this._canvas,i18nString(UIStrings.graphsDisplayingARealtimeViewOf)),this.contentElement.createChild("div","perfmon-chart-suspend-overlay fill").createChild("div").textContent=i18nString(UIStrings.paused),this._controlPane.addEventListener("MetricChanged",this._recalcChartHeight,this),SDK.SDKModel.TargetManager.instance().observeModels(SDK.PerformanceMetricsModel.PerformanceMetricsModel,this)}static instance(t={forceNew:null}){const{forceNew:e}=t;return performanceMonitorImplInstance&&!e||(performanceMonitorImplInstance=new PerformanceMonitorImpl),performanceMonitorImplInstance}wasShown(){this._model&&(SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.SuspendStateChanged,this._suspendStateChanged,this),this._model.enable(),this._suspendStateChanged())}willHide(){this._model&&(SDK.SDKModel.TargetManager.instance().removeEventListener(SDK.SDKModel.Events.SuspendStateChanged,this._suspendStateChanged,this),this._stopPolling(),this._model.disable())}modelAdded(t){this._model||(this._model=t,this.isShowing()&&this.wasShown())}modelRemoved(t){this._model===t&&(this.isShowing()&&this.willHide(),this._model=null)}_suspendStateChanged(){const t=SDK.SDKModel.TargetManager.instance().allTargetsSuspended();t?this._stopPolling():this._startPolling(),this.contentElement.classList.toggle("suspended",t)}_startPolling(){this._startTimestamp=0,this._pollTimer=window.setInterval((()=>this._poll()),this._pollIntervalMs),this.onResize();const t=()=>{this._draw(),this._animationId=this.contentElement.window().requestAnimationFrame((()=>{t()}))};t()}_stopPolling(){window.clearInterval(this._pollTimer),this.contentElement.window().cancelAnimationFrame(this._animationId),this._metricsBuffer=[]}async _poll(){if(!this._model)return;const t=await this._model.requestMetrics(),e=t.timestamp,i=t.metrics;this._metricsBuffer.push({timestamp:e,metrics:i});const r=this._width/this._pixelsPerMs,o=Math.ceil(r/this._pollIntervalMs*2);this._metricsBuffer.length>2*o&&this._metricsBuffer.splice(0,this._metricsBuffer.length-o),this._controlPane.updateMetrics(i)}_draw(){const t=this._canvas.getContext("2d");t.save(),t.scale(window.devicePixelRatio,window.devicePixelRatio),t.clearRect(0,0,this._width,this._height),t.save(),t.translate(0,this._scaleHeight);for(const e of this._controlPane.charts())this._controlPane.isActive(e.metrics[0].name)&&(this._drawChart(t,e,this._graphHeight),t.translate(0,this._graphHeight));t.restore(),this._drawHorizontalGrid(t),t.restore()}_drawHorizontalGrid(t){const e=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.02)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);t.font="10px "+Host.Platform.fontFamily(),t.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground);const i=Date.now()/1e3;for(let r=Math.ceil(i);;--r){const o=this._width-(1e3*(i-r)-this._pollIntervalMs)*this._pixelsPerMs;if(o<-50)break;t.beginPath(),t.moveTo(o,0),t.lineTo(o,this._height),r>=0&&r%10===0&&t.fillText(new Date(1e3*r).toLocaleTimeString(),o+4,12),t.strokeStyle=r%10?e:this._gridColor,t.stroke()}}_drawChart(t,e,i){t.save(),t.rect(0,0,this._width,i),t.clip();const r=1.05*this._calcMax(e),o=e.stacked?new Map:null,s=[];for(let a=e.metrics.length-1;a>=0;--a){const t=e.metrics[a];s.push({path:this._buildMetricPath(e,t,i-8,r,a?o:null),color:t.color})}const n=Common.Color.Color.parse(ThemeSupport.ThemeSupport.instance().patchColorText("white",ThemeSupport.ThemeSupport.ColorUsage.Background));if(n)for(const a of s.reverse()){const e=a.color;t.save();const i=Common.Color.Color.parse(e);i&&(t.fillStyle=n.blendWith(i.setAlpha(.2)).asString(null)||"",t.fill(a.path),t.strokeStyle=e,t.lineWidth=.5,t.stroke(a.path),t.restore())}t.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),t.font=`10px  ${Host.Platform.fontFamily()}`,t.fillText(e.title,8,10),this._drawVerticalGrid(t,i-8,r,e),t.restore()}_calcMax(t){if(t.max)return t.max;const e=this._width,i=performance.now()-this._pollIntervalMs-e/this._pixelsPerMs;let r=-1/0;for(const s of t.metrics)for(let t=this._metricsBuffer.length-1;t>=0;--t){const e=this._metricsBuffer[t],o=e.metrics.get(s.name);if(void 0!==o&&(r=Math.max(r,o)),e.timestamp<i)break}if(!this._metricsBuffer.length)return 10;const o=Math.pow(10,Math.floor(Math.log10(r)));r=Math.ceil(r/o/2)*o*2;return t.currentMax=.2*r+.8*(t.currentMax||r),t.currentMax}_drawVerticalGrid(t,e,i,r){let o=Math.pow(10,Math.floor(Math.log10(i)));const s=Math.floor(i/o);1!==s&&s%2===1&&(o*=2);let n=Math.floor(i/o)*o;const a=i,l=e-18;t.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.55)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),t.strokeStyle=this._gridColor,t.beginPath();for(let c=0;c<2;++c){const e=h(n),i=MetricIndicator._formatNumber(n,r);t.moveTo(0,e),t.lineTo(4,e),t.moveTo(t.measureText(i).width+12,e),t.lineTo(this._width,e),t.fillText(i,8,h(n)+3),n/=2}function h(t){return Math.round(e-l*t/a)+.5}t.stroke(),t.beginPath(),t.moveTo(0,e+.5),t.lineTo(this._width,e+.5),t.strokeStyle=ThemeSupport.ThemeSupport.instance().patchColorText("rgba(0, 0, 0, 0.2)",ThemeSupport.ThemeSupport.ColorUsage.Foreground),t.stroke()}_buildMetricPath(t,e,i,r,o){const s=new Path2D,n=i-18;if(n<1)return s;const a=r,l=e.name,h=this._pixelsPerMs,c=performance.now()-this._pollIntervalMs-this._width/h,m=t.smooth;let p=0,d=0,u=0;this._metricsBuffer.length&&(p=(this._metricsBuffer[0].timestamp-c)*h,s.moveTo(p,g(0)),s.lineTo(this._width+5,g(0)),d=g(this._metricsBuffer[this._metricsBuffer.length-1].metrics.get(l)||0),u=this._width+5,s.lineTo(u,d));for(let _=this._metricsBuffer.length-1;_>=0;--_){const t=this._metricsBuffer[_],e=t.timestamp;let i=t.metrics.get(l)||0;o&&(i+=o.get(e)||0,i=Platform.NumberUtilities.clamp(i,0,1),o.set(e,i));const r=g(i);if(p=(e-c)*h,m){const t=(u+p)/2;s.bezierCurveTo(t,d,t,r,p,r)}else s.lineTo(p,d),s.lineTo(p,r);if(u=p,d=r,e<c)break}return s;function g(t){return Math.round(i-n*t/a)+.5}}onResize(){super.onResize(),this._width=this._canvas.offsetWidth,this._canvas.width=Math.round(this._width*window.devicePixelRatio),this._recalcChartHeight()}_recalcChartHeight(){let t=this._scaleHeight;for(const e of this._controlPane.charts())this._controlPane.isActive(e.metrics[0].name)&&(t+=this._graphHeight);this._height=Math.ceil(t*window.devicePixelRatio),this._canvas.height=this._height,this._canvas.style.height=this._height/window.devicePixelRatio+"px"}}export class ControlPane extends Common.ObjectWrapper.ObjectWrapper{constructor(t){super(),this.element=t.createChild("div","perfmon-control-pane"),this._enabledChartsSetting=Common.Settings.Settings.instance().createSetting("perfmonActiveIndicators2",["TaskDuration","JSHeapTotalSize","Nodes"]),this._enabledCharts=new Set(this._enabledChartsSetting.get());const e={color:void 0,format:void 0,currentMax:void 0,max:void 0,smooth:void 0,stacked:void 0};this._chartsInfo=[{...e,title:i18nString(UIStrings.cpuUsage),metrics:[{name:"TaskDuration",color:"#999"},{name:"ScriptDuration",color:"orange"},{name:"LayoutDuration",color:"blueviolet"},{name:"RecalcStyleDuration",color:"violet"}],format:"Percent",smooth:!0,stacked:!0,color:"red",max:1,currentMax:void 0},{...e,title:i18nString(UIStrings.jsHeapSize),metrics:[{name:"JSHeapTotalSize",color:"#99f"},{name:"JSHeapUsedSize",color:"blue"}],format:"Bytes",color:"blue"},{...e,title:i18nString(UIStrings.domNodes),metrics:[{name:"Nodes",color:"green"}]},{...e,title:i18nString(UIStrings.jsEventListeners),metrics:[{name:"JSEventListeners",color:"yellowgreen"}]},{...e,title:i18nString(UIStrings.documents),metrics:[{name:"Documents",color:"darkblue"}]},{...e,title:i18nString(UIStrings.documentFrames),metrics:[{name:"Frames",color:"darkcyan"}]},{...e,title:i18nString(UIStrings.layoutsSec),metrics:[{name:"LayoutCount",color:"hotpink"}]},{...e,title:i18nString(UIStrings.styleRecalcsSec),metrics:[{name:"RecalcStyleCount",color:"deeppink"}]}];for(const i of this._chartsInfo){i.color&&(i.color=ThemeSupport.ThemeSupport.instance().patchColorText(i.color,ThemeSupport.ThemeSupport.ColorUsage.Foreground));for(const t of i.metrics)t.color=ThemeSupport.ThemeSupport.instance().patchColorText(t.color,ThemeSupport.ThemeSupport.ColorUsage.Foreground)}this._indicators=new Map;for(const i of this._chartsInfo){const t=i.metrics[0].name,e=this._enabledCharts.has(t),r=new MetricIndicator(this.element,i,e,this._onToggle.bind(this,t));this._indicators.set(t,r)}}_onToggle(t,e){e?this._enabledCharts.add(t):this._enabledCharts.delete(t),this._enabledChartsSetting.set(Array.from(this._enabledCharts)),this.dispatchEventToListeners("MetricChanged")}charts(){return this._chartsInfo}isActive(t){return this._enabledCharts.has(t)}updateMetrics(t){for(const e of this._indicators.keys()){const i=t.get(e);if(void 0!==i){const t=this._indicators.get(e);t&&t.setValue(i)}}}}export class MetricIndicator{constructor(t,e,i,r){const o=e.color||e.metrics[0].color;this._info=e,this._active=i,this._onToggle=r,this.element=t.createChild("div","perfmon-indicator"),this._swatchElement=UI.Icon.Icon.create("smallicon-checkmark-square","perfmon-indicator-swatch"),this._swatchElement.style.backgroundColor=o,this.element.appendChild(this._swatchElement),this.element.createChild("div","perfmon-indicator-title").textContent=e.title,this._valueElement=this.element.createChild("div","perfmon-indicator-value"),this._valueElement.style.color=o,this.element.addEventListener("click",(()=>this._toggleIndicator())),this.element.addEventListener("keypress",(t=>this._handleKeypress(t))),this.element.classList.toggle("active",i),UI.ARIAUtils.markAsCheckbox(this.element),UI.ARIAUtils.setChecked(this.element,this._active),this.element.tabIndex=0}static _formatNumber(t,e){switch(numberFormatter||(numberFormatter=new Intl.NumberFormat("en-US",{maximumFractionDigits:1}),percentFormatter=new Intl.NumberFormat("en-US",{maximumFractionDigits:1,style:"percent"})),e.format){case"Percent":return percentFormatter.format(t);case"Bytes":return Platform.NumberUtilities.bytesToString(t);default:return numberFormatter.format(t)}}setValue(t){this._valueElement.textContent=MetricIndicator._formatNumber(t,this._info)}_toggleIndicator(){this._active=!this._active,this.element.classList.toggle("active",this._active),UI.ARIAUtils.setChecked(this.element,this._active),this._onToggle(this._active)}_handleKeypress(t){const e=t;" "!==e.key&&"Enter"!==e.key||this._toggleIndicator()}}export const format=new Intl.NumberFormat("en-US",{maximumFractionDigits:1});