import*as Common from"../common/common.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{FileSystemWorkspaceBinding}from"./FileSystemWorkspaceBinding.js";import{PersistenceBinding,PersistenceImpl}from"./PersistenceImpl.js";let networkPersistenceManagerInstance;export class NetworkPersistenceManager extends Common.ObjectWrapper.ObjectWrapper{constructor(e){super(),this._bindings=new WeakMap,this._originalResponseContentPromises=new WeakMap,this._savingForOverrides=new WeakSet,this._savingSymbol=Symbol("SavingForOverrides"),this._enabledSetting=Common.Settings.Settings.instance().moduleSetting("persistenceNetworkOverridesEnabled"),this._enabledSetting.addChangeListener(this._enabledChanged,this),this._workspace=e,this._networkUISourceCodeForEncodedPath=new Map,this._interceptionHandlerBound=this._interceptionHandler.bind(this),this._updateInterceptionThrottler=new Common.Throttler.Throttler(50),this._project=null,this._activeProject=null,this._active=!1,this._enabled=!1,this._workspace.addEventListener(Workspace.Workspace.Events.ProjectAdded,(e=>{this._onProjectAdded(e.data)})),this._workspace.addEventListener(Workspace.Workspace.Events.ProjectRemoved,(e=>{this._onProjectRemoved(e.data)})),PersistenceImpl.instance().addNetworkInterceptor(this._canHandleNetworkUISourceCode.bind(this)),this._eventDescriptors=[],this._enabledChanged()}static instance(e={forceNew:null,workspace:null}){const{forceNew:t,workspace:o}=e;if(!networkPersistenceManagerInstance||t){if(!o)throw new Error("Missing workspace for NetworkPersistenceManager");networkPersistenceManagerInstance=new NetworkPersistenceManager(o)}return networkPersistenceManagerInstance}active(){return this._active}project(){return this._project}originalContentForUISourceCode(e){const t=this._bindings.get(e);if(!t)return null;const o=t.fileSystem;return this._originalResponseContentPromises.get(o)||null}async _enabledChanged(){this._enabled!==this._enabledSetting.get()&&(this._enabled=this._enabledSetting.get(),this._enabled?(this._eventDescriptors=[Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRenamed,(e=>{this._uiSourceCodeRenamedListener(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,(e=>{this._uiSourceCodeAdded(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,(e=>{this._uiSourceCodeRemovedListener(e)})),Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.WorkingCopyCommitted,(e=>this._onUISourceCodeWorkingCopyCommitted(e.data.uiSourceCode)))],await this._updateActiveProject()):(Common.EventTarget.EventTarget.removeEventListeners(this._eventDescriptors),await this._updateActiveProject()))}async _uiSourceCodeRenamedListener(e){const t=e.data.uiSourceCode;await this._onUISourceCodeRemoved(t),await this._onUISourceCodeAdded(t)}async _uiSourceCodeRemovedListener(e){await this._onUISourceCodeRemoved(e.data)}async _uiSourceCodeAdded(e){await this._onUISourceCodeAdded(e.data)}async _updateActiveProject(){const e=this._active;if(this._active=Boolean(this._enabledSetting.get()&&SDK.SDKModel.TargetManager.instance().mainTarget()&&this._project),this._active!==e){if(this._active&&this._project){await Promise.all(this._project.uiSourceCodes().map((e=>this._filesystemUISourceCodeAdded(e))));const e=this._workspace.projectsForType(Workspace.Workspace.projectTypes.Network);for(const t of e)await Promise.all(t.uiSourceCodes().map((e=>this._networkUISourceCodeAdded(e))))}else this._project&&(await Promise.all(this._project.uiSourceCodes().map((e=>this._filesystemUISourceCodeRemoved(e)))),this._networkUISourceCodeForEncodedPath.clear());PersistenceImpl.instance().refreshAutomapping()}}_encodedPathFromUrl(e){if(!this._active||!this._project)return"";let t=Common.ParsedURL.ParsedURL.urlWithoutHash(e.replace(/^https?:\/\//,""));t.endsWith("/")&&-1===t.indexOf("?")&&(t+="index.html");let o=function(e){const t=[];for(const o of function(e){const t=(e=Common.ParsedURL.ParsedURL.urlWithoutHash(e)).indexOf("?");if(-1===t)return e.split("/");if(0===t)return[e];const o=e.substr(t),r=e.substr(0,e.length-o.length).split("/");return r[r.length-1]+=o,r}(e)){if(!o)continue;let e=encodeURI(o).replace(/[\/:\?\*]/g,(e=>"%"+e[0].charCodeAt(0).toString(16)));RESERVED_FILENAMES.has(e.toLowerCase())&&(e=e.split("").map((e=>"%"+e.charCodeAt(0).toString(16))).join(""));"."===e.charAt(e.length-1)&&(e=e.substr(0,e.length-1)+"%2e"),t.push(e)}return t}(t);const r=FileSystemWorkspaceBinding.fileSystemPath(this._project.id()),s=o.join("/");if(r.length+s.length>200){const e=o[0],r=o[o.length-1],n=r?r.substr(0,10)+"-":"",i=Common.ParsedURL.ParsedURL.extractExtension(t),a=i?"."+i.substr(0,10):"";o=[e,"longurls",n+Platform.StringUtilities.hashCode(s).toString(16)+a]}return o.join("/")}_decodeLocalPathToUrlPath(e){try{return unescape(e)}catch(t){console.error(t)}return e}async _unbind(e){const t=this._bindings.get(e);t&&(this._bindings.delete(t.network),this._bindings.delete(t.fileSystem),await PersistenceImpl.instance().removeBinding(t))}async _bind(e,t){this._bindings.has(e)&&await this._unbind(e),this._bindings.has(t)&&await this._unbind(t);const o=new PersistenceBinding(e,t);this._bindings.set(e,o),this._bindings.set(t,o),await PersistenceImpl.instance().addBinding(o);const r=this._savingForOverrides.has(e)?e:t,[{content:s},n]=await Promise.all([r.requestContent(),r.contentEncoded()]);PersistenceImpl.instance().syncContent(r,s||"",n)}_onUISourceCodeWorkingCopyCommitted(e){this.saveUISourceCodeForOverrides(e)}canSaveUISourceCodeForOverrides(e){return this._active&&e.project().type()===Workspace.Workspace.projectTypes.Network&&!this._bindings.has(e)&&!this._savingForOverrides.has(e)}async saveUISourceCodeForOverrides(e){if(!this.canSaveUISourceCodeForOverrides(e))return;this._savingForOverrides.add(e);let t=this._encodedPathFromUrl(e.url());const o=(await e.requestContent()).content||"",r=await e.contentEncoded(),s=t.lastIndexOf("/"),n=t.substr(s+1);t=t.substr(0,s),this._project&&await this._project.createFile(t,n,o,r),this._fileCreatedForTest(t,n),this._savingForOverrides.delete(e)}_fileCreatedForTest(e,t){}_patternForFileSystemUISourceCode(e){const t=FileSystemWorkspaceBinding.relativePath(e);return t.length<2?"":"longurls"===t[1]&&2!==t.length?"http?://"+t[0]+"/*":"http?://"+this._decodeLocalPathToUrlPath(t.join("/"))}async _onUISourceCodeAdded(e){await this._networkUISourceCodeAdded(e),await this._filesystemUISourceCodeAdded(e)}_canHandleNetworkUISourceCode(e){return this._active&&!e.url().startsWith("snippet://")}async _networkUISourceCodeAdded(e){if(e.project().type()!==Workspace.Workspace.projectTypes.Network||!this._canHandleNetworkUISourceCode(e))return;const t=Common.ParsedURL.ParsedURL.urlWithoutHash(e.url());this._networkUISourceCodeForEncodedPath.set(this._encodedPathFromUrl(t),e);const o=this._project,r=o.uiSourceCodeForURL(o.fileSystemPath()+"/"+this._encodedPathFromUrl(t));r&&await this._bind(e,r)}async _filesystemUISourceCodeAdded(e){if(!this._active||e.project()!==this._project)return;this._updateInterceptionPatterns();const t=FileSystemWorkspaceBinding.relativePath(e),o=this._networkUISourceCodeForEncodedPath.get(t.join("/"));o&&await this._bind(o,e)}_updateInterceptionPatterns(){this._updateInterceptionThrottler.schedule(function(){if(!this._active||!this._project)return SDK.NetworkManager.MultitargetNetworkManager.instance().setInterceptionHandlerForPatterns([],this._interceptionHandlerBound);const e=new Set,t="index.html";for(const o of this._project.uiSourceCodes()){const r=this._patternForFileSystemUISourceCode(o);e.add(r),r.endsWith("/index.html")&&e.add(r.substr(0,r.length-t.length))}return SDK.NetworkManager.MultitargetNetworkManager.instance().setInterceptionHandlerForPatterns(Array.from(e).map((e=>({urlPattern:e,interceptionStage:Protocol.Network.InterceptionStage.HeadersReceived}))),this._interceptionHandlerBound)}.bind(this))}async _onUISourceCodeRemoved(e){await this._networkUISourceCodeRemoved(e),await this._filesystemUISourceCodeRemoved(e)}async _networkUISourceCodeRemoved(e){e.project().type()===Workspace.Workspace.projectTypes.Network&&(await this._unbind(e),this._networkUISourceCodeForEncodedPath.delete(this._encodedPathFromUrl(e.url())))}async _filesystemUISourceCodeRemoved(e){e.project()===this._project&&(this._updateInterceptionPatterns(),this._originalResponseContentPromises.delete(e),await this._unbind(e))}async _setProject(e){e!==this._project&&(this._project&&await Promise.all(this._project.uiSourceCodes().map((e=>this._filesystemUISourceCodeRemoved(e)))),this._project=e,this._project&&await Promise.all(this._project.uiSourceCodes().map((e=>this._filesystemUISourceCodeAdded(e)))),await this._updateActiveProject(),this.dispatchEventToListeners(Events.ProjectChanged,this._project))}async _onProjectAdded(e){if(e.type()!==Workspace.Workspace.projectTypes.FileSystem||"overrides"!==FileSystemWorkspaceBinding.fileSystemType(e))return;FileSystemWorkspaceBinding.fileSystemPath(e.id())&&(this._project&&this._project.remove(),await this._setProject(e))}async _onProjectRemoved(e){e===this._project&&await this._setProject(null)}async _interceptionHandler(e){const t=e.request.method;if(!this._active||"GET"!==t&&"POST"!==t)return;const o=this._project,r=o.fileSystemPath()+"/"+this._encodedPathFromUrl(e.request.url),s=o.uiSourceCodeForURL(r);if(!s)return;let n="";if(e.responseHeaders){n=SDK.NetworkManager.NetworkManager.lowercaseHeaders(e.responseHeaders)["content-type"]}if(!n){const t=Common.ResourceType.resourceTypes[e.resourceType]||Common.ResourceType.resourceTypes.Other;n=s.mimeType(),Common.ResourceType.ResourceType.fromMimeType(n)!==t&&(n=t.canonicalMimeType())}const i=s.project();this._originalResponseContentPromises.set(s,e.responseBody().then((e=>e.error||null===e.content?null:e.encoded?atob(e.content):e.content)));const a=await i.requestFileBlob(s);a&&e.continueRequestWithContent(new Blob([a],{type:n}))}}const RESERVED_FILENAMES=new Set(["con","prn","aux","nul","com1","com2","com3","com4","com5","com6","com7","com8","com9","lpt1","lpt2","lpt3","lpt4","lpt5","lpt6","lpt7","lpt8","lpt9"]);export const Events={ProjectChanged:Symbol("ProjectChanged")};