import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{Automapping}from"./Automapping.js";import{LinkDecorator}from"./PersistenceUtils.js";let persistenceInstance;export class PersistenceImpl extends Common.ObjectWrapper.ObjectWrapper{constructor(e,n){super(),this._workspace=e,this._breakpointManager=n,this._filePathPrefixesToBindingCount=new Map,this._subscribedBindingEventListeners=new Platform.MapUtilities.Multimap;const t=new LinkDecorator(this);Components.Linkifier.Linkifier.setLinkDecorator(t),this._mapping=new Automapping(this._workspace,this._onStatusAdded.bind(this),this._onStatusRemoved.bind(this))}static instance(e={forceNew:null,workspace:null,breakpointManager:null}){const{forceNew:n,workspace:t,breakpointManager:i}=e;if(!persistenceInstance||n){if(!t||!i)throw new Error("Missing arguments for workspace");persistenceInstance=new PersistenceImpl(t,i)}return persistenceInstance}addNetworkInterceptor(e){this._mapping.addNetworkInterceptor(e)}refreshAutomapping(){this._mapping.scheduleRemap()}async addBinding(e){await this._innerAddBinding(e)}async addBindingForTest(e){await this._innerAddBinding(e)}async removeBinding(e){await this._innerRemoveBinding(e)}async removeBindingForTest(e){await this._innerRemoveBinding(e)}async _innerAddBinding(e){bindings.set(e.network,e),bindings.set(e.fileSystem,e),e.fileSystem.forceLoadOnCheckContent(),e.network.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._onWorkingCopyCommitted,this),e.fileSystem.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._onWorkingCopyCommitted,this),e.network.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._onWorkingCopyChanged,this),e.fileSystem.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._onWorkingCopyChanged,this),this._addFilePathBindingPrefixes(e.fileSystem.url()),await this._moveBreakpoints(e.fileSystem,e.network),console.assert(!e.fileSystem.isDirty()||!e.network.isDirty()),e.fileSystem.isDirty()?this._syncWorkingCopy(e.fileSystem):e.network.isDirty()?this._syncWorkingCopy(e.network):e.network.hasCommits()&&e.network.content()!==e.fileSystem.content()&&(e.network.setWorkingCopy(e.network.content()),this._syncWorkingCopy(e.network)),this._notifyBindingEvent(e.network),this._notifyBindingEvent(e.fileSystem),this.dispatchEventToListeners(Events.BindingCreated,e)}async _innerRemoveBinding(e){bindings.get(e.network)===e&&(console.assert(bindings.get(e.network)===bindings.get(e.fileSystem),"ERROR: inconsistent binding for networkURL "+e.network.url()),bindings.delete(e.network),bindings.delete(e.fileSystem),e.network.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._onWorkingCopyCommitted,this),e.fileSystem.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._onWorkingCopyCommitted,this),e.network.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._onWorkingCopyChanged,this),e.fileSystem.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._onWorkingCopyChanged,this),this._removeFilePathBindingPrefixes(e.fileSystem.url()),await this._breakpointManager.copyBreakpoints(e.network.url(),e.fileSystem),this._notifyBindingEvent(e.network),this._notifyBindingEvent(e.fileSystem),this.dispatchEventToListeners(Events.BindingRemoved,e))}async _onStatusAdded(e){const n=new PersistenceBinding(e.network,e.fileSystem);statusBindings.set(e,n),await this._innerAddBinding(n)}async _onStatusRemoved(e){const n=statusBindings.get(e);await this._innerRemoveBinding(n)}_onWorkingCopyChanged(e){const n=e.data;this._syncWorkingCopy(n)}_syncWorkingCopy(e){const n=bindings.get(e);if(!n||mutedWorkingCopies.has(n))return;const t=n.network===e?n.fileSystem:n.network;if(!e.isDirty())return mutedWorkingCopies.add(n),t.resetWorkingCopy(),mutedWorkingCopies.delete(n),void this._contentSyncedForTest();const i=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(n.network);if(i&&i.type()===SDK.SDKModel.Type.Node){const n=e.workingCopy();t.requestContent().then((()=>{const e=PersistenceImpl.rewrapNodeJSContent(t,t.workingCopy(),n);o.call(this,(()=>e))}))}else o.call(this,(()=>e.workingCopy()));function o(e){n&&mutedWorkingCopies.add(n),t.setWorkingCopyGetter(e),n&&mutedWorkingCopies.delete(n),this._contentSyncedForTest()}}_onWorkingCopyCommitted(e){const n=e.data.uiSourceCode,t=e.data.content;this.syncContent(n,t,e.data.encoded)}syncContent(e,n,t){const i=bindings.get(e);if(!i||mutedCommits.has(i))return;const o=i.network===e?i.fileSystem:i.network,s=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(i.network);function r(e){i&&mutedCommits.add(i),o.setContent(e,t),i&&mutedCommits.delete(i),this._contentSyncedForTest()}s&&s.type()===SDK.SDKModel.Type.Node?o.requestContent().then((e=>{const t=PersistenceImpl.rewrapNodeJSContent(o,e.content||"",n);r.call(this,t)})):r.call(this,n)}static rewrapNodeJSContent(e,n,t){return e.project().type()===Workspace.Workspace.projectTypes.FileSystem?(t.startsWith(NodePrefix)&&t.endsWith(NodeSuffix)&&(t=t.substring(NodePrefix.length,t.length-NodeSuffix.length)),n.startsWith(NodeShebang)&&(t=NodeShebang+t)):(t.startsWith(NodeShebang)&&(t=t.substring(NodeShebang.length)),n.startsWith(NodePrefix)&&n.endsWith(NodeSuffix)&&(t=NodePrefix+t+NodeSuffix)),t}_contentSyncedForTest(){}async _moveBreakpoints(e,n){const t=this._breakpointManager.breakpointLocationsForUISourceCode(e).map((e=>e.breakpoint));await Promise.all(t.map((e=>(e.remove(!1),this._breakpointManager.setBreakpoint(n,e.lineNumber(),e.columnNumber(),e.condition(),e.enabled())))))}hasUnsavedCommittedChanges(e){return!this._workspace.hasResourceContentTrackingExtensions()&&(!e.project().canSetFileContent()&&(!bindings.has(e)&&Boolean(e.hasCommits())))}binding(e){return bindings.get(e)||null}subscribeForBindingEvent(e,n){this._subscribedBindingEventListeners.set(e,n)}unsubscribeFromBindingEvent(e,n){this._subscribedBindingEventListeners.delete(e,n)}_notifyBindingEvent(e){if(!this._subscribedBindingEventListeners.has(e))return;const n=Array.from(this._subscribedBindingEventListeners.get(e));for(const t of n)t.call(null)}fileSystem(e){const n=this.binding(e);return n?n.fileSystem:null}network(e){const n=this.binding(e);return n?n.network:null}_addFilePathBindingPrefixes(e){let n="";for(const t of e.split("/")){n+=t+"/";const e=this._filePathPrefixesToBindingCount.get(n)||0;this._filePathPrefixesToBindingCount.set(n,e+1)}}_removeFilePathBindingPrefixes(e){let n="";for(const t of e.split("/")){n+=t+"/";const e=this._filePathPrefixesToBindingCount.get(n);1===e?this._filePathPrefixesToBindingCount.delete(n):void 0!==e&&this._filePathPrefixesToBindingCount.set(n,e-1)}}filePathHasBindings(e){return e.endsWith("/")||(e+="/"),this._filePathPrefixesToBindingCount.has(e)}}const bindings=new WeakMap,statusBindings=new WeakMap,mutedCommits=new WeakSet,mutedWorkingCopies=new WeakSet;export const NodePrefix="(function (exports, require, module, __filename, __dirname) { ";export const NodeSuffix="\n});";export const NodeShebang="#!/usr/bin/env node";export const Events={BindingCreated:Symbol("BindingCreated"),BindingRemoved:Symbol("BindingRemoved")};export class PathEncoder{constructor(){this._encoder=new Common.CharacterIdMap.CharacterIdMap}encode(e){return e.split("/").map((e=>this._encoder.toChar(e))).join("")}decode(e){return e.split("").map((e=>this._encoder.fromChar(e))).join("/")}}export class PersistenceBinding{constructor(e,n){this.network=e,this.fileSystem=n}}