import*as Common from"../common/common.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";const UIStrings={jsHeap:"JS Heap",allocatedJsHeapSizeCurrentlyIn:"Allocated JS heap size currently in use",vms:"VMs",numberOfVmsSharingTheSameScript:"Number of VMs sharing the same script source",scriptUrl:"Script URL",urlOfTheScriptSource:"URL of the script source",heapProfile:"Heap Profile",anonymousScriptS:"(Anonymous Script {PH1})",kb:"kB"},str_=i18n.i18n.registerUIStrings("profiler/LiveHeapProfileView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let liveHeapProfileViewInstance,profilerActionDelegateInstance;export class LiveHeapProfileView extends UI.Widget.VBox{constructor(){super(!0),this._gridNodeByUrl=new Map,this.registerRequiredCSS("profiler/liveHeapProfile.css",{enableLegacyPatching:!0}),this._setting=Common.Settings.Settings.instance().moduleSetting("memoryLiveHeapProfile");const e=new UI.Toolbar.Toolbar("live-heap-profile-toolbar",this.contentElement);this._toggleRecordAction=UI.ActionRegistry.ActionRegistry.instance().action("live-heap-profile.toggle-recording"),this._toggleRecordButton=UI.Toolbar.Toolbar.createActionButton(this._toggleRecordAction),this._toggleRecordButton.setToggled(this._setting.get()),e.appendToolbarItem(this._toggleRecordButton);const t=SDK.SDKModel.TargetManager.instance().mainTarget();if(t&&t.model(SDK.ResourceTreeModel.ResourceTreeModel)){const t=UI.ActionRegistry.ActionRegistry.instance().action("live-heap-profile.start-with-reload");this._startWithReloadButton=UI.Toolbar.Toolbar.createActionButton(t),e.appendToolbarItem(this._startWithReloadButton)}this._dataGrid=this._createDataGrid(),this._dataGrid.asWidget().show(this.contentElement),this._currentPollId=0}static instance(){return liveHeapProfileViewInstance||(liveHeapProfileViewInstance=new LiveHeapProfileView),liveHeapProfileViewInstance}_createDataGrid(){const e={id:"",title:Common.UIString.LocalizedEmptyString,width:void 0,fixedWidth:!0,sortable:!0,align:DataGrid.DataGrid.Align.Right,sort:DataGrid.DataGrid.Order.Descending,titleDOMFragment:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,weight:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},t=[{...e,id:"size",title:i18nString(UIStrings.jsHeap),width:"72px",fixedWidth:!0,sortable:!0,align:DataGrid.DataGrid.Align.Right,sort:DataGrid.DataGrid.Order.Descending,tooltip:i18nString(UIStrings.allocatedJsHeapSizeCurrentlyIn)},{...e,id:"isolates",title:i18nString(UIStrings.vms),width:"40px",fixedWidth:!0,align:DataGrid.DataGrid.Align.Right,tooltip:i18nString(UIStrings.numberOfVmsSharingTheSameScript)},{...e,id:"url",title:i18nString(UIStrings.scriptUrl),fixedWidth:!1,sortable:!0,tooltip:i18nString(UIStrings.urlOfTheScriptSource)}],i=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.heapProfile),columns:t,editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0});i.setResizeMethod(DataGrid.DataGrid.ResizeMethod.Last),i.element.classList.add("flex-auto"),i.element.addEventListener("keydown",this._onKeyDown.bind(this),!1),i.addEventListener(DataGrid.DataGrid.Events.OpenedNode,this._revealSourceForSelectedNode,this),i.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortingChanged,this);for(const r of t){const e=i.headerTableHeader(r.id);e&&e.setAttribute("title",r.tooltip)}return i}wasShown(){this._poll(),this._setting.addChangeListener(this._settingChanged,this)}willHide(){++this._currentPollId,this._setting.removeChangeListener(this._settingChanged,this)}_settingChanged(e){this._toggleRecordButton.setToggled(e.data)}async _poll(){const e=this._currentPollId;do{const t=Array.from(SDK.IsolateManager.IsolateManager.instance().isolates()),i=await Promise.all(t.map((e=>{const t=e.heapProfilerModel();return t?t.getSamplingProfile():null})));if(this._currentPollId!==e)return;this._update(t,i),await new Promise((e=>setTimeout(e,3e3)))}while(this._currentPollId===e)}_update(e,t){const i=new Map;t.forEach(((t,i)=>{t&&n(e[i],"",t.head)}));const r=this._dataGrid.rootNode(),o=new Set;for(const a of i){const e=a[0],t=a[1].size,i=a[1].isolates.size;if(!e){console.info(`Node with empty URL: ${t} bytes`);continue}let n=this._gridNodeByUrl.get(e);n?n.updateNode(t,i):(n=new GridNode(e,t,i),this._gridNodeByUrl.set(e,n),r.appendChild(n)),o.add(n)}for(const a of r.children.slice()){o.has(a)||a.remove();const e=a;this._gridNodeByUrl.delete(e._url)}function n(e,t,r){const o=r.callFrame.url||t||function(e){const t=e.callFrame.functionName;return t.startsWith("(")&&"(root)"!==t?t:""}(r)||function(e){return Number(e.callFrame.scriptId)?i18nString(UIStrings.anonymousScriptS,{PH1:e.callFrame.scriptId}):""}(r);if(r.children.forEach(n.bind(null,e,o)),!r.selfSize)return;let a=i.get(o);a||(a={size:0,isolates:new Set},i.set(o,a)),a.size+=r.selfSize,a.isolates.add(e)}this._sortingChanged()}_onKeyDown(e){"Enter"===e.key&&(e.consume(!0),this._revealSourceForSelectedNode())}_revealSourceForSelectedNode(){const e=this._dataGrid.selectedNode;if(!e||!e._url)return;const t=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(e._url);t&&Common.Revealer.reveal(t)}_sortingChanged(){const e=this._dataGrid.sortColumnId();if(!e)return;const t="url"===e?function(e,t){return t._url.localeCompare(e._url)}:function(e,t){return t._size-e._size};this._dataGrid.sortNodes(t,this._dataGrid.isSortOrderAscending())}_toggleRecording(){!this._setting.get()?this._startRecording(!1):this._stopRecording()}_startRecording(e){if(this._setting.set(!0),!e)return;const t=SDK.SDKModel.TargetManager.instance().mainTarget();if(!t)return;const i=t.model(SDK.ResourceTreeModel.ResourceTreeModel);i&&i.reloadPage()}async _stopRecording(){this._setting.set(!1)}}export class GridNode extends DataGrid.SortableDataGrid.SortableDataGridNode{constructor(e,t,i){super(),this._url=e,this._size=t,this._isolateCount=i}updateNode(e,t){this._size===e&&this._isolateCount===t||(this._size=e,this._isolateCount=t,this.refresh())}createCell(e){const t=this.createTD(e);switch(e){case"url":t.textContent=this._url;break;case"size":t.textContent=Number.withThousandsSeparator(Math.round(this._size/1e3)),t.createChild("span","size-units").textContent=i18nString(UIStrings.kb);break;case"isolates":t.textContent=`${this._isolateCount}`}return t}}export class ActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return profilerActionDelegateInstance&&!t||(profilerActionDelegateInstance=new ActionDelegate),profilerActionDelegateInstance}handleAction(e,t){return(async()=>{const e="live_heap_profile";await UI.ViewManager.ViewManager.instance().showView(e);const i=UI.ViewManager.ViewManager.instance().view(e);if(i){const e=await i.widget();this._innerHandleAction(e,t)}})(),!0}_innerHandleAction(e,t){switch(t){case"live-heap-profile.toggle-recording":e._toggleRecording();break;case"live-heap-profile.start-with-reload":e._startRecording(!0);break;default:console.assert(!1,`Unknown action: ${t}`)}}}