import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as UI from"../ui/ui.js";import{BottomUpProfileDataGridTree}from"./BottomUpProfileDataGrid.js";import{CPUProfileFlameChart}from"./CPUProfileFlameChart.js";import{ProfileDataGridTree}from"./ProfileDataGrid.js";import{Events,ProfileHeader}from"./ProfileHeader.js";import{ProfileSidebarTreeElement}from"./ProfileSidebarTreeElement.js";import{TopDownProfileDataGridTree}from"./TopDownProfileDataGrid.js";const UIStrings={profile:"Profile",findByCostMsNameOrFile:"Find by cost (>50ms), name or file",function:"Function",profiler:"Profiler",profileViewMode:"Profile view mode",focusSelectedFunction:"Focus selected function",excludeSelectedFunction:"Exclude selected function",restoreAllFunctions:"Restore all functions",chart:"Chart",heavyBottomUp:"Heavy (Bottom Up)",treeTopDown:"Tree (Top Down)",profileD:"Profile {PH1}",loadingD:"Loading\u2026 {PH1}%",fileSReadErrorS:"File '{PH1}' read error: {PH2}",loading:"Loading\u2026",failedToReadFile:"Failed to read file",parsing:"Parsing\u2026",loaded:"Loaded"},str_=i18n.i18n.registerUIStrings("profiler/ProfileView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ProfileView extends UI.View.SimpleView{constructor(){super(i18nString(UIStrings.profile)),this._profile=null,this._searchableView=new UI.SearchableView.SearchableView(this,null),this._searchableView.setPlaceholder(i18nString(UIStrings.findByCostMsNameOrFile)),this._searchableView.show(this.element);const e=[];e.push({id:"self",title:this.columnHeader("self"),width:"120px",fixedWidth:!0,sortable:!0,sort:DataGrid.DataGrid.Order.Descending,titleDOMFragment:void 0,align:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,weight:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0}),e.push({id:"total",title:this.columnHeader("total"),width:"120px",fixedWidth:!0,sortable:!0,sort:void 0,titleDOMFragment:void 0,align:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,weight:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0}),e.push({id:"function",title:i18nString(UIStrings.function),disclosure:!0,sortable:!0,sort:void 0,titleDOMFragment:void 0,align:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,weight:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0,width:void 0,fixedWidth:void 0}),this.dataGrid=new DataGrid.DataGrid.DataGridImpl({displayName:i18nString(UIStrings.profiler),columns:e,editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this.dataGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortProfile,this),this.dataGrid.addEventListener(DataGrid.DataGrid.Events.SelectedNode,this._nodeSelected.bind(this,!0)),this.dataGrid.addEventListener(DataGrid.DataGrid.Events.DeselectedNode,this._nodeSelected.bind(this,!1)),this.dataGrid.setRowContextMenuCallback(this._populateContextMenu.bind(this)),this.viewSelectComboBox=new UI.Toolbar.ToolbarComboBox(this._changeView.bind(this),i18nString(UIStrings.profileViewMode)),this.focusButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.focusSelectedFunction),"largeicon-visibility"),this.focusButton.setEnabled(!1),this.focusButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._focusClicked,this),this.excludeButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.excludeSelectedFunction),"largeicon-delete"),this.excludeButton.setEnabled(!1),this.excludeButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._excludeClicked,this),this.resetButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.restoreAllFunctions),"largeicon-refresh"),this.resetButton.setEnabled(!1),this.resetButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._resetClicked,this),this._linkifier=new Components.Linkifier.Linkifier(maxLinkLength)}static buildPopoverTable(e){const t=document.createElement("table");for(const i of e){const e=t.createChild("tr");e.createChild("td").textContent=i.title,e.createChild("td").textContent=i.value}return t}setProfile(e){this._profile=e,this._bottomUpProfileDataGridTree=null,this._topDownProfileDataGridTree=null,this._changeView(),this.refresh()}profile(){return this._profile}initialize(e){this._nodeFormatter=e,this._viewType=Common.Settings.Settings.instance().createSetting("profileView","Heavy");const t=["Flame","Heavy","Tree"],i=new Map([["Flame",i18nString(UIStrings.chart)],["Heavy",i18nString(UIStrings.heavyBottomUp)],["Tree",i18nString(UIStrings.treeTopDown)]]),r=new Map(t.map((e=>[e,this.viewSelectComboBox.createOption(i.get(e),e)]))),o=this._viewType.get()||t[0],s=r.get(o)||r.get(t[0]);this.viewSelectComboBox.select(s),this._changeView(),this._flameChart&&this._flameChart.update()}focus(){this._flameChart?this._flameChart.focus():super.focus()}columnHeader(e){throw"Not implemented"}selectRange(e,t){this._flameChart&&this._flameChart.selectRange(e,t)}async toolbarItems(){return[this.viewSelectComboBox,this.focusButton,this.excludeButton,this.resetButton]}_getBottomUpProfileDataGridTree(){return this._bottomUpProfileDataGridTree||(this._bottomUpProfileDataGridTree=new BottomUpProfileDataGridTree(this._nodeFormatter,this._searchableView,this._profile.root,this.adjustedTotal)),this._bottomUpProfileDataGridTree}_getTopDownProfileDataGridTree(){return this._topDownProfileDataGridTree||(this._topDownProfileDataGridTree=new TopDownProfileDataGridTree(this._nodeFormatter,this._searchableView,this._profile.root,this.adjustedTotal)),this._topDownProfileDataGridTree}_populateContextMenu(e,t){const i=t;i.linkElement&&!e.containsTarget(i.linkElement)&&e.appendApplicableItems(i.linkElement)}willHide(){this._currentSearchResultIndex=-1}refresh(){if(!this.profileDataGridTree)return;const e=this.dataGrid.selectedNode?this.dataGrid.selectedNode.profileNode:null;this.dataGrid.rootNode().removeChildren();const t=this.profileDataGridTree.children,i=t.length;for(let r=0;r<i;++r)this.dataGrid.rootNode().appendChild(t[r]);e&&(e.selected=!0)}refreshVisibleData(){let e=this.dataGrid.rootNode().children[0];for(;e;)e.refresh(),e=e.traverseNextNode(!1,null,!0)}searchableView(){return this._searchableView}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!1}searchCanceled(){this._searchableElement&&this._searchableElement.searchCanceled()}performSearch(e,t,i){this._searchableElement&&this._searchableElement.performSearch(e,t,i)}jumpToNextSearchResult(){this._searchableElement&&this._searchableElement.jumpToNextSearchResult()}jumpToPreviousSearchResult(){this._searchableElement&&this._searchableElement.jumpToPreviousSearchResult()}linkifier(){return this._linkifier}createFlameChartDataProvider(){throw"Not implemented"}_ensureFlameChartCreated(){this._flameChart||(this._dataProvider=this.createFlameChartDataProvider(),this._flameChart=new CPUProfileFlameChart(this._searchableView,this._dataProvider),this._flameChart.addEventListener(PerfUI.FlameChart.Events.EntryInvoked,(e=>{this._onEntryInvoked(e)})))}async _onEntryInvoked(e){if(!this._dataProvider)return;const t=e.data,i=this._dataProvider._entryNodes[t],r=this.profileHeader._debuggerModel;if(!i||!i.scriptId||!r)return;const o=r.scriptForId(i.scriptId);if(!o)return;const s=r.createRawLocation(o,i.lineNumber,i.columnNumber),a=await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(s);Common.Revealer.reveal(a)}_changeView(){if(!this._profile)return;switch(this._searchableView.closeSearch(),this._visibleView&&this._visibleView.detach(),this._viewType.set(this.viewSelectComboBox.selectedOption().value),this._viewType.get()){case"Flame":this._ensureFlameChartCreated(),this._visibleView=this._flameChart,this._searchableElement=this._flameChart;break;case"Tree":this.profileDataGridTree=this._getTopDownProfileDataGridTree(),this._sortProfile(),this._visibleView=this.dataGrid.asWidget(),this._searchableElement=this.profileDataGridTree;break;case"Heavy":this.profileDataGridTree=this._getBottomUpProfileDataGridTree(),this._sortProfile(),this._visibleView=this.dataGrid.asWidget(),this._searchableElement=this.profileDataGridTree}const e="Flame"===this._viewType.get();this.focusButton.setVisible(!e),this.excludeButton.setVisible(!e),this.resetButton.setVisible(!e),this._visibleView&&this._visibleView.show(this._searchableView.element)}_nodeSelected(e){this.focusButton.setEnabled(e),this.excludeButton.setEnabled(e)}_focusClicked(e){this.dataGrid.selectedNode&&(this.resetButton.setEnabled(!0),this.resetButton.element.focus(),this.profileDataGridTree&&this.profileDataGridTree.focus(this.dataGrid.selectedNode),this.refresh(),this.refreshVisibleData(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.CpuProfileNodeFocused))}_excludeClicked(e){const t=this.dataGrid.selectedNode;t&&(this.resetButton.setEnabled(!0),this.resetButton.element.focus(),t.deselect(),this.profileDataGridTree&&this.profileDataGridTree.exclude(t),this.refresh(),this.refreshVisibleData(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.CpuProfileNodeExcluded))}_resetClicked(e){this.viewSelectComboBox.selectElement().focus(),this.resetButton.setEnabled(!1),this.profileDataGridTree&&this.profileDataGridTree.restore(),this._linkifier.reset(),this.refresh(),this.refreshVisibleData()}_sortProfile(){if(!this.profileDataGridTree)return;const e=this.dataGrid.isSortOrderAscending(),t=this.dataGrid.sortColumnId(),i="function"===t?"functionName":t||"";this.profileDataGridTree.sort(ProfileDataGridTree.propertyComparator(i,e),!1),this.refresh()}}export const maxLinkLength=30;export class WritableProfileHeader extends ProfileHeader{constructor(e,t,i){super(t,i||i18nString(UIStrings.profileD,{PH1:t.nextProfileUid()})),this._debuggerModel=e}_onChunkTransferred(e){this._jsonifiedProfile&&this.updateStatus(i18nString(UIStrings.loadingD,{PH1:Platform.NumberUtilities.bytesToString(this._jsonifiedProfile.length)}))}_onError(e){const t=e.error();t&&this.updateStatus(i18nString(UIStrings.fileSReadErrorS,{PH1:e.fileName(),PH2:t.message}))}async write(e){this._jsonifiedProfile+=e}async close(){}dispose(){this.removeTempFile()}createSidebarTreeElement(e){return new ProfileSidebarTreeElement(e,this,"profile-sidebar-tree-item")}canSaveToFile(){return!this.fromFile()&&Boolean(this._protocolProfile)}async saveToFile(){const e=new Bindings.FileUtils.FileOutputStream;if(!this._fileName){const e=Platform.DateUtilities.toISO8601Compact(new Date),t=this.profileType().fileExtension();this._fileName=`${this.profileType().typeName()}-${e}${t}`}if(!await e.open(this._fileName)||!this.tempFile)return;const t=await this.tempFile.read();t&&await e.write(t),e.close()}async loadFromFile(e){this.updateStatus(i18nString(UIStrings.loading),!0);const t=new Bindings.FileUtils.ChunkedFileReader(e,1e7,this._onChunkTransferred.bind(this));this._jsonifiedProfile="";if(!await t.read(this))return this._onError(t),new Error(i18nString(UIStrings.failedToReadFile));this.updateStatus(i18nString(UIStrings.parsing),!0);let i=null;try{this._profile=JSON.parse(this._jsonifiedProfile),this.setProfile(this._profile),this.updateStatus(i18nString(UIStrings.loaded),!1)}catch(r){i=r,this.profileType().removeProfile(this)}return this._jsonifiedProfile=null,this.profileType().profileBeingRecorded()===this&&this.profileType().setProfileBeingRecorded(null),i}setProtocolProfile(e){this.setProfile(e),this._protocolProfile=e,this.tempFile=new Bindings.TempFile.TempFile,this.tempFile.write([JSON.stringify(e)]),this.canSaveToFile()&&this.dispatchEventToListeners(Events.ProfileReceived)}}