import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{ProfileEvents as ProfileTypeEvents}from"./ProfileHeader.js";import{Events as ProfileLauncherEvents,ProfileLauncherView}from"./ProfileLauncherView.js";import{ProfileSidebarTreeElement,setSharedFileSelectorElement}from"./ProfileSidebarTreeElement.js";import{instance}from"./ProfileTypeRegistry.js";const UIStrings={clearAllProfiles:"Clear all profiles",cantLoadFileSupportedFile:"Can\u2019t load file. Supported file extensions: '{PH1}.'",cantLoadProfileWhileAnother:"Can\u2019t load profile while another profile is being recorded.",profileLoadingFailedS:"Profile loading failed: {PH1}.",load:"Load\u2026",runD:"Run {PH1}",profiles:"Profiles"},str_=i18n.i18n.registerUIStrings("profiler/ProfilesPanel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ProfilesPanel extends UI.Panel.PanelWithSidebar{constructor(e,i,t){super(e),this._profileTypes=i,this.registerRequiredCSS("profiler/heapProfiler.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("profiler/profilesPanel.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("object_ui/objectValue.css",{enableLegacyPatching:!0});const r=new UI.Widget.VBox;this.splitWidget().setMainWidget(r),this.profilesItemTreeElement=new ProfilesSidebarTreeElement(this),this._sidebarTree=new UI.TreeOutline.TreeOutlineInShadow,this._sidebarTree.registerRequiredCSS("profiler/profilesSidebarTree.css",{enableLegacyPatching:!0}),this._sidebarTree.element.classList.add("profiles-sidebar-tree-box"),this.panelSidebarElement().appendChild(this._sidebarTree.element),this._sidebarTree.appendChild(this.profilesItemTreeElement),this._sidebarTree.element.addEventListener("keydown",this._onKeyDown.bind(this),!1),this.profileViews=document.createElement("div"),this.profileViews.id="profile-views",this.profileViews.classList.add("vbox"),r.element.appendChild(this.profileViews),this._toolbarElement=document.createElement("div"),this._toolbarElement.classList.add("profiles-toolbar"),r.element.insertBefore(this._toolbarElement,r.element.firstChild),this.panelSidebarElement().classList.add("profiles-tree-sidebar");const l=document.createElement("div");l.classList.add("profiles-toolbar"),this.panelSidebarElement().insertBefore(l,this.panelSidebarElement().firstChild);const o=new UI.Toolbar.Toolbar("",l);this._toggleRecordAction=UI.ActionRegistry.ActionRegistry.instance().action(t),this._toggleRecordButton=UI.Toolbar.Toolbar.createActionButton(this._toggleRecordAction),o.appendToolbarItem(this._toggleRecordButton),this.clearResultsButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearAllProfiles),"largeicon-clear"),this.clearResultsButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._reset,this),o.appendToolbarItem(this.clearResultsButton),o.appendSeparator(),o.appendToolbarItem(UI.Toolbar.Toolbar.createActionButtonForId("components.collect-garbage")),this._profileViewToolbar=new UI.Toolbar.Toolbar("",this._toolbarElement),this._profileGroups={},this._launcherView=new ProfileLauncherView(this),this._launcherView.addEventListener(ProfileLauncherEvents.ProfileTypeSelected,this._onProfileTypeSelected,this),this._profileToView=[],this._typeIdToSidebarSection={};const s=this._profileTypes;for(let n=0;n<s.length;n++)this._registerProfileType(s[n]);this._launcherView.restoreSelectedProfileType(),this.profilesItemTreeElement.select(),this._showLauncherView(),this._createFileSelectorElement(),this.element.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this),!1),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.SuspendStateChanged,this._onSuspendStateChanged,this),UI.Context.Context.instance().addFlavorChangeListener(SDK.CPUProfilerModel.CPUProfilerModel,this._updateProfileTypeSpecificUI,this),UI.Context.Context.instance().addFlavorChangeListener(SDK.HeapProfilerModel.HeapProfilerModel,this._updateProfileTypeSpecificUI,this)}_onKeyDown(e){const i=e;let t=!1;"ArrowDown"!==i.key||i.altKey?"ArrowUp"!==i.key||i.altKey||(t=this._sidebarTree.selectPrevious()):t=this._sidebarTree.selectNext(),t&&i.consume(!0)}searchableView(){const e=this.visibleView;return e&&e.searchableView?e.searchableView():null}_createFileSelectorElement(){this._fileSelectorElement&&this.element.removeChild(this._fileSelectorElement),this._fileSelectorElement=UI.UIUtils.createFileSelectorElement(this._loadFromFile.bind(this)),setSharedFileSelectorElement(this._fileSelectorElement),this.element.appendChild(this._fileSelectorElement)}_findProfileTypeByExtension(e){return this._profileTypes.find((i=>Boolean(i.fileExtension())&&e.endsWith(i.fileExtension()||"")))||null}async _loadFromFile(e){this._createFileSelectorElement();const i=this._findProfileTypeByExtension(e.name);if(!i){const e=new Set(this._profileTypes.map((e=>e.fileExtension())).filter((e=>e)));return void Common.Console.Console.instance().error(i18nString(UIStrings.cantLoadFileSupportedFile,{PH1:Array.from(e).join("', '")}))}if(Boolean(i.profileBeingRecorded()))return void Common.Console.Console.instance().error(i18nString(UIStrings.cantLoadProfileWhileAnother));const t=await i.loadFromFile(e);t&&"message"in t&&UI.UIUtils.MessageDialog.show(i18nString(UIStrings.profileLoadingFailedS,{PH1:t.message}))}toggleRecord(){if(!this._toggleRecordAction.enabled())return!0;const e=this.element.ownerDocument.deepActiveElement(),i=this._selectedProfileType;if(!i)return!0;const t=i.buttonClicked();return this._updateToggleRecordAction(t),t?(this._launcherView.profileStarted(),i.hasTemporaryView()&&this.showProfile(i.profileBeingRecorded())):this._launcherView.profileFinished(),e&&e.focus(),!0}_onSuspendStateChanged(){this._updateToggleRecordAction(this._toggleRecordAction.toggled())}_updateToggleRecordAction(e){const i=Boolean(UI.Context.Context.instance().flavor(SDK.CPUProfilerModel.CPUProfilerModel)||UI.Context.Context.instance().flavor(SDK.HeapProfilerModel.HeapProfilerModel)),t=e||!SDK.SDKModel.TargetManager.instance().allTargetsSuspended()&&i;this._toggleRecordAction.setEnabled(t),this._toggleRecordAction.setToggled(e),t?this._toggleRecordButton.setTitle(this._selectedProfileType?this._selectedProfileType.buttonTooltip:""):this._toggleRecordButton.setTitle(UI.UIUtils.anotherProfilerActiveLabel()),this._selectedProfileType&&this._launcherView.updateProfileType(this._selectedProfileType,t)}_profileBeingRecordedRemoved(){this._updateToggleRecordAction(!1),this._launcherView.profileFinished()}_onProfileTypeSelected(e){this._selectedProfileType=e.data,this._updateProfileTypeSpecificUI()}_updateProfileTypeSpecificUI(){this._updateToggleRecordAction(this._toggleRecordAction.toggled())}_reset(){this._profileTypes.forEach((e=>e.reset())),delete this.visibleView,this._profileGroups={},this._updateToggleRecordAction(!1),this._launcherView.profileFinished(),this._sidebarTree.element.classList.remove("some-expandable"),this._launcherView.detach(),this.profileViews.removeChildren(),this._profileViewToolbar.removeToolbarItems(),this.clearResultsButton.element.classList.remove("hidden"),this.profilesItemTreeElement.select(),this._showLauncherView()}_showLauncherView(){this.closeVisibleView(),this._profileViewToolbar.removeToolbarItems(),this._launcherView.show(this.profileViews),this.visibleView=this._launcherView,this._toolbarElement.classList.add("hidden")}_registerProfileType(e){this._launcherView.addProfileType(e);const i=new ProfileTypeSidebarSection(this,e);this._typeIdToSidebarSection[e.id]=i,this._sidebarTree.appendChild(i),i.childrenListElement.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this),!1),e.addEventListener(ProfileTypeEvents.ViewUpdated,this._updateProfileTypeSpecificUI,this),e.addEventListener(ProfileTypeEvents.AddProfileHeader,(function(e){this._addProfileHeader(e.data)}),this),e.addEventListener(ProfileTypeEvents.RemoveProfileHeader,(function(e){this._removeProfileHeader(e.data)}),this),e.addEventListener(ProfileTypeEvents.ProfileComplete,(function(e){this.showProfile(e.data)}),this);const t=e.getProfiles();for(let r=0;r<t.length;r++)this._addProfileHeader(t[r])}_handleContextMenuEvent(e){const i=new UI.ContextMenu.ContextMenu(e);this.panelSidebarElement().isSelfOrAncestor(e.target)&&i.defaultSection().appendItem(i18nString(UIStrings.load),this._fileSelectorElement.click.bind(this._fileSelectorElement)),i.show()}showLoadFromFileDialog(){this._fileSelectorElement.click()}_addProfileHeader(e){const i=e.profileType().id;this._typeIdToSidebarSection[i].addProfileHeader(e),this.visibleView&&this.visibleView!==this._launcherView||this.showProfile(e)}_removeProfileHeader(e){e.profileType().profileBeingRecorded()===e&&this._profileBeingRecordedRemoved();const i=this._indexOfViewForProfile(e);-1!==i&&this._profileToView.splice(i,1);const t=e.profileType().id;this._typeIdToSidebarSection[t].removeProfileHeader(e)&&(this.profilesItemTreeElement.select(),this._showLauncherView())}showProfile(e){if(!e||e.profileType().profileBeingRecorded()===e&&!e.profileType().hasTemporaryView())return null;const i=this.viewForProfile(e);if(i===this.visibleView)return i;this.closeVisibleView(),i.show(this.profileViews),this._toolbarElement.classList.remove("hidden"),this.visibleView=i;const t=this._typeIdToSidebarSection[e.profileType().id].sidebarElementForProfile(e);return t&&t.revealAndSelect(),this._profileViewToolbar.removeToolbarItems(),i.toolbarItems().then((e=>{e.map((e=>this._profileViewToolbar.appendToolbarItem(e)))})),i}showObject(e,i){}async linkifyObject(e){return null}viewForProfile(e){const i=this._indexOfViewForProfile(e);if(-1!==i)return this._profileToView[i].view;const t=e.createView(this);return t.element.classList.add("profile-view"),this._profileToView.push({profile:e,view:t}),t}_indexOfViewForProfile(e){return this._profileToView.findIndex((i=>i.profile===e))}closeVisibleView(){this.visibleView&&this.visibleView.detach(),delete this.visibleView}focus(){this._sidebarTree.focus()}}export class ProfileTypeSidebarSection extends UI.TreeOutline.TreeElement{constructor(e,i){super(i.treeItemTitle,!0),this.selectable=!1,this._dataDisplayDelegate=e,this._profileTreeElements=[],this._profileGroups={},this.expand(),this.hidden=!0,this.setCollapsible(!1)}addProfileHeader(e){this.hidden=!1;const i=e.profileType();let t=this;const r=e.createSidebarTreeElement(this._dataDisplayDelegate);if(this._profileTreeElements.push(r),!e.fromFile()&&i.profileBeingRecorded()!==e){const i=e.title;let l=this._profileGroups[i];l||(l=new ProfileGroup,this._profileGroups[i]=l),l.profileSidebarTreeElements.push(r);const o=l.profileSidebarTreeElements.length;if(2===o){l.sidebarTreeElement=new ProfileGroupSidebarTreeElement(this._dataDisplayDelegate,e.title);const i=l.profileSidebarTreeElements[0],t=this.children().indexOf(i);this.insertChild(l.sidebarTreeElement,t);const r=i.selected;this.removeChild(i),l.sidebarTreeElement.appendChild(i),r&&i.revealAndSelect(),i.setSmall(!0),i.setMainTitle(i18nString(UIStrings.runD,{PH1:1})),this.treeOutline&&this.treeOutline.element.classList.add("some-expandable")}o>=2&&(t=l.sidebarTreeElement,r.setSmall(!0),r.setMainTitle(i18nString(UIStrings.runD,{PH1:o})))}t&&t.appendChild(r)}removeProfileHeader(e){const i=this._sidebarElementIndex(e);if(-1===i)return!1;const t=this._profileTreeElements[i];this._profileTreeElements.splice(i,1);let r=this;const l=this._profileGroups[e.title];if(l){const i=l.profileSidebarTreeElements;if(i.splice(i.indexOf(t),1),1===i.length){const t=r.children().indexOf(l.sidebarTreeElement);l.sidebarTreeElement&&l.sidebarTreeElement.removeChild(i[0]),this.insertChild(i[0],t),i[0].setSmall(!1),i[0].setMainTitle(e.title),l.sidebarTreeElement&&this.removeChild(l.sidebarTreeElement)}0!==i.length&&(r=l.sidebarTreeElement)}return r&&r.removeChild(t),t.dispose(),!this.childCount()&&(this.hidden=!0,!0)}sidebarElementForProfile(e){const i=this._sidebarElementIndex(e);return-1===i?null:this._profileTreeElements[i]}_sidebarElementIndex(e){const i=this._profileTreeElements;for(let t=0;t<i.length;t++)if(i[t].profile===e)return t;return-1}onattach(){this.listItemElement.classList.add("profiles-tree-section")}}export class ProfileGroup{constructor(){this.profileSidebarTreeElements=[],this.sidebarTreeElement=null}}export class ProfileGroupSidebarTreeElement extends UI.TreeOutline.TreeElement{constructor(e,i){super("",!0),this.selectable=!1,this._dataDisplayDelegate=e,this._profileTitle=i,this.expand(),this.toggleOnClick=!0}onselect(){const e=this.childCount()>0;if(e){const e=this.lastChild();e instanceof ProfileSidebarTreeElement&&this._dataDisplayDelegate.showProfile(e.profile)}return e}onattach(){this.listItemElement.classList.add("profile-group-sidebar-tree-item"),this.listItemElement.createChild("div","icon"),this.listItemElement.createChild("div","titles no-subtitle").createChild("span","title-container").createChild("span","title").textContent=this._profileTitle}}export class ProfilesSidebarTreeElement extends UI.TreeOutline.TreeElement{constructor(e){super("",!1),this.selectable=!0,this._panel=e}onselect(){return this._panel._showLauncherView(),!0}onattach(){this.listItemElement.classList.add("profile-launcher-view-tree-item"),this.listItemElement.createChild("div","icon"),this.listItemElement.createChild("div","titles no-subtitle").createChild("span","title-container").createChild("span","title").textContent=i18nString(UIStrings.profiles)}}let jsProfilerPanelInstance;export class JSProfilerPanel extends ProfilesPanel{constructor(){super("js_profiler",[instance.cpuProfileType],"profiler.js-toggle-recording")}static instance(e={forceNew:null}){const{forceNew:i}=e;return jsProfilerPanelInstance&&!i||(jsProfilerPanelInstance=new JSProfilerPanel),jsProfilerPanelInstance}wasShown(){UI.Context.Context.instance().setFlavor(JSProfilerPanel,this)}willHide(){UI.Context.Context.instance().setFlavor(JSProfilerPanel,null)}handleAction(e,i){const t=UI.Context.Context.instance().flavor(JSProfilerPanel);if(!(t instanceof JSProfilerPanel))throw new Error("non-null JSProfilerPanel expected!");return t.toggleRecord(),!0}}