import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as ProtocolClient from"../protocol_client/protocol_client.js";import*as SDK from"../sdk/sdk.js";import*as SourceFrame from"../source_frame/source_frame.js";import*as TextUtils from"../text_utils/text_utils.js";import*as LitHtml from"../third_party/lit-html/lit-html.js";import*as Components from"../ui/components/components.js";import*as UI from"../ui/ui.js";const UIStrings={method:"Method",direction:"Direction",request:"Request",response:"Response",timestamp:"Timestamp",target:"Target",record:"Record",clearAll:"Clear all",filter:"Filter",documentation:"Documentation",sMs:"{PH1} ms",noMessageSelected:"No message selected"},str_=i18n.i18n.registerUIStrings("protocol_monitor/ProtocolMonitor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),timestampRenderer=t=>LitHtml.html`${i18nString(UIStrings.sMs,{PH1:t})}`;let protocolMonitorImplInstance;export class ProtocolMonitorImpl extends UI.Widget.VBox{constructor(){super(!0),this._started=!1,this._startTime=0,this._dataGridRowForId=new Map,this.registerRequiredCSS("protocol_monitor/protocolMonitor.css",{enableLegacyPatching:!0});const t=new UI.Toolbar.Toolbar("protocol-monitor-toolbar",this.contentElement),e=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.record),"largeicon-start-recording","largeicon-stop-recording");e.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{e.setToggled(!e.toggled()),this._setRecording(e.toggled())})),e.setToggleWithRedColor(!0),t.appendToolbarItem(e),e.setToggled(!0);const r=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearAll),"largeicon-clear");r.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this._dataGridIntegrator.update({...this._dataGridIntegrator.data(),rows:[]})})),t.appendToolbarItem(r);const i=new UI.SplitWidget.SplitWidget(!0,!0,"protocol-monitor-panel-split",250);i.show(this.contentElement),this._infoWidget=new InfoWidget;const o={columns:[{id:"method",title:i18nString(UIStrings.method),sortable:!1,widthWeighting:1,visible:!0,hideable:!1},{id:"direction",title:i18nString(UIStrings.direction),sortable:!0,widthWeighting:1,visible:!1,hideable:!0},{id:"request",title:i18nString(UIStrings.request),sortable:!1,widthWeighting:1,visible:!0,hideable:!0},{id:"response",title:i18nString(UIStrings.response),sortable:!1,widthWeighting:1,visible:!0,hideable:!0},{id:"timestamp",title:i18nString(UIStrings.timestamp),sortable:!0,widthWeighting:1,visible:!1,hideable:!0},{id:"target",title:i18nString(UIStrings.target),sortable:!0,widthWeighting:1,visible:!1,hideable:!0}],rows:[],contextMenus:{bodyRow:(t,e,r)=>{const i=Components.DataGridUtils.getRowEntryForColumnId(r,"method"),o=Components.DataGridUtils.getRowEntryForColumnId(r,"direction");t.defaultSection().appendItem(i18nString(UIStrings.filter),(()=>{const t=Components.DataGridUtils.getRowEntryForColumnId(r,"method");this._textFilterUI.setValue(`method:${t.value}`,!0)})),t.defaultSection().appendItem(i18nString(UIStrings.documentation),(()=>{if(!i.value)return;const[t,e]=String(i.value).split("."),r="sent"===o.value?"method":"event";Host.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab(`https://chromedevtools.github.io/devtools-protocol/tot/${t}#${r}-${e}`)}))}}};this._dataGridIntegrator=new Components.DataGridControllerIntegrator.DataGridControllerIntegrator(o),this._dataGridIntegrator.dataGrid.addEventListener("cell-focused",(t=>{const e=t.data.row,r={request:Components.DataGridUtils.getRowEntryForColumnId(e,"request"),response:Components.DataGridUtils.getRowEntryForColumnId(e,"response"),direction:Components.DataGridUtils.getRowEntryForColumnId(e,"direction")};this._infoWidget.render(r)})),this._dataGridIntegrator.dataGrid.addEventListener("new-user-filter-text",(t=>{const e=t;this._textFilterUI.setValue(e.data.filterText,!0)})),i.setMainWidget(this._dataGridIntegrator),i.setSidebarWidget(this._infoWidget);const n=["method","request","response","direction"];this._filterParser=new TextUtils.TextUtils.FilterParser(n),this._suggestionBuilder=new UI.FilterSuggestionBuilder.FilterSuggestionBuilder(n),this._textFilterUI=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.filter),"",1,.2,"",this._suggestionBuilder.completions.bind(this._suggestionBuilder),!0),this._textFilterUI.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,(t=>{const e=t.data,r=this._filterParser.parse(e);this._dataGridIntegrator.update({...this._dataGridIntegrator.data(),filters:r})})),t.appendToolbarItem(this._textFilterUI)}static instance(t={forceNew:null}){const{forceNew:e}=t;return protocolMonitorImplInstance&&!e||(protocolMonitorImplInstance=new ProtocolMonitorImpl),protocolMonitorImplInstance}wasShown(){this._started||(this._started=!0,this._startTime=Date.now(),this._setRecording(!0))}_setRecording(t){const e=ProtocolClient.InspectorBackend.test;t?(e.onMessageSent=this._messageSent.bind(this),e.onMessageReceived=this._messageReceived.bind(this)):(e.onMessageSent=null,e.onMessageReceived=null)}_targetToString(t){return t?t.decorateLabel(`${t.name()} ${t===SDK.SDKModel.TargetManager.instance().mainTarget()?"":t.id()}`):""}_messageReceived(t,e){if("id"in t&&t.id){const e=this._dataGridRowForId.get(t.id);if(!e)return;const r=this._dataGridIntegrator.data().rows.findIndex((t=>e===t)),i={...e,cells:e.cells.map((e=>"response"===e.columnId?{...e,value:JSON.stringify(t.result||t.error)}:e))},o=[...this._dataGridIntegrator.data().rows];return o[r]=i,this._dataGridRowForId.delete(t.id),void this._dataGridIntegrator.update({...this._dataGridIntegrator.data(),rows:o})}const r=e,i={cells:[{columnId:"method",value:t.method},{columnId:"request",value:"",renderer:Components.DataGridRenderers.codeBlockRenderer},{columnId:"response",value:JSON.stringify(t.params),renderer:Components.DataGridRenderers.codeBlockRenderer},{columnId:"timestamp",value:Date.now()-this._startTime,renderer:timestampRenderer},{columnId:"direction",value:"received"},{columnId:"target",value:this._targetToString(r)}],hidden:!1};this._dataGridIntegrator.update({...this._dataGridIntegrator.data(),rows:this._dataGridIntegrator.data().rows.concat([i])})}_messageSent(t,e){const r=e,i={cells:[{columnId:"method",value:t.method},{columnId:"request",value:JSON.stringify(t.params),renderer:Components.DataGridRenderers.codeBlockRenderer},{columnId:"response",value:"(pending)",renderer:Components.DataGridRenderers.codeBlockRenderer},{columnId:"timestamp",value:Date.now()-this._startTime,renderer:timestampRenderer},{columnId:"direction",value:"sent"},{columnId:"target",value:this._targetToString(r)}],hidden:!1};this._dataGridRowForId.set(t.id,i),this._dataGridIntegrator.update({...this._dataGridIntegrator.data(),rows:this._dataGridIntegrator.data().rows.concat([i])})}}export class InfoWidget extends UI.Widget.VBox{constructor(){super(),this._tabbedPane=new UI.TabbedPane.TabbedPane,this._tabbedPane.appendTab("request",i18nString(UIStrings.request),new UI.Widget.Widget),this._tabbedPane.appendTab("response",i18nString(UIStrings.response),new UI.Widget.Widget),this._tabbedPane.show(this.contentElement),this._tabbedPane.selectTab("response"),this.render(null)}render(t){if(!t||!t.request||!t.response)return this._tabbedPane.changeTabView("request",new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noMessageSelected))),void this._tabbedPane.changeTabView("response",new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noMessageSelected)));const e=t&&t.direction&&"sent"===t.direction.value;this._tabbedPane.setTabEnabled("request",Boolean(e)),e||this._tabbedPane.selectTab("response");const r=JSON.parse(String(t.request.value)||"null");this._tabbedPane.changeTabView("request",SourceFrame.JSONView.JSONView.createViewSync(r));const i=JSON.parse(String(t.response.value)||"null");this._tabbedPane.changeTabView("response",SourceFrame.JSONView.JSONView.createViewSync(i))}}