import*as Common from"../common/common.js";import*as SDK from"../sdk/sdk.js";import{RecordingEventHandler}from"./RecordingEventHandler.js";import{RecordingScriptWriter}from"./RecordingScriptWriter.js";import{EmulateNetworkConditions,NavigationStep}from"./Steps.js";const DOM_BREAKPOINTS=new Set(["Mouse:click","Control:change","Control:submit"]);export class RecordingSession{constructor(e,t,n){this.steps=[],this._scriptWriter=null,this._target=e,this._uiSourceCode=t,this._indentation=n,this._debuggerAgent=e.debuggerAgent(),this._domDebuggerAgent=e.domdebuggerAgent(),this._runtimeAgent=e.runtimeAgent(),this._accessibilityAgent=e.accessibilityAgent(),this._pageAgent=e.pageAgent(),this._targetAgent=e.targetAgent(),this._networkManager=SDK.NetworkManager.MultitargetNetworkManager.instance(),this._domModel=e.model(SDK.DOMModel.DOMModel),this._axModel=e.model(SDK.AccessibilityModel.AccessibilityModel),this._debuggerModel=e.model(SDK.DebuggerModel.DebuggerModel),this._resourceTreeModel=e.model(SDK.ResourceTreeModel.ResourceTreeModel),this._runtimeModel=e.model(SDK.RuntimeModel.RuntimeModel),this._childTargetManager=e.model(SDK.ChildTargetManager.ChildTargetManager),this._target=e,this._eventHandlers=new Map,this._targets=new Map,this._initialDomBreakpointState=new Map,this._interestingBreakpoints=[],this._newDocumentScriptIdentifier=null}async start(){const e=SDK.DOMDebuggerModel.DOMDebuggerManager.instance().eventListenerBreakpoints();this._interestingBreakpoints=e.filter((e=>DOM_BREAKPOINTS.has(e.category()+":"+e.title())));for(const o of this._interestingBreakpoints)this._initialDomBreakpointState.set(o,o.enabled()),o.setEnabled(!0);this._networkManager.addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,this._handleNetworkConditionsChanged,this),this.attachToTarget(this._target);const t=SDK.SDKModel.TargetManager.instance().mainTarget();if(!t)throw new Error("Could not find main target");const n=t.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!n)throw new Error("Could not find resource tree model");const r=n.mainFrame;if(!r)throw new Error("Could not find main frame");this._scriptWriter=new RecordingScriptWriter(this._indentation);const i=this._networkManager.networkConditions();i!==SDK.NetworkManager.NoThrottlingConditions&&await this.appendStep(new EmulateNetworkConditions(i)),await this.appendStep(new NavigationStep(r.url))}_handleNetworkConditionsChanged(){const e=this._networkManager.networkConditions();this.appendStep(new EmulateNetworkConditions(e))}async stop(){for(const e of this._targets.values())await this.detachFromTarget(e);await this.detachFromTarget(this._target),this._networkManager.removeEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,this._handleNetworkConditionsChanged,this),this._newDocumentScriptIdentifier&&await this._pageAgent.invoke_removeScriptToEvaluateOnNewDocument({identifier:this._newDocumentScriptIdentifier}),await this._debuggerModel.ignoreDebuggerPausedEvents(!1);for(const[e,t]of this._initialDomBreakpointState.entries())e.setEnabled(t)}async appendStep(e){if(!this._scriptWriter)throw new Error("Recording has not started yet.");this._scriptWriter.appendStep(e),this.renderSteps(),e.addEventListener("condition-added",(()=>{this.renderSteps()}))}async renderSteps(){if(!this._scriptWriter)throw new Error("Recording has not started yet.");const e=this._scriptWriter.getScript();this._uiSourceCode.setContent(e,!1),Common.Revealer.reveal(this._uiSourceCode.uiLocation(e.length),!0)}async isSubmitButton(e){const{result:t}=await this._runtimeAgent.invoke_callFunctionOn({functionDeclaration:function(){return"BUTTON"===this.tagName&&"submit"===this.type&&null!==this.form}.toString(),objectId:e});return t.value}async attachToTarget(e){this._targets.set(e.id(),e);const t=new RecordingEventHandler(this,e);this._eventHandlers.set(e.id(),t),e.registerDebuggerDispatcher(t);const n=e.pageAgent(),r=e.model(SDK.DebuggerModel.DebuggerModel),i=e.model(SDK.ChildTargetManager.ChildTargetManager),o="\n      if (!window.__recorderEventListener) {\n        const recorderEventListener = (event) => { };\n        window.addEventListener('click', recorderEventListener, true);\n        window.addEventListener('submit', recorderEventListener, true);\n        window.addEventListener('change', recorderEventListener, true);\n        window.__recorderEventListener = recorderEventListener;\n      }\n    ";await r.resumeModel(),await r.ignoreDebuggerPausedEvents(!0);const{identifier:a}=await n.invoke_addScriptToEvaluateOnNewDocument({source:o});this._newDocumentScriptIdentifier=a,await this.evaluateInAllFrames(e,o),i.addEventListener(SDK.ChildTargetManager.Events.TargetCreated,this.handleWindowOpened,this),i.addEventListener(SDK.ChildTargetManager.Events.TargetDestroyed,this.handleWindowClosed,this),i.addEventListener(SDK.ChildTargetManager.Events.TargetInfoChanged,this.handleNavigation,this);for(const s of i.childTargets())this.attachToTarget(s)}async detachFromTarget(e){const t=this._eventHandlers.get(e.id());if(!t)return;e.unregisterDebuggerDispatcher(t);const n=e.model(SDK.DebuggerModel.DebuggerModel);await n.ignoreDebuggerPausedEvents(!1)}async evaluateInAllFrames(e,t){const n=e.model(SDK.ResourceTreeModel.ResourceTreeModel),r=e.model(SDK.RuntimeModel.RuntimeModel).executionContexts();for(const i of n.frames()){const e=r.find((e=>e.frameId===i.id));e&&await e.evaluate({expression:t,objectGroup:void 0,includeCommandLineAPI:void 0,silent:void 0,returnByValue:void 0,generatePreview:void 0,allowUnsafeEvalBlockedByCSP:void 0,throwOnSideEffect:void 0,timeout:void 0,disableBreaks:void 0,replMode:void 0},!0,!1)}}async handleWindowOpened(e){if("page"!==e.data.type)return;if(!this._runtimeModel.executionContexts().find((t=>t.frameId===e.data.openerFrameId)))throw new Error("Could not find execution context in opened frame.");await this._targetAgent.invoke_attachToTarget({targetId:e.data.targetId,flatten:!0});const t=SDK.SDKModel.TargetManager.instance().targets().find((t=>t.id()===e.data.targetId));if(!t)throw new Error("Could not find target.");this.attachToTarget(t)}async handleWindowClosed(e){const t=this._targets.get(e.data);if(!t)return;const n=t.targetInfo();if(n&&"page"!==n.type)return;const r=this._eventHandlers.get(t.id());r&&r.targetDestroyed()}async handleNavigation(e){if("page"!==e.data.type)return;const t=this._resourceTreeModel.mainFrame?.id===e.data.targetId?"main":e.data.targetId,n=this._eventHandlers.get(t);n&&n.targetInfoChanged(e.data.url)}}