import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as i18n from"../i18n/i18n.js";import*as InlineEditor from"../inline_editor/inline_editor.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={noManifestDetected:"No manifest detected",appManifest:"App Manifest",errorsAndWarnings:"Errors and warnings",installability:"Installability",identity:"Identity",presentation:"Presentation",icons:"Icons",name:"Name",shortName:"Short name",description:"Description",startUrl:"Start URL",themeColor:"Theme color",backgroundColor:"Background color",orientation:"Orientation",display:"Display",descriptionMayBeTruncated:"Description may be truncated.",showOnlyTheMinimumSafeAreaFor:"Show only the minimum safe area for maskable icons",documentationOnMaskableIcons:"documentation on maskable icons",needHelpReadOurS:"Need help? Read {PH1}.",primaryManifestIconFromS:"Primary manifest icon from {PH1}",primaryIconasUsedByChrome:"Primary icon as used by `Chrome`",shortcutS:"Shortcut #{PH1}",shortcutSShouldIncludeAXPixel:"Shortcut #{PH1} should include a 96x96 pixel icon",screenshotS:"Screenshot #{PH1}",pageIsNotLoadedInTheMainFrame:"Page is not loaded in the main frame",pageIsNotServedFromASecureOrigin:"Page is not served from a secure origin",pageHasNoManifestLinkUrl:"Page has no manifest <link> `URL`",manifestCouldNotBeFetchedIsEmpty:"Manifest could not be fetched, is empty, or could not be parsed",manifestStartUrlIsNotValid:"Manifest start `URL` is not valid",manifestDoesNotContainANameOr:"Manifest does not contain a '`name`' or '`short_name`' field",manifestDisplayPropertyMustBeOne:"Manifest '`display`' property must be one of '`standalone`', '`fullscreen`', or '`minimal-ui`'",manifestDoesNotContainASuitable:'Manifest does not contain a suitable icon - PNG, SVG or WebP format of at least {PH1}px is required, the `sizes` attribute must be set, and the `purpose` attribute, if set, must include `"any"` and should not include `"maskable"`.',noMatchingServiceWorkerDetected:"No matching `service worker` detected. You may need to reload the page, or check that the scope of the `service worker` for the current page encloses the scope and start URL from the manifest.",noSuppliedIconIsAtLeastSpxSquare:'No supplied icon is at least {PH1} pixels square in `PNG`, `SVG` or `WebP` format, with the purpose attribute unset or set to `"any"`.',couldNotDownloadARequiredIcon:"Could not download a required icon from the manifest",downloadedIconWasEmptyOr:"Downloaded icon was empty or corrupted",theSpecifiedApplicationPlatform:"The specified application platform is not supported on `Android`",noPlayStoreIdProvided:"No Play store ID provided",thePlayStoreAppUrlAndPlayStoreId:"The Play Store app URL and Play Store ID do not match",theAppIsAlreadyInstalled:"The app is already installed",aUrlInTheManifestContainsA:"A URL in the manifest contains a username, password, or port",pageIsLoadedInAnIncognitoWindow:"Page is loaded in an incognito window",pageDoesNotWorkOffline:"Page does not work offline",couldNotCheckServiceWorker:"Could not check `service worker` without a '`start_url`' field in the manifest",manifestSpecifies:"Manifest specifies `prefer_related_applications`: true",preferrelatedapplicationsIsOnly:"`prefer_related_applications` is only supported on `Chrome` Beta and Stable channels on `Android`.",manifestContainsDisplayoverride:"Manifest contains '`display_override`' field, and the first supported display mode must be one of '`standalone`', '`fullscreen`', or '`minimal-ui`'",pageDoesNotWorkOfflineThePage:"Page does not work offline. Starting in Chrome 93, the installability criteria are changing, and this site will not be installable. See {PH1} for more information.",imageFromS:"Image from {PH1}",screenshot:"Screenshot",icon:"Icon",sSrcIsNotSet:"{PH1} `src` is not set",sUrlSFailedToParse:"{PH1} URL '{PH2}' failed to parse",sSFailedToLoad:"{PH1} {PH2} failed to load",sSDoesNotSpecifyItsSizeInThe:"{PH1} {PH2} does not specify its size in the manifest",sSShouldSpecifyItsSizeAs:"{PH1} {PH2} should specify its size as `{width}x{height}`",sSDimensionsShouldBeSquare:"{PH1} {PH2} dimensions should be square",actualSizeSspxOfSSDoesNotMatch:"Actual size ({PH1}\xd7{PH2})px of {PH3} {PH4} does not match specified size ({PH5}\xd7{PH6}px)",actualWidthSpxOfSSDoesNotMatch:"Actual width ({PH1}px) of {PH2} {PH3} does not match specified width ({PH4}px)",actualHeightSpxOfSSDoesNotMatch:"Actual height ({PH1}px) of {PH2} {PH3} does not match specified height ({PH4}px)",sSSizeShouldBeAtLeast320:"{PH1} {PH2} size should be at least 320\xd7320",sSSizeShouldBeAtMost3840:"{PH1} {PH2} size should be at most 3840\xd73840",sSWidthShouldBeLessThanTwiceTheHeight:"{PH1} {PH2} width should be less than twice the height",sSHeightShouldBeLessThanTwiceTheWidth:"{PH1} {PH2} height should be less than twice the width"},str_=i18n.i18n.registerUIStrings("resources/AppManifestView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class AppManifestView extends UI.Widget.VBox{constructor(){super(!0),this.registerRequiredCSS("resources/appManifestView.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("manifest-container"),Common.Settings.Settings.instance().moduleSetting("colorFormat").addChangeListener(this._updateManifest.bind(this,!0)),this._emptyView=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noManifestDetected)),this._emptyView.appendLink("https://web.dev/add-manifest/"),this._emptyView.show(this.contentElement),this._emptyView.hideWidget(),this._reportView=new UI.ReportView.ReportView(i18nString(UIStrings.appManifest)),this._reportView.registerRequiredCSS("resources/appManifestView.css",{enableLegacyPatching:!1}),this._reportView.element.classList.add("manifest-view-header"),this._reportView.show(this.contentElement),this._reportView.hideWidget(),this._errorsSection=this._reportView.appendSection(i18nString(UIStrings.errorsAndWarnings)),this._installabilitySection=this._reportView.appendSection(i18nString(UIStrings.installability)),this._identitySection=this._reportView.appendSection(i18nString(UIStrings.identity)),this._presentationSection=this._reportView.appendSection(i18nString(UIStrings.presentation)),this._iconsSection=this._reportView.appendSection(i18nString(UIStrings.icons),"report-section-icons"),this._shortcutSections=[],this._screenshotsSections=[],this._nameField=this._identitySection.appendField(i18nString(UIStrings.name)),this._shortNameField=this._identitySection.appendField(i18nString(UIStrings.shortName)),this._descriptionField=this._identitySection.appendFlexedField(i18nString(UIStrings.description)),this._startURLField=this._presentationSection.appendField(i18nString(UIStrings.startUrl));const e=this._presentationSection.appendField(i18nString(UIStrings.themeColor));this._themeColorSwatch=new InlineEditor.ColorSwatch.ColorSwatch,e.appendChild(this._themeColorSwatch);const t=this._presentationSection.appendField(i18nString(UIStrings.backgroundColor));this._backgroundColorSwatch=new InlineEditor.ColorSwatch.ColorSwatch,t.appendChild(this._backgroundColorSwatch),this._orientationField=this._presentationSection.appendField(i18nString(UIStrings.orientation)),this._displayField=this._presentationSection.appendField(i18nString(UIStrings.display)),this._throttler=new Common.Throttler.Throttler(1e3),SDK.SDKModel.TargetManager.instance().observeTargets(this),this._registeredListeners=[]}targetAdded(e){this._target||(this._target=e,this._resourceTreeModel=e.model(SDK.ResourceTreeModel.ResourceTreeModel),this._serviceWorkerManager=e.model(SDK.ServiceWorkerManager.ServiceWorkerManager),this._resourceTreeModel&&this._serviceWorkerManager&&(this._updateManifest(!0),this._registeredListeners=[this._resourceTreeModel.addEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,(e=>{this._updateManifest(!0)})),this._serviceWorkerManager.addEventListener(SDK.ServiceWorkerManager.Events.RegistrationUpdated,(e=>{this._updateManifest(!1)}))]))}targetRemoved(e){this._target===e&&this._resourceTreeModel&&this._serviceWorkerManager&&(delete this._resourceTreeModel,delete this._serviceWorkerManager,Common.EventTarget.EventTarget.removeEventListeners(this._registeredListeners))}async _updateManifest(e){if(!this._resourceTreeModel)return;const{url:t,data:i,errors:n}=await this._resourceTreeModel.fetchAppManifest(),s=await this._resourceTreeModel.getInstallabilityErrors(),r=await this._resourceTreeModel.getManifestIcons();this._throttler.schedule((()=>this._renderManifest(t,i,n,s,r)),e)}async _renderManifest(e,t,i,n,s){if(!t&&!i.length)return this._emptyView.showWidget(),void this._reportView.hideWidget();this._emptyView.hideWidget(),this._reportView.showWidget();const r=Components.Linkifier.Linkifier.linkifyURL(e);r.tabIndex=0,this._reportView.setURL(r),this._errorsSection.clearContent(),this._errorsSection.element.classList.toggle("hidden",!i.length);for(const y of i)this._errorsSection.appendRow().appendChild(UI.UIUtils.createIconLabel(y.message,y.critical?"smallicon-error":"smallicon-warning"));if(!t)return;65279===t.charCodeAt(0)&&(t=t.slice(1));const o=JSON.parse(t);this._nameField.textContent=w("name"),this._shortNameField.textContent=w("short_name");const a=[],d=w("description");this._descriptionField.textContent=d,d.length>324&&a.push(i18nString(UIStrings.descriptionMayBeTruncated)),this._startURLField.removeChildren();const c=w("start_url");if(c){const t=Common.ParsedURL.ParsedURL.completeURL(e,c),i=Components.Linkifier.Linkifier.linkifyURL(t,{text:c});i.tabIndex=0,this._startURLField.appendChild(i)}this._themeColorSwatch.classList.toggle("hidden",!w("theme_color"));const l=Common.Color.Color.parse(w("theme_color")||"white")||Common.Color.Color.parse("white");l&&this._themeColorSwatch.renderColor(l,!0),this._backgroundColorSwatch.classList.toggle("hidden",!w("background_color"));const h=Common.Color.Color.parse(w("background_color")||"white")||Common.Color.Color.parse("white");h&&this._backgroundColorSwatch.renderColor(h,!0),this._orientationField.textContent=w("orientation");const p=w("display");this._displayField.textContent=p;const S=o.icons||[];this._iconsSection.clearContent();const g=o.shortcuts||[];for(const y of this._shortcutSections)y.detach(!0);const m=o.screenshots||[];for(const y of this._screenshotsSections)y.detach(!0);const u=[],f=UI.UIUtils.CheckboxLabel.create(i18nString(UIStrings.showOnlyTheMinimumSafeAreaFor));f.classList.add("mask-checkbox"),f.addEventListener("click",(()=>{this._iconsSection.setIconMasked(f.checkboxElement.checked)})),this._iconsSection.appendRow().appendChild(f);const I=UI.XLink.XLink.create("https://web.dev/maskable-icon/",i18nString(UIStrings.documentationOnMaskableIcons));if(this._iconsSection.appendRow().appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.needHelpReadOurS,{PH1:I})),s&&s.primaryIcon){const t=document.createElement("div");t.classList.add("image-wrapper");const i=document.createElement("img");i.style.maxWidth="200px",i.style.maxHeight="200px",i.src="data:image/png;base64,"+s.primaryIcon,i.alt=i18nString(UIStrings.primaryManifestIconFromS,{PH1:e});const n=i18nString(UIStrings.primaryIconasUsedByChrome),r=this._iconsSection.appendFlexedField(n);t.appendChild(i),r.appendChild(t)}for(const y of S){const t=await this._appendImageResourceToSection(e,y,this._iconsSection,!1);u.push(...t)}let _=1;for(const y of g){const t=this._reportView.appendSection(i18nString(UIStrings.shortcutS,{PH1:_}));this._shortcutSections.push(t),t.appendFlexedField("Name",y.name),y.short_name&&t.appendFlexedField("Short name",y.short_name),y.description&&t.appendFlexedField("Description",y.description);const i=t.appendFlexedField("URL"),n=Common.ParsedURL.ParsedURL.completeURL(e,y.url),s=Components.Linkifier.Linkifier.linkifyURL(n,{text:y.url});s.tabIndex=0,i.appendChild(s);const r=y.icons||[];let o=!1;for(const a of r){const i=await this._appendImageResourceToSection(e,a,t,!1);if(u.push(...i),!o&&a.sizes){const e=a.sizes.match(/^(\d+)x(\d+)$/);e&&e[1]>=96&&e[2]>=96&&(o=!0)}}o||u.push(i18nString(UIStrings.shortcutSShouldIncludeAXPixel,{PH1:_})),_++}let P=1;for(const y of m){const t=this._reportView.appendSection(i18nString(UIStrings.screenshotS,{PH1:P}));this._screenshotsSections.push(t);const i=await this._appendImageResourceToSection(e,y,t,!0);u.push(...i),P++}this._installabilitySection.clearContent(),this._installabilitySection.element.classList.toggle("hidden",!n.length);const U=this.getInstallabilityErrorMessages(n);for(const y of U)this._installabilitySection.appendRow().appendChild(UI.UIUtils.createIconLabel(y,"smallicon-warning"));this._errorsSection.element.classList.toggle("hidden",!i.length&&!u.length&&!a.length);for(const y of a)this._errorsSection.appendRow().appendChild(UI.UIUtils.createIconLabel(y,"smallicon-warning"));for(const y of u)this._errorsSection.appendRow().appendChild(UI.UIUtils.createIconLabel(y,"smallicon-warning"));function w(e){const t=o[e];return"string"!==typeof t?"":t}}getInstallabilityErrorMessages(e){const t=[];for(const i of e){let e;switch(i.errorId){case"not-in-main-frame":e=i18nString(UIStrings.pageIsNotLoadedInTheMainFrame);break;case"not-from-secure-origin":e=i18nString(UIStrings.pageIsNotServedFromASecureOrigin);break;case"no-manifest":e=i18nString(UIStrings.pageHasNoManifestLinkUrl);break;case"manifest-empty":e=i18nString(UIStrings.manifestCouldNotBeFetchedIsEmpty);break;case"start-url-not-valid":e=i18nString(UIStrings.manifestStartUrlIsNotValid);break;case"manifest-missing-name-or-short-name":e=i18nString(UIStrings.manifestDoesNotContainANameOr);break;case"manifest-display-not-supported":e=i18nString(UIStrings.manifestDisplayPropertyMustBeOne);break;case"manifest-missing-suitable-icon":if(1!==i.errorArguments.length||"minimum-icon-size-in-pixels"!==i.errorArguments[0].name){console.error("Installability error does not have the correct errorArguments");break}e=i18nString(UIStrings.manifestDoesNotContainASuitable,{PH1:i.errorArguments[0].value});break;case"no-matching-service-worker":e=i18nString(UIStrings.noMatchingServiceWorkerDetected);break;case"no-acceptable-icon":if(1!==i.errorArguments.length||"minimum-icon-size-in-pixels"!==i.errorArguments[0].name){console.error("Installability error does not have the correct errorArguments");break}e=i18nString(UIStrings.noSuppliedIconIsAtLeastSpxSquare,{PH1:i.errorArguments[0].value});break;case"cannot-download-icon":e=i18nString(UIStrings.couldNotDownloadARequiredIcon);break;case"no-icon-available":e=i18nString(UIStrings.downloadedIconWasEmptyOr);break;case"platform-not-supported-on-android":e=i18nString(UIStrings.theSpecifiedApplicationPlatform);break;case"no-id-specified":e=i18nString(UIStrings.noPlayStoreIdProvided);break;case"ids-do-not-match":e=i18nString(UIStrings.thePlayStoreAppUrlAndPlayStoreId);break;case"already-installed":e=i18nString(UIStrings.theAppIsAlreadyInstalled);break;case"url-not-supported-for-webapk":e=i18nString(UIStrings.aUrlInTheManifestContainsA);break;case"in-incognito":e=i18nString(UIStrings.pageIsLoadedInAnIncognitoWindow);break;case"not-offline-capable":e=i18nString(UIStrings.pageDoesNotWorkOffline);break;case"no-url-for-service-worker":e=i18nString(UIStrings.couldNotCheckServiceWorker);break;case"prefer-related-applications":e=i18nString(UIStrings.manifestSpecifies);break;case"prefer-related-applications-only-beta-stable":e=i18nString(UIStrings.preferrelatedapplicationsIsOnly);break;case"manifest-display-override-not-supported":e=i18nString(UIStrings.manifestContainsDisplayoverride);break;case"warn-not-offline-capable":e=i18nString(UIStrings.pageDoesNotWorkOfflineThePage,{PH1:"https://developer.chrome.com/blog/improved-pwa-offline-detection/"});break;default:console.error(`Installability error id '${i.errorId}' is not recognized`)}e&&t.push(e)}return t}async _loadImage(e){const t=document.createElement("div");t.classList.add("image-wrapper");const i=document.createElement("img"),n=new Promise(((e,t)=>{i.onload=e,i.onerror=t}));i.src=e,i.alt=i18nString(UIStrings.imageFromS,{PH1:e}),t.appendChild(i);try{return await n,{wrapper:t,image:i}}catch(s){}return null}async _appendImageResourceToSection(e,t,i,n){const s=[],r=i18nString(n?UIStrings.screenshot:UIStrings.icon);if(!t.src)return s.push(i18nString(UIStrings.sSrcIsNotSet,{PH1:r})),s;const o=Common.ParsedURL.ParsedURL.completeURL(e,t.src);if(!o)return s.push(i18nString(UIStrings.sUrlSFailedToParse,{PH1:r,PH2:t.src})),s;const a=await this._loadImage(o);if(!a)return s.push(i18nString(UIStrings.sSFailedToLoad,{PH1:r,PH2:o})),s;const{wrapper:d,image:c}=a,l=(t.sizes?t.sizes.replace("x","\xd7")+"px":"")+"\n"+(t.type||""),h=i.appendFlexedField(l);if(t.sizes)if(/^\d+x\d+$/.test(t.sizes)){const[e,i]=t.sizes.split("x").map((e=>parseInt(e,10)));n||e===i?c.naturalWidth!==e&&c.naturalHeight!==i?s.push(i18nString(UIStrings.actualSizeSspxOfSSDoesNotMatch,{PH1:c.naturalWidth,PH2:c.naturalHeight,PH3:r,PH4:o,PH5:e,PH6:i})):c.naturalWidth!==e?s.push(i18nString(UIStrings.actualWidthSpxOfSSDoesNotMatch,{PH1:c.naturalWidth,PH2:r,PH3:o,PH4:e})):c.naturalHeight!==i?s.push(i18nString(UIStrings.actualHeightSpxOfSSDoesNotMatch,{PH1:c.naturalHeight,PH2:r,PH3:o,PH4:i})):n&&(e<320||i<320?s.push(i18nString(UIStrings.sSSizeShouldBeAtLeast320,{PH1:r,PH2:o})):e>3840||i>3840?s.push(i18nString(UIStrings.sSSizeShouldBeAtMost3840,{PH1:r,PH2:o})):e>2*i?s.push(i18nString(UIStrings.sSWidthShouldBeLessThanTwiceTheHeight,{PH1:r,PH2:o})):i>2*e&&s.push(i18nString(UIStrings.sSHeightShouldBeLessThanTwiceTheWidth,{PH1:r,PH2:o}))):s.push(i18nString(UIStrings.sSDimensionsShouldBeSquare,{PH1:r,PH2:o}))}else s.push(i18nString(UIStrings.sSShouldSpecifyItsSizeAs,{PH1:r,PH2:o}));else s.push(i18nString(UIStrings.sSDoesNotSpecifyItsSizeInThe,{PH1:r,PH2:o}));return h.appendChild(d),s}}