import*as BrowserSDK from"../browser_sdk/browser_sdk.js";import*as Common from"../common/common.js";import*as CookieTable from"../cookie_table/cookie_table.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{StorageItemsView}from"./StorageItemsView.js";const UIStrings={showUrlDecoded:"Show URL decoded",cookies:"Cookies",selectACookieToPreviewItsValue:"Select a cookie to preview its value",onlyShowCookiesWithAnIssue:"Only show cookies with an issue",onlyShowCookiesWhichHaveAn:"Only show cookies which have an associated issue",clearFilteredCookies:"Clear filtered cookies",clearAllCookies:"Clear all cookies",numberOfCookiesShownInTableS:"Number of cookies shown in table: {PH1}"},str_=i18n.i18n.registerUIStrings("resources/CookieItemsView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class CookiePreviewWidget extends UI.Widget.VBox{constructor(){super(),this.setMinimumSize(230,45),this._cookie=null,this._showDecodedSetting=Common.Settings.Settings.instance().createSetting("cookieViewShowDecoded",!1);const e=document.createElement("div");e.classList.add("cookie-preview-widget-header");const t=document.createElement("span");t.classList.add("cookie-preview-widget-header-label"),t.textContent="Cookie Value",e.appendChild(t),this.contentElement.appendChild(e);const i=UI.UIUtils.CheckboxLabel.create(i18nString(UIStrings.showUrlDecoded),this._showDecodedSetting.get());i.classList.add("cookie-preview-widget-toggle"),i.checkboxElement.addEventListener("click",(()=>this.showDecoded(!this._showDecodedSetting.get()))),e.appendChild(i),this._toggle=i;const s=document.createElement("div");s.classList.add("cookie-preview-widget-cookie-value"),s.textContent="",s.addEventListener("dblclick",this.handleDblClickOnCookieValue.bind(this)),this._value=s,this.contentElement.classList.add("cookie-preview-widget"),this.contentElement.appendChild(s)}showDecoded(e){this._cookie&&(this._showDecodedSetting.set(e),this._toggle.checkboxElement.checked=e,this._updatePreview())}_updatePreview(){this._cookie?this._value.textContent=this._showDecodedSetting.get()?decodeURIComponent(this._cookie.value()):this._cookie.value():this._value.textContent=""}setCookie(e){this._cookie=e,this._updatePreview()}handleDblClickOnCookieValue(e){e.preventDefault();const t=document.createRange();t.selectNode(this._value);const i=window.getSelection();i&&(i.removeAllRanges(),i.addRange(t))}}export class CookieItemsView extends StorageItemsView{constructor(e,t){super(i18nString(UIStrings.cookies),"cookiesPanel"),this.registerRequiredCSS("resources/cookieItemsView.css",{enableLegacyPatching:!1}),this.element.classList.add("storage-view"),this._model=e,this._cookieDomain=t,this._totalSize=0,this._cookiesTable=new CookieTable.CookiesTable.CookiesTable(!1,this._saveCookie.bind(this),this.refreshItems.bind(this),this._handleCookieSelected.bind(this),this._deleteCookie.bind(this)),this._cookiesTable.setMinimumSize(0,50),this._splitWidget=new UI.SplitWidget.SplitWidget(!1,!0,"cookieItemsSplitViewState"),this._splitWidget.show(this.element),this._previewPanel=new UI.Widget.VBox;const i=this._previewPanel.element.createChild("div","preview-panel-resizer");this._splitWidget.setMainWidget(this._cookiesTable),this._splitWidget.setSidebarWidget(this._previewPanel),this._splitWidget.installResizer(i),this._previewWidget=new CookiePreviewWidget,this._emptyWidget=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.selectACookieToPreviewItsValue)),this._emptyWidget.show(this._previewPanel.contentElement),this._onlyIssuesFilterUI=new UI.Toolbar.ToolbarCheckbox(i18nString(UIStrings.onlyShowCookiesWithAnIssue),i18nString(UIStrings.onlyShowCookiesWhichHaveAn),(()=>{this._updateWithCookies(this._allCookies)})),this.appendToolbarItem(this._onlyIssuesFilterUI),this._refreshThrottler=new Common.Throttler.Throttler(300),this._eventDescriptors=[],this._allCookies=[],this._shownCookies=[],this._selectedCookie=null,this.setCookiesDomain(e,t)}setCookiesDomain(e,t){this._model=e,this._cookieDomain=t,this.refreshItems(),Common.EventTarget.EventTarget.removeEventListeners(this._eventDescriptors);const i=e.target().model(SDK.NetworkManager.NetworkManager);i&&(this._eventDescriptors=[i.addEventListener(SDK.NetworkManager.Events.ResponseReceived,this._onResponseReceived,this),i.addEventListener(SDK.NetworkManager.Events.LoadingFinished,this._onLoadingFinished,this)])}_showPreview(e){e!==this._selectedCookie&&(this._selectedCookie=e,e?(this._emptyWidget.detach(),this._previewWidget.setCookie(e),this._previewWidget.show(this._previewPanel.contentElement)):(this._previewWidget.detach(),this._emptyWidget.show(this._previewPanel.contentElement)))}_handleCookieSelected(){const e=this._cookiesTable.selectedCookie();this.setCanDeleteSelected(Boolean(e)),this._showPreview(e)}async _saveCookie(e,t){return t&&e.key()!==t.key()&&await this._model.deleteCookie(t),this._model.saveCookie(e)}_deleteCookie(e,t){this._model.deleteCookie(e).then(t)}_updateWithCookies(e){this._allCookies=e,this._totalSize=e.reduce(((e,t)=>e+t.size()),0);const t=Common.ParsedURL.ParsedURL.fromString(this._cookieDomain),i=t?t.host:"";this._cookiesTable.setCookieDomain(i),this._shownCookies=this.filter(e,(e=>`${e.name()} ${e.value()} ${e.domain()}`)),this.hasFilter()?(this.setDeleteAllTitle(i18nString(UIStrings.clearFilteredCookies)),this.setDeleteAllGlyph("largeicon-delete-filter")):(this.setDeleteAllTitle(i18nString(UIStrings.clearAllCookies)),this.setDeleteAllGlyph("largeicon-delete-list")),this._cookiesTable.setCookies(this._shownCookies,this._model.getCookieToBlockedReasonsMap()),UI.ARIAUtils.alert(i18nString(UIStrings.numberOfCookiesShownInTableS,{PH1:this._shownCookies.length}),this.element),this.setCanFilter(!0),this.setCanDeleteAll(this._shownCookies.length>0),this.setCanDeleteSelected(Boolean(this._cookiesTable.selectedCookie())),this._cookiesTable.selectedCookie()||this._showPreview(null)}filter(e,t){return super.filter(e,t).filter((e=>!this._onlyIssuesFilterUI.checked()||e instanceof SDK.Cookie.Cookie&&BrowserSDK.RelatedIssue.hasIssues(e)))}deleteAllItems(){this._showPreview(null),this._model.deleteCookies(this._shownCookies).then((()=>this.refreshItems()))}deleteSelectedItem(){const e=this._cookiesTable.selectedCookie();e&&(this._showPreview(null),this._model.deleteCookie(e).then((()=>this.refreshItems())))}refreshItems(){this._model.getCookiesForDomain(this._cookieDomain).then(this._updateWithCookies.bind(this))}refreshItemsThrottled(){this._refreshThrottler.schedule((()=>Promise.resolve(this.refreshItems())))}_onResponseReceived(){this.refreshItemsThrottled()}_onLoadingFinished(){this.refreshItemsThrottled()}}