import*as Common from"../common/common.js";import*as SDK from"../sdk/sdk.js";export class IndexedDBModel extends SDK.SDKModel.SDKModel{constructor(e){super(e),e.registerStorageDispatcher(this),this._securityOriginManager=e.model(SDK.SecurityOriginManager.SecurityOriginManager),this._indexedDBAgent=e.indexedDBAgent(),this._storageAgent=e.storageAgent(),this._databases=new Map,this._databaseNamesBySecurityOrigin={},this._originsUpdated=new Set,this._throttler=new Common.Throttler.Throttler(1e3)}static keyFromIDBKey(e){if("undefined"===typeof e||null===e)return;let t;switch(typeof e){case"number":t={type:Protocol.IndexedDB.KeyType.Number,number:e};break;case"string":t={type:Protocol.IndexedDB.KeyType.String,string:e};break;case"object":if(e instanceof Date)t={type:Protocol.IndexedDB.KeyType.Date,date:e.getTime()};else{if(!Array.isArray(e))return;{const a=[];for(let t=0;t<e.length;++t){const i=IndexedDBModel.keyFromIDBKey(e[t]);i&&a.push(i)}t={type:Protocol.IndexedDB.KeyType.Array,array:a}}}break;default:return}return t}static _keyRangeFromIDBKeyRange(e){return{lower:IndexedDBModel.keyFromIDBKey(e.lower),upper:IndexedDBModel.keyFromIDBKey(e.upper),lowerOpen:Boolean(e.lowerOpen),upperOpen:Boolean(e.upperOpen)}}static idbKeyPathFromKeyPath(e){let t;switch(e.type){case Protocol.IndexedDB.KeyPathType.Null:t=null;break;case Protocol.IndexedDB.KeyPathType.String:t=e.string;break;case Protocol.IndexedDB.KeyPathType.Array:t=e.array}return t}static keyPathStringFromIDBKeyPath(e){return"string"===typeof e?'"'+e+'"':e instanceof Array?'["'+e.join('", "')+'"]':null}enable(){if(!this._enabled){if(this._indexedDBAgent.invoke_enable(),this._securityOriginManager){this._securityOriginManager.addEventListener(SDK.SecurityOriginManager.Events.SecurityOriginAdded,this._securityOriginAdded,this),this._securityOriginManager.addEventListener(SDK.SecurityOriginManager.Events.SecurityOriginRemoved,this._securityOriginRemoved,this);for(const e of this._securityOriginManager.securityOrigins())this._addOrigin(e)}this._enabled=!0}}clearForOrigin(e){this._enabled&&this._databaseNamesBySecurityOrigin[e]&&(this._removeOrigin(e),this._addOrigin(e))}async deleteDatabase(e){this._enabled&&(await this._indexedDBAgent.invoke_deleteDatabase({securityOrigin:e.securityOrigin,databaseName:e.name}),this._loadDatabaseNames(e.securityOrigin))}async refreshDatabaseNames(){for(const e in this._databaseNamesBySecurityOrigin)await this._loadDatabaseNames(e);this.dispatchEventToListeners(Events.DatabaseNamesRefreshed)}refreshDatabase(e){this._loadDatabase(e,!0)}async clearObjectStore(e,t){await this._indexedDBAgent.invoke_clearObjectStore({securityOrigin:e.securityOrigin,databaseName:e.name,objectStoreName:t})}async deleteEntries(e,t,a){const i=IndexedDBModel._keyRangeFromIDBKeyRange(a);await this._indexedDBAgent.invoke_deleteObjectStoreEntries({securityOrigin:e.securityOrigin,databaseName:e.name,objectStoreName:t,keyRange:i})}_securityOriginAdded(e){const t=e.data;this._addOrigin(t)}_securityOriginRemoved(e){const t=e.data;this._removeOrigin(t)}_addOrigin(e){console.assert(!this._databaseNamesBySecurityOrigin[e]),this._databaseNamesBySecurityOrigin[e]=[],this._loadDatabaseNames(e),this._isValidSecurityOrigin(e)&&this._storageAgent.invoke_trackIndexedDBForOrigin({origin:e})}_removeOrigin(e){console.assert(Boolean(this._databaseNamesBySecurityOrigin[e]));for(let t=0;t<this._databaseNamesBySecurityOrigin[e].length;++t)this._databaseRemoved(e,this._databaseNamesBySecurityOrigin[e][t]);delete this._databaseNamesBySecurityOrigin[e],this._isValidSecurityOrigin(e)&&this._storageAgent.invoke_untrackIndexedDBForOrigin({origin:e})}_isValidSecurityOrigin(e){const t=Common.ParsedURL.ParsedURL.fromString(e);return null!==t&&t.scheme.startsWith("http")}_updateOriginDatabaseNames(e,t){const a=new Set(t),i=new Set(this._databaseNamesBySecurityOrigin[e]);this._databaseNamesBySecurityOrigin[e]=t;for(const s of i)a.has(s)||this._databaseRemoved(e,s);for(const s of a)i.has(s)||this._databaseAdded(e,s)}databases(){const e=[];for(const t in this._databaseNamesBySecurityOrigin){const a=this._databaseNamesBySecurityOrigin[t];for(let i=0;i<a.length;++i)e.push(new DatabaseId(t,a[i]))}return e}_databaseAdded(e,t){const a=new DatabaseId(e,t);this.dispatchEventToListeners(Events.DatabaseAdded,{model:this,databaseId:a})}_databaseRemoved(e,t){const a=new DatabaseId(e,t);this.dispatchEventToListeners(Events.DatabaseRemoved,{model:this,databaseId:a})}async _loadDatabaseNames(e){const{databaseNames:t}=await this._indexedDBAgent.invoke_requestDatabaseNames({securityOrigin:e});return t&&this._databaseNamesBySecurityOrigin[e]?(this._updateOriginDatabaseNames(e,t),t):[]}async _loadDatabase(e,t){const{databaseWithObjectStores:a}=await this._indexedDBAgent.invoke_requestDatabase({securityOrigin:e.securityOrigin,databaseName:e.name});if(!a)return;if(!this._databaseNamesBySecurityOrigin[e.securityOrigin])return;const i=new Database(e,a.version);this._databases.set(e,i);for(const s of a.objectStores){const e=IndexedDBModel.idbKeyPathFromKeyPath(s.keyPath),t=new ObjectStore(s.name,e,s.autoIncrement);for(let a=0;a<s.indexes.length;++a){const e=s.indexes[a],i=IndexedDBModel.idbKeyPathFromKeyPath(e.keyPath),r=new Index(e.name,i,e.unique,e.multiEntry);t.indexes.set(r.name,r)}i.objectStores.set(t.name,t)}this.dispatchEventToListeners(Events.DatabaseLoaded,{model:this,database:i,entriesUpdated:t})}loadObjectStoreData(e,t,a,i,s,r){this._requestData(e,e.name,t,"",a,i,s,r)}loadIndexData(e,t,a,i,s,r,n){this._requestData(e,e.name,t,a,i,s,r,n)}async _requestData(e,t,a,i,s,r,n,o){const d=s?IndexedDBModel._keyRangeFromIDBKeyRange(s):void 0,c=await this._indexedDBAgent.invoke_requestData({securityOrigin:e.securityOrigin,databaseName:t,objectStoreName:a,indexName:i,skipCount:r,pageSize:n,keyRange:d});if(c.getError())return void console.error("IndexedDBAgent error: "+c.getError());const h=this.target().model(SDK.RuntimeModel.RuntimeModel);if(!h||!this._databaseNamesBySecurityOrigin[e.securityOrigin])return;const y=c.objectStoreDataEntries,g=[];for(const u of y){const e=h.createRemoteObject(u.key),t=h.createRemoteObject(u.primaryKey),a=h.createRemoteObject(u.value);g.push(new Entry(e,t,a))}o(g,c.hasMore)}async getMetadata(e,t){const a=e.securityOrigin,i=e.name,s=t.name,r=await this._indexedDBAgent.invoke_getMetadata({securityOrigin:a,databaseName:i,objectStoreName:s});return r.getError()?(console.error("IndexedDBAgent error: "+r.getError()),null):{entriesCount:r.entriesCount,keyGeneratorValue:r.keyGeneratorValue}}async _refreshDatabaseList(e){const t=await this._loadDatabaseNames(e);for(const a of t)this._loadDatabase(new DatabaseId(e,a),!1)}indexedDBListUpdated({origin:e}){this._originsUpdated.add(e),this._throttler.schedule((()=>{const e=Array.from(this._originsUpdated,(e=>{this._refreshDatabaseList(e)}));return this._originsUpdated.clear(),Promise.all(e)}))}indexedDBContentUpdated({origin:e,databaseName:t,objectStoreName:a}){const i=new DatabaseId(e,t);this.dispatchEventToListeners(Events.IndexedDBContentUpdated,{databaseId:i,objectStoreName:a,model:this})}cacheStorageListUpdated(e){}cacheStorageContentUpdated(e){}}SDK.SDKModel.SDKModel.register(IndexedDBModel,SDK.SDKModel.Capability.Storage,!1);export var Events;!function(e){e.DatabaseAdded="DatabaseAdded",e.DatabaseRemoved="DatabaseRemoved",e.DatabaseLoaded="DatabaseLoaded",e.DatabaseNamesRefreshed="DatabaseNamesRefreshed",e.IndexedDBContentUpdated="IndexedDBContentUpdated"}(Events||(Events={}));export class Entry{constructor(e,t,a){this.key=e,this.primaryKey=t,this.value=a}}export class DatabaseId{constructor(e,t){this.securityOrigin=e,this.name=t}equals(e){return this.name===e.name&&this.securityOrigin===e.securityOrigin}}export class Database{constructor(e,t){this.databaseId=e,this.version=t,this.objectStores=new Map}}export class ObjectStore{constructor(e,t,a){this.name=e,this.keyPath=t,this.autoIncrement=a,this.indexes=new Map}get keyPathString(){return IndexedDBModel.keyPathStringFromIDBKeyPath(this.keyPath)}}export class Index{constructor(e,t,a,i){this.name=e,this.keyPath=t,this.unique=a,this.multiEntry=i}get keyPathString(){return IndexedDBModel.keyPathStringFromIDBKeyPath(this.keyPath)}}