import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={yes:"Yes",no:"No",clickToRevealInElementsPanel:"Click to reveal in Elements panel",document:"Document",url:"URL",security:"Security",openerFrame:"Opener Frame",accessToOpener:"Access to opener",showsWhetherTheOpenedWindowIs:"Shows whether the opened window is able to access its opener and vice versa",windowWithoutTitle:"Window without title",closed:"closed",worker:"worker",type:"Type",securityIsolation:"Security & Isolation",crossoriginEmbedderPolicy:"Cross-Origin Embedder Policy",webWorker:"Web Worker",serviceWorker:"`Service Worker`",unknown:"Unknown",reportingTo:"reporting to"},str_=i18n.i18n.registerUIStrings("resources/OpenedWindowDetailsView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),booleanToYesNo=e=>i18nString(e?UIStrings.yes:UIStrings.no);function linkifyIcon(e,t,i){const n=UI.Icon.Icon.create(e,"icon-link devtools-link"),r=document.createElement("span");return UI.Tooltip.Tooltip.install(r,t),r.classList.add("devtools-link"),r.tabIndex=0,r.appendChild(n),r.addEventListener("click",(e=>{e.consume(!0),i()})),r.addEventListener("keydown",(e=>{"Enter"===e.key&&(e.consume(!0),i())})),r}async function maybeCreateLinkToElementsPanel(e){let t=null;if(e instanceof SDK.ResourceTreeModel.ResourceTreeFrame?t=e:e&&(t=SDK.FrameManager.FrameManager.instance().getFrame(e)),!t)return null;const i=await t.getOwnerDOMNodeOrDocument();if(!i)return null;const n=linkifyIcon("mediumicon-elements-panel",i18nString(UIStrings.clickToRevealInElementsPanel),(()=>Common.Revealer.reveal(i))),r=document.createElement("span");return r.textContent=`<${i.nodeName().toLocaleLowerCase()}>`,n.insertBefore(r,n.firstChild),n.addEventListener("mouseenter",(()=>{t&&t.highlight()})),n.addEventListener("mouseleave",(()=>{SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()})),n}export class OpenedWindowDetailsView extends UI.ThrottledWidget.ThrottledWidget{constructor(e,t){super(),this._targetInfo=e,this._isWindowClosed=t,this.registerRequiredCSS("resources/frameDetailsReportView.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("frame-details-container"),this._reportView=new UI.ReportView.ReportView(this.buildTitle()),this._reportView.registerRequiredCSS("resources/frameDetailsReportView.css",{enableLegacyPatching:!1}),this._reportView.show(this.contentElement),this._reportView.element.classList.add("frame-details-report-container"),this._documentSection=this._reportView.appendSection(i18nString(UIStrings.document)),this._URLFieldValue=this._documentSection.appendField(i18nString(UIStrings.url)),this._securitySection=this._reportView.appendSection(i18nString(UIStrings.security)),this._openerElementField=this._securitySection.appendField(i18nString(UIStrings.openerFrame)),this._securitySection.setFieldVisible(i18nString(UIStrings.openerFrame),!1),this._hasDOMAccessValue=this._securitySection.appendField(i18nString(UIStrings.accessToOpener)),UI.Tooltip.Tooltip.install(this._hasDOMAccessValue,i18nString(UIStrings.showsWhetherTheOpenedWindowIs)),this.update()}async doUpdate(){var e;this._reportView.setTitle(this.buildTitle()),this._URLFieldValue.textContent=this._targetInfo.url,this._hasDOMAccessValue.textContent=(e=this._targetInfo.canAccessOpener,i18nString(e?UIStrings.yes:UIStrings.no)),this.maybeDisplayOpenerFrame()}async maybeDisplayOpenerFrame(){this._openerElementField.removeChildren();const e=await maybeCreateLinkToElementsPanel(this._targetInfo.openerFrameId);if(e)return this._openerElementField.append(e),void this._securitySection.setFieldVisible(i18nString(UIStrings.openerFrame),!0);this._securitySection.setFieldVisible(i18nString(UIStrings.openerFrame),!1)}buildTitle(){let e=this._targetInfo.title||i18nString(UIStrings.windowWithoutTitle);return this._isWindowClosed&&(e+=` (${i18nString(UIStrings.closed)})`),e}setIsWindowClosed(e){this._isWindowClosed=e}setTargetInfo(e){this._targetInfo=e}}export class WorkerDetailsView extends UI.ThrottledWidget.ThrottledWidget{constructor(e){super(),this._targetInfo=e,this.registerRequiredCSS("resources/frameDetailsReportView.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("frame-details-container"),this._reportView=new UI.ReportView.ReportView(this._targetInfo.title||this._targetInfo.url||i18nString(UIStrings.worker)),this._reportView.registerRequiredCSS("resources/frameDetailsReportView.css",{enableLegacyPatching:!1}),this._reportView.show(this.contentElement),this._reportView.element.classList.add("frame-details-report-container"),this._documentSection=this._reportView.appendSection(i18nString(UIStrings.document)),this._URLFieldValue=this._documentSection.appendField(i18nString(UIStrings.url)),this._URLFieldValue.textContent=this._targetInfo.url;this._documentSection.appendField(i18nString(UIStrings.type)).textContent=this.workerTypeToString(this._targetInfo.type),this._isolationSection=this._reportView.appendSection(i18nString(UIStrings.securityIsolation)),this._coepPolicy=this._isolationSection.appendField(i18nString(UIStrings.crossoriginEmbedderPolicy)),this.update()}workerTypeToString(e){return i18nString("worker"===e?UIStrings.webWorker:"service_worker"===e?UIStrings.serviceWorker:UIStrings.unknown)}async _updateCoopCoepStatus(){const e=SDK.SDKModel.TargetManager.instance().targetById(this._targetInfo.targetId);if(!e)return;const t=e.model(SDK.NetworkManager.NetworkManager),i=t&&await t.getSecurityIsolationStatus("");if(!i)return;this._fillCrossOriginPolicy(this._coepPolicy,(e=>e!==Protocol.Network.CrossOriginEmbedderPolicyValue.None),i.coep)}_fillCrossOriginPolicy(e,t,i){if(!i)return void(e.textContent="");const n=t(i.value);if(e.textContent=n?i.value:i.reportOnlyValue,!n&&t(i.reportOnlyValue)){const t=document.createElement("span");t.classList.add("inline-comment"),t.textContent="report-only",e.appendChild(t)}const r=n?i.reportingEndpoint:i.reportOnlyReportingEndpoint;if(r){e.createChild("span","inline-name").textContent=i18nString(UIStrings.reportingTo);e.createChild("span").textContent=r}}async doUpdate(){await this._updateCoopCoepStatus()}}