import*as Common from"../common/common.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as Network from"../network/network.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={cache:"Cache",refresh:"Refresh",deleteSelected:"Delete Selected",filterByPath:"Filter by Path",selectACacheEntryAboveToPreview:"Select a cache entry above to preview",name:"Name",responsetype:"`Response-Type`",contenttype:"`Content-Type`",contentlength:"`Content-Length`",timeCached:"Time Cached",serviceWorkerCache:"`Service Worker` Cache",matchingEntriesS:"Matching entries: {PH1}",totalEntriesS:"Total entries: {PH1}",headers:"Headers",preview:"Preview"},str_=i18n.i18n.registerUIStrings("resources/ServiceWorkerCacheViews.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ServiceWorkerCacheView extends UI.View.SimpleView{constructor(e,t){super(i18nString(UIStrings.cache)),this.registerRequiredCSS("resources/serviceWorkerCacheViews.css",{enableLegacyPatching:!0}),this._model=e,this._entriesForTest=null,this.element.classList.add("service-worker-cache-data-view"),this.element.classList.add("storage-view");const r=new UI.Toolbar.Toolbar("data-view-toolbar",this.element);this._splitWidget=new UI.SplitWidget.SplitWidget(!1,!1),this._splitWidget.show(this.element),this._previewPanel=new UI.Widget.VBox;const i=this._previewPanel.element.createChild("div","cache-preview-panel-resizer");this._splitWidget.setMainWidget(this._previewPanel),this._splitWidget.installResizer(i),this._preview=null,this._cache=t,this._dataGrid=null,this._refreshThrottler=new Common.Throttler.Throttler(300),this._refreshButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.refresh),"largeicon-refresh"),this._refreshButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._refreshButtonClicked,this),r.appendToolbarItem(this._refreshButton),this._deleteSelectedButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.deleteSelected),"largeicon-delete"),this._deleteSelectedButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(e=>{this._deleteButtonClicked(null)})),r.appendToolbarItem(this._deleteSelectedButton);const s=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.filterByPath),"",1);r.appendToolbarItem(s);const a=new Common.Throttler.Throttler(300);this._entryPathFilter="",s.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,(()=>{a.schedule((()=>(this._entryPathFilter=s.value(),this._updateData(!0))))})),this._returnCount=null,this._summaryBarElement=null,this._loadingPromise=null,this.update(t)}_resetDataGrid(){this._dataGrid&&this._dataGrid.asWidget().detach(),this._dataGrid=this._createDataGrid();const e=this._dataGrid.asWidget();this._splitWidget.setSidebarWidget(e),e.setMinimumSize(0,250)}wasShown(){this._model.addEventListener(SDK.ServiceWorkerCacheModel.Events.CacheStorageContentUpdated,this._cacheContentUpdated,this),this._updateData(!0)}willHide(){this._model.removeEventListener(SDK.ServiceWorkerCacheModel.Events.CacheStorageContentUpdated,this._cacheContentUpdated,this)}_showPreview(e){e&&this._preview===e||(this._preview&&this._preview.detach(),e||(e=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.selectACacheEntryAboveToPreview))),this._preview=e,this._preview.show(this._previewPanel.element))}_createDataGrid(){const e=[{id:"number",title:"#",sortable:!1,width:"3px"},{id:"name",title:i18nString(UIStrings.name),weight:4,sortable:!0},{id:"responseType",title:i18nString(UIStrings.responsetype),weight:1,align:DataGrid.DataGrid.Align.Right,sortable:!0},{id:"contentType",title:i18nString(UIStrings.contenttype),weight:1,sortable:!0},{id:"contentLength",title:i18nString(UIStrings.contentlength),weight:1,align:DataGrid.DataGrid.Align.Right,sortable:!0},{id:"responseTime",title:i18nString(UIStrings.timeCached),width:"12em",weight:1,align:DataGrid.DataGrid.Align.Right,sortable:!0}],t=new DataGrid.DataGrid.DataGridImpl({displayName:i18nString(UIStrings.serviceWorkerCache),columns:e,deleteCallback:this._deleteButtonClicked.bind(this),refreshCallback:this._updateData.bind(this,!0),editCallback:void 0});return t.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortingChanged,this),t.addEventListener(DataGrid.DataGrid.Events.SelectedNode,(e=>{this._previewCachedResponse(e.data.data)}),this),t.setStriped(!0),t}_sortingChanged(){if(!this._dataGrid)return;const e=this._dataGrid,t=e.isSortOrderAscending(),r=e.sortColumnId();let i;"name"===r?i=(e,t)=>e._name.localeCompare(t._name):"contentType"===r?i=(e,t)=>e.data.mimeType.localeCompare(t.data.mimeType):"contentLength"===r?i=(e,t)=>e.data.resourceSize-t.data.resourceSize:"responseTime"===r?i=(e,t)=>e.data.endTime-t.data.endTime:"responseType"===r&&(i=(e,t)=>e._responseType.localeCompare(t._responseType));const s=e.rootNode().children.slice();e.rootNode().removeChildren(),s.sort(((e,r)=>{const s=i(e,r);return t?s:-s})),s.forEach((t=>e.rootNode().appendChild(t)))}async _deleteButtonClicked(e){(e||(e=this._dataGrid&&this._dataGrid.selectedNode))&&(await this._model.deleteCacheEntry(this._cache,e.data.url()),e.remove())}update(e){this._cache=e,this._resetDataGrid(),this._updateData(!0)}_updateSummaryBar(){this._summaryBarElement||(this._summaryBarElement=this.element.createChild("div","cache-storage-summary-bar")),this._summaryBarElement.removeChildren();const e=this._summaryBarElement.createChild("span");this._entryPathFilter?e.textContent=i18nString(UIStrings.matchingEntriesS,{PH1:this._returnCount}):e.textContent=i18nString(UIStrings.totalEntriesS,{PH1:this._returnCount})}_updateDataCallback(e,t,r){if(!this._dataGrid)return;const i=this._dataGrid.selectedNode&&this._dataGrid.selectedNode.data.url();this._refreshButton.setEnabled(!0),this._entriesForTest=t,this._returnCount=r,this._updateSummaryBar();const s=new Map,a=this._dataGrid.rootNode();for(const o of a.children)s.set(o.data.url,o);a.removeChildren();let n=null;for(let o=0;o<t.length;++o){const e=t[o];let r=s.get(e.requestURL);r&&r.data.responseTime===e.responseTime?r.data.number=o:(r=new DataGridNode(o,this._createRequest(e),e.responseType),r.selectable=!0),a.appendChild(r),e.requestURL===i&&(n=r)}n?n.revealAndSelect():this._showPreview(null),this._updatedForTest()}async _updateData(e){if(!e&&this._loadingPromise)return this._loadingPromise;if(this._refreshButton.setEnabled(!1),this._loadingPromise)return this._loadingPromise;this._loadingPromise=new Promise((e=>{this._model.loadAllCacheData(this._cache,this._entryPathFilter,((t,r)=>{e({entries:t,returnCount:r})}))}));const{entries:t,returnCount:r}=await this._loadingPromise;this._updateDataCallback(0,t,r),this._loadingPromise=null}_refreshButtonClicked(e){this._updateData(!0)}_cacheContentUpdated(e){const t=e.data;this._cache.securityOrigin===t.origin&&this._cache.cacheName===t.cacheName&&this._refreshThrottler.schedule((()=>Promise.resolve(this._updateData(!0))),!0)}async _previewCachedResponse(e){let t=networkRequestToPreview.get(e);t||(t=new RequestView(e),networkRequestToPreview.set(e,t)),this._dataGrid&&this._dataGrid.selectedNode&&e===this._dataGrid.selectedNode.data&&this._showPreview(t)}_createRequest(e){const t=new SDK.NetworkRequest.NetworkRequest("cache-storage-"+e.requestURL,e.requestURL,"","","",null);t.requestMethod=e.requestMethod,t.setRequestHeaders(e.requestHeaders),t.statusCode=e.responseStatus,t.statusText=e.responseStatusText,t.protocol=new Common.ParsedURL.ParsedURL(e.requestURL).scheme,t.responseHeaders=e.responseHeaders,t.setRequestHeadersText(""),t.endTime=e.responseTime;let r=e.responseHeaders.find((e=>"content-type"===e.name.toLowerCase()));const i=r?r.value:SDK.NetworkRequest.MIME_TYPE.PLAIN;t.mimeType=i,r=e.responseHeaders.find((e=>"content-length"===e.name.toLowerCase())),t.resourceSize=r&&Number(r.value)||0;let s=Common.ResourceType.ResourceType.fromMimeType(i);return s||(s=Common.ResourceType.ResourceType.fromURL(e.requestURL)||Common.ResourceType.resourceTypes.Other),t.setResourceType(s),t.setContentDataProvider(this._requestContent.bind(this,t)),t}async _requestContent(e){const t=e.resourceType().isTextType(),r={error:null,content:null,encoded:!t},i=await this._cache.requestCachedResponse(e.url(),e.requestHeaders());return i&&(r.content=t?window.atob(i.body):i.body),r}_updatedForTest(){}}ServiceWorkerCacheView._previewSymbol=Symbol("preview");const networkRequestToPreview=new WeakMap;export class DataGridNode extends DataGrid.DataGrid.DataGridNode{constructor(e,t,r){super(t),this._number=e;const i=new Common.ParsedURL.ParsedURL(t.url());i.isValid?this._name=Platform.StringUtilities.trimURL(t.url(),i.domain()):this._name=t.url(),this._request=t,this._responseType=r}createCell(e){const t=this.createTD(e);let r;return"number"===e?r=String(this._number):"name"===e?r=this._name:"responseType"===e?r="opaqueResponse"===this._responseType?"opaque":"opaqueRedirect"===this._responseType?"opaqueredirect":this._responseType:"contentType"===e?r=this._request.mimeType:"contentLength"===e?r=(0|this._request.resourceSize).toLocaleString("en-US"):"responseTime"===e&&(r=new Date(1e3*this._request.endTime).toLocaleString()),DataGrid.DataGrid.DataGridImpl.setElementText(t,r||"",!0),UI.Tooltip.Tooltip.install(t,this._request.url()),t}}export class RequestView extends UI.Widget.VBox{constructor(e){super(),this._tabbedPane=new UI.TabbedPane.TabbedPane,this._tabbedPane.addEventListener(UI.TabbedPane.Events.TabSelected,this._tabSelected,this),this._resourceViewTabSetting=Common.Settings.Settings.instance().createSetting("cacheStorageViewTab","preview"),this._tabbedPane.appendTab("headers",i18nString(UIStrings.headers),new Network.RequestHeadersView.RequestHeadersView(e)),this._tabbedPane.appendTab("preview",i18nString(UIStrings.preview),new Network.RequestPreviewView.RequestPreviewView(e)),this._tabbedPane.show(this.element)}wasShown(){super.wasShown(),this._selectTab()}_selectTab(e){e||(e=this._resourceViewTabSetting.get()),e&&!this._tabbedPane.selectTab(e)&&this._tabbedPane.selectTab("headers")}_tabSelected(e){e.data.isUserGesture&&this._resourceViewTabSetting.set(e.data.tabId)}}