import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{ApplicationCacheModel}from"./ApplicationCacheModel.js";import{DatabaseModel}from"./DatabaseModel.js";import{DOMStorageModel}from"./DOMStorageModel.js";import{IndexedDBModel}from"./IndexedDBModel.js";const UIStrings={storageQuotaUsed:"{PH1} used out of {PH2} storage quota",storageQuotaUsedWithBytes:"{PH1} bytes used out of {PH2} bytes storage quota",storageWithCustomMarker:"{PH1} (custom)",storageTitle:"Storage",usage:"Usage",mb:"MB",learnMore:"Learn more",clearSiteData:"Clear site data",application:"Application",unregisterServiceWorker:"Unregister service workers",localAndSessionStorage:"Local and session storage",indexDB:"IndexedDB",webSql:"Web SQL",cookies:"Cookies",cache:"Cache",cacheStorage:"Cache storage",applicationCache:"Application cache",includingThirdPartyCookies:"including third-party cookies",sFailedToLoad:"{PH1} (failed to load)",internalError:"Internal error",pleaseEnterANumber:"Please enter a number",numberMustBeNonNegative:"Number must be non-negative",clearing:"Clearing...",storageQuotaIsLimitedIn:"Storage quota is limited in Incognito mode",fileSystem:"File System",other:"Other",storageUsage:"Storage usage",serviceWorkers:"Service Workers"},str_=i18n.i18n.registerUIStrings("resources/StorageView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class StorageView extends UI.ThrottledWidget.ThrottledWidget{constructor(){super(!0,1e3),this.registerRequiredCSS("resources/storageView.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("clear-storage-container");const e=Protocol.Storage.StorageType;this.pieColors=new Map([[e.Appcache,"rgb(110, 161, 226)"],[e.Cache_storage,"rgb(229, 113, 113)"],[e.Cookies,"rgb(239, 196, 87)"],[e.Indexeddb,"rgb(155, 127, 230)"],[e.Local_storage,"rgb(116, 178, 102)"],[e.Service_workers,"rgb(255, 167, 36)"],[e.Websql,"rgb(203, 220, 56)"]]),this.reportView=new UI.ReportView.ReportView(i18nString(UIStrings.storageTitle)),this.reportView.registerRequiredCSS("resources/storageView.css",{enableLegacyPatching:!1}),this.reportView.element.classList.add("clear-storage-header"),this.reportView.show(this.contentElement),this.target=null,this.securityOrigin=null,this.settings=new Map;for(const h of AllStorageTypes)this.settings.set(h,Common.Settings.Settings.instance().createSetting("clear-storage-"+h,!0));this.includeThirdPartyCookiesSetting=Common.Settings.Settings.instance().createSetting("clear-storage-include-third-party-cookies",!1);const t=this.reportView.appendSection(i18nString(UIStrings.usage));this.quotaRow=t.appendSelectableRow(),this.quotaRow.classList.add("quota-usage-row");const r=t.appendRow(),i=UI.XLink.XLink.create("https://developers.google.com/web/tools/chrome-devtools/progressive-web-apps#opaque-responses",i18nString(UIStrings.learnMore));r.appendChild(i),this.quotaUsage=null,this.pieChart=new PerfUI.PieChart.PieChart,this.populatePieChart(0,[]);const o=t.appendRow();o.classList.add("usage-breakdown-row"),o.appendChild(this.pieChart),this.previousOverrideFieldValue="";const a=t.appendRow();this.quotaOverrideCheckbox=UI.UIUtils.CheckboxLabel.create("Simulate custom storage quota",!1,""),a.appendChild(this.quotaOverrideCheckbox),this.quotaOverrideCheckbox.checkboxElement.addEventListener("click",this.onClickCheckbox.bind(this),!1),this.quotaOverrideControlRow=t.appendRow(),this.quotaOverrideEditor=this.quotaOverrideControlRow.createChild("input","quota-override-notification-editor"),this.quotaOverrideControlRow.appendChild(UI.UIUtils.createLabel(i18nString(UIStrings.mb))),this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideEditor.addEventListener("keyup",(e=>{"Enter"===e.key&&(this.applyQuotaOverrideFromInputField(),e.consume(!0))})),this.quotaOverrideEditor.addEventListener("focusout",(e=>{this.applyQuotaOverrideFromInputField(),e.consume(!0)}));const s=t.appendRow();this.quotaOverrideErrorMessage=s.createChild("div","quota-override-error");const n=this.reportView.appendSection("","clear-storage-button").appendRow();this.clearButton=UI.UIUtils.createTextButton(i18nString(UIStrings.clearSiteData),this.clear.bind(this)),this.clearButton.id="storage-view-clear-button",n.appendChild(this.clearButton);const g=UI.SettingsUI.createSettingCheckbox(i18nString(UIStrings.includingThirdPartyCookies),this.includeThirdPartyCookiesSetting,!0);g.classList.add("include-third-party-cookies"),n.appendChild(g);const c=this.reportView.appendSection(i18nString(UIStrings.application));this.appendItem(c,i18nString(UIStrings.unregisterServiceWorker),Protocol.Storage.StorageType.Service_workers),c.markFieldListAsGroup();const l=this.reportView.appendSection(i18nString(UIStrings.storageTitle));this.appendItem(l,i18nString(UIStrings.localAndSessionStorage),Protocol.Storage.StorageType.Local_storage),this.appendItem(l,i18nString(UIStrings.indexDB),Protocol.Storage.StorageType.Indexeddb),this.appendItem(l,i18nString(UIStrings.webSql),Protocol.Storage.StorageType.Websql),this.appendItem(l,i18nString(UIStrings.cookies),Protocol.Storage.StorageType.Cookies),l.markFieldListAsGroup();const d=this.reportView.appendSection(i18nString(UIStrings.cache));this.appendItem(d,i18nString(UIStrings.cacheStorage),Protocol.Storage.StorageType.Cache_storage),this.appendItem(d,i18nString(UIStrings.applicationCache),Protocol.Storage.StorageType.Appcache),d.markFieldListAsGroup(),SDK.SDKModel.TargetManager.instance().observeTargets(this)}appendItem(e,t,r){const i=e.appendRow(),o=this.settings.get(r);o&&i.appendChild(UI.SettingsUI.createSettingCheckbox(t,o,!0))}targetAdded(e){if(this.target)return;this.target=e;const t=e.model(SDK.SecurityOriginManager.SecurityOriginManager);this.updateOrigin(t.mainSecurityOrigin(),t.unreachableMainSecurityOrigin()),t.addEventListener(SDK.SecurityOriginManager.Events.MainSecurityOriginChanged,this.originChanged,this)}targetRemoved(e){if(this.target!==e)return;e.model(SDK.SecurityOriginManager.SecurityOriginManager).removeEventListener(SDK.SecurityOriginManager.Events.MainSecurityOriginChanged,this.originChanged,this)}originChanged(e){const t=e.data.mainSecurityOrigin,r=e.data.unreachableMainSecurityOrigin;this.updateOrigin(t,r)}updateOrigin(e,t){const r=this.securityOrigin;t?(this.securityOrigin=t,this.reportView.setSubtitle(i18nString(UIStrings.sFailedToLoad,{PH1:t}))):(this.securityOrigin=e,this.reportView.setSubtitle(e)),r!==this.securityOrigin&&(this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!1,this.quotaOverrideErrorMessage.textContent=""),this.doUpdate()}async applyQuotaOverrideFromInputField(){if(!this.target||!this.securityOrigin)return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.internalError));this.quotaOverrideErrorMessage.textContent="";const e=this.quotaOverrideEditor.value;if(""===e)return await this.clearQuotaForOrigin(this.target,this.securityOrigin),void(this.previousOverrideFieldValue="");const t=parseFloat(e);if(!Number.isFinite(t))return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.pleaseEnterANumber));if(t<0)return void(this.quotaOverrideErrorMessage.textContent=i18nString(UIStrings.numberMustBeNonNegative));const r=1e6,i=Math.round(t*r),o=""+i/r;this.quotaOverrideEditor.value=o,this.previousOverrideFieldValue=o,await this.target.storageAgent().invoke_overrideQuotaForOrigin({origin:this.securityOrigin,quotaSize:i})}async clearQuotaForOrigin(e,t){await e.storageAgent().invoke_overrideQuotaForOrigin({origin:t})}async onClickCheckbox(){this.quotaOverrideControlRow.classList.contains("hidden")?(this.quotaOverrideControlRow.classList.remove("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!0,this.quotaOverrideEditor.value=this.previousOverrideFieldValue,this.quotaOverrideEditor.focus()):this.target&&this.securityOrigin&&(this.quotaOverrideControlRow.classList.add("hidden"),this.quotaOverrideCheckbox.checkboxElement.checked=!1,await this.clearQuotaForOrigin(this.target,this.securityOrigin),this.quotaOverrideErrorMessage.textContent="")}clear(){if(!this.securityOrigin)return;const e=[];for(const r of this.settings.keys()){const t=this.settings.get(r);t&&t.get()&&e.push(r)}if(this.target){const t=this.includeThirdPartyCookiesSetting.get();StorageView.clear(this.target,this.securityOrigin,e,t)}this.clearButton.disabled=!0;const t=this.clearButton.textContent;this.clearButton.textContent=i18nString(UIStrings.clearing),setTimeout((()=>{this.clearButton.disabled=!1,this.clearButton.textContent=t,this.clearButton.focus()}),500)}static clear(e,t,r,i){e.storageAgent().invoke_clearDataForOrigin({origin:t,storageTypes:r.join(",")});const o=new Set(r),a=o.has(Protocol.Storage.StorageType.All);if(o.has(Protocol.Storage.StorageType.Cookies)||a){const r=e.model(SDK.CookieModel.CookieModel);r&&r.clear(void 0,i?void 0:t)}if(o.has(Protocol.Storage.StorageType.Indexeddb)||a)for(const s of SDK.SDKModel.TargetManager.instance().targets()){const e=s.model(IndexedDBModel);e&&e.clearForOrigin(t)}if(o.has(Protocol.Storage.StorageType.Local_storage)||a){const r=e.model(DOMStorageModel);r&&r.clearForOrigin(t)}if(o.has(Protocol.Storage.StorageType.Websql)||a){const t=e.model(DatabaseModel);t&&(t.disable(),t.enable())}if(o.has(Protocol.Storage.StorageType.Cache_storage)||a){const e=SDK.SDKModel.TargetManager.instance().mainTarget(),r=e&&e.model(SDK.ServiceWorkerCacheModel.ServiceWorkerCacheModel);r&&r.clearForOrigin(t)}if(o.has(Protocol.Storage.StorageType.Appcache)||a){const t=e.model(ApplicationCacheModel);t&&t.reset()}}async doUpdate(){if(!this.securityOrigin||!this.target)return this.quotaRow.textContent="",void this.populatePieChart(0,[]);const e=this.securityOrigin,t=await this.target.storageAgent().invoke_getUsageAndQuota({origin:e});if(this.quotaRow.textContent="",t.getError())return void this.populatePieChart(0,[]);const r=t.overrideActive,i=Platform.NumberUtilities.bytesToString(t.quota),o=Platform.NumberUtilities.bytesToString(t.usage),a=i18nString(UIStrings.storageWithCustomMarker,{PH1:i}),s=r?UI.Fragment.Fragment.build`<b>${a}</b>`.element():i,n=i18n.i18n.getFormatLocalizedString(str_,UIStrings.storageQuotaUsed,{PH1:o,PH2:s});if(this.quotaRow.appendChild(n),UI.Tooltip.Tooltip.install(this.quotaRow,i18nString(UIStrings.storageQuotaUsedWithBytes,{PH1:t.usage.toLocaleString(),PH2:t.quota.toLocaleString()})),!t.overrideActive&&t.quota<125829120&&(UI.Tooltip.Tooltip.install(this.quotaRow,i18nString(UIStrings.storageQuotaIsLimitedIn)),this.quotaRow.appendChild(UI.Icon.Icon.create("smallicon-info"))),null===this.quotaUsage||this.quotaUsage!==t.usage){this.quotaUsage=t.usage;const e=[];for(const r of t.usageBreakdown.sort(((e,t)=>t.usage-e.usage))){const t=r.usage;if(!t)continue;const i=this.getStorageTypeName(r.storageType),o=this.pieColors.get(r.storageType)||"#ccc";e.push({value:t,color:o,title:i})}this.populatePieChart(t.usage,e)}this.update()}populatePieChart(e,t){this.pieChart.data={chartName:i18nString(UIStrings.storageUsage),size:110,formatter:Platform.NumberUtilities.bytesToString,showLegend:!0,total:e,slices:t}}getStorageTypeName(e){switch(e){case Protocol.Storage.StorageType.File_systems:return i18nString(UIStrings.fileSystem);case Protocol.Storage.StorageType.Websql:return i18nString(UIStrings.webSql);case Protocol.Storage.StorageType.Appcache:return i18nString(UIStrings.application);case Protocol.Storage.StorageType.Indexeddb:return i18nString(UIStrings.indexDB);case Protocol.Storage.StorageType.Cache_storage:return i18nString(UIStrings.cacheStorage);case Protocol.Storage.StorageType.Service_workers:return i18nString(UIStrings.serviceWorkers);default:return i18nString(UIStrings.other)}}}export const AllStorageTypes=[Protocol.Storage.StorageType.Appcache,Protocol.Storage.StorageType.Cache_storage,Protocol.Storage.StorageType.Cookies,Protocol.Storage.StorageType.Indexeddb,Protocol.Storage.StorageType.Local_storage,Protocol.Storage.StorageType.Service_workers,Protocol.Storage.StorageType.Websql];let actionDelegateInstance;export class ActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return actionDelegateInstance&&!t||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(e,t){switch(t){case"resources.clear":return this.handleClear(!1);case"resources.clear-incl-third-party-cookies":return this.handleClear(!0)}return!1}handleClear(e){const t=SDK.SDKModel.TargetManager.instance().mainTarget();if(!t)return!1;const r=t.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!r)return!1;const i=r.getMainSecurityOrigin();return!!i&&(StorageView.clear(t,i,AllStorageTypes,e),!0)}}