import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import{ConsoleMessage,ConsoleModel,MessageLevel,MessageSource}from"./ConsoleModel.js";import{Events as NetworkManagerEvents,NetworkManager}from"./NetworkManager.js";import{Events as NetworkRequestEvents,InitiatorType}from"./NetworkRequest.js";import{Events as ResourceTreeModelEvents,ResourceTreeModel}from"./ResourceTreeModel.js";import{RuntimeModel}from"./RuntimeModel.js";import{TargetManager}from"./SDKModel.js";const UIStrings={anonymous:"<anonymous>",considerDisablingSWhileDebugging:"Consider disabling {PH1} while debugging. For more info see: {PH2}"},str_=i18n.i18n.registerUIStrings("sdk/NetworkLog.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let _instance;export class NetworkLog extends Common.ObjectWrapper.ObjectWrapper{constructor(){super(),this._requests=[],this._sentNetworkRequests=[],this._receivedNetworkResponses=[],this._requestsSet=new Set,this._requestsMap=new Map,this._pageLoadForManager=new Map,this._isRecording=!0,this._modelListeners=new WeakMap,this._initiatorData=new WeakMap,TargetManager.instance().observeModels(NetworkManager,this);const e=Common.Settings.Settings.instance().moduleSetting("network_log.record-log");e.addChangeListener((()=>{!Common.Settings.Settings.instance().moduleSetting("network_log.preserve-log").get()&&e.get()&&this.reset(!0),this.setIsRecording(e.get())}),this),this._unresolvedPreflightRequests=new Map}static instance(){return _instance||(_instance=new NetworkLog),_instance}modelAdded(e){const t=[];t.push(e.addEventListener(NetworkManagerEvents.RequestStarted,this._onRequestStarted,this)),t.push(e.addEventListener(NetworkManagerEvents.RequestUpdated,this._onRequestUpdated,this)),t.push(e.addEventListener(NetworkManagerEvents.RequestRedirected,this._onRequestRedirect,this)),t.push(e.addEventListener(NetworkManagerEvents.RequestFinished,this._onRequestUpdated,this)),t.push(e.addEventListener(NetworkManagerEvents.MessageGenerated,this._networkMessageGenerated.bind(this,e))),t.push(e.addEventListener(NetworkManagerEvents.ResponseReceived,this._onResponseReceived,this));const s=e.target().model(ResourceTreeModel);s&&(t.push(s.addEventListener(ResourceTreeModelEvents.WillReloadPage,this._willReloadPage,this)),t.push(s.addEventListener(ResourceTreeModelEvents.MainFrameNavigated,this._onMainFrameNavigated,this)),t.push(s.addEventListener(ResourceTreeModelEvents.Load,this._onLoad,this)),t.push(s.addEventListener(ResourceTreeModelEvents.DOMContentLoaded,this._onDOMContentLoaded.bind(this,s)))),this._modelListeners.set(e,t)}modelRemoved(e){this._removeNetworkManagerListeners(e)}_removeNetworkManagerListeners(e){Common.EventTarget.EventTarget.removeEventListeners(this._modelListeners.get(e)||[])}setIsRecording(e){this._isRecording!==e&&(this._isRecording=e,e?TargetManager.instance().observeModels(NetworkManager,this):(TargetManager.instance().unobserveModels(NetworkManager,this),TargetManager.instance().models(NetworkManager).forEach(this._removeNetworkManagerListeners.bind(this))))}requestForURL(e){return this._requests.find((t=>t.url()===e))||null}originalRequestForURL(e){return this._sentNetworkRequests.find((t=>t.url===e))||null}originalResponseForURL(e){return this._receivedNetworkResponses.find((t=>t.url===e))||null}requests(){return this._requests}requestByManagerAndId(e,t){for(let s=this._requests.length-1;s>=0;s--){const r=this._requests[s];if(t===r.requestId()&&e===NetworkManager.forRequest(r))return r}return null}_requestByManagerAndURL(e,t){for(const s of this._requests)if(t===s.url()&&e===NetworkManager.forRequest(s))return s;return null}_initializeInitiatorSymbolIfNeeded(e){let t=this._initiatorData.get(e);return t||(t={info:null,chain:null,request:void 0},this._initiatorData.set(e,t),t)}initiatorInfoForRequest(e){const t=this._initializeInitiatorSymbolIfNeeded(e);if(t.info)return t.info;let s=InitiatorType.Other,r="",i=-1/0,n=-1/0,o=null,a=null,u=null;const d=e.initiator(),l=e.redirectSource();if(l)s=InitiatorType.Redirect,r=l.url();else if(d)if(d.type===Protocol.Network.InitiatorType.Parser)s=InitiatorType.Parser,r=d.url?d.url:r,i="number"===typeof d.lineNumber?d.lineNumber:i,n="number"===typeof d.columnNumber?d.columnNumber:n;else if(d.type===Protocol.Network.InitiatorType.Script){for(let e=d.stack;e;){const t=e.callFrames.length?e.callFrames[0]:null;if(t){s=InitiatorType.Script,r=t.url||i18nString(UIStrings.anonymous),i=t.lineNumber,n=t.columnNumber,o=t.scriptId;break}e=e.parent}!d.stack&&d.url&&(s=InitiatorType.Script,r=d.url,i=d.lineNumber||0),d.stack&&d.stack.callFrames&&d.stack.callFrames.length&&(a=d.stack||null)}else d.type===Protocol.Network.InitiatorType.Preload?s=InitiatorType.Preload:d.type===Protocol.Network.InitiatorType.Preflight?(s=InitiatorType.Preflight,u=e.preflightInitiatorRequest()):d.type===Protocol.Network.InitiatorType.SignedExchange&&(s=InitiatorType.SignedExchange,r=d.url||"");return t.info={type:s,url:r,lineNumber:i,columnNumber:n,scriptId:o,stack:a,initiatorRequest:u},t.info}initiatorGraphForRequest(e){const t=new Map,s=NetworkManager.forRequest(e);for(const r of this._requests){if(s===NetworkManager.forRequest(r)&&this._initiatorChain(r).has(e)){const e=this._initiatorRequest(r);e&&t.set(r,e)}}return{initiators:this._initiatorChain(e),initiated:t}}_initiatorChain(e){const t=this._initializeInitiatorSymbolIfNeeded(e);let s=t.chain;if(s)return s;s=new Set;let r=e;for(;r;){const e=this._initializeInitiatorSymbolIfNeeded(r);if(e.chain){Platform.SetUtilities.addAll(s,e.chain);break}if(s.has(r))break;s.add(r),r=this._initiatorRequest(r)}return t.chain=s,s}_initiatorRequest(e){const t=this._initializeInitiatorSymbolIfNeeded(e);if(void 0!==t.request)return t.request;const s=this.initiatorInfoForRequest(e).url,r=NetworkManager.forRequest(e);return t.request=r?this._requestByManagerAndURL(r,s):null,t.request}_willReloadPage(){Common.Settings.Settings.instance().moduleSetting("network_log.preserve-log").get()||this.reset(!0)}_onMainFrameNavigated(e){const t=e.data,s=t.resourceTreeModel().target().model(NetworkManager);if(!s||t.resourceTreeModel().target().parentTarget())return;if(t.url!==t.unreachableUrl()&&t.url.startsWith("chrome-error://"))return;const r=Common.Settings.Settings.instance().moduleSetting("network_log.preserve-log").get(),i=this._requests,n=this._requests.filter((e=>NetworkManager.forRequest(e)===s)),o=this._requestsSet;this._requests=[],this._sentNetworkRequests=[],this._receivedNetworkResponses=[],this._requestsSet=new Set,this._requestsMap.clear(),this._unresolvedPreflightRequests.clear(),this.dispatchEventToListeners(Events.Reset,{clearIfPreserved:!r});let a=null;const u=[];for(const l of n)if(l.loaderId===t.loaderId){if(!a){a=new PageLoad(l);let e=l.redirectSource();for(;e;)u.push(e),e=e.redirectSource()}u.push(l)}const d=[];for(const l of i){if(!l.initiatedByServiceWorker())continue;u.some((e=>e.url()===l.url()&&e.issueTime()<=l.issueTime()))&&d.push(l)}u.push(...d);for(const l of u)a&&a.bindRequest(l),o.delete(l),this._addRequest(l);if(r)for(const l of o)this._addRequest(l);a&&this._pageLoadForManager.set(s,a)}_addRequest(e){this._requests.push(e),this._requestsSet.add(e);const t=this._requestsMap.get(e.requestId());t?t.push(e):this._requestsMap.set(e.requestId(),[e]),this._tryResolvePreflightRequests(e),this.dispatchEventToListeners(Events.RequestAdded,e)}_tryResolvePreflightRequests(e){if(e.isPreflightRequest()){const t=e.initiator();if(t&&t.requestId){const s=this.requestsForId(t.requestId);s.length?e.setPreflightInitiatorRequest(s[0]):this._unresolvedPreflightRequests.set(t.requestId,e)}}else{const t=this._unresolvedPreflightRequests.get(e.requestId());if(t){this._unresolvedPreflightRequests.delete(e.requestId()),e.setPreflightRequest(t),t.setPreflightInitiatorRequest(e);const s=this._initiatorData.get(t);s&&(s.info=null),this.dispatchEventToListeners(Events.RequestUpdated,t)}}}importRequests(e){this.reset(!0),this._requests=[],this._sentNetworkRequests=[],this._receivedNetworkResponses=[],this._requestsSet.clear(),this._requestsMap.clear(),this._unresolvedPreflightRequests.clear();for(const t of e)this._addRequest(t)}_onRequestStarted(e){const t=e.data.request;e.data.originalRequest&&this._sentNetworkRequests.push(e.data.originalRequest),this._requestsSet.add(t);const s=NetworkManager.forRequest(t),r=s?this._pageLoadForManager.get(s):null;r&&r.bindRequest(t),this._addRequest(t)}_onResponseReceived(e){const t=e.data.response;this._receivedNetworkResponses.push(t)}_onRequestUpdated(e){const t=e.data;this._requestsSet.has(t)&&this.dispatchEventToListeners(Events.RequestUpdated,t)}_onRequestRedirect(e){const t=e.data;this._initiatorData.delete(t)}_onDOMContentLoaded(e,t){const s=e.target().model(NetworkManager),r=s?this._pageLoadForManager.get(s):null;r&&(r.contentLoadTime=t.data)}_onLoad(e){const t=e.data.resourceTreeModel.target().model(NetworkManager),s=t?this._pageLoadForManager.get(t):null;s&&(s.loadTime=e.data.loadTime)}reset(e){this._requests=[],this._sentNetworkRequests=[],this._receivedNetworkResponses=[],this._requestsSet.clear(),this._requestsMap.clear(),this._unresolvedPreflightRequests.clear();const t=new Set(TargetManager.instance().models(NetworkManager));for(const s of this._pageLoadForManager.keys())t.has(s)||this._pageLoadForManager.delete(s);this.dispatchEventToListeners(Events.Reset,{clearIfPreserved:e})}_networkMessageGenerated(e,t){const s=t.data,r=new ConsoleMessage(e.target().model(RuntimeModel),MessageSource.Network,s.warning?MessageLevel.Warning:MessageLevel.Info,s.message);this.associateConsoleMessageWithRequest(r,s.requestId),ConsoleModel.instance().addMessage(r)}associateConsoleMessageWithRequest(e,t){const s=e.target(),r=s?s.model(NetworkManager):null;if(!r)return;const i=this.requestByManagerAndId(r,t);if(!i)return;consoleMessageToRequest.set(e,i);const n=i.initiator();n&&(e.stackTrace=n.stack||void 0,n.url&&(e.url=n.url,e.line=n.lineNumber||0))}static requestForConsoleMessage(e){return consoleMessageToRequest.get(e)||null}requestsForId(e){return this._requestsMap.get(e)||[]}}const consoleMessageToRequest=new WeakMap;export class PageLoad{constructor(e){this.id=++PageLoad._lastIdentifier,this.url=e.url(),this.startTime=e.startTime,this.loadTime,this.contentLoadTime,this.mainRequest=e,this._showDataSaverWarningIfNeeded()}async _showDataSaverWarningIfNeeded(){const e=NetworkManager.forRequest(this.mainRequest);if(!e)return;this.mainRequest.finished||await this.mainRequest.once(NetworkRequestEvents.FinishedLoading);const t=this.mainRequest.requestHeaderValue("Save-Data");if(!PageLoad._dataSaverMessageWasShown&&t&&"on"===t){const t=i18nString(UIStrings.considerDisablingSWhileDebugging,{PH1:"Chrome Data Saver",PH2:"https://support.google.com/chrome/?p=datasaver"});e.dispatchEventToListeners(NetworkManagerEvents.MessageGenerated,{message:t,requestId:this.mainRequest.requestId(),warning:!0}),PageLoad._dataSaverMessageWasShown=!0}}static forRequest(e){return pageLoadForRequest.get(e)||null}bindRequest(e){pageLoadForRequest.set(e,this)}}PageLoad._lastIdentifier=0;const pageLoadForRequest=new WeakMap;PageLoad._dataSaverMessageWasShown=!1;export const Events={Reset:Symbol("Reset"),RequestAdded:Symbol("RequestAdded"),RequestUpdated:Symbol("RequestUpdated")};let InitiatorData;export let InitiatorGraph;export let _InitiatorInfo;