import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Root from"../root/root.js";import{DebuggerModel,Events as DebuggerModelEvents}from"./DebuggerModel.js";import{DeferredDOMNode,DOMModel,Events as DOMModelEvents}from"./DOMModel.js";import{OverlayPersistentHighlighter}from"./OverlayPersistentHighlighter.js";import{Capability,SDKModel,TargetManager}from"./SDKModel.js";const UIStrings={pausedInDebugger:"Paused in debugger"},str_=i18n.i18n.registerUIStrings("sdk/OverlayModel.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export let HighlightColor;export let HighlightRect;export let Hinge;export class OverlayModel extends SDKModel{constructor(e){super(e),this._domModel=e.model(DOMModel),e.registerOverlayDispatcher(this),this._overlayAgent=e.overlayAgent(),this._debuggerModel=e.model(DebuggerModel),this._debuggerModel&&(Common.Settings.Settings.instance().moduleSetting("disablePausedStateOverlay").addChangeListener(this._updatePausedInDebuggerMessage,this),this._debuggerModel.addEventListener(DebuggerModelEvents.DebuggerPaused,this._updatePausedInDebuggerMessage,this),this._debuggerModel.addEventListener(DebuggerModelEvents.DebuggerResumed,this._updatePausedInDebuggerMessage,this),this._debuggerModel.addEventListener(DebuggerModelEvents.GlobalObjectCleared,this._updatePausedInDebuggerMessage,this)),this._inspectModeEnabled=!1,this._flexFeaturesExperimentEnabled=Root.Runtime.experiments.isEnabled("cssFlexboxFeatures"),this._hideHighlightTimeout=null,this._defaultHighlighter=new DefaultHighlighter(this),this._highlighter=this._defaultHighlighter,this._showPaintRectsSetting=Common.Settings.Settings.instance().moduleSetting("showPaintRects"),this._showLayoutShiftRegionsSetting=Common.Settings.Settings.instance().moduleSetting("showLayoutShiftRegions"),this._showAdHighlightsSetting=Common.Settings.Settings.instance().moduleSetting("showAdHighlights"),this._showDebugBordersSetting=Common.Settings.Settings.instance().moduleSetting("showDebugBorders"),this._showFPSCounterSetting=Common.Settings.Settings.instance().moduleSetting("showFPSCounter"),this._showScrollBottleneckRectsSetting=Common.Settings.Settings.instance().moduleSetting("showScrollBottleneckRects"),this._showHitTestBordersSetting=Common.Settings.Settings.instance().moduleSetting("showHitTestBorders"),this._showWebVitalsSetting=Common.Settings.Settings.instance().moduleSetting("showWebVitals"),this._registeredListeners=[],this._showViewportSizeOnResize=!0,e.suspended()||(this._overlayAgent.invoke_enable(),this._wireAgentToSettings()),this._peristentHighlighter=new OverlayPersistentHighlighter(this,this._flexFeaturesExperimentEnabled),this._domModel.addEventListener(DOMModelEvents.NodeRemoved,(()=>{this._peristentHighlighter&&this._peristentHighlighter.refreshHighlights()})),this._domModel.addEventListener(DOMModelEvents.DocumentUpdated,(()=>{this._peristentHighlighter&&this._peristentHighlighter.hideAllInOverlay()})),this._sourceOrderHighlighter=new SourceOrderHighlighter(this),this._sourceOrderModeActive=!1}static highlightObjectAsDOMNode(e){const t=e.runtimeModel().target().model(DOMModel);t&&t.overlayModel().highlightInOverlay({object:e,selectorList:void 0})}static hideDOMNodeHighlight(){for(const e of TargetManager.instance().models(OverlayModel))e._delayedHideHighlight(0)}static async muteHighlight(){return Promise.all(TargetManager.instance().models(OverlayModel).map((e=>e.suspendModel())))}static async unmuteHighlight(){return Promise.all(TargetManager.instance().models(OverlayModel).map((e=>e.resumeModel())))}static highlightRect(e){for(const t of TargetManager.instance().models(OverlayModel))t.highlightRect(e)}static clearHighlight(){for(const e of TargetManager.instance().models(OverlayModel))e.clearHighlight()}getDOMModel(){return this._domModel}highlightRect({x:e,y:t,width:o,height:i,color:r,outlineColor:n}){const l=r||{r:255,g:0,b:255,a:.3},h=n||{r:255,g:0,b:255,a:.5};return this._overlayAgent.invoke_highlightRect({x:e,y:t,width:o,height:i,color:l,outlineColor:h})}clearHighlight(){return this._overlayAgent.invoke_hideHighlight()}async _wireAgentToSettings(){this._registeredListeners=[this._showPaintRectsSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowPaintRects({result:this._showPaintRectsSetting.get()}))),this._showLayoutShiftRegionsSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowLayoutShiftRegions({result:this._showLayoutShiftRegionsSetting.get()}))),this._showAdHighlightsSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowAdHighlights({show:this._showAdHighlightsSetting.get()}))),this._showDebugBordersSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowDebugBorders({show:this._showDebugBordersSetting.get()}))),this._showFPSCounterSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowFPSCounter({show:this._showFPSCounterSetting.get()}))),this._showScrollBottleneckRectsSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowScrollBottleneckRects({show:this._showScrollBottleneckRectsSetting.get()}))),this._showHitTestBordersSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowHitTestBorders({show:this._showHitTestBordersSetting.get()}))),this._showWebVitalsSetting.addChangeListener((()=>this._overlayAgent.invoke_setShowWebVitals({show:this._showWebVitalsSetting.get()})))],this._showPaintRectsSetting.get()&&this._overlayAgent.invoke_setShowPaintRects({result:!0}),this._showLayoutShiftRegionsSetting.get()&&this._overlayAgent.invoke_setShowLayoutShiftRegions({result:!0}),this._showAdHighlightsSetting.get()&&this._overlayAgent.invoke_setShowAdHighlights({show:!0}),this._showDebugBordersSetting.get()&&this._overlayAgent.invoke_setShowDebugBorders({show:!0}),this._showFPSCounterSetting.get()&&this._overlayAgent.invoke_setShowFPSCounter({show:!0}),this._showScrollBottleneckRectsSetting.get()&&this._overlayAgent.invoke_setShowScrollBottleneckRects({show:!0}),this._showHitTestBordersSetting.get()&&this._overlayAgent.invoke_setShowHitTestBorders({show:!0}),this._showWebVitalsSetting.get()&&this._overlayAgent.invoke_setShowWebVitals({show:!0}),this._debuggerModel&&this._debuggerModel.isPaused()&&this._updatePausedInDebuggerMessage(),await this._overlayAgent.invoke_setShowViewportSizeOnResize({show:this._showViewportSizeOnResize})}async suspendModel(){Common.EventTarget.EventTarget.removeEventListeners(this._registeredListeners),await this._overlayAgent.invoke_disable()}async resumeModel(){await Promise.all([this._overlayAgent.invoke_enable(),this._wireAgentToSettings()])}setShowViewportSizeOnResize(e){this._showViewportSizeOnResize!==e&&(this._showViewportSizeOnResize=e,this.target().suspended()||this._overlayAgent.invoke_setShowViewportSizeOnResize({show:e}))}_updatePausedInDebuggerMessage(){if(this.target().suspended())return;const e=this._debuggerModel&&this._debuggerModel.isPaused()&&!Common.Settings.Settings.instance().moduleSetting("disablePausedStateOverlay").get()?i18nString(UIStrings.pausedInDebugger):void 0;this._overlayAgent.invoke_setPausedInDebuggerMessage({message:e})}setHighlighter(e){this._highlighter=e||this._defaultHighlighter}async setInspectMode(e,t=!0){await this._domModel.requestDocument(),this._inspectModeEnabled=e!==Protocol.Overlay.InspectMode.None,this.dispatchEventToListeners(Events.InspectModeWillBeToggled,this),this._highlighter.setInspectMode(e,this._buildHighlightConfig("all",t))}inspectModeEnabled(){return this._inspectModeEnabled}highlightInOverlay(e,t,o){if(this._sourceOrderModeActive)return;this._hideHighlightTimeout&&(clearTimeout(this._hideHighlightTimeout),this._hideHighlightTimeout=null);const i=this._buildHighlightConfig(t);"undefined"!==typeof o&&(i.showInfo=o),this._highlighter.highlightInOverlay(e,i)}highlightInOverlayForTwoSeconds(e){this.highlightInOverlay(e),this._delayedHideHighlight(2e3)}highlightGridInPersistentOverlay(e){this._peristentHighlighter&&(this._peristentHighlighter.highlightGridInOverlay(e),this.dispatchEventToListeners(Events.PersistentGridOverlayStateChanged,{nodeId:e,enabled:!0}))}isHighlightedGridInPersistentOverlay(e){return!!this._peristentHighlighter&&this._peristentHighlighter.isGridHighlighted(e)}hideGridInPersistentOverlay(e){this._peristentHighlighter&&(this._peristentHighlighter.hideGridInOverlay(e),this.dispatchEventToListeners(Events.PersistentGridOverlayStateChanged,{nodeId:e,enabled:!1}))}highlightFlexContainerInPersistentOverlay(e){this._peristentHighlighter&&(this._peristentHighlighter.highlightFlexInOverlay(e),this.dispatchEventToListeners(Events.PersistentFlexContainerOverlayStateChanged,{nodeId:e,enabled:!0}))}isHighlightedFlexContainerInPersistentOverlay(e){return!!this._peristentHighlighter&&this._peristentHighlighter.isFlexHighlighted(e)}hideFlexContainerInPersistentOverlay(e){this._peristentHighlighter&&(this._peristentHighlighter.hideFlexInOverlay(e),this.dispatchEventToListeners(Events.PersistentFlexContainerOverlayStateChanged,{nodeId:e,enabled:!1}))}highlightSourceOrderInOverlay(e){const t={parentOutlineColor:Common.Color.SourceOrderHighlight.ParentOutline.toProtocolRGBA(),childOutlineColor:Common.Color.SourceOrderHighlight.ChildOutline.toProtocolRGBA()};this._sourceOrderHighlighter.highlightSourceOrderInOverlay(e,t)}colorOfGridInPersistentOverlay(e){return this._peristentHighlighter?this._peristentHighlighter.colorOfGrid(e).asString(Common.Color.Format.HEX):null}setColorOfGridInPersistentOverlay(e,t){if(!this._peristentHighlighter)return;const o=Common.Color.Color.parse(t);o&&(this._peristentHighlighter.setColorOfGrid(e,o),this._peristentHighlighter.resetOverlay())}colorOfFlexInPersistentOverlay(e){return this._peristentHighlighter?this._peristentHighlighter.colorOfFlex(e).asString(Common.Color.Format.HEX):null}setColorOfFlexInPersistentOverlay(e,t){if(!this._peristentHighlighter)return;const o=Common.Color.Color.parse(t);o&&(this._peristentHighlighter.setColorOfFlex(e,o),this._peristentHighlighter.resetOverlay())}hideSourceOrderInOverlay(){this._sourceOrderHighlighter.hideSourceOrderHighlight()}setSourceOrderActive(e){this._sourceOrderModeActive=e}sourceOrderModeActive(){return this._sourceOrderModeActive}_delayedHideHighlight(e){null===this._hideHighlightTimeout&&(this._hideHighlightTimeout=setTimeout((()=>this.highlightInOverlay({clear:!0})),e))}highlightFrame(e){this._hideHighlightTimeout&&(clearTimeout(this._hideHighlightTimeout),this._hideHighlightTimeout=null),this._highlighter.highlightFrame(e)}showHingeForDualScreen(e){if(e){const{x:t,y:o,width:i,height:r,contentColor:n,outlineColor:l}=e;this._overlayAgent.invoke_setShowHinge({hingeConfig:{rect:{x:t,y:o,width:i,height:r},contentColor:n,outlineColor:l}})}else this._overlayAgent.invoke_setShowHinge({})}_buildHighlightConfig(e="all",t=!1){const o=Common.Settings.Settings.instance().moduleSetting("showMetricsRulers").get(),i=Common.Settings.Settings.instance().moduleSetting("colorFormat").get(),r={showInfo:"all"===e,showRulers:o,showStyles:t,showAccessibilityInfo:t,showExtensionLines:o,gridHighlightConfig:{},flexContainerHighlightConfig:{},flexItemHighlightConfig:{},contrastAlgorithm:Root.Runtime.experiments.isEnabled("APCA")?Protocol.Overlay.ContrastAlgorithm.Apca:Protocol.Overlay.ContrastAlgorithm.Aa};"all"!==e&&"content"!==e||(r.contentColor=Common.Color.PageHighlight.Content.toProtocolRGBA()),"all"!==e&&"padding"!==e||(r.paddingColor=Common.Color.PageHighlight.Padding.toProtocolRGBA()),"all"!==e&&"border"!==e||(r.borderColor=Common.Color.PageHighlight.Border.toProtocolRGBA()),"all"!==e&&"margin"!==e||(r.marginColor=Common.Color.PageHighlight.Margin.toProtocolRGBA()),"all"===e&&(r.eventTargetColor=Common.Color.PageHighlight.EventTarget.toProtocolRGBA(),r.shapeColor=Common.Color.PageHighlight.Shape.toProtocolRGBA(),r.shapeMarginColor=Common.Color.PageHighlight.ShapeMargin.toProtocolRGBA(),r.gridHighlightConfig={rowGapColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA(),rowHatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),columnGapColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA(),columnHatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),rowLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),columnLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),rowLineDash:!0,columnLineDash:!0},this._flexFeaturesExperimentEnabled&&(r.flexContainerHighlightConfig={containerBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},itemSeparator:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dotted},lineSeparator:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},mainDistributedSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()},crossDistributedSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()},rowGapSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()},columnGapSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()}},r.flexItemHighlightConfig={baseSizeBox:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA()},baseSizeBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dotted},flexibilityArrow:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA()}})),e.endsWith("gap")&&(r.gridHighlightConfig={gridBorderColor:Common.Color.PageHighlight.GridBorder.toProtocolRGBA(),gridBorderDash:!0},"gap"!==e&&"row-gap"!==e||(r.gridHighlightConfig.rowGapColor=Common.Color.PageHighlight.GapBackground.toProtocolRGBA(),r.gridHighlightConfig.rowHatchColor=Common.Color.PageHighlight.GapHatch.toProtocolRGBA()),"gap"!==e&&"column-gap"!==e||(r.gridHighlightConfig.columnGapColor=Common.Color.PageHighlight.GapBackground.toProtocolRGBA(),r.gridHighlightConfig.columnHatchColor=Common.Color.PageHighlight.GapHatch.toProtocolRGBA())),e.endsWith("gap")&&this._flexFeaturesExperimentEnabled&&(r.flexContainerHighlightConfig={containerBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed}},"gap"!==e&&"row-gap"!==e||(r.flexContainerHighlightConfig.rowGapSpace={hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()}),"gap"!==e&&"column-gap"!==e||(r.flexContainerHighlightConfig.columnGapSpace={hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()})),"grid-areas"===e&&(r.gridHighlightConfig={rowLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),columnLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),rowLineDash:!0,columnLineDash:!0,showAreaNames:!0,areaBorderColor:Common.Color.PageHighlight.GridAreaBorder.toProtocolRGBA()}),"grid-template-columns"===e&&(r.contentColor=Common.Color.PageHighlight.Content.toProtocolRGBA(),r.gridHighlightConfig={columnLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),columnLineDash:!0}),"grid-template-rows"===e&&(r.contentColor=Common.Color.PageHighlight.Content.toProtocolRGBA(),r.gridHighlightConfig={rowLineColor:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),rowLineDash:!0}),"justify-content"===e&&this._flexFeaturesExperimentEnabled&&(r.flexContainerHighlightConfig={containerBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},mainDistributedSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()}}),"align-content"===e&&this._flexFeaturesExperimentEnabled&&(r.flexContainerHighlightConfig={containerBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},crossDistributedSpace:{hatchColor:Common.Color.PageHighlight.GapHatch.toProtocolRGBA(),fillColor:Common.Color.PageHighlight.GapBackground.toProtocolRGBA()}}),"align-items"===e&&this._flexFeaturesExperimentEnabled&&(r.flexContainerHighlightConfig={containerBorder:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},lineSeparator:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA(),pattern:Protocol.Overlay.LineStylePattern.Dashed},crossAlignment:{color:Common.Color.PageHighlight.LayoutLine.toProtocolRGBA()}});return new Set(["rgb","hsl","hex"]).has(i)&&(r.colorFormat=i),r}nodeHighlightRequested({nodeId:e}){const t=this._domModel.nodeForId(e);t&&this.dispatchEventToListeners(Events.HighlightNodeRequested,t)}static setInspectNodeHandler(e){OverlayModel._inspectNodeHandler=e}inspectNodeRequested({backendNodeId:e}){const t=new DeferredDOMNode(this.target(),e);OverlayModel._inspectNodeHandler?t.resolvePromise().then((e=>{e&&OverlayModel._inspectNodeHandler&&OverlayModel._inspectNodeHandler(e)})):Common.Revealer.reveal(t),this.dispatchEventToListeners(Events.ExitedInspectMode)}screenshotRequested({viewport:e}){this.dispatchEventToListeners(Events.ScreenshotRequested,e),this.dispatchEventToListeners(Events.ExitedInspectMode)}inspectModeCanceled(){this.dispatchEventToListeners(Events.ExitedInspectMode)}}OverlayModel._inspectNodeHandler=null;export const Events={InspectModeWillBeToggled:Symbol("InspectModeWillBeToggled"),ExitedInspectMode:Symbol("InspectModeExited"),HighlightNodeRequested:Symbol("HighlightNodeRequested"),ScreenshotRequested:Symbol("ScreenshotRequested"),PersistentGridOverlayStateChanged:Symbol("PersistentGridOverlayStateChanged"),PersistentFlexContainerOverlayStateChanged:Symbol("PersistentFlexContainerOverlayStateChanged")};export class Highlighter{highlightInOverlay(e,t){}setInspectMode(e,t){throw Error("Unimplemented method")}highlightFrame(e){}}class DefaultHighlighter{constructor(e){this._model=e}highlightInOverlay(e,t){const{node:o,deferredNode:i,object:r,selectorList:n}={node:void 0,deferredNode:void 0,object:void 0,selectorList:void 0,...e},l=o?o.id:void 0,h=i?i.backendNodeId():void 0,s=r?r.objectId:void 0;l||h||s?this._model.target().overlayAgent().invoke_highlightNode({highlightConfig:t,nodeId:l,backendNodeId:h,objectId:s,selector:n}):this._model.target().overlayAgent().invoke_hideHighlight()}async setInspectMode(e,t){await this._model.target().overlayAgent().invoke_setInspectMode({mode:e,highlightConfig:t})}highlightFrame(e){this._model.target().overlayAgent().invoke_highlightFrame({frameId:e,contentColor:Common.Color.PageHighlight.Content.toProtocolRGBA(),contentOutlineColor:Common.Color.PageHighlight.ContentOutline.toProtocolRGBA()})}}export class SourceOrderHighlighter{constructor(e){this._model=e}highlightSourceOrderInOverlay(e,t){this._model.setSourceOrderActive(!0),this._model.setShowViewportSizeOnResize(!1),this._model._overlayAgent.invoke_highlightSourceOrder({sourceOrderConfig:t,nodeId:e.id})}hideSourceOrderHighlight(){this._model.setSourceOrderActive(!1),this._model.setShowViewportSizeOnResize(!0),this._model.clearHighlight()}}SDKModel.register(OverlayModel,Capability.DOM,!0);export let HighlightData;