import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as TextUtils from"../text_utils/text_utils.js";import{Location}from"./DebuggerModel.js";import{ResourceTreeModel}from"./ResourceTreeModel.js";const UIStrings={scriptRemovedOrDeleted:"Script removed or deleted.",unableToFetchScriptSource:"Unable to fetch script source."},str_=i18n.i18n.registerUIStrings("sdk/Script.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class Script{constructor(t,e,r,i,n,s,o,c,a,u,d,h,l,g,m,p,S,f,b){this.debuggerModel=t,this.scriptId=e,this.sourceURL=r,this.lineOffset=i,this.columnOffset=n,this.endLine=s,this.endColumn=o,this.executionContextId=c,this.hash=a,this._isContentScript=u,this._isLiveEdit=d,this.sourceMapURL=h,this.debugSymbols=f,this.hasSourceURL=l,this.contentLength=g,this._originalContentProvider=null,this.originStackTrace=m,this._codeOffset=p,this._language=S,this._contentPromise=null,this._embedderName=b}embedderName(){return this._embedderName}target(){return this.debuggerModel.target()}static _trimSourceURLComment(t){let e=t.lastIndexOf("//# sourceURL=");if(-1===e&&(e=t.lastIndexOf("//@ sourceURL="),-1===e))return t;const r=t.lastIndexOf("\n",e);if(-1===r)return t;return t.substr(r+1).match(sourceURLRegex)?t.substr(0,r):t}isContentScript(){return this._isContentScript}codeOffset(){return this._codeOffset}isJavaScript(){return this._language===Protocol.Debugger.ScriptLanguage.JavaScript}isWasm(){return this._language===Protocol.Debugger.ScriptLanguage.WebAssembly}scriptLanguage(){return this._language}executionContext(){return this.debuggerModel.runtimeModel().executionContext(this.executionContextId)}isLiveEdit(){return this._isLiveEdit}contentURL(){return this.sourceURL}contentType(){return Common.ResourceType.resourceTypes.Script}async contentEncoded(){return!1}requestContent(){return this._contentPromise||(this._contentPromise=this.originalContentProvider().requestContent()),this._contentPromise}async getWasmBytecode(){const t=await this.debuggerModel.target().debuggerAgent().invoke_getWasmBytecode({scriptId:this.scriptId});return(await fetch(`data:application/wasm;base64,${t.bytecode}`)).arrayBuffer()}originalContentProvider(){if(!this._originalContentProvider){let t;this._originalContentProvider=new TextUtils.StaticContentProvider.StaticContentProvider(this.contentURL(),this.contentType(),(()=>(t||(t=(async()=>{if(!this.scriptId)return{content:null,error:i18nString(UIStrings.scriptRemovedOrDeleted),isEncoded:!1};try{const t=await this.debuggerModel.target().debuggerAgent().invoke_getScriptSource({scriptId:this.scriptId});if(t.getError())throw new Error(t.getError());const{scriptSource:e,bytecode:r}=t;if(r)return{content:r,isEncoded:!0};let i=e||"";return this.hasSourceURL&&(i=Script._trimSourceURLComment(i)),{content:i,isEncoded:!1}}catch(t){return{content:null,error:i18nString(UIStrings.unableToFetchScriptSource),isEncoded:!1}}})()),t)))}return this._originalContentProvider}async searchInContent(t,e,r){if(!this.scriptId)return[];return((await this.debuggerModel.target().debuggerAgent().invoke_searchInContent({scriptId:this.scriptId,query:t,caseSensitive:e,isRegex:r})).result||[]).map((t=>new TextUtils.ContentProvider.SearchMatch(t.lineNumber,t.lineContent)))}_appendSourceURLCommentIfNeeded(t){return this.hasSourceURL?t+"\n //# sourceURL="+this.sourceURL:t}async editSource(t,e){if(t=Script._trimSourceURLComment(t),t=this._appendSourceURLCommentIfNeeded(t),!this.scriptId)return void e("Script failed to parse");const{content:r}=await this.requestContent();if(r===t)return void e(null);const i=await this.debuggerModel.target().debuggerAgent().invoke_setScriptSource({scriptId:this.scriptId,scriptSource:t});i.getError()||i.exceptionDetails||(this._contentPromise=Promise.resolve({content:t,isEncoded:!1}));const n=Boolean(i.stackChanged);e(i.getError()||null,i.exceptionDetails,i.callFrames,i.asyncStackTrace,i.asyncStackTraceId,n)}rawLocation(t,e){return this.containsLocation(t,e)?new Location(this.debuggerModel,this.scriptId,t,e):null}toRelativeLocation(t){console.assert(t.scriptId===this.scriptId,"`toRelativeLocation` must be used with location of the same script");const e=t.lineNumber-this.lineOffset;return[e,(t.columnNumber||0)-(0===e?this.columnOffset:0)]}isInlineScript(){const t=!this.lineOffset&&!this.columnOffset;return!this.isWasm()&&Boolean(this.sourceURL)&&!t}isAnonymousScript(){return!this.sourceURL}isInlineScriptWithSourceURL(){return Boolean(this.hasSourceURL)&&this.isInlineScript()}async setBlackboxedRanges(t){return!(await this.debuggerModel.target().debuggerAgent().invoke_setBlackboxedRanges({scriptId:this.scriptId,positions:t})).getError()}containsLocation(t,e){const r=t===this.lineOffset&&e>=this.columnOffset||t>this.lineOffset,i=t<this.endLine||t===this.endLine&&e<=this.endColumn;return r&&i}get frameId(){return"string"!==typeof this[frameIdSymbol]&&(this[frameIdSymbol]=frameIdForScript(this)),this[frameIdSymbol]||""}createPageResourceLoadInitiator(){return{target:this.target(),frameId:this.frameId,initiatorUrl:this.embedderName()}}}const frameIdSymbol=Symbol("frameid");function frameIdForScript(t){const e=t.executionContext();if(e)return e.frameId||"";const r=t.debuggerModel.target().model(ResourceTreeModel);return r&&r.mainFrame?r.mainFrame.id:""}export const sourceURLRegex=/^[\040\t]*\/\/[@#] sourceURL=\s*(\S*?)\s*$/;