import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={pausedOnS:"Paused on {PH1}",childSAdded:"Child {PH1} added",descendantSAdded:"Descendant {PH1} added",descendantSRemoved:"Descendant {PH1} removed",pausedOnEventListener:"Paused on event listener",pausedOnXhrOrFetch:"Paused on XHR or fetch",pausedOnException:"Paused on exception",pausedOnPromiseRejection:"Paused on promise rejection",pausedOnAssertion:"Paused on assertion",pausedOnDebuggedFunction:"Paused on debugged function",pausedBeforePotentialOutofmemory:"Paused before potential out-of-memory crash",pausedOnCspViolation:"Paused on CSP violation",trustedTypeSinkViolation:"`Trusted Type` Sink Violation",trustedTypePolicyViolation:"`Trusted Type` Policy Violation",pausedOnBreakpoint:"Paused on breakpoint",debuggerPaused:"Debugger paused",subtreeModifications:"subtree modifications",attributeModifications:"attribute modifications",nodeRemoval:"node removal"},str_=i18n.i18n.registerUIStrings("sources/DebuggerPausedMessage.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class DebuggerPausedMessage{constructor(){this._element=document.createElement("div"),this._element.classList.add("paused-message"),this._element.classList.add("flex-none");const e=UI.Utils.createShadowRootWithCoreStyles(this._element,{cssFile:"sources/debuggerPausedMessage.css",enableLegacyPatching:!0,delegatesFocus:void 0});this._contentElement=e.createChild("div"),UI.ARIAUtils.markAsPoliteLiveRegion(this._element,!1)}element(){return this._element}static _descriptionWithoutStack(e){const t=/^\s+at\s/m.exec(e);return t?e.substring(0,t.index-1):e.substring(0,e.lastIndexOf("\n"))}static async _createDOMBreakpointHitMessage(e){const t=document.createElement("span"),n=e.debuggerModel.target().model(SDK.DOMDebuggerModel.DOMDebuggerModel);if(!e.auxData||!n)return t;const o=n.resolveDOMBreakpointData(e.auxData);if(!o)return t;const i=t.createChild("div","status-main");i.appendChild(UI.Icon.Icon.create("smallicon-info","status-icon"));const s=BreakpointTypeNouns.get(o.type);i.appendChild(document.createTextNode(i18nString(UIStrings.pausedOnS,{PH1:s?s():null})));const a=t.createChild("div","status-sub monospace"),r=await Common.Linkifier.Linkifier.linkify(o.node);if(a.appendChild(r),o.targetNode){const e=await Common.Linkifier.Linkifier.linkify(o.targetNode);let t;t=o.insertion?o.targetNode===o.node?i18n.i18n.getFormatLocalizedString(str_,UIStrings.childSAdded,{PH1:e}):i18n.i18n.getFormatLocalizedString(str_,UIStrings.descendantSAdded,{PH1:e}):i18n.i18n.getFormatLocalizedString(str_,UIStrings.descendantSRemoved,{PH1:e}),a.appendChild(document.createElement("br")),a.appendChild(t)}return t}async render(e,t,n){if(this._contentElement.removeChildren(),this._contentElement.hidden=!e,!e)return;const o=this._contentElement.createChild("div","paused-status"),i=e.reason===Protocol.Debugger.PausedEventReason.Exception||e.reason===Protocol.Debugger.PausedEventReason.PromiseRejection||e.reason===Protocol.Debugger.PausedEventReason.Assert||e.reason===Protocol.Debugger.PausedEventReason.OOM;let s;if(e.reason===Protocol.Debugger.PausedEventReason.DOM)s=await DebuggerPausedMessage._createDOMBreakpointHitMessage(e);else if(e.reason===Protocol.Debugger.PausedEventReason.EventListener){let t="";e.auxData&&(t=SDK.DOMDebuggerModel.DOMDebuggerManager.instance().resolveEventListenerBreakpointTitle(e.auxData)),s=a(i18nString(UIStrings.pausedOnEventListener),t)}else if(e.reason===Protocol.Debugger.PausedEventReason.XHR){const t=e.auxData;s=a(i18nString(UIStrings.pausedOnXhrOrFetch),t.url||"")}else if(e.reason===Protocol.Debugger.PausedEventReason.Exception){const t=e.auxData,n=t.description||t.value||"",o=DebuggerPausedMessage._descriptionWithoutStack(n);s=a(i18nString(UIStrings.pausedOnException),o,n)}else if(e.reason===Protocol.Debugger.PausedEventReason.PromiseRejection){const t=e.auxData,n=t.description||t.value||"",o=DebuggerPausedMessage._descriptionWithoutStack(n);s=a(i18nString(UIStrings.pausedOnPromiseRejection),o,n)}else if(e.reason===Protocol.Debugger.PausedEventReason.Assert)s=a(i18nString(UIStrings.pausedOnAssertion));else if(e.reason===Protocol.Debugger.PausedEventReason.DebugCommand)s=a(i18nString(UIStrings.pausedOnDebuggedFunction));else if(e.reason===Protocol.Debugger.PausedEventReason.OOM)s=a(i18nString(UIStrings.pausedBeforePotentialOutofmemory));else if(e.reason===Protocol.Debugger.PausedEventReason.CSPViolation&&e.auxData&&e.auxData.violationType){const t=e.auxData.violationType;t===Protocol.DOMDebugger.CSPViolationType.TrustedtypeSinkViolation?s=a(i18nString(UIStrings.pausedOnCspViolation),i18nString(UIStrings.trustedTypeSinkViolation)):t===Protocol.DOMDebugger.CSPViolationType.TrustedtypePolicyViolation&&(s=a(i18nString(UIStrings.pausedOnCspViolation),i18nString(UIStrings.trustedTypePolicyViolation)))}else if(e.callFrames.length){const o=await t.rawLocationToUILocation(e.callFrames[0].location()),i=o?n.findBreakpoint(o):null;s=a(i18nString(i?UIStrings.pausedOnBreakpoint:UIStrings.debuggerPaused))}else console.warn("ScriptsPanel paused, but callFrames.length is zero.");function a(e,t,n){const o=document.createElement("span"),s=o.createChild("div","status-main"),a=UI.Icon.Icon.create(i?"smallicon-error":"smallicon-info","status-icon");if(s.appendChild(a),s.appendChild(document.createTextNode(e)),t){const e=o.createChild("div","status-sub monospace");e.textContent=t,UI.Tooltip.Tooltip.install(e,n||t)}return o}o.classList.toggle("error-reason",i),s&&o.appendChild(s)}}export const BreakpointTypeNouns=new Map([[Protocol.DOMDebugger.DOMBreakpointType.SubtreeModified,i18nLazyString(UIStrings.subtreeModifications)],[Protocol.DOMDebugger.DOMBreakpointType.AttributeModified,i18nLazyString(UIStrings.attributeModifications)],[Protocol.DOMDebugger.DOMBreakpointType.NodeRemoved,i18nLazyString(UIStrings.nodeRemoval)]]);let PausedDetailsAuxData;