import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as ObjectUI from"../object_ui/object_ui.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as SourceFrame from"../source_frame/source_frame.js";import*as TextEditor from"../text_editor/text_editor.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";import{AddSourceMapURLDialog}from"./AddSourceMapURLDialog.js";import{BreakpointEditDialog,LogpointPrefix}from"./BreakpointEditDialog.js";import{Plugin}from"./Plugin.js";import{ScriptFormatterEditorAction}from"./ScriptFormatterEditorAction.js";import{resolveExpression,resolveScopeInObject}from"./SourceMapNamesResolver.js";import{SourcesPanel}from"./SourcesPanel.js";import{getRegisteredEditorActions}from"./SourcesView.js";const UIStrings={thisScriptIsOnTheDebuggersIgnore:"This script is on the debugger's ignore list",removeFromIgnoreList:"Remove from ignore list",configure:"Configure",sourceMapFoundButIgnoredForFile:"Source map found, but ignored for file on ignore list.",addBreakpoint:"Add breakpoint",addConditionalBreakpoint:"Add conditional breakpoint\u2026",addLogpoint:"Add logpoint\u2026",neverPauseHere:"Never pause here",removeBreakpoint:"Remove breakpoint",removeAllBreakpointsInLine:"Remove all breakpoints in line",editBreakpoint:"Edit breakpoint\u2026",disableBreakpoint:"Disable breakpoint",disableAllBreakpointsInLine:"Disable all breakpoints in line",enableBreakpoint:"Enable breakpoint",enableAllBreakpointsInLine:"Enable all breakpoints in line",addSourceMap:"Add source map\u2026",sourceMapDetected:"Source Map detected.",prettyprintThisMinifiedFile:"Pretty-print this minified file?",prettyprint:"Pretty-print",prettyprintingWillFormatThisFile:"Pretty-printing will format this file in a new tab where you can continue debugging. You can also pretty-print this file by clicking the {PH1} button on the bottom status bar.",associatedFilesAreAvailable:"Associated files are available via file tree or {PH1}.",associatedFilesShouldBeAdded:"Associated files should be added to the file tree. You can debug these resolved source files as regular JavaScript files.",theDebuggerWillSkipStepping:"The debugger will skip stepping through this script, and will not stop on exceptions."},str_=i18n.i18n.registerUIStrings("sources/DebuggerPlugin.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);class DecoratorWidget extends HTMLDivElement{constructor(){super(),this.__nameToToken}}export class DebuggerPlugin extends Plugin{constructor(e,t,i){super(),this._textEditor=e,this._uiSourceCode=t,this._transformer=i,this._executionLocation=null,this._controlDown=!1,this._asyncStepInHoveredLine=0,this._asyncStepInHovered=!1,this._clearValueWidgetsTimer=null,this._sourceMapInfobar=null,this._controlTimeout=null,this._scriptsPanel=SourcesPanel.instance(),this._breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance(),t.project().type()===Workspace.Workspace.projectTypes.Debugger&&this._textEditor.element.classList.add("source-frame-debugger-script"),this._popoverHelper=new UI.PopoverHelper.PopoverHelper(this._scriptsPanel.element,this._getPopoverRequest.bind(this)),this._popoverHelper.setDisableOnClick(!0),this._popoverHelper.setTimeout(250,250),this._popoverHelper.setHasPadding(!0),this._boundPopoverHelperHide=this._popoverHelper.hidePopover.bind(this._popoverHelper),this._scriptsPanel.element.addEventListener("scroll",this._boundPopoverHelperHide,!0);const o={"debugger.toggle-breakpoint":async()=>{const e=this._textEditor.selection();return!!e&&(await this._toggleBreakpoint(e.startLine,!1),!0)},"debugger.toggle-breakpoint-enabled":async()=>{const e=this._textEditor.selection();return!!e&&(await this._toggleBreakpoint(e.startLine,!0),!0)},"debugger.breakpoint-input-window":async()=>{const e=this._textEditor.selection();if(!e)return!1;const t=this._lineBreakpointDecorations(e.startLine).map((e=>e.breakpoint)).filter((e=>Boolean(e)));let i=null;t.length&&(i=t[0]);const o=!!i&&i.condition().includes(LogpointPrefix);return this._editBreakpointCondition(e.startLine,i,null,o),!0}};UI.ShortcutRegistry.ShortcutRegistry.instance().addShortcutListener(this._textEditor.element,o),this._boundKeyDown=this._onKeyDown.bind(this),this._textEditor.element.addEventListener("keydown",this._boundKeyDown,!0),this._boundKeyUp=this._onKeyUp.bind(this),this._textEditor.element.addEventListener("keyup",this._boundKeyUp,!0),this._boundMouseMove=this._onMouseMove.bind(this),this._textEditor.element.addEventListener("mousemove",this._boundMouseMove,!1),this._boundMouseDown=this._onMouseDown.bind(this),this._textEditor.element.addEventListener("mousedown",this._boundMouseDown,!0),this._boundBlur=this._onBlur.bind(this),this._textEditor.element.addEventListener("focusout",this._boundBlur,!1),this._boundWheel=this._onWheel.bind(this),this._textEditor.element.addEventListener("wheel",this._boundWheel,!0),this._boundGutterClick=e=>{this._handleGutterClick(e)},this._textEditor.addEventListener(SourceFrame.SourcesTextEditor.Events.GutterClick,this._boundGutterClick,this),this._breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this._breakpointAdded,this),this._breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this._breakpointRemoved,this),this._uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._workingCopyChanged,this),this._uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._workingCopyCommitted,this),this._breakpointDecorations=new Set,this._decorationByBreakpoint=new Map,this._possibleBreakpointsRequested=new Set,this._scriptFileForDebuggerModel=new Map,Common.Settings.Settings.instance().moduleSetting("skipStackFramesPattern").addChangeListener(this._showIgnoreListInfobarIfNeeded,this),Common.Settings.Settings.instance().moduleSetting("skipContentScripts").addChangeListener(this._showIgnoreListInfobarIfNeeded,this),this._valueWidgets=new Map,this._continueToLocationDecorations=null,UI.Context.Context.instance().addFlavorChangeListener(SDK.DebuggerModel.CallFrame,this._callFrameChanged,this),this._liveLocationPool=new Bindings.LiveLocation.LiveLocationPool,this._callFrameChanged(),this._updateScriptFiles(),this._uiSourceCode.isDirty()?(this._muted=!0,this._mutedFromStart=!0):(this._muted=!1,this._mutedFromStart=!1,this._initializeBreakpoints()),this._ignoreListInfobar=null,this._showIgnoreListInfobarIfNeeded();for(const n of this._scriptFileForDebuggerModel.values())n.checkMapping();this._hasLineWithoutMapping=!1,this._updateLinesWithoutMappingHighlight(),Root.Runtime.experiments.isEnabled("sourcesPrettyPrint")||(this._prettyPrintInfobar=null,this._detectMinified())}static accepts(e){return e.contentType().hasScripts()}_showIgnoreListInfobarIfNeeded(){const e=this._uiSourceCode;if(!e.contentType().hasScripts())return;const t=e.project().type();if(!Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedUISourceCode(e))return void this._hideIgnoreListInfobar();this._ignoreListInfobar&&this._ignoreListInfobar.dispose();const i=new UI.Infobar.Infobar(UI.Infobar.Type.Warning,i18nString(UIStrings.thisScriptIsOnTheDebuggersIgnore),[{text:i18nString(UIStrings.removeFromIgnoreList),highlight:!1,delegate:function(){Bindings.IgnoreListManager.IgnoreListManager.instance().unIgnoreListUISourceCode(e),t===Workspace.Workspace.projectTypes.ContentScripts&&Bindings.IgnoreListManager.IgnoreListManager.instance().unIgnoreListContentScripts()},dismiss:!0},{text:i18nString(UIStrings.configure),highlight:!1,delegate:UI.ViewManager.ViewManager.instance().showView.bind(UI.ViewManager.ViewManager.instance(),"blackbox"),dismiss:!1}]);this._ignoreListInfobar=i,i.createDetailsRowMessage(i18nString(UIStrings.theDebuggerWillSkipStepping));const o=this._scriptFileForDebuggerModel.size?this._scriptFileForDebuggerModel.values().next().value:null;o&&o.hasSourceMapURL()&&i.createDetailsRowMessage(i18nString(UIStrings.sourceMapFoundButIgnoredForFile)),this._textEditor.attachInfobar(this._ignoreListInfobar)}_hideIgnoreListInfobar(){this._ignoreListInfobar&&(this._ignoreListInfobar.dispose(),this._ignoreListInfobar=null)}wasShown(){this._executionLocation&&queueMicrotask((()=>{this._generateValuesInSource()}))}willHide(){this._popoverHelper.hidePopover()}async populateLineGutterContextMenu(e,t){const i=new Workspace.UISourceCode.UILocation(this._uiSourceCode,t,0);this._scriptsPanel.appendUILocationItems(e,i);const o=this._lineBreakpointDecorations(t).map((e=>e.breakpoint)).filter((e=>Boolean(e))),n=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().supportsConditionalBreakpoints(this._uiSourceCode);if(o.length){const i=1===o.length,r=i18nString(i?UIStrings.removeBreakpoint:UIStrings.removeAllBreakpointsInLine);e.debugSection().appendItem(r,(()=>o.map((e=>e.remove(!1))))),i&&n&&e.debugSection().appendItem(i18nString(UIStrings.editBreakpoint),this._editBreakpointCondition.bind(this,t,o[0],null,!1));if(o.some((e=>e.enabled()))){const t=i18nString(i?UIStrings.disableBreakpoint:UIStrings.disableAllBreakpointsInLine);e.debugSection().appendItem(t,(()=>o.map((e=>e.setEnabled(!1)))))}if(o.some((e=>!e.enabled()))){const t=i18nString(i?UIStrings.enableBreakpoint:UIStrings.enableAllBreakpointsInLine);e.debugSection().appendItem(t,(()=>o.map((e=>e.setEnabled(!0)))))}}else this._textEditor.hasLineClass(t,"cm-non-breakable-line")||(e.debugSection().appendItem(i18nString(UIStrings.addBreakpoint),this._createNewBreakpoint.bind(this,t,"",!0)),n&&(e.debugSection().appendItem(i18nString(UIStrings.addConditionalBreakpoint),this._editBreakpointCondition.bind(this,t,null,null,!1)),e.debugSection().appendItem(i18nString(UIStrings.addLogpoint),this._editBreakpointCondition.bind(this,t,null,null,!0)),e.debugSection().appendItem(i18nString(UIStrings.neverPauseHere),this._createNewBreakpoint.bind(this,t,"false",!0))))}populateTextAreaContextMenu(e,t,i){function o(e){new AddSourceMapURLDialog(n.bind(null,e)).show()}function n(e,t){t&&e.addSourceMapURL(t)}return super.populateTextAreaContextMenu(e,t,i).then(function(){if(this._uiSourceCode.project().type()===Workspace.Workspace.projectTypes.Network&&Common.Settings.Settings.instance().moduleSetting("jsSourceMapsEnabled").get()&&!Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedUISourceCode(this._uiSourceCode)&&this._scriptFileForDebuggerModel.size){const t=this._scriptFileForDebuggerModel.values().next().value,i=i18nString(UIStrings.addSourceMap);e.debugSection().appendItem(i,o.bind(null,t))}}.bind(this))}_workingCopyChanged(){this._scriptFileForDebuggerModel.size||(this._uiSourceCode.isDirty()?this._muteBreakpointsWhileEditing():this._restoreBreakpointsAfterEditing())}_workingCopyCommitted(e){this._scriptsPanel.updateLastModificationTime(),this._scriptFileForDebuggerModel.size||this._restoreBreakpointsAfterEditing()}_didMergeToVM(){this._restoreBreakpointsIfConsistentScripts()}_didDivergeFromVM(){this._muteBreakpointsWhileEditing()}_muteBreakpointsWhileEditing(){if(!this._muted){for(const e of this._breakpointDecorations)this._updateBreakpointDecoration(e);this._muted=!0}}async _restoreBreakpointsIfConsistentScripts(){for(const e of this._scriptFileForDebuggerModel.values())if(e.hasDivergedFromVM()||e.isMergingToVM())return;await this._restoreBreakpointsAfterEditing()}async _restoreBreakpointsAfterEditing(){if(this._muted=!1,this._mutedFromStart)return this._mutedFromStart=!1,void this._initializeBreakpoints();const e=Array.from(this._breakpointDecorations);this._breakpointDecorations.clear(),this._textEditor.operation((()=>e.map((e=>e.hide()))));for(const t of e){if(!t.breakpoint)continue;const e=t.enabled;t.breakpoint.remove(!1);const i=t.handle.resolve();i&&await this._setBreakpoint(i.lineNumber,i.columnNumber,t.condition,e)}}_isIdentifier(e){return e.startsWith("js-variable")||e.startsWith("js-property")||"js-def"===e||"variable"===e}_getPopoverRequest(e){if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e))return null;const t=UI.Context.Context.instance().flavor(SDK.SDKModel.Target),i=t?t.model(SDK.DebuggerModel.DebuggerModel):null;if(!i||!i.isPaused())return null;const o=this._textEditor.coordinatesToCursorPosition(e.x,e.y);if(!o)return null;const n=o.startLine,r=o.startColumn,s=this._textEditor.selection().normalize();let a,l=-1,c=-1,d=-1;const u=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!u)return null;if(s&&!s.isEmpty()){if(s.startLine!==s.endLine||s.startLine!==n||r<s.startColumn||r>s.endColumn)return null;const e=this._textEditor.cursorPositionToCoordinates(s.startLine,s.startColumn),t=this._textEditor.cursorPositionToCoordinates(s.endLine,s.endColumn);if(!e)throw new Error("Expected leftCorner to not be null.");if(!t)throw new Error("Expected rightCorner to not be null.");a=new AnchorBox(e.x,e.y,t.x-e.x,e.height),l=s.startLine,c=s.startColumn,d=s.endColumn-1}else if("application/wasm"===this._uiSourceCode.mimeType()){const e=this._textEditor.tokenAtTextPosition(o.startLine,o.startColumn);if(!e||"variable-2"!==e.type)return null;const t=this._textEditor.cursorPositionToCoordinates(o.startLine,e.startColumn),i=this._textEditor.cursorPositionToCoordinates(o.startLine,e.endColumn-1);if(!t)throw new Error("Expected leftCorner to not be null.");if(!i)throw new Error("Expected rightCorner to not be null.");a=new AnchorBox(t.x,t.y,i.x-t.x,t.height),l=o.startLine,c=e.startColumn,d=e.endColumn-1}else{const e=this._textEditor.tokenAtTextPosition(o.startLine,o.startColumn);if(!e||!e.type)return null;l=o.startLine;const t=this._textEditor.line(l),i=t.substring(e.startColumn,e.endColumn);if(!this._isIdentifier(e.type)&&("js-keyword"!==e.type||"this"!==i))return null;const n=this._textEditor.cursorPositionToCoordinates(l,e.startColumn),r=this._textEditor.cursorPositionToCoordinates(l,e.endColumn-1);if(!n)throw new Error("Expected leftCorner to not be null.");if(!r)throw new Error("Expected rightCorner to not be null.");for(a=new AnchorBox(n.x,n.y,r.x-n.x,n.height),c=e.startColumn,d=e.endColumn-1;c>1&&"."===t.charAt(c-1);){const e=this._textEditor.tokenAtTextPosition(l,c-2);if(!e||!e.type)return null;if("js-meta"===e.type)break;if("js-string-2"===e.type){if(e.endColumn<2)return null;if(c=t.lastIndexOf("`",e.endColumn-2),c<0)return null;break}c=e.startColumn}}let h,p;return{box:a,show:async e=>{const t=this._textEditor.line(l).substring(c,d+1),o=await async function(e,t){const i=await resolveExpression(u,t,e,l,c,d);return await u.evaluate({expression:i||t,objectGroup:"popover",includeCommandLineAPI:!1,silent:!0,returnByValue:!1,generatePreview:!1,throwOnSideEffect:void 0,timeout:void 0,disableBreaks:void 0,replMode:void 0,allowUnsafeEvalBlockedByCSP:void 0})}(this._uiSourceCode,t);if(!o||"error"in o||!o.object||"object"===o.object.type&&"error"===o.object.subtype)return!1;h=await ObjectUI.ObjectPopoverHelper.ObjectPopoverHelper.buildObjectPopover(o.object,e);const n=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!h||u!==n)return i.runtimeModel().releaseObjectGroup("popover"),h&&h.dispose(),!1;const r=new TextUtils.TextRange.TextRange(l,c,l,d);return p=this._textEditor.highlightRange(r,"source-frame-eval-expression"),!0},hide:()=>{h&&h.dispose(),i.runtimeModel().releaseObjectGroup("popover"),p&&this._textEditor.removeHighlight(p)}}}_onWheel(e){this._executionLocation&&UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e)&&e.preventDefault()}_onKeyDown(e){(!e.ctrlKey||!e.metaKey&&Host.Platform.isMac())&&this._clearControlDown(),"Escape"!==e.key?UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e)&&this._executionLocation&&(this._controlDown=!0,e.key===(Host.Platform.isMac()?"Meta":"Control")&&(this._controlTimeout=window.setTimeout((()=>{this._executionLocation&&this._controlDown&&this._showContinueToLocations()}),150))):this._popoverHelper.isPopoverVisible()&&(this._popoverHelper.hidePopover(),e.consume())}_onMouseMove(e){if(this._executionLocation&&this._controlDown&&UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e)&&(this._continueToLocationDecorations||this._showContinueToLocations()),this._continueToLocationDecorations){const t=e.target,i=this._textEditor.coordinatesToCursorPosition(e.x,e.y),o=Boolean(t.enclosingNodeOrSelfWithClass("source-frame-async-step-in"));this._setAsyncStepInHoveredLine(i?i.startLine:null,o)}}_setAsyncStepInHoveredLine(e,t){this._asyncStepInHoveredLine===e&&this._asyncStepInHovered===t||(this._asyncStepInHovered&&this._asyncStepInHoveredLine&&this._textEditor.toggleLineClass(this._asyncStepInHoveredLine,"source-frame-async-step-in-hovered",!1),this._asyncStepInHoveredLine=e,this._asyncStepInHovered=t,this._asyncStepInHovered&&this._asyncStepInHoveredLine&&this._textEditor.toggleLineClass(this._asyncStepInHoveredLine,"source-frame-async-step-in-hovered",!0))}_onMouseDown(e){if(!this._executionLocation||!UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e))return;if(!this._continueToLocationDecorations)return;e.consume();const t=this._textEditor.coordinatesToCursorPosition(e.x,e.y);if(t)for(const i of this._continueToLocationDecorations.keys()){const e=i.find();if(e&&(e.from.line===t.startLine&&e.to.line===t.startLine&&e.from.ch<=t.startColumn&&t.startColumn<=e.to.ch)){const e=this._continueToLocationDecorations.get(i);if(!e)throw new Error("Expected a function");e();break}}}_onBlur(e){this._clearControlDown()}_onKeyUp(e){this._clearControlDown()}_clearControlDown(){this._controlDown=!1,this._clearContinueToLocations(),this._controlTimeout&&clearTimeout(this._controlTimeout)}async _editBreakpointCondition(e,t,i,o){const n=t?t.condition():"",r=document.createElement("div"),s=new BreakpointEditDialog(e,n,Boolean(o),(async o=>{s.detach(),this._textEditor.removeDecoration(r,e),o.committed&&(t?t.setCondition(o.condition):i?await this._setBreakpoint(i.lineNumber,i.columnNumber,o.condition,!0):await this._createNewBreakpoint(e,o.condition,!0))}));this._textEditor.addDecoration(r,e),s.markAsExternallyManaged(),s.show(r)}async _executionLineChanged(e){this._clearExecutionLine();const t=await e.uiLocation();if(!t||t.uiSourceCode.url()!==this._uiSourceCode.url())return void(this._executionLocation=null);this._executionLocation=t;const i=this._transformer.uiLocationToEditorLocation(t.lineNumber,t.columnNumber);this._textEditor.setExecutionLocation(i.lineNumber,i.columnNumber),this._textEditor.isShowing()&&queueMicrotask((()=>{this._controlDown?this._showContinueToLocations():this._generateValuesInSource()}))}_generateValuesInSource(){if(!Common.Settings.Settings.instance().moduleSetting("inlineVariableValues").get())return;if(!UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext))return;const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!e)return;const t=e.localScope(),i=e.functionLocation();t&&i&&resolveScopeInObject(t).getAllProperties(!1,!1).then(this._prepareScopeVariables.bind(this,e))}_showContinueToLocations(){this._popoverHelper.hidePopover();if(!UI.Context.Context.instance().flavor(SDK.RuntimeModel.ExecutionContext))return;const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);if(!e)return;const t=e.functionLocation()||e.location();function i(e){this._clearContinueToLocationsNoRestore(),this._textEditor.hideExecutionLineBackground(),this._continueToLocationDecorations=new Map,e=e.reverse();let t=-1;for(const i of e){const e=this._transformer.uiLocationToEditorLocation(i.lineNumber,i.columnNumber),o=this._textEditor.tokenAtTextPosition(e.lineNumber,e.columnNumber);if(!o)continue;let n=o;const r=this._textEditor.line(e.lineNumber);let s=r.substring(n.startColumn,n.endColumn);if(!n.type&&"."===s){const t=this._textEditor.tokenAtTextPosition(e.lineNumber,n.endColumn+1);if(!t)throw new Error("nextToken should not be null.");n=t,s=r.substring(n.startColumn,n.endColumn)}if(!n.type)continue;if(!("js-keyword"===n.type&&("this"===s||"return"===s||"new"===s||"continue"===s||"break"===s))&&!this._isIdentifier(n.type))continue;if(t===e.lineNumber&&i.type!==Protocol.Debugger.BreakLocationType.Call)continue;let a=new TextUtils.TextRange.TextRange(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn-1),l=this._textEditor.highlightRange(a,"source-frame-continue-to-location");this._continueToLocationDecorations.set(l,i.continueToLocation.bind(i)),i.type===Protocol.Debugger.BreakLocationType.Call&&(t=e.lineNumber);let c="."===r[n.startColumn-1]&&"then"===s||"setTimeout"===s||"setInterval"===s||"postMessage"===s;if("new"===s){const t=this._textEditor.tokenAtTextPosition(e.lineNumber,n.endColumn+1);if(!t)throw new Error("nextToken should not be null.");n=t,s=r.substring(n.startColumn,n.endColumn),c="Worker"===s}const d=this._executionLocation&&i.lineNumber===this._executionLocation.lineNumber&&i.columnNumber===this._executionLocation.columnNumber;if(i.type===Protocol.Debugger.BreakLocationType.Call&&c){const t=this._findAsyncStepInRange(this._textEditor,e.lineNumber,r,n.endColumn);t&&(a=new TextUtils.TextRange.TextRange(e.lineNumber,t.from,e.lineNumber,t.to-1),l=this._textEditor.highlightRange(a,"source-frame-async-step-in"),this._continueToLocationDecorations.set(l,this._asyncStepIn.bind(this,i,Boolean(d))))}}this._continueToLocationRenderedForTest()}e.debuggerModel.getPossibleBreakpoints(t,null,!0).then((e=>this._textEditor.operation(i.bind(this,e))))}_continueToLocationRenderedForTest(){}_findAsyncStepInRange(e,t,i,o){let n,r=null,s=o,a=i.length,l=i.indexOf("(",o);const c=l;if(-1===l)return null;if(l++,h(),l>=i.length)return null;if(r=u(),!r)return null;if(s=r.startColumn,"js-keyword"===r.type&&"async"===n){if(h(),l>=i.length)return{from:s,to:a};if(r=u(),!r)return{from:s,to:a}}if("js-keyword"===r.type&&"function"===n)return{from:s,to:a};if("js-string"===r.type)return{from:c,to:a};if(r.type&&this._isIdentifier(r.type))return{from:s,to:a};if("("!==n)return null;const d=i.indexOf(")",l);return-1===d||-1!==i.substring(l,d).indexOf("(")?{from:s,to:a}:{from:s,to:d+1};function u(){return r=e.tokenAtTextPosition(t,l),r&&(l=r.endColumn,a=r.endColumn,n=i.substring(r.startColumn,r.endColumn)),r}function h(){for(;l<i.length;){if(" "===i[l]){l++;continue}const o=e.tokenAtTextPosition(t,l);if(!o)throw new Error("expected token to not be null");if("js-comment"!==o.type)break;l=o.endColumn}}}_asyncStepIn(e,t){function i(){e.debuggerModel.scheduleStepIntoAsync()}t?i():e.continueToLocation(i)}async _prepareScopeVariables(e,t){const i=t.properties;if(this._clearValueWidgets(),!i||!i.length||i.length>500||!this._textEditor.isShowing())return;const o=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.functionLocation()),n=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.location()),[r,s]=await Promise.all([o,n]);if(!r||!s||r.uiSourceCode.url()!==this._uiSourceCode.url()||s.uiSourceCode.url()!==this._uiSourceCode.url())return;const a=this._transformer.uiLocationToEditorLocation(r.lineNumber,r.columnNumber),l=this._transformer.uiLocationToEditorLocation(s.lineNumber,s.columnNumber),c=a.lineNumber,d=a.columnNumber,u=l.lineNumber;if(c>=u||u-c>500||c<0||u>=this._textEditor.linesCount)return;const h=new Map;for(const b of i)h.set(b.name,b.value);const p=new Map;let g=!1;const m=TextEditor.CodeMirrorUtils.TokenizerFactory.instance().createTokenizer("text/javascript");m(this._textEditor.line(c).substring(d),_.bind(this,c));for(let b=c+1;b<u;++b)m(this._textEditor.line(b),_.bind(this,b));function _(e,t,i,o,n){if(!g&&i&&this._isIdentifier(i)&&h.get(t)){let i=p.get(e);i||(i=new Set,p.set(e,i)),i.add(t)}g="."===t}this._textEditor.operation(this._renderDecorations.bind(this,h,p,c,u))}_renderDecorations(e,t,i,o){const n=new ObjectUI.RemoteObjectPreviewFormatter.RemoteObjectPreviewFormatter;for(let r=i;r<o;++r){const i=t.get(r),o=this._valueWidgets.get(r);if(!i){o&&(this._valueWidgets.delete(r),this._textEditor.removeDecoration(o,r));continue}const s=document.createElement("div");s.classList.add("text-editor-value-decoration");const a=this._textEditor.cursorPositionToCoordinates(r,0);if(!a)throw new Error("base is expected to not be null");const l=this._textEditor.cursorPositionToCoordinates(r,this._textEditor.line(r).length);if(!l)throw new Error("offset is expected to not be null");const c=4,d=l.x-a.x+c;s.style.left=d+"px",s.__nameToToken=new Map;let u=0;for(const p of i){if(u>10)break;const i=t.get(r-1);if(i&&i.has(p))continue;u&&UI.UIUtils.createTextChild(s,", ");const o=s.createChild("span");s.__nameToToken.set(p,o),UI.UIUtils.createTextChild(o,p+" = ");const a=e.get(p);if(!a)throw new Error("value is expected to be null");const l=a.preview?a.preview.properties.length:0,c=a.preview&&a.preview.entries?a.preview.entries.length:0;if(a.preview&&l+c<10)n.appendObjectPreview(o,a.preview,!1);else{const e=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.createPropertyValue(a,!1,!1);o.appendChild(e.element)}++u}let h=!0;if(o){h=!1;for(const e of s.__nameToToken.keys()){const t=o.__nameToToken.get(e),i=s.__nameToToken.get(e),n=t?t.textContent:"";(i?i.textContent:"")!==n&&(h=!0,UI.UIUtils.runCSSAnimationOnce(s.__nameToToken.get(e),"source-frame-value-update-highlight"))}h&&(this._valueWidgets.delete(r),this._textEditor.removeDecoration(o,r))}h&&(this._valueWidgets.set(r,s),this._textEditor.addDecoration(s,r))}}_clearExecutionLine(){this._textEditor.operation((()=>{this._executionLocation&&this._textEditor.clearExecutionLine(),this._executionLocation=null,this._clearValueWidgetsTimer&&(clearTimeout(this._clearValueWidgetsTimer),this._clearValueWidgetsTimer=null),this._clearValueWidgetsTimer=window.setTimeout(this._clearValueWidgets.bind(this),1e3),this._clearContinueToLocationsNoRestore()}))}_clearValueWidgets(){this._clearValueWidgetsTimer&&clearTimeout(this._clearValueWidgetsTimer),this._clearValueWidgetsTimer=null,this._textEditor.operation((()=>{for(const e of this._valueWidgets.keys()){const t=this._valueWidgets.get(e);t&&this._textEditor.removeDecoration(t,e)}this._valueWidgets.clear()}))}_clearContinueToLocationsNoRestore(){const e=this._continueToLocationDecorations;e&&this._textEditor.operation((()=>{for(const t of e.keys())this._textEditor.removeHighlight(t);this._continueToLocationDecorations=null,this._setAsyncStepInHoveredLine(null,!1)}))}_clearContinueToLocations(){this._continueToLocationDecorations&&this._textEditor.operation((()=>{this._textEditor.showExecutionLineBackground(),this._generateValuesInSource(),this._clearContinueToLocationsNoRestore()}))}_lineBreakpointDecorations(e){return Array.from(this._breakpointDecorations).filter((t=>(t.handle.resolve()||{}).lineNumber===e))}_breakpointDecoration(e,t){for(const i of this._breakpointDecorations){const o=i.handle.resolve();if(o&&(o.lineNumber===e&&o.columnNumber===t))return i}return null}_updateBreakpointDecoration(e){function t(){if(!this._scheduledBreakpointDecorationUpdates)return;const e=new Set;for(const i of this._scheduledBreakpointDecorationUpdates){const t=i.handle.resolve();t&&e.add(t.lineNumber)}this._scheduledBreakpointDecorationUpdates=null;let t=!1;for(const n of e){const e=this._lineBreakpointDecorations(n);i.call(this,n,e),this._possibleBreakpointsRequested.has(n)?t=!0:o.call(this,n,e)}t||this._breakpointDecorationsUpdatedForTest()}function i(e,t){if(this._textEditor.toggleLineClass(e,"cm-breakpoint",!1),this._textEditor.toggleLineClass(e,"cm-breakpoint-disabled",!1),this._textEditor.toggleLineClass(e,"cm-breakpoint-unbound",!1),this._textEditor.toggleLineClass(e,"cm-breakpoint-conditional",!1),this._textEditor.toggleLineClass(e,"cm-breakpoint-logpoint",!1),t.length){t.sort(BreakpointDecoration.mostSpecificFirst);const i=!t[0].enabled||this._muted,o=t[0].condition.includes(LogpointPrefix),n=!t[0].bound,r=Boolean(t[0].condition)&&!o;this._textEditor.toggleLineClass(e,"cm-breakpoint",!0),this._textEditor.toggleLineClass(e,"cm-breakpoint-disabled",i),this._textEditor.toggleLineClass(e,"cm-breakpoint-unbound",n&&!i),this._textEditor.toggleLineClass(e,"cm-breakpoint-logpoint",o),this._textEditor.toggleLineClass(e,"cm-breakpoint-conditional",r)}}function o(e,t){const i=new Set(t.map((e=>e.bookmark)).filter((e=>Boolean(e)))),o=this._textEditor.line(e).length,n=this._textEditor.bookmarks(new TextUtils.TextRange.TextRange(e,0,e,o),BreakpointDecoration.bookmarkSymbol);for(const r of n)i.has(r)||r.clear();if(t.length)if(t.length>1)for(const r of t)r.update(),this._muted?r.hide():r.show();else t[0].update(),t[0].hide()}this._scheduledBreakpointDecorationUpdates||(this._scheduledBreakpointDecorationUpdates=new Set,queueMicrotask((()=>{this._textEditor.operation(t.bind(this))}))),this._scheduledBreakpointDecorationUpdates.add(e)}_breakpointDecorationsUpdatedForTest(){}async _inlineBreakpointClick(e,t){if(t.consume(!0),e.breakpoint)t.shiftKey?e.breakpoint.setEnabled(!e.breakpoint.enabled()):e.breakpoint.remove(!1);else{const t=e.handle.resolve();if(!t)return;const i=this._transformer.editorLocationToUILocation(t.lineNumber,t.columnNumber);await this._setBreakpoint(i.lineNumber,i.columnNumber,e.condition,!0)}}_inlineBreakpointContextMenu(e,t){t.consume(!0);const i=e.handle.resolve();if(!i)return;if(this._textEditor.hasLineClass(i.lineNumber,"cm-non-breakable-line"))return;if(!Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().supportsConditionalBreakpoints(this._uiSourceCode))return;const o=this._transformer.editorLocationToUILocation(i.lineNumber,i.columnNumber),n=new UI.ContextMenu.ContextMenu(t);e.breakpoint?n.debugSection().appendItem(i18nString(UIStrings.editBreakpoint),this._editBreakpointCondition.bind(this,i.lineNumber,e.breakpoint,null,!1)):(n.debugSection().appendItem(i18nString(UIStrings.addConditionalBreakpoint),this._editBreakpointCondition.bind(this,i.lineNumber,null,i,!1)),n.debugSection().appendItem(i18nString(UIStrings.addLogpoint),this._editBreakpointCondition.bind(this,i.lineNumber,null,i,!0)),n.debugSection().appendItem(i18nString(UIStrings.neverPauseHere),this._setBreakpoint.bind(this,o.lineNumber,o.columnNumber,"false",!0))),n.show()}_shouldIgnoreExternalBreakpointEvents(e){if(e.data.uiLocation.uiSourceCode!==this._uiSourceCode)return!0;if(this._muted)return!0;for(const t of this._scriptFileForDebuggerModel.values())if(t.isDivergingFromVM()||t.isMergingToVM())return!0;return!1}_breakpointAdded(e){if(this._shouldIgnoreExternalBreakpointEvents(e))return;const t=e.data.uiLocation,i=e.data.breakpoint;this._addBreakpoint(t,i)}_addBreakpoint(e,t){const i=this._transformer.uiLocationToEditorLocation(e.lineNumber,e.columnNumber),o=this._lineBreakpointDecorations(e.lineNumber);let n=this._breakpointDecoration(i.lineNumber,i.columnNumber);if(n)n.breakpoint=t,n.condition=t.condition(),n.enabled=t.enabled();else{const e=this._textEditor.textEditorPositionHandle(i.lineNumber,i.columnNumber);n=new BreakpointDecoration(this._textEditor,e,t.condition(),t.enabled(),t.bound()||!t.hasBoundScript(),t),n.element.addEventListener("click",this._inlineBreakpointClick.bind(this,n),!0),n.element.addEventListener("contextmenu",this._inlineBreakpointContextMenu.bind(this,n),!0),this._breakpointDecorations.add(n)}if(this._decorationByBreakpoint.set(t,n),this._updateBreakpointDecoration(n),t.enabled()&&!o.length){this._possibleBreakpointsRequested.add(i.lineNumber);const e=this._transformer.editorLocationToUILocation(i.lineNumber,0),t=this._transformer.editorLocationToUILocation(i.lineNumber+1,0);this._breakpointManager.possibleBreakpoints(this._uiSourceCode,new TextUtils.TextRange.TextRange(e.lineNumber,e.columnNumber||0,t.lineNumber,t.columnNumber||0)).then(function(e,t){this._possibleBreakpointsRequested.delete(e);const i=this._lineBreakpointDecorations(e);for(const n of i)this._updateBreakpointDecoration(n);if(!i.some((e=>Boolean(e.breakpoint))))return;const o=new Set;for(const n of i){const e=n.handle.resolve();e&&o.add(e.columnNumber)}for(const n of t.slice(0,100)){const t=this._transformer.uiLocationToEditorLocation(n.lineNumber,n.columnNumber);if(t.lineNumber!==e)continue;if(o.has(t.columnNumber))continue;const i=this._textEditor.textEditorPositionHandle(t.lineNumber,t.columnNumber),r=new BreakpointDecoration(this._textEditor,i,"",!1,!1,null);r.element.addEventListener("click",this._inlineBreakpointClick.bind(this,r),!0),r.element.addEventListener("contextmenu",this._inlineBreakpointContextMenu.bind(this,r),!0),this._breakpointDecorations.add(r),this._updateBreakpointDecoration(r)}}.bind(this,i.lineNumber))}}_breakpointRemoved(e){if(this._shouldIgnoreExternalBreakpointEvents(e))return;const t=e.data.uiLocation,i=e.data.breakpoint,o=this._decorationByBreakpoint.get(i);if(!o)return;this._decorationByBreakpoint.delete(i);const n=this._transformer.uiLocationToEditorLocation(t.lineNumber,t.columnNumber);o.breakpoint=null,o.enabled=!1;const r=this._lineBreakpointDecorations(n.lineNumber);if(r.some((e=>Boolean(e.breakpoint))))this._updateBreakpointDecoration(o);else for(const s of r)this._breakpointDecorations.delete(s),this._updateBreakpointDecoration(s)}_initializeBreakpoints(){const e=this._breakpointManager.breakpointLocationsForUISourceCode(this._uiSourceCode);for(const t of e)this._addBreakpoint(t.uiLocation,t.breakpoint)}_updateLinesWithoutMappingHighlight(){if(Bindings.CompilerScriptMapping.CompilerScriptMapping.uiSourceCodeOrigin(this._uiSourceCode).length){const e=this._textEditor.linesCount;for(let t=0;t<e;++t){const e=Bindings.CompilerScriptMapping.CompilerScriptMapping.uiLineHasMapping(this._uiSourceCode,t);e||(this._hasLineWithoutMapping=!0),this._hasLineWithoutMapping&&this._textEditor.toggleLineClass(t,"cm-non-breakable-line",!e)}return}const{pluginManager:e}=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance();e&&e.getMappedLines(this._uiSourceCode).then((e=>{if(void 0===e)return;const t=this._textEditor.linesCount;for(let i=0;i<t;++i){const t=e.has(i);t||(this._hasLineWithoutMapping=!0),this._hasLineWithoutMapping&&this._textEditor.toggleLineClass(i,"cm-non-breakable-line",!t)}})).catch(console.error)}_updateScriptFiles(){for(const e of SDK.SDKModel.TargetManager.instance().models(SDK.DebuggerModel.DebuggerModel)){Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().scriptFile(this._uiSourceCode,e)&&this._updateScriptFile(e)}}_updateScriptFile(e){const t=this._scriptFileForDebuggerModel.get(e),i=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().scriptFile(this._uiSourceCode,e);this._scriptFileForDebuggerModel.delete(e),t&&(t.removeEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidMergeToVM,this._didMergeToVM,this),t.removeEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidDivergeFromVM,this._didDivergeFromVM,this),this._muted&&!this._uiSourceCode.isDirty()&&this._restoreBreakpointsIfConsistentScripts()),i&&(this._scriptFileForDebuggerModel.set(e,i),i.addEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidMergeToVM,this._didMergeToVM,this),i.addEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidDivergeFromVM,this._didDivergeFromVM,this),i.checkMapping(),i.hasSourceMapURL()&&this._showSourceMapInfobar())}_showSourceMapInfobar(){this._sourceMapInfobar||(this._sourceMapInfobar=UI.Infobar.Infobar.create(UI.Infobar.Type.Info,i18nString(UIStrings.sourceMapDetected),[],Common.Settings.Settings.instance().createSetting("sourceMapInfobarDisabled",!1)),this._sourceMapInfobar&&(this._sourceMapInfobar.createDetailsRowMessage(i18nString(UIStrings.associatedFilesShouldBeAdded)),this._sourceMapInfobar.createDetailsRowMessage(i18nString(UIStrings.associatedFilesAreAvailable,{PH1:UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("quickOpen.show")})),this._sourceMapInfobar.setCloseCallback((()=>{this._sourceMapInfobar=null})),this._textEditor.attachInfobar(this._sourceMapInfobar)))}async _detectMinified(){const e=this._uiSourceCode.content();if(!e||!TextUtils.TextUtils.isMinified(e))return;const t=getRegisteredEditorActions();let i=null;for(const r of t)if(r instanceof ScriptFormatterEditorAction){if(!r.isCurrentUISourceCodeFormatable())return;i=r.toggleFormatScriptSource.bind(r);break}if(this._prettyPrintInfobar=UI.Infobar.Infobar.create(UI.Infobar.Type.Info,i18nString(UIStrings.prettyprintThisMinifiedFile),[{text:i18nString(UIStrings.prettyprint),delegate:i,highlight:!0,dismiss:!0}],Common.Settings.Settings.instance().createSetting("prettyPrintInfobarDisabled",!1)),!this._prettyPrintInfobar)return;this._prettyPrintInfobar.setCloseCallback((()=>{this._prettyPrintInfobar=null}));const o=new UI.Toolbar.Toolbar(""),n=new UI.Toolbar.ToolbarButton("","largeicon-pretty-print");o.appendToolbarItem(n),o.element.style.display="inline-block",o.element.style.verticalAlign="middle",o.element.style.marginBottom="3px",o.element.style.pointerEvents="none",o.element.tabIndex=-1;this._prettyPrintInfobar.createDetailsRowMessage().appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.prettyprintingWillFormatThisFile,{PH1:o.element})),this._textEditor.attachInfobar(this._prettyPrintInfobar)}async _handleGutterClick(e){if(this._muted)return;const t=e.data;if(t.gutterType!==SourceFrame.SourcesTextEditor.lineNumbersGutterType)return;const i=t.lineNumber,o=t.event;0!==o.button||o.altKey||o.ctrlKey||o.metaKey||(await this._toggleBreakpoint(i,o.shiftKey),o.consume(!0))}async _toggleBreakpoint(e,t){const i=this._lineBreakpointDecorations(e);if(!i.length)return void await this._createNewBreakpoint(e,"",!0);const o=this._textEditor.hasLineClass(e,"cm-breakpoint-disabled"),n=i.map((e=>e.breakpoint)).filter((e=>Boolean(e)));for(const r of n)t?r.setEnabled(o):r.remove(!1)}async _createNewBreakpoint(e,t,i){if(this._textEditor.hasLineClass(e,"cm-non-breakable-line"))return;Host.userMetrics.actionTaken(Host.UserMetrics.Action.ScriptsBreakpointSet);const o=this._transformer.editorLocationToUILocation(e);await this._setBreakpoint(o.lineNumber,o.columnNumber,t,i)}async _setBreakpoint(e,t,i,o){Common.Settings.Settings.instance().moduleSetting("breakpointsActive").set(!0),await this._breakpointManager.setBreakpoint(this._uiSourceCode,e,t,i,o),this._breakpointWasSetForTest(e,t,i,o)}_breakpointWasSetForTest(e,t,i,o){}async _callFrameChanged(){this._liveLocationPool.disposeAll();const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);e?await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().createCallFrameLiveLocation(e.location(),this._executionLineChanged.bind(this),this._liveLocationPool):this._clearExecutionLine()}dispose(){for(const e of this._breakpointDecorations)e.dispose();if(this._breakpointDecorations.clear(),this._scheduledBreakpointDecorationUpdates){for(const e of this._scheduledBreakpointDecorationUpdates)e.dispose();this._scheduledBreakpointDecorationUpdates.clear()}this._hideIgnoreListInfobar(),this._sourceMapInfobar&&this._sourceMapInfobar.dispose(),this._prettyPrintInfobar&&this._prettyPrintInfobar.dispose(),this._scriptsPanel.element.removeEventListener("scroll",this._boundPopoverHelperHide,!0);for(const e of this._scriptFileForDebuggerModel.values())e.removeEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidMergeToVM,this._didMergeToVM,this),e.removeEventListener(Bindings.ResourceScriptMapping.ResourceScriptFile.Events.DidDivergeFromVM,this._didDivergeFromVM,this);this._scriptFileForDebuggerModel.clear(),this._textEditor.element.removeEventListener("keydown",this._boundKeyDown,!0),this._textEditor.element.removeEventListener("keyup",this._boundKeyUp,!0),this._textEditor.element.removeEventListener("mousemove",this._boundMouseMove,!1),this._textEditor.element.removeEventListener("mousedown",this._boundMouseDown,!0),this._textEditor.element.removeEventListener("focusout",this._boundBlur,!1),this._textEditor.element.removeEventListener("wheel",this._boundWheel,!0),this._textEditor.removeEventListener(SourceFrame.SourcesTextEditor.Events.GutterClick,this._boundGutterClick,this),this._popoverHelper.hidePopover(),this._popoverHelper.dispose(),this._breakpointManager.removeEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this._breakpointAdded,this),this._breakpointManager.removeEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this._breakpointRemoved,this),this._uiSourceCode.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,this._workingCopyChanged,this),this._uiSourceCode.removeEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,this._workingCopyCommitted,this),Common.Settings.Settings.instance().moduleSetting("skipStackFramesPattern").removeChangeListener(this._showIgnoreListInfobarIfNeeded,this),Common.Settings.Settings.instance().moduleSetting("skipContentScripts").removeChangeListener(this._showIgnoreListInfobarIfNeeded,this),super.dispose(),this._clearExecutionLine(),UI.Context.Context.instance().removeFlavorChangeListener(SDK.DebuggerModel.CallFrame,this._callFrameChanged,this),this._liveLocationPool.disposeAll()}}export class BreakpointDecoration{constructor(e,t,i,o,n,r){this._textEditor=e,this.handle=t,this.condition=i,this.enabled=o,this.bound=n,this.breakpoint=r,this.element=document.createElement("span"),this.element.classList.toggle("cm-inline-breakpoint",!0),this.bookmark=null}static mostSpecificFirst(e,t){return e.enabled!==t.enabled?e.enabled?-1:1:e.bound!==t.bound?e.bound?-1:1:Boolean(e.condition)!==Boolean(t.condition)?Boolean(e.condition)?-1:1:0}update(){const e=Boolean(this.condition)&&this.condition.includes(LogpointPrefix),t=Boolean(this.condition)&&!e;this.element.classList.toggle("cm-inline-logpoint",e),this.element.classList.toggle("cm-inline-breakpoint-conditional",t),this.element.classList.toggle("cm-inline-disabled",!this.enabled)}show(){if(this.bookmark)return;const e=this.handle.resolve();e&&(this.bookmark=this._textEditor.addBookmark(e.lineNumber,e.columnNumber,this.element,BreakpointDecoration.bookmarkSymbol),this.bookmark[BreakpointDecoration._elementSymbolForTest]=this.element)}hide(){this.bookmark&&(this.bookmark.clear(),this.bookmark=null)}dispose(){const e=this.handle.resolve();e&&(this._textEditor.toggleLineClass(e.lineNumber,"cm-breakpoint",!1),this._textEditor.toggleLineClass(e.lineNumber,"cm-breakpoint-disabled",!1),this._textEditor.toggleLineClass(e.lineNumber,"cm-breakpoint-unbound",!1),this._textEditor.toggleLineClass(e.lineNumber,"cm-breakpoint-conditional",!1),this._textEditor.toggleLineClass(e.lineNumber,"cm-breakpoint-logpoint",!1)),this.hide()}}BreakpointDecoration.bookmarkSymbol=Symbol("bookmark"),BreakpointDecoration._elementSymbolForTest=Symbol("element");export const continueToLocationDecorationSymbol=Symbol("bookmark");