import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";const UIStrings={noBreakpoints:"No breakpoints",checked:"checked",unchecked:"unchecked",mixed:"mixed",sBreakpointHit:"{PH1} breakpoint hit",removeAllBreakpointsInLine:"Remove all breakpoints in line",removeBreakpoint:"Remove breakpoint",revealLocation:"Reveal location",deactivateBreakpoints:"Deactivate breakpoints",activateBreakpoints:"Activate breakpoints",enableAllBreakpoints:"Enable all breakpoints",enableBreakpointsInFile:"Enable breakpoints in file",disableAllBreakpoints:"Disable all breakpoints",disableBreakpointsInFile:"Disable breakpoints in file",removeAllBreakpoints:"Remove all breakpoints",removeOtherBreakpoints:"Remove other breakpoints"},str_=i18n.i18n.registerUIStrings("sources/JavaScriptBreakpointsSidebarPane.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let javaScriptBreakpointsSidebarPaneInstance;export class JavaScriptBreakpointsSidebarPane extends UI.ThrottledWidget.ThrottledWidget{constructor(){super(!0),this.registerRequiredCSS("sources/javaScriptBreakpointsSidebarPane.css",{enableLegacyPatching:!0}),this._breakpointManager=Bindings.BreakpointManager.BreakpointManager.instance(),this._breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointAdded,this.update,this),this._breakpointManager.addEventListener(Bindings.BreakpointManager.Events.BreakpointRemoved,this.update,this),Common.Settings.Settings.instance().moduleSetting("breakpointsActive").addChangeListener(this.update,this),this._breakpoints=new UI.ListModel.ListModel,this._list=new UI.ListControl.ListControl(this._breakpoints,this,UI.ListControl.ListMode.NonViewport),UI.ARIAUtils.markAsList(this._list.element),this.contentElement.appendChild(this._list.element),this._emptyElement=this.contentElement.createChild("div","gray-info-message"),this._emptyElement.textContent=i18nString(UIStrings.noBreakpoints),this._emptyElement.tabIndex=-1,this.update()}static instance(){return javaScriptBreakpointsSidebarPaneInstance||(javaScriptBreakpointsSidebarPaneInstance=new JavaScriptBreakpointsSidebarPane),javaScriptBreakpointsSidebarPaneInstance}_getBreakpointLocations(){const e=this._breakpointManager.allBreakpointLocations().filter((e=>e.uiLocation.uiSourceCode.project().type()!==Workspace.Workspace.projectTypes.Debugger));e.sort(((e,t)=>e.uiLocation.compareTo(t.uiLocation)));const t=[];let i=null,n=null;for(const o of e)(o.breakpoint!==i||n&&o.uiLocation.compareTo(n))&&(t.push(o),i=o.breakpoint,n=o.uiLocation);return t}_hideList(){this._list.element.classList.add("hidden"),this._emptyElement.classList.remove("hidden")}_ensureListShown(){this._list.element.classList.remove("hidden"),this._emptyElement.classList.add("hidden")}_groupBreakpointLocationsById(e){const t=new Platform.MapUtilities.Multimap;for(const n of e){const e=n.uiLocation;t.set(e.id(),n)}const i=[];for(const n of t.keysArray()){const e=Array.from(t.get(n));e.length&&i.push(e)}return i}_getLocationIdsByLineId(e){const t=new Platform.MapUtilities.Multimap;for(const i of e){const e=i.uiLocation;t.set(e.lineId(),e.id())}return t}async _getSelectedUILocation(){const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.DebuggerPausedDetails);return e&&e.callFrames.length?await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(e.callFrames[0].location()):null}_getContent(e){const t=new Map;return Promise.all(e.map((async([{uiLocation:{uiSourceCode:e}}])=>{if("application/wasm"===e.mimeType())return new TextUtils.Text.Text("");const{content:i}=await e.requestContent(),n=i||"";if(t.has(n))return t.get(n);const o=new TextUtils.Text.Text(n);return t.set(n,o),o})))}async doUpdate(){const e=this.hasFocus(),t=this._getBreakpointLocations();if(!t.length)return this._hideList(),this._setBreakpointItems([]),this._didUpdateForTest();this._ensureListShown();const i=this._groupBreakpointLocationsById(t),n=this._getLocationIdsByLineId(t),o=await this._getContent(i),s=await this._getSelectedUILocation(),a=[];for(let r=0;r<i.length;r++){const e=i[r],t=e[0].uiLocation,l=null!==s&&e.some((e=>e.uiLocation.id()===s.id())),c="application/wasm"!==t.uiSourceCode.mimeType()&&n.get(t.lineId()).size>1,p=o[r];a.push(new BreakpointItem(e,p,l,c))}return a.some((e=>e.isSelected))&&UI.ViewManager.ViewManager.instance().showView("sources.jsBreakpoints"),this._list.element.classList.toggle("breakpoints-list-deactivated",!Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get()),this._setBreakpointItems(a),e&&this.focus(),this._didUpdateForTest()}_setBreakpointItems(e){if(this._breakpoints.length===e.length)for(let t=0;t<this._breakpoints.length;t++)this._breakpoints.at(t).isSimilar(e[t])||this._breakpoints.replace(t,e[t],!0);else this._breakpoints.replaceAll(e);!this._list.selectedItem()&&this._breakpoints.at(0)&&this._list.selectItem(this._breakpoints.at(0))}createElementForItem(e){const t=document.createElement("div");t.classList.add("breakpoint-entry"),UI.ARIAUtils.markAsListitem(t),t.tabIndex=this._list.selectedItem()===e?0:-1,t.addEventListener("contextmenu",this._breakpointContextMenu.bind(this),!0),t.addEventListener("click",this._revealLocation.bind(this,t),!1);const i=UI.UIUtils.CheckboxLabel.create(""),n=e.locations[0].uiLocation,o=e.locations.some((e=>e.breakpoint.enabled())),s=e.locations.some((e=>!e.breakpoint.enabled()));i.textElement.textContent=n.linkText()+(e.showColumn&&"number"===typeof n.columnNumber?":"+(n.columnNumber+1):""),i.checkboxElement.checked=o,i.checkboxElement.indeterminate=o&&s,i.checkboxElement.tabIndex=-1,i.addEventListener("click",this._breakpointCheckboxClicked.bind(this),!1),t.appendChild(i);let a=i18nString(o?UIStrings.checked:UIStrings.unchecked);o&&s&&(a=i18nString(UIStrings.mixed)),e.isSelected?(UI.ARIAUtils.setDescription(t,i18nString(UIStrings.sBreakpointHit,{PH1:a})),t.classList.add("breakpoint-hit"),this.setDefaultFocusedElement(t)):UI.ARIAUtils.setDescription(t,a),t.addEventListener("keydown",(e=>{" "===e.key&&(i.checkboxElement.click(),e.consume(!0))}));const r=t.createChild("div","source-text monospace"),l=n.lineNumber;if(e.text&&l<e.text.lineCount()){const t=e.text.lineAt(l),i=200;r.textContent=Platform.StringUtilities.trimEndWithMaxLength(t.substring(e.showColumn&&n.columnNumber||0),i)}return elementToBreakpointMap.set(t,e.locations),elementToUILocationMap.set(t,n),t}heightForItem(e){return 0}isItemSelectable(e){return!0}selectedItemChanged(e,t,i,n){i&&(i.tabIndex=-1),n&&(n.tabIndex=0,this.setDefaultFocusedElement(n),this.hasFocus()&&n.focus())}updateSelectedItemARIA(e,t){return!0}_breakpointLocations(e){return e.target instanceof Element?this._breakpointLocationsForElement(e.target):[]}_breakpointLocationsForElement(e){const t=e.enclosingNodeOrSelfWithClass("breakpoint-entry");return t&&elementToBreakpointMap.get(t)||[]}_breakpointCheckboxClicked(e){const t=this.hasFocus(),i=this._breakpointLocations(e).map((e=>e.breakpoint)),n=e.target.checkboxElement.checked;for(const o of i){o.setEnabled(n);const e=this._breakpoints.find((e=>e.locations.some((e=>e.breakpoint===o))));e&&this._list.refreshItem(e)}t&&this.focus(),e.consume()}_revealLocation(e){const t=this._breakpointLocationsForElement(e).map((e=>e.uiLocation));let i=null;for(const n of t)(!i||n.compareTo(i)<0)&&(i=n);i&&Common.Revealer.reveal(i)}_breakpointContextMenu(e){const t=this._breakpointLocations(e).map((e=>e.breakpoint)),i=new UI.ContextMenu.ContextMenu(e),n=t.length>1?i18nString(UIStrings.removeAllBreakpointsInLine):i18nString(UIStrings.removeBreakpoint);i.defaultSection().appendItem(n,(()=>t.map((e=>e.remove(!1))))),e.target instanceof Element&&i.defaultSection().appendItem(i18nString(UIStrings.revealLocation),this._revealLocation.bind(this,e.target));const o=Common.Settings.Settings.instance().moduleSetting("breakpointsActive").get(),s=i18nString(o?UIStrings.deactivateBreakpoints:UIStrings.activateBreakpoints);if(i.defaultSection().appendItem(s,(()=>Common.Settings.Settings.instance().moduleSetting("breakpointsActive").set(!o))),t.some((e=>!e.enabled()))){const t=i18nString(UIStrings.enableAllBreakpoints);if(i.defaultSection().appendItem(t,this._toggleAllBreakpoints.bind(this,!0)),e.target instanceof Element){const t=i18nString(UIStrings.enableBreakpointsInFile);i.defaultSection().appendItem(t,this._toggleAllBreakpointsInFile.bind(this,e.target,!0))}}if(t.some((e=>e.enabled()))){const t=i18nString(UIStrings.disableAllBreakpoints);if(i.defaultSection().appendItem(t,this._toggleAllBreakpoints.bind(this,!1)),e.target instanceof Element){const t=i18nString(UIStrings.disableBreakpointsInFile);i.defaultSection().appendItem(t,this._toggleAllBreakpointsInFile.bind(this,e.target,!1))}}const a=i18nString(UIStrings.removeAllBreakpoints);i.defaultSection().appendItem(a,this._removeAllBreakpoints.bind(this));const r=i18nString(UIStrings.removeOtherBreakpoints);i.defaultSection().appendItem(r,this._removeOtherBreakpoints.bind(this,new Set(t))),i.show()}_toggleAllBreakpointsInFile(e,t){const i=this._getBreakpointLocations(),n=this._breakpointLocationsForElement(e);i.forEach((e=>{n.some((t=>t.breakpoint.url()===e.breakpoint.url()))&&e.breakpoint.setEnabled(t)}))}_toggleAllBreakpoints(e){for(const t of this._breakpointManager.allBreakpointLocations())t.breakpoint.setEnabled(e)}_removeAllBreakpoints(){for(const e of this._breakpointManager.allBreakpointLocations())e.breakpoint.remove(!1)}_removeOtherBreakpoints(e){for(const t of this._breakpointManager.allBreakpointLocations())e.has(t.breakpoint)||t.breakpoint.remove(!1)}flavorChanged(e){this.update()}_didUpdateForTest(){}}class BreakpointItem{constructor(e,t,i,n){this.locations=e,this.text=t,this.isSelected=i,this.showColumn=n}isSimilar(e){return this.locations.length===e.locations.length&&this.locations.every(((t,i)=>t.uiLocation===e.locations[i].uiLocation))&&this.locations.every(((t,i)=>t.breakpoint===e.locations[i].breakpoint))&&(this.text===e.text||this.text&&e.text&&this.text.value()===e.text.value())&&this.isSelected===e.isSelected&&this.showColumn===e.showColumn}}const elementToUILocationMap=new WeakMap;export function retrieveLocationForElement(e){return elementToUILocationMap.get(e)}const elementToBreakpointMap=new WeakMap;export let BreakpointLocation;