import*as Common from"../common/common.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";let themeSupportInstance;export class ThemeSupport{constructor(e){const t=window.matchMedia("(prefers-color-scheme: dark)").matches?"dark":"default";this._themeName="systemPreferred"===e.get()?t:e.get(),this._themableProperties=new Set(["color","box-shadow","text-shadow","outline-color","background-image","background-color","border-left-color","border-right-color","border-top-color","border-bottom-color","-webkit-border-image","fill","stroke"]),this._cachedThemePatches=new Map,this._setting=e,this._customSheets=new Set,this._computedRoot=Common.Lazy.lazy((()=>window.getComputedStyle(document.documentElement)))}static hasInstance(){return"undefined"!==typeof themeSupportInstance}static instance(e={forceNew:null,setting:null}){const{forceNew:t,setting:o}=e;if(!themeSupportInstance||t){if(!o)throw new Error(`Unable to create theme support: setting must be provided: ${(new Error).stack}`);themeSupportInstance=new ThemeSupport(o)}return themeSupportInstance}getComputedValue(e){const t=this._computedRoot();if("symbol"===typeof t)throw new Error(`Computed value for property (${e}) could not be found on :root.`);return t.getPropertyValue(e)}hasTheme(){return"default"!==this._themeName}themeName(){return this._themeName}injectHighlightStyleSheets(e){this._injectingStyleSheet=!0,this._appendStyle(e,"ui/inspectorSyntaxHighlight.css",{enableLegacyPatching:!0}),"dark"===this._themeName&&this._appendStyle(e,"ui/inspectorSyntaxHighlightDark.css",{enableLegacyPatching:!0}),this._injectingStyleSheet=!1}_appendStyle(e,t,o={enableLegacyPatching:!1}){const r=Root.Runtime.cachedResources.get(t)||"";r||console.error(t+" not preloaded. Check module.json");let n=document.createElement("style");if(n.textContent=r,e.appendChild(n),o.enableLegacyPatching){const o=ThemeSupport.instance().themeStyleSheet(t,r);o&&(n=document.createElement("style"),n.textContent=o+"\n"+Root.Runtime.Runtime.resolveSourceURL(t+".theme"),e.appendChild(n))}}injectCustomStyleSheets(e){for(const t of this._customSheets){const o=document.createElement("style");o.textContent=t,e.appendChild(o)}}isForcedColorsMode(){return window.matchMedia("(forced-colors: active)").matches}addCustomStylesheet(e){this._customSheets.add(e)}applyTheme(e){if(!this.hasTheme()||this.isForcedColorsMode())return;"dark"===this._themeName&&e.documentElement.classList.add("-theme-with-dark-background");const t=e.styleSheets,o=[];for(let n=0;n<t.length;++n){const e=t[n].href;e&&o.push(this._patchForTheme(e,t[n]))}o.push("/*# sourceURL=inspector.css.theme */");const r=e.createElement("style");r.textContent=o.join("\n"),e.head.appendChild(r)}themeStyleSheet(e,t){if(!this.hasTheme()||this._injectingStyleSheet||this.isForcedColorsMode())return"";let o=this._cachedThemePatches.get(e);if(!o){const r=document.createElement("style");r.textContent=t,document.body.appendChild(r);const{sheet:n}=r;if(!n)throw new Error("No sheet in stylesheet object");o=this._patchForTheme(e,n),document.body.removeChild(r)}return o}_patchForTheme(e,t){const o=this._cachedThemePatches.get(e);if(o)return o;try{const o=t.cssRules,r=[];for(let e=0;e<o.length;++e){const t=o[e];if(t instanceof CSSImportRule){r.push(this._patchForTheme(t.styleSheet.href||"",t.styleSheet));continue}if(!(t instanceof CSSStyleRule))continue;const n=[],s=t.style,h=t.selectorText;for(let e=0;s&&e<s.length;++e)this._patchProperty(h,s,s[e],n);n.length&&r.push(t.selectorText+"{"+n.join("")+"}")}const n=r.join("\n");return this._cachedThemePatches.set(e,n),n}catch(r){return this._setting.set("default"),""}}_patchProperty(e,t,o,r){if(!this._themableProperties.has(o))return;const n=t.getPropertyValue(o);if(!n||"none"===n||"inherit"===n||"initial"===n||"transparent"===n)return;if("background-image"===o&&-1===n.indexOf("gradient"))return;if(-1!==e.indexOf("-theme-"))return;let s=ThemeSupport.ColorUsage.Unknown;if(0!==o.indexOf("background")&&0!==o.indexOf("border")||(s|=ThemeSupport.ColorUsage.Background),-1===o.indexOf("background")&&(s|=ThemeSupport.ColorUsage.Foreground),r.push(o),r.push(":"),/^var\(.*\)$/.test(n))r.push(n);else{const e=n.replace(Common.Color.Regex,"\0$1\0").split("\0");for(const t of e)r.push(this.patchColorText(t,s))}t.getPropertyPriority(o)&&r.push(" !important"),r.push(";")}patchColorText(e,t){const o=Common.Color.Color.parse(e);if(!o)return e;const r=this.patchColor(o,t);let n=r.asString(null);return n||(n=r.asString(r.hasAlpha()?Common.Color.Format.RGBA:Common.Color.Format.RGB)),n||e}patchColor(e,t){const o=e.hsla();this._patchHSLA(o,t);const r=[];return Common.Color.Color.hsl2rgb(o,r),new Common.Color.Color(r,e.format())}_patchHSLA(e,t){const o=e[0],r=e[1];let n=e[2];const s=e[3];switch(this._themeName){case"dark":{const e=t&ThemeSupport.ColorUsage.Background?.14:0,o=t&ThemeSupport.ColorUsage.Foreground?.9:1;n=1-n,n<2*e?n=e+n/2:n>2*o-1&&(n=o-.5+n/2);break}}e[0]=Platform.NumberUtilities.clamp(o,0,1),e[1]=Platform.NumberUtilities.clamp(r,0,1),e[2]=Platform.NumberUtilities.clamp(n,0,1),e[3]=Platform.NumberUtilities.clamp(s,0,1)}}ThemeSupport.ColorUsage={Unknown:0,Foreground:1,Background:2};