/*! For license information please see report.js.LICENSE.txt */
"use strict";const ELLIPSIS="\u2026",NBSP="\xa0",PASS_THRESHOLD=.9,SCREENSHOT_PREFIX="data:image/jpeg;base64,",RATINGS={PASS:{label:"pass",minScore:.9},AVERAGE:{label:"average",minScore:.5},FAIL:{label:"fail"},ERROR:{label:"error"}},listOfTlds=["com","co","gov","edu","ac","org","go","gob","or","net","in","ne","nic","gouv","web","spb","blog","jus","kiev","mil","wi","qc","ca","bel","on"];class Util{static get PASS_THRESHOLD(){return.9}static get MS_DISPLAY_VALUE(){return"%10d\xa0ms"}static prepareReportResult(e){const t=JSON.parse(JSON.stringify(e));t.configSettings.locale||(t.configSettings.locale="en"),t.configSettings.formFactor||(t.configSettings.formFactor=t.configSettings.emulatedFormFactor);for(const n of Object.values(t.audits))if("not_applicable"!==n.scoreDisplayMode&&"not-applicable"!==n.scoreDisplayMode||(n.scoreDisplayMode="notApplicable"),n.details&&(void 0!==n.details.type&&"diagnostic"!==n.details.type||(n.details.type="debugdata"),"filmstrip"===n.details.type))for(const e of n.details.items)e.data.startsWith(SCREENSHOT_PREFIX)||(e.data=SCREENSHOT_PREFIX+e.data);if("object"!==typeof t.categories)throw new Error("No categories provided.");for(const n of Object.values(t.categories))n.auditRefs.forEach((e=>{const n=t.audits[e.id];e.result=n,t.stackPacks&&t.stackPacks.forEach((t=>{t.descriptions[e.id]&&(e.stackPacks=e.stackPacks||[],e.stackPacks.push({title:t.title,iconDataURL:t.iconDataURL,description:t.descriptions[e.id]}))}))}));return t}static showAsPassed(e){switch(e.scoreDisplayMode){case"manual":case"notApplicable":return!0;case"error":case"informative":return!1;case"numeric":case"binary":default:return Number(e.score)>=RATINGS.PASS.minScore}}static calculateRating(e,t){if("manual"===t||"notApplicable"===t)return RATINGS.PASS.label;if("error"===t)return RATINGS.ERROR.label;if(null===e)return RATINGS.FAIL.label;let n=RATINGS.FAIL.label;return e>=RATINGS.PASS.minScore?n=RATINGS.PASS.label:e>=RATINGS.AVERAGE.minScore&&(n=RATINGS.AVERAGE.label),n}static splitMarkdownCodeSpans(e){const t=[],n=e.split(/`(.*?)`/g);for(let i=0;i<n.length;i++){const e=n[i];if(!e)continue;const r=i%2!==0;t.push({isCode:r,text:e})}return t}static splitMarkdownLink(e){const t=[],n=e.split(/\[([^\]]+?)\]\((https?:\/\/.*?)\)/g);for(;n.length;){const[e,i,r]=n.splice(0,3);e&&t.push({isLink:!1,text:e}),i&&r&&t.push({isLink:!0,text:i,linkHref:r})}return t}static getURLDisplayName(e,t){const n=void 0!==(t=t||{numPathParts:void 0,preserveQuery:void 0,preserveHost:void 0}).numPathParts?t.numPathParts:2,i=void 0===t.preserveQuery||t.preserveQuery,r=t.preserveHost||!1;let s;if("about:"===e.protocol||"data:"===e.protocol)s=e.href;else{s=e.pathname;const t=s.split("/").filter((e=>e.length));n&&t.length>n&&(s="\u2026"+t.slice(-1*n).join("/")),r&&(s=`${e.host}/${s.replace(/^\//,"")}`),i&&(s=`${s}${e.search}`)}if(s=s.replace(/([a-f0-9]{7})[a-f0-9]{13}[a-f0-9]*/g,"$1\u2026"),s=s.replace(/([a-zA-Z0-9-_]{9})(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])[a-zA-Z0-9-_]{10,}/g,"$1\u2026"),s=s.replace(/(\d{3})\d{6,}/g,"$1\u2026"),s=s.replace(/\u2026+/g,"\u2026"),s.length>64&&s.includes("?")&&(s=s.replace(/\?([^=]*)(=)?.*/,"?$1$2\u2026"),s.length>64&&(s=s.replace(/\?.*/,"?\u2026"))),s.length>64){const e=s.lastIndexOf(".");s=e>=0?s.slice(0,63-(s.length-e))+`\u2026${s.slice(e)}`:s.slice(0,63)+"\u2026"}return s}static parseURL(e){const t=new URL(e);return{file:Util.getURLDisplayName(t),hostname:t.hostname,origin:t.origin}}static createOrReturnURL(e){return e instanceof URL?e:new URL(e)}static getTld(e){const t=e.split(".").slice(-2);return listOfTlds.includes(t[0])?`.${t.join(".")}`:`.${t[t.length-1]}`}static getRootDomain(e){const t=Util.createOrReturnURL(e).hostname,n=Util.getTld(t).split(".");return t.split(".").slice(-n.length).join(".")}static getEnvironmentDisplayValues(e){const t=Util.getEmulationDescriptions(e);return[{name:Util.i18n.strings.runtimeSettingsDevice,description:t.deviceEmulation},{name:Util.i18n.strings.runtimeSettingsNetworkThrottling,description:t.networkThrottling},{name:Util.i18n.strings.runtimeSettingsCPUThrottling,description:t.cpuThrottling}]}static getEmulationDescriptions(e){let t,n;const i=e.throttling;switch(e.throttlingMethod){case"provided":t=Util.i18n.strings.throttlingProvided,n=Util.i18n.strings.throttlingProvided;break;case"devtools":{const{cpuSlowdownMultiplier:e,requestLatencyMs:r}=i;t=`${Util.i18n.formatNumber(e)}x slowdown (DevTools)`,n=`${Util.i18n.formatNumber(r)}\xa0ms HTTP RTT, ${Util.i18n.formatNumber(i.downloadThroughputKbps)}\xa0Kbps down, ${Util.i18n.formatNumber(i.uploadThroughputKbps)}\xa0Kbps up (DevTools)`;break}case"simulate":{const{cpuSlowdownMultiplier:e,rttMs:r,throughputKbps:s}=i;t=`${Util.i18n.formatNumber(e)}x slowdown (Simulated)`,n=`${Util.i18n.formatNumber(r)}\xa0ms TCP RTT, ${Util.i18n.formatNumber(s)}\xa0Kbps throughput (Simulated)`;break}default:t=Util.i18n.strings.runtimeUnknown,n=Util.i18n.strings.runtimeUnknown}return{deviceEmulation:{mobile:Util.i18n.strings.runtimeMobileEmulation,desktop:Util.i18n.strings.runtimeDesktopEmulation}[e.formFactor]||Util.i18n.strings.runtimeNoEmulation,cpuThrottling:t,networkThrottling:n}}static filterRelevantLines(e,t,n){if(0===t.length)return e.slice(0,2*n+1);const i=new Set;return(t=t.sort(((e,t)=>(e.lineNumber||0)-(t.lineNumber||0)))).forEach((({lineNumber:e})=>{let t=e-n,r=e+n;for(;t<1;)t++,r++;i.has(t-3-1)&&(t-=3);for(let n=t;n<=r;n++){const e=n;i.add(e)}})),e.filter((e=>i.has(e.lineNumber)))}static isPluginCategory(e){return e.startsWith("lighthouse-plugin-")}}Util.reportJson=null,Util.getUniqueSuffix=(()=>{let e=0;return function(){return e++}})(),Util.i18n=null,Util.UIStrings={varianceDisclaimer:"Values are estimated and may vary. The [performance score is calculated](https://web.dev/performance-scoring/) directly from these metrics.",calculatorLink:"See calculator.",opportunityResourceColumnLabel:"Opportunity",opportunitySavingsColumnLabel:"Estimated Savings",errorMissingAuditInfo:"Report error: no audit information",errorLabel:"Error!",warningHeader:"Warnings: ",warningAuditsGroupTitle:"Passed audits but with warnings",passedAuditsGroupTitle:"Passed audits",notApplicableAuditsGroupTitle:"Not applicable",manualAuditsGroupTitle:"Additional items to manually check",toplevelWarningsMessage:"There were issues affecting this run of Lighthouse:",crcInitialNavigation:"Initial Navigation",crcLongestDurationLabel:"Maximum critical path latency:",snippetExpandButtonLabel:"Expand snippet",snippetCollapseButtonLabel:"Collapse snippet",lsPerformanceCategoryDescription:"[Lighthouse](https://developers.google.com/web/tools/lighthouse/) analysis of the current page on an emulated mobile network. Values are estimated and may vary.",labDataTitle:"Lab Data",thirdPartyResourcesLabel:"Show 3rd-party resources",dropdownPrintSummary:"Print Summary",dropdownPrintExpanded:"Print Expanded",dropdownCopyJSON:"Copy JSON",dropdownSaveHTML:"Save as HTML",dropdownSaveJSON:"Save as JSON",dropdownViewer:"Open in Viewer",dropdownSaveGist:"Save as Gist",dropdownDarkTheme:"Toggle Dark Theme",runtimeSettingsTitle:"Runtime Settings",runtimeSettingsUrl:"URL",runtimeSettingsFetchTime:"Fetch Time",runtimeSettingsDevice:"Device",runtimeSettingsNetworkThrottling:"Network throttling",runtimeSettingsCPUThrottling:"CPU throttling",runtimeSettingsChannel:"Channel",runtimeSettingsUA:"User agent (host)",runtimeSettingsUANetwork:"User agent (network)",runtimeSettingsBenchmark:"CPU/Memory Power",runtimeSettingsAxeVersion:"Axe version",footerIssue:"File an issue",runtimeNoEmulation:"No emulation",runtimeMobileEmulation:"Emulated Moto G4",runtimeDesktopEmulation:"Emulated Desktop",runtimeUnknown:"Unknown",throttlingProvided:"Provided by environment"},"undefined"!==typeof module&&module.exports?module.exports=Util:self.Util=Util;class DOM{constructor(e){this._document=e,this._lighthouseChannel="unknown"}createElement(e,t,n={}){const i=this._document.createElement(e);return t&&(i.className=t),Object.keys(n).forEach((e=>{const t=n[e];"undefined"!==typeof t&&i.setAttribute(e,t)})),i}createElementNS(e,t,n,i={}){const r=this._document.createElementNS(e,t);return n&&(r.className=n),Object.keys(i).forEach((e=>{const t=i[e];"undefined"!==typeof t&&r.setAttribute(e,t)})),r}createFragment(){return this._document.createDocumentFragment()}createChildOf(e,t,n,i){const r=this.createElement(t,n,i);return e.appendChild(r),r}cloneTemplate(e,t){const n=t.querySelector(e);if(!n)throw new Error(`Template not found: template${e}`);const i=this._document.importNode(n.content,!0);return n.hasAttribute("data-stamped")&&this.findAll("style",i).forEach((e=>e.remove())),n.setAttribute("data-stamped","true"),i}resetTemplates(){this.findAll("template[data-stamped]",this._document).forEach((e=>{e.removeAttribute("data-stamped")}))}convertMarkdownLinkSnippets(e){const t=this.createElement("span");for(const n of Util.splitMarkdownLink(e)){if(!n.isLink){t.appendChild(this._document.createTextNode(n.text));continue}const e=new URL(n.linkHref);["https://developers.google.com","https://web.dev"].includes(e.origin)&&(e.searchParams.set("utm_source","lighthouse"),e.searchParams.set("utm_medium",this._lighthouseChannel));const i=this.createElement("a");i.rel="noopener",i.target="_blank",i.textContent=n.text,i.href=e.href,t.appendChild(i)}return t}convertMarkdownCodeSnippets(e){const t=this.createElement("span");for(const n of Util.splitMarkdownCodeSpans(e))if(n.isCode){const e=this.createElement("code");e.textContent=n.text,t.appendChild(e)}else t.appendChild(this._document.createTextNode(n.text));return t}setLighthouseChannel(e){this._lighthouseChannel=e}document(){return this._document}isDevTools(){return!!this._document.querySelector(".lh-devtools")}find(e,t){const n=t.querySelector(e);if(null===n)throw new Error(`query ${e} not found`);return n}findAll(e,t){return Array.from(t.querySelectorAll(e))}}"undefined"!==typeof module&&module.exports?module.exports=DOM:self.DOM=DOM,function(){var e=document.createElement("details"),t="undefined"!=typeof HTMLDetailsElement&&e instanceof HTMLDetailsElement,n="open"in e||t,i="ontoggle"in e,r='\ndetails, summary {\n  display: block;\n}\ndetails:not([open]) > *:not(summary) {\n  display: none;\n}\nsummary::before {\n  content: "\u25ba";\n  padding-right: 0.3rem;\n  font-size: 0.6rem;\n  cursor: default;\n}\n[open] > summary::before {\n  content: "\u25bc";\n}\n',s=[],o=s.forEach,a=s.slice;function l(e){(function(e,t){return(e.tagName==t?[e]:[]).concat("function"==typeof e.getElementsByTagName?a.call(e.getElementsByTagName(t)):[])})(e,"SUMMARY").forEach((function(e){var t=u(e,"DETAILS");e.setAttribute("aria-expanded",t.hasAttribute("open")),e.hasAttribute("tabindex")||e.setAttribute("tabindex","0"),e.hasAttribute("role")||e.setAttribute("role","button")}))}function d(e){return!(e.defaultPrevented||e.ctrlKey||e.metaKey||e.shiftKey||e.target.isContentEditable)}function c(e){addEventListener("click",(function(t){if(d(t)&&t.which<=1){var n=u(t.target,"SUMMARY");n&&n.parentNode&&"DETAILS"==n.parentNode.tagName&&e(n.parentNode)}}),!1),addEventListener("keydown",(function(t){if(d(t)&&(13==t.keyCode||32==t.keyCode)){var n=u(t.target,"SUMMARY");n&&n.parentNode&&"DETAILS"==n.parentNode.tagName&&(e(n.parentNode),t.preventDefault())}}),!1)}function h(e){var t=document.createEvent("Event");t.initEvent("toggle",!1,!1),e.dispatchEvent(t)}function u(e,t){if("function"==typeof e.closest)return e.closest(t);for(;e;){if(e.tagName==t)return e;e=e.parentNode}}n||(document.head.insertAdjacentHTML("afterbegin","<style>"+r+"</style>"),function(){var e=document.createElement("details").constructor.prototype,t=e.setAttribute,n=e.removeAttribute,i=Object.getOwnPropertyDescriptor(e,"open");Object.defineProperties(e,{open:{get:function(){return"DETAILS"==this.tagName?this.hasAttribute("open"):i&&i.get?i.get.call(this):void 0},set:function(e){return"DETAILS"==this.tagName?e?this.setAttribute("open",""):this.removeAttribute("open"):i&&i.set?i.set.call(this,e):void 0}},setAttribute:{value:function(e,n){var i=this,r=function(){return t.call(i,e,n)};if("open"==e&&"DETAILS"==this.tagName){var s=this.hasAttribute("open"),o=r();if(!s){var a=this.querySelector("summary");a&&a.setAttribute("aria-expanded",!0),h(this)}return o}return r()}},removeAttribute:{value:function(e){var t=this,i=function(){return n.call(t,e)};if("open"==e&&"DETAILS"==this.tagName){var r=this.hasAttribute("open"),s=i();if(r){var o=this.querySelector("summary");o&&o.setAttribute("aria-expanded",!1),h(this)}return s}return i()}}})}(),c((function(e){e.hasAttribute("open")?e.removeAttribute("open"):e.setAttribute("open","")})),l(document),window.MutationObserver?new MutationObserver((function(e){o.call(e,(function(e){o.call(e.addedNodes,l)}))})).observe(document.documentElement,{subtree:!0,childList:!0}):document.addEventListener("DOMNodeInserted",(function(e){l(e.target)}))),n&&!i&&(window.MutationObserver?new MutationObserver((function(e){o.call(e,(function(e){var t=e.target,n=e.attributeName;"DETAILS"==t.tagName&&"open"==n&&h(t)}))})).observe(document.documentElement,{attributes:!0,subtree:!0}):c((function(e){var t=e.getAttribute("open");setTimeout((function(){var n=e.getAttribute("open");t!=n&&h(e)}),1)})))}();const URL_PREFIXES=["http://","https://","data:"];class DetailsRenderer{constructor(e,t={}){this._dom=e,this._fullPageScreenshot=t.fullPageScreenshot,this._templateContext}setTemplateContext(e){this._templateContext=e}render(e){switch(e.type){case"filmstrip":return this._renderFilmstrip(e);case"list":return this._renderList(e);case"table":return this._renderTable(e);case"criticalrequestchain":return CriticalRequestChainRenderer.render(this._dom,this._templateContext,e,this);case"opportunity":return this._renderTable(e);case"screenshot":case"debugdata":case"full-page-screenshot":return null;default:return this._renderUnknown(e.type,e)}}_renderBytes(e){const t=Util.i18n.formatBytesToKiB(e.value,e.granularity),n=this._renderText(t);return n.title=Util.i18n.formatBytes(e.value),n}_renderMilliseconds(e){let t=Util.i18n.formatMilliseconds(e.value,e.granularity);return"duration"===e.displayUnit&&(t=Util.i18n.formatDuration(e.value)),this._renderText(t)}renderTextURL(e){const t=e;let n,i,r;try{const e=Util.parseURL(t);n="/"===e.file?e.origin:e.file,i="/"===e.file||""===e.hostname?"":`(${e.hostname})`,r=t}catch(o){n=t}const s=this._dom.createElement("div","lh-text__url");if(s.appendChild(this._renderLink({text:n,url:t})),i){const e=this._renderText(i);e.classList.add("lh-text__url-host"),s.appendChild(e)}return r&&(s.title=t,s.dataset.url=t),s}_renderLink(e){let t;try{t=new URL(e.url)}catch(i){}if(!t||!["https:","http:"].includes(t.protocol)){const t=this._renderText(e.text);return t.classList.add("lh-link"),t}const n=this._dom.createElement("a");return n.rel="noopener",n.target="_blank",n.textContent=e.text,n.href=t.href,n.classList.add("lh-link"),n}_renderText(e){const t=this._dom.createElement("div","lh-text");return t.textContent=e,t}_renderNumeric(e){const t=Util.i18n.formatNumber(e.value,e.granularity),n=this._dom.createElement("div","lh-numeric");return n.textContent=t,n}_renderThumbnail(e){const t=this._dom.createElement("img","lh-thumbnail"),n=e;return t.src=n,t.title=n,t.alt="",t}_renderUnknown(e,t){console.error(`Unknown details type: ${e}`,t);const n=this._dom.createElement("details","lh-unknown");return this._dom.createChildOf(n,"summary").textContent=`We don't know how to render audit details of type \`${e}\`. The Lighthouse version that collected this data is likely newer than the Lighthouse version of the report renderer. Expand for the raw JSON.`,this._dom.createChildOf(n,"pre").textContent=JSON.stringify(t,null,2),n}_renderTableValue(e,t){if(void 0===e||null===e)return null;if("object"===typeof e)switch(e.type){case"code":return this._renderCode(e.value);case"link":return this._renderLink(e);case"node":return this.renderNode(e);case"numeric":return this._renderNumeric(e);case"source-location":return this.renderSourceLocation(e);case"url":return this.renderTextURL(e.value);default:return this._renderUnknown(e.type,e)}switch(t.valueType){case"bytes":{const n=Number(e);return this._renderBytes({value:n,granularity:t.granularity})}case"code":{const t=String(e);return this._renderCode(t)}case"ms":{const n={value:Number(e),granularity:t.granularity,displayUnit:t.displayUnit};return this._renderMilliseconds(n)}case"numeric":{const n=Number(e);return this._renderNumeric({value:n,granularity:t.granularity})}case"text":{const t=String(e);return this._renderText(t)}case"thumbnail":{const t=String(e);return this._renderThumbnail(t)}case"timespanMs":{const t=Number(e);return this._renderMilliseconds({value:t})}case"url":{const t=String(e);return URL_PREFIXES.some((e=>t.startsWith(e)))?this.renderTextURL(t):this._renderCode(t)}default:return this._renderUnknown(t.valueType,e)}}_getCanonicalizedHeadingsFromTable(e){return"opportunity"===e.type?e.headings:e.headings.map((e=>this._getCanonicalizedHeading(e)))}_getCanonicalizedHeading(e){let t;return e.subItemsHeading&&(t=this._getCanonicalizedsubItemsHeading(e.subItemsHeading,e)),{key:e.key,valueType:e.itemType,subItemsHeading:t,label:e.text,displayUnit:e.displayUnit,granularity:e.granularity}}_getCanonicalizedsubItemsHeading(e,t){return e.key||console.warn("key should not be null"),{key:e.key||"",valueType:e.itemType||t.itemType,granularity:e.granularity||t.granularity,displayUnit:e.displayUnit||t.displayUnit}}_getDerivedsubItemsHeading(e){return e.subItemsHeading?{key:e.subItemsHeading.key||"",valueType:e.subItemsHeading.valueType||e.valueType,granularity:e.subItemsHeading.granularity||e.granularity,displayUnit:e.subItemsHeading.displayUnit||e.displayUnit,label:""}:null}_renderTableRow(e,t){const n=this._dom.createElement("tr");for(const i of t){if(!i||!i.key){this._dom.createChildOf(n,"td","lh-table-column--empty");continue}const t=e[i.key];let r;if(void 0!==t&&null!==t&&(r=this._renderTableValue(t,i)),r){const e=`lh-table-column--${i.valueType}`;this._dom.createChildOf(n,"td",e).appendChild(r)}else this._dom.createChildOf(n,"td","lh-table-column--empty")}return n}_renderTableRowsFromItem(e,t){const n=this._dom.createFragment();if(n.append(this._renderTableRow(e,t)),!e.subItems)return n;const i=t.map(this._getDerivedsubItemsHeading);if(!i.some(Boolean))return n;for(const r of e.subItems.items){const e=this._renderTableRow(r,i);e.classList.add("lh-sub-item-row"),n.append(e)}return n}_renderTable(e){if(!e.items.length)return this._dom.createElement("span");const t=this._dom.createElement("table","lh-table"),n=this._dom.createChildOf(t,"thead"),i=this._dom.createChildOf(n,"tr"),r=this._getCanonicalizedHeadingsFromTable(e);for(const a of r){const e=`lh-table-column--${a.valueType||"text"}`,t=this._dom.createElement("div","lh-text");t.textContent=a.label,this._dom.createChildOf(i,"th",e).appendChild(t)}const s=this._dom.createChildOf(t,"tbody");let o=!0;for(const a of e.items){const e=this._renderTableRowsFromItem(a,r);for(const t of this._dom.findAll("tr",e))t.classList.add(o?"lh-row--even":"lh-row--odd");o=!o,s.append(e)}return t}_renderList(e){const t=this._dom.createElement("div","lh-list");return e.items.forEach((e=>{const n=SnippetRenderer.render(this._dom,this._templateContext,e,this);t.appendChild(n)})),t}renderNode(e){const t=this._dom.createElement("span","lh-node");if(e.nodeLabel){const n=this._dom.createElement("div");n.textContent=e.nodeLabel,t.appendChild(n)}if(e.snippet){const n=this._dom.createElement("div");n.classList.add("lh-node__snippet"),n.textContent=e.snippet,t.appendChild(n)}if(e.selector&&(t.title=e.selector),e.path&&t.setAttribute("data-path",e.path),e.selector&&t.setAttribute("data-selector",e.selector),e.snippet&&t.setAttribute("data-snippet",e.snippet),!this._fullPageScreenshot)return t;const n=e.lhId&&this._fullPageScreenshot.nodes[e.lhId];if(!n||0===n.width||0===n.height)return t;const i=ElementScreenshotRenderer.render(this._dom,this._templateContext,this._fullPageScreenshot.screenshot,n,{width:147,height:100});return i&&t.prepend(i),t}renderSourceLocation(e){if(!e.url)return null;const t=`${e.url}:${e.line+1}:${e.column}`;let n,i;if(e.original){n=`${e.original.file||"<unmapped>"}:${e.original.line+1}:${e.original.column}`}if("network"===e.urlProvider&&n)i=this._renderLink({url:e.url,text:n}),i.title=`maps to generated location ${t}`;else if("network"!==e.urlProvider||n)if("comment"===e.urlProvider&&n)i=this._renderText(`${n} (from source map)`),i.title=`${t} (from sourceURL)`;else{if("comment"!==e.urlProvider||n)return null;i=this._renderText(`${t} (from sourceURL)`)}else i=this.renderTextURL(e.url),this._dom.find(".lh-link",i).textContent+=`:${e.line+1}:${e.column}`;return i.classList.add("lh-source-location"),i.setAttribute("data-source-url",e.url),i.setAttribute("data-source-line",String(e.line)),i.setAttribute("data-source-column",String(e.column)),i}_renderFilmstrip(e){const t=this._dom.createElement("div","lh-filmstrip");for(const n of e.items){const e=this._dom.createChildOf(t,"div","lh-filmstrip__frame");this._dom.createChildOf(e,"img","lh-filmstrip__thumbnail",{src:n.data,alt:"Screenshot"})}return t}_renderCode(e){const t=this._dom.createElement("pre","lh-code");return t.textContent=e,t}}"undefined"!==typeof module&&module.exports?module.exports=DetailsRenderer:self.DetailsRenderer=DetailsRenderer;class CriticalRequestChainRenderer{static initTree(e){let t=0;const n=Object.keys(e);if(n.length>0){t=e[n[0]].request.startTime}return{tree:e,startTime:t,transferSize:0}}static createSegment(e,t,n,i,r,s){const o=e[t],a=Object.keys(e),l=a.indexOf(t)===a.length-1,d=!!o.children&&Object.keys(o.children).length>0,c=Array.isArray(r)?r.slice(0):[];return"undefined"!==typeof s&&c.push(!s),{node:o,isLastChild:l,hasChildren:d,startTime:n,transferSize:i+o.request.transferSize,treeMarkers:c}}static createChainNode(e,t,n,i){const r=e.cloneTemplate("#tmpl-lh-crc__chains",t);e.find(".crc-node",r).setAttribute("title",n.node.request.url);const s=e.find(".crc-node__tree-marker",r);n.treeMarkers.forEach((t=>{t?(s.appendChild(e.createElement("span","tree-marker vert")),s.appendChild(e.createElement("span","tree-marker"))):(s.appendChild(e.createElement("span","tree-marker")),s.appendChild(e.createElement("span","tree-marker")))})),n.isLastChild?(s.appendChild(e.createElement("span","tree-marker up-right")),s.appendChild(e.createElement("span","tree-marker right"))):(s.appendChild(e.createElement("span","tree-marker vert-right")),s.appendChild(e.createElement("span","tree-marker right"))),n.hasChildren?s.appendChild(e.createElement("span","tree-marker horiz-down")):s.appendChild(e.createElement("span","tree-marker right"));const o=n.node.request.url,a=i.renderTextURL(o),l=e.find(".crc-node__tree-value",r);if(l.appendChild(a),!n.hasChildren){const{startTime:t,endTime:i,transferSize:r}=n.node.request,s=e.createElement("span","crc-node__chain-duration");s.textContent=" - "+Util.i18n.formatMilliseconds(1e3*(i-t))+", ";const o=e.createElement("span","crc-node__chain-duration");o.textContent=Util.i18n.formatBytesToKiB(r,.01),l.appendChild(s),l.appendChild(o)}return r}static buildTree(e,t,n,i,r,s){if(i.appendChild(CRCRenderer.createChainNode(e,t,n,s)),n.node.children)for(const o of Object.keys(n.node.children)){const a=CRCRenderer.createSegment(n.node.children,o,n.startTime,n.transferSize,n.treeMarkers,n.isLastChild);CRCRenderer.buildTree(e,t,a,i,r,s)}}static render(e,t,n,i){const r=e.cloneTemplate("#tmpl-lh-crc",t),s=e.find(".lh-crc",r);e.find(".crc-initial-nav",r).textContent=Util.i18n.strings.crcInitialNavigation,e.find(".lh-crc__longest_duration_label",r).textContent=Util.i18n.strings.crcLongestDurationLabel,e.find(".lh-crc__longest_duration",r).textContent=Util.i18n.formatMilliseconds(n.longestChain.duration);const o=CRCRenderer.initTree(n.chains);for(const a of Object.keys(o.tree)){const t=CRCRenderer.createSegment(o.tree,a,o.startTime,o.transferSize);CRCRenderer.buildTree(e,r,t,s,n,i)}return e.find(".lh-crc-container",r)}}const CRCRenderer=CriticalRequestChainRenderer;"undefined"!==typeof module&&module.exports?module.exports=CriticalRequestChainRenderer:self.CriticalRequestChainRenderer=CriticalRequestChainRenderer;const LineVisibility={ALWAYS:0,WHEN_COLLAPSED:1,WHEN_EXPANDED:2},LineContentType={CONTENT_NORMAL:0,CONTENT_HIGHLIGHTED:1,PLACEHOLDER:2,MESSAGE:3},classNamesByContentType={[LineContentType.CONTENT_NORMAL]:["lh-snippet__line--content"],[LineContentType.CONTENT_HIGHLIGHTED]:["lh-snippet__line--content","lh-snippet__line--content-highlighted"],[LineContentType.PLACEHOLDER]:["lh-snippet__line--placeholder"],[LineContentType.MESSAGE]:["lh-snippet__line--message"]};function getLineAndPreviousLine(e,t){return{line:e.find((e=>e.lineNumber===t)),previousLine:e.find((e=>e.lineNumber===t-1))}}function getMessagesForLineNumber(e,t){return e.filter((e=>e.lineNumber===t))}function getLinesWhenCollapsed(e){return Util.filterRelevantLines(e.lines,e.lineMessages,2)}class SnippetRenderer{static renderHeader(e,t,n,i,r){const s=getLinesWhenCollapsed(n).length<n.lines.length,o=e.cloneTemplate("#tmpl-lh-snippet__header",t);e.find(".lh-snippet__title",o).textContent=n.title;const{snippetCollapseButtonLabel:a,snippetExpandButtonLabel:l}=Util.i18n.strings;e.find(".lh-snippet__btn-label-collapse",o).textContent=a,e.find(".lh-snippet__btn-label-expand",o).textContent=l;const d=e.find(".lh-snippet__toggle-expand",o);if(s?d.addEventListener("click",(()=>r())):d.remove(),n.node&&e.isDevTools()){e.find(".lh-snippet__node",o).appendChild(i.renderNode(n.node))}return o}static renderSnippetLine(e,t,{content:n,lineNumber:i,truncated:r,contentType:s,visibility:o}){const a=e.cloneTemplate("#tmpl-lh-snippet__line",t),l=e.find(".lh-snippet__line",a),{classList:d}=l;classNamesByContentType[s].forEach((e=>d.add(e))),o===LineVisibility.WHEN_COLLAPSED?d.add("lh-snippet__show-if-collapsed"):o===LineVisibility.WHEN_EXPANDED&&d.add("lh-snippet__show-if-expanded");const c=n+(r?"\u2026":""),h=e.find(".lh-snippet__line code",l);return s===LineContentType.MESSAGE?h.appendChild(e.convertMarkdownLinkSnippets(c)):h.textContent=c,e.find(".lh-snippet__line-number",l).textContent=i.toString(),l}static renderMessage(e,t,n){return SnippetRenderer.renderSnippetLine(e,t,{lineNumber:" ",content:n.message,contentType:LineContentType.MESSAGE})}static renderOmittedLinesPlaceholder(e,t,n){return SnippetRenderer.renderSnippetLine(e,t,{lineNumber:"\u2026",content:"",visibility:n,contentType:LineContentType.PLACEHOLDER})}static renderSnippetContent(e,t,n){const i=e.cloneTemplate("#tmpl-lh-snippet__content",t),r=e.find(".lh-snippet__snippet-inner",i);return n.generalMessages.forEach((n=>r.append(SnippetRenderer.renderMessage(e,t,n)))),r.append(SnippetRenderer.renderSnippetLines(e,t,n)),i}static renderSnippetLines(e,t,n){const{lineMessages:i,generalMessages:r,lineCount:s,lines:o}=n,a=getLinesWhenCollapsed(n),l=r.length>0&&0===i.length,d=e.createFragment();let c=!1;for(let h=1;h<=s;h++){const{line:n,previousLine:r}=getLineAndPreviousLine(o,h),{line:s,previousLine:u}=getLineAndPreviousLine(a,h),p=!!s;!!u&&!p&&(c=!0),p&&c&&(d.append(SnippetRenderer.renderOmittedLinesPlaceholder(e,t,LineVisibility.WHEN_COLLAPSED)),c=!1);const m=!n&&1===h;if(!n&&!!r||m){const n=!a.some((e=>e.lineNumber>h))||1===h;d.append(SnippetRenderer.renderOmittedLinesPlaceholder(e,t,n?LineVisibility.WHEN_EXPANDED:LineVisibility.ALWAYS)),c=!1}if(!n)continue;const g=getMessagesForLineNumber(i,h),f=g.length>0||l,_=Object.assign({},n,{contentType:f?LineContentType.CONTENT_HIGHLIGHTED:LineContentType.CONTENT_NORMAL,visibility:s?LineVisibility.ALWAYS:LineVisibility.WHEN_EXPANDED});d.append(SnippetRenderer.renderSnippetLine(e,t,_)),g.forEach((n=>{d.append(SnippetRenderer.renderMessage(e,t,n))}))}return d}static render(e,t,n,i){const r=e.cloneTemplate("#tmpl-lh-snippet",t),s=e.find(".lh-snippet",r),o=SnippetRenderer.renderHeader(e,r,n,i,(()=>s.classList.toggle("lh-snippet--expanded"))),a=SnippetRenderer.renderSnippetContent(e,r,n);return s.append(o,a),s}}function screenshotOverlapsRect(e,t){return t.left<=e.width&&0<=t.right&&t.top<=e.height&&0<=t.bottom}function clamp(e,t,n){return e<t?t:e>n?n:e}function getRectCenterPoint(e){return{x:e.left+e.width/2,y:e.top+e.height/2}}"undefined"!==typeof module&&module.exports?module.exports=SnippetRenderer:self.SnippetRenderer=SnippetRenderer;class ElementScreenshotRenderer{static getScreenshotPositions(e,t,n){const i=getRectCenterPoint(e),r=clamp(i.x-t.width/2,0,n.width-t.width),s=clamp(i.y-t.height/2,0,n.height-t.height);return{screenshot:{left:r,top:s},clip:{left:e.left-r,top:e.top-s}}}static renderClipPathInScreenshot(e,t,n,i,r){const s=e.find("clipPath",t),o=`clip-${Util.getUniqueSuffix()}`;s.id=o,t.style.clipPath=`url(#${o})`;const a=n.top/r.height,l=a+i.height/r.height,d=n.left/r.width,c=d+i.width/r.width,h=[`0,0             1,0            1,${a}          0,${a}`,`0,${l}     1,${l}    1,1               0,1`,`0,${a}        ${d},${a} ${d},${l} 0,${l}`,`${c},${a} 1,${a}       1,${l}       ${c},${l}`];for(const u of h)s.append(e.createElementNS("http://www.w3.org/2000/svg","polygon",void 0,{points:u}))}static createBackgroundImageStyle(e,t){const n=e.createElement("style");return n.id="full-page-screenshot-style",n.textContent=`\n      .lh-element-screenshot__image {\n        background-image: url(${t.data})\n      }`,n}static installOverlayFeature(e,t,n){const i=e.find(".lh-root",e.document());if(!i)return void console.warn("No lh-root. Overlay install failed.");const r="lh-screenshot-overlay--enabled";i.classList.contains(r)||(i.classList.add(r),i.addEventListener("click",(r=>{const s=r.target;if(!s)return;const o=s.closest(".lh-node > .lh-element-screenshot");if(!o)return;const a=e.createElement("div","lh-element-screenshot__overlay");i.append(a);const l={width:.95*a.clientWidth,height:.8*a.clientHeight},d={width:Number(o.dataset.rectWidth),height:Number(o.dataset.rectHeight),left:Number(o.dataset.rectLeft),right:Number(o.dataset.rectLeft)+Number(o.dataset.rectWidth),top:Number(o.dataset.rectTop),bottom:Number(o.dataset.rectTop)+Number(o.dataset.rectHeight)},c=ElementScreenshotRenderer.render(e,t,n.screenshot,d,l);c?(a.appendChild(c),a.addEventListener("click",(()=>a.remove()))):a.remove()})))}static _computeZoomFactor(e,t){const n={x:t.width/e.width,y:t.height/e.height},i=.75*Math.min(n.x,n.y);return Math.min(1,i)}static render(e,t,n,i,r){if(!screenshotOverlapsRect(n,i))return null;const s=e.cloneTemplate("#tmpl-lh-element-screenshot",t),o=e.find("div.lh-element-screenshot",s);o.dataset.rectWidth=i.width.toString(),o.dataset.rectHeight=i.height.toString(),o.dataset.rectLeft=i.left.toString(),o.dataset.rectTop=i.top.toString();const a=this._computeZoomFactor(i,r),l={width:r.width/a,height:r.height/a};l.width=Math.min(n.width,l.width);const d=l.width*a,c=l.height*a,h=ElementScreenshotRenderer.getScreenshotPositions(i,l,{width:n.width,height:n.height});e.find("div.lh-element-screenshot__content",o).style.top=`-${c}px`;const u=e.find("div.lh-element-screenshot__image",o);u.style.width=d+"px",u.style.height=c+"px",u.style.backgroundPositionY=-h.screenshot.top*a+"px",u.style.backgroundPositionX=-h.screenshot.left*a+"px",u.style.backgroundSize=`${n.width*a}px ${n.height*a}px`;const p=e.find("div.lh-element-screenshot__element-marker",o);p.style.width=i.width*a+"px",p.style.height=i.height*a+"px",p.style.left=h.clip.left*a+"px",p.style.top=h.clip.top*a+"px";const m=e.find("div.lh-element-screenshot__mask",o);return m.style.width=d+"px",m.style.height=c+"px",ElementScreenshotRenderer.renderClipPathInScreenshot(e,m,h.clip,i,l),o}}function getFilenamePrefix(e){const t=new URL(e.finalUrl).hostname,n=e.fetchTime&&new Date(e.fetchTime)||new Date,i=n.toLocaleTimeString("en-US",{hour12:!1}),r=n.toLocaleDateString("en-US",{year:"numeric",month:"2-digit",day:"2-digit"}).split("/");r.unshift(r.pop());return`${t}_${r.join("-")}_${i}`.replace(/[/?<>\\:*|"]/g,"-")}"undefined"!==typeof module&&module.exports?module.exports=ElementScreenshotRenderer:self.ElementScreenshotRenderer=ElementScreenshotRenderer,"undefined"!==typeof module&&module.exports&&(module.exports={getFilenamePrefix:getFilenamePrefix});class Logger{constructor(e){this.el=e,this._id=void 0}log(e,t=!0){this._id&&clearTimeout(this._id),this.el.textContent=e,this.el.classList.add("show"),t&&(this._id=setTimeout((e=>{this.el.classList.remove("show")}),7e3))}warn(e){this.log("Warning: "+e)}error(e){this.log(e),setTimeout((t=>{throw new Error(e)}),0)}hide(){this._id&&clearTimeout(this._id),this.el.classList.remove("show")}}function getTableRows(e){return Array.from(e.tBodies[0].rows)}function getAppsOrigin(){const e=window.location.host.endsWith(".vercel.app"),t=new URLSearchParams(window.location.search).has("dev");return e?`https://${window.location.host}/gh-pages`:t?"http://localhost:8000":"https://googlechrome.github.io/lighthouse"}"undefined"!==typeof module&&module.exports&&(module.exports=Logger);class ReportUIFeatures{constructor(e){this.json,this._dom=e,this._document=this._dom.document(),this._templateContext=this._dom.document(),this._dropDown=new DropDown(this._dom),this._copyAttempt=!1,this.topbarEl,this.scoreScaleEl,this.stickyHeaderEl,this.highlightEl,this.onMediaQueryChange=this.onMediaQueryChange.bind(this),this.onCopy=this.onCopy.bind(this),this.onDropDownMenuClick=this.onDropDownMenuClick.bind(this),this.onKeyUp=this.onKeyUp.bind(this),this.collapseAllDetails=this.collapseAllDetails.bind(this),this.expandAllDetails=this.expandAllDetails.bind(this),this._toggleDarkTheme=this._toggleDarkTheme.bind(this),this._updateStickyHeaderOnScroll=this._updateStickyHeaderOnScroll.bind(this)}initFeatures(e){this.json=e,this._setupMediaQueryListeners(),this._dropDown.setup(this.onDropDownMenuClick),this._setupThirdPartyFilter(),this._setupElementScreenshotOverlay(),this._setUpCollapseDetailsAfterPrinting(),this._resetUIState(),this._document.addEventListener("keyup",this.onKeyUp),this._document.addEventListener("copy",this.onCopy);this._dom.find(".lh-topbar__logo",this._document).addEventListener("click",(()=>this._toggleDarkTheme()));let t=!1;!this._dom.isDevTools()&&window.matchMedia("(prefers-color-scheme: dark)").matches&&(t=!0);if(["performance","accessibility","best-practices","seo"].every((t=>{const n=e.categories[t];return n&&1===n.score}))&&(t=!0,this._enableFireworks()),t&&this._toggleDarkTheme(!0),Object.keys(this.json.categories).length>=2){this._setupStickyHeaderElements();const e=this._dom.find(".lh-container",this._document);if(this._getScrollParent(e).addEventListener("scroll",this._updateStickyHeaderOnScroll),this._dom.isDevTools()){new window.ResizeObserver(this._updateStickyHeaderOnScroll).observe(e)}else window.addEventListener("resize",this._updateStickyHeaderOnScroll)}if(e.categories.performance&&e.categories.performance.auditRefs.some((t=>Boolean("metrics"===t.group&&e.audits[t.id].errorMessage)))){this._dom.find("input.lh-metrics-toggle__input",this._document).checked=!0}for(const n of this._dom.findAll("[data-i18n]",this._dom.document())){const e=n.getAttribute("data-i18n");n.textContent=Util.i18n.strings[e]}}setTemplateContext(e){this._templateContext=e}_getScrollParent(e){const{overflowY:t}=window.getComputedStyle(e);return"visible"!==t&&"hidden"!==t?e:e.parentElement?this._getScrollParent(e.parentElement):document}_enableFireworks(){const e=this._dom.find(".lh-scores-container",this._document);e.classList.add("score100"),e.addEventListener("click",(t=>{e.classList.toggle("fireworks-paused")}))}_fireEventOn(e,t=this._document,n){const i=new CustomEvent(e,n?{detail:n}:void 0);t.dispatchEvent(i)}_setupMediaQueryListeners(){const e=self.matchMedia("(max-width: 500px)");e.addListener(this.onMediaQueryChange),this.onMediaQueryChange(e)}onMediaQueryChange(e){this._dom.find(".lh-root",this._document).classList.toggle("lh-narrow",e.matches)}_setupThirdPartyFilter(){const e=["uses-rel-preconnect","third-party-facades"],t=["legacy-javascript"];Array.from(this._document.querySelectorAll("table.lh-table")).filter((e=>e.querySelector("td.lh-table-column--url, td.lh-table-column--source-location"))).filter((t=>{const n=t.closest(".lh-audit");if(!n)throw new Error(".lh-table not within audit");return!e.includes(n.id)})).forEach(((e,n)=>{const i=getTableRows(e),r=this._getThirdPartyRows(i,this.json.finalUrl),s=this._dom.cloneTemplate("#tmpl-lh-3p-filter",this._templateContext),o=this._dom.find("input",s),a=`lh-3p-filter-label--${n}`;o.id=a,o.addEventListener("change",(e=>{const t=e.target instanceof HTMLInputElement&&!e.target.checked;let n=!0,s=i[0];for(;s;){const e=t&&r.includes(s);do{s.classList.toggle("lh-row--hidden",e),s.classList.toggle("lh-row--even",!e&&n),s.classList.toggle("lh-row--odd",!e&&!n),s=s.nextElementSibling}while(s&&s.classList.contains("lh-sub-item-row"));e||(n=!n)}})),this._dom.find("label",s).setAttribute("for",a),this._dom.find(".lh-3p-filter-count",s).textContent=`${r.length}`,this._dom.find(".lh-3p-ui-string",s).textContent=Util.i18n.strings.thirdPartyResourcesLabel;const l=r.length===i.length,d=!r.length;if((l||d)&&(o.disabled=!0,o.checked=l),!e.parentNode)return;e.parentNode.insertBefore(s,e);const c=e.closest(".lh-audit");if(!c)throw new Error(".lh-table not within audit");t.includes(c.id)&&!l&&o.click()}))}_setupElementScreenshotOverlay(){const e=this.json.audits["full-page-screenshot"]&&this.json.audits["full-page-screenshot"].details&&"full-page-screenshot"===this.json.audits["full-page-screenshot"].details.type&&this.json.audits["full-page-screenshot"].details;e&&ElementScreenshotRenderer.installOverlayFeature(this._dom,this._templateContext,e)}_getThirdPartyRows(e,t){const n=[],i=Util.getRootDomain(t);for(const r of e){if(r.classList.contains("lh-sub-item-row"))continue;const e=r.querySelector("div.lh-text__url");if(!e)continue;const t=e.dataset.url;if(!t)continue;Util.getRootDomain(t)!==i&&n.push(r)}return n}_setupStickyHeaderElements(){this.topbarEl=this._dom.find("div.lh-topbar",this._document),this.scoreScaleEl=this._dom.find("div.lh-scorescale",this._document),this.stickyHeaderEl=this._dom.find("div.lh-sticky-header",this._document),this.highlightEl=this._dom.createChildOf(this.stickyHeaderEl,"div","lh-highlighter")}onCopy(e){this._copyAttempt&&e.clipboardData&&(e.preventDefault(),e.clipboardData.setData("text/plain",JSON.stringify(this.json,null,2)),this._fireEventOn("lh-log",this._document,{cmd:"log",msg:"Report JSON copied to clipboard"})),this._copyAttempt=!1}onCopyButtonClick(){this._fireEventOn("lh-analytics",this._document,{cmd:"send",fields:{hitType:"event",eventCategory:"report",eventAction:"copy"}});try{this._document.queryCommandSupported("copy")&&(this._copyAttempt=!0,this._document.execCommand("copy")||(this._copyAttempt=!1,this._fireEventOn("lh-log",this._document,{cmd:"warn",msg:"Your browser does not support copy to clipboard."})))}catch(e){this._copyAttempt=!1,this._fireEventOn("lh-log",this._document,{cmd:"log",msg:e.message})}}_resetUIState(){this._dropDown.close(),this._dom.resetTemplates()}onDropDownMenuClick(e){e.preventDefault();const t=e.target;if(t&&t.hasAttribute("data-action")){switch(t.getAttribute("data-action")){case"copy":this.onCopyButtonClick();break;case"print-summary":this.collapseAllDetails(),this._print();break;case"print-expanded":this.expandAllDetails(),this._print();break;case"save-json":{const e=JSON.stringify(this.json,null,2);this._saveFile(new Blob([e],{type:"application/json"}));break}case"save-html":{const t=this.getReportHtml();try{this._saveFile(new Blob([t],{type:"text/html"}))}catch(e){this._fireEventOn("lh-log",this._document,{cmd:"error",msg:"Could not export as HTML. "+e.message})}break}case"open-viewer":ReportUIFeatures.openTabAndSendJsonReportToViewer(this.json);break;case"save-gist":this.saveAsGist();break;case"toggle-dark":this._toggleDarkTheme()}this._dropDown.close()}}_print(){self.print()}onKeyUp(e){(e.ctrlKey||e.metaKey)&&80===e.keyCode&&this._dropDown.close()}static openTabAndSendJsonReportToViewer(e){const t=e.generatedTime,n=e.fetchTime||t,i=`${e.lighthouseVersion}-${e.requestedUrl}-${n}`,r=getAppsOrigin()+"/viewer/";ReportUIFeatures.openTabAndSendData({lhr:e},r,i)}static openTreemap(e){if(!e.audits["script-treemap-data"].details)throw new Error("no script treemap data found");const t=`treemap-${e.requestedUrl}`,n={lhr:e},i=getAppsOrigin()+"/treemap/";ReportUIFeatures.openTabAndSendData(n,i,t)}static openTabAndSendData(e,t,n){const i=new URL(t).origin;window.addEventListener("message",(function t(n){n.origin===i&&r&&n.data.opened&&(r.postMessage(e,i),window.removeEventListener("message",t))}));const r=window.open(t,n)}expandAllDetails(){this._dom.findAll(".lh-categories details",this._document).map((e=>e.open=!0))}collapseAllDetails(){this._dom.findAll(".lh-categories details",this._document).map((e=>e.open=!1))}_setUpCollapseDetailsAfterPrinting(){"onbeforeprint"in self?self.addEventListener("afterprint",this.collapseAllDetails):self.matchMedia("print").addListener((e=>{e.matches?this.expandAllDetails():this.collapseAllDetails()}))}getReportHtml(){return this._resetUIState(),this._document.documentElement.outerHTML}saveAsGist(){throw new Error("Cannot save as gist from base report")}_saveFile(e){const t=getFilenamePrefix({finalUrl:this.json.finalUrl,fetchTime:this.json.fetchTime}),n=e.type.match("json")?".json":".html",i=URL.createObjectURL(e),r=this._dom.createElement("a");r.download=`${t}${n}`,r.href=i,this._document.body.appendChild(r),r.click(),this._document.body.removeChild(r),setTimeout((e=>URL.revokeObjectURL(i)),500)}_toggleDarkTheme(e){const t=this._dom.find(".lh-vars",this._document);"undefined"===typeof e?t.classList.toggle("dark"):t.classList.toggle("dark",e)}_updateStickyHeaderOnScroll(){const e=this.topbarEl.getBoundingClientRect().bottom>=this.scoreScaleEl.getBoundingClientRect().top,t=Array.from(this._document.querySelectorAll(".lh-category")).filter((e=>e.getBoundingClientRect().top-window.innerHeight/2<0)),n=t.length>0?t.length-1:0,i=this.stickyHeaderEl.querySelectorAll(".lh-gauge__wrapper"),r=i[n],s=i[0].getBoundingClientRect().left,o=r.getBoundingClientRect().left-s;this.highlightEl.style.transform=`translate(${o}px)`,this.stickyHeaderEl.classList.toggle("lh-sticky-header--visible",e)}}class DropDown{constructor(e){this._dom=e,this._toggleEl,this._menuEl,this.onDocumentKeyDown=this.onDocumentKeyDown.bind(this),this.onToggleClick=this.onToggleClick.bind(this),this.onToggleKeydown=this.onToggleKeydown.bind(this),this.onMenuFocusOut=this.onMenuFocusOut.bind(this),this.onMenuKeydown=this.onMenuKeydown.bind(this),this._getNextMenuItem=this._getNextMenuItem.bind(this),this._getNextSelectableNode=this._getNextSelectableNode.bind(this),this._getPreviousMenuItem=this._getPreviousMenuItem.bind(this)}setup(e){this._toggleEl=this._dom.find("button.lh-tools__button",this._dom.document()),this._toggleEl.addEventListener("click",this.onToggleClick),this._toggleEl.addEventListener("keydown",this.onToggleKeydown),this._menuEl=this._dom.find("div.lh-tools__dropdown",this._dom.document()),this._menuEl.addEventListener("keydown",this.onMenuKeydown),this._menuEl.addEventListener("click",e)}close(){this._toggleEl.classList.remove("active"),this._toggleEl.setAttribute("aria-expanded","false"),this._menuEl.contains(this._dom.document().activeElement)&&this._toggleEl.focus(),this._menuEl.removeEventListener("focusout",this.onMenuFocusOut),this._dom.document().removeEventListener("keydown",this.onDocumentKeyDown)}open(e){this._toggleEl.classList.contains("active")?e.focus():this._menuEl.addEventListener("transitionend",(()=>{e.focus()}),{once:!0}),this._toggleEl.classList.add("active"),this._toggleEl.setAttribute("aria-expanded","true"),this._menuEl.addEventListener("focusout",this.onMenuFocusOut),this._dom.document().addEventListener("keydown",this.onDocumentKeyDown)}onToggleClick(e){e.preventDefault(),e.stopImmediatePropagation(),this._toggleEl.classList.contains("active")?this.close():this.open(this._getNextMenuItem())}onToggleKeydown(e){switch(e.code){case"ArrowUp":e.preventDefault(),this.open(this._getPreviousMenuItem());break;case"ArrowDown":case"Enter":case" ":e.preventDefault(),this.open(this._getNextMenuItem())}}onMenuKeydown(e){const t=e.target;switch(e.code){case"ArrowUp":e.preventDefault(),this._getPreviousMenuItem(t).focus();break;case"ArrowDown":e.preventDefault(),this._getNextMenuItem(t).focus();break;case"Home":e.preventDefault(),this._getNextMenuItem().focus();break;case"End":e.preventDefault(),this._getPreviousMenuItem().focus()}}onDocumentKeyDown(e){27===e.keyCode&&this.close()}onMenuFocusOut(e){const t=e.relatedTarget;this._menuEl.contains(t)||this.close()}_getNextSelectableNode(e,t){const n=e.filter((e=>e instanceof HTMLElement&&(!e.hasAttribute("disabled")&&"none"!==window.getComputedStyle(e).display)));let i=t?n.indexOf(t)+1:0;return i>=n.length&&(i=0),n[i]}_getNextMenuItem(e){const t=Array.from(this._menuEl.childNodes);return this._getNextSelectableNode(t,e)}_getPreviousMenuItem(e){const t=Array.from(this._menuEl.childNodes).reverse();return this._getNextSelectableNode(t,e)}}"undefined"!==typeof module&&module.exports?module.exports=ReportUIFeatures:self.ReportUIFeatures=ReportUIFeatures;class CategoryRenderer{constructor(e,t){this.dom=e,this.detailsRenderer=t,this.templateContext=this.dom.document(),this.detailsRenderer.setTemplateContext(this.templateContext)}get _clumpTitles(){return{warning:Util.i18n.strings.warningAuditsGroupTitle,manual:Util.i18n.strings.manualAuditsGroupTitle,passed:Util.i18n.strings.passedAuditsGroupTitle,notApplicable:Util.i18n.strings.notApplicableAuditsGroupTitle}}renderAudit(e){const t=this.dom.cloneTemplate("#tmpl-lh-audit",this.templateContext);return this.populateAuditValues(e,t)}populateAuditValues(e,t){const n=Util.i18n.strings,i=this.dom.find(".lh-audit",t);i.id=e.result.id;const r=e.result.scoreDisplayMode;e.result.displayValue&&(this.dom.find(".lh-audit__display-text",i).textContent=e.result.displayValue);const s=this.dom.find(".lh-audit__title",i);s.appendChild(this.dom.convertMarkdownCodeSnippets(e.result.title)),this.dom.find(".lh-audit__description",i).appendChild(this.dom.convertMarkdownLinkSnippets(e.result.description)),e.stackPacks&&e.stackPacks.forEach((e=>{const t=this.dom.createElement("div");t.classList.add("lh-audit__stackpack");const n=this.dom.createElement("img");n.classList.add("lh-audit__stackpack__img"),n.src=e.iconDataURL,n.alt=e.title,t.appendChild(n),t.appendChild(this.dom.convertMarkdownLinkSnippets(e.description)),this.dom.find(".lh-audit__stackpacks",i).appendChild(t)}));const o=this.dom.find("details",i);if(e.result.details){const t=this.detailsRenderer.render(e.result.details);t&&(t.classList.add("lh-details"),o.appendChild(t))}if(this.dom.find(".lh-chevron-container",i).appendChild(this._createChevron()),this._setRatingClass(i,e.result.score,r),"error"===e.result.scoreDisplayMode){i.classList.add("lh-audit--error");const t=this.dom.find(".lh-audit__display-text",i);t.textContent=n.errorLabel,t.classList.add("tooltip-boundary");this.dom.createChildOf(t,"div","tooltip tooltip--error").textContent=e.result.errorMessage||n.errorMissingAuditInfo}else if(e.result.explanation){this.dom.createChildOf(s,"div","lh-audit-explanation").textContent=e.result.explanation}const a=e.result.warnings;if(!a||0===a.length)return i;const l=this.dom.find("summary",o),d=this.dom.createChildOf(l,"div","lh-warnings");if(this.dom.createChildOf(d,"span").textContent=n.warningHeader,1===a.length)d.appendChild(this.dom.document().createTextNode(a.join("")));else{const e=this.dom.createChildOf(d,"ul");for(const t of a){this.dom.createChildOf(e,"li").textContent=t}}return i}_createChevron(){const e=this.dom.cloneTemplate("#tmpl-lh-chevron",this.templateContext);return this.dom.find("svg.lh-chevron",e)}_setRatingClass(e,t,n){const i=Util.calculateRating(t,n);return e.classList.add(`lh-audit--${n.toLowerCase()}`),"informative"!==n&&e.classList.add(`lh-audit--${i}`),e}renderCategoryHeader(e,t){const n=this.dom.cloneTemplate("#tmpl-lh-category-header",this.templateContext),i=this.dom.find(".lh-score__gauge",n),r=this.renderScoreGauge(e,t);if(i.appendChild(r),e.description){const t=this.dom.convertMarkdownLinkSnippets(e.description);this.dom.find(".lh-category-header__description",n).appendChild(t)}return n}renderAuditGroup(e){const t=this.dom.createElement("div","lh-audit-group"),n=this.dom.createElement("div","lh-audit-group__header");if(this.dom.createChildOf(n,"span","lh-audit-group__title").textContent=e.title,e.description){const t=this.dom.convertMarkdownLinkSnippets(e.description);t.classList.add("lh-audit-group__description"),n.appendChild(t)}return t.appendChild(n),t}_renderGroupedAudits(e,t){const n=new Map,i="NotAGroup";n.set(i,[]);for(const s of e){const e=s.group||i,t=n.get(e)||[];t.push(s),n.set(e,t)}const r=[];for(const[s,o]of n){if(s===i){for(const e of o)r.push(this.renderAudit(e));continue}const e=t[s],n=this.renderAuditGroup(e);for(const t of o)n.appendChild(this.renderAudit(t));n.classList.add(`lh-audit-group--${s}`),r.push(n)}return r}renderUnexpandableClump(e,t){const n=this.dom.createElement("div");return this._renderGroupedAudits(e,t).forEach((e=>n.appendChild(e))),n}renderClump(e,{auditRefs:t,description:n}){const i=this.dom.cloneTemplate("#tmpl-lh-clump",this.templateContext),r=this.dom.find(".lh-clump",i);"warning"===e&&r.setAttribute("open","");this.dom.find("div.lh-audit-group__summary",r).appendChild(this._createChevron());const s=this.dom.find(".lh-audit-group__header",r),o=this._clumpTitles[e];if(this.dom.find(".lh-audit-group__title",s).textContent=o,n){const e=this.dom.convertMarkdownLinkSnippets(n);e.classList.add("lh-audit-group__description"),s.appendChild(e)}this.dom.find(".lh-audit-group__itemcount",r).textContent=`(${t.length})`;const a=t.map(this.renderAudit.bind(this));return r.append(...a),r.classList.add(`lh-clump--${e.toLowerCase()}`),r}setTemplateContext(e){this.templateContext=e,this.detailsRenderer.setTemplateContext(e)}renderScoreGauge(e,t){const n=this.dom.cloneTemplate("#tmpl-lh-gauge",this.templateContext),i=this.dom.find("a.lh-gauge__wrapper",n);i.href=`#${e.id}`,Util.isPluginCategory(e.id)&&i.classList.add("lh-gauge__wrapper--plugin");const r=Number(e.score),s=this.dom.find(".lh-gauge",n),o=this.dom.find("circle.lh-gauge-arc",s);o&&this._setGaugeArc(o,r);const a=Math.round(100*r),l=this.dom.find("div.lh-gauge__percentage",n);return l.textContent=a.toString(),null===e.score&&(l.textContent="?",l.title=Util.i18n.strings.errorLabel),0===e.auditRefs.length||this.hasApplicableAudits(e)?i.classList.add(`lh-gauge__wrapper--${Util.calculateRating(e.score)}`):(i.classList.add("lh-gauge__wrapper--not-applicable"),l.textContent="-",l.title=Util.i18n.strings.notApplicableAuditsGroupTitle),this.dom.find(".lh-gauge__label",n).textContent=e.title,n}hasApplicableAudits(e){return e.auditRefs.some((e=>"notApplicable"!==e.result.scoreDisplayMode))}_setGaugeArc(e,t){const n=2*Math.PI*Number(e.getAttribute("r")),i=Number(e.getAttribute("stroke-width")),r=.25*i/n;e.style.transform=`rotate(${360*r-90}deg)`;let s=t*n-i/2;0===t&&(e.style.opacity="0"),1===t&&(s=n),e.style.strokeDasharray=`${Math.max(s,0)} ${n}`}_auditHasWarning(e){return Boolean(e.result.warnings&&e.result.warnings.length)}_getClumpIdForAuditRef(e){const t=e.result.scoreDisplayMode;return"manual"===t||"notApplicable"===t?t:Util.showAsPassed(e.result)?this._auditHasWarning(e)?"warning":"passed":"failed"}render(e,t={}){const n=this.dom.createElement("div","lh-category");this.createPermalinkSpan(n,e.id),n.appendChild(this.renderCategoryHeader(e,t));const i=new Map;i.set("failed",[]),i.set("warning",[]),i.set("manual",[]),i.set("passed",[]),i.set("notApplicable",[]);for(const r of e.auditRefs){const e=this._getClumpIdForAuditRef(r),t=i.get(e);t.push(r),i.set(e,t)}for(const[r,s]of i){if(0===s.length)continue;if("failed"===r){const e=this.renderUnexpandableClump(s,t);e.classList.add("lh-clump--failed"),n.appendChild(e);continue}const i="manual"===r?e.manualDescription:void 0,o=this.renderClump(r,{auditRefs:s,description:i});n.appendChild(o)}return n}createPermalinkSpan(e,t){this.dom.createChildOf(e,"span","lh-permalink").id=t}}"undefined"!==typeof module&&module.exports?module.exports=CategoryRenderer:self.CategoryRenderer=CategoryRenderer;class PerformanceCategoryRenderer extends CategoryRenderer{_renderMetric(e){const t=this.dom.cloneTemplate("#tmpl-lh-metric",this.templateContext),n=this.dom.find(".lh-metric",t);n.id=e.result.id;const i=Util.calculateRating(e.result.score,e.result.scoreDisplayMode);n.classList.add(`lh-metric--${i}`);this.dom.find(".lh-metric__title",t).textContent=e.result.title;const r=this.dom.find(".lh-metric__value",t);r.textContent=e.result.displayValue||"";const s=this.dom.find(".lh-metric__description",t);if(s.appendChild(this.dom.convertMarkdownLinkSnippets(e.result.description)),"error"===e.result.scoreDisplayMode){s.textContent="",r.textContent="Error!";this.dom.createChildOf(s,"span").textContent=e.result.errorMessage||"Report error: no metric information"}return n}_renderOpportunity(e,t){const n=this.dom.cloneTemplate("#tmpl-lh-opportunity",this.templateContext),i=this.populateAuditValues(e,n);if(i.id=e.result.id,!e.result.details||"error"===e.result.scoreDisplayMode)return i;const r=e.result.details;if("opportunity"!==r.type)return i;const s=this.dom.find("span.lh-audit__display-text, div.lh-audit__display-text",i),o=r.overallSavingsMs/t*100+"%";if(this.dom.find("div.lh-sparkline__bar",i).style.width=o,s.textContent=Util.i18n.formatSeconds(r.overallSavingsMs,.01),e.result.displayValue){const t=e.result.displayValue;this.dom.find("div.lh-load-opportunity__sparkline",i).title=t,s.title=t}return i}_getWastedMs(e){if(e.result.details&&"opportunity"===e.result.details.type){const t=e.result.details;if("number"!==typeof t.overallSavingsMs)throw new Error("non-opportunity details passed to _getWastedMs");return t.overallSavingsMs}return Number.MIN_VALUE}_getScoringCalculatorHref(e){const t=e.filter((e=>"metrics"===e.group)),n=e.find((e=>"first-cpu-idle"===e.id)),i=e.find((e=>"first-meaningful-paint"===e.id));n&&t.push(n),i&&t.push(i);const r={"cumulative-layout-shift":"CLS","first-contentful-paint":"FCP","first-cpu-idle":"FCI","first-meaningful-paint":"FMP",interactive:"TTI","largest-contentful-paint":"LCP","speed-index":"SI","total-blocking-time":"TBT"},s=[...t.map((e=>{let t;var n;return"number"===typeof e.result.numericValue?(t="cumulative-layout-shift"===e.id?(n=e.result.numericValue,Math.round(100*n)/100):Math.round(e.result.numericValue),t=t.toString()):t="null",[r[e.id]||e.id,t]}))];Util.reportJson&&(s.push(["device",Util.reportJson.configSettings.formFactor]),s.push(["version",Util.reportJson.lighthouseVersion]));const o=new URLSearchParams(s),a=new URL("https://googlechrome.github.io/lighthouse/scorecalc/");return a.hash=o.toString(),a.href}render(e,t,n){const i=Util.i18n.strings,r=this.dom.createElement("div","lh-category");if("PSI"===n){const n=this.dom.createElement("div","lh-score__gauge");n.appendChild(this.renderScoreGauge(e,t)),r.appendChild(n)}else this.createPermalinkSpan(r,e.id),r.appendChild(this.renderCategoryHeader(e,t));const s=this.renderAuditGroup(t.metrics),o=this.dom.cloneTemplate("#tmpl-lh-metrics-toggle",this.templateContext),a=this.dom.find(".lh-metrics-toggle",o);s.append(...a.childNodes);const l=e.auditRefs.filter((e=>"metrics"===e.group)),d=this.dom.createChildOf(s,"div","lh-metrics-container");l.forEach((e=>{d.appendChild(this._renderMetric(e))}));const c=this.dom.createChildOf(s,"div","lh-metrics__disclaimer"),h=this.dom.convertMarkdownLinkSnippets(i.varianceDisclaimer);c.appendChild(h);const u=this.dom.createChildOf(c,"a","lh-calclink");u.target="_blank",u.textContent=i.calculatorLink,u.href=this._getScoringCalculatorHref(e.auditRefs),s.classList.add("lh-audit-group--metrics"),r.appendChild(s);const p=this.dom.createChildOf(r,"div","lh-filmstrip-container"),m=e.auditRefs.find((e=>"screenshot-thumbnails"===e.id)),g=m&&m.result;if(g&&g.details){p.id=g.id;const e=this.detailsRenderer.render(g.details);e&&p.appendChild(e)}const f=[];if(["performance-budget","timing-budget"].forEach((t=>{const n=e.auditRefs.find((e=>e.id===t));if(n&&n.result.details){const e=this.detailsRenderer.render(n.result.details);e&&(e.id=t,e.classList.add("lh-audit"),f.push(e))}})),f.length>0){const e=this.renderAuditGroup(t.budgets);f.forEach((t=>e.appendChild(t))),e.classList.add("lh-audit-group--budgets"),r.appendChild(e)}const _=e.auditRefs.filter((e=>"load-opportunities"===e.group&&!Util.showAsPassed(e.result))).sort(((e,t)=>this._getWastedMs(t)-this._getWastedMs(e)));if(_.length){const e=2e3,n=_.map((e=>this._getWastedMs(e))),s=Math.max(...n),o=Math.max(1e3*Math.ceil(s/1e3),e),a=this.renderAuditGroup(t["load-opportunities"]),l=this.dom.cloneTemplate("#tmpl-lh-opportunity-header",this.templateContext);this.dom.find(".lh-load-opportunity__col--one",l).textContent=i.opportunityResourceColumnLabel,this.dom.find(".lh-load-opportunity__col--two",l).textContent=i.opportunitySavingsColumnLabel;const d=this.dom.find(".lh-load-opportunity__header",l);a.appendChild(d),_.forEach((e=>a.appendChild(this._renderOpportunity(e,o)))),a.classList.add("lh-audit-group--load-opportunities"),r.appendChild(a)}const y=e.auditRefs.filter((e=>"diagnostics"===e.group&&!Util.showAsPassed(e.result))).sort(((e,t)=>("informative"===e.result.scoreDisplayMode?100:Number(e.result.score))-("informative"===t.result.scoreDisplayMode?100:Number(t.result.score))));if(y.length){const e=this.renderAuditGroup(t.diagnostics);y.forEach((t=>e.appendChild(this.renderAudit(t)))),e.classList.add("lh-audit-group--diagnostics"),r.appendChild(e)}const C=e.auditRefs.filter((e=>("load-opportunities"===e.group||"diagnostics"===e.group)&&Util.showAsPassed(e.result)));if(!C.length)return r;const b={auditRefs:C,groupDefinitions:t},v=this.renderClump("passed",b);return r.appendChild(v),r}}"undefined"!==typeof module&&module.exports?module.exports=PerformanceCategoryRenderer:self.PerformanceCategoryRenderer=PerformanceCategoryRenderer;class PwaCategoryRenderer extends CategoryRenderer{render(e,t={}){const n=this.dom.createElement("div","lh-category");this.createPermalinkSpan(n,e.id),n.appendChild(this.renderCategoryHeader(e,t));const i=e.auditRefs,r=i.filter((e=>"manual"!==e.result.scoreDisplayMode)),s=this._renderAudits(r,t);n.appendChild(s);const o=i.filter((e=>"manual"===e.result.scoreDisplayMode)),a=this.renderClump("manual",{auditRefs:o,description:e.manualDescription});return n.appendChild(a),n}renderScoreGauge(e,t){if(null===e.score)return super.renderScoreGauge(e,t);const n=this.dom.cloneTemplate("#tmpl-lh-gauge--pwa",this.templateContext),i=this.dom.find("a.lh-gauge--pwa__wrapper",n);i.href=`#${e.id}`;const r=n.querySelector("svg");if(!r)throw new Error("no SVG element found in PWA score gauge template");PwaCategoryRenderer._makeSvgReferencesUnique(r);const s=this._getGroupIds(e.auditRefs),o=this._getPassingGroupIds(e.auditRefs);if(o.size===s.size)i.classList.add("lh-badged--all");else for(const a of o)i.classList.add(`lh-badged--${a}`);return this.dom.find(".lh-gauge__label",n).textContent=e.title,i.title=this._getGaugeTooltip(e.auditRefs,t),n}_getGroupIds(e){const t=e.map((e=>e.group)).filter((e=>!!e));return new Set(t)}_getPassingGroupIds(e){const t=this._getGroupIds(e);for(const n of e)!Util.showAsPassed(n.result)&&n.group&&t.delete(n.group);return t}_getGaugeTooltip(e,t){const n=this._getGroupIds(e),i=[];for(const r of n){const n=e.filter((e=>e.group===r)),s=n.length,o=n.filter((e=>Util.showAsPassed(e.result))).length,a=t[r].title;i.push(`${a}: ${o}/${s}`)}return i.join(", ")}_renderAudits(e,t){const n=this.renderUnexpandableClump(e,t),i=this._getPassingGroupIds(e);for(const r of i){this.dom.find(`.lh-audit-group--${r}`,n).classList.add("lh-badged")}return n}static _makeSvgReferencesUnique(e){const t=e.querySelector("defs");if(!t)return;const n=Util.getUniqueSuffix(),i=t.querySelectorAll("[id]");for(const r of i){const t=r.id,i=`${t}-${n}`;r.id=i;const s=e.querySelectorAll(`use[href="#${t}"]`);for(const e of s)e.setAttribute("href",`#${i}`);const o=e.querySelectorAll(`[fill="url(#${t})"]`);for(const e of o)e.setAttribute("fill",`url(#${i})`)}}}"undefined"!==typeof module&&module.exports?module.exports=PwaCategoryRenderer:self.PwaCategoryRenderer=PwaCategoryRenderer;class ReportRenderer{constructor(e){this._dom=e,this._templateContext=this._dom.document()}renderReport(e,t){this._dom.setLighthouseChannel(e.configSettings.channel||"unknown");const n=Util.prepareReportResult(e);return t.textContent="",t.appendChild(this._renderReport(n)),t}setTemplateContext(e){this._templateContext=e}_renderReportTopbar(e){const t=this._dom.cloneTemplate("#tmpl-lh-topbar",this._templateContext),n=this._dom.find("a.lh-topbar__url",t);return n.href=n.textContent=e.finalUrl,n.title=e.finalUrl,t}_renderReportHeader(){const e=this._dom.cloneTemplate("#tmpl-lh-heading",this._templateContext),t=this._dom.cloneTemplate("#tmpl-lh-scores-wrapper",this._templateContext);return this._dom.find(".lh-scores-wrapper-placeholder",e).replaceWith(t),e}_renderReportFooter(e){const t=this._dom.cloneTemplate("#tmpl-lh-footer",this._templateContext),n=this._dom.find(".lh-env__items",t);n.id="runtime-settings",this._dom.find(".lh-env__title",t).textContent=Util.i18n.strings.runtimeSettingsTitle;const i=Util.getEnvironmentDisplayValues(e.configSettings||{}),r=[{name:Util.i18n.strings.runtimeSettingsUrl,description:e.finalUrl},{name:Util.i18n.strings.runtimeSettingsFetchTime,description:Util.i18n.formatDateTime(e.fetchTime)},...i,{name:Util.i18n.strings.runtimeSettingsChannel,description:e.configSettings.channel},{name:Util.i18n.strings.runtimeSettingsUA,description:e.userAgent},{name:Util.i18n.strings.runtimeSettingsUANetwork,description:e.environment&&e.environment.networkUserAgent},{name:Util.i18n.strings.runtimeSettingsBenchmark,description:e.environment&&e.environment.benchmarkIndex.toFixed(0)}];e.environment.credits&&e.environment.credits["axe-core"]&&r.push({name:Util.i18n.strings.runtimeSettingsAxeVersion,description:e.environment.credits["axe-core"]});for(const s of r){if(!s.description)continue;const e=this._dom.cloneTemplate("#tmpl-lh-env__items",n);this._dom.find(".lh-env__name",e).textContent=s.name,this._dom.find(".lh-env__description",e).textContent=s.description,n.appendChild(e)}return this._dom.find(".lh-footer__version_issue",t).textContent=Util.i18n.strings.footerIssue,this._dom.find(".lh-footer__version",t).textContent=e.lighthouseVersion,t}_renderReportWarnings(e){if(!e.runWarnings||0===e.runWarnings.length)return this._dom.createElement("div");const t=this._dom.cloneTemplate("#tmpl-lh-warnings--toplevel",this._templateContext);this._dom.find(".lh-warnings__msg",t).textContent=Util.i18n.strings.toplevelWarningsMessage;const n=this._dom.find("ul",t);for(const i of e.runWarnings){n.appendChild(this._dom.createElement("li")).appendChild(this._dom.convertMarkdownLinkSnippets(i))}return t}_renderScoreGauges(e,t,n){const i=[],r=[],s=[];for(const o of Object.values(e.categories)){const a=n[o.id]||t,l=a.renderScoreGauge(o,e.categoryGroups||{});Util.isPluginCategory(o.id)?s.push(l):a.renderScoreGauge===t.renderScoreGauge?i.push(l):r.push(l)}return[...i,...r,...s]}_renderReport(e){const t=new I18n(e.configSettings.locale,{...Util.UIStrings,...e.i18n.rendererFormattedStrings});Util.i18n=t,Util.reportJson=e;const n=e.audits["full-page-screenshot"]&&e.audits["full-page-screenshot"].details&&"full-page-screenshot"===e.audits["full-page-screenshot"].details.type?e.audits["full-page-screenshot"].details:void 0,i=new DetailsRenderer(this._dom,{fullPageScreenshot:n}),r=n&&ElementScreenshotRenderer.createBackgroundImageStyle(this._dom,n.screenshot),s=new CategoryRenderer(this._dom,i);s.setTemplateContext(this._templateContext);const o={performance:new PerformanceCategoryRenderer(this._dom,i),pwa:new PwaCategoryRenderer(this._dom,i)};Object.values(o).forEach((e=>{e.setTemplateContext(this._templateContext)}));const a=this._dom.createElement("div");a.appendChild(this._renderReportHeader());const l=this._dom.createElement("div","lh-container"),d=this._dom.createElement("div","lh-report");let c;d.appendChild(this._renderReportWarnings(e));if(1===Object.keys(e.categories).length?a.classList.add("lh-header--solo-category"):c=this._dom.createElement("div","lh-scores-header"),c){const t=this._dom.cloneTemplate("#tmpl-lh-scorescale",this._templateContext),n=this._dom.find(".lh-scores-container",a);c.append(...this._renderScoreGauges(e,s,o)),n.appendChild(c),n.appendChild(t);const i=this._dom.createElement("div","lh-sticky-header");i.append(...this._renderScoreGauges(e,s,o)),l.appendChild(i)}const h=d.appendChild(this._dom.createElement("div","lh-categories"));for(const m of Object.values(e.categories)){const t=o[m.id]||s;t.dom.createChildOf(h,"div","lh-category-wrapper").appendChild(t.render(m,e.categoryGroups))}const u=this._dom.createFragment(),p=this._renderReportTopbar(e);return u.appendChild(p),u.appendChild(l),l.appendChild(a),l.appendChild(d),r&&l.appendChild(r),d.appendChild(this._renderReportFooter(e)),u}}"undefined"!==typeof module&&module.exports?module.exports=ReportRenderer:self.ReportRenderer=ReportRenderer;const NBSP2="\xa0";class I18n{constructor(e,t){"en-XA"===e&&(e="de"),this._numberDateLocale=e,this._numberFormatter=new Intl.NumberFormat(e),this._strings=t||{}}get strings(){return this._strings}formatNumber(e,t=.1){const n=Math.round(e/t)*t;return this._numberFormatter.format(n)}formatBytesToKiB(e,t=.1){return`${this._byteFormatterForGranularity(t).format(Math.round(e/1024/t)*t)}\xa0KiB`}formatBytes(e,t=1){return`${this._byteFormatterForGranularity(t).format(Math.round(e/t)*t)}\xa0bytes`}_byteFormatterForGranularity(e){let t=0;return e<1&&(t=-Math.floor(Math.log10(e))),new Intl.NumberFormat(this._numberDateLocale,{...this._numberFormatter.resolvedOptions(),maximumFractionDigits:t,minimumFractionDigits:t})}formatMilliseconds(e,t=10){const n=Math.round(e/t)*t;return 0===n?`${this._numberFormatter.format(0)}\xa0ms`:`${this._numberFormatter.format(n)}\xa0ms`}formatSeconds(e,t=.1){const n=Math.round(e/1e3/t)*t;return`${this._numberFormatter.format(n)}\xa0s`}formatDateTime(e){const t={month:"short",day:"numeric",year:"numeric",hour:"numeric",minute:"numeric",timeZoneName:"short"};let n;try{n=new Intl.DateTimeFormat(this._numberDateLocale,t)}catch(i){t.timeZone="UTC",n=new Intl.DateTimeFormat(this._numberDateLocale,t)}return n.format(new Date(e))}formatDuration(e){let t=e/1e3;if(0===Math.round(t))return"None";const n=[],i={d:86400,h:3600,m:60,s:1};return Object.keys(i).forEach((e=>{const r=i[e],s=Math.floor(t/r);s>0&&(t-=s*r,n.push(`${s}\xa0${e}`))})),n.join(" ")}}"undefined"!==typeof module&&module.exports?module.exports=I18n:self.I18n=I18n;