import{assert}from"./assert.js";import{EVALUATION_SCRIPT_URL}from"./ExecutionContext.js";import{debugError,helper}from"./helper.js";export class Coverage{constructor(e){this._jsCoverage=new JSCoverage(e),this._cssCoverage=new CSSCoverage(e)}async startJSCoverage(e={}){return await this._jsCoverage.start(e)}async stopJSCoverage(){return await this._jsCoverage.stop()}async startCSSCoverage(e={}){return await this._cssCoverage.start(e)}async stopCSSCoverage(){return await this._cssCoverage.stop()}}class JSCoverage{constructor(e){this._enabled=!1,this._scriptURLs=new Map,this._scriptSources=new Map,this._eventListeners=[],this._resetOnNavigation=!1,this._reportAnonymousScripts=!1,this._client=e}async start(e={}){assert(!this._enabled,"JSCoverage is already enabled");const{resetOnNavigation:t=!0,reportAnonymousScripts:s=!1}=e;this._resetOnNavigation=t,this._reportAnonymousScripts=s,this._enabled=!0,this._scriptURLs.clear(),this._scriptSources.clear(),this._eventListeners=[helper.addEventListener(this._client,"Debugger.scriptParsed",this._onScriptParsed.bind(this)),helper.addEventListener(this._client,"Runtime.executionContextsCleared",this._onExecutionContextsCleared.bind(this))],await Promise.all([this._client.send("Profiler.enable"),this._client.send("Profiler.startPreciseCoverage",{callCount:!1,detailed:!0}),this._client.send("Debugger.enable"),this._client.send("Debugger.setSkipAllPauses",{skip:!0})])}_onExecutionContextsCleared(){this._resetOnNavigation&&(this._scriptURLs.clear(),this._scriptSources.clear())}async _onScriptParsed(e){if(e.url!==EVALUATION_SCRIPT_URL&&(e.url||this._reportAnonymousScripts))try{const t=await this._client.send("Debugger.getScriptSource",{scriptId:e.scriptId});this._scriptURLs.set(e.scriptId,e.url),this._scriptSources.set(e.scriptId,t.scriptSource)}catch(t){debugError(t)}}async stop(){assert(this._enabled,"JSCoverage is not enabled"),this._enabled=!1;const e=await Promise.all([this._client.send("Profiler.takePreciseCoverage"),this._client.send("Profiler.stopPreciseCoverage"),this._client.send("Profiler.disable"),this._client.send("Debugger.disable")]);helper.removeEventListeners(this._eventListeners);const t=[],s=e[0];for(const r of s.result){let e=this._scriptURLs.get(r.scriptId);!e&&this._reportAnonymousScripts&&(e="debugger://VM"+r.scriptId);const s=this._scriptSources.get(r.scriptId);if(void 0===s||void 0===e)continue;const n=[];for(const t of r.functions)n.push(...t.ranges);const i=convertToDisjointRanges(n);t.push({url:e,ranges:i,text:s})}return t}}class CSSCoverage{constructor(e){this._enabled=!1,this._stylesheetURLs=new Map,this._stylesheetSources=new Map,this._eventListeners=[],this._resetOnNavigation=!1,this._reportAnonymousScripts=!1,this._client=e}async start(e={}){assert(!this._enabled,"CSSCoverage is already enabled");const{resetOnNavigation:t=!0}=e;this._resetOnNavigation=t,this._enabled=!0,this._stylesheetURLs.clear(),this._stylesheetSources.clear(),this._eventListeners=[helper.addEventListener(this._client,"CSS.styleSheetAdded",this._onStyleSheet.bind(this)),helper.addEventListener(this._client,"Runtime.executionContextsCleared",this._onExecutionContextsCleared.bind(this))],await Promise.all([this._client.send("DOM.enable"),this._client.send("CSS.enable"),this._client.send("CSS.startRuleUsageTracking")])}_onExecutionContextsCleared(){this._resetOnNavigation&&(this._stylesheetURLs.clear(),this._stylesheetSources.clear())}async _onStyleSheet(e){const t=e.header;if(t.sourceURL)try{const e=await this._client.send("CSS.getStyleSheetText",{styleSheetId:t.styleSheetId});this._stylesheetURLs.set(t.styleSheetId,t.sourceURL),this._stylesheetSources.set(t.styleSheetId,e.text)}catch(s){debugError(s)}}async stop(){assert(this._enabled,"CSSCoverage is not enabled"),this._enabled=!1;const e=await this._client.send("CSS.stopRuleUsageTracking");await Promise.all([this._client.send("CSS.disable"),this._client.send("DOM.disable")]),helper.removeEventListeners(this._eventListeners);const t=new Map;for(const r of e.ruleUsage){let e=t.get(r.styleSheetId);e||(e=[],t.set(r.styleSheetId,e)),e.push({startOffset:r.startOffset,endOffset:r.endOffset,count:r.used?1:0})}const s=[];for(const r of this._stylesheetURLs.keys()){const e=this._stylesheetURLs.get(r),n=this._stylesheetSources.get(r),i=convertToDisjointRanges(t.get(r)||[]);s.push({url:e,ranges:i,text:n})}return s}}function convertToDisjointRanges(e){const t=[];for(const i of e)t.push({offset:i.startOffset,type:0,range:i}),t.push({offset:i.endOffset,type:1,range:i});t.sort(((e,t)=>{if(e.offset!==t.offset)return e.offset-t.offset;if(e.type!==t.type)return t.type-e.type;const s=e.range.endOffset-e.range.startOffset,r=t.range.endOffset-t.range.startOffset;return 0===e.type?r-s:s-r}));const s=[],r=[];let n=0;for(const i of t){if(s.length&&n<i.offset&&s[s.length-1]>0){const e=r.length?r[r.length-1]:null;e&&e.end===n?e.end=i.offset:r.push({start:n,end:i.offset})}n=i.offset,0===i.type?s.push(i.range.count):s.pop()}return r.filter((e=>e.end-e.start>1))}