import{debug}from"../common/Debug.js";import{assert}from"./assert.js";import{DOMWorld}from"./DOMWorld.js";import{EventEmitter}from"./EventEmitter.js";import{EVALUATION_SCRIPT_URL,ExecutionContext}from"./ExecutionContext.js";import{debugError,helper}from"./helper.js";import{LifecycleWatcher}from"./LifecycleWatcher.js";import{NetworkManager}from"./NetworkManager.js";const UTILITY_WORLD_NAME="__puppeteer_utility_world__";export const FrameManagerEmittedEvents={FrameAttached:Symbol("FrameManager.FrameAttached"),FrameNavigated:Symbol("FrameManager.FrameNavigated"),FrameDetached:Symbol("FrameManager.FrameDetached"),LifecycleEvent:Symbol("FrameManager.LifecycleEvent"),FrameNavigatedWithinDocument:Symbol("FrameManager.FrameNavigatedWithinDocument"),ExecutionContextCreated:Symbol("FrameManager.ExecutionContextCreated"),ExecutionContextDestroyed:Symbol("FrameManager.ExecutionContextDestroyed")};export class FrameManager extends EventEmitter{constructor(e,t,a,r){super(),this._frames=new Map,this._contextIdToContext=new Map,this._isolatedWorlds=new Set,this._client=e,this._page=t,this._networkManager=new NetworkManager(e,a,this),this._timeoutSettings=r,this._client.on("Page.frameAttached",(e=>this._onFrameAttached(e.frameId,e.parentFrameId))),this._client.on("Page.frameNavigated",(e=>this._onFrameNavigated(e.frame))),this._client.on("Page.navigatedWithinDocument",(e=>this._onFrameNavigatedWithinDocument(e.frameId,e.url))),this._client.on("Page.frameDetached",(e=>this._onFrameDetached(e.frameId))),this._client.on("Page.frameStoppedLoading",(e=>this._onFrameStoppedLoading(e.frameId))),this._client.on("Runtime.executionContextCreated",(e=>this._onExecutionContextCreated(e.context))),this._client.on("Runtime.executionContextDestroyed",(e=>this._onExecutionContextDestroyed(e.executionContextId))),this._client.on("Runtime.executionContextsCleared",(()=>this._onExecutionContextsCleared())),this._client.on("Page.lifecycleEvent",(e=>this._onLifecycleEvent(e))),this._client.on("Target.attachedToTarget",(async e=>this._onFrameMoved(e)))}async initialize(){const e=await Promise.all([this._client.send("Page.enable"),this._client.send("Page.getFrameTree")]),{frameTree:t}=e[1];this._handleFrameTree(t),await Promise.all([this._client.send("Page.setLifecycleEventsEnabled",{enabled:!0}),this._client.send("Runtime.enable").then((()=>this._ensureIsolatedWorld(UTILITY_WORLD_NAME))),this._networkManager.initialize()])}networkManager(){return this._networkManager}async navigateFrame(e,t,a={}){assertNoLegacyNavigationOptions(a);const{referer:r=this._networkManager.extraHTTPHeaders().referer,waitUntil:i=["load"],timeout:n=this._timeoutSettings.navigationTimeout()}=a,o=new LifecycleWatcher(this,e,i,n);let s=!1,d=await Promise.race([async function(e,t,a,r){try{const i=await e.send("Page.navigate",{url:t,referrer:a,frameId:r});return s=!!i.loaderId,i.errorText?new Error(`${i.errorText} at ${t}`):null}catch(d){return d}}(this._client,t,r,e._id),o.timeoutOrTerminationPromise()]);if(d||(d=await Promise.race([o.timeoutOrTerminationPromise(),s?o.newDocumentNavigationPromise():o.sameDocumentNavigationPromise()])),o.dispose(),d)throw d;return o.navigationResponse()}async waitForFrameNavigation(e,t={}){assertNoLegacyNavigationOptions(t);const{waitUntil:a=["load"],timeout:r=this._timeoutSettings.navigationTimeout()}=t,i=new LifecycleWatcher(this,e,a,r),n=await Promise.race([i.timeoutOrTerminationPromise(),i.sameDocumentNavigationPromise(),i.newDocumentNavigationPromise()]);if(i.dispose(),n)throw n;return i.navigationResponse()}async _onFrameMoved(e){"iframe"===e.targetInfo.type&&debug("puppeteer:frame")(`The frame '${e.targetInfo.targetId}' moved to another session. Out-of-process iframes (OOPIF) are not supported by Puppeteer yet. https://github.com/puppeteer/puppeteer/issues/2548`)}_onLifecycleEvent(e){const t=this._frames.get(e.frameId);t&&(t._onLifecycleEvent(e.loaderId,e.name),this.emit(FrameManagerEmittedEvents.LifecycleEvent,t))}_onFrameStoppedLoading(e){const t=this._frames.get(e);t&&(t._onLoadingStopped(),this.emit(FrameManagerEmittedEvents.LifecycleEvent,t))}_handleFrameTree(e){if(e.frame.parentId&&this._onFrameAttached(e.frame.id,e.frame.parentId),this._onFrameNavigated(e.frame),e.childFrames)for(const t of e.childFrames)this._handleFrameTree(t)}page(){return this._page}mainFrame(){return this._mainFrame}frames(){return Array.from(this._frames.values())}frame(e){return this._frames.get(e)||null}_onFrameAttached(e,t){if(this._frames.has(e))return;assert(t);const a=this._frames.get(t),r=new Frame(this,a,e);this._frames.set(r._id,r),this.emit(FrameManagerEmittedEvents.FrameAttached,r)}_onFrameNavigated(e){const t=!e.parentId;let a=t?this._mainFrame:this._frames.get(e.id);if(assert(t||a,"We either navigate top level or have old version of the navigated frame"),a)for(const r of a.childFrames())this._removeFramesRecursively(r);t&&(a?(this._frames.delete(a._id),a._id=e.id):a=new Frame(this,null,e.id),this._frames.set(e.id,a),this._mainFrame=a),a._navigated(e),this.emit(FrameManagerEmittedEvents.FrameNavigated,a)}async _ensureIsolatedWorld(e){this._isolatedWorlds.has(e)||(this._isolatedWorlds.add(e),await this._client.send("Page.addScriptToEvaluateOnNewDocument",{source:`//# sourceURL=${EVALUATION_SCRIPT_URL}`,worldName:e}),await Promise.all(this.frames().map((t=>this._client.send("Page.createIsolatedWorld",{frameId:t._id,worldName:e,grantUniveralAccess:!0}).catch(debugError)))))}_onFrameNavigatedWithinDocument(e,t){const a=this._frames.get(e);a&&(a._navigatedWithinDocument(t),this.emit(FrameManagerEmittedEvents.FrameNavigatedWithinDocument,a),this.emit(FrameManagerEmittedEvents.FrameNavigated,a))}_onFrameDetached(e){const t=this._frames.get(e);t&&this._removeFramesRecursively(t)}_onExecutionContextCreated(e){const t=e.auxData,a=t?t.frameId:null,r=this._frames.get(a)||null;let i=null;r&&(e.auxData&&e.auxData.isDefault?i=r._mainWorld:e.name!==UTILITY_WORLD_NAME||r._secondaryWorld._hasContext()||(i=r._secondaryWorld));const n=new ExecutionContext(this._client,e,i);i&&i._setContext(n),this._contextIdToContext.set(e.id,n)}_onExecutionContextDestroyed(e){const t=this._contextIdToContext.get(e);t&&(this._contextIdToContext.delete(e),t._world&&t._world._setContext(null))}_onExecutionContextsCleared(){for(const e of this._contextIdToContext.values())e._world&&e._world._setContext(null);this._contextIdToContext.clear()}executionContextById(e){const t=this._contextIdToContext.get(e);return assert(t,"INTERNAL ERROR: missing context with id = "+e),t}_removeFramesRecursively(e){for(const t of e.childFrames())this._removeFramesRecursively(t);e._detach(),this._frames.delete(e._id),this.emit(FrameManagerEmittedEvents.FrameDetached,e)}}export class Frame{constructor(e,t,a){this._url="",this._detached=!1,this._loaderId="",this._lifecycleEvents=new Set,this._frameManager=e,this._parentFrame=t,this._url="",this._id=a,this._detached=!1,this._loaderId="",this._mainWorld=new DOMWorld(e,this,e._timeoutSettings),this._secondaryWorld=new DOMWorld(e,this,e._timeoutSettings),this._childFrames=new Set,this._parentFrame&&this._parentFrame._childFrames.add(this)}async goto(e,t={}){return await this._frameManager.navigateFrame(this,e,t)}async waitForNavigation(e={}){return await this._frameManager.waitForFrameNavigation(this,e)}executionContext(){return this._mainWorld.executionContext()}async evaluateHandle(e,...t){return this._mainWorld.evaluateHandle(e,...t)}async evaluate(e,...t){return this._mainWorld.evaluate(e,...t)}async $(e){return this._mainWorld.$(e)}async $x(e){return this._mainWorld.$x(e)}async $eval(e,t,...a){return this._mainWorld.$eval(e,t,...a)}async $$eval(e,t,...a){return this._mainWorld.$$eval(e,t,...a)}async $$(e){return this._mainWorld.$$(e)}async content(){return this._secondaryWorld.content()}async setContent(e,t={}){return this._secondaryWorld.setContent(e,t)}name(){return this._name||""}url(){return this._url}parentFrame(){return this._parentFrame}childFrames(){return Array.from(this._childFrames)}isDetached(){return this._detached}async addScriptTag(e){return this._mainWorld.addScriptTag(e)}async addStyleTag(e){return this._mainWorld.addStyleTag(e)}async click(e,t={}){return this._secondaryWorld.click(e,t)}async focus(e){return this._secondaryWorld.focus(e)}async hover(e){return this._secondaryWorld.hover(e)}select(e,...t){return this._secondaryWorld.select(e,...t)}async tap(e){return this._secondaryWorld.tap(e)}async type(e,t,a){return this._mainWorld.type(e,t,a)}waitFor(e,t={},...a){if(console.warn("waitFor is deprecated and will be removed in a future release. See https://github.com/puppeteer/puppeteer/issues/6214 for details and how to migrate your code."),helper.isString(e)){const a=e;return a.startsWith("//")?this.waitForXPath(a,t):this.waitForSelector(a,t)}return helper.isNumber(e)?new Promise((t=>setTimeout(t,e))):"function"===typeof e?this.waitForFunction(e,t,...a):Promise.reject(new Error("Unsupported target type: "+typeof e))}waitForTimeout(e){return new Promise((t=>{setTimeout(t,e)}))}async waitForSelector(e,t={}){const a=await this._secondaryWorld.waitForSelector(e,t);if(!a)return null;const r=await this._mainWorld.executionContext(),i=await r._adoptElementHandle(a);return await a.dispose(),i}async waitForXPath(e,t={}){const a=await this._secondaryWorld.waitForXPath(e,t);if(!a)return null;const r=await this._mainWorld.executionContext(),i=await r._adoptElementHandle(a);return await a.dispose(),i}waitForFunction(e,t={},...a){return this._mainWorld.waitForFunction(e,t,...a)}async title(){return this._secondaryWorld.title()}_navigated(e){this._name=e.name,this._url=`${e.url}${e.urlFragment||""}`}_navigatedWithinDocument(e){this._url=e}_onLifecycleEvent(e,t){"init"===t&&(this._loaderId=e,this._lifecycleEvents.clear()),this._lifecycleEvents.add(t)}_onLoadingStopped(){this._lifecycleEvents.add("DOMContentLoaded"),this._lifecycleEvents.add("load")}_detach(){this._detached=!0,this._mainWorld._detach(),this._secondaryWorld._detach(),this._parentFrame&&this._parentFrame._childFrames.delete(this),this._parentFrame=null}}function assertNoLegacyNavigationOptions(e){assert(void 0===e.networkIdleTimeout,"ERROR: networkIdleTimeout option is no longer supported."),assert(void 0===e.networkIdleInflight,"ERROR: networkIdleInflight option is no longer supported."),assert("networkidle"!==e.waitUntil,'ERROR: "networkidle" option is no longer supported. Use "networkidle2" instead')}