import{isNode}from"../environment.js";import{Accessibility}from"./Accessibility.js";import{assert}from"./assert.js";import{CDPSessionEmittedEvents,Connection}from"./Connection.js";import{ConsoleMessage}from"./ConsoleMessage.js";import{Coverage}from"./Coverage.js";import{Dialog}from"./Dialog.js";import{EmulationManager}from"./EmulationManager.js";import{EventEmitter}from"./EventEmitter.js";import{FileChooser}from"./FileChooser.js";import{FrameManager,FrameManagerEmittedEvents}from"./FrameManager.js";import{debugError,helper}from"./helper.js";import{Keyboard,Mouse,Touchscreen}from"./Input.js";import{createJSHandle}from"./JSHandle.js";import{NetworkManagerEmittedEvents}from"./NetworkManager.js";import{paperFormats}from"./PDFOptions.js";import{TimeoutSettings}from"./TimeoutSettings.js";import{Tracing}from"./Tracing.js";import{WebWorker}from"./WebWorker.js";class ScreenshotTaskQueue{constructor(){this._chain=Promise.resolve(void 0)}postTask(e){const t=this._chain.then(e);return this._chain=t.catch((()=>{})),t}}export class Page extends EventEmitter{constructor(e,t,i){super(),this._closed=!1,this._timeoutSettings=new TimeoutSettings,this._pageBindings=new Map,this._javascriptEnabled=!0,this._workers=new Map,this._fileChooserInterceptors=new Set,this._client=e,this._target=t,this._keyboard=new Keyboard(e),this._mouse=new Mouse(e,this._keyboard),this._touchscreen=new Touchscreen(e,this._keyboard),this._accessibility=new Accessibility(e),this._frameManager=new FrameManager(e,this,i,this._timeoutSettings),this._emulationManager=new EmulationManager(e),this._tracing=new Tracing(e),this._coverage=new Coverage(e),this._screenshotTaskQueue=new ScreenshotTaskQueue,this._viewport=null,e.on("Target.attachedToTarget",(t=>{if("worker"!==t.targetInfo.type)return void e.send("Target.detachFromTarget",{sessionId:t.sessionId}).catch(debugError);const i=Connection.fromSession(e).session(t.sessionId),a=new WebWorker(i,t.targetInfo.url,this._addConsoleMessage.bind(this),this._handleException.bind(this));this._workers.set(t.sessionId,a),this.emit("workercreated",a)})),e.on("Target.detachedFromTarget",(e=>{const t=this._workers.get(e.sessionId);t&&(this.emit("workerdestroyed",t),this._workers.delete(e.sessionId))})),this._frameManager.on(FrameManagerEmittedEvents.FrameAttached,(e=>this.emit("frameattached",e))),this._frameManager.on(FrameManagerEmittedEvents.FrameDetached,(e=>this.emit("framedetached",e))),this._frameManager.on(FrameManagerEmittedEvents.FrameNavigated,(e=>this.emit("framenavigated",e)));const a=this._frameManager.networkManager();a.on(NetworkManagerEmittedEvents.Request,(e=>this.emit("request",e))),a.on(NetworkManagerEmittedEvents.Response,(e=>this.emit("response",e))),a.on(NetworkManagerEmittedEvents.RequestFailed,(e=>this.emit("requestfailed",e))),a.on(NetworkManagerEmittedEvents.RequestFinished,(e=>this.emit("requestfinished",e))),this._fileChooserInterceptors=new Set,e.on("Page.domContentEventFired",(()=>this.emit("domcontentloaded"))),e.on("Page.loadEventFired",(()=>this.emit("load"))),e.on("Runtime.consoleAPICalled",(e=>this._onConsoleAPI(e))),e.on("Runtime.bindingCalled",(e=>this._onBindingCalled(e))),e.on("Page.javascriptDialogOpening",(e=>this._onDialog(e))),e.on("Runtime.exceptionThrown",(e=>this._handleException(e.exceptionDetails))),e.on("Inspector.targetCrashed",(()=>this._onTargetCrashed())),e.on("Performance.metrics",(e=>this._emitMetrics(e))),e.on("Log.entryAdded",(e=>this._onLogEntryAdded(e))),e.on("Page.fileChooserOpened",(e=>this._onFileChooser(e))),this._target._isClosedPromise.then((()=>{this.emit("close"),this._closed=!0}))}static async create(e,t,i,a){const r=new Page(e,t,i);return await r._initialize(),a&&await r.setViewport(a),r}async _initialize(){await Promise.all([this._frameManager.initialize(),this._client.send("Target.setAutoAttach",{autoAttach:!0,waitForDebuggerOnStart:!1,flatten:!0}),this._client.send("Performance.enable"),this._client.send("Log.enable")])}async _onFileChooser(e){if(!this._fileChooserInterceptors.size)return;const t=this._frameManager.frame(e.frameId),i=await t.executionContext(),a=await i._adoptBackendNodeId(e.backendNodeId),r=Array.from(this._fileChooserInterceptors);this._fileChooserInterceptors.clear();const n=new FileChooser(a,e);for(const s of r)s.call(null,n)}isJavaScriptEnabled(){return this._javascriptEnabled}async waitForFileChooser(e={}){this._fileChooserInterceptors.size||await this._client.send("Page.setInterceptFileChooserDialog",{enabled:!0});const{timeout:t=this._timeoutSettings.timeout()}=e;let i;const a=new Promise((e=>i=e));return this._fileChooserInterceptors.add(i),helper.waitWithTimeout(a,"waiting for file chooser",t).catch((e=>{throw this._fileChooserInterceptors.delete(i),e}))}async setGeolocation(e){const{longitude:t,latitude:i,accuracy:a=0}=e;if(t<-180||t>180)throw new Error(`Invalid longitude "${t}": precondition -180 <= LONGITUDE <= 180 failed.`);if(i<-90||i>90)throw new Error(`Invalid latitude "${i}": precondition -90 <= LATITUDE <= 90 failed.`);if(a<0)throw new Error(`Invalid accuracy "${a}": precondition 0 <= ACCURACY failed.`);await this._client.send("Emulation.setGeolocationOverride",{longitude:t,latitude:i,accuracy:a})}target(){return this._target}browser(){return this._target.browser()}browserContext(){return this._target.browserContext()}_onTargetCrashed(){this.emit("error",new Error("Page crashed!"))}_onLogEntryAdded(e){const{level:t,text:i,args:a,source:r,url:n,lineNumber:s}=e.entry;a&&a.map((e=>helper.releaseObject(this._client,e))),"worker"!==r&&this.emit("console",new ConsoleMessage(t,i,[],[{url:n,lineNumber:s}]))}mainFrame(){return this._frameManager.mainFrame()}get keyboard(){return this._keyboard}get touchscreen(){return this._touchscreen}get coverage(){return this._coverage}get tracing(){return this._tracing}get accessibility(){return this._accessibility}frames(){return this._frameManager.frames()}workers(){return Array.from(this._workers.values())}async setRequestInterception(e){return this._frameManager.networkManager().setRequestInterception(e)}setOfflineMode(e){return this._frameManager.networkManager().setOfflineMode(e)}emulateNetworkConditions(e){return this._frameManager.networkManager().emulateNetworkConditions(e)}setDefaultNavigationTimeout(e){this._timeoutSettings.setDefaultNavigationTimeout(e)}setDefaultTimeout(e){this._timeoutSettings.setDefaultTimeout(e)}async $(e){return this.mainFrame().$(e)}async evaluateHandle(e,...t){return(await this.mainFrame().executionContext()).evaluateHandle(e,...t)}async queryObjects(e){return(await this.mainFrame().executionContext()).queryObjects(e)}async $eval(e,t,...i){return this.mainFrame().$eval(e,t,...i)}async $$eval(e,t,...i){return this.mainFrame().$$eval(e,t,...i)}async $$(e){return this.mainFrame().$$(e)}async $x(e){return this.mainFrame().$x(e)}async cookies(...e){const t=(await this._client.send("Network.getCookies",{urls:e.length?e:[this.url()]})).cookies,i=["priority"];return t.map((e=>{for(const t of i)delete e[t];return e}))}async deleteCookie(...e){const t=this.url();for(const i of e){const e=Object.assign({},i);!i.url&&t.startsWith("http")&&(e.url=t),await this._client.send("Network.deleteCookies",e)}}async setCookie(...e){const t=this.url(),i=t.startsWith("http"),a=e.map((e=>{const a=Object.assign({},e);return!a.url&&i&&(a.url=t),assert("about:blank"!==a.url,`Blank page can not have cookie "${a.name}"`),assert(!String.prototype.startsWith.call(a.url||"","data:"),`Data URL page can not have cookie "${a.name}"`),a}));await this.deleteCookie(...a),a.length&&await this._client.send("Network.setCookies",{cookies:a})}async addScriptTag(e){return this.mainFrame().addScriptTag(e)}async addStyleTag(e){return this.mainFrame().addStyleTag(e)}async exposeFunction(e,t){if(this._pageBindings.has(e))throw new Error(`Failed to add page binding with name ${e}: window['${e}'] already exists!`);this._pageBindings.set(e,t);const i=helper.pageBindingInitString("exposedFun",e);await this._client.send("Runtime.addBinding",{name:e}),await this._client.send("Page.addScriptToEvaluateOnNewDocument",{source:i}),await Promise.all(this.frames().map((e=>e.evaluate(i).catch(debugError))))}async authenticate(e){return this._frameManager.networkManager().authenticate(e)}async setExtraHTTPHeaders(e){return this._frameManager.networkManager().setExtraHTTPHeaders(e)}async setUserAgent(e){return this._frameManager.networkManager().setUserAgent(e)}async metrics(){const e=await this._client.send("Performance.getMetrics");return this._buildMetricsObject(e.metrics)}_emitMetrics(e){this.emit("metrics",{title:e.title,metrics:this._buildMetricsObject(e.metrics)})}_buildMetricsObject(e){const t={};for(const i of e||[])supportedMetrics.has(i.name)&&(t[i.name]=i.value);return t}_handleException(e){const t=helper.getExceptionMessage(e),i=new Error(t);i.stack="",this.emit("pageerror",i)}async _onConsoleAPI(e){if(0===e.executionContextId)return;const t=this._frameManager.executionContextById(e.executionContextId),i=e.args.map((e=>createJSHandle(t,e)));this._addConsoleMessage(e.type,i,e.stackTrace)}async _onBindingCalled(e){let t;try{t=JSON.parse(e.payload)}catch{return}const{type:i,name:a,seq:r,args:n}=t;if("exposedFun"!==i||!this._pageBindings.has(a))return;let s=null;try{const e=await this._pageBindings.get(a)(...n);s=helper.pageBindingDeliverResultString(a,r,e)}catch(o){s=o instanceof Error?helper.pageBindingDeliverErrorString(a,r,o.message,o.stack):helper.pageBindingDeliverErrorValueString(a,r,o)}this._client.send("Runtime.evaluate",{expression:s,contextId:e.executionContextId}).catch(debugError)}_addConsoleMessage(e,t,i){if(!this.listenerCount("console"))return void t.forEach((e=>e.dispose()));const a=[];for(const s of t){const e=s._remoteObject;e.objectId?a.push(s.toString()):a.push(helper.valueFromRemoteObject(e))}const r=[];if(i)for(const s of i.callFrames)r.push({url:s.url,lineNumber:s.lineNumber,columnNumber:s.columnNumber});const n=new ConsoleMessage(e,a.join(" "),t,r);this.emit("console",n)}_onDialog(e){let t=null;new Set(["alert","confirm","prompt","beforeunload"]).has(e.type)&&(t=e.type),assert(t,"Unknown javascript dialog type: "+e.type);const i=new Dialog(this._client,t,e.message,e.defaultPrompt);this.emit("dialog",i)}url(){return this.mainFrame().url()}async content(){return await this._frameManager.mainFrame().content()}async setContent(e,t={}){await this._frameManager.mainFrame().setContent(e,t)}async goto(e,t={}){return await this._frameManager.mainFrame().goto(e,t)}async reload(e){return(await Promise.all([this.waitForNavigation(e),this._client.send("Page.reload")]))[0]}async waitForNavigation(e={}){return await this._frameManager.mainFrame().waitForNavigation(e)}_sessionClosePromise(){return this._disconnectPromise||(this._disconnectPromise=new Promise((e=>this._client.once(CDPSessionEmittedEvents.Disconnected,(()=>e(new Error("Target closed"))))))),this._disconnectPromise}async waitForRequest(e,t={}){const{timeout:i=this._timeoutSettings.timeout()}=t;return helper.waitForEvent(this._frameManager.networkManager(),NetworkManagerEmittedEvents.Request,(t=>helper.isString(e)?e===t.url():"function"===typeof e&&!!e(t)),i,this._sessionClosePromise())}async waitForResponse(e,t={}){const{timeout:i=this._timeoutSettings.timeout()}=t;return helper.waitForEvent(this._frameManager.networkManager(),NetworkManagerEmittedEvents.Response,(async t=>helper.isString(e)?e===t.url():"function"===typeof e&&!!await e(t)),i,this._sessionClosePromise())}async goBack(e={}){return this._go(-1,e)}async goForward(e={}){return this._go(1,e)}async _go(e,t){const i=await this._client.send("Page.getNavigationHistory"),a=i.entries[i.currentIndex+e];if(!a)return null;return(await Promise.all([this.waitForNavigation(t),this._client.send("Page.navigateToHistoryEntry",{entryId:a.id})]))[0]}async bringToFront(){await this._client.send("Page.bringToFront")}async emulate(e){await Promise.all([this.setViewport(e.viewport),this.setUserAgent(e.userAgent)])}async setJavaScriptEnabled(e){this._javascriptEnabled!==e&&(this._javascriptEnabled=e,await this._client.send("Emulation.setScriptExecutionDisabled",{value:!e}))}async setBypassCSP(e){await this._client.send("Page.setBypassCSP",{enabled:e})}async emulateMediaType(e){assert("screen"===e||"print"===e||null===e,"Unsupported media type: "+e),await this._client.send("Emulation.setEmulatedMedia",{media:e||""})}async emulateMediaFeatures(e){null===e&&await this._client.send("Emulation.setEmulatedMedia",{features:null}),Array.isArray(e)&&(e.every((e=>{const t=e.name;return assert(/^prefers-(?:color-scheme|reduced-motion)$/.test(t),"Unsupported media feature: "+t),!0})),await this._client.send("Emulation.setEmulatedMedia",{features:e}))}async emulateTimezone(e){try{await this._client.send("Emulation.setTimezoneOverride",{timezoneId:e||""})}catch(t){if(t.message.includes("Invalid timezone"))throw new Error(`Invalid timezone ID: ${e}`);throw t}}async emulateIdleState(e){e?await this._client.send("Emulation.setIdleOverride",{isUserActive:e.isUserActive,isScreenUnlocked:e.isScreenUnlocked}):await this._client.send("Emulation.clearIdleOverride")}async emulateVisionDeficiency(e){const t=new Set(["none","achromatopsia","blurredVision","deuteranopia","protanopia","tritanopia"]);try{assert(!e||t.has(e),`Unsupported vision deficiency: ${e}`),await this._client.send("Emulation.setEmulatedVisionDeficiency",{type:e||"none"})}catch(i){throw i}}async setViewport(e){const t=await this._emulationManager.emulateViewport(e);this._viewport=e,t&&await this.reload()}viewport(){return this._viewport}async evaluate(e,...t){return this._frameManager.mainFrame().evaluate(e,...t)}async evaluateOnNewDocument(e,...t){const i=helper.evaluationString(e,...t);await this._client.send("Page.addScriptToEvaluateOnNewDocument",{source:i})}async setCacheEnabled(e=!0){await this._frameManager.networkManager().setCacheEnabled(e)}async screenshot(e={}){let t=null;if(e.type)assert("png"===e.type||"jpeg"===e.type,"Unknown options.type value: "+e.type),t=e.type;else if(e.path){const i=e.path,a=i.slice(i.lastIndexOf(".")+1).toLowerCase();"png"===a?t="png":"jpg"!==a&&"jpeg"!==a||(t="jpeg"),assert(t,`Unsupported screenshot type for extension \`.${a}\``)}return t||(t="png"),e.quality&&(assert("jpeg"===t,"options.quality is unsupported for the "+t+" screenshots"),assert("number"===typeof e.quality,"Expected options.quality to be a number but found "+typeof e.quality),assert(Number.isInteger(e.quality),"Expected options.quality to be an integer"),assert(e.quality>=0&&e.quality<=100,"Expected options.quality to be between 0 and 100 (inclusive), got "+e.quality)),assert(!e.clip||!e.fullPage,"options.clip and options.fullPage are exclusive"),e.clip&&(assert("number"===typeof e.clip.x,"Expected options.clip.x to be a number but found "+typeof e.clip.x),assert("number"===typeof e.clip.y,"Expected options.clip.y to be a number but found "+typeof e.clip.y),assert("number"===typeof e.clip.width,"Expected options.clip.width to be a number but found "+typeof e.clip.width),assert("number"===typeof e.clip.height,"Expected options.clip.height to be a number but found "+typeof e.clip.height),assert(0!==e.clip.width,"Expected options.clip.width not to be 0."),assert(0!==e.clip.height,"Expected options.clip.height not to be 0.")),this._screenshotTaskQueue.postTask((()=>this._screenshotTask(t,e)))}async _screenshotTask(e,t){await this._client.send("Target.activateTarget",{targetId:this._target._targetId});let i=t.clip?function(e){const t=Math.round(e.x),i=Math.round(e.y),a=Math.round(e.width+e.x-t),r=Math.round(e.height+e.y-i);return{x:t,y:i,width:a,height:r,scale:1}}(t.clip):void 0;if(t.fullPage){const e=await this._client.send("Page.getLayoutMetrics"),t=Math.ceil(e.contentSize.width),a=Math.ceil(e.contentSize.height);i={x:0,y:0,width:t,height:a,scale:1};const{isMobile:r=!1,deviceScaleFactor:n=1,isLandscape:s=!1}=this._viewport||{},o=s?{angle:90,type:"landscapePrimary"}:{angle:0,type:"portraitPrimary"};await this._client.send("Emulation.setDeviceMetricsOverride",{mobile:r,width:t,height:a,deviceScaleFactor:n,screenOrientation:o})}const a=t.omitBackground&&"png"===e;a&&await this._client.send("Emulation.setDefaultBackgroundColorOverride",{color:{r:0,g:0,b:0,a:0}});const r=await this._client.send("Page.captureScreenshot",{format:e,quality:t.quality,clip:i});a&&await this._client.send("Emulation.setDefaultBackgroundColorOverride"),t.fullPage&&this._viewport&&await this.setViewport(this._viewport);const n="base64"===t.encoding?r.data:Buffer.from(r.data,"base64");if(!isNode&&t.path)throw new Error("Screenshots can only be written to a file path in a Node environment.");const s=await helper.importFSModule();return t.path&&await s.promises.writeFile(t.path,n),n}async pdf(e={}){const{scale:t=1,displayHeaderFooter:i=!1,headerTemplate:a="",footerTemplate:r="",printBackground:n=!1,landscape:s=!1,pageRanges:o="",preferCSSPageSize:c=!1,margin:l={},path:h=null}=e;let u=8.5,m=11;if(e.format){const t=paperFormats[e.format.toLowerCase()];assert(t,"Unknown paper format: "+e.format),u=t.width,m=t.height}else u=convertPrintParameterToInches(e.width)||u,m=convertPrintParameterToInches(e.height)||m;const d=convertPrintParameterToInches(l.top)||0,p=convertPrintParameterToInches(l.left)||0,g=convertPrintParameterToInches(l.bottom)||0,w=convertPrintParameterToInches(l.right)||0,f=await this._client.send("Page.printToPDF",{transferMode:"ReturnAsStream",landscape:s,displayHeaderFooter:i,headerTemplate:a,footerTemplate:r,printBackground:n,scale:t,paperWidth:u,paperHeight:m,marginTop:d,marginBottom:g,marginLeft:p,marginRight:w,pageRanges:o,preferCSSPageSize:c});return await helper.readProtocolStream(this._client,f.stream,h)}async title(){return this.mainFrame().title()}async close(e={runBeforeUnload:void 0}){assert(!!this._client._connection,"Protocol error: Connection closed. Most likely the page has been closed.");!!e.runBeforeUnload?await this._client.send("Page.close"):(await this._client._connection.send("Target.closeTarget",{targetId:this._target._targetId}),await this._target._isClosedPromise)}isClosed(){return this._closed}get mouse(){return this._mouse}click(e,t={}){return this.mainFrame().click(e,t)}focus(e){return this.mainFrame().focus(e)}hover(e){return this.mainFrame().hover(e)}select(e,...t){return this.mainFrame().select(e,...t)}tap(e){return this.mainFrame().tap(e)}type(e,t,i){return this.mainFrame().type(e,t,i)}waitFor(e,t={},...i){return this.mainFrame().waitFor(e,t,...i)}waitForTimeout(e){return this.mainFrame().waitForTimeout(e)}waitForSelector(e,t={}){return this.mainFrame().waitForSelector(e,t)}waitForXPath(e,t={}){return this.mainFrame().waitForXPath(e,t)}waitForFunction(e,t={},...i){return this.mainFrame().waitForFunction(e,t,...i)}}const supportedMetrics=new Set(["Timestamp","Documents","Frames","JSEventListeners","Nodes","LayoutCount","RecalcStyleCount","LayoutDuration","RecalcStyleDuration","ScriptDuration","TaskDuration","JSHeapUsedSize","JSHeapTotalSize"]),unitToPixels={px:1,in:96,cm:37.8,mm:3.78};function convertPrintParameterToInches(e){if("undefined"===typeof e)return;let t;if(helper.isNumber(e))t=e;else{if(!helper.isString(e))throw new Error("page.pdf() Cannot handle parameter type: "+typeof e);{const i=e;let a=i.substring(i.length-2).toLowerCase(),r="";unitToPixels.hasOwnProperty(a)?r=i.substring(0,i.length-2):(a="px",r=i);const n=Number(r);assert(!isNaN(n),"Failed to parse parameter value: "+i),t=n*unitToPixels[a]}}return t/96}