import*as childProcess from"child_process";import extractZip from"extract-zip";import*as fs from"fs";import*as http from"http";import*as https from"https";import createHttpsProxyAgent from"https-proxy-agent";import*as os from"os";import*as path from"path";import{getProxyForUrl}from"proxy-from-env";import removeRecursive from"rimraf";import*as URL from"url";import*as util from"util";import{promisify}from"util";import{assert}from"../common/assert.js";import{debug}from"../common/Debug.js";const debugFetcher=debug("puppeteer:fetcher"),downloadURLs={chrome:{linux:"%s/chromium-browser-snapshots/Linux_x64/%d/%s.zip",mac:"%s/chromium-browser-snapshots/Mac/%d/%s.zip",win32:"%s/chromium-browser-snapshots/Win/%d/%s.zip",win64:"%s/chromium-browser-snapshots/Win_x64/%d/%s.zip"},firefox:{linux:"%s/firefox-%s.en-US.%s-x86_64.tar.bz2",mac:"%s/firefox-%s.en-US.%s.dmg",win32:"%s/firefox-%s.en-US.%s.zip",win64:"%s/firefox-%s.en-US.%s.zip"}},browserConfig={chrome:{host:"https://storage.googleapis.com",destination:".local-chromium"},firefox:{host:"https://archive.mozilla.org/pub/firefox/nightly/latest-mozilla-central",destination:".local-firefox"}};function archiveName(t,o,r){if("chrome"===t){if("linux"===o)return"chrome-linux";if("mac"===o)return"chrome-mac";if("win32"===o||"win64"===o)return parseInt(r,10)>591479?"chrome-win":"chrome-win32"}else if("firefox"===t)return o}function downloadURL(t,o,r,e){return util.format(downloadURLs[t][o],r,e,archiveName(t,o,e))}function handleArm64(){fs.stat("/usr/bin/chromium-browser",(function(t,o){void 0===o&&fs.stat("/usr/bin/chromium",(function(t,o){if(void 0===o)throw console.error("The chromium binary is not available for arm64."),console.error("If you are on Ubuntu, you can install with: "),console.error("\n sudo apt install chromium\n"),console.error("\n sudo apt install chromium-browser\n"),new Error}))}))}const readdirAsync=promisify(fs.readdir.bind(fs)),mkdirAsync=promisify(fs.mkdir.bind(fs)),unlinkAsync=promisify(fs.unlink.bind(fs)),chmodAsync=promisify(fs.chmod.bind(fs));function existsAsync(t){return new Promise((o=>{fs.access(t,(t=>o(!t)))}))}export class BrowserFetcher{constructor(t,o={}){this._product=(o.product||"chrome").toLowerCase(),assert("chrome"===this._product||"firefox"===this._product,`Unknown product: "${o.product}"`),this._downloadsFolder=o.path||path.join(t,browserConfig[this._product].destination),this._downloadHost=o.host||browserConfig[this._product].host,this.setPlatform(o.platform),assert(downloadURLs[this._product][this._platform],"Unsupported platform: "+this._platform)}setPlatform(t){if(t)return void(this._platform=t);const o=os.platform();"darwin"===o?this._platform="mac":"linux"===o?this._platform="linux":"win32"===o?this._platform="x64"===os.arch()?"win64":"win32":assert(this._platform,"Unsupported platform: "+os.platform())}platform(){return this._platform}product(){return this._product}host(){return this._downloadHost}canDownload(t){const o=downloadURL(this._product,this._platform,this._downloadHost,t);return new Promise((t=>{httpRequest(o,"HEAD",(o=>{t(200===o.statusCode)})).on("error",(o=>{console.error(o),t(!1)}))}))}async download(t,o=(()=>{})){const r=downloadURL(this._product,this._platform,this._downloadHost,t),e=r.split("/").pop(),s=path.join(this._downloadsFolder,e),i=this._getFolderPath(t);if(await existsAsync(i))return this.revisionInfo(t);if(await existsAsync(this._downloadsFolder)||await mkdirAsync(this._downloadsFolder),"arm64"===os.arch())return void handleArm64();try{await downloadFile(r,s,o),await install(s,i)}finally{await existsAsync(s)&&await unlinkAsync(s)}const n=this.revisionInfo(t);return n&&await chmodAsync(n.executablePath,493),n}async localRevisions(){if(!await existsAsync(this._downloadsFolder))return[];return(await readdirAsync(this._downloadsFolder)).map((t=>parseFolderPath(this._product,t))).filter((t=>t&&t.platform===this._platform)).map((t=>t.revision))}async remove(t){const o=this._getFolderPath(t);assert(await existsAsync(o),`Failed to remove: revision ${t} is not downloaded`),await new Promise((t=>removeRecursive(o,t)))}revisionInfo(t){const o=this._getFolderPath(t);let r="";if("chrome"===this._product)if("mac"===this._platform)r=path.join(o,archiveName(this._product,this._platform,t),"Chromium.app","Contents","MacOS","Chromium");else if("linux"===this._platform)r=path.join(o,archiveName(this._product,this._platform,t),"chrome");else{if("win32"!==this._platform&&"win64"!==this._platform)throw new Error("Unsupported platform: "+this._platform);r=path.join(o,archiveName(this._product,this._platform,t),"chrome.exe")}else{if("firefox"!==this._product)throw new Error("Unsupported product: "+this._product);if("mac"===this._platform)r=path.join(o,"Firefox Nightly.app","Contents","MacOS","firefox");else if("linux"===this._platform)r=path.join(o,"firefox","firefox");else{if("win32"!==this._platform&&"win64"!==this._platform)throw new Error("Unsupported platform: "+this._platform);r=path.join(o,"firefox","firefox.exe")}}const e=downloadURL(this._product,this._platform,this._downloadHost,t),s=fs.existsSync(o);return debugFetcher({revision:t,executablePath:r,folderPath:o,local:s,url:e,product:this._product}),{revision:t,executablePath:r,folderPath:o,local:s,url:e,product:this._product}}_getFolderPath(t){return path.join(this._downloadsFolder,this._platform+"-"+t)}}function parseFolderPath(t,o){const r=path.basename(o).split("-");if(2!==r.length)return null;const[e,s]=r;return downloadURLs[t][e]?{product:t,platform:e,revision:s}:null}function downloadFile(t,o,r){let e,s;debugFetcher(`Downloading binary from ${t}`);let i=0,n=0;const a=new Promise(((t,o)=>{e=t,s=o}));return httpRequest(t,"GET",(i=>{if(200!==i.statusCode){const o=new Error(`Download failed: server returned code ${i.statusCode}. URL: ${t}`);return i.resume(),void s(o)}const a=fs.createWriteStream(o);a.on("finish",(()=>e())),a.on("error",(t=>s(t))),i.pipe(a),n=parseInt(i.headers["content-length"],10),r&&i.on("data",c)})).on("error",(t=>s(t))),a;function c(t){i+=t.length,r(i,n)}}function install(t,o){if(debugFetcher(`Installing ${t} to ${o}`),t.endsWith(".zip"))return extractZip(t,{dir:o});if(t.endsWith(".tar.bz2"))return extractTar(t,o);if(t.endsWith(".dmg"))return mkdirAsync(o).then((()=>installDMG(t,o)));throw new Error(`Unsupported archive format: ${t}`)}function extractTar(t,o){const r=require("tar-fs"),e=require("unbzip2-stream");return new Promise(((s,i)=>{const n=r.extract(o);n.on("error",i),n.on("finish",s);fs.createReadStream(t).pipe(e()).pipe(n)}))}function installDMG(t,o){let r;return new Promise((function(e,s){const i=`hdiutil attach -nobrowse -noautoopen "${t}"`;childProcess.exec(i,((t,i)=>{if(t)return s(t);const n=i.match(/\/Volumes\/(.*)/m);if(!n)return s(new Error(`Could not find volume path in ${i}`));r=n[0],readdirAsync(r).then((t=>{const i=t.filter((t=>"string"===typeof t&&t.endsWith(".app")))[0];if(!i)return s(new Error(`Cannot find app in ${r}`));const n=path.join(r,i);debugFetcher(`Copying ${n} to ${o}`),childProcess.exec(`cp -R "${n}" "${o}"`,(t=>{t?s(t):e()}))})).catch(s)}))})).catch((t=>{console.error(t)})).finally((function(){if(!r)return;const t=`hdiutil detach "${r}" -quiet`;debugFetcher(`Unmounting ${r}`),childProcess.exec(t,(t=>{t&&console.error(`Error unmounting dmg: ${t}`)}))}))}function httpRequest(t,o,r){let e={...URL.parse(t),method:o};const s=getProxyForUrl(t);if(s)if(t.startsWith("http:")){const t=URL.parse(s);e={path:e.href,host:t.hostname,port:t.port}}else{const t=URL.parse(s),o={...t,secureProxy:"https:"===t.protocol};e.agent=createHttpsProxyAgent(o),e.rejectUnauthorized=!1}const i=t=>{t.statusCode>=300&&t.statusCode<400&&t.headers.location?httpRequest(t.headers.location,o,r):r(t)},n="https:"===e.protocol?https.request(e,i):http.request(e,i);return n.end(),n}