import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as TimelineModel from"../timeline_model/timeline_model.js";import*as UI from"../ui/ui.js";import{Events}from"./PerformanceModel.js";const UIStrings={jsHeap:"JS Heap",documents:"Documents",nodes:"Nodes",listeners:"Listeners",gpuMemory:"GPU Memory",ss:"[{PH1}\xa0\u2013\xa0{PH2}]"},str_=i18n.i18n.registerUIStrings("timeline/CountersGraph.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class CountersGraph extends UI.Widget.VBox{constructor(t){super(),this.element.id="memory-graphs-container",this._delegate=t,this._calculator=new Calculator,this._model,this._header=new UI.Widget.HBox,this._header.element.classList.add("timeline-memory-header"),this._header.show(this.element),this._toolbar=new UI.Toolbar.Toolbar("timeline-memory-toolbar"),this._header.element.appendChild(this._toolbar.element),this._graphsContainer=new UI.Widget.VBox,this._graphsContainer.show(this.element);const e=new UI.Widget.VBoxWithResizeCallback(this._resize.bind(this));e.show(this._graphsContainer.element),this._createCurrentValuesBar(),this._canvasContainer=e.element,this._canvasContainer.id="memory-graphs-canvas-container",this._canvas=document.createElement("canvas"),this._canvasContainer.appendChild(this._canvas),this._canvas.id="memory-counters-graph",this._canvasContainer.addEventListener("mouseover",this._onMouseMove.bind(this),!0),this._canvasContainer.addEventListener("mousemove",this._onMouseMove.bind(this),!0),this._canvasContainer.addEventListener("mouseleave",this._onMouseLeave.bind(this),!0),this._canvasContainer.addEventListener("click",this._onClick.bind(this),!0),this._timelineGrid=new PerfUI.TimelineGrid.TimelineGrid,this._canvasContainer.appendChild(this._timelineGrid.dividersElement),this._counters=[],this._counterUI=[],this._countersByName=new Map,this._countersByName.set("jsHeapSizeUsed",this._createCounter(i18nString(UIStrings.jsHeap),"hsl(220, 90%, 43%)",Platform.NumberUtilities.bytesToString)),this._countersByName.set("documents",this._createCounter(i18nString(UIStrings.documents),"hsl(0, 90%, 43%)")),this._countersByName.set("nodes",this._createCounter(i18nString(UIStrings.nodes),"hsl(120, 90%, 43%)")),this._countersByName.set("jsEventListeners",this._createCounter(i18nString(UIStrings.listeners),"hsl(38, 90%, 43%)")),this._gpuMemoryCounter=this._createCounter(i18nString(UIStrings.gpuMemory),"hsl(300, 90%, 43%)",Platform.NumberUtilities.bytesToString),this._countersByName.set("gpuMemoryUsedKB",this._gpuMemoryCounter)}setModel(t,e){this._model!==t&&(this._model&&this._model.removeEventListener(Events.WindowChanged,this._onWindowChanged,this),this._model=t,this._model&&this._model.addEventListener(Events.WindowChanged,this._onWindowChanged,this)),this._calculator.setZeroTime(t?t.timelineModel().minimumRecordTime():0);for(let s=0;s<this._counters.length;++s)this._counters[s].reset(),this._counterUI[s].reset();if(this.scheduleRefresh(),this._track=e,!e)return;const i=e.syncEvents();for(let s=0;s<i.length;++s){const t=i[s];if(t.name!==TimelineModel.TimelineModel.RecordType.UpdateCounters)continue;const e=t.args.data;if(!e)return;for(const i in e){const s=this._countersByName.get(i);s&&s.appendSample(t.startTime,e[i])}const r="gpuMemoryLimitKB";r in e&&this._gpuMemoryCounter.setLimit(e[r])}}_createCurrentValuesBar(){this._currentValuesBar=this._graphsContainer.element.createChild("div"),this._currentValuesBar.id="counter-values-bar"}_createCounter(t,e,i){const s=new Counter;return this._counters.push(s),this._counterUI.push(new CounterUI(this,t,e,s,i)),s}resizerElement(){return this._header.element}_resize(){const t=this._canvas.parentElement;this._canvas.width=t.clientWidth*window.devicePixelRatio,this._canvas.height=t.clientHeight*window.devicePixelRatio,this._calculator.setDisplayWidth(this._canvas.width),this.refresh()}_onWindowChanged(t){const e=t.data.window;this._calculator.setWindow(e.left,e.right),this.scheduleRefresh()}scheduleRefresh(){UI.UIUtils.invokeOnceAfterBatchUpdate(this,this.refresh)}draw(){this._clear();for(const t of this._counters)t._calculateVisibleIndexes(this._calculator),t._calculateXValues(this._canvas.width);for(const t of this._counterUI)t._drawGraph(this._canvas)}_onClick(t){const e=t.x-this._canvasContainer.totalOffsetLeft();let i,s=1/0;for(const r of this._counterUI){if(!r.counter.times.length)continue;const t=r._recordIndexAt(e),n=Math.abs(e*window.devicePixelRatio-r.counter.x[t]);n<s&&(s=n,i=r.counter.times[t])}void 0!==i&&this._track&&this._delegate.selectEntryAtTime(this._track.events.length?this._track.events:this._track.asyncEvents,i)}_onMouseLeave(t){delete this._markerXPosition,this._clearCurrentValueAndMarker()}_clearCurrentValueAndMarker(){for(let t=0;t<this._counterUI.length;t++)this._counterUI[t]._clearCurrentValueAndMarker()}_onMouseMove(t){const e=t.x-this._canvasContainer.totalOffsetLeft();this._markerXPosition=e,this._refreshCurrentValues()}_refreshCurrentValues(){if(void 0!==this._markerXPosition)for(let t=0;t<this._counterUI.length;++t)this._counterUI[t].updateCurrentValue(this._markerXPosition)}refresh(){this._timelineGrid.updateDividers(this._calculator),this.draw(),this._refreshCurrentValues()}_clear(){const t=this._canvas.getContext("2d");if(!t)throw new Error("Unable to get canvas context");t.clearRect(0,0,t.canvas.width,t.canvas.height)}}export class Counter{constructor(){this.times=[],this.values=[],this.x=[],this._minimumIndex=0,this._maximumIndex=0,this._maxTime=0,this._minTime=0}appendSample(t,e){this.values.length&&this.values[this.values.length-1]===e||(this.times.push(t),this.values.push(e))}reset(){this.times=[],this.values=[]}setLimit(t){this._limitValue=t}_calculateBounds(){let t,e;for(let i=this._minimumIndex;i<=this._maximumIndex;i++){const s=this.values[i];(void 0===e||s<e)&&(e=s),(void 0===t||s>t)&&(t=s)}return e=e||0,t=t||1,this._limitValue&&(t>.5*this._limitValue&&(t=Math.max(t,this._limitValue)),e=Math.min(e,this._limitValue)),{min:e,max:t}}_calculateVisibleIndexes(t){const e=t.minimumBoundary(),i=t.maximumBoundary();this._minimumIndex=Platform.NumberUtilities.clamp(Platform.ArrayUtilities.upperBound(this.times,e,Platform.ArrayUtilities.DEFAULT_COMPARATOR)-1,0,this.times.length-1),this._maximumIndex=Platform.NumberUtilities.clamp(Platform.ArrayUtilities.lowerBound(this.times,i,Platform.ArrayUtilities.DEFAULT_COMPARATOR),0,this.times.length-1),this._minTime=e,this._maxTime=i}_calculateXValues(t){if(!this.values.length)return;const e=t/(this._maxTime-this._minTime);this.x=new Array(this.values.length);for(let i=this._minimumIndex+1;i<=this._maximumIndex;i++)this.x[i]=e*(this.times[i]-this._minTime)}}export class CounterUI{constructor(t,e,i,s,r){this._countersPane=t,this.counter=s,this._formatter=r||Number.withThousandsSeparator,this._setting=Common.Settings.Settings.instance().createSetting("timelineCountersGraph-"+e,!0),this._setting.setTitle(e),this._filter=new UI.Toolbar.ToolbarSettingCheckbox(this._setting,e),this._filter.inputElement.classList.add("-theme-preserve-input");const n=Common.Color.Color.parse(i);if(n){const t=n.setAlpha(.5).asString(Common.Color.Format.RGBA),e=this._filter.element;t&&(e.style.backgroundColor=t),e.style.borderColor="transparent"}this._filter.inputElement.addEventListener("click",this._toggleCounterGraph.bind(this)),t._toolbar.appendToolbarItem(this._filter),this._range=this._filter.element.createChild("span","range"),this._value=t._currentValuesBar.createChild("span","memory-counter-value"),this._value.style.color=i,this.graphColor=i,n&&(this.limitColor=n.setAlpha(.3).asString(Common.Color.Format.RGBA)),this.graphYValues=[],this._verticalPadding=10,this._currentValueLabel=e,this._marker=t._canvasContainer.createChild("div","memory-counter-marker"),this._marker.style.backgroundColor=i,this._clearCurrentValueAndMarker()}reset(){this._range.textContent=""}setRange(t,e){const i=this._formatter(t),s=this._formatter(e);this._range.textContent=i18nString(UIStrings.ss,{PH1:i,PH2:s})}_toggleCounterGraph(){this._value.classList.toggle("hidden",!this._filter.checked()),this._countersPane.refresh()}_recordIndexAt(t){return Platform.ArrayUtilities.upperBound(this.counter.x,t*window.devicePixelRatio,Platform.ArrayUtilities.DEFAULT_COMPARATOR,this.counter._minimumIndex+1,this.counter._maximumIndex+1)-1}updateCurrentValue(t){if(!this.visible()||!this.counter.values.length||!this.counter.x)return;const e=this._recordIndexAt(t),i=Number.withThousandsSeparator(this.counter.values[e]);this._value.textContent=`${this._currentValueLabel}: ${i}`;const s=this.graphYValues[e]/window.devicePixelRatio;this._marker.style.left=t+"px",this._marker.style.top=s+"px",this._marker.classList.remove("hidden")}_clearCurrentValueAndMarker(){this._value.textContent="",this._marker.classList.add("hidden")}_drawGraph(t){const e=t.getContext("2d");if(!e)throw new Error("Unable to get canvas context");const i=t.width,s=t.height-2*this._verticalPadding;if(s<=0)return void(this.graphYValues=[]);const r=this._verticalPadding,n=this.counter,a=n.values;if(!a.length)return;const o=n._calculateBounds(),h=o.min,l=o.max;if(this.setRange(h,l),!this.visible())return;const m=this.graphYValues,u=l-h,c=u?s/u:1;e.save(),e.lineWidth=window.devicePixelRatio,e.lineWidth%2&&e.translate(.5,.5),e.beginPath();let d=a[n._minimumIndex],_=Math.round(r+s-(d-h)*c);e.moveTo(0,_);let g=n._minimumIndex;for(;g<=n._maximumIndex;g++){const t=Math.round(n.x[g]);e.lineTo(t,_);const i=a[g];"undefined"!==typeof i&&(d=i),_=Math.round(r+s-(d-h)*c),e.lineTo(t,_),m[g]=_}if(m.length=g,e.lineTo(i,_),e.strokeStyle=this.graphColor,e.stroke(),n._limitValue){const t=Math.round(r+s-(n._limitValue-h)*c);e.moveTo(0,t),e.lineTo(i,t),this.limitColor&&(e.strokeStyle=this.limitColor),e.stroke()}e.closePath(),e.restore()}visible(){return this._filter.checked()}}export class Calculator{constructor(){this._minimumBoundary=0,this._maximumBoundary=0,this._workingArea=0,this._zeroTime=0}setZeroTime(t){this._zeroTime=t}computePosition(t){return(t-this._minimumBoundary)/this.boundarySpan()*this._workingArea}setWindow(t,e){this._minimumBoundary=t,this._maximumBoundary=e}setDisplayWidth(t){this._workingArea=t}formatValue(t,e){return Number.preciseMillisToString(t-this.zeroTime(),e)}maximumBoundary(){return this._maximumBoundary}minimumBoundary(){return this._minimumBoundary}zeroTime(){return this._zeroTime}boundarySpan(){return this._maximumBoundary-this._minimumBoundary}}