import*as Coverage from"../coverage/coverage.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as TimelineModel from"../timeline_model/timeline_model.js";import*as UI from"../ui/ui.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={net:"NET",cpu:"CPU",fps:"FPS",heap:"HEAP",sSDash:"{PH1} \u2013 {PH2}",coverage:"COVERAGE"},str_=i18n.i18n.registerUIStrings("timeline/TimelineEventOverview.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineEventOverview extends PerfUI.TimelineOverviewPane.TimelineOverviewBase{constructor(e,t){super(),this.element.id="timeline-overview-"+e,this.element.classList.add("overview-strip"),this._model=null,t&&(this.element.createChild("div","timeline-overview-strip-title").textContent=t)}setModel(e){this._model=e}_renderBar(e,t,i,n,o){const s=e,r=t-e,l=this.context();l.fillStyle=o,l.fillRect(s,i,r,n)}}export class TimelineEventOverviewInput extends TimelineEventOverview{constructor(){super("input",null)}update(){if(super.update(),!this._model)return;const e=this.height(),t=TimelineUIUtils.eventDispatchDesciptors(),i=new Map;let n=-1;for(const m of t){for(const e of m.eventTypes)i.set(e,m);n=Math.max(n,m.priority)}const o=2*window.devicePixelRatio,s=this._model.timelineModel().minimumRecordTime(),r=this._model.timelineModel().maximumRecordTime()-s,l=this.width(),a=l/r;for(let m=0;m<=n;++m)for(const t of this._model.timelineModel().tracks())for(let n=0;n<t.events.length;++n){const r=t.events[n];if(r.name!==TimelineModel.TimelineModel.RecordType.EventDispatch)continue;const h=i.get(r.args.data.type);if(!h||h.priority!==m)continue;if(void 0===r.endTime)continue;const d=Platform.NumberUtilities.clamp(Math.floor((r.startTime-s)*a),0,l),c=Platform.NumberUtilities.clamp(Math.ceil((r.endTime-s)*a),0,l),u=Math.max(c-d,o);this._renderBar(d,d+u,0,e,h.color)}}}export class TimelineEventOverviewNetwork extends TimelineEventOverview{constructor(){super("network",i18nString(UIStrings.net))}update(){if(super.update(),!this._model)return;const e=this._model.timelineModel(),t=this.height()/2,i=e.minimumRecordTime(),n=e.maximumRecordTime()-i,o=this.width(),s=o/n,r=new Path2D,l=new Path2D,a=Protocol.Network.ResourcePriority,m=new Set([a.VeryHigh,a.High,a.Medium]);for(const d of e.networkRequests()){const e=m.has(d.priority)?r:l,n=Math.max(Math.floor((d.startTime-i)*s),0),a=Math.min(Math.ceil((d.endTime-i)*s+1),o);e.rect(n,0,a-n,t-1)}const h=this.context();h.save(),h.fillStyle="hsl(214, 60%, 60%)",h.fill(r),h.translate(0,t),h.fillStyle="hsl(214, 80%, 80%)",h.fill(l),h.restore()}}const categoryToIndex=new WeakMap;export class TimelineEventOverviewCPUActivity extends TimelineEventOverview{constructor(){super("cpu-activity",i18nString(UIStrings.cpu)),this._backgroundCanvas=this.element.createChild("canvas","fill background")}resetCanvas(){super.resetCanvas(),this._backgroundCanvas.width=this.element.clientWidth*window.devicePixelRatio,this._backgroundCanvas.height=this.element.clientHeight*window.devicePixelRatio}update(){if(super.update(),!this._model)return;const e=this._model.timelineModel(),t=4*window.devicePixelRatio,i=this.width(),n=this.height(),o=n,s=e.minimumRecordTime(),r=e.maximumRecordTime()-s,l=t/(i/r),a=TimelineUIUtils.categories(),m=TimelineUIUtils.getTimelineMainEventCategories(),h=m.indexOf("other");console.assert(0===m.indexOf("idle"));for(let u=1;u<m.length;++u)categoryToIndex.set(a[m[u]],u);const d=this._backgroundCanvas.getContext("2d");if(!d)throw new Error("Could not find 2d canvas");for(const u of e.tracks())u.type===TimelineModel.TimelineModel.TrackType.MainThread&&u.forMainFrame?c(this.context(),u.events):c(d,u.events);function c(e,d){const c=new Quantizer(s,l,(function(e){let i=o;for(let o=1;o<m.length;++o){const s=(e[o]||0)/l*n;i-=s,v[o].bezierCurveTo(u,p[o],u,i,u+t/2,i),p[o]=i}u+=t}));let u=0;const f=[],v=[],p=[];for(let t=0;t<m.length;++t)v[t]=new Path2D,v[t].moveTo(0,n),p[t]=n;TimelineModel.TimelineModel.TimelineModelImpl.forEachEvent(d,(function(e){const t=f.length?f[f.length-1]:0;c.appendInterval(e.startTime,t),f.push(categoryToIndex.get(TimelineUIUtils.eventStyle(e).category)||h)}),(function(e){const t=f.pop();void 0!==e.endTime&&t&&c.appendInterval(e.endTime,t)})),c.appendInterval(s+r+l,0);for(let t=m.length-1;t>0;--t)v[t].lineTo(i,n),e.fillStyle=a[m[t]].color,e.fill(v[t])}!function(e){const t=4*window.devicePixelRatio;e.save(),e.lineWidth=t/Math.sqrt(8);for(let o=.5;o<i+n;o+=t)e.moveTo(o,0),e.lineTo(o-n,n);e.globalCompositeOperation="destination-out",e.stroke(),e.restore()}(d)}}export class TimelineEventOverviewResponsiveness extends TimelineEventOverview{constructor(){super("responsiveness",null)}update(){if(super.update(),!this._model)return;const e=this.height(),t=this._model.timelineModel().minimumRecordTime(),i=this._model.timelineModel().maximumRecordTime()-t,n=this.width()/i,o=this._model.frames(),s=this.context(),r=new Path2D,l=new Path2D;for(let m=0;m<o.length;++m){const e=o[m];e.hasWarnings()&&a(e.startTime,e.duration)}for(const m of this._model.timelineModel().tracks()){const e=m.events;for(let t=0;t<e.length;++t){if(!TimelineModel.TimelineModel.TimelineData.forEvent(e[t]).warning)continue;const i=e[t].duration;void 0!==i&&a(e[t].startTime,i)}}function a(i,o){const s=Math.round(n*(i-t)),a=Math.round(n*o);r.rect(s,0,a,e),l.moveTo(s+a,0),l.lineTo(s+a,e)}s.fillStyle="hsl(0, 80%, 90%)",s.strokeStyle="red",s.lineWidth=2*window.devicePixelRatio,s.fill(r),s.stroke(l)}}export class TimelineFilmStripOverview extends TimelineEventOverview{constructor(){super("filmstrip",null),this._frameToImagePromise=new Map,this._lastFrame=null,this._lastElement=null,this.reset()}update(){super.update();const e=this._model?this._model.filmStripModel().frames():[];if(!e.length)return;const t=Symbol("drawGeneration");this._drawGeneration=t,this._imageByFrame(e[0]).then((e=>{if(this._drawGeneration!==t)return;if(!e||!e.naturalWidth||!e.naturalHeight)return;const i=this.height()-2*TimelineFilmStripOverview.Padding,n=Math.ceil(i*e.naturalWidth/e.naturalHeight),o=Math.min(200/e.naturalWidth,1);this._emptyImage=new Image(e.naturalWidth*o,e.naturalHeight*o),this._drawFrames(n,i)}))}async _imageByFrame(e){let t=this._frameToImagePromise.get(e);if(!t){const i=await e.imageDataPromise();t=UI.UIUtils.loadImageFromData(i),this._frameToImagePromise.set(e,t)}return t}_drawFrames(e,t){if(!e||!this._model)return;const i=this._model.filmStripModel();if(!i.frames().length)return;const n=TimelineFilmStripOverview.Padding,o=this.width(),s=i.zeroTime(),r=i.spanTime()/o,l=this.context(),a=this._drawGeneration;l.beginPath();for(let h=n;h<o;h+=e+2*n){const n=s+(h+e/2)*r,o=i.frameByTimestamp(n);o&&(l.rect(h-.5,.5,e+1,t+1),this._imageByFrame(o).then(m.bind(this,h)))}function m(i,n){this._drawGeneration===a&&n&&l.drawImage(n,i,1,e,t)}l.strokeStyle="#ddd",l.stroke()}async overviewInfoPromise(e){if(!this._model||!this._model.filmStripModel().frames().length)return null;const t=this.calculator();if(!t)return null;const i=t.positionToTime(e),n=this._model.filmStripModel().frameByTimestamp(i);if(n===this._lastFrame)return this._lastElement;const o=n?this._imageByFrame(n):Promise.resolve(this._emptyImage),s=await o,r=document.createElement("div");return r.classList.add("frame"),s&&r.createChild("div","thumbnail").appendChild(s),this._lastFrame=n,this._lastElement=r,r}reset(){this._lastFrame=null,this._lastElement=null,this._frameToImagePromise=new Map,this._imageWidth=0}}TimelineFilmStripOverview.Padding=2;export class TimelineEventOverviewFrames extends TimelineEventOverview{constructor(){super("framerate",i18nString(UIStrings.fps))}update(){if(super.update(),!this._model)return;const e=this._model.frames();if(!e.length)return;const t=this.height(),i=Number(window.devicePixelRatio),n=t-2*i,o=this._model.timelineModel().minimumRecordTime(),s=this._model.timelineModel().maximumRecordTime()-o,r=this.width()/s,l=t-i,a=this.context(),m=l+10*window.devicePixelRatio;let h=0,d=m;const c=window.devicePixelRatio,u=1&c?.5:0,f=1.5*window.devicePixelRatio;a.beginPath(),a.moveTo(0,d);for(let p=0;p<e.length;++p){const t=e[p];h=Math.round((t.startTime-o)*r)+u,a.lineTo(h,d),a.lineTo(h,d+f),d=t.idle?m:Math.round(l-n*Math.min(16.666666666666668/t.duration,1))-u,a.lineTo(h,d+f),a.lineTo(h,d)}const v=e[e.length-1];v&&(h=Math.round((v.startTime+v.duration-o)*r)+u),a.lineTo(h,d),a.lineTo(h,m),a.fillStyle="hsl(110, 50%, 88%)",a.strokeStyle="hsl(110, 50%, 60%)",a.lineWidth=c,a.fill(),a.stroke()}}export class TimelineEventOverviewMemory extends TimelineEventOverview{constructor(){super("memory",i18nString(UIStrings.heap)),this._heapSizeLabel=this.element.createChild("div","memory-graph-label")}resetHeapSizeLabels(){this._heapSizeLabel.textContent=""}update(){super.update();const e=window.devicePixelRatio;if(!this._model)return void this.resetHeapSizeLabels();const t=this._model.timelineModel().tracks().filter((e=>e.type===TimelineModel.TimelineModel.TrackType.MainThread&&e.forMainFrame)).map((e=>e.events)),i=3*e;let n=0,o=1e11;const s=this._model.timelineModel().minimumRecordTime(),r=this._model.timelineModel().maximumRecordTime();function l(e){return e.name===TimelineModel.TimelineModel.RecordType.UpdateCounters}for(let w=0;w<t.length;w++)t[w]=t[w].filter(l);function a(e){const t=e.args.data;t&&t.jsHeapSizeUsed&&(n=Math.max(n,t.jsHeapSizeUsed),o=Math.min(o,t.jsHeapSizeUsed))}for(let w=0;w<t.length;w++)t[w].forEach(a);o=Math.min(o,n);const m=this.width(),h=this.height()-i,d=m/(r-s),c=(h-1)/Math.max(n-o,1),u=new Array(m);function f(e){const t=e.args.data;if(!t||!t.jsHeapSizeUsed)return;const i=Math.round((e.startTime-s)*d),n=Math.round((t.jsHeapSizeUsed-o)*c);u[i]=Math.max(u[i]||0,n)}for(let w=0;w<t.length;w++)t[w].forEach(f);const v=this.context(),p=h+i+1;v.translate(.5,.5),v.beginPath(),v.moveTo(-1,p);let T=0,g=!0,_=0;for(let w=0;w<u.length;w++){if("undefined"===typeof u[w])continue;g&&(g=!1,T=u[w],v.lineTo(-1,h-T));const e=u[w];Math.abs(e-T)>2&&Math.abs(w-_)>1&&v.lineTo(w,h-T),T=e,v.lineTo(w,h-T),_=w}v.lineTo(m+1,h-T),v.lineTo(m+1,p),v.closePath(),v.fillStyle="hsla(220, 90%, 70%, 0.2)",v.fill(),v.lineWidth=1,v.strokeStyle="hsl(220, 90%, 70%)",v.stroke(),this._heapSizeLabel.textContent=i18nString(UIStrings.sSDash,{PH1:Platform.NumberUtilities.bytesToString(o),PH2:Platform.NumberUtilities.bytesToString(n)})}}export class Quantizer{constructor(e,t,i){this._lastTime=e,this._quantDuration=t,this._callback=i,this._counters=[],this._remainder=t}appendInterval(e,t){let i=e-this._lastTime;if(i<=this._remainder)return this._counters[t]=(this._counters[t]||0)+i,this._remainder-=i,void(this._lastTime=e);for(this._counters[t]=(this._counters[t]||0)+this._remainder,this._callback(this._counters),i-=this._remainder;i>=this._quantDuration;){const e=[];e[t]=this._quantDuration,this._callback(e),i-=this._quantDuration}this._counters=[],this._counters[t]=i,this._lastTime=e,this._remainder=this._quantDuration-i}}export class TimelineEventOverviewCoverage extends TimelineEventOverview{constructor(){super("coverage",i18nString(UIStrings.coverage)),this._heapSizeLabel=this.element.createChild("div","timeline-overview-coverage-label")}resetHeapSizeLabels(){this._heapSizeLabel.textContent=""}setModel(e){if(super.setModel(e),e){const t=e.mainTarget();t&&(this._coverageModel=t.model(Coverage.CoverageModel.CoverageModel))}}update(){super.update();const e=window.devicePixelRatio;if(!this._coverageModel)return;let t=0,i=0;const n=new Map,o=new Map;for(const S of this._coverageModel.entries())for(const e of S.entries()){t+=e.size();for(const[t,s]of e.usedByTimestamp()){i+=s;let r=o.get(t);void 0===r&&(r=new Set,o.set(t,r)),r.add(e);const l=n.get(t);void 0===l?n.set(t,s):n.set(t,l+s)}}const s=new Set,r=new Map;let l=0,a=0;const m=Array.from(o.entries()).sort(((e,t)=>e[0]-t[0]));for(const[S,y]of m){for(const e of y.values())s.has(e)||(s.add(e),l+=e.size());a+=n.get(S)||0,r.set(S,a/l)}const h=t?Math.round(100*i/t):0,d=3*e;if(!this._model)return;const c=this._model.timelineModel().minimumRecordTime()/1e3,u=this._model.timelineModel().maximumRecordTime()/1e3,f=this.width(),v=this.height()-d,p=f/(u-c),T=v-1;let g=0;const _=this.context(),w=v+d+1;_.translate(.5,.5),_.beginPath(),_.moveTo(-1,w),_.lineTo(-1,v-g);let M=null;for(const S of this._coverageModel.coverageUpdateTimes()){const e=r.get(S)||M;if(M=e,!e)continue;if(S>u)break;const t=(S-c)*p;g=e*T,_.lineTo(t,v-g)}const x="hsl(220, 90%, 70%)";_.lineTo(f+1,v-g),_.lineTo(f+1,w),_.closePath(),_.fillStyle="hsla(220, 90%, 70%, 0.2)",_.fill(),_.lineWidth=1,_.strokeStyle=x,_.stroke(),M=null;for(const S of this._coverageModel.coverageUpdateTimes()){const e=r.get(S)||M;if(M=e,!e)continue;_.beginPath();const t=(S-c)*p,i=v-e*T;_.arc(t,i,2,0,2*Math.PI,!1),_.closePath(),_.stroke(),_.fillStyle=r.has(S)?x:"hsl(0, 100%, 100%)",_.fill()}this._heapSizeLabel.textContent=`${h}% used`}}