import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as TimelineModel from"../timeline_model/timeline_model.js";import*as UI from"../ui/ui.js";import{FlameChartStyle,Selection,TimelineFlameChartMarker}from"./TimelineFlameChartView.js";import{TimelineSelection}from"./TimelinePanel.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={onIgnoreList:"On ignore list",unexpectedEntryindexD:"Unexpected entryIndex {PH1}",input:"Input",animation:"Animation",timings:"Timings",console:"Console",mainS:"Main \u2014 {PH1}",main:"Main",frameS:"Frame \u2014 {PH1}",subframe:"Subframe",raster:"Raster",rasterizerThreadS:"Rasterizer Thread {PH1}",gpu:"GPU",thread:"Thread",experience:"Experience",interactions:"Interactions",frames:"Frames",sSelfS:"{PH1} (self {PH2})",occurrencesS:"Occurrences: {PH1}",sFfps:"{PH1} ~ {PH2}\xa0fps",idleFrame:"Idle Frame",droppedFrame:"Dropped Frame",frame:"Frame",longFrame:"Long frame",threadS:"Thread {PH1}"},str_=i18n.i18n.registerUIStrings("timeline/TimelineFlameChartDataProvider.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineFlameChartDataProvider extends Common.ObjectWrapper.ObjectWrapper{constructor(){super(),this.reset(),this._font="11px "+Host.Platform.fontFamily(),this._timelineData=null,this._currentLevel=0,this._performanceModel=null,this._model=null,this._minimumBoundary=0,this._maximumBoundary=0,this._timeSpan=0,this._consoleColorGenerator=new Common.Color.Generator({min:30,max:55,count:void 0},{min:70,max:100,count:6},50,.7),this._extensionColorGenerator=new Common.Color.Generator({min:210,max:300,count:void 0},{min:70,max:100,count:6},70,.7),this._headerLevel1=this._buildGroupStyle({shareHeaderLine:!1}),this._headerLevel2=this._buildGroupStyle({padding:2,nestingLevel:1,collapsible:!1}),this._staticHeader=this._buildGroupStyle({collapsible:!1}),this._framesHeader=this._buildGroupStyle({useFirstLineForOverview:!0}),this._collapsibleTimingsHeader=this._buildGroupStyle({shareHeaderLine:!0,useFirstLineForOverview:!0,collapsible:!0}),this._timingsHeader=this._buildGroupStyle({shareHeaderLine:!0,useFirstLineForOverview:!0,collapsible:!1}),this._screenshotsHeader=this._buildGroupStyle({useFirstLineForOverview:!0,nestingLevel:1,collapsible:!1,itemsHeight:150}),this._interactionsHeaderLevel1=this._buildGroupStyle({useFirstLineForOverview:!0}),this._interactionsHeaderLevel2=this._buildGroupStyle({padding:2,nestingLevel:1}),this._experienceHeader=this._buildGroupStyle({collapsible:!1}),this._flowEventIndexById=new Map,this._entryData,this._entryTypeByLevel,this._markers,this._asyncColorByInteractionPhase,this._screenshotImageCache,this._extensionInfo,this._entryIndexToTitle,this._asyncColorByCategory,this._lastInitiatorEntry,this._entryParent}_buildGroupStyle(e){const t={padding:4,height:17,collapsible:!0,color:ThemeSupport.ThemeSupport.instance().patchColorText("#222",ThemeSupport.ThemeSupport.ColorUsage.Foreground),backgroundColor:ThemeSupport.ThemeSupport.instance().patchColorText("white",ThemeSupport.ThemeSupport.ColorUsage.Background),font:this._font,nestingLevel:0,shareHeaderLine:!0};return Object.assign(t,e)}setModel(e){this.reset(),this._performanceModel=e,this._model=e&&e.timelineModel()}groupTrack(e){return e.track||null}navStartTimes(){return this._model?this._model.navStartTimes():new Map}entryTitle(e){const t=EntryType,n=this._entryType(e);if(n===t.Event){const t=this._entryData[e];return t.phase===SDK.TracingModel.Phase.AsyncStepInto||t.phase===SDK.TracingModel.Phase.AsyncStepPast?t.name+":"+t.args.step:eventToDisallowRoot.get(t)?i18nString(UIStrings.onIgnoreList):this._performanceModel&&this._performanceModel.timelineModel().isMarkerEvent(t)?TimelineUIUtils.markerShortTitle(t):TimelineUIUtils.eventTitle(t)}if(n===t.ExtensionEvent){return this._entryData[e].name}if(n===t.Screenshot)return"";let i=this._entryIndexToTitle[e];return i||(i=i18nString(UIStrings.unexpectedEntryindexD,{PH1:e}),console.error(i)),i}textColor(e){const t=this._entryData[e];return t&&eventToDisallowRoot.get(t)?"#888":FlameChartStyle.textColor}entryFont(e){return this._font}reset(){this._currentLevel=0,this._timelineData=null,this._entryData=[],this._entryParent=[],this._entryTypeByLevel=[],this._entryIndexToTitle=[],this._markers=[],this._asyncColorByCategory=new Map,this._asyncColorByInteractionPhase=new Map,this._extensionInfo=[],this._screenshotImageCache=new Map}maxStackDepth(){return this._currentLevel}timelineData(){return this._timelineData?this._timelineData:(this._timelineData=new PerfUI.FlameChart.TimelineData([],[],[],[]),this._model?(this._flowEventIndexById.clear(),this._minimumBoundary=this._model.minimumRecordTime(),this._timeSpan=this._model.isEmpty()?1e3:this._model.maximumRecordTime()-this._minimumBoundary,this._currentLevel=0,this._model.isGenericTrace()?this._processGenericTrace():this._processInspectorTrace(),this._timelineData):this._timelineData)}_processGenericTrace(){const e=this._buildGroupStyle({shareHeaderLine:!1}),t=this._buildGroupStyle({padding:2,nestingLevel:1,shareHeaderLine:!1}),n=EntryType.Event,i=new Platform.MapUtilities.Multimap;if(this._model){for(const e of this._model.tracks())null!==e.thread?i.set(e.thread.process(),e):console.error("Failed to process track");for(const r of i.keysArray()){if(i.size>1){const t=`${r.name()} ${r.id()}`;this._appendHeader(t,e,!1)}for(const e of i.get(r)){const i=this._appendSyncEvents(e,e.events,e.name,t,n,!0);!this._timelineData||this._timelineData.selectedGroup&&e.name!==TimelineModel.TimelineModel.TimelineModelImpl.BrowserMainThreadName||(this._timelineData.selectedGroup=i)}}}}_processInspectorTrace(){this._appendFrames(),this._appendInteractionRecords();const e=EntryType.Event,t=e=>{switch(e.type){case TimelineModel.TimelineModel.TrackType.Input:return 0;case TimelineModel.TimelineModel.TrackType.Animation:return 1;case TimelineModel.TimelineModel.TrackType.Timings:return 2;case TimelineModel.TimelineModel.TrackType.Console:return 3;case TimelineModel.TimelineModel.TrackType.Experience:return 4;case TimelineModel.TimelineModel.TrackType.MainThread:return e.forMainFrame?5:6;case TimelineModel.TimelineModel.TrackType.Worker:return 7;case TimelineModel.TimelineModel.TrackType.Raster:return 8;case TimelineModel.TimelineModel.TrackType.GPU:return 9;case TimelineModel.TimelineModel.TrackType.Other:return 10;default:return-1}};if(!this._model)return;const n=this._model.tracks().slice();n.sort(((e,n)=>t(e)-t(n)));let i=0;for(const r of n)switch(r.type){case TimelineModel.TimelineModel.TrackType.Input:this._appendAsyncEventsGroup(r,i18nString(UIStrings.input),r.asyncEvents,this._interactionsHeaderLevel2,e,!1);break;case TimelineModel.TimelineModel.TrackType.Animation:this._appendAsyncEventsGroup(r,i18nString(UIStrings.animation),r.asyncEvents,this._interactionsHeaderLevel2,e,!1);break;case TimelineModel.TimelineModel.TrackType.Timings:{const t=r.asyncEvents.length>0?this._collapsibleTimingsHeader:this._timingsHeader;this._appendHeader(i18nString(UIStrings.timings),t,!0).track=r,this._appendPageMetrics(),this._copyPerfMarkEvents(r),this._appendSyncEvents(r,r.events,null,null,e,!0),this._appendAsyncEventsGroup(r,null,r.asyncEvents,null,e,!0);break}case TimelineModel.TimelineModel.TrackType.Console:this._appendAsyncEventsGroup(r,i18nString(UIStrings.console),r.asyncEvents,this._headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.MainThread:if(r.forMainFrame){const t=this._appendSyncEvents(r,r.events,r.url?i18nString(UIStrings.mainS,{PH1:r.url}):i18nString(UIStrings.main),this._headerLevel1,e,!0);t&&this._timelineData&&(this._timelineData.selectedGroup=t)}else this._appendSyncEvents(r,r.events,r.url?i18nString(UIStrings.frameS,{PH1:r.url}):i18nString(UIStrings.subframe),this._headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Worker:this._appendSyncEvents(r,r.events,r.name,this._headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Raster:i||this._appendHeader(i18nString(UIStrings.raster),this._headerLevel1,!1),++i,this._appendSyncEvents(r,r.events,i18nString(UIStrings.rasterizerThreadS,{PH1:i}),this._headerLevel2,e,!0);break;case TimelineModel.TimelineModel.TrackType.GPU:this._appendSyncEvents(r,r.events,i18nString(UIStrings.gpu),this._headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Other:this._appendSyncEvents(r,r.events,r.name||i18nString(UIStrings.thread),this._headerLevel1,e,!0),this._appendAsyncEventsGroup(r,r.name,r.asyncEvents,this._headerLevel1,e,!0);break;case TimelineModel.TimelineModel.TrackType.Experience:this._appendSyncEvents(r,r.events,i18nString(UIStrings.experience),this._experienceHeader,e,!0)}this._timelineData&&this._timelineData.selectedGroup&&(this._timelineData.selectedGroup.expanded=!0);for(let r=0;r<this._extensionInfo.length;r++)this._innerAppendExtensionEvents(r);this._markers.sort(((e,t)=>e.startTime()-t.startTime())),this._timelineData&&(this._timelineData.markers=this._markers),this._flowEventIndexById.clear()}minimumBoundary(){return this._minimumBoundary}totalTime(){return this._timeSpan}search(e,t,n){const i=[],r=EntryType;this.timelineData();for(let s=0;s<this._entryData.length;++s){if(this._entryType(s)!==r.Event)continue;const a=this._entryData[s];a.startTime>t||((a.endTime||a.startTime)<e||n.accept(a)&&i.push(s))}return i.sort(((e,t)=>SDK.TracingModel.Event.compareStartTime(this._entryData[e],this._entryData[t]))),i}_appendSyncEvents(e,t,n,i,r,s){if(!t.length)return null;if(!this._performanceModel||!this._model)return null;const a=r===EntryType.ExtensionEvent,o=[],l=!a&&Root.Runtime.experiments.isEnabled("blackboxJSFramesOnTimeline");let m=0,h=null;e&&e.type===TimelineModel.TimelineModel.TrackType.MainThread&&(h=this._appendHeader(n,i,s),h.track=e);for(let c=0;c<t.length;++c){const r=t[c];if(this._performanceModel){const t=this._performanceModel.timelineModel().isInteractiveTimeEvent(r),n=this._performanceModel.timelineModel().isLayoutShiftEvent(r),i=t||n;if(e&&e.type===TimelineModel.TimelineModel.TrackType.MainThread&&i)continue}if(this._performanceModel&&this._performanceModel.timelineModel().isLayoutShiftEvent(r))for(const e of this._performanceModel.frames()){"undefined"===typeof r.endTime&&r.setEndTime(r.startTime);const t=r.startTime>=e.startTime,n=r.endTime&&r.endTime<=e.endTime;t&&n&&(r.startTime=e.startTime,r.setEndTime(e.endTime))}if(!a&&this._performanceModel.timelineModel().isMarkerEvent(r)&&this._markers.push(new TimelineFlameChartMarker(r.startTime,r.startTime-this._model.minimumRecordTime(),TimelineUIUtils.markerStyleForEvent(r))),!SDK.TracingModel.TracingModel.isFlowPhase(r.phase)){if(!r.endTime&&r.phase!==SDK.TracingModel.Phase.Instant)continue;if(SDK.TracingModel.TracingModel.isAsyncPhase(r.phase))continue;if(!a&&!this._performanceModel.isVisible(r))continue}for(;o.length&&o[o.length-1].endTime<=r.startTime;)o.pop();if(eventToDisallowRoot.set(r,!1),l&&this._isIgnoreListedEvent(r)){const e=o[o.length-1];if(e&&eventToDisallowRoot.get(e))continue;eventToDisallowRoot.set(r,!0)}!h&&n&&(h=this._appendHeader(n,i,s),s&&(h.track=e));const d=this._currentLevel+o.length,p=this._appendEvent(r,d);o.length&&(this._entryParent[p]=o[o.length-1]),!a&&this._performanceModel.timelineModel().isMarkerEvent(r)&&(this._timelineData.entryTotalTimes[this._entryData.length]=void 0),m=Math.max(m,o.length+1),r.endTime&&o.push(r)}return this._entryTypeByLevel.length=this._currentLevel+m,this._entryTypeByLevel.fill(r,this._currentLevel),this._currentLevel+=m,h}_isIgnoreListedEvent(e){if(e.name!==TimelineModel.TimelineModel.RecordType.JSFrame)return!1;const t=e.args.data.url;return t&&this._isIgnoreListedURL(t)}_isIgnoreListedURL(e){return Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedURL(e)}_appendAsyncEventsGroup(e,t,n,i,r,s){if(!n.length)return null;const a=[];let o=null;for(let l=0;l<n.length;++l){const r=n[l];if(!this._performanceModel||!this._performanceModel.isVisible(r))continue;!o&&t&&(o=this._appendHeader(t,i,s),s&&(o.track=e));const m=r.startTime;let h;for(h=0;h<a.length&&a[h]>m;++h);this._appendAsyncEvent(r,this._currentLevel+h),a[h]=r.endTime}return this._entryTypeByLevel.length=this._currentLevel+a.length,this._entryTypeByLevel.fill(r,this._currentLevel),this._currentLevel+=a.length,o}_appendInteractionRecords(){if(!this._performanceModel)return;const e=this._performanceModel.interactionRecords();if(e.length){this._appendHeader(i18nString(UIStrings.interactions),this._interactionsHeaderLevel1,!1);for(const t of e){const e=this._entryData.length;this._entryData.push(t.data),this._entryIndexToTitle[e]=t.data,this._timelineData&&(this._timelineData.entryLevels[e]=this._currentLevel,this._timelineData.entryTotalTimes[e]=t.end-t.begin,this._timelineData.entryStartTimes[e]=t.begin)}this._entryTypeByLevel[this._currentLevel++]=EntryType.InteractionRecord}}_appendPageMetrics(){if(this._entryTypeByLevel[this._currentLevel]=EntryType.Event,!this._performanceModel||!this._model)return;const e=[],t=[],n=this._performanceModel.timelineModel();for(const i of this._model.tracks())for(const r of i.events)n.isMarkerEvent(r)&&(n.isLCPCandidateEvent(r)||n.isLCPInvalidateEvent(r)?t.push(r):e.push(r));if(t.length>0){const i=new Map;for(const e of t){const t=e.args.data.navigationId,n=i.get(t);(!n||n.args.data.candidateIndex<e.args.data.candidateIndex)&&i.set(t,e)}const r=Array.from(i.values()).filter((e=>n.isLCPCandidateEvent(e)));e.push(...r)}if(e.sort(SDK.TracingModel.Event.compareStartTime),this._timelineData){const t=this._timelineData.entryTotalTimes;for(const n of e)this._appendEvent(n,this._currentLevel),t[t.length-1]=Number.NaN}++this._currentLevel}_copyPerfMarkEvents(e){if(this._entryTypeByLevel[this._currentLevel]=EntryType.Event,!this._performanceModel||!this._model||!e)return;const t=this._performanceModel.timelineModel(),n=["workerStart","redirectStart","redirectEnd","fetchStart","domainLookupStart","domainLookupEnd","connectStart","connectEnd","secureConnectionStart","requestStart","responseStart","responseEnd","navigationStart","unloadEventStart","unloadEventEnd","redirectStart","redirectEnd","fetchStart","domainLookupStart","domainLookupEnd","connectStart","connectEnd","secureConnectionStart","requestStart","responseStart","responseEnd","domLoading","domInteractive","domContentLoadedEventStart","domContentLoadedEventEnd","domComplete","loadEventStart","loadEventEnd"];for(const i of this._model.tracks())if(i.type===TimelineModel.TimelineModel.TrackType.MainThread)for(const r of i.events)if(t.isUserTimingEvent(r)){if(n.includes(r.name))continue;if(SDK.TracingModel.TracingModel.isAsyncPhase(r.phase))continue;r.setEndTime(r.startTime),e.events.push(r)}++this._currentLevel}_appendFrames(){if(!this._performanceModel||!this._timelineData||!this._model)return;const e=this._performanceModel.filmStripModel().frames(),t=Boolean(e.length);this._framesHeader.collapsible=t,this._appendHeader(i18nString(UIStrings.frames),this._framesHeader,!1),this._frameGroup=this._timelineData.groups[this._timelineData.groups.length-1];const n=TimelineUIUtils.markerStyleForFrame();this._entryTypeByLevel[this._currentLevel]=EntryType.Frame;for(const r of this._performanceModel.frames())this._markers.push(new TimelineFlameChartMarker(r.startTime,r.startTime-this._model.minimumRecordTime(),n)),this._appendFrame(r);if(++this._currentLevel,!t)return;let i;this._appendHeader("",this._screenshotsHeader,!1),this._entryTypeByLevel[this._currentLevel]=EntryType.Screenshot;for(const r of e)this._entryData.push(r),this._timelineData.entryLevels.push(this._currentLevel),this._timelineData.entryStartTimes.push(r.timestamp),i&&this._timelineData.entryTotalTimes.push(r.timestamp-i),i=r.timestamp;e.length&&void 0!==i&&this._timelineData.entryTotalTimes.push(this._model.maximumRecordTime()-i),++this._currentLevel}_entryType(e){return this._entryTypeByLevel[this._timelineData.entryLevels[e]]}prepareHighlightedEntryInfo(e){let t,n,i="",r="timeline-info-time";const s=this._entryType(e);if(s===EntryType.Event){const r=this._entryData[e],s=r.duration,a=r.selfTime,o=1e-6;if("number"===typeof s&&(i=Math.abs(s-a)>o&&a>o?i18nString(UIStrings.sSelfS,{PH1:Number.millisToString(s,!0),PH2:Number.millisToString(a,!0)}):Number.millisToString(s,!0)),t=this._performanceModel&&this._performanceModel.timelineModel().isMarkerEvent(r)?TimelineUIUtils.eventTitle(r):this.entryTitle(e),n=TimelineUIUtils.eventWarning(r),this._model&&this._model.isLayoutShiftEvent(r)){i=i18nString(UIStrings.occurrencesS,{PH1:1})}if(this._model&&this._model.isParseHTMLEvent(r)){const e=r.args.beginData.startLine,n=r.args.endData&&r.args.endData.endLine;t+=` - ${Bindings.ResourceUtils.displayNameForURL(r.args.beginData.url)} [${-1!==n||n===e?`${e}...${n}`:e}]`}}else{if(s!==EntryType.Frame)return null;{const s=this._entryData[e];i=i18nString(UIStrings.sFfps,{PH1:Number.preciseMillisToString(s.duration,1),PH2:(1e3/s.duration).toFixed(0)}),s.idle?t=i18nString(UIStrings.idleFrame):s.dropped?(t=i18nString(UIStrings.droppedFrame),r="timeline-info-warning"):t=i18nString(UIStrings.frame),s.hasWarnings()&&(n=document.createElement("span"),n.textContent=i18nString(UIStrings.longFrame))}}const a=document.createElement("div"),o=UI.Utils.createShadowRootWithCoreStyles(a,{cssFile:"timeline/timelineFlamechartPopover.css",enableLegacyPatching:!0,delegatesFocus:void 0}).createChild("div","timeline-flamechart-popover");return o.createChild("span",r).textContent=i,o.createChild("span","timeline-info-title").textContent=t,n&&(n.classList.add("timeline-info-warning"),o.appendChild(n)),a}entryColor(e){function t(e,t,n){let i=e.get(t);if(i)return i;const r=Common.Color.Color.parse(n(t));if(!r)throw new Error("Could not parse color from entry");return i=r.setAlpha(.7).asString(Common.Color.Format.RGBA)||"",e.set(t,i),i}if(!this._performanceModel||!this._model)return"";const n=EntryType,i=this._entryType(e);if(i===n.Event){const n=this._entryData[e];if(this._model.isGenericTrace())return this._genericTraceEventColor(n);if(this._performanceModel.timelineModel().isMarkerEvent(n))return TimelineUIUtils.markerStyleForEvent(n).color;if(!SDK.TracingModel.TracingModel.isAsyncPhase(n.phase)&&this._colorForEvent)return this._colorForEvent(n);if(n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.Console)||n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.UserTiming))return this._consoleColorGenerator.colorForID(n.name);if(n.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.LatencyInfo)){const e=TimelineModel.TimelineIRModel.TimelineIRModel.phaseForEvent(n)||TimelineModel.TimelineIRModel.Phases.Uncategorized;return t(this._asyncColorByInteractionPhase,e,TimelineUIUtils.interactionPhaseColor)}const i=TimelineUIUtils.eventStyle(n).category;return t(this._asyncColorByCategory,i,(()=>i.color))}if(i===n.Frame)return"white";if(i===n.InteractionRecord)return"transparent";if(i===n.ExtensionEvent){const t=this._entryData[e];return this._extensionColorGenerator.colorForID(t.name)}return""}_genericTraceEventColor(e){const t=e.categoriesString||e.name;return t?`hsl(${Platform.StringUtilities.hashCode(t)%300+30}, 40%, 70%)`:"#ccc"}_drawFrame(e,t,n,i,r,s,a){const o=this._entryData[e];i+=1,s-=2,t.fillStyle=o.idle?"white":o.dropped?"#f0b7b1":o.hasWarnings()?"#fad1d1":"#d7f0d1",t.fillRect(i,r,s,a);const l=Number.preciseMillisToString(o.duration,1),m=t.measureText(l).width;m<=s&&(t.fillStyle=this.textColor(e),t.fillText(l,i+(s-m)/2,r+a-4))}async _drawScreenshot(e,t,n,i,r,s){const a=this._entryData[e];if(!this._screenshotImageCache.has(a)){this._screenshotImageCache.set(a,null);const e=await a.imageDataPromise(),t=await UI.UIUtils.loadImageFromData(e);return this._screenshotImageCache.set(a,t),void this.dispatchEventToListeners(Events.DataChanged)}const o=this._screenshotImageCache.get(a);if(!o)return;const l=n+1,m=i+1,h=s-2,c=h/o.naturalHeight,d=Math.floor(o.naturalWidth*c);t.save(),t.beginPath(),t.rect(n,i,r,s),t.clip(),t.drawImage(o,l,m,d,h),t.strokeStyle="#ccc",t.strokeRect(l-.5,m-.5,Math.min(r-1,d+1),h),t.restore()}decorateEntry(e,t,n,i,r,s,a,o,l){const m=this._entryData[e],h=this._entryType(e),c=EntryType;if(h===c.Frame)return this._drawFrame(e,t,n,i,r,s,a),!0;if(h===c.Screenshot)return this._drawScreenshot(e,t,i,r,s,a),!0;if(h===c.InteractionRecord){const e=TimelineUIUtils.interactionPhaseColor(m);return t.fillStyle=e,t.fillRect(i,r,s-1,2),t.fillRect(i,r-3,2,3),t.fillRect(i+s-3,r-3,2,3),!1}if(h===c.Event){const e=m;if(e.hasCategory(TimelineModel.TimelineModel.TimelineModelImpl.Category.LatencyInfo)){const n=TimelineModel.TimelineModel.TimelineData.forEvent(e).timeWaitingForMainThread;if(n){t.fillStyle="hsla(0, 70%, 60%, 1)";const e=Math.floor(o-i+n*l);t.fillRect(i,r+a-3,e,2)}}TimelineModel.TimelineModel.TimelineData.forEvent(e).warning&&function(e,n){const i=8;t.save(),t.beginPath(),t.rect(e,r,n,a),t.clip(),t.beginPath(),t.fillStyle="red",t.moveTo(e+n-i,r),t.lineTo(e+n,r),t.lineTo(e+n,r+i),t.fill(),t.restore()}(i,s-1.5)}return!1}forceDecoration(e){const t=EntryType,n=this._entryType(e);if(n===t.Frame)return!0;if(n===t.Screenshot)return!0;if(n===t.Event){const t=this._entryData[e];return Boolean(TimelineModel.TimelineModel.TimelineData.forEvent(t).warning)}return!1}appendExtensionEvents(e){this._extensionInfo.push(e),this._timelineData&&this._innerAppendExtensionEvents(this._extensionInfo.length-1)}_innerAppendExtensionEvents(e){const t=this._extensionInfo[e],n=EntryType.ExtensionEvent,i=[...t.model.sortedProcesses().map((e=>e.sortedThreads()))].flat();if(!i.length)return;const r=1===i.length&&(!i[0].events().length||!i[0].asyncEvents().length);r||this._appendHeader(t.title,this._headerLevel1,!1);const s=r?this._headerLevel2:this._headerLevel1;let a=0;for(const o of i){const e=r?t.title:o.name()||i18nString(UIStrings.threadS,{PH1:++a});this._appendAsyncEventsGroup(null,e,o.asyncEvents(),s,n,!1),this._appendSyncEvents(null,o.events(),e,s,n,!1)}}_appendHeader(e,t,n){const i={startLevel:this._currentLevel,name:e,style:t,selectable:n};return this._timelineData.groups.push(i),i}_appendEvent(e,t){const n=this._entryData.length;this._entryData.push(e);const i=this._timelineData;return i.entryLevels[n]=t,i.entryTotalTimes[n]=e.duration||InstantEventVisibleDurationMs,i.entryStartTimes[n]=e.startTime,indexForEvent.set(e,n),n}_appendAsyncEvent(e,t){if(SDK.TracingModel.TracingModel.isNestableAsyncPhase(e.phase))return void this._appendEvent(e,t);const n=e.steps,i=n.length>1&&n[1].phase===SDK.TracingModel.Phase.AsyncStepPast?1:0;for(let r=0;r<n.length-1;++r){const e=this._entryData.length;this._entryData.push(n[r+i]);const s=n[r].startTime,a=this._timelineData;a.entryLevels[e]=t,a.entryTotalTimes[e]=n[r+1].startTime-s,a.entryStartTimes[e]=s}}_appendFrame(e){const t=this._entryData.length;this._entryData.push(e),this._entryIndexToTitle[t]=Number.millisToString(e.duration,!0),this._timelineData&&(this._timelineData.entryLevels[t]=this._currentLevel,this._timelineData.entryTotalTimes[t]=e.duration,this._timelineData.entryStartTimes[t]=e.startTime)}createSelection(e){const t=this._entryType(e);let n=null;return t===EntryType.Event?n=TimelineSelection.fromTraceEvent(this._entryData[e]):t===EntryType.Frame&&(n=TimelineSelection.fromFrame(this._entryData[e])),n&&(this._lastSelection=new Selection(n,e)),n}formatValue(e,t){return Number.preciseMillisToString(e,t)}canJumpToEntry(e){return!1}entryIndexForSelection(e){if(!e||e.type()===TimelineSelection.Type.Range)return-1;if(this._lastSelection&&this._lastSelection.timelineSelection.object()===e.object())return this._lastSelection.entryIndex;const t=this._entryData.indexOf(e.object());return-1!==t&&(this._lastSelection=new Selection(e,t)),t}buildFlowForInitiator(e){if(this._lastInitiatorEntry===e)return!1;this._lastInitiatorEntry=e;let t=this.eventByIndex(e);const n=this._timelineData;if(!n)return!1;for(n.flowStartTimes=[],n.flowStartLevels=[],n.flowEndTimes=[],n.flowEndLevels=[];t;){let e;for(;t&&(e=TimelineModel.TimelineModel.TimelineData.forEvent(t).initiator(),!e);t=this._eventParent(t));if(!e||!t)break;const i=indexForEvent.get(t),r=indexForEvent.get(e);n.flowStartTimes.push(e.endTime||e.startTime),n.flowStartLevels.push(n.entryLevels[r]),n.flowEndTimes.push(t.startTime),n.flowEndLevels.push(n.entryLevels[i]),t=e}return!0}_eventParent(e){const t=indexForEvent.get(e);return void 0===t?null:this._entryParent[t]||null}eventByIndex(e){return e>=0&&this._entryType(e)===EntryType.Event?this._entryData[e]:null}setEventColorMapping(e){this._colorForEvent=e}}export const InstantEventVisibleDurationMs=.001;const eventToDisallowRoot=new WeakMap,indexForEvent=new WeakMap;export const Events={DataChanged:Symbol("DataChanged")};export const EntryType={Frame:Symbol("Frame"),Event:Symbol("Event"),InteractionRecord:Symbol("InteractionRecord"),ExtensionEvent:Symbol("ExtensionEvent"),Screenshot:Symbol("Screenshot")};