import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TimelineModel from"../timeline_model/timeline_model.js";import*as UI from"../ui/ui.js";import{TimelineRegExp}from"./TimelineFilters.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={performance:"Performance",filter:"Filter",selfTime:"Self Time",totalTime:"Total Time",activity:"Activity",selectItemForDetails:"Select item for details.",notOptimizedS:"Not optimized: {PH1}",fms:"{PH1}\xa0ms",percentPlaceholder:"{PH1}\xa0%",chromeExtensionsOverhead:"[`Chrome` extensions overhead]",vRuntime:"[`V8` Runtime]",unattributed:"[unattributed]",javascript:"JavaScript",page:"Page",noGrouping:"No Grouping",groupByActivity:"Group by Activity",groupByCategory:"Group by Category",groupByDomain:"Group by Domain",groupByFrame:"Group by Frame",groupBySubdomain:"Group by Subdomain",groupByUrl:"Group by URL",groupBy:"Group by",filterCallTree:"Filter call tree",filterBottomup:"Filter bottom-up",heaviestStack:"Heaviest stack",showHeaviestStack:"Show Heaviest stack",hideHeaviestStack:"Hide Heaviest stack",timelineStack:"Timeline Stack"},str_=i18n.i18n.registerUIStrings("timeline/TimelineTreeView.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineTreeView extends UI.Widget.VBox{constructor(){super(),this._model=null,this._track=null,this._tree=null,this.element.classList.add("timeline-tree-view"),this._searchResults=[],this.linkifier,this.dataGrid,this._lastHoveredProfileNode,this._textFilter,this._taskFilter,this._startTime,this._endTime,this.splitWidget,this.detailsView,this._searchableView}static eventNameForSorting(e){if(e.name===TimelineModel.TimelineModel.RecordType.JSFrame){const t=e.args.data;return t.functionName+"@"+(t.scriptId||t.url||"")}return e.name+":@"+TimelineModel.TimelineProfileTree.eventURL(e)}setSearchableView(e){this._searchableView=e}setModel(e,t){this._model=e,this._track=t,this.refreshTree()}getToolbarInputAccessiblePlaceHolder(){return""}model(){return this._model}init(){this.linkifier=new Components.Linkifier.Linkifier,this._taskFilter=new TimelineModel.TimelineModelFilter.ExclusiveNameFilter([TimelineModel.TimelineModel.RecordType.Task]),this._textFilter=new TimelineRegExp,this._currentThreadSetting=Common.Settings.Settings.instance().createSetting("timelineTreeCurrentThread",0),this._currentThreadSetting.addChangeListener(this.refreshTree,this);const e=[];this.populateColumns(e),this.splitWidget=new UI.SplitWidget.SplitWidget(!0,!0,"timelineTreeViewDetailsSplitWidget");const t=new UI.Widget.VBox,i=new UI.Toolbar.Toolbar("",t.element);this.populateToolbar(i),this.dataGrid=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.performance),columns:e,refreshCallback:void 0,editCallback:void 0,deleteCallback:void 0}),this.dataGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortingChanged,this),this.dataGrid.element.addEventListener("mousemove",this._onMouseMove.bind(this),!0),this.dataGrid.setResizeMethod(DataGrid.DataGrid.ResizeMethod.Last),this.dataGrid.setRowContextMenuCallback(this._onContextMenu.bind(this)),this.dataGrid.asWidget().show(t.element),this.dataGrid.addEventListener(DataGrid.DataGrid.Events.SelectedNode,this._updateDetailsForSelection,this),this.detailsView=new UI.Widget.VBox,this.detailsView.element.classList.add("timeline-details-view","timeline-details-view-body"),this.splitWidget.setMainWidget(t),this.splitWidget.setSidebarWidget(this.detailsView),this.splitWidget.hideSidebar(),this.splitWidget.show(this.element),this.splitWidget.addEventListener(UI.SplitWidget.Events.ShowModeChanged,this._onShowModeChanged,this),this._lastSelectedNode}lastSelectedNode(){return this._lastSelectedNode}updateContents(e){this.setRange(e.startTime(),e.endTime())}setRange(e,t){this._startTime=e,this._endTime=t,this.refreshTree()}filters(){return[this._taskFilter,this._textFilter,...this._model?this._model.filters():[]]}filtersWithoutTextFilter(){return[this._taskFilter,...this._model?this._model.filters():[]]}textFilter(){return this._textFilter}_exposePercentages(){return!1}populateToolbar(e){const t=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.filter),this.getToolbarInputAccessiblePlaceHolder());t.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,(()=>{const e=t.value();this._textFilter.setRegExp(e?createPlainTextSearchRegex(e,"i"):null),this.refreshTree()}),this),this._textFilterUI=t,e.appendToolbarItem(t)}_modelEvents(){return this._track?this._track.syncEvents():[]}_onHover(e){}_appendContextMenuItems(e,t){}_linkifyLocation(e){if(!this._model)return null;const t=this._model.timelineModel().targetByEvent(e);if(!t)return null;const i=TimelineModel.TimelineProfileTree.eventStackFrame(e);return i?this.linkifier.maybeLinkifyConsoleCallFrame(t,i):null}selectProfileNode(e,t){const i=[];let r=e;for(;r;r=r.parent)i.push(r);for(let o=i.length-1;o>0;--o){const e=this.dataGridNodeForTreeNode(i[o]);e&&e.dataGrid&&e.expand()}const n=this.dataGridNodeForTreeNode(e);n&&n.dataGrid&&(n.reveal(),n.select(t))}refreshTree(){if(this.linkifier.reset(),this.dataGrid.rootNode().removeChildren(),!this._model)return void this._updateDetailsForSelection();this._root=this._buildTree();const e=this._root.children();let t=0,i=0;const r=this._root.totalTime-this._root.selfTime;for(const o of e.values())t=Math.max(t,o.selfTime),i=Math.max(i,o.totalTime);for(const o of e.values()){const e=new TreeGridNode(o,r,t,i,this);this.dataGrid.insertChild(e)}this._sortingChanged(),this._updateDetailsForSelection(),this._searchableView&&this._searchableView.refreshSearch();const n=this.dataGrid.rootNode();n.children.length>0&&n.children[0].select(!0)}_buildTree(){throw new Error("Not Implemented")}buildTopDownTree(e,t){return new TimelineModel.TimelineProfileTree.TopDownRootNode(this._modelEvents(),this.filters(),this._startTime,this._endTime,e,t)}populateColumns(e){e.push({id:"self",title:i18nString(UIStrings.selfTime),width:"120px",fixedWidth:!0,sortable:!0}),e.push({id:"total",title:i18nString(UIStrings.totalTime),width:"120px",fixedWidth:!0,sortable:!0}),e.push({id:"activity",title:i18nString(UIStrings.activity),disclosure:!0,sortable:!0})}_sortingChanged(){const e=this.dataGrid.sortColumnId();if(!e)return;let t;switch(e){case"startTime":t=function(e,t){const i=t,r=e._profileNode.event,n=i._profileNode.event;return r.startTime-n.startTime};break;case"self":t=i.bind(null,"selfTime");break;case"total":t=i.bind(null,"totalTime");break;case"activity":t=function(e,t){const i=t,r=e._profileNode.event,n=i._profileNode.event,o=TimelineTreeView.eventNameForSorting(r),s=TimelineTreeView.eventNameForSorting(n);return o.localeCompare(s)};break;default:return void console.assert(!1,"Unknown sort field: "+e)}function i(e,t,i){const r=i;return t._profileNode[e]-r._profileNode[e]}this.dataGrid.sortNodes(t,!this.dataGrid.isSortOrderAscending())}_onShowModeChanged(){this.splitWidget.showMode()!==UI.SplitWidget.ShowMode.OnlyMain&&(this._lastSelectedNode=void 0,this._updateDetailsForSelection())}_updateDetailsForSelection(){const e=this.dataGrid.selectedNode?this.dataGrid.selectedNode._profileNode:null;if(e===this._lastSelectedNode)return;if(this._lastSelectedNode=e,this.splitWidget.showMode()===UI.SplitWidget.ShowMode.OnlyMain)return;if(this.detailsView.detachChildWidgets(),this.detailsView.element.removeChildren(),e&&this._showDetailsForNode(e))return;const t=this.detailsView.element.createChild("div","full-widget-dimmed-banner");UI.UIUtils.createTextChild(t,i18nString(UIStrings.selectItemForDetails))}_showDetailsForNode(e){return!1}_onMouseMove(e){const t=e.target&&e.target instanceof Node?this.dataGrid.dataGridNodeFromNode(e.target):null,i=t&&t._profileNode;i!==this._lastHoveredProfileNode&&(this._lastHoveredProfileNode=i,this._onHover(i))}_onContextMenu(e,t){const i=t;i._linkElement&&!e.containsTarget(i._linkElement)&&e.appendApplicableItems(i._linkElement);const r=i._profileNode;r&&this._appendContextMenuItems(e,r)}dataGridNodeForTreeNode(e){return profileNodeToTreeGridNode.get(e)||null}searchCanceled(){this._searchResults=[],this._currentResult=0}performSearch(e,t,i){if(this._searchResults=[],this._currentResult=0,!this._root)return;const r=e.toSearchRegex();this._searchResults=this._root.searchTree((e=>TimelineUIUtils.testContentMatching(e,r))),this._searchableView.updateSearchMatchesCount(this._searchResults.length)}jumpToNextSearchResult(){this._searchResults.length&&(this.selectProfileNode(this._searchResults[this._currentResult],!1),this._currentResult=Platform.NumberUtilities.mod(this._currentResult+1,this._searchResults.length))}jumpToPreviousSearchResult(){this._searchResults.length&&(this.selectProfileNode(this._searchResults[this._currentResult],!1),this._currentResult=Platform.NumberUtilities.mod(this._currentResult-1,this._searchResults.length))}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}}export class GridNode extends DataGrid.SortableDataGrid.SortableDataGridNode{constructor(e,t,i,r,n){super(null,!1),this._populated=!1,this._profileNode=e,this._treeView=n,this._grandTotalTime=t,this._maxSelfTime=i,this._maxTotalTime=r,this._linkElement=null}createCell(e){return"activity"===e?this._createNameCell(e):this._createValueCell(e)||super.createCell(e)}_createNameCell(e){const t=this.createTD(e),i=t.createChild("div","name-container"),r=i.createChild("div","activity-icon-container"),n=r.createChild("div","activity-icon"),o=i.createChild("div","activity-name"),s=this._profileNode.event;if(this._profileNode.isGroupNode()){const e=this._treeView._displayInfoForGroupNode(this._profileNode);o.textContent=e.name,n.style.backgroundColor=e.color,e.icon&&r.insertBefore(e.icon,n)}else if(s){const e=s.args.data,t=e&&e.deoptReason;t&&(i.createChild("div","activity-warning").title=i18nString(UIStrings.notOptimizedS,{PH1:t})),o.textContent=TimelineUIUtils.eventTitle(s),this._linkElement=this._treeView._linkifyLocation(s),this._linkElement&&i.createChild("div","activity-link").appendChild(this._linkElement);const r=TimelineUIUtils.eventStyle(s).category;UI.ARIAUtils.setAccessibleName(n,r.title),n.style.backgroundColor=r.color}return t}_createValueCell(e){if("self"!==e&&"total"!==e&&"startTime"!==e)return null;let t,i,r,n=!1;switch(e){case"startTime":if(r=this._profileNode.event,!this._treeView._model)throw new Error("Unable to find model for tree view");t=(r?r.startTime:0)-this._treeView._model.timelineModel().minimumRecordTime();break;case"self":t=this._profileNode.selfTime,i=this._maxSelfTime,n=!0;break;case"total":t=this._profileNode.totalTime,i=this._maxTotalTime,n=!0;break;default:return null}const o=this.createTD(e);o.className="numeric-column";const s=o.createChild("div");return s.createChild("span").textContent=i18nString(UIStrings.fms,{PH1:t.toFixed(1)}),n&&this._treeView._exposePercentages()&&(s.createChild("span","percent-column").textContent=i18nString(UIStrings.percentPlaceholder,{PH1:(t/this._grandTotalTime*100).toFixed(1)})),i&&(s.classList.add("background-percent-bar"),o.createChild("div","background-bar-container").createChild("div","background-bar").style.width=(100*t/i).toFixed(1)+"%"),o}}export class TreeGridNode extends GridNode{constructor(e,t,i,r,n){super(e,t,i,r,n),this.setHasChildren(this._profileNode.hasChildren()),profileNodeToTreeGridNode.set(e,this)}populate(){if(!this._populated&&(this._populated=!0,this._profileNode.children))for(const e of this._profileNode.children().values()){const t=new TreeGridNode(e,this._grandTotalTime,this._maxSelfTime,this._maxTotalTime,this._treeView);this.insertChildOrdered(t)}}}TreeGridNode._gridNodeSymbol=Symbol("treeGridNode");const profileNodeToTreeGridNode=new WeakMap;export class AggregatedTimelineTreeView extends TimelineTreeView{constructor(){super(),this._groupBySetting=Common.Settings.Settings.instance().createSetting("timelineTreeGroupBy",AggregatedTimelineTreeView.GroupBy.None),this._groupBySetting.addChangeListener(this.refreshTree.bind(this)),this.init(),this._stackView=new TimelineStackView(this),this._stackView.addEventListener(TimelineStackView.Events.SelectionChanged,this._onStackViewSelectionChanged,this),this._productByURLCache=new Map,this._colorByURLCache=new Map,this._executionContextNamesByOrigin=new Map}setModel(e,t){super.setModel(e,t)}updateContents(e){this._updateExtensionResolver(),super.updateContents(e);const t=this.dataGrid.rootNode();t.children.length&&t.children[0].select(!0)}_updateExtensionResolver(){this._executionContextNamesByOrigin=new Map;for(const e of SDK.SDKModel.TargetManager.instance().models(SDK.RuntimeModel.RuntimeModel))for(const t of e.executionContexts())this._executionContextNamesByOrigin.set(t.origin,t.name)}_beautifyDomainName(e){return AggregatedTimelineTreeView._isExtensionInternalURL(e)?e=i18nString(UIStrings.chromeExtensionsOverhead):AggregatedTimelineTreeView._isV8NativeURL(e)?e=i18nString(UIStrings.vRuntime):e.startsWith("chrome-extension")&&(e=this._executionContextNamesByOrigin.get(e)||e),e}_displayInfoForGroupNode(e){const t=TimelineUIUtils.categories(),i=e.id?TimelineUIUtils.eventColor(e.event):t.other.color,r=i18nString(UIStrings.unattributed),n="symbol"===typeof e.id?void 0:e.id;switch(this._groupBySetting.get()){case AggregatedTimelineTreeView.GroupBy.Category:{const e=n?t[n]||t.other:{title:r,color:r};return{name:e.title,color:e.color,icon:void 0}}case AggregatedTimelineTreeView.GroupBy.Domain:case AggregatedTimelineTreeView.GroupBy.Subdomain:return{name:(n?this._beautifyDomainName(n):void 0)||r,color:i,icon:void 0};case AggregatedTimelineTreeView.GroupBy.EventName:if(!e.event)throw new Error("Unable to find event for group by operation");return{name:e.event.name===TimelineModel.TimelineModel.RecordType.JSFrame?i18nString(UIStrings.javascript):TimelineUIUtils.eventTitle(e.event),color:e.event.name===TimelineModel.TimelineModel.RecordType.JSFrame?TimelineUIUtils.eventStyle(e.event).category.color:i,icon:void 0};case AggregatedTimelineTreeView.GroupBy.URL:break;case AggregatedTimelineTreeView.GroupBy.Frame:{if(!this._model)throw new Error("Unable to find model for group by frame operation");const e=n?this._model.timelineModel().pageFrameById(n):void 0;return{name:e?TimelineUIUtils.displayNameForFrame(e,80):i18nString(UIStrings.page),color:i,icon:void 0}}default:console.assert(!1,"Unexpected grouping type")}return{name:n||r,color:i,icon:void 0}}populateToolbar(e){super.populateToolbar(e);const t=AggregatedTimelineTreeView.GroupBy,i=[{label:i18nString(UIStrings.noGrouping),value:t.None},{label:i18nString(UIStrings.groupByActivity),value:t.EventName},{label:i18nString(UIStrings.groupByCategory),value:t.Category},{label:i18nString(UIStrings.groupByDomain),value:t.Domain},{label:i18nString(UIStrings.groupByFrame),value:t.Frame},{label:i18nString(UIStrings.groupBySubdomain),value:t.Subdomain},{label:i18nString(UIStrings.groupByUrl),value:t.URL}];e.appendToolbarItem(new UI.Toolbar.ToolbarSettingComboBox(i,this._groupBySetting,i18nString(UIStrings.groupBy))),e.appendSpacer(),e.appendToolbarItem(this.splitWidget.createShowHideSidebarButton(i18nString(UIStrings.showHeaviestStack),i18nString(UIStrings.hideHeaviestStack)))}_buildHeaviestStack(e){console.assert(Boolean(e.parent),"Attempt to build stack for tree root");let t=[];for(let i=e;i&&i.parent;i=i.parent)t.push(i);t=t.reverse();for(let i=e;i&&i.children()&&i.children().size;){const e=Array.from(i.children().values());i=e.reduce(((e,t)=>e.totalTime>t.totalTime?e:t)),t.push(i)}return t}_exposePercentages(){return!0}_onStackViewSelectionChanged(){const e=this._stackView.selectedTreeNode();e&&this.selectProfileNode(e,!0)}_showDetailsForNode(e){const t=this._buildHeaviestStack(e);return this._stackView.setStack(t,e),this._stackView.show(this.detailsView.element),!0}_groupingFunction(e){const t=AggregatedTimelineTreeView.GroupBy;switch(e){case t.None:return null;case t.EventName:return e=>TimelineUIUtils.eventStyle(e).title;case t.Category:return e=>TimelineUIUtils.eventStyle(e).category.name;case t.Subdomain:return this._domainByEvent.bind(this,!1);case t.Domain:return this._domainByEvent.bind(this,!0);case t.URL:return e=>TimelineModel.TimelineProfileTree.eventURL(e)||"";case t.Frame:return e=>TimelineModel.TimelineModel.TimelineData.forEvent(e).frameId;default:return console.assert(!1,`Unexpected aggregation setting: ${e}`),null}}_domainByEvent(e,t){const i=TimelineModel.TimelineProfileTree.eventURL(t);if(!i)return"";if(AggregatedTimelineTreeView._isExtensionInternalURL(i))return AggregatedTimelineTreeView._extensionInternalPrefix;if(AggregatedTimelineTreeView._isV8NativeURL(i))return AggregatedTimelineTreeView._v8NativePrefix;const r=Common.ParsedURL.ParsedURL.fromString(i);if(!r)return"";if("chrome-extension"===r.scheme)return r.scheme+"://"+r.host;if(!e)return r.host;if(/^[.0-9]+$/.test(r.host))return r.host;const n=/([^.]*\.)?[^.]*$/.exec(r.host);return n&&n[0]||""}_appendContextMenuItems(e,t){if(this._groupBySetting.get()!==AggregatedTimelineTreeView.GroupBy.Frame)return;if(!t.isGroupNode())return;if(!this._model)return;const i=this._model.timelineModel().pageFrameById(t.id);i&&i.ownerNode&&e.appendApplicableItems(i.ownerNode)}static _isExtensionInternalURL(e){return e.startsWith(AggregatedTimelineTreeView._extensionInternalPrefix)}static _isV8NativeURL(e){return e.startsWith(AggregatedTimelineTreeView._v8NativePrefix)}}AggregatedTimelineTreeView._extensionInternalPrefix="extensions::",AggregatedTimelineTreeView._v8NativePrefix="native ",AggregatedTimelineTreeView.GroupBy={None:"None",EventName:"EventName",Category:"Category",Domain:"Domain",Subdomain:"Subdomain",URL:"URL",Frame:"Frame"};export class CallTreeTimelineTreeView extends AggregatedTimelineTreeView{constructor(){super(),this.dataGrid.markColumnAsSortedBy("total",DataGrid.DataGrid.Order.Descending)}getToolbarInputAccessiblePlaceHolder(){return i18nString(UIStrings.filterCallTree)}_buildTree(){const e=this._groupBySetting.get();return this.buildTopDownTree(!1,this._groupingFunction(e))}}export class BottomUpTimelineTreeView extends AggregatedTimelineTreeView{constructor(){super(),this.dataGrid.markColumnAsSortedBy("self",DataGrid.DataGrid.Order.Descending)}getToolbarInputAccessiblePlaceHolder(){return i18nString(UIStrings.filterBottomup)}_buildTree(){return new TimelineModel.TimelineProfileTree.BottomUpRootNode(this._modelEvents(),this.textFilter(),this.filtersWithoutTextFilter(),this._startTime,this._endTime,this._groupingFunction(this._groupBySetting.get()))}}export class TimelineStackView extends UI.Widget.VBox{constructor(e){super();this.element.createChild("div","timeline-stack-view-header").textContent=i18nString(UIStrings.heaviestStack),this._treeView=e;const t=[{id:"total",title:i18nString(UIStrings.totalTime),fixedWidth:!0,width:"110px"},{id:"activity",title:i18nString(UIStrings.activity)}];this._dataGrid=new DataGrid.ViewportDataGrid.ViewportDataGrid({displayName:i18nString(UIStrings.timelineStack),columns:t,deleteCallback:void 0,editCallback:void 0,refreshCallback:void 0}),this._dataGrid.setResizeMethod(DataGrid.DataGrid.ResizeMethod.Last),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.SelectedNode,this._onSelectionChanged,this),this._dataGrid.asWidget().show(this.element)}setStack(e,t){const i=this._dataGrid.rootNode();i.removeChildren();let r=null;const n=Math.max.apply(Math,e.map((e=>e.totalTime)));for(const o of e){const e=new GridNode(o,n,n,n,this._treeView);i.appendChild(e),o===t&&(r=e)}r&&r.revealAndSelect()}selectedTreeNode(){const e=this._dataGrid.selectedNode;return e&&e._profileNode}_onSelectionChanged(){this.dispatchEventToListeners(TimelineStackView.Events.SelectionChanged)}}TimelineStackView.Events={SelectionChanged:Symbol("SelectionChanged")};