import*as Host from"../host/host.js";import*as Root from"../root/root.js";import{ActionRegistry}from"./ActionRegistry.js";import{ShortcutRegistry}from"./ShortcutRegistry.js";import{SoftContextMenu}from"./SoftContextMenu.js";import{deepElementFromEvent}from"./UIUtils.js";export class Item{constructor(e,t,s,n,i){this._type=t,this._label=s,this._disabled=n,this._checked=i,this._contextMenu=e,this._id=void 0,"item"!==t&&"checkbox"!==t||(this._id=e?e._nextId():0),this._customElement}id(){if(void 0===this._id)throw new Error("Tried to access a ContextMenu Item ID but none was set.");return this._id}type(){return this._type}isEnabled(){return!this._disabled}setEnabled(e){this._disabled=!e}_buildDescriptor(){switch(this._type){case"item":{const e={type:"item",id:this._id,label:this._label,enabled:!this._disabled,checked:void 0,subItems:void 0};if(this._customElement){e.element=this._customElement}if(this._shortcut){e.shortcut=this._shortcut}return e}case"separator":return{type:"separator",id:void 0,label:void 0,enabled:void 0,checked:void 0,subItems:void 0};case"checkbox":return{type:"checkbox",id:this._id,label:this._label,checked:Boolean(this._checked),enabled:!this._disabled,subItems:void 0}}throw new Error("Invalid item type:"+this._type)}setShortcut(e){this._shortcut=e}}export class Section{constructor(e){this._contextMenu=e,this._items=[]}appendItem(e,t,s){const n=new Item(this._contextMenu,"item",e,s);return this._items.push(n),this._contextMenu&&this._contextMenu._setHandler(n.id(),t),n}appendCustomItem(e){const t=new Item(this._contextMenu,"item","<custom>");return t._customElement=e,this._items.push(t),t}appendSeparator(){const e=new Item(this._contextMenu,"separator");return this._items.push(e),e}appendAction(e,t,s){const n=ActionRegistry.instance().action(e);if(!n)return void(s||console.error(`Action ${e} was not defined`));t||(t=n.title());const i=this.appendItem(t,n.execute.bind(n)),o=ShortcutRegistry.instance().shortcutTitleForAction(e);o&&i.setShortcut(o)}appendSubMenuItem(e,t){const s=new SubMenu(this._contextMenu,e,t);return s._init(),this._items.push(s),s}appendCheckboxItem(e,t,s,n){const i=new Item(this._contextMenu,"checkbox",e,n,s);return this._items.push(i),this._contextMenu&&this._contextMenu._setHandler(i.id(),t),i}}export class SubMenu extends Item{constructor(e,t,s){super(e,"subMenu",t,s),this._sections=new Map,this._sectionList=[]}_init(){_groupWeights.forEach((e=>this.section(e)))}section(e){let t=e?this._sections.get(e):null;return t||(t=new Section(this._contextMenu),e?(this._sections.set(e,t),this._sectionList.push(t)):this._sectionList.splice(ContextMenu._groupWeights.indexOf("default"),0,t)),t}headerSection(){return this.section("header")}newSection(){return this.section("new")}revealSection(){return this.section("reveal")}clipboardSection(){return this.section("clipboard")}editSection(){return this.section("edit")}debugSection(){return this.section("debug")}viewSection(){return this.section("view")}defaultSection(){return this.section("default")}saveSection(){return this.section("save")}footerSection(){return this.section("footer")}_buildDescriptor(){const e={type:"subMenu",label:this._label,enabled:!this._disabled,subItems:[],id:void 0,checked:void 0},t=this._sectionList.filter((e=>Boolean(e._items.length)));for(const s of t){for(const t of s._items)e.subItems||(e.subItems=[]),e.subItems.push(t._buildDescriptor());s!==t[t.length-1]&&(e.subItems||(e.subItems=[]),e.subItems.push({type:"separator",id:void 0,subItems:void 0,checked:void 0,enabled:void 0,label:void 0}))}return e}appendItemsAtLocation(e){const t=getRegisteredItems();t.sort(((e,t)=>(e.order||0)-(t.order||0)));for(const s of t){const t=s.location,n=s.actionId;if(!t||!t.startsWith(e+"/"))continue;const i=t.substr(e.length+1);i&&!i.includes("/")&&(n&&this.section(i).appendAction(n))}}}Item._uniqueSectionName=0;export class ContextMenu extends SubMenu{constructor(e,t,s,n){super(null);const i=e;this._contextMenu=this,super._init(),this._defaultSection=this.defaultSection(),this._pendingPromises=[],this._pendingTargets=[],this._event=i,this._useSoftMenu=Boolean(t),this._x=void 0===s?i.x:s,this._y=void 0===n?i.y:n,this._handlers=new Map,this._id=0;const o=deepElementFromEvent(e);o&&this.appendApplicableItems(o)}static initialize(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.SetUseSoftMenu,(function(e){ContextMenu._useSoftMenu=e.data}))}static installHandler(e){e.body.addEventListener("contextmenu",(function(e){new ContextMenu(e).show()}),!1)}_nextId(){return this._id++}async show(){ContextMenu._pendingMenu=this,this._event.consume(!0);const e=await Promise.all(this._pendingPromises);if(ContextMenu._pendingMenu===this){ContextMenu._pendingMenu=null;for(let t=0;t<e.length;++t){const s=e[t],n=this._pendingTargets[t];for(const e of s)e.appendApplicableItems(this._event,this,n)}this._pendingPromises=[],this._pendingTargets=[],this._innerShow()}}discard(){this._softMenu&&this._softMenu.discard()}_innerShow(){const e=this._buildMenuDescriptors(),t=this._event.target;if(!t)return;const s=t.ownerDocument;if(this._useSoftMenu||ContextMenu._useSoftMenu||Host.InspectorFrontendHost.InspectorFrontendHostInstance.isHostedMode())this._softMenu=new SoftContextMenu(e,this._itemSelected.bind(this)),this._softMenu.show(s,new AnchorBox(this._x,this._y,0,0));else{function t(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.ContextMenuCleared,this._menuCleared,this),Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.ContextMenuItemSelected,this._onItemSelected,this)}Host.InspectorFrontendHost.InspectorFrontendHostInstance.showContextMenuAtPoint(this._x,this._y,e,s),queueMicrotask(t.bind(this))}}setX(e){this._x=e}setY(e){this._y=e}_setHandler(e,t){t&&this._handlers.set(e,t)}_buildMenuDescriptors(){return super._buildDescriptor().subItems}_onItemSelected(e){this._itemSelected(e.data)}_itemSelected(e){const t=this._handlers.get(e);t&&t.call(this),this._menuCleared()}_menuCleared(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.removeEventListener(Host.InspectorFrontendHostAPI.Events.ContextMenuCleared,this._menuCleared,this),Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.removeEventListener(Host.InspectorFrontendHostAPI.Events.ContextMenuItemSelected,this._onItemSelected,this)}containsTarget(e){return this._pendingTargets.indexOf(e)>=0}appendApplicableItems(e){this._pendingPromises.push(loadApplicableRegisteredProviders(e)),this._pendingTargets.push(e)}}ContextMenu._useSoftMenu=!1,ContextMenu._pendingMenu=null;export const _groupWeights=["header","new","reveal","edit","clipboard","debug","view","default","save","footer"];export class Provider{appendApplicableItems(e,t,s){}}const registeredProviders=[];export function registerProvider(e){registeredProviders.push(e)}async function loadApplicableRegisteredProviders(e){return Promise.all(registeredProviders.filter((function(t){if(!Root.Runtime.Runtime.isDescriptorEnabled({experiment:t.experiment,condition:void 0}))return!1;if(!t.contextTypes)return!0;for(const s of t.contextTypes())if(e instanceof s)return!0;return!1})).map((e=>e.loadProvider())))}const registeredItemsProviders=[];export function registerItem(e){registeredItemsProviders.push(e)}function getRegisteredItems(){return registeredItemsProviders}export const ItemLocation={DEVICE_MODE_MENU_SAVE:"deviceModeMenu/save",MAIN_MENU:"mainMenu",MAIN_MENU_DEFAULT:"mainMenu/default",MAIN_MENU_FOOTER:"mainMenu/footer",MAIN_MENU_HELP_DEFAULT:"mainMenuHelp/default",NAVIGATOR_MENU_DEFAULT:"navigatorMenu/default",TIMELINE_MENU_OPEN:"timelineMenu/open"};export let ProviderRegistration;export let ContextMenuItemRegistration;ContextMenu._groupWeights=_groupWeights;