import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as ARIAUtils from"./ARIAUtils.js";import{Icon}from"./Icon.js";import{KeyboardShortcut,Modifiers}from"./KeyboardShortcut.js";import{bindCheckbox}from"./SettingsUI.js";import{Events,TextPrompt}from"./TextPrompt.js";import{ToolbarSettingToggle}from"./Toolbar.js";import{Tooltip}from"./Tooltip.js";import{CheckboxLabel,createTextChild}from"./UIUtils.js";import{HBox}from"./Widget.js";const UIStrings={filter:"Filter",egSmalldUrlacomb:"e.g. `/small[d]+/ url:a.com/b`",sclickToSelectMultipleTypes:"{PH1}Click to select multiple types",allStrings:"All"},str_=i18n.i18n.registerUIStrings("ui/FilterBar.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FilterBar extends HBox{constructor(t,e){super(),this.registerRequiredCSS("ui/filter.css",{enableLegacyPatching:!0}),this._enabled=!0,this.element.classList.add("filter-bar"),this._stateSetting=Common.Settings.Settings.instance().createSetting("filterBar-"+t+"-toggled",Boolean(e)),this._filterButton=new ToolbarSettingToggle(this._stateSetting,"largeicon-filter",i18nString(UIStrings.filter)),this._filters=[],this._updateFilterBar(),this._stateSetting.addChangeListener(this._updateFilterBar.bind(this))}filterButton(){return this._filterButton}addFilter(t){this._filters.push(t),this.element.appendChild(t.element()),t.addEventListener(FilterUI.Events.FilterChanged,this._filterChanged,this),this._updateFilterButton()}setEnabled(t){this._enabled=t,this._filterButton.setEnabled(t),this._updateFilterBar()}forceShowFilterBar(){this._alwaysShowFilters=!0,this._updateFilterBar()}showOnce(){this._stateSetting.set(!0)}_filterChanged(t){this._updateFilterButton(),this.dispatchEventToListeners(FilterBar.Events.Changed)}wasShown(){super.wasShown(),this._updateFilterBar()}_updateFilterBar(){this.parentWidget()&&!this._showingWidget&&(this.visible()?(this._showingWidget=!0,this.showWidget(),this._showingWidget=!1):this.hideWidget())}focus(){for(let t=0;t<this._filters.length;++t)if(this._filters[t]instanceof TextFilterUI){this._filters[t].focus();break}}_updateFilterButton(){let t=!1;for(const e of this._filters)t=t||e.isActive();this._filterButton.setDefaultWithRedColor(t),this._filterButton.setToggleWithRedColor(t)}clear(){this.element.removeChildren(),this._filters=[],this._updateFilterButton()}setting(){return this._stateSetting}visible(){return this._alwaysShowFilters||this._stateSetting.get()&&this._enabled}}FilterBar.Events={Changed:Symbol("Changed")};export class FilterUI extends Common.EventTarget.EventTarget{isActive(){throw new Error("not implemented")}element(){throw new Error("not implemented")}}FilterUI.Events={FilterChanged:Symbol("FilterChanged")};export class TextFilterUI extends Common.ObjectWrapper.ObjectWrapper{constructor(){super(),this._filterElement=document.createElement("div"),this._filterElement.className="filter-text-filter";const t=this._filterElement.createChild("div","filter-input-container");this._filterInputElement=t.createChild("span","filter-input-field"),this._prompt=new TextPrompt,this._prompt.initialize(this._completions.bind(this)," ",!0),this._proxyElement=this._prompt.attach(this._filterInputElement),Tooltip.install(this._proxyElement,i18nString(UIStrings.egSmalldUrlacomb)),this._prompt.setPlaceholder(i18nString(UIStrings.filter)),this._prompt.addEventListener(Events.TextChanged,this._valueChanged.bind(this)),this._suggestionProvider=null;const e=t.createChild("div","filter-input-clear-button");e.appendChild(Icon.create("mediumicon-gray-cross-hover","filter-cancel-button")),e.addEventListener("click",(()=>{this.clear(),this.focus()})),this._updateEmptyStyles()}_completions(t,e,i){return this._suggestionProvider?this._suggestionProvider(t,e,i):Promise.resolve([])}isActive(){return Boolean(this._prompt.text())}element(){return this._filterElement}value(){return this._prompt.textWithCurrentSuggestion()}setValue(t){this._prompt.setText(t),this._valueChanged()}focus(){this._filterInputElement.focus()}setSuggestionProvider(t){this._prompt.clearAutocomplete(),this._suggestionProvider=t}_valueChanged(){this.dispatchEventToListeners(FilterUI.Events.FilterChanged,null),this._updateEmptyStyles()}_updateEmptyStyles(){this._filterElement.classList.toggle("filter-text-empty",!this._prompt.text())}clear(){this.setValue("")}}export class NamedBitSetFilterUI extends Common.ObjectWrapper.ObjectWrapper{constructor(t,e){super(),this._filtersElement=document.createElement("div"),this._filtersElement.classList.add("filter-bitset-filter"),ARIAUtils.markAsListBox(this._filtersElement),ARIAUtils.markAsMultiSelectable(this._filtersElement),Tooltip.install(this._filtersElement,i18nString(UIStrings.sclickToSelectMultipleTypes,{PH1:KeyboardShortcut.shortcutToString("",Modifiers.CtrlOrMeta)})),this._typeFilterElementTypeNames=new WeakMap,this._allowedTypes=new Set,this._typeFilterElements=[],this._addBit(NamedBitSetFilterUI.ALL_TYPES,i18nString(UIStrings.allStrings)),this._typeFilterElements[0].tabIndex=0,this._filtersElement.createChild("div","filter-bitset-filter-divider");for(let i=0;i<t.length;++i)this._addBit(t[i].name,t[i].label(),t[i].title);e?(this._setting=e,e.addChangeListener(this._settingChanged.bind(this)),this._settingChanged()):this._toggleTypeFilter(NamedBitSetFilterUI.ALL_TYPES,!1)}reset(){this._toggleTypeFilter(NamedBitSetFilterUI.ALL_TYPES,!1)}isActive(){return!this._allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES)}element(){return this._filtersElement}accept(t){return this._allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES)||this._allowedTypes.has(t)}_settingChanged(){const t=this._setting.get();this._allowedTypes=new Set;for(const e of this._typeFilterElements){const i=this._typeFilterElementTypeNames.get(e);i&&t[i]&&this._allowedTypes.add(i)}this._update()}_update(){(0===this._allowedTypes.size||this._allowedTypes.has(NamedBitSetFilterUI.ALL_TYPES))&&(this._allowedTypes=new Set,this._allowedTypes.add(NamedBitSetFilterUI.ALL_TYPES));for(const t of this._typeFilterElements){const e=this._typeFilterElementTypeNames.get(t),i=this._allowedTypes.has(e||"");t.classList.toggle("selected",i),ARIAUtils.setSelected(t,i)}this.dispatchEventToListeners(FilterUI.Events.FilterChanged,null)}_addBit(t,e,i){const s=this._filtersElement.createChild("span",t);s.tabIndex=-1,this._typeFilterElementTypeNames.set(s,t),createTextChild(s,e),ARIAUtils.markAsOption(s),i&&(s.title=i),s.addEventListener("click",this._onTypeFilterClicked.bind(this),!1),s.addEventListener("keydown",this._onTypeFilterKeydown.bind(this),!1),this._typeFilterElements.push(s)}_onTypeFilterClicked(t){const e=t;let i;if(i=Host.Platform.isMac()?e.metaKey&&!e.ctrlKey&&!e.altKey&&!e.shiftKey:e.ctrlKey&&!e.metaKey&&!e.altKey&&!e.shiftKey,e.target){const t=e.target,s=this._typeFilterElementTypeNames.get(t);this._toggleTypeFilter(s,i)}}_onTypeFilterKeydown(t){const e=t,i=e.target;i&&("ArrowLeft"===e.key||"ArrowUp"===e.key?this._keyFocusNextBit(i,!0)&&e.consume(!0):"ArrowRight"===e.key||"ArrowDown"===e.key?this._keyFocusNextBit(i,!1)&&e.consume(!0):isEnterOrSpaceKey(e)&&this._onTypeFilterClicked(e))}_keyFocusNextBit(t,e){const i=this._typeFilterElements.indexOf(t);if(-1===i)return!1;const s=e?i-1:i+1;if(s<0||s>=this._typeFilterElements.length)return!1;const l=this._typeFilterElements[s];return l.tabIndex=0,t.tabIndex=-1,l.focus(),!0}_toggleTypeFilter(t,e){if(e&&t!==NamedBitSetFilterUI.ALL_TYPES?this._allowedTypes.delete(NamedBitSetFilterUI.ALL_TYPES):this._allowedTypes=new Set,this._allowedTypes.has(t)?this._allowedTypes.delete(t):this._allowedTypes.add(t),this._setting){const t={};for(const e of this._allowedTypes)t[e]=!0;this._setting.set(t)}else this._update()}}NamedBitSetFilterUI.ALL_TYPES="all";export class CheckboxFilterUI extends Common.ObjectWrapper.ObjectWrapper{constructor(t,e,i,s){super(),this._filterElement=document.createElement("div"),this._filterElement.classList.add("filter-checkbox-filter"),this._activeWhenChecked=Boolean(i),this._label=CheckboxLabel.create(e),this._filterElement.appendChild(this._label),this._checkboxElement=this._label.checkboxElement,s?bindCheckbox(this._checkboxElement,s):this._checkboxElement.checked=!0,this._checkboxElement.addEventListener("change",this._fireUpdated.bind(this),!1)}isActive(){return this._activeWhenChecked===this._checkboxElement.checked}checked(){return this._checkboxElement.checked}setChecked(t){this._checkboxElement.checked=t}element(){return this._filterElement}labelElement(){return this._label}_fireUpdated(){this.dispatchEventToListeners(FilterUI.Events.FilterChanged,null)}setColor(t,e){this._label.backgroundColor=t,this._label.borderColor=e}}export let Item;