import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import{getRegisteredActionExtensions}from"./ActionRegistration.js";import{Context}from"./Context.js";import{Dialog}from"./Dialog.js";import{KeyboardShortcut,Modifiers,Type}from"./KeyboardShortcut.js";import{isEditing}from"./UIUtils.js";let shortcutRegistryInstance;export class ShortcutRegistry{constructor(t){this._actionRegistry=t,this._actionToShortcut=new Platform.MapUtilities.Multimap,this._keyMap=new ShortcutTreeNode(0,0),this._activePrefixKey=null,this._activePrefixTimeout=null,this._consumePrefix=null,this._devToolsDefaultShortcutActions=new Set,this._disabledDefaultShortcutsForAction=new Platform.MapUtilities.Multimap,this._keybindSetSetting=Common.Settings.Settings.instance().moduleSetting("activeKeybindSet"),this._keybindSetSetting.addChangeListener((t=>{Host.userMetrics.keybindSetSettingChanged(t.data),this._registerBindings()})),this._userShortcutsSetting=Common.Settings.Settings.instance().moduleSetting("userShortcuts"),this._userShortcutsSetting.addChangeListener(this._registerBindings,this),this._registerBindings()}static instance(t={forceNew:null,actionRegistry:null}){const{forceNew:e,actionRegistry:o}=t;if(!shortcutRegistryInstance||e){if(!o)throw new Error("Missing actionRegistry for shortcutRegistry");shortcutRegistryInstance=new ShortcutRegistry(o)}return shortcutRegistryInstance}static removeInstance(){shortcutRegistryInstance=void 0}_applicableActions(t,e={}){let o=[];const i=(this._activePrefixKey||this._keyMap).getNode(t);i&&(o=i.actions());const s=this._actionRegistry.applicableActions(o,Context.instance());if(i)for(const r of Object.keys(e))if(i.actions().indexOf(r)>=0){const t=this._actionRegistry.action(r);t&&s.push(t)}return s}shortcutsForAction(t){return[...this._actionToShortcut.get(t)]}actionsForDescriptors(t){let e=this._keyMap;for(const{key:o}of t){if(!e)return[];e=e.getNode(o)}return e?e.actions():[]}globalShortcutKeys(){const t=[];for(const e of this._keyMap.chords().values()){const o=e.actions();(this._actionRegistry.applicableActions(o,Context.instance()).length||e.hasChords())&&t.push(e.key())}return t}keysForActions(t){const e=t.flatMap((t=>[...this._actionToShortcut.get(t)].flatMap((t=>t.descriptors.map((t=>t.key))))));return[...new Set(e)]}shortcutTitleForAction(t){for(const e of this._actionToShortcut.get(t))return e.title()}handleShortcut(t,e){this.handleKey(KeyboardShortcut.makeKeyFromEvent(t),t.key,t,e)}actionHasDefaultShortcut(t){return this._devToolsDefaultShortcutActions.has(t)}addShortcutListener(t,e){const o=new ShortcutTreeNode(0,0);Object.keys(e).flatMap((t=>[...this._actionToShortcut.get(t)])).forEach((t=>{o.addKeyMapping(t.descriptors.map((t=>t.key)),t.action)}));const i=t=>{const i=KeyboardShortcut.makeKeyFromEvent(t),s=this._activePrefixKey?o.getNode(this._activePrefixKey.key()):o;s&&s.getNode(i)&&this.handleShortcut(t,e)};return t.addEventListener("keydown",i),i}async handleKey(t,e,o,i){const s=t>>8,r=Boolean(i)||Boolean(this._activePrefixKey),n=this._keyMap.getNode(t),c=this._applicableActions(t,i).length>0||n&&n.hasChords();if((r||!function(){if(!o||!isEditing()||/^F\d+|Control|Shift|Alt|Meta|Escape|Win|U\+001B$/.test(e))return!1;if(!s)return!0;const i=Modifiers;if(Host.Platform.isMac()){if(KeyboardShortcut.makeKey("z",i.Meta)===t)return!0;if(KeyboardShortcut.makeKey("z",i.Meta|i.Shift)===t)return!0}else{if(KeyboardShortcut.makeKey("z",i.Ctrl)===t)return!0;if(KeyboardShortcut.makeKey("y",i.Ctrl)===t)return!0;if(!Host.Platform.isWin()&&KeyboardShortcut.makeKey("z",i.Ctrl|i.Shift)===t)return!0}if((s&(i.Ctrl|i.Alt))===(i.Ctrl|i.Alt))return Host.Platform.isWin();return!a(i.Ctrl)&&!a(i.Alt)&&!a(i.Meta)}())&&c&&!KeyboardShortcut.isModifier(KeyboardShortcut.keyCodeAndModifiersFromKey(t).keyCode)&&(o&&o.consume(!0),r||!Dialog.hasInstance())){if(this._activePrefixTimeout){clearTimeout(this._activePrefixTimeout);const t=h.call(this);if(this._activePrefixKey=null,this._activePrefixTimeout=null,t)return;this._consumePrefix&&await this._consumePrefix()}n&&n.hasChords()?(this._activePrefixKey=n,this._consumePrefix=async()=>{this._activePrefixKey=null,this._activePrefixTimeout=null,await h.call(this)},this._activePrefixTimeout=window.setTimeout(this._consumePrefix,KeyTimeout)):await h.call(this)}function a(t){return Boolean(s&t)}async function h(){const e=this._applicableActions(t,i);if(!e.length)return!1;for(const t of e){let e;if(i&&i[t.id()]&&(e=await i[t.id()]()),i||(e=await t.execute()),e)return Host.userMetrics.keyboardShortcutFired(t.id()),!0}return!1}}registerUserShortcut(t){for(const e of this._disabledDefaultShortcutsForAction.get(t.action))if(e.descriptorsMatch(t.descriptors)&&e.hasKeybindSet(this._keybindSetSetting.get()))return void this.removeShortcut(e);for(const e of this._actionToShortcut.get(t.action))if(e.descriptorsMatch(t.descriptors)&&e.hasKeybindSet(this._keybindSetSetting.get()))return;this._addShortcutToSetting(t)}removeShortcut(t){t.type===Type.DefaultShortcut||t.type===Type.KeybindSetShortcut?this._addShortcutToSetting(t.changeType(Type.DisabledDefault)):this._removeShortcutFromSetting(t)}disabledDefaultsForAction(t){return this._disabledDefaultShortcutsForAction.get(t)}_addShortcutToSetting(t){const e=this._userShortcutsSetting.get();e.push(t),this._userShortcutsSetting.set(e)}_removeShortcutFromSetting(t){const e=this._userShortcutsSetting.get(),o=e.findIndex(t.equals,t);-1!==o&&(e.splice(o,1),this._userShortcutsSetting.set(e))}_registerShortcut(t){this._actionToShortcut.set(t.action,t),this._keyMap.addKeyMapping(t.descriptors.map((t=>t.key)),t.action)}_registerBindings(){this._actionToShortcut.clear(),this._keyMap.clear();const t=this._keybindSetSetting.get();this._disabledDefaultShortcutsForAction.clear(),this._devToolsDefaultShortcutActions.clear();const e=[];if(Root.Runtime.experiments.isEnabled("keyboardShortcutEditor")){const t=this._userShortcutsSetting.get();for(const o of t){const t=KeyboardShortcut.createShortcutFromSettingObject(o);t.type===Type.DisabledDefault?this._disabledDefaultShortcutsForAction.set(t.action,t):(ForwardedActions.has(t.action)&&e.push(...t.descriptors.map((t=>KeyboardShortcut.keyCodeAndModifiersFromKey(t.key)))),this._registerShortcut(t))}}for(const s of getRegisteredActionExtensions()){const t=s.id(),r=s.bindings();for(let s=0;r&&s<r.length;++s){const n=r[s].keybindSets;if(!o(r[s].platform)||!i(n))continue;const c=r[s].shortcut.split(/\s+/).map(KeyboardShortcut.makeDescriptorFromBindingShortcut);if(c.length>0){if(this._isDisabledDefault(c,t)){this._devToolsDefaultShortcutActions.add(t);continue}ForwardedActions.has(t)&&e.push(...c.map((t=>KeyboardShortcut.keyCodeAndModifiersFromKey(t.key)))),n?(n.includes("devToolsDefault")&&this._devToolsDefaultShortcutActions.add(t),this._registerShortcut(new KeyboardShortcut(c,t,Type.KeybindSetShortcut,new Set(n)))):(this._devToolsDefaultShortcutActions.add(t),this._registerShortcut(new KeyboardShortcut(c,t,Type.DefaultShortcut)))}}}function o(t){if(!t)return!0;const e=t.split(",");let o=!1;const i=Host.Platform.platform();for(let s=0;!o&&s<e.length;++s)o=e[s]===i;return o}function i(e){return!e||e.includes(t)}Host.InspectorFrontendHost.InspectorFrontendHostInstance.setWhitelistedShortcuts(JSON.stringify(e))}_isDisabledDefault(t,e){const o=this._disabledDefaultShortcutsForAction.get(e);for(const i of o)if(i.descriptorsMatch(t))return!0;return!1}}export class ShortcutTreeNode{constructor(t,e=0){this._key=t,this._actions=[],this._chords=new Map,this._depth=e}addAction(t){this._actions.push(t)}key(){return this._key}chords(){return this._chords}hasChords(){return this._chords.size>0}addKeyMapping(t,e){if(!(t.length<this._depth))if(t.length===this._depth)this.addAction(e);else{const o=t[this._depth];this._chords.has(o)||this._chords.set(o,new ShortcutTreeNode(o,this._depth+1)),this._chords.get(o).addKeyMapping(t,e)}}getNode(t){return this._chords.get(t)||null}actions(){return this._actions}clear(){this._actions=[],this._chords=new Map}}export class ForwardedShortcut{}ForwardedShortcut.instance=new ForwardedShortcut;export const ForwardedActions=new Set(["main.toggle-dock","debugger.toggle-breakpoints-active","debugger.toggle-pause","commandMenu.show","console.show"]);export const KeyTimeout=1e3;export const DefaultShortcutSetting="devToolsDefault";