import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as ARIAUtils from"./ARIAUtils.js";import{Icon}from"./Icon.js";import{Events as TabbedPaneEvents,TabbedPane}from"./TabbedPane.js";import{Toolbar,ToolbarMenuButton}from"./Toolbar.js";import{createTextChild}from"./UIUtils.js";import{getRegisteredLocationResolvers,getRegisteredViewExtensions,registerLocationResolver,registerViewExtension,ViewLocationCategoryValues}from"./ViewRegistration.js";import{VBox}from"./Widget.js";const UIStrings={sPanel:"{PH1} panel"},str_=i18n.i18n.registerUIStrings("ui/ViewManager.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class PreRegisteredView{constructor(e){this._viewRegistration=e,this._widgetRequested=!1}title(){return this._viewRegistration.title()}commandPrompt(){return this._viewRegistration.commandPrompt()}isCloseable(){return"closeable"===this._viewRegistration.persistence}isTransient(){return"transient"===this._viewRegistration.persistence}viewId(){return this._viewRegistration.id}location(){return this._viewRegistration.location}order(){return this._viewRegistration.order}settings(){return this._viewRegistration.settings}tags(){if(this._viewRegistration.tags)return this._viewRegistration.tags.map((e=>e())).join("\0")}persistence(){return this._viewRegistration.persistence}async toolbarItems(){return this._viewRegistration.hasToolbar?this.widget().then((e=>e.toolbarItems())):[]}async widget(){return this._widgetRequested=!0,this._viewRegistration.loadView()}async disposeView(){if(!this._widgetRequested)return;const e=await this.widget();await e.ownerViewDisposed()}experiment(){return this._viewRegistration.experiment}condition(){return this._viewRegistration.condition}}let viewManagerInstance;export class ViewManager{constructor(){this._views=new Map,this._locationNameByViewId=new Map,this._locationOverrideSetting=Common.Settings.Settings.instance().createSetting("viewsLocationOverride",{});const e=this._locationOverrideSetting.get(),t=new Map;for(const s of getRegisteredViewExtensions()){const e=s.location()||"none",i=t.get(e)||[];i.push(s),t.set(e,i)}let i=[];for(const s of t.values())s.sort(((e,t)=>{const i=e.order(),s=t.order();return i&&s?i-s:0})),i=i.concat(s);for(const s of i){const t=s.viewId(),i=s.location();if(this._views.has(t))throw new Error(`Duplicate view id '${t}'`);this._views.set(t,s);const n=e[t]||i;this._locationNameByViewId.set(t,n)}}static instance(e={forceNew:null}){const{forceNew:t}=e;return viewManagerInstance&&!t||(viewManagerInstance=new ViewManager),viewManagerInstance}static _createToolbar(e){if(!e.length)return null;const t=new Toolbar("");for(const i of e)t.appendToolbarItem(i);return t.element}locationNameForViewId(e){const t=this._locationNameByViewId.get(e);if(!t)throw new Error(`No location name for view with id ${e}`);return t}moveView(e,t,i){const{shouldSelectTab:s,overrideSaving:n}=i||{shouldSelectTab:!0,overrideSaving:!1};if(!e||!t)return;const a=this.view(e);if(a){if(!n){this._locationNameByViewId.set(e,t);const i=this._locationOverrideSetting.get();i[e]=t,this._locationOverrideSetting.set(i)}this.resolveLocation(t).then((t=>{if(!t)throw new Error("Move view: Could not resolve location for view: "+e);return t._reveal(),t.showView(a,void 0,!0,!1,s)}))}}revealView(e){const t=locationForView.get(e);return t?(t._reveal(),t.showView(e)):Promise.resolve()}showViewInLocation(e,t,i=!0){this.moveView(e,t,{shouldSelectTab:i,overrideSaving:!0})}view(e){const t=this._views.get(e);if(!t)throw new Error(`No view with id ${e} found!`);return t}materializedWidget(e){const t=this.view(e);return t&&widgetForView.get(t)||null}showView(e,t,i){const s=this._views.get(e);if(!s)return console.error("Could not find view for id: '"+e+"' "+(new Error).stack),Promise.resolve();const n=this._locationNameByViewId.get(e),a=locationForView.get(s);return a?(a._reveal(),a.showView(s,void 0,t,i)):this.resolveLocation(n).then((n=>{if(!n)throw new Error("Could not resolve location for view: "+e);return n._reveal(),n.showView(s,void 0,t,i)}))}async resolveLocation(e){if(!e)return Promise.resolve(null);const t=getRegisteredLocationResolvers().filter((t=>t.name===e));if(t.length>1)throw new Error("Duplicate resolver for location: "+e);if(t.length){return(await t[0].loadResolver()).resolveLocation(e)}throw new Error("Unresolved location: "+e)}createTabbedLocation(e,t,i,s,n){return new _TabbedLocation(this,e,t,i,s,n)}createStackLocation(e,t){return new _StackLocation(this,e,t)}hasViewsForLocation(e){return Boolean(this._viewsForLocation(e).length)}_viewsForLocation(e){const t=[];for(const[i,s]of this._views.entries())this._locationNameByViewId.get(i)===e&&t.push(s);return t}}const widgetForView=new WeakMap;export class ContainerWidget extends VBox{constructor(e){super(),this.element.classList.add("flex-auto","view-container","overflow-auto"),this._view=e,this.element.tabIndex=-1,ARIAUtils.markAsTabpanel(this.element),ARIAUtils.setAccessibleName(this.element,i18nString(UIStrings.sPanel,{PH1:e.title()})),this.setDefaultFocusedElement(this.element)}_materialize(){if(this._materializePromise)return this._materializePromise;const e=[];return e.push(this._view.toolbarItems().then((e=>{const t=ViewManager._createToolbar(e);t&&this.element.insertBefore(t,this.element.firstChild)}))),e.push(this._view.widget().then((e=>{const t=this.element.hasFocus();this.setDefaultFocusedElement(null),widgetForView.set(this._view,e),e.show(this.element),t&&e.focus()}))),this._materializePromise=Promise.all(e),this._materializePromise}wasShown(){this._materialize().then((()=>{const e=widgetForView.get(this._view);e&&(e.show(this.element),this._wasShownForTest())}))}_wasShownForTest(){}}export class _ExpandableContainerWidget extends VBox{constructor(e){super(!0),this.element.classList.add("flex-none"),this.registerRequiredCSS("ui/viewContainers.css",{enableLegacyPatching:!0}),this._titleElement=document.createElement("div"),this._titleElement.classList.add("expandable-view-title"),ARIAUtils.markAsButton(this._titleElement),this._titleExpandIcon=Icon.create("smallicon-triangle-right","title-expand-icon"),this._titleElement.appendChild(this._titleExpandIcon);const t=e.title();createTextChild(this._titleElement,t),ARIAUtils.setAccessibleName(this._titleElement,t),ARIAUtils.setExpanded(this._titleElement,!1),this._titleElement.tabIndex=0,self.onInvokeElement(this._titleElement,this._toggleExpanded.bind(this)),this._titleElement.addEventListener("keydown",this._onTitleKeyDown.bind(this),!1),this.contentElement.insertBefore(this._titleElement,this.contentElement.firstChild),ARIAUtils.setControls(this._titleElement,this.contentElement.createChild("slot")),this._view=e,expandableContainerForView.set(e,this)}wasShown(){this._widget&&this._materializePromise&&this._materializePromise.then((()=>{this._titleElement.classList.contains("expanded")&&this._widget&&this._widget.show(this.element)}))}_materialize(){if(this._materializePromise)return this._materializePromise;const e=[];return e.push(this._view.toolbarItems().then((e=>{const t=ViewManager._createToolbar(e);t&&this._titleElement.appendChild(t)}))),e.push(this._view.widget().then((e=>{this._widget=e,widgetForView.set(this._view,e),e.show(this.element)}))),this._materializePromise=Promise.all(e),this._materializePromise}_expand(){return this._titleElement.classList.contains("expanded")?this._materialize():(this._titleElement.classList.add("expanded"),ARIAUtils.setExpanded(this._titleElement,!0),this._titleExpandIcon.setIconType("smallicon-triangle-down"),this._materialize().then((()=>{this._widget&&this._widget.show(this.element)})))}_collapse(){this._titleElement.classList.contains("expanded")&&(this._titleElement.classList.remove("expanded"),ARIAUtils.setExpanded(this._titleElement,!1),this._titleExpandIcon.setIconType("smallicon-triangle-right"),this._materialize().then((()=>{this._widget&&this._widget.detach()})))}_toggleExpanded(e){"keydown"===e.type&&e.target!==this._titleElement||(this._titleElement.classList.contains("expanded")?this._collapse():this._expand())}_onTitleKeyDown(e){if(e.target!==this._titleElement)return;const t=e;"ArrowLeft"===t.key?this._collapse():"ArrowRight"===t.key&&(this._titleElement.classList.contains("expanded")?this._widget&&this._widget.focus():this._expand())}}const expandableContainerForView=new WeakMap;class _Location{constructor(e,t,i){this._manager=e,this._revealCallback=i,this._widget=t}widget(){return this._widget}_reveal(){this._revealCallback&&this._revealCallback()}showView(e,t,i,s,n){throw new Error("not implemented")}removeView(e){throw new Error("not implemented")}}const locationForView=new WeakMap;export class _TabbedLocation extends _Location{constructor(e,t,i,s,n,a){const o=new TabbedPane;n&&o.setAllowTabReorder(!0),super(e,o,t),this._tabbedPane=o,this._allowReorder=n,this._tabbedPane.addEventListener(TabbedPaneEvents.TabSelected,this._tabSelected,this),this._tabbedPane.addEventListener(TabbedPaneEvents.TabClosed,this._tabClosed,this),this._closeableTabSetting=Common.Settings.Settings.instance().createSetting("closeableTabs",{}),this._setOrUpdateCloseableTabsSetting(),this._tabOrderSetting=Common.Settings.Settings.instance().createSetting(i+"-tabOrder",{}),this._tabbedPane.addEventListener(TabbedPaneEvents.TabOrderChanged,this._persistTabOrder,this),s&&(this._lastSelectedTabSetting=Common.Settings.Settings.instance().createSetting(i+"-selectedTab","")),this._defaultTab=a,this._views=new Map,i&&this.appendApplicableItems(i)}_setOrUpdateCloseableTabsSetting(){const e=this._closeableTabSetting.get(),t=Object.assign({security:!0},e);this._closeableTabSetting.set(t)}widget(){return this._tabbedPane}tabbedPane(){return this._tabbedPane}enableMoreTabsButton(){const e=new ToolbarMenuButton(this._appendTabsToMenu.bind(this));return this._tabbedPane.leftToolbar().appendToolbarItem(e),this._tabbedPane.disableOverflowMenu(),e}appendApplicableItems(e){const t=this._manager._viewsForLocation(e);if(this._allowReorder){let e=0;const i=this._tabOrderSetting.get(),s=new Map;for(const n of t)s.set(n.viewId(),i[n.viewId()]||++e*_TabbedLocation.orderStep);t.sort(((e,t)=>s.get(e.viewId())-s.get(t.viewId())))}for(const i of t){const e=i.viewId();this._views.set(e,i),locationForView.set(i,this),i.isTransient()||(i.isCloseable()?this._closeableTabSetting.get()[e]&&this._appendTab(i):this._appendTab(i))}if(this._defaultTab)if(this._tabbedPane.hasTab(this._defaultTab))this._tabbedPane.selectTab(this._defaultTab);else{const e=Array.from(this._views.values()).find((e=>e.viewId()===this._defaultTab));e&&this.showView(e)}else this._lastSelectedTabSetting&&this._tabbedPane.hasTab(this._lastSelectedTabSetting.get())&&this._tabbedPane.selectTab(this._lastSelectedTabSetting.get())}_appendTabsToMenu(e){const t=Array.from(this._views.values());t.sort(((e,t)=>e.title().localeCompare(t.title())));for(const i of t){const t=i.title();"issues-pane"!==i.viewId()?e.defaultSection().appendItem(t,this.showView.bind(this,i,void 0,!0)):e.defaultSection().appendItem(t,(()=>{Host.userMetrics.issuesPanelOpenedFrom(Host.UserMetrics.IssueOpener.HamburgerMenu),this.showView(i,void 0,!0)}))}}_appendTab(e,t){this._tabbedPane.appendTab(e.viewId(),e.title(),new ContainerWidget(e),void 0,!1,e.isCloseable()||e.isTransient(),t)}appendView(e,t){if(this._tabbedPane.hasTab(e.viewId()))return;const i=locationForView.get(e);let s;i&&i!==this&&i.removeView(e),locationForView.set(e,this),this._manager._views.set(e.viewId(),e),this._views.set(e.viewId(),e);const n=this._tabbedPane.tabIds();if(this._allowReorder){const t=this._tabOrderSetting.get(),i=t[e.viewId()];for(let e=0;i&&e<n.length;++e)if(t[n[e]]&&t[n[e]]>i){s=e;break}}else if(t)for(let a=0;a<n.length;++a)if(n[a]===t.viewId()){s=a;break}if(this._appendTab(e,s),e.isCloseable()){const t=this._closeableTabSetting.get(),i=e.viewId();t[i]||(t[i]=!0,this._closeableTabSetting.set(t))}this._persistTabOrder()}async showView(e,t,i,s,n=!0){this.appendView(e,t),n&&this._tabbedPane.selectTab(e.viewId(),i),s||this._tabbedPane.focus();const a=this._tabbedPane.tabView(e.viewId());await a._materialize()}removeView(e){this._tabbedPane.hasTab(e.viewId())&&(locationForView.delete(e),this._manager._views.delete(e.viewId()),this._tabbedPane.closeTab(e.viewId()),this._views.delete(e.viewId()))}_tabSelected(e){const t=e.data.tabId;this._lastSelectedTabSetting&&e.data.isUserGesture&&this._lastSelectedTabSetting.set(t)}_tabClosed(e){const t=e.data.tabId,i=this._closeableTabSetting.get();i[t]&&(i[t]=!1,this._closeableTabSetting.set(i));const s=this._views.get(t);s&&s.disposeView()}_persistTabOrder(){const e=this._tabbedPane.tabIds(),t={};for(let a=0;a<e.length;a++)t[e[a]]=(a+1)*_TabbedLocation.orderStep;const i=this._tabOrderSetting.get(),s=Object.keys(i);s.sort(((e,t)=>i[e]-i[t]));let n=0;for(const a of s)a in t?n=t[a]:t[a]=++n;this._tabOrderSetting.set(t)}}_TabbedLocation.orderStep=10;class _StackLocation extends _Location{constructor(e,t,i){const s=new VBox;super(e,s,t),this._vbox=s,this._expandableContainers=new Map,i&&this.appendApplicableItems(i)}appendView(e,t){const i=locationForView.get(e);i&&i!==this&&i.removeView(e);let s=this._expandableContainers.get(e.viewId());if(!s){locationForView.set(e,this),this._manager._views.set(e.viewId(),e),s=new _ExpandableContainerWidget(e);let i=null;if(t){const e=expandableContainerForView.get(t);i=e?e.element:null}s.show(this._vbox.contentElement,i),this._expandableContainers.set(e.viewId(),s)}}async showView(e,t){this.appendView(e,t);const i=this._expandableContainers.get(e.viewId());i&&await i._expand()}removeView(e){const t=this._expandableContainers.get(e.viewId());t&&(t.detach(),this._expandableContainers.delete(e.viewId()),locationForView.delete(e),this._manager._views.delete(e.viewId()))}appendApplicableItems(e){for(const t of this._manager._viewsForLocation(e))this.appendView(t)}}export let ViewRegistry;export{getRegisteredViewExtensions,registerViewExtension,getRegisteredLocationResolvers,registerLocationResolver,ViewLocationCategoryValues};